/************************************
* ANIEDITO.C Animation editor
*      Jorma Jormakka
*      28.9.92
*************************************/
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "animatio.ext"
extern int gplanes;
extern XColor *xcolor;
static int part_in_use[MAXPARTS];

/* CONTENT: */
/*******************************
* routines for animation editor
********************************/

int animation_editor();
int do_aedi_engine();
int background_editor();
int do_abck_engine();
int fill_aniedimenu();
int fill_startmenu();
int fill_movemenu();
int aedi_operations();
int drawbar_actions1();
int pensize_menu();
int start_menu();
int move_menu();
int aedi_menu();
int replace_buffer_menu();
int cut_buffer_color_menu();
int cut_buffer_menu();
int remove_cut_buffer();
int allopicture();
void fillb();
void fillc();

static TRANSFORMDATA *part0;
unsigned char *curplane;
int color_area_flag=0,set_palette=0;
int pensize,nocolor,colorZ;
/*unsigned char palette[16]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};*/
unsigned char palette[16]={0,1,2,3,4,5,11,7,8,28,20,32,40,55,54,63};
/*
unsigned char palette[16]=
 {0,1,2,3,4,38,32,7,40,6,20,11,4,55,54,63};
*/
/************************************************
*   animation_editor()
*************************************************/ 
int animation_editor()
{
 int i,x,y;

 nocolor=15;set_turnpoints=set_endpoints=set_flexdata=0;pensize=1;part0=0;
 clearwin(0,0,X__max,Y__max,bgcol);
 clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor); 
 clearwin(XOFF2,YOFF2,XOFF2+JSIZE,YOFF2+JSIZE-1,nocolor);  
 fillbox(95,75,210,4,2);
 fillbox(95,281,210,4,2); 
 fillbox(95,79,4,202,2);  
 fillbox(301,79,4,202,2);
 getdrawbar(X__max-40);

 fill_aniedimenu(3, 8, 6,50,2,10*cs,350,30*cs,3*cs+6*cr,Co1,Co2,Co3,Co4,Co5); 
 fill_movemenu  (7,11,11,50,3,49*cs,250,27*cs,3*cs+11*cr,Co1,Co2,Co3,Co4,Co5);
 allo_partm(0); /* allocate structure for one animation */
 if(do_aedi_engine(3)) {;}
 /*savedrawbar();*/
 free_partm(0);
 return 0; 
}
/**************************************
* display manager
***************************************/
int do_aedi_engine(maxi) int maxi;
{
 int command,x,y,x1,y1,oldx,oldy,i,j,k;
 char line[20],**u2,ch;
 int *chosen;int isize,size;
 if(init_engine(maxi)) return(1);

 isize=GPLANES*(JSIZE/8+1);
 size=((3*JSIZE)>isize ? (3*JSIZE*JSIZE):(isize*JSIZE)); 

 plane1=balloc(size);
 plane2=balloc(size); 
 curplane=plane1;
 while(1) {     
  do {
   command=do_operations();
   if(command==1) {
    if(aedi_operations(popwindow,0)==1) {
     if(plane1) b_free(plane1);if(plane2) b_free(plane2);plane1=plane2=0;
     return(1);} /* exit asked */
   }
   else if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */
    if(X>=XOFF1 && X+2*pensize<=XOFF1+2*JSIZE && 
	Y>=YOFF1 && Y+2*pensize<=YOFF1+2*JSIZE) {
     x=(X-XOFF1)>>1;y=(Y-YOFF1)>>1;
     if(!part0) if(allopicture()) return 1;
     if(color_area_flag) {
      color_area_flag=0;
      fill_area(X,Y,colorZ,curplane,XOFF1,YOFF1,XOFF1+2*JSIZE,YOFF1+2*JSIZE);
     }
     else if(set_turnpoints) {
      if(x<1) x=1;else if(x>JSIZE-2) x=JSIZE-2;
      if(y<1) y=1;else if(y>JSIZE-2) y=JSIZE-2;
      for(i=0;i<MAXPARTS;i++) { 
       if(part_in_use[i]) {
	if( x-part0[i].xcur<2 && part0[i].xcur-x<2
	 && y-part0[i].ycur<2 && part0[i].ycur-y<2) break;
       }
      }
      if(i<MAXPARTS) {      
       oldx=part0[i].xcur;part0[i].xcur=x;
       oldy=part0[i].ycur;part0[i].ycur=y;      
       fillb(oldx,oldy,1);       
       fillbox((X>>1)<<1,(Y>>1)<<1,2,2,i);
      }
     }     
     else if(set_endpoints) {
      if(x<1) x=1;else if(x>JSIZE-2) x=JSIZE-2;
      if(y<1) y=1;else if(y>JSIZE-2) y=JSIZE-2;
      for(i=0;i<MAXPARTS;i++) { 
       if(part_in_use[i]) {
	 /* find which end point is close to x,y */
	if( x-part0[i].xend<2 && part0[i].xend-x<2
	 && y-part0[i].yend<2 && part0[i].yend-y<2) break;
       }
      }
      if(i<MAXPARTS) {
	/* replace old end point by (x,y) */      
       oldx=part0[i].xend;part0[i].xend=x;
       oldy=part0[i].yend;part0[i].yend=y;      
       fillb(oldx,oldy,1);       
       fillbox((X>>1)<<1,(Y>>1)<<1,2,2,i);
      }
     }          
     else if(set_flexdata) {
      j=0;
      for(i=0;i<MAXPARTS;i++) { 
       if(part_in_use[i]) {
	if(x-part0[i].xcur<2 && part0[i].xcur-x<2) {
	 if(y-part0[i].ycur+part0[i].l<2 && part0[i].ycur-part0[i].l-y<2) 
	 {j=1;break;}
	 else if(y-part0[i].ycur+part0[i].a<2 && part0[i].ycur-part0[i].a-y<2) 
	 {j=2;break;}           
	}
	if(j==0 && y-part0[i].ycur-part0[i].yoff+XYOFF<2 
		&& part0[i].ycur+part0[i].yoff-XYOFF-y<2
		&& x-part0[i].xcur-part0[i].xoff+XYOFF<2 
		&& part0[i].xcur+part0[i].xoff-XYOFF-x<2) 
	{j=3;break;}
       }
      }
      if(i<MAXPARTS) {
       x1=part0[i].xcur;                    
       for(k=part0[i].ycur-part0[i].l;k<=part0[i].ycur;k++) fillb(x1,k,1);
       x1=part0[i].xcur+part0[i].xoff-XYOFF;
       y1=part0[i].ycur+part0[i].yoff-XYOFF;
       fillb(x1,y1,1);

       if(j==1) {
	oldy=part0[i].ycur-part0[i].l;part0[i].l=part0[i].ycur-y;
       }
       else if(j==2){
	oldy=part0[i].ycur-part0[i].a;part0[i].a=part0[i].ycur-y;
	if(part0[i].a>part0[i].l) part0[i].a=part0[i].l;
       }
       else if(j==3) {
	part0[i].xoff=x-part0[i].xcur+XYOFF;
	part0[i].yoff=y-part0[i].ycur+XYOFF;
       }
       x1=XOFF1+(part0[i].xcur<<1);                             
       for(k=YOFF1+((part0[i].ycur-part0[i].l)<<1);
        k<YOFF1+(part0[i].ycur<<1);k++)
	drawpixel(x1,k,i);
       fillbox(x1,YOFF1+((part0[i].ycur-part0[i].l)<<1),2,2,i);
       fillbox(x1,YOFF1+((part0[i].ycur-part0[i].a)<<1),2,2,i);
       fillbox(x1,YOFF1+(part0[i].ycur<<1),2,2,i);       
       x1=XOFF1+((part0[i].xcur+part0[i].xoff-XYOFF)<<1);       
       y1=YOFF1+((part0[i].ycur+part0[i].yoff-XYOFF)<<1);       
       fillbox(x1,y1,2,2,i);
      }
     }
     else {
      if((char *)curplane==(char *)plane1) {        
       for(j=0;j<pensize;j++) { 
	for(i=0;i<pensize;i++){*(plane1+JSIZE*(y+j)+x+i)=colorZ;}}     
       fillbox((X>>1)<<1,(Y>>1)<<1,2*pensize,2*pensize,colorZ);
      }
      else if((char *)curplane==(char *)plane2) {        
       for(j=0;j<pensize;j++) { 
	for(i=0;i<pensize;i++){*(plane2+JSIZE*(y+j)+x+i)=colorZ;}}           
       if(colorZ==EMPTYCOL) {
	for(j=0;j<pensize;j++) { 
	 for(i=0;i<pensize;i++){
	  if(*(plane1+JSIZE*(y+j)+x+i)!=nocolor)
	   fillbox(((x+i)<<1)+XOFF1,((y+j)<<1)+YOFF1,2,2,14);
	  else 
	   fillbox(((x+i)<<1)+XOFF1,((y+j)<<1)+YOFF1,2,2,nocolor);
	 }
	}
       }
       else 
	fillbox((X>>1)<<1,(Y>>1)<<1,2*pensize,2*pensize,colorZ);       
      }
     }               
    }
    else if(X>620) {
     if (Y>=320 && Y<340 && (char *)curplane!=(char *)plane2) {;}
     else 
      drawbar_actions1(EMPTYCOL);
    }
   }
  } while(!kbhit());
  if(getch()=='s') save_as_pcxfile(0,0,X__max,Y__max,"screen.pcx");
 }
}

/************************************************
*   background_editor()
*************************************************/ 
int background_editor()
{
 int i,x,y;

 nocolor=15;pensize=1;part0=0;
 clearwin(0,0,X__max,Y__max,nocolor);
 getdrawbar(X__max-40);   
 fill_aniedimenu(3,8,8,50,2,10*cs,400,30*cs,3*cs+8*cr,Co1,Co2,Co3,Co4,Co5);   
 
 if(do_abck_engine(2)) {;}
 /*savedrawbar();*/ 

 return 0;  
}

/************************************************
*   display manager
*************************************************/ 
int do_abck_engine(maxi) int maxi;
{
 int command,i;
 char line[20],**u2;
 int *chosen;
 
 if(init_engine(maxi)) return(1);

 while(1) {     
  do {
   command=do_operations();
   if(command==1) {
    if(aedi_operations(popwindow,1)==1) return(1); /* exit asked */
   }
   else if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */

    if(X<608 && Y<360) {
     if(color_area_flag) {
      color_area_flag=0;
      flood_fill(X,Y,colorZ,0,0,607,Y__max);
     }
     else fillbox(X,Y,pensize,pensize,colorZ);
    }
    else if(X>608) {
     drawbar_actions1(15);
    }
   }
  } while(!kbhit());
 }
}
/**********************************
* fill routine for aniedi menu
***********************************/
int fill_aniedimenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);        
  return(-1);
 }
 strcpy(u2[0],"Quit ");
 strcpy(u2[1],"Load picture ");
 strcpy(u2[2],"Save picture ");
 strcpy(u2[3],"Copy to curplane "); 
 strcpy(u2[4],"List files ");  
 strcpy(u2[5],"Cut buffer menu ");   
 strcpy(u2[6],"Load background ");
 strcpy(u2[7],"Save background ");

 
 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;
 u1[0].bsize=u1[0].size=10; 
 strcpy(u1[0].name,"wolf.ani");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 u1[1].bsize=u1[1].size=10;  
 strcpy(u1[1].name,"test.ani"); 
 
 u1[2].xcord=strlen(u2[6])*cs; 
 u1[2].ycord=4*cr; 
 u1[2].parmax=1;
 strcpy(u1[2].name,"*.ani"); 
 u1[2].bsize=u1[2].size=10; 
  
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
		max,pmax,window,linelength);
 wd_object[id-1].options |= NO_KILLING;
 strcpy(wd_object[id-1].name,"The main menu");
 return(0);
}

/**********************************
* fill routine for start menu
***********************************/
int fill_startmenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("Failed to allocate menu",15,0);        
  return(-1);
 } 
 strcpy(u2[0],"The animation editor");
 strcpy(u2[1],"The background editor");
 strcpy(u2[2],"The fish animation");
 strcpy(u2[3],"The shooting game");
 strcpy(u2[4],"Quit the program");
 strcpy(u2[5],"Postcard"); 

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
		max,pmax,window,linelength);
 wd_object[id-1].options |= NO_KILLING;
 strcpy(wd_object[id-1].name,"The start menu");
 return(0);
}

/**********************************
* fill routine for move menu
***********************************/
int fill_movemenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);        
  return(-1);
 }
 strcpy(u2[RUN_ANIMATION],"Run ");
 strcpy(u2[CHANGE_CURRENT_PLANE],"Current plane= picture");
 strcpy(u2[TEST_TRANSFORM],"Move part    angle ");
 strcpy(u2[SET_TURNING_POINTS],"Set turning points ");
 strcpy(u2[SET_JOINTS],"Set flexible joints "); 
 strcpy(u2[CLEAR_PARTS],"Clear parts ");  
 strcpy(u2[CLEAR_PICTURE],"Clear planes ");  
 strcpy(u2[REMOVE_EMPTY_POINTS],"Remove empty points ");    
 strcpy(u2[CONNECT_PARTS],"Connect     to ");     
 strcpy(u2[NEW_PART],"New part ");      
 strcpy(u2[SET_END_POINTS],"Set end points "); 
 
 u1[0].xcord=10*cs; 
 u1[0].ycord=TEST_TRANSFORM*cr; 
 u1[0].bsize=u1[0].size=2;
 u1[0].parmax=2;
 strcpy(u1[0].name,"1"); 
 
 u1[1].xcord=strlen(u2[TEST_TRANSFORM])*cs; 
 u1[1].ycord=TEST_TRANSFORM*cr; 
 u1[1].bsize=u1[1].size=3;
 u1[1].parmax=1;
 strcpy(u1[1].name,"20");  
 
 u1[2].xcord=strlen(u2[NEW_PART])*cs; 
 u1[2].ycord=NEW_PART*cr; 
 u1[2].bsize=u1[2].size=3;
 u1[2].parmax=1;
 strcpy(u1[2].name,"6");  
 
 u1[3].xcord=strlen(u2[REMOVE_EMPTY_POINTS])*cs; 
 u1[3].ycord=REMOVE_EMPTY_POINTS*cr; 
 u1[3].bsize=u1[2].size=3;
 u1[3].parmax=1;
 strcpy(u1[3].name,"15");  

 u1[4].xcord=8*cs; 
 u1[4].ycord=CONNECT_PARTS*cr; 
 u1[4].bsize=u1[4].size=3;
 u1[4].parmax=2;
 strcpy(u1[4].name,"?");   
 
 u1[5].xcord=strlen(u2[CONNECT_PARTS])*cs; 
 u1[5].ycord=CONNECT_PARTS*cr; 
 u1[5].bsize=u1[5].size=3;
 u1[5].parmax=1;
 strcpy(u1[5].name,"1");   
 
 u1[6].xcord=strlen(u2[RUN_ANIMATION])*cs; 
 u1[6].ycord=RUN_ANIMATION*cr; 
 u1[6].bsize=u1[6].size=3;
 u1[6].parmax=1;
 strcpy(u1[6].name,"2");   
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
		max,pmax,window,linelength);
 wd_object[id-1].options |= NO_KILLING; 
 strcpy(wd_object[id-1].name,"run menu");               
 return(0);
}
/******************************
* aedi_operations()
*
* This function calls needed menus based
* on id. Returns: 0=continue, 1=exit
*******************************/
int aedi_operations(id,bgedit) int id;int bgedit;
{
 switch(id) {
  case 2:return(aedi_menu(id,bgedit));
  case 3:move_menu(id);break;
  case 4:start_menu(id);return 1;
  case 5:pensize_menu(id);break;  
  case 8:cut_buffer_menu(id,6);break;      
  case 9:cut_buffer_color_menu(id,6);break;  
  case 10:replace_buffer_menu(id);break;
  case 11:list_files_menu(id);break;
 }
 return(0);
} 
/*************************************************
* drawbar_actions1(emptycol)
*
* Item Y<320: The variable set_palette activates
* when you point some colour in the palette and
* then hit the Enter-key thus enabling you to change
* the colour in the palette. With "?"-key you can
* see the value of colour and "y" or "Y"-keys exit
* the loop. 
* Item Y<340: The rubber gum.
* Item Y<360: 
* Item Y<380: The pen size menu. The double click
* exist the menu. The menu structure is drawn by
* the function pop_up_menu(int id,int com_par)
* which calls the actual routine popUpMenu(....).
* Id for the pensize menu structure is 5.
* Item Y<400: This shows the palette menu info.
* Item Y<420: The magnification of the picture. The
* enlarged no_resizeble area contains 31*31 pixels. 
* The function make_transparent_card(....) makes
* window structure by means of which you can move drawnings
* in the actual drawing board by clicking the window
* or to copy to the other editing plane seen in bottom
* screen by clicking left edge scroll bar box. Changes
* made in editing plane appear changes in actual drawing
* board. The function make_pixel_draw(...) makes largened window
* structure.The function put_wd_objects(...) make corresponding
* structures visible.
* Item Y<440: By means of cutbuffer you can copy drawnings in
* the actual drawning board just by pressing and holding rigth
* mouse button and moving the cutbuffer window and releasing
* the button.By left mouse button you can only move cut buffer 
* window to the different areas. The function make_transparent_
* card(...) makes the needed structures and put_wd_objects(...)
* make structures visible. 
* Item Y<460: Replace color in cut buffer changes the color in
* cutbuffer according to palette.
* Item Y<480:    
*****************************************************/
int drawbar_actions1(emptycol) int emptycol;
{
 int k,i;char line[20],**u2,ch;int *chosen;
 
 if(Y<320) {
  colorZ=Y/20;
  print(540,Y__max-15,"color=",colorZ);
  if(!pensize) pensize=1;            
  if(set_palette) {     
   k=palette[colorZ];
   while(1) {       
    ch=getch();
    if('y'==ch || 'Y'==ch) break;
    else if ('?'==ch) {
     xkoord=624;ykoord=colorZ*20+3;
     X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;  
     textn(int_to_string((long)k),0,15);                
     ch=getch();
     fillbox(616,colorZ*20,24,20,1);           
     fillbox(619,colorZ*20,20,20,colorZ);
     if('y'==ch || 'Y'==ch) break;
    }
    else {
     k++;if(k==64) k=0;         
     setVGApalette(colorZ,k);
     palette[colorZ]=k;          
    }
   }
   set_palette=0;              
  }
 }
 else if (Y<340) colorZ=emptycol;
 else if (Y<360) color_area_flag=1;
 else if (Y<380) {
  fill_pensizemenu(0,5,5,20,5,61*cs,360,15*cs,3*cs+5*cr,Co1,Co2,Co3,Co4,Co5);
  chosen=(int *)wd_object[4].p3;      
  u2=(char **)wd_object[4].p2;
  for(i=0;i<5;i++) {
   strcpy(line,u2[i]);line[7]=0;        
   if(pensize==string_to_int(&line[5])) {chosen[i] |= 1;break;}
  }      
  if(pop_up_menu(5,DRAW_ONLY_DO_NOT_STAY)>0) return(1);
  X=wd_object[4].xcord+3*cs;Y=wd_object[4].ycord+cr;
  if(pop_up_menu(5,NORMAL_OPERATION)>0) return(1);    
  pensize_menu(5);
  free_pop_up_menu(5);
 }
 else if (Y<400) {
  while(kbhit()) getch(); /* flush input */
  change_palette_info();
  set_palette=1;
 }     
 else if (Y<420) {
  if(wd_object[10].type==FREE_OBJ && wd_object[11].type==FREE_OBJ) {
   make_transparent_card(11,100,80,"lense.xxx",34,34,1);
   make_pixel_draw(12,35*cs,298,11+32*5+4,11+32*5+4,15,0,"largened.xxx",11);
   put_wd_objects(11,12);
  }
 }     
 else if (Y<440) {
  if(wd_object[5].type==FREE_OBJ) {             
   make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);          
   put_wd_objects(6,6);
  }      
 }     
 else if (Y<460) { /* replace color in cut buffer */
  if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
  else {
   fill_chgcolormenu(2,1,1,30,9,35*cs,420,40*cs,3*cs+1*cr,Co1,Co2,Co3,Co4,Co5);
   if(pull_down(9)) return(1);    
   cut_buffer_color_menu(9,6);
   free_pop_up_menu(9);       
  }
 }
 else if (Y<480) { /* match pattern */
  if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
  else {     
   if(wd_object[9].type==FREE_OBJ) {
    make_replace_buffer(10,35*cs,298,3*cs+30*5+2,3*cs+30*5+2,7,0,"replace.xxx",6);
    put_wd_objects(10,10);
   }
  }     
 }
 return 0;
}
/*********************************
* pensize_menu()
* 
* This function sets pensize selected by
* the user in the pensize menu. Pensize
* menu has to be id 5.
************************************/
int pensize_menu(id) int id;
{
 int i;int *chosen;char **u2,line[20];

 chosen=(int *)wd_object[id-1].p3;
 u2=(char **)wd_object[id-1].p2;
      
 for(i=0;i<5;i++) {
  if(chosen[i]&1) {
   strcpy(line,u2[i]);line[7]=0;
   pensize=string_to_int(&line[5]);break;}
 }
 return 0;
}
/************************************
* start_menu()
*
* This calls programs chosen by the user
* in the start menu.
**************************************/
int start_menu(id) int id;
{
 int action;int *chosen;char **u2;

 chosen=(int *)wd_object[id-1].p3;
 u2=(char **)wd_object[id-1].p2;
 if     (chosen[0]&1) action=1;      
 else if(chosen[1]&1) action=2;
 else if(chosen[2]&1) action=3;            
 else if(chosen[3]&1) action=4;            
 else if(chosen[4]&1) action=5; 
 else if(chosen[5]&1) action=6;                       
 free_one_wd_object(id);

 if      (action==1) animation_editor();
 else if (action==2) background_editor();
 else if (action==3) film1();
 else if (action==4) shooting_game();
 else if (action==5) return 1;
 else if (action==6) postcard();  
 return 1;
}
/**************************************
* move_menu()
*
***************************************/ 
int move_menu(id) int id;
{
 int i,j,x,y,class;int *chosen;LINE10 *u1;char **u2,line[20];
 PARTMOVES *partm;int clength,isize;
 unsigned int pixel, nopixel;int counter,color;
 
 chosen=(int *)wd_object[id-1].p3;
 u1=(LINE10 *)wd_object[id-1].p1;      
 u2=(char **)wd_object[id-1].p2;
 set_turnpoints=set_endpoints=set_flexdata=0;
 if(!part0) return 0;              
 if(chosen[RUN_ANIMATION] & 1) {
  if(part0) {
   part0->partmove_id=0;
   partm=partm_table[part0->partmove_id];
   clearwin(XOFF2,YOFF2,XOFF2+JSIZE,YOFF2+JSIZE-1,nocolor);          
   class=string_to_int(u1[6].name);
   if(class<RUNMODES) {
    inipartm(partm,class);     	
    inipart(part0,partm);     	
    clength=(int)(JSIZE/8)+1;
    isize=clength*GPLANES;
    if(!tplane1);tplane1=balloc(JSIZE*isize);
    if(tplane2) b_free(tplane2);tplane2=balloc(JSIZE*isize);
    save_buf1(XOFF2,YOFF2,JSIZE,JSIZE,clength,isize,tplane1);         
    while(1) {
     do {
      memcpy(tplane2,tplane1,isize*JSIZE);
      endp_transf(part0);
      animat_move(JSIZE,JSIZE,plane2,plane1,part0,clength,isize,tplane2);
      draw_buf1(XOFF2,YOFF2,JSIZE,JSIZE,clength,isize,tplane2);
      next_move(partm,part0);
     } while(!kbhit());
     if('q'==getch()) break;
    }
    b_free(tplane1);tplane1=0;
   }
  }
 }   
 else if(chosen[CHANGE_CURRENT_PLANE] & 1) {
  if(plane1 && plane2) {
   if(!strcmp(u2[CHANGE_CURRENT_PLANE],"Current plane= picture")) {
    strcpy(u2[CHANGE_CURRENT_PLANE],"Current plane= lines");    
    curplane=plane2;
   }
   else {
    strcpy(u2[CHANGE_CURRENT_PLANE],"Current plane= picture");          
    curplane=plane1;
   }

   display_line(u1,u2,wd_object[id-1].i1,CHANGE_CURRENT_PLANE,   
		wd_object[id-1].xstart,
		wd_object[id-1].ystart,
		wd_object[id-1].col3,
		wd_object[id-1].col4);
    
   /* draw current plane */
   if((char *)curplane==(char *)plane1) {
    clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor);
    nopixel=xcolor[nocolor].pixel;      
    for(y=0;y<JSIZE;y++) {
     for(x=0;x<JSIZE;x++) {
      pixel  =(*(plane1+3*JSIZE*y+3*x))<<16;
      pixel |=(*(plane1+3*JSIZE*y+3*x+1))<<8;
      pixel |= *(plane1+3*JSIZE*y+3*x+2);
      if(pixel!=nopixel) 
       fillbox2(XOFF1+(x<<1),YOFF1+(y<<1),2,2,pixel);  
     }
    }
   }
   else { /* if plane is lines */
    clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor);      
    for(y=0;y<JSIZE;y++) for(x=0;x<JSIZE;x++) fillc(x,y);
   }
  }
 }        
 else if(chosen[TEST_TRANSFORM] & 1) {
  if(part0) {
   j=string_to_int(u1[0].name);  	
   part0[j].angle=string_to_int(u1[1].name);
   clearwin(XOFF2,YOFF2,XOFF2+JSIZE,YOFF2+JSIZE-1,nocolor);
   clength=(int)(JSIZE/8)+1;
   isize=clength*GPLANES;      
   save_buf1(XOFF2,YOFF2,JSIZE,JSIZE,clength,isize,tplane2);    
   endp_transf(part0);
   animat_move(JSIZE,JSIZE,plane2,plane1,part0,clength,isize,tplane2);
   draw_buf1(XOFF2,YOFF2,JSIZE,JSIZE,clength,isize,tplane2);
  }
 }
 else if(chosen[CONNECT_PARTS] & 1) {
  if(part0) {    
   y=string_to_int(u1[5].name);
   if('?'!=u1[4].name[0])
    part0[y].connected=string_to_int(u1[4].name);
   else {
    strcpy(u1[4].name,int_to_string((long)(part0[y].connected)));
    display_line(u1,u2,wd_object[id-1].i1,CONNECT_PARTS, 
		wd_object[id-1].xstart,
		wd_object[id-1].ystart,
		wd_object[id-1].col3,
		wd_object[id-1].col4);     
   }
  }
 }   
 else if(chosen[SET_TURNING_POINTS] & 1) {
  if(part0) {
   clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor);          
   set_turnpoints=1; 
   nopixel=xcolor[nocolor].pixel; 
   for(i=0;i<MAXPARTS;i++) part_in_use[i]=0;

   for(y=0;y<JSIZE;y++) {
    for(x=0;x<JSIZE;x++) {
     color= *(plane2+JSIZE*y+x);
     if(color!= EMPTYCOL) {
       part_in_use[color]=1;       
      fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,14);      
      drawpixel(XOFF1+(x<<1),YOFF1+(y<<1),color);
     }
    }
   }
   for(i=0;i<MAXPARTS;i++) {
    if(part_in_use[i]) {
     fillbox(XOFF1+(part0[i].xcur<<1),YOFF1+(part0[i].ycur<<1),2,2,i);
    }
   }
  }
 }           
 else if(chosen[SET_JOINTS] & 1) { 
  if(part0) {   
   clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor);

   for(i=0;i<MAXPARTS;i++) part_in_use[i]=0;
   for(y=0;y<JSIZE;y++) {
    for(x=0;x<JSIZE;x++) {
     color= *(plane2+JSIZE*y+x);     
     if(color!= EMPTYCOL) {
      part_in_use[color]=1;
      fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,14);      
      drawpixel(XOFF1+(x<<1),YOFF1+(y<<1),color);             
     }
    }
   }

   set_flexdata=1; 
   for(i=0;i<MAXPARTS;i++) {
    if(part_in_use[i]) {
     x=XOFF1+(part0[i].xcur<<1);
     for(j=YOFF1+((part0[i].ycur-part0[i].l)<<1);
         j<YOFF1+(part0[i].ycur<<1);j++) drawpixel(x,j,i);         

     fillbox(x,YOFF1+((part0[i].ycur-part0[i].l)<<1),2,2,i);
     fillbox(x,YOFF1+((part0[i].ycur-part0[i].a)<<1),2,2,i);
     fillbox(x,YOFF1+(part0[i].ycur<<1),2,2,i);
     x=XOFF1+((part0[i].xcur+part0[i].xoff-XYOFF)<<1);                    
     fillbox(x,YOFF1+((part0[i].ycur+part0[i].yoff-XYOFF)<<1),2,2,i);       
    }
   }         
  }
 }
 else if(chosen[SET_END_POINTS] & 1) { 
  if(part0) {   
   clearwin(XOFF1,YOFF1,2*JSIZE+XOFF1,2*JSIZE+YOFF1-1,nocolor);          
   set_endpoints=1;
   nopixel=xcolor[nocolor].pixel; 
   for(i=0;i<MAXPARTS;i++) part_in_use[i]=0;
   for(y=0;y<JSIZE;y++) {
    for(x=0;x<JSIZE;x++) {
     color= *(plane2+JSIZE*y+x);     
     if(color!= EMPTYCOL) {
      part_in_use[color]=1;
      fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,14);      
      drawpixel(XOFF1+(x<<1),YOFF1+(y<<1),color);             
     }
    }
   }
   for(i=0;i<MAXPARTS;i++) {
    if(part_in_use[i]) {
     fillbox(XOFF1+(part0[i].xend<<1),YOFF1+(part0[i].yend<<1),2,2,i);
    }
   }         
  }
 }           
 else if(chosen[CLEAR_PARTS] & 1) {
  if(part0) {    
   for(i=0;i<MAXPARTS;i++) {part0[i].xcur=0;part0[i].connected=EMPTYCOL;}
   part0[1].xcur=70;part0[1].ycur=60;part0[1].xend=70;part0[1].yend=80;
   part0[1].xoff=XYOFF;part0[1].yoff=XYOFF;
   part0[1].l=12;part0[1].a=8;part0[1].direct=0;
   part0[2].xcur=25;part0[2].ycur=40;part0[2].xend=25;part0[2].yend=80;
   part0[2].xoff=XYOFF;part0[2].yoff=XYOFF;
   part0[2].l=12;part0[2].a=8;part0[1].direct=0;  
   part0[3].xcur=70;part0[3].ycur=30;part0[3].xend=70;part0[3].yend=20;
   part0[3].xoff=XYOFF;part0[3].yoff=XYOFF;
   part0[3].l=12;part0[3].a=8;part0[3].direct=0;
   part0[4].xcur=25;part0[4].ycur=30;part0[4].xend=25;part0[4].yend=20;
   part0[4].xoff=XYOFF;part0[4].yoff=XYOFF;
   part0[4].l=12;part0[4].a=8;part0[4].direct=0;
   part0[5].xcur=50;part0[5].ycur=20;part0[5].xend=50;part0[5].yend=40;
   part0[5].xoff=30;part0[5].yoff=XYOFF;part0[5].l=12;
   part0[5].a=8;part0[5].direct=0;  
  }
 }              
 else if(chosen[CLEAR_PICTURE] & 1) {
  if(plane1 && plane2) {
   nopixel=xcolor[nocolor].pixel;        
   for(i=0;i<JSIZE;i++) for(j=0;j<JSIZE;j++) {
    *(plane1+j*3*JSIZE+3*i)  =0xff&(nopixel>>16);
    *(plane1+j*3*JSIZE+3*i+1)=0xff&(nopixel>>8);
    *(plane1+j*3*JSIZE+3*i+2)=0xff&nopixel; 	 	
    *(plane2+JSIZE*j+i)=EMPTYCOL;}
  }
 }              
 else if(chosen[REMOVE_EMPTY_POINTS] & 1) {
  if(plane1 && plane2) {        
   nocolor=string_to_int(u1[3].name);
   nopixel=xcolor[nocolor].pixel;
   for(i=0;i<JSIZE;i++) for(j=0;j<JSIZE;j++) {
    pixel  =(*(plane1+3*JSIZE*y+3*x))<<16;
    pixel |=(*(plane1+3*JSIZE*y+3*x+1))<<8;
    pixel |= *(plane1+3*JSIZE*y+3*x+2);
    if(pixel!=nopixel) 
     *(plane2+JSIZE*j+i)=EMPTYCOL;
   }
  }
 }                    
 else if(chosen[NEW_PART] & 1) {
  if(part0) {
   i=string_to_int(u1[2].name);   
   part0[i].xcur=5;part0[i].ycur=5;    
   part0[i].xend=5;part0[i].yend=5;        
   part0[i].xoff=XYOFF;part0[i].yoff=XYOFF;
   part0[i].a=5;part0[i].l=10;          
   part0[i].connected=EMPTYCOL;
  }
 }                       
 return 0;
}
/****************************************
* aedi_menu
*****************************************/
int aedi_menu(id,bgedit) int id,bgedit;
{
 int i,j,m,n,x,y;
 int xsize,ysize,isize;
 int *chosen,class;
 LINE10 *u1;
 char **u2;
 FILE *stream;
 char line[20];
 char *buf;
 unsigned int pixel;
	
 chosen=(int *)wd_object[id-1].p3;
 u1=(LINE10 *)wd_object[id-1].p1;    
 if(chosen[0] & 1) { /* quit */
  free_wd_objects();
  if(part0) b_free(part0);
  return 1; /* exit */ 
 }
 else if(chosen[1] & 1) { /* read picture */
  if(bgedit) {
   use_aeeditor();
  }
  else {
   if(!part0) if(allopicture()) return 1;  
   stream=fopen(u1[0].name,"rb+");
   if(!stream) { /* error file not found */
    cannot_find_file(u1[0].name);
    return -1;
   }
   fread(line,1,4,stream); 
   /* the header tells us if the data is old or new */
   /* in old line[0],line[1]=xsize=100 and old line[2],line[3]=ysize=100 */
   /* in new, line[0] has the first bit set */
   if(line[0]==0){ /* old input file */
    buf=balloc(JSIZE*JSIZE);if(!buf){no_memory();return(1);}
    fread(buf,1,JSIZE*JSIZE,stream);
    change_to_24_colors(JSIZE,JSIZE,buf,plane1); 
    b_free(buf);
   }
   else {
    fread(plane1,1,3*JSIZE*JSIZE,stream);
   }
   fread(plane2,1,JSIZE*JSIZE,stream);
   fread((unsigned char *)part0,MAXPARTS,sizeof(TRANSFORMDATA),stream); 
   fclose(stream);
   for(y=0;y<JSIZE;y++) {
    for(x=0;x<JSIZE;x++) {
     pixel  = (0xff&(*(plane1+3*(JSIZE*y+x))))<<16;
     pixel |= (0xff&(*(plane1+3*(JSIZE*y+x)+1)))<<8;
     pixel |=  0xff&(*(plane1+3*(JSIZE*y+x)+2));
     fillbox2(XOFF1+(x<<1),YOFF1+(y<<1),2,2,pixel);
    }
   }
  }
  if(!bgedit)
   for(i=0;i<MAXPARTS;i++) part0[i].angle=0;
 }      
 else if(chosen[2] & 1) { /* save */
  if(bgedit) use_aeeditor();
  else {
   stream=0;    
   stream=fopen(u1[1].name,"rb+"); 
   if(stream) { /* copy on a existing file? */
    if(!copy_on_existing_file()) return(-1);
   }
   if(!stream) stream=fopen(u1[1].name,"wb+"); 
   if(!stream) { /* error can't create file */
    cannot_create_file();return(-1);
   }             
   for(i=0;i<JSIZE;i++) for(j=0;j<JSIZE;j++) 
    if(*(plane2+j*JSIZE+i)==15) *(plane2+j*JSIZE+i)=EMPTYCOL;
   /* sound(E2); */ delay(100);/* nosound(); */           
   rewind(stream);
   line[0]=0x80;line[1]=JSIZE;line[2]=0;line[3]=JSIZE;
   fwrite(line,1,4,stream);
   fwrite(plane1,1,3*JSIZE*JSIZE,stream);
   fwrite(plane2,1,JSIZE*JSIZE,stream);
   fwrite((unsigned char *)part0,MAXPARTS,sizeof(TRANSFORMDATA),stream);
   fclose(stream);
  }
 }
 else if(chosen[6] & 1) { /* load background */
  if(!bgedit) use_bgeditor();
  else {
   curplane=(char *)balloc(55440);
   if(!curplane) {no_memory();return(1);}
   gplanes=4; 
   for(i=0;i<2;i++) {
    strcpy(line,"backg");
    strcat(line,int_to_string((long)i));
    strcat(line,".fn2"); 
    xsize=ysize=isize=0x7fff; /* as input over maximum, will get values */ 
    loadbuf_fromfile(line,&xsize,&ysize,&isize,curplane);
    draw_buf1(0,i*180,608,180,77,308,curplane);     
   }
   gplanes=GPLANES; 
   b_free(curplane);
  }
 }
 else if(chosen[7] & 1) { /* save background */
  if(!bgedit) use_bgeditor();
  else {
   curplane=(char *)balloc(55440);
   if(!curplane) no_memory();    
   else {    
    gplanes=4; 
    /* sound(E2); */
    for(i=0;i<2;i++) {
     strcpy(line,"backg");
     strcat(line,int_to_string((long)i));
     strcat(line,".fn2"); 
     save_buf1(0,i*180,608,180,77,308,curplane);           
     savebuf_tofile(line,608,180,308,curplane);
    }
    /* nosound();*/
    gplanes=GPLANES; 
    b_free(curplane);
   }
  }        
 } 
 else if(chosen[3] & 1) { /* copy image to curplane */
   if(bgedit) use_aeeditor();
  else {
   if(  ((char *)curplane!=(char *)plane1 
     && (char *)curplane!=(char *)plane2) || color_area_flag
     ||  set_turnpoints || set_endpoints  || set_flexdata)
   {/*sound(E2);*/ delay(100);/*nosound();*/}/* put suitable error code*/
   else {

    if((char *)curplane==(char *)plane2) { /* linebuffer */
     for(x=0;x<JSIZE;x++) {
      for(y=0;y<JSIZE;y++) {
       /* this is drawing the place black and then restoring the color */
       /* probably for giving a visual effect of doing something       */ 
       i=change_pixel(XOFF1+(x<<1),YOFF1+(y<<1),0);
       drawpixel(XOFF1+(x<<1),YOFF1+(y<<1),i);
       *(curplane+JSIZE*y+x)=i;
      }
     }  
    }     
    else if((char *)curplane==(char *)plane1) { /* picturebuffer */
     for(x=0;x<JSIZE;x++) {
      for(y=0;y<JSIZE;y++) {
       /* so, let's do a similar virtual work by swapping black and color */
       pixel=getpixel2c(XOFF1+(x<<1),YOFF1+(y<<1));
       drawpixel2b(XOFF1+(x<<1),YOFF1+(y<<1),0);
       drawpixel2b(XOFF1+(x<<1),YOFF1+(y<<1),pixel);
       *(curplane+3*(JSIZE*y+x))  =0xff&(pixel>>16);
       *(curplane+3*(JSIZE*y+x)+1)=0xff&(pixel>>8);
       *(curplane+3*(JSIZE*y+x)+2)=0xff&pixel;
      }
     }
    }  
   }     
  }              
 }
 else if(chosen[4] & 1) { /* list files menu */   
  list_files(u1[2].name,11,
	wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
	30,5,Co1,Co2,Co3,Co4,Co5);   
 }      
 else if(chosen[5] & 1) { /* call cut buffer menu */
  fill_cutbuffermenu(2,3,3,20,8,
	 wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
	30*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5);
  if(pull_down(8)) return(1);
  cut_buffer_menu(8,6);
  free_pop_up_menu(8);    
 }
 return 0;      
}
/*******************************
* replace_buffer actions
********************************/
int replace_buffer_menu(id) int id;
{
 int j,n,m;int *chosen;char **u2;
	
 j=wd_object[id-1].i1-1; /* cut buffer id -1 */
 wd_object[j].i1=0;      
 for(m=1;m<wd_object[j].xsize-1;m++) {
  for(n=1;n<wd_object[j].ysize-1;n++) { 
   if(match_replacebuffer(wd_object[j].foreground,wd_object[id-1].p1,
		m,n,wd_object[j].clength,wd_object[j].isize,9))
   {
    replace(wd_object[j].foreground,(char *)wd_object[id-1].p2,
		m,n,wd_object[j].clength,wd_object[j].isize,9,j);
   }         
  }
 }
 return 0;      
}
/************************************
* cutbuffer color actions
*************************************/
int cut_buffer_color_menu(id,cutbuf_id) int id,cutbuf_id;
{
 int col1,col2;int *chosen;char **u2;LINE10 *u1;
	
 chosen=(int *)wd_object[id-1].p3;
 u1=(LINE10 *)wd_object[id-1].p1;    
 col1=string_to_int(u1[0].name);col2=string_to_int(u1[1].name);
 if(col1!=col2) {
  change_color(col1,col2,
		wd_object[cutbuf_id-1].xcord,wd_object[cutbuf_id-1].ycord,
		wd_object[cutbuf_id-1].xsize,wd_object[cutbuf_id-1].ysize,
		wd_object[cutbuf_id-1].clength,wd_object[cutbuf_id-1].isize,
		wd_object[cutbuf_id-1].foreground);

 }
 return 0;      
}
/************************************
* cutbuffer actions
*************************************/
int cut_buffer_menu(id,cutbuf_id) int id,cutbuf_id;
{
 int j;short x,y,x2,y2,isize;int *chosen;LINE10 *u1;
	
 chosen=(int *)wd_object[id-1].p3;
 u1=(LINE10 *)wd_object[id-1].p1;    
 j=cutbuf_id;
 if(chosen[0] & 1) { /* kill cut buffer */
  remove_cut_buffer(j,id);
 }
 else if (chosen[1] & 1) { /* save cut buffer */
  j--;
  if(wd_object[j].type==FREE_OBJ) no_cutbuffer();
  else {        
   if(save_picture(u1[0].name,
	wd_object[j].xcord+1,wd_object[j].ycord+1,
	wd_object[j].xcord+wd_object[j].xsize-1,
	wd_object[j].ycord+wd_object[j].ysize-1,
	wd_object[j].isize,palette)) return(1);   
  }
 }
 else if(chosen[2] == 1) { /* read cut buffer */
  j--;
  if(wd_object[j-1].type!=FREE_OBJ)
  { 
   x=wd_object[j].xcord;
   y=wd_object[j].ycord;
   remove_cut_buffer(j,id);
  }
  else x=100;y=100;
       
  x2=250;y2=250;            
  if(get_picture(u1[1].name,x+1,y+1,
      &x2,&y2,&isize,palette)) return(1);
      
  make_transparent_card(j+1,x,y,"cutbuffer.xxx",x2-x,y2-y,0);           
  wd_object[j].i1=0;         
  put_wd_objects(j+1,j+1);
	       
  save_buf2(wd_object[j].xcord,wd_object[j].ycord,1,1,
	wd_object[j].xsize-1,wd_object[j].ysize-1,wd_object[j].xcord&7,
	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);
 }   

 return 0;      
}
/**********************************
* remove cut buffer
***********************************/
int remove_cut_buffer(j,id) int j;
{
 if(wd_object[j-1].type==FREE_OBJ) return 1;    
 update_over(id);    
 bring_id_to_top(j);          
 if_b_opt_bgfromfile(j);    
 update_over(j);   
 free_transparent_card(j);
 update_over(id);     
 return 0;      
}
/***************************************
* allocate memory structures for picture
*****************************************/
int allopicture()
{int i,j;int size,isize;
 unsigned int nopixel;

 nopixel=xcolor[nocolor].pixel;

 isize=GPLANES*(JSIZE/8+1);
 size=((3*JSIZE)>isize ? (3*JSIZE*JSIZE):(isize*JSIZE)); 
 
 if(!part0) part0=(TRANSFORMDATA *)balloc(sizeof(TRANSFORMDATA)*MAXPARTS);
 if(!part0) {no_memory();return 1;}
 if(!plane1) plane1=balloc(size);
 if(!plane1) {no_memory();return 1;}    
 if(!plane2) plane2=balloc(size);
 if(!plane2) {no_memory();return 1;}     
 if(!tplane2) tplane2=balloc(size);
 if(!tplane2) {no_memory();return 1;}     
 curplane=plane1;
 for(i=0;i<JSIZE;i++) for(j=0;j<JSIZE;j++) {
  *(plane2+j*JSIZE+i)  =EMPTYCOL; 	
  *(plane1+j*3*JSIZE+3*i)  =0xff&(nopixel>>16);
  *(plane1+j*3*JSIZE+3*i+1)=0xff&(nopixel>>8);
  *(plane1+j*3*JSIZE+3*i+2)=0xff&nopixel; 	 	
 }
 return 0;
}
/***********************************************
* in animation editor plane1 and plane2 are used 
* for the picture front and moving parts resp.
* if erasor (EMPTYCOL) is used on plane2, then
* all nocolor points are made yellow.
************************************************/
void fillb(x,y,clear) int x,y,clear;
{
 unsigned int pixel,nopixel;

 nopixel=xcolor[nocolor].pixel;

 pixel  = (*(plane1+3*JSIZE*y+3*x  ))<<16;     
 pixel |= (*(plane1+3*JSIZE*y+3*x+1))<<8;     
 pixel |=  *(plane1+3*JSIZE*y+3*x+2);     

 if(*(plane2+JSIZE*y+x)==EMPTYCOL) {
  if(pixel!=nopixel) fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,15);
  else if(clear) fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,nocolor);
 }
 else {
  fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,15);
  drawpixel(XOFF1+(x<<1),YOFF1+(y<<1),(short)(*(plane2+JSIZE*y+x)));
 }
}

/***********************************************
* if in plane1 not nocolor, then make white
* if for a point plane1 is nocolor, then the color
* of plane2 is drawn unless on plane2 is emptycolor
************************************************/
void fillc(x,y) int x,y;
{
 unsigned int pixel,nopixel,emptypixel;

 nopixel=xcolor[nocolor].pixel;

 pixel  = (*(plane1+3*JSIZE*y+3*x  ))<<16;     
 pixel |= (*(plane1+3*JSIZE*y+3*x+1))<<8;     
 pixel |=  *(plane1+3*JSIZE*y+3*x+2);      

 if(pixel!=nopixel) fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,15);
 colorZ= *(plane2+JSIZE*y+x);     
 if(colorZ!= EMPTYCOL) fillbox(XOFF1+(x<<1),YOFF1+(y<<1),2,2,colorZ);      	
}


