/************************************
* ANIDEMO.C Animation routines
*      Jorma Jormakka
*      28.9.92
*************************************/
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "animatio.ext"
extern XColor *xcolor;
int pensize,nocolor;
void handle_gun();
void init_gun();
extern unsigned char palette[16];
extern int debug1;
extern int debug11;
static int random11;
/************************************************
*   film1()
*************************************************/ 
int film1()
{
 int i,x,y;
 OBJLIST *objl,*cobjl;

 X1_min=10;Y1_min=10;X1_max=618;Y1_max=410; 
 loadbackground("bfish");

 /* allocate as many structures as there are animation objects */
 for(i=0;i<6;i++) allo_partm(i); 

 /* fill_animation(id,name,xcord,ycord,class,level,partmove_id)          */
 /* id, identified of object. Error texts uses id=1, it is not available */
 /* name, name of an animation file made with editor in ae.c             */
 /* coords give the starting place of the animation                      */
 /* class is a movement type, can put there any number for which         */
 /* movement is defined, like 2-5 or so on                               */
 /* level means that higher level is on top when animations pass         */
 /* partmove_id is the identifier in partm_table, must be unique <10 now */
 fill_animation(2,"fish2.ani",300,140,2,0,0);
 fill_animation(3,"fish2.ani",100,240,2,1,1);
 fill_animation(4,"fish2.ani",200,100,2,2,2);
 fill_animation(5,"fish2.ani",150,300,2,3,3);
 fill_animation(6,"fish2.ani",350,230,2,4,4);
 fill_animation(7,"fish2.ani",250,160,2,5,5);

 /* turn some animations backwards */
 turnx(1,1);
 turnx(3,1);

/* this is a way to get close by objects be drawn after each other */
 objl=cobjl=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->prev=0;cobjl->id=2;
 cobjl->next=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->next->prev=cobjl;cobjl=cobjl->next;cobjl->id=3;
 cobjl->next=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->next->prev=cobjl;cobjl=cobjl->next;cobjl->id=4;
 cobjl->next=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->next->prev=cobjl;cobjl=cobjl->next;cobjl->id=5;
 cobjl->next=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->next->prev=cobjl;cobjl=cobjl->next;cobjl->id=6;
 cobjl->next=(OBJLIST *)malloc(sizeof(OBJLIST));
 cobjl->next->prev=cobjl;cobjl=cobjl->next;cobjl->id=7;
 cobjl->next=0;

 put_wd_objects(2,7);
 /*
 put_one_wd_object(2);
 put_one_wd_object(3);
 put_one_wd_object(4);
 put_one_wd_object(5);
 put_one_wd_object(6);
 put_one_wd_object(7);
 */

 /* the main loop */
 if(do_film1_engine(objl)) {getch();}
 
 /* free the buffers in the linked list */
 for(cobjl=objl;cobjl;cobjl=objl) {
  objl=cobjl->next;free(cobjl);	
 }
 /* free animation structures */
 for(i=0;i<6;i++) free_partm(i);     

#ifdef JJ
 /* free standard GRAPH buffers */
 return(free_win(1,0x0));
#endif
 return 0;
}
/************************************************
*   postcard()
*************************************************/ 
int postcard()
{
 int i,x,y;

 X1_min=Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 clearwin(0,0,X__max,50,15); 
 clearwin(0,40,X__max,250,2);  
 clearwin(0,250,X__max,Y__max,1);  

 for(i=0;i<3;i++) allo_partm(i);     
 fill_animation(2,"man2.ani" , 10,100,6,0,0);
 fill_animation(3,"fish4.ani",500,340,5,1,1); 
 fill_animation(5,"man3.ani" ,300,100,7,2,2);
 wd_object[4].options|=WINDOW_HIDDEN;
  
 turnx(2,1);    
 
 make_file_window(4,20*cs,20,50*cs,3*cs+2*cr,Co1,Co2,Co3,Co4,"hello.txt",20,-1);  
 wd_object[3].options=
  WINDOW_HIDDEN | NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING | NO_RESIZING | NO_KILLING; 
 
 if(put_wd_objects(2,3)) return(1);  

 if(do_postcard_engine(6)) {getch();}

 for(i=0;i<3;i++) free_partm(i);     
 return 0;
}
/************************************************
*   shooting_game()
*************************************************/ 
int shooting_game()
{
 int i,x,y;
 
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 loadbackground("backg"); 
 
 allo_partm(0);
 fill_animation(2,"wolf.ani",300,210,0,0,0); 
 if(put_wd_objects(2,2)) return(1);
 if(do_game_engine(1)) {getch();}
 free_partm(0);
 return 0; 
}
/************************************************
*   do_film1_engine
*************************************************/ 
int do_film1_engine(objl) OBJLIST *objl;
{
 int id,id2;
 TRANSFORMDATA *part1;PARTMOVES *partm;
 char ch;long counter=0;
 OBJLIST *cobjl,*cob;

 while(1) {	
  do {
   counter++;
   /* this demo runs only animations */
   cobjl=objl;
   while(cobjl)
   {
    id=cobjl->id;
    part1=(TRANSFORMDATA *)wd_object[id-1].p4;
    partm=partm_table[part1->partmove_id]; 
    next_move(partm,part1);

    /* after bring_id_to_top, stacking order is restored, id is on top */
    bring_id_to_top(id,0);
    /* animate gets all objects visible and stacking order restored */
    /* must leave everything in a similar state */

    animate(id,NORMAL_OPERATION);

    /* get_top_card does not change stacking order */
    id2=get_top_card(wd_object[id-1].xcord,wd_object[id-1].ycord,
      wd_object[id-1].xcord+wd_object[id-1].xsize,
      wd_object[id-1].ycord+wd_object[id-1].ysize);

     /* if id2 has not been drawn yet, it is in the linked list */
     /* find it and put it to be next in the list */
    for(cob=cobjl->next;cob;cob=cob->next) {
     if(id2==cob->id) { 
      /* unlink cob */
      if(cob->prev) cob->prev->next=cob->next;
      if(cob->next) cob->next->prev=cob->prev;
      /* link first */
      cob->next=cobjl->next;
      cob->prev=cobjl;
      if(cobjl->next) cobjl->next->prev=cob;
      cobjl->next=cob;
      break;	
     }	
    }
    cobjl=cobjl->next;
   }
  } while(!kbhit());
  ch=getch();
  if(ch=='q') return(0);
  if(ch=='d') {debug1=1;print(10,10,"counter=",counter);}
 }
}
/************************************************
*   do_postcard_engine
*************************************************/ 
int do_postcard_engine(max) int max;
{
 int i,id;char ch;int counter=0;
 TRANSFORMDATA *part1;PARTMOVES *partm;

 while(1) {	
  do {
   for(i=0;i<max;i++) {
    if(!(wd_object[i].options & WINDOW_HIDDEN)) {
     if(wd_object[i].type==ANIMATION_OBJ)
      
     {
      id=i+1;
      part1=(TRANSFORMDATA *)wd_object[i].p4;
      partm=partm_table[part1->partmove_id];  
      next_move(partm,part1);  	
      bring_id_to_top(id,0);      
      update_over(id);
      animate(id,NORMAL_OPERATION);
      update_over(id);
      /* when man2 is in place xcord >200 */  
      if(wd_object[1].xcord>200) {  	      
      
       if(!counter) {
        if(wd_object[3].options&WINDOW_HIDDEN) {
         postcard_hello(4,0);
         hide_object(2);
         wd_object[4].options -= WINDOW_HIDDEN;
         wd_object[4].xcord=wd_object[1].xcord;
         wd_object[4].ycord=wd_object[1].ycord;         
  	 put_wd_objects(5,5);
        }
       }
       counter++;
       if(counter==35) {
        hide_object(4);      	
        turnx(i,1);
       }
       if(counter==55) {
        if(wd_object[3].options&WINDOW_HIDDEN) {
         postcard_hello(4,2);
        }      		
       }
       if(counter==85) {
        hide_object(4);
        hide_object(5);
        wd_object[1].options -= WINDOW_HIDDEN;
        wd_object[1].xcord=wd_object[4].xcord;
        wd_object[1].ycord=wd_object[4].ycord;
  	put_wd_objects(2,2);
  	change_runmode(2,3);  	        
        turnx(1,1);           	
       }      
       if(counter==100){
        hide_object(2);
        wd_object[4].options -= WINDOW_HIDDEN;
        wd_object[4].xcord=wd_object[1].xcord;
        wd_object[4].ycord=wd_object[1].ycord;         
  	put_wd_objects(5,5);
  	change_runmode(5,3);
       }
       if(counter==120){
        hide_object(5);
        wd_object[1].options -= WINDOW_HIDDEN;
        wd_object[1].xcord=wd_object[4].xcord;
        wd_object[1].ycord=wd_object[4].ycord;         
  	put_wd_objects(2,2);
  	change_runmode(2,3);  	       	
       }       
       if(counter==160) return 0;
      }
     }     
    }
   }
  } while(!kbhit());
  ch=getch();
  if(ch=='q') return(0);
 }
}
/************************************************
*   do_game_engine
*************************************************/ 
int do_game_engine(gun) int gun;
{
 int i;
 TRANSFORMDATA *part1;PARTMOVES *partm;
 GUNDATA *gundata;

 if(gun) {  
  gundata=(GUNDATA *)malloc(sizeof(GUNDATA));
  if(!gundata) {no_memory();return(1);}
  init_gun(gundata);
 } 

 X1_min=0;Y1_min=205;X1_max=600;Y1_max=390;

 while(1) {	
  do {
   for(i=0;i<MAX_WINDOWS;i++) {
    if(wd_object[i].type==ANIMATION_OBJ) {
     bring_id_to_top(i+1,0);
     update_over(i+1);
     animate(i+1,NORMAL_OPERATION);
     update_over(i+1);     
     part1=(TRANSFORMDATA *)wd_object[i].p4;
     partm=partm_table[part1->partmove_id]; 
     next_move(partm,part1);  	     
    }
   }
   if(gun) {
    X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
    handle_gun(gundata);
    X1_min=0;Y1_min=205;X1_max=600;Y1_max=390;
   }
  } while(!kbhit());
  if(getch()=='q') { if(gun) free(gundata);return(0);}
 }
}
/************************************************
*   handle_gun
*************************************************/ 
void handle_gun(GUNDATA *gundata)   
{
 int i,j,k,Xb,Yb,col;
 	
 buttons=0;
 readmouse(&buttons,&X,&Y);
 if(buttons&2) {
   flush_mouse();
  if(gundata->move==1) {
   gundata->move=2;    	
   if(gundata->ontop==1) {
    restorecursor1(gundata->Xold1,gundata->Yold1,2,10,
      gundata->sbuf1,gundata->cbuf1);   
    restorecursor1(gundata->Xold2,gundata->Yold2,2,10,
      gundata->sbuf2,gundata->cbuf2);
    savecursor1(gundata->Xold1,gundata->Yold1,2,10,
     gundata->sbuf1,gundata->cbuf1);
    drawcursor1(gundata->Xold1,gundata->Yold1,0,2,10,gundata->cbuf1);
    gundata->Xold2=X;gundata->Yold2=Y;                      
    savecursor1(gundata->Xold2,gundata->Yold2,2,10,
		gundata->sbuf2,gundata->cbuf2);
    drawcursor1(gundata->Xold2,gundata->Yold2,0,2,10,gundata->cbuf2);          
    gundata->ontop=2;                
   }      
   else {
    restorecursor1(gundata->Xold2,gundata->Yold2,2,10,
		   gundata->sbuf2,gundata->cbuf2);
    gundata->Xold2=X;gundata->Yold2=Y;                      
    savecursor1(gundata->Xold2,gundata->Yold2,2,10,
		gundata->sbuf2,gundata->cbuf2);
    drawcursor1(gundata->Xold2,gundata->Yold2,0,2,10,gundata->cbuf2);
   }
  }
  else if(gundata->move==2) {
   gundata->move=1;
   if(gundata->ontop==2) {
    restorecursor1(gundata->Xold2,gundata->Yold2,2,10,
		   gundata->sbuf2,gundata->cbuf2);
    restorecursor1(gundata->Xold1,gundata->Yold1,2,10,
                   gundata->sbuf1,gundata->cbuf1);   
    savecursor1(gundata->Xold2,gundata->Yold2,2,10,
		gundata->sbuf2,gundata->cbuf2);
    drawcursor1(gundata->Xold2,gundata->Yold2,0,2,10,gundata->cbuf2);
    gundata->Xold1=X;gundata->Yold1=Y;                 
    savecursor1(gundata->Xold1,gundata->Yold1,2,10,
		gundata->sbuf1,gundata->cbuf1);
    drawcursor1(gundata->Xold1,gundata->Yold1,0,2,10,gundata->cbuf1);     
    gundata->ontop=1;
   }
   else {
    restorecursor1(gundata->Xold1,gundata->Yold1,2,10,
		   gundata->sbuf1,gundata->cbuf1);    
    gundata->Xold1=X;gundata->Yold1=Y;                 
    savecursor1(gundata->Xold1,gundata->Yold1,2,10,
		gundata->sbuf1,gundata->cbuf1);
    drawcursor1(gundata->Xold1,gundata->Yold1,0,2,10,gundata->cbuf1);
   }
  }      
 }
 else if(gundata->move==1) {
  flush_mouse();
  if(gundata->Xold1!=X || gundata->Yold1!=Y) {  
   restorecursor1(gundata->Xold1,gundata->Yold1,2,10,
		  gundata->sbuf1,gundata->cbuf1);
   gundata->Xold1=X;gundata->Yold1=Y;      
   savecursor1(gundata->Xold1,gundata->Yold1,2,10,
	       gundata->sbuf1,gundata->cbuf1);
   drawcursor1(gundata->Xold1,gundata->Yold1,0,2,10,gundata->cbuf1);
  }
 }    	
 else if(gundata->move==2) {
  flush_mouse();
  if(gundata->Xold2!=X || gundata->Yold2!=Y) { 
   restorecursor1(gundata->Xold2,gundata->Yold2,2,10,
		  gundata->sbuf2,gundata->cbuf2);
   gundata->Xold2=X;gundata->Yold2=Y;      
   savecursor1(gundata->Xold2,gundata->Yold2,2,10,
    gundata->sbuf2,gundata->cbuf2);
   drawcursor1(gundata->Xold2,gundata->Yold2,0,2,10,gundata->cbuf2);
  }
 }
 if(buttons&1) {
  flush_mouse();
  /* sound(E2);delay(20);nosound();*/
  Xb=(((gundata->Xold2-gundata->Xold1)/8)*160)+
  	((gundata->Xold2-gundata->Xold1)%8)*4+gundata->Xold1+1;
  Yb=((gundata->Yold2-gundata->Yold1)*30)+gundata->Yold1-100;    	    	
  random11=linear_regression(random11,389,517,1);
  Xb+=random11%11;  
  random11=linear_regression(random11,319,517,1);
  Yb+=random11%31;
    
  if(Xb>0 && Xb<X__max-1 && Yb>0 && Yb<400) {
   fillbox(Xb-1,Yb-1,3,3,0); /* this is a shot */
     
   for(i=0;i<MAX_WINDOWS;i++) {
    if(wd_object[i].type==ANIMATION_OBJ) {
     Xb=Xb-wd_object[i].xcord;Yb=Yb-wd_object[i].ycord;
     if(Xb>0 && Xb<wd_object[i].xsize && Yb>0 && Yb<wd_object[i].ysize
        	&& (int)(*(wd_object[i].p2+Yb*JSIZE+Xb))!=(int)EMPTYCOL ){
      col= (int)(*(wd_object[i].p2+Yb*JSIZE+Xb));
      if(col==0 || col==3) {
       sound(E3);delay(200);nosound();
       wd_object[i].i1=1;/* die */
      }
      else {
       xkoord=45;ykoord=450;
       otext("WOUNDED!!",4,2);  
       sound(E3);delay(200);nosound();         
       gundata->total -= 200;
       xkoord=50;ykoord=430;
       otext(int_to_string(gundata->total),4,2);         
      }
      break;
     }
     else {
      j=wd_object[i].i1;
      
      if(j!=2) k=2;else k=3;
      wd_object[i].i1=k; 
      gundata->total -= 100;
      xkoord=50;ykoord=430;
      otext(int_to_string(gundata->total),4,2);
     }       	 	
    }
   }
  }
 }
}
/************************************************
*   init_gun
*************************************************/ 
void init_gun(GUNDATA *gundata)
{ 
 char cbuf1[20]={
  0x38,0x38, 
  0x38,0x38, 
  0x38,0x38, 
  0x38,0x38,
  0x38,0x38, 
  0xff,0xfe, 
  0xff,0xfe, 
  0xff,0xfe, 
  0xff,0xfe,      
  0xff,0xfe
 };
 char cbuf2[20]={
  0x03,0x80, 
  0x03,0x80, 
  0x03,0x80, 
  0x03,0x80,      
  0x03,0x80, 
  0x03,0x80, 
  0x03,0x80, 
  0x03,0x80,      
  0xff,0xfe, 
  0xff,0xfe
 };
 memcpy(gundata->cbuf1,cbuf1,20);
 memcpy(gundata->cbuf2,cbuf2,20); 
 gundata->Xold2=300;gundata->Yold2=400;
 savecursor1(gundata->Xold2,gundata->Yold2,2,10,
	     gundata->sbuf2,gundata->cbuf2); 
 drawcursor1(gundata->Xold2,gundata->Yold2,0,2,10,gundata->cbuf2);
         
 gundata->Xold1=300;gundata->Yold1=400;
 savecursor1(gundata->Xold1,gundata->Yold1,2,10,
	     gundata->sbuf1,gundata->cbuf1);
 drawcursor1(gundata->Xold1,gundata->Yold1,0,2,10,gundata->cbuf1);        

 gundata->move=1;gundata->ontop=1;
 setmouselim(0,390,X__max-16,Y__max-10);
 setmouse(gundata->Xold1,gundata->Yold1); 
 gundata->total=0;
 xkoord=45;ykoord=410;
 otext("YOUR SCORE",4,2);  
 xkoord=50;ykoord=430;
 otext(int_to_string(gundata->total),4,2); 
}  

/******************************************/
int postcard_hello(i,off) int i,off;
{
 wd_object[i-1].xstart=0;wd_object[i-1].ystart=off;   	  
 if(file_window(i,DRAW_ONLY_DO_NOT_STAY)>0) return(1);
 if(wd_object[i-1].options & WINDOW_HIDDEN) {  	
  wd_object[i-1].options -= WINDOW_HIDDEN;   
  update_over(i);
 }
 return(0); 	
}
int hide_object(i) int i;
{
 if(!(wd_object[i-1].options & WINDOW_HIDDEN)){
  update_over(i); 	
  wd_object[i-1].options |= WINDOW_HIDDEN;
  remove_background(i);
 }
 return 0;
}

/*********************************************
 * these were defined in asm
 *********************************************/
/* the cursor is drawn to (x,y)                         */
/* the cursor has width a characters and hight b pixels */
/* and its form is defined in cursorbuf                 */

int drawcursor1(x,y,col,a,b,cursorbuf)
int x,y,col,a,b;unsigned char *cursorbuf;
{int i,j,m,n;unsigned int pixel,byte,bit;

 pixel=xcolor[col].pixel;
 m=0;

 for(j=y;j<y+b;j++) {
  for(i=0;i<a;i++) { 
   byte=(unsigned int)cursorbuf[m];
   for(n=0,bit=0x80;n<8;n++,bit=bit>>1) { 
    if(bit&byte) drawpixel2b(x+(i<<3)+n,j,pixel);
   }
   m++;
  }
 }
 return 0;
}

/**************************************************************
 * saving cursor of 20 bytes requires max 20*8=160 unsigned int
 * actually 5*6+5*15=105 is enough for sbuf1
 * and      8*3+2*15=74 for sbuf2
 **************************************************************/
int savecursor1(x,y,a,b,savebuf,cursorbuf)
int x,y,a,b;unsigned int *savebuf;unsigned char *cursorbuf;
{int i,j,m,m2,n;unsigned int pixel,byte,bit;

 m=m2=0;
 for(j=y;j<y+b;j++) {
  for(i=0;i<a;i++) { 
   byte=(unsigned int)cursorbuf[m2];
   for(n=0,bit=0x80;n<8;n++,bit=bit>>1) { 
    if(bit&byte){
     savebuf[m]=getpixel2c(x+(i<<3)+n,j);
     m++;
    }
   }
   m2++;
  }
 }
 return 0;
}

int restorecursor1(x,y,a,b,savebuf,cursorbuf)
int x,y,a,b;unsigned int *savebuf;unsigned char *cursorbuf;
{int i,j,m,m2,n;unsigned int byte,bit;

 m=m2=0;
 for(j=y;j<y+b;j++) {
  for(i=0;i<a;i++) { 
   byte=(unsigned int)cursorbuf[m2];
   for(n=0,bit=0x80;n<8;n++,bit=bit>>1) { 
    if(bit&byte){
     drawpixel2b(x+(i<<3)+n,j,savebuf[m]);
     m++;
    }
   }
   m2++;
  }
 }
 return 0;
}
  




