/*******************************************
* 
* Author:     	Jorma Jormakka
* Date:   	Feb.2017
********************************************/
#include <string.h>
#include <math.h>
#include "x.ext"
#include "pmenus.ext"
#include "win.ext"
#include "text.ext"

typedef struct {
  int size;
  float f1[100000];
  float f2[100000];
  float f3[100000];
  float f4[100000];
} RESDATA;

#define CEDI_MODULE

extern XImage   *screenbuf;
extern XImage   *screenbuf1;
extern XColor *xcolor;
extern XColor *xcolor2;
extern int xxmin,yymin,xxmax,yymax;
int exit_vect_ed;
int X1_image=0,Y1_image=0,X2_image=474,Y2_image=549;
JMPTABLE c_table[30];
int color_area_flag=0; 
int color_request_flag=0;
extern int vobjmode;
extern int nocolor,pensize,colorZ;
extern VECTOR_OBJECT *cvobj,*firstvobj,*lastvobj;
extern VECTOR_OBJECT *create_vector_obj();
extern FILE *open_eps(); 
extern void draw_vobj();
extern int xxmin,yymin,xxmax,yymax;
extern oldX,oldY;

unsigned char palette[16]={0,9,26,54,36,13,10, 7,56,59,58, 6,37,61,62,63};
int saved=0;
int debug;

char plot1name[30];
char plot2name[30];
char plot3name[30];
static RESDATA *pointer1;

/*********************************************/
static int analysis_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
 int xoff,stepx,start;
 float xscale,yscale,ave;

 if(chosen[0] & 1) { 
  if(!strcmp(u1[1].name,"1")) {
   autocorrelation(u1[0].name,"1");
   strcpy(plot1name,"autocor1.res");
   clearwin(0,0,X__max,170,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0;  /* default values */
   plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[1].name,"2")) {         
   autocorrelation(u1[0].name,"2");
   strcpy(plot2name,"autocor2.res");
   clearwin(0,176,X__max,170+176,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0; 
   plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[1].name,"3")) {         
   autocorrelation(u1[0].name,"3");
   strcpy(plot3name,"autocor3.res");
   clearwin(0,352,X__max,170+352,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0; 
   plot_anew(plot3name,352,xoff,stepx,(double)xscale,(double)yscale,0);
  }
 }
 else if(chosen[1] & 1) {
  if(!strcmp(u1[4].name,"1")) {
   correlation(u1[2].name,u1[3].name,"1");
   strcpy(plot1name,"corre1.res");
   clearwin(0,0,X__max,170,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0;  /* default values */
   plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[4].name,"2")) {      
   correlation(u1[2].name,u1[3].name,"2");
   strcpy(plot2name,"corre2.res");
   clearwin(0,176,X__max,170+176,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0; 
   plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[4].name,"3")) {
   correlation(u1[2].name,u1[3].name,"3");   
   strcpy(plot3name,"corre3.res");
   clearwin(0,352,X__max,170+352,nocolor);
   xoff=0;stepx=1;xscale=1.0;yscale=1.0; 
   plot_anew(plot3name,352,xoff,stepx,(double)xscale,(double)yscale,0);
  }

 }
 else if(chosen[2] & 1) {
  if(!strcmp(u1[7].name,"1")) {
   strcpy(plot1name,"compar1.res");
   start=0;
   my_correlation(u1[5].name,u1[6].name,plot1name,&ave,&xoff,&yscale,
    1,start,u1[8].name);
   clearwin(0,0,X__max,170,nocolor);
   stepx=1;xscale=0.02;yscale=1.0;  
   plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[7].name,"2")) {      
   strcpy(plot2name,"compar2.res");
   start=0;
   my_correlation(u1[5].name,u1[6].name,plot2name,&ave,&xoff,&yscale,
    1,start,u1[8].name);
   clearwin(0,176,X__max,170+176,nocolor);
   stepx=1;xscale=0.02;yscale=1.0; 
   plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(!strcmp(u1[7].name,"3")) {
   strcpy(plot3name,"compar3.res");
   start=1544; /* moving HOLD2 0.035 s to the right */ 
   yscale=0.7; /* starting value */
   my_correlation(u1[5].name,u1[6].name,plot3name,&ave,&xoff,&yscale,
		  1,start,u1[8].name);
   /* plot the second signal with the final offset and obtained yscale */
   clearwin(0,176,X__max,170+176,nocolor);
   stepx=1;xscale=0.02;
   plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,0);
   /* plot the difference */
   clearwin(0,352,X__max,170+352,nocolor);
   stepx=1;xscale=0.02;yscale=1.0; 
   plot_anew(plot3name,352,xoff,stepx,(double)xscale,(double)yscale,0);
  }
 }

 return 0; 
}
/*********************************************/
static int analysis2_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
 int xoff,stepx,start;
 float xscale,yscale,ave;
 int x1,x2,y1,y2,low,high;

 if(chosen[0] & 1) { 
  low=string_to_int(u1[1].name);
  high=string_to_int(u1[2].name);
  filter_spectrum(u1[6].name,u1[0].name,low,high,1); 
 }
 else if(chosen[1] & 1) {
  if(!strcmp(u1[4].name,"1")) {
   strcpy(plot1name,"spectr1.spe");
   power_spectrum(u1[3].name,plot1name,u1[5].name);
   clearwin(0,0,X__max,170,nocolor);
   xoff=0;stepx=1;xscale=0.4;yscale=1.0; 
   plot_spectrum_anew(plot1name,0,xoff,stepx,
    (double)xscale,(double)yscale,0,u1[5].name);
  }
  else if(!strcmp(u1[4].name,"2")) {      
   strcpy(plot2name,"spectr2.spe");
   power_spectrum(u1[3].name,plot2name,u1[5].name);
   clearwin(0,176,X__max,170+176,nocolor);
   xoff=0;stepx=1;xscale=0.4;yscale=1.0; 
   plot_spectrum_anew(plot2name,176,xoff,stepx,
    (double)xscale,(double)yscale,0,u1[5].name);
  }
  else if(!strcmp(u1[4].name,"3")) {
   strcpy(plot3name,"spectr3.spe");
   power_spectrum(u1[3].name,plot3name,u1[5].name);
   clearwin(0,352,X__max,170+352,nocolor);
   xoff=0;stepx=1;xscale=0.4;yscale=1.0; 
   plot_spectrum_anew(plot3name,352,xoff,stepx,
    (double)xscale,(double)yscale,0,u1[5].name);
  }
 }
 else if(chosen[2] & 1) {
  low=string_to_int(u1[7].name);
  high=string_to_int(u1[8].name);
  printf("going to filter_spectrum low=%d high=%d\n",low,high);
  filter_spectrum(u1[6].name,u1[0].name,low,high,0); 
 }

 return 0; 
}
/***************************************************
 * Concerning any fill-routine
 * max=number of u1 fields, pmax=number of u2 fields
 * window= how many u2-lines are shown
 * linelength=max length of u2-line
 * id=identifier of the menu, use a free one
 * x,y= coordinates of the left upper corner
 * xsize,ysize=size of the window
 * col1,col2,col3,col4,col5= colors used in the menu 
 ***************************************************/
int fill_analysis_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],analysis_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"Autocorrelation of               to Plot");
 strcpy(u2[1],"Correlation of           and            to Plot");
 strcpy(u2[2],"Comparison  of           and            to Plot  samples=");

 len=strlen("Autocorrelation of ");
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].size=u1[0].bsize=8;
 strcpy(u1[0].name,plot1name);

 u1[1].xcord=(len+22)*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=2;
 strcpy(u1[1].name,"1");

 len=strlen("Correlation of ");
 u1[2].xcord=len*cs;  
 u1[2].ycord=1*cr; 
 u1[2].parmax=3;
 u1[2].size=u1[2].bsize=8;
 strcpy(u1[2].name,plot1name);

 u1[3].xcord=(len+14)*cs; 
 u1[3].ycord=1*cr; 
 u1[3].parmax=2;
 u1[3].size=u1[3].bsize=8;
 strcpy(u1[3].name,plot2name);

 u1[4].xcord=(len+32)*cs; 
 u1[4].ycord=1*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=2;
 strcpy(u1[4].name,"3");


 len=strlen("Comparison  of ");
 u1[5].xcord=len*cs;  
 u1[5].ycord=2*cr; 
 u1[5].parmax=4;
 u1[5].size=u1[5].bsize=8;
 strcpy(u1[5].name,plot1name);

 u1[6].xcord=(len+14)*cs; 
 u1[6].ycord=2*cr; 
 u1[6].parmax=3;
 u1[6].size=u1[6].bsize=8;
 strcpy(u1[6].name,plot2name);

 u1[7].xcord=(len+32)*cs; 
 u1[7].ycord=2*cr; 
 u1[7].parmax=2;
 u1[7].size=u1[7].bsize=2;
 strcpy(u1[7].name,"3");

 u1[8].xcord=
  strlen("Comparison  of           and            to Plot  samples=")*cs; 
 u1[8].ycord=2*cr; 
 u1[8].parmax=1;
 u1[8].size=u1[8].bsize=6;
 strcpy(u1[8].name,"all");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

int fill_analysis2_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],analysis2_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"Out-of-band to             low=      Hz high=     Hz");
 strcpy(u2[1],"Powerspectrum of              to Plot  samples=");
 strcpy(u2[2],"Bandpass to                low=      Hz high=     Hz");


 len=strlen("Out-of-band to ");
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=3;
 u1[0].size=u1[0].bsize=12;
 strcpy(u1[0].name,"rest.res");

 len=strlen("Out-of-band to             low=");
 u1[1].xcord=len*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=2;
 u1[1].size=u1[1].bsize=5;
 strcpy(u1[1].name,"2200");

 len=strlen("Out-of-band to             low=      Hz high=");
 u1[2].xcord=len*cs; 
 u1[2].ycord=0*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=5;
 strcpy(u1[2].name,"5000");


 len=strlen("Powerspectrum of ");
 u1[3].xcord=len*cs;  
 u1[3].ycord=1*cr; 
 u1[3].parmax=3;
 u1[3].size=u1[3].bsize=10;
 strcpy(u1[3].name,plot3name);

 len=strlen("Powerspectrum of              to Plot");
 u1[4].xcord=len*cs;
 u1[4].ycord=1*cr; 
 u1[4].parmax=2;
 u1[4].size=u1[4].bsize=2;
 strcpy(u1[4].name,"3");

 len=strlen("Powerspectrum of              to Plot3 samples=");
 u1[5].xcord=len*cs;
 u1[5].ycord=1*cr; 
 u1[5].parmax=1;
 u1[5].size=u1[5].bsize=6;
 strcpy(u1[5].name,"all");

 len=strlen("Bandpass to ");
 u1[6].xcord=len*cs;  
 u1[6].ycord=2*cr; 
 u1[6].parmax=3;
 u1[6].size=u1[6].bsize=9;
 strcpy(u1[6].name,"mid.res");

 len=strlen("Bandpass to                low=");
 u1[7].xcord=len*cs;  
 u1[7].ycord=2*cr; 
 u1[7].parmax=2;
 u1[7].size=u1[7].bsize=5;
 strcpy(u1[7].name,"2200");

 len=strlen("Bandpass to                low=      Hz high=");
 u1[8].xcord=len*cs;  
 u1[8].ycord=2*cr; 
 u1[8].parmax=1;
 u1[8].size=u1[8].bsize=5;
 strcpy(u1[8].name,"5000");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int analysis_ope()
{
 flush_mouse();
 if(wd_object[14].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_analysis_menu(9,3,3,80,15,32*cs,487+3*cr,67*cs,2*cs+4*cr,
  Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(15,15);
 buttons=0;
 return(0);	
}
/**********************/
int analysis2_ope()
{
 flush_mouse();
 if(wd_object[15].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_analysis2_menu(9,3,3,80,16,40*cs,487+3*cr,57*cs,2*cs+4*cr,
  Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(16,16);
 buttons=0;
 return(0);	
}

/*********************************************/
static int write_au_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
  float f1,f2;
  /* u1[0].name=*.res file, input */
  /* u1[1].name=*.au file, output */

 if(chosen[0] & 1) {          /* make part from *.res to *.au */
  make_au_file(u1[0].name,u1[1].name);
  printf("done\n");
 }
 else if(chosen[1] & 1) {
                              /* cut part from *.au to *.res */
  sscanf(u1[2].name,"%f",&f1); /* start cutting seconds */
  sscanf(u1[3].name,"%f",&f2); /* stop cutting seconds */

  printf("at write_au_menu_actions\n");
  printf("u1[0].name=%s\n",u1[0].name); 
  printf("u1[1].name=%s\n",u1[1].name);
  printf("u1[2].name=%s\n",u1[2].name);
  printf("u1[3].name=%s\n",u1[3].name);
  cut_part(u1[1].name,u1[0].name,f1,f2);
  printf("done\n");
 }

 return 0; 
}

/*********************************************/
int fill_write_au_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],write_au_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }


 strcpy(u2[0],"Convert RES to AU.");
 strcpy(u2[1],"Cut AU to RES. Start sek=       End sek=   ");
 strcpy(u2[2],"RES=                 AU=                   ");
 
 u1[0].xcord=strlen("RES=")*cs;
 u1[0].ycord=2*cr; 
 u1[0].parmax=2;
 u1[0].size=u1[0].bsize=10;
 strcpy(u1[0].name,"checknew.res");

 u1[1].xcord=strlen("RES=                 AU=")*cs;
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=10;
 strcpy(u1[1].name,"checkts.au");


 u1[2].xcord=strlen("Cut AU to RES. Start sek=")*cs;
 u1[2].ycord=1*cr; 
 u1[2].parmax=2;
 u1[2].size=u1[2].bsize=5;
 strcpy(u1[2].name,"1.9");

 u1[3].xcord=strlen("Cut AU to RES. Start sek=       End sek=")*cs;
 u1[3].ycord=1*cr; 
 u1[3].parmax=1;
 u1[3].size=u1[3].bsize=5;
 strcpy(u1[3].name,"2.37");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int write_au_ope()
{
 flush_mouse();
 if(wd_object[10].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_write_au_menu(5,3,3,80,11,50*cs,485+4*cr,48*cs,3*cs+4*cr,
  Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(11,11);
 buttons=0;
 return(0);	
}

/*********************************************/
static int read_au_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
 FILE *stream1;
 char line[30];
 int xoff,stepx;
 float xscale,ave,yscale;
 LINE10 *u1b;
 int len,ymax,ymin,x1,x2,y1,y2;

 if(chosen[0] & 1) {
  if(!strcmp(u1[2].name,"1")) {
   ymin=0;ymax=170;
   strcpy(plot1name,u1[0].name);
  }
  else if(!strcmp(u1[2].name,"2")) {
   ymin=176;ymax=170+176;
   strcpy(plot2name,u1[0].name);
  }
  else if(!strcmp(u1[2].name,"3")) {
   ymin=2*176;ymax=170+2*176;
   strcpy(plot3name,u1[0].name);
  }
  strcpy(u1[1].name,u1[0].name);
  clearwin(0,ymin,X__max,ymax,nocolor);
  strcpy(line,u1[0].name);
  len=strlen(line);
  if(len>4 && !strcmp(line+len-4,".spe")){
   xoff=0;stepx=1;xscale=0.4;yscale=1.0;
   plot_spectrum_anew(u1[0].name,ymin,xoff,stepx,
    (double)xscale,(double)yscale,0,"20000");
  }
  if(len>3 && !strcmp(line+len-3,".au")){ 
   if(cut_part(u1[0].name,u1[0].name,0.0,100.0)) return 0;
   xoff=0;stepx=1;xscale=0.02;yscale=1.0; 
   plot_anew(u1[0].name,ymin,xoff,stepx,(double)xscale,(double)yscale,0);
  }
  else if(len>4 && !strcmp(line+len-4,".res")) {
   refresh_one_wd_object(14);
   xoff=0;stepx=1;xscale=0.02;yscale=1.0; 
   plot_anew(u1[0].name,ymin,xoff,stepx,(double)xscale,(double)yscale,0);
  }
 }
 else if(chosen[1] & 1) {
  analyse(u1[3].name);
 }
 else if(chosen[2] & 1) {
  if(!strcmp(u1[5].name,"1")) {
   x1=0;y1=0;x2=X__max;y2=170;
  }
  else if(!strcmp(u1[5].name,"2")) {
   x1=0;y1=176;x2=X__max;y2=y1+170;
  }
  else if(!strcmp(u1[5].name,"3")) {         
   x1=0;y1=2*176;x2=X__max;y2=y1+170;
  }
  writeGIF1(u1[4].name,x1,y1,x2,y2);
 }

 return 0; 
}

/*********************************************/
int fill_read_au_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],read_au_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"Get .au/.res/.spe             to             into Plot");
 strcpy(u2[1],"Analyze au file ");
 strcpy(u2[2],"Make a gif-file                 from Plot");
 
 len=strlen("Get .au/.res/.spe ");
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=3;
 u1[0].size=u1[0].bsize=10;
 strcpy(u1[0].name,"mid.res");

 len=strlen("Get .au/.res/.spe             to ");
 u1[1].xcord=len*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=2;
 u1[1].size=u1[1].bsize=10;
 strcpy(u1[1].name,"mid.res");

 len=strlen("Get .au/.res/.spe             to             into Plot");
 u1[2].xcord=len*cs;  
 u1[2].ycord=0*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=2;
 strcpy(u1[2].name,"1");

 len=strlen("Analyze au file ");
 u1[3].xcord=len*cs;  
 u1[3].ycord=1*cr; 
 u1[3].parmax=1;
 u1[3].size=u1[3].bsize=10;
 strcpy(u1[3].name,"bchk1.res");

 len=strlen("Make a gif-file ");
 u1[4].xcord=len*cs;  
 u1[4].ycord=2*cr; 
 u1[4].parmax=2;
 u1[4].size=u1[4].bsize=12;
 strcpy(u1[4].name,"figure.gif");

 len=strlen("Make a gif-file                 from Plot");
 u1[5].xcord=len*cs;  
 u1[5].ycord=2*cr; 
 u1[5].parmax=1;
 u1[5].size=u1[5].bsize=2;
 strcpy(u1[5].name,"1");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int read_au_ope()
{
 flush_mouse();
 if(wd_object[13].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_read_au_menu(6,3,3,80,14,30*cs,487+3*cr,62*cs,3*cs+4*cr,
  Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(14,14);
 buttons=0;
 return(0);	
}

/*********************************************/
static int printeps_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
 FILE *stream1;
 char line[30];
 int xoff,stepx;
 float xscale,ave,yscale;
 LINE10 *u1b;

  /* open eps opens stream1 to psexampl.dat and name to outstream */
  /* close_eps closes both streams */
  /* we locate wdobject 12, that is plotmenu, and get its u1 data */

 if(chosen[0] & 1) {
  stream1=open_eps(u1[0].name,"psexampl.dat");
  if(!stream1) return 0;
  u1b=(LINE10 *)wd_object[12-1].p1;
  if(u1b) { /* menu is still up */
   sscanf(u1b[0].name,"%d",&xoff);
   sscanf(u1b[1].name,"%d",&stepx);
   sscanf(u1b[2].name,"%f",&xscale);
   sscanf(u1b[3].name,"%f",&yscale);
  }
  else {
   xoff=0;stepx=1;xscale=0.02;yscale=1.0;
  }
  plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,1);
  close_eps(stream1);
 }
 else if(chosen[1] & 1) {
  stream1=open_eps(u1[0].name,"psexampl.dat");
  if(!stream1) return 0;
  u1b=(LINE10 *)wd_object[12-1].p1;
  if(u1b) { /* menu is still up */   
   sscanf(u1b[4].name,"%d",&xoff);
   sscanf(u1b[5].name,"%d",&stepx);
   sscanf(u1b[6].name,"%f",&xscale);
   sscanf(u1b[7].name,"%f",&yscale);
  }
  else {
   xoff=0;stepx=1;xscale=0.02;yscale=1.0;
  }
  plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,1);
  close_eps(stream1);
 }
 else if(chosen[2] & 1) {
  stream1=open_eps(u1[0].name,"psexampl.dat");
  if(!stream1) return 0;
  u1b=(LINE10 *)wd_object[12-1].p1;  
  if(u1b) { /* menu is still up */    
   sscanf(u1b[8].name,"%d",&xoff);
   sscanf(u1b[9].name,"%d",&stepx);
   sscanf(u1b[10].name,"%f",&xscale);
   sscanf(u1b[11].name,"%f",&yscale);
  }
  else { /* default values */
   xoff=0;stepx=1;xscale=0.02;yscale=1.0;
  }
  plot_anew(plot3name,352,xoff,stepx,(double)xscale,(double)yscale,1);
  close_eps(stream1);
 }

 return 0; 
}

/*********************************************/
int fill_printeps_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],printeps_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 /* "Save Plot1 in eps, name=    ");
 /*                          24 */

 strcpy(u2[0],"Save Plot1 in eps, name=    ");
 strcpy(u2[1],"Save Plot2 in eps, name=    ");
 strcpy(u2[2],"Save Plot3 in eps, name=    ");
 
 len=24;
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=1;
 u1[0].size=u1[0].bsize=8;
 strcpy(u1[0].name,"plot1.eps");

 u1[1].xcord=len*cs;  
 u1[1].ycord=1*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=8;
 strcpy(u1[1].name,"plot2.eps");

 u1[2].xcord=len*cs;  
 u1[2].ycord=2*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=8;
 strcpy(u1[2].name,"plot3.eps");   

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int printeps_ope()
{
 flush_mouse();
 if(wd_object[12].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_printeps_menu(3,3,3,80,13,50*cs,487+3*cr,40*cs,3*cs+4*cr,Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(13,13);
 buttons=0;
 return(0);	
}

/*********************************************/
static int audio_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
 int xoff,stepx,start;
 float xscale,ave,yscale;char line[20];

 if(chosen[0] & 1) {
  clearwin(0,0,X__max,170,nocolor);
  sscanf(u1[0].name,"%d",&xoff);
  sscanf(u1[1].name,"%d",&stepx);
  sscanf(u1[2].name,"%f",&xscale);
  sscanf(u1[3].name,"%f",&yscale);
  plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,0);
 }
 else if(chosen[1] & 1) {
  clearwin(0,176,X__max,170+176,nocolor);
  sscanf(u1[4].name,"%d",&xoff);
  sscanf(u1[5].name,"%d",&stepx);
  sscanf(u1[6].name,"%f",&xscale);
  sscanf(u1[7].name,"%f",&yscale);
  plot_anew(plot2name,176,xoff,stepx,(double)xscale,(double)yscale,0);
 }
 else if(chosen[2] & 1) {
  clearwin(0,352,X__max,170+352,nocolor);
  sscanf(u1[8].name,"%d",&xoff);
  sscanf(u1[9].name,"%d",&stepx);
  sscanf(u1[10].name,"%f",&xscale);
  sscanf(u1[11].name,"%f",&yscale);
  plot_anew(plot3name,352,xoff,stepx,(double)xscale,(double)yscale,0);
 }
 else if(chosen[3] & 1) {
  sscanf(u1[12].name,"%d",&start);
  strcpy(plot3name,u1[13].name);
  if(my_correlation(plot1name,plot2name,plot3name,&ave,&xoff,&yscale,
   1,start,u1[8].name))
  { printf("sample too small\n");return 0;}
  /* the one which was moved is plot 1 */

  if(xoff>=0){
   strcpy(u1[0].name,(char *)int_to_string(xoff));  /* xoff as obtained */
   strcpy(u1[4].name,"0");                          /* xoff=0 */
   strcpy(u1[8].name,"0");                          /* xoff=0 */
  }
  else {
   strcpy(u1[0].name,"0");                         
   strcpy(u1[4].name,(char *)int_to_string(-xoff));
   strcpy(u1[8].name,(char *)int_to_string(-xoff));
  }
  sscanf(u1[1].name,"%d",&stepx);                  /* set to the others */
  sscanf(u1[2].name,"%f",&xscale);                 /* set to the others */
  sprintf(line,"%f",yscale);line[5]=0; /* if too long */
  strcpy(u1[3].name,line);                         /* set yscale as obtained */
  strcpy(u1[5].name,u1[1].name);                   /* same stepx */ 
  strcpy(u1[6].name,u1[2].name);                   /* same xscale */ 
  strcpy(u1[7].name,"1.0");                        /* yscale=1.0 */
  strcpy(u1[9].name,u1[1].name);                   /* same stepx */ 
  strcpy(u1[10].name,u1[2].name);                  /* same xscale */ 
  strcpy(u1[11].name,"1.0");                       /* yscale=1.0 */

  clearwin(0,0,X__max,170,nocolor);
  plot_anew(plot1name,0,xoff,stepx,(double)xscale,(double)yscale,0);
  yscale=1.0;
  clearwin(0,176,X__max,170+176,nocolor);
  plot_anew(plot2name,176,0,stepx,(double)xscale,(double)yscale,0); 
  clearwin(0,352,X__max,170+352,nocolor);
  plot_anew(plot3name,352,0,stepx,(double)xscale,(double)yscale,0);
  refresh_one_wd_object(12);
 } 

 return 0; 
}

/*********************************************/
int fill_audiomenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;int color;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 fill_jmptable_b(&wd_actions[id-1],audio_menu_actions);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 /* "Plot1 start=      step=      xsc=      ysc=    "); */
 /*              12        +11       +9        +9 */

 strcpy(u2[0],"Plot1 start=      step=      xsc=     ysc=    ");
 strcpy(u2[1],"Plot2 start=      step=      xsc=     ysc=    ");
 strcpy(u2[2],"Plot3 start=      step=      xsc=     ysc=    ");
 strcpy(u2[3],"Find a match, start sample=         outfile=");
 
 len=12;
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=4;
 u1[0].size=u1[0].bsize=5;
 strcpy(u1[0].name,"0");

 u1[1].xcord=(len+11)*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=3;
 u1[1].size=u1[1].bsize=5;
 strcpy(u1[1].name,"44");

 u1[2].xcord=(len+21)*cs;  
 u1[2].ycord=0*cr; 
 u1[2].parmax=2;
 u1[2].size=u1[2].bsize=5;
 strcpy(u1[2].name,"1.0");

 u1[3].xcord=(len+30)*cs;  
 u1[3].ycord=0*cr; 
 u1[3].parmax=1;
 u1[3].size=u1[3].bsize=5;
 strcpy(u1[3].name,"1.0");

 u1[4].xcord=len*cs;  
 u1[4].ycord=1*cr; 
 u1[4].parmax=4;
 u1[4].size=u1[4].bsize=5;
 strcpy(u1[4].name,"0");

 u1[5].xcord=(len+11)*cs;  
 u1[5].ycord=1*cr; 
 u1[5].parmax=3;
 u1[5].size=u1[5].bsize=5;
 strcpy(u1[5].name,"44");

 u1[6].xcord=(len+21)*cs; 
 u1[6].ycord=1*cr; 
 u1[6].parmax=2;
 u1[6].size=u1[6].bsize=5;
 strcpy(u1[6].name,"1.0");

 u1[7].xcord=(len+30)*cs;  
 u1[7].ycord=1*cr; 
 u1[7].parmax=1;
 u1[7].size=u1[7].bsize=5;
 strcpy(u1[7].name,"1.0");

 u1[8].xcord=len*cs;  
 u1[8].ycord=2*cr; 
 u1[8].parmax=4;
 u1[8].size=u1[8].bsize=5;
 strcpy(u1[8].name,"0");   

 u1[9].xcord=(len+11)*cs;  
 u1[9].ycord=2*cr; 
 u1[9].parmax=3;
 u1[9].size=u1[9].bsize=5;
 strcpy(u1[9].name,"44");

 u1[10].xcord=(len+21)*cs; 
 u1[10].ycord=2*cr; 
 u1[10].parmax=2;
 u1[10].size=u1[10].bsize=5;
 strcpy(u1[10].name,"1.0");

 u1[11].xcord=(len+30)*cs;  
 u1[11].ycord=2*cr; 
 u1[11].parmax=1;
 u1[11].size=u1[11].bsize=5;
 strcpy(u1[11].name,"1.0");

 u1[12].xcord=strlen("Find a match, start sample=")*cs;  
 u1[12].ycord=3*cr; 
 u1[12].parmax=2;
 u1[12].size=u1[12].bsize=5;
 strcpy(u1[12].name,"0");

 u1[13].xcord=strlen("Find a match, start sample=         outfile=")*cs;  
 u1[13].ycord=3*cr; 
 u1[13].parmax=1;
 u1[13].size=u1[13].bsize=8;
 strcpy(u1[13].name,"compres.res");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}



/*********************************************/
int audio_ope()
{
 flush_mouse();
 if(wd_object[11].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_audiomenu(14,4,4,80,12,50*cs,487+3*cr,49*cs,3*cs+4*cr,Co1,Co2,Co3,Co4,Co5);
 put_wd_objects(12,12);
}


int main(argc,argv) int argc; char **argv;
{
 int i,j; int wWidth,wHeight;
 /* defaultfont=2; standard system font */
 /* defaultfont=35; is greek letters */
 defaultfont=7;

 xxmin=0;yymin=0;xxmax=500;yymax=350;
 if(init_font(defaultfont)) 
  {printf("problems in loading font\n");getch();return(1);} 
 if(init_font2(6)) {printf("problems in loading font\n");getch();return(1);}   
 if(initPool(0,0,0,0)) return(0);


 initgraph(argc,argv); 


 term=I86;lg=ENGL;plg=0;bgcol=1;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 firstvobj=lastvobj=cvobj=0;vobjmode=0; 
 for(i=0;i<16;i++) setVGApalette(i,(int)palette[i]); 

 xcolor2=xcolor; 
 wWidth=773;wHeight=559;
 set_xcolor2();

 pointer1=(RESDATA *)malloc(sizeof(RESDATA));
 if(pointer1) {
  pointer1->size=0; /* not filled */
  editor();
 }
 
 free(pointer1);
 endgraph();

 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 return(0);
}
/************************************************
*   editor()
*************************************************/ 
int editor()
{
 int i,x,y,m,xoff;
 int xsize,ysize;VECTOR_OBJECT *nextvobj;
 FILE *stream1,*stream2,*stream3;
 char line[20];

 if(init_win(0,15)) return(1);

 fgbuffer=(char *)malloc(FGSIZE);if(!fgbuffer) return(1);
 bgbuffer=(char *)malloc(FGSIZE);if(!bgbuffer) return(1);


 if(initPool(1,1200*cr,0,0)) return(1);
 nocolor=15;pensize=0;


 xxmin=0;xxmax=LIMDBAR;yymin=0;yymax=Y__max;

 clearwin(0,0,X__max,Y__max,nocolor);

 firstvobj=lastvobj=cvobj=0;vobjmode=0;

 /* put icons */
 i=0;

 y=Y__max-45;

 x=1;getpicture("texit.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,texit_ope);

 x=1+45;getpicture("plicon.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,audio_ope);
  
 x=1+45*2;getpicture("print.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,printeps_ope);

 x=1+45*3;getpicture("readic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,read_au_ope);
 
 x=1+45*4;getpicture("writeic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,write_au_ope);
 
 x=1+45*5;getpicture("compile.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,analysis_ope);
 
 x=1+45*6;getpicture("start.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,analysis2_ope);

 /*
 x=1+45*7;getpicture("pointer.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,pointer_ope);
 */


 fill_jmptable(&c_table[i++],0,0,0,0,NULL);

 /*  for HOLD */
 
 strcpy(plot1name,"bhld1.res"); 
 strcpy(plot2name,"bhld2.res");
 
 /* for CHECK */
 /*
 strcpy(plot1name,"bchk1.res"); 
 strcpy(plot2name,"bchk2.res");
 */

 strcpy(plot3name,"compar3.res");  

 stream1=fopen(plot1name,"r");
 stream2=fopen(plot2name,"r");
 stream3=fopen(plot3name,"r");
 if(!stream1 || !stream2 || !stream3) {
  xkoord=12*cs+X1_min;ykoord=Y1_min+3;
  strcpy(line,"Cannot find files");  
  textn1(6,0,line,3,15); 

 }
 else {

  plot_curve(stream1,0,0,15,0,1,
            0,0.02,1.0,
            1,0,plot1name);

  /* you can shift the plot right or left by setting xoff */
  xoff= -1544;
  /* xoff=0; */
  plot_curve(stream2,0,0,15,0,1,
            xoff,0.02,1.0,
            1,176,plot2name);

  xoff=0;
  plot_curve(stream3,0,0,15,0,1,
            xoff,0.02,1.0,
            1,352,plot3name);
 }
 do_edi1_engine(1,c_table);

 if(stream1) fclose(stream1);
 if(stream2) fclose(stream2);
 if(stream3) fclose(stream3);


 if(bgbuffer) free(bgbuffer);
 if(fgbuffer) free(fgbuffer);

 free_win(0,15);
 return 1;
}

/***************************************************
* display manager of the editor
****************************************************/
int do_edi1_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,k1,set_palette=0;
 unsigned char ch;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize;
 int col11;
 LINE10 *u1;
 char buf1[30];int col2;int pixel,color;

 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   oldX=X;oldY=Y;
   if(!color_request_flag) {
    command=do_operations();
   }
   else {
    readmouse(&buttons,&X,&Y);
    
    if(buttons==1 && Y<Y__max-45)
    {
      ;
    }
    break;         	
   }
   if(command==1) {
    pensize=0;
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) return(1); /* exit asked */
    delay(100);flush_mouse();buttons=0;
   }
   else if(command== -1) {
     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {

     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){

      exit_vect_ed=0;	
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return(1); /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) vect_ed(buttons,X,Y);     
    else 
    {
      ;
    }
   }
  } while(!kbhit());
 }
}
/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;

{
 
 switch(id) {
  case 1:	/* put here cases */	

 default:
   return edi2_operations(id);
   break;
 }
 return(0);
} 


/********************************************************
* plot_curve
*
* take data from stream
*********************************************************/
int plot_curve(stream,nogrid,col1,col2,print1,stepx,
               xoff1,xscale,yscale,ypow,yoffset,plotname) 
FILE *stream;int nogrid,col1,col2,print1;int stepx;
int xoff1;double xscale,yscale;int ypow;
int yoffset;char *plotname;
{
 int oldxc,oldyc;
 double sum,avey;
 float f1,maxf1,minf1;
 float *stat;
 int i,j;
 int counter1;
 char line[180];
 char txtx[10],txty[10];
 int offset,xoff;
 double ysc; 
 double xscale1,yscale1,xstart1,ystart1;
 int xx,yy;
 int xind,yind;
 double x_start;
 int yc;double xc;
 int midpoint,maxstat;
 
 Y1_min=12+yoffset;Y1_max=170+yoffset;     	
 X1_min=0;X1_max=795;

 midpoint=(Y1_max-Y1_min)/2;
 x_start=0.0;

 xoff=0;
 rewind(stream); 
 if(xoff1>0) {
 /* advance the file by xoff samples */
  for(i=0;i<xoff1;i++) { 
   if(!fgets(line,180,stream)) break;
  }
  if(i!=xoff1) {printf("file too short\n");return 1;}
  xoff=0;
 }
 else if (xoff1<0) {
  /* move the plot to start at xscale*xoff */
  x_start= -xscale*(double)xoff1;
  xoff=0;
 }

 /* read all data to a buffer */
 stat=(float *)malloc(100000*sizeof(float)); 
 if(!stat) {no_memory();return 0;}
 for(i=0;i<100000;i++) { /* this is max 2.2675 sek of audio */
  if(!fgets(line,180,stream)) break;
  sscanf(line,"%d %f\n",&counter1,&f1);
  stat[i]=f1;
 }
 maxstat=i;

 /* the way we plot the curve is by summing stepx points */
 /* we are interested on max and min sums */
 offset = xoff;
 maxf1=minf1=0.0; 
 for(i=0;i<maxstat-offset;i++) {
  sum=0.0;
  for (j=0;j<stepx;j++) {
   if(j+i+offset<maxstat) 
    sum += stat[j+i+offset];
  }
  if(sum>maxf1) {
    maxf1=sum;
  }
  if(-sum>-minf1) {
   minf1=sum;
  }
 }
 if(minf1<0) minf1= -minf1;
 if(minf1>maxf1) maxf1=minf1;

 printf("plot_curve largest absolute value is %f\n",maxf1);
 /* now maxf1 is the largest absolute value */

 /* on place yy on y-axis is written the number (yscale1+ystart1)*10**ypow */
 /* ypow is a calling parameter, but set to 0 */
 /* we want maxf1 to range to the border, that is midpoint from origin */
 /* We select yy as the midpoint, thus yy should read maxf1. */
 /* thus, midpoint/maxf1=yoffset/sum */
 /* yoffset=ysc*sum, so ysc=midpoint/maxf1 */
 /* BUT there is also the yscale as a calling parameter,so */

 yy=midpoint;
 yscale1= maxf1/yscale;
 ystart1= -maxf1/yscale;
 if(maxf1) ysc=yscale*(double)midpoint/maxf1;else ysc=0.0;

 strcpy(txty,"num"); /* just writing some name to the y-scale */

 /* on place xx on x-axis is written the number (xscale1+xstart1)*10**xpow */
 /* xpow we set as zero in the call */

 xx=50; /* set this value */

 /* the sampling speed is 44100 samples/s */
 /* xoff is number of samples from the beginning */

 if(stepx<=441 && stepx>=1){
  if(xoff1>=0) xstart1=((double)xoff1)*1000.0/44100.0;
  else xstart1=0.0;
  xscale1=1000.0*(50.0/xscale)*(double)stepx/44100.0;
  strcpy(txtx,"ms");
 }
 else if(stepx>441){
  if(xoff1>=0) xstart1=((double)xoff1)*1.0/44100.0;
  else xstart1=0.0;
  xscale1=(50.0/xscale)*(double)stepx/44100.0;
  strcpy(txtx,"sec");
 }

 /* how many marked points on axises */
 xind=14;
 yind=2;


 draw_frame2(X1_min,Y1_min,X1_max,Y1_max,16, /* coordinates */
                col1,col2,	/* colors */
 		xscale1, 	/* scale of x-axis */
 		yscale1, 	/* scale of y-axis */
 		0,		/* xpow multiply x-axis numbers with this power */
 		ypow,		/* ypow multiply y-axis numbers with this power */
 		xstart1,	/* starting of x-axis from line number xstart */
 		ystart1,	/* ystart */
 		0,		/* do not clear before drawing */
 		yind,		/* number of marked points in y-axis */
 		nogrid,		/* do not draw a grid */
 		0,		/* do not mark numbers to x-axis */
 		0,		/* do not mark numbers to y-axis */
 		xind,		/* number of marked points in x-axis */
 		print1,		/* print to a file in PS or screen */
 		xx, 		/* controls spacing of points in x-scale */
 		yy		/* controls spacing of points in y-scale */
 		); 		

 ykoord=Y1_max-16/2-5;xkoord=8*(X1_max/8)-strlen(txtx)*cs;
 textn1(6,print1,txtx,0,15);
 ykoord=Y1_min+20;xkoord=X1_min+cs;
 textn1(6,print1,txty,0,15);
 
 xkoord=12*cs+X1_min;ykoord=Y1_min+3;
 strcpy(line,plotname);  
 textn1(6,print1,line,0,15); 

 /* if xscale=1.0, then every sum of j=0...stepx samples is written */
 /* to the point i on the x-axis. But if xscale is e.g. 2.0 */
 /* then xc advances by 2 pixels in the loop of i */

 /* xoff is given as number of samples */
 offset = xoff;

 /* plot the curve */
 maxf1=minf1=0.0; 
 oldxc=X1_min+16*2+x_start;oldyc=Y1_max-16;
 for(i=0,xc=(double)(X1_min+16*2)+x_start;
   i<maxstat-offset && xc<=X1_max;i++,xc+=xscale){
  sum=0.0;
  for (j=0;j<stepx;j++) {
   if(j+i+offset<maxstat) 
    sum += stat[j+i+offset];
  }
  yc= Y1_max-16- (int)(sum*ysc)-midpoint;
  if(yc<Y1_min) yc=Y1_min;
  else if(yc>Y1_max-16) yc=Y1_max-16;
  if(i>0)
   draw_line(oldxc,oldyc,(int)xc,yc,col1,print1);
  oldxc=xc;oldyc=yc;
 }

 if(stat) free(stat);
 return 0;
}

/********************************************************
* plot_spectrum
*
* take data from stream
*********************************************************/
int plot_spectrum(stream,nogrid,col1,col2,print1,stepx,
               xoff1,xscale,yscale,ypow,yoffset,plotname,samples) 
FILE *stream;int nogrid,col1,col2,print1;int stepx;
int xoff1;double xscale,yscale;int ypow;
int yoffset;char *plotname,*samples;
{
 int oldxc,oldyc;
 double sum,avey;
 float f1,maxf1,minf1;
 float *stat;
 int i,j;
 int counter1;
 char line[180];
 char txtx[10],txty[10];
 int offset,xoff;
 double ysc; 
 double xscale1,yscale1,xstart1,ystart1;
 int xx,yy;
 int xind,yind;
 double x_start;
 int yc;double xc;
 int midpoint,maxstat;
 int maxi,K;
 int numsamples;

 if(strcmp(samples,"all")) {
  numsamples=(int)string_to_int(samples);
  if(numsamples>100000) numsamples=100000;
 }
 else numsamples=100000;

 Y1_min=12+yoffset;Y1_max=170+yoffset;     	
 X1_min=0;X1_max=795;

 midpoint=(Y1_max-Y1_min)/2;
 x_start=0.0;

 xoff=0;
 rewind(stream);
 if(!fgets(line,180,stream)) return 1;
 if(!strncmp(line,"size=",5)) {
  K=(int)string_to_int(line+5);
 }
 printf("plot_spectrum K=%d\n",K);  

 if(xoff1>0) {
 /* advance the file by xoff samples */
  for(i=0;i<xoff1;i++) { 
   if(!fgets(line,180,stream)) break;
  }
  if(i!=xoff1) {printf("file too short\n");return 1;}
  xoff=0;
 }
 else if (xoff1<0) {
  /* move the plot to start at xscale*xoff */
  x_start= -xscale*(double)xoff1;
  xoff=0;
 }

 /* read all data to a buffer */
 stat=(float *)malloc(numsamples*sizeof(float)); 
 if(!stat) {no_memory();return 0;}
 for(i=0;i<numsamples;i++) { 
  if(!fgets(line,180,stream)) break;
  sscanf(line,"%d %f\n",&counter1,&f1);
  stat[i]=f1;
 }
 maxstat=i;

 /* the way we plot the curve is by summing stepx points */
 /* we are interested on max and min sums */
 offset = xoff;
 maxf1=minf1=0.0;maxi=-1; 
 for(i=0;i<maxstat-offset;i++) {
  sum=0.0;
  for (j=0;j<stepx;j++) {
   if(j+i+offset<maxstat) 
    sum += stat[j+i+offset];
  }
  if(sum>maxf1) {
    maxf1=sum;maxi=i+offset;
  }
  if(-sum>-minf1) {
   minf1=sum;
  }
 }
 printf("maxi=%d maxf1=%f offset=%d\n",maxi,maxf1,offset);

 if(minf1<0) minf1= -minf1;
 if(minf1>maxf1) maxf1=minf1;


 /* now maxf1 is the largest absolute value */

 /* on place yy on y-axis is written the number (yscale1+ystart1)*10**ypow */
 /* ypow is a calling parameter, but set to 0 */
 /* we want maxf1 to range to the border, that is midpoint from origin */
 /* We select yy as the midpoint, thus yy should read maxf1. */
 /* thus, midpoint/maxf1=yoffset/sum */
 /* yoffset=ysc*sum, so ysc=midpoint/maxf1 */
 /* BUT there is also the yscale as a calling parameter,so */

 yy=midpoint;
 yscale1= maxf1/yscale;
 ystart1= -maxf1/yscale;
 if(maxf1) ysc=yscale*(double)midpoint/maxf1;else ysc=0.0;

 strcpy(txty,""); /* for writing some name to the y-scale */

 /* on place xx on x-axis is written the number (xscale1+xstart1)*10**xpow */
 /* xpow we set as zero in the call */

 xx=50; /* set this value */

 /* xoff is number of samples from the beginning */
 if(stepx<1000 && stepx>=1){

  if(xoff1>=0) xstart1=(double)xoff1;
  else xstart1=0.0;
  xscale1=(50.0/xscale)*(double)stepx*44100.0/(float)K;
  strcpy(txtx,"Hz");
 }
 else if(stepx>=1000){
  if(xoff1>=0) xstart1=(double)xoff1;
  else xstart1=0.0;
  xscale1=(50.0/xscale)*(double)stepx/1000.0*44100.0/(float)K;
  strcpy(txtx,"kHz");
 }


 /* how many marked points on axises */
 xind=14;
 yind=2;

 draw_frame2(X1_min,Y1_min,X1_max,Y1_max,16, /* coordinates */
                col1,col2,	/* colors */
 		xscale1, 	/* scale of x-axis */
 		yscale1, 	/* scale of y-axis */
 		0,		/* xpow multiply x-axis numbers with this power */
 		ypow,		/* ypow multiply y-axis numbers with this power */
 		xstart1+0.1,	/* starting of x-axis from line number xstart */
 		ystart1,	/* ystart */
 		0,		/* do not clear before drawing */
 		yind,		/* number of marked points in y-axis */
 		nogrid,		/* do not draw a grid */
 		0,		/* do not mark numbers to x-axis */
 		1,		/* do not mark numbers to y-axis */
 		xind,		/* number of marked points in x-axis */
 		print1,		/* print to a file in PS or screen */
 		xx, 		/* controls spacing of points in x-scale */
 		yy		/* controls spacing of points in y-scale */
 		); 		


 ykoord=Y1_max-16/2-5;xkoord=8*(X1_max/8)-strlen(txtx)*cs;
 textn1(6,print1,txtx,0,15);
 ykoord=Y1_min+20;xkoord=X1_min+cs;
 textn1(6,print1,txty,0,15);
 
 xkoord=12*cs+X1_min;ykoord=Y1_min+3;
 strcpy(line,"Power spectrum");
 textn1(6,print1,line,0,15); 

 /* if xscale=1.0, then every sum of j=0...stepx samples is written */
 /* to the point i on the x-axis. But if xscale is e.g. 2.0 */
 /* then xc advances by 2 pixels in the loop of i */

 /* xoff is given as number of samples */
 offset = xoff;

 /* plot the curve */
 maxf1=minf1=0.0; 
 oldxc=X1_min+16*2+x_start;oldyc=Y1_max-16;
 for(i=0,xc=(double)(X1_min+16*2)+x_start;
     i<maxstat-offset && xc<=X1_max;i++,xc+=xscale){
  sum=0.0;
  for (j=0;j<stepx;j++) {
   if(j+i+offset<maxstat)
    sum += stat[j+i+offset];
  }
  yc= Y1_max-16- (int)(sum*ysc*1.7);
  if(yc<Y1_min) yc=Y1_min;
  else if(yc>Y1_max-16) yc=Y1_max-16;
  if(i>0)
   draw_line(oldxc,oldyc,(int)xc,yc,col1,print1);
  oldxc=xc;oldyc=yc;
 }

 if(stat) free(stat);
 return 0;
}


int plot_anew(name,offset,xoff,stepx,xscale,yscale,print1)
     char *name;int offset;int xoff,stepx;double xscale,yscale;int print1;
{
  FILE *stream1;char line[20];

 stream1=fopen(name,"r");
 if(!stream1) {
  xkoord=12*cs+X1_min;ykoord=Y1_min+3;
  strcpy(line,"Cannot find files");  
  textn1(6,0,line,3,15);
  return 1; 
 }
 plot_curve(stream1,0,0,15,print1,stepx,xoff,xscale,yscale,1,offset,name);
 fclose(stream1);
}

int plot_spectrum_anew(name,offset,xoff,stepx,xscale,yscale,print1,samples)
     char *name;int offset;int xoff,stepx;double xscale,yscale;int print1;
     char *samples;
{
  FILE *stream1;char line[20];

 stream1=fopen(name,"r");
 if(!stream1) {
  xkoord=12*cs+X1_min;ykoord=Y1_min+3;
  strcpy(line,"Cannot find files");  
  textn1(6,0,line,3,15);
  return 1; 
 }
 plot_spectrum(stream1,0,0,15,print1,stepx,xoff,xscale,yscale,1,offset,
  name,samples);
 fclose(stream1);
}


/********************************************
 *  from au-file name1 take sec1 to sec2 part
 *  and write it as linenumber float
 *  into the file name2
 ********************************************/
cut_part(name1,name2,sec1,sec2) char *name1,*name2;float sec1,sec2;
{
 char line[132], line2[132];
 FILE *stream1,*stream2;
 float f1,f2,minf1,maxf1,rmsf1,minf2,maxf2,rmsf2;
 int len,len2,counter1,headerlen,count_start,count_stop;
 int counter=0,show=1,print;
 int encoding,counter3,number,sampling_rate;

 stream1=fopen(name1,"rb");
 if(!stream1) {printf("no file %s\n",name1);return 1;}
 stream2=fopen(name2,"wb+");
 if(!stream2) {printf("no file %s\n",name2);fclose(stream1);return 1;}

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 if(memcmp(line,"dns.",4)){printf("not au-file\n");return 1;}
 line[4]=0;  
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&headerlen,line,4); 
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&f1);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&encoding,line,4); 
 counter+=4;

 
 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&sampling_rate,line,4); 
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&len2,line,4); 
 counter+=4;

 if(!fread(line,1,20,stream1)) {printf("not au-file\n");return 1;}
 line[20]=0;
 counter+=20;
  
 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&minf1);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&maxf1);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&rmsf1);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&minf2);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&maxf2);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&rmsf2);
 counter+=4;

 len2=headerlen-68;
 if(headerlen%4) {
  printf("cut_part wrong coding of au-header len=%d\n",headerlen);getchar();
 }

 counter1=len2;
 while(counter1>0) {
  if(!fread(line,1,4,stream1)) break;
  counter1 -=4;
  counter+=4;
 }
  
 if(encoding==3) {
  count_start=sec1*44100*2+headerlen;
  count_stop=sec2*44100*2+headerlen;
 }
 else {
  count_start=sec1*44100*4+headerlen;
  count_stop=sec2*44100*4+headerlen;
 }

 if(encoding==3) {   /* the data is in 16-bit linear PCM */
  counter3=0;
  while(1) {
   if(!fread(line,1,2,stream1)) break;
   memcpy((char *)&number,line,2);
   if(counter>=count_start && counter<=count_stop) {  
    if((counter3%4)) {  /* take every second */
     fprintf(stream2,"%d %d\n",(counter-headerlen)/4,number);
    }
   }
   counter3+=2;
   counter+=2;
  }
 }
 else if (encoding==6){   /* the data is in binary32 */

  while(1) {
   if(!fread(line,1,4,stream1)) break;
   line[4]=0;
   sbinary(line2,line,32,&f1);
   if(counter>=count_start && counter<=count_stop) {
    fprintf(stream2,"%d %f\n",(counter-headerlen)/4, f1);
   }
   counter+=4;
  }
 }
 else if (encoding== -6){   /* the data is in binary16, 2 channels */
  while(1) {
   if(!fread(line,1,4,stream1)) break;
   sbinary(line2,line,16,&f1);
   counter+=2;
   sbinary(line2,line+2,16,&f2); /* channel2 is the correct one */
   if(counter>=count_start && counter<=count_stop) {
    fprintf(stream2,"%d %f\n",(counter-headerlen)/4, f2);
   }
   counter+=2;
  }
 }

 fclose(stream1);
 fclose(stream2);
 return 0;
}

/************************************/
/* ieee 754 binary16 floating point */
/************************************/
int build_binary16(float f1,char *line)
{
 int mantissa, expo;
 unsigned int sign;
 float f2,round;

 if(f1<0) {sign=0x80;f1= -f1;} else sign=0;

 if(f1<=0.0000609) { /* subnormal number */
  mantissa=1024*16384*f1; /* f1=(0.mantissa_2)*2^-14 */
  line[0]=mantissa&0xff;
  line[1]=sign|(mantissa>>8);
  return 0;
 }

 expo=15; /* bias */

 /* if f1>=1, reduce until f1 is as little under 1 as possible */
 if (f1>=1.0) {
  while(f1>=1.0) {f1=f1/2;expo++;}
 }
 else {
  while(f1<1.0) {f1=f1*2;expo--;}
  f1=f1/2;expo++;
 }
 mantissa=(int)(f1*2048.0); /* mantissa=f1*2^11 */
 
 round=f1*2048.0-(float)mantissa;  /* round, not truncate */
 if(round>=0.5) mantissa++;

 /* as 2*f1>=1>f1 and mantissa=2^11*f1 */
 /* it follows that  2*mantissa>= 2^11 > mantissa */
 /* so mantissa >= 2^10. It has bit 10 set, remove it */

 mantissa=mantissa-1024; /* remove the leading bit 2^10 */

 expo -= 1;                 /* first multiplied mantissa by 2^11 */
                            /* then divided mantissa by 2^10 */
 expo=(expo<<2);
 line[0]=mantissa&0xff;
 line[1]=sign|(mantissa>>8)|(0x7C & expo);

}

/************************************/
/* ieee 754 binary32 floating point */
/************************************/
int build_binary32(float f1,char *line)
{
 int mantissa, expo;
 unsigned int sign;
 float f2;
 double res;
 int i;

 if(f1<0) {sign=0x80;f1= -f1;} else sign=0;

 /* 2^24*2^-126 = 2^-102, larger than any subnormal number */
 if(f1<1.0/(1048576.0*1048576.0*1048576.0*1048576.0*1048576.0*4.0))
 { /* subnormal number */
  res=f1;
  for (i=0;i<23;i++)  res=2*res; /* res=2^23*f1 */
  for (i=0;i<126;i++) res=2*res; /* res=2^126*2^23*f1 */
  mantissa=(int)res;             /* f1=(0.mantissa_2)*2^-126 */

  line[0]=mantissa&0xff;
  line[1]=(mantissa>>8)&0xff;
  line[2]=(mantissa>>16);
  line[3]=sign;
  return 0;
 }

 expo=127; /* bias */

 /* if f1>=1, reduce until f1 is as little under 1 as possible */
 if (f1>=1.0) {
  while(f1>=1.0) {f1=f1/2;expo++;}
 }
 else {
  while(f1<1.0) {f1=f1*2;expo--;}
  f1=f1/2;expo++;
 }

 mantissa=(int)(f1*1024*1024*16); /* mantissa=f1*2^24 */
 mantissa=mantissa-1024*1024*8;   /* remove the leading bit 2^23 */
 /* expo -= 2; */ /* correct */ 
 expo -= 1;


 line[0]=mantissa&0xff;
 line[1]=(mantissa>>8)&0xff;
 line[2]=((mantissa>>16)&0x7f)|((0x1&expo)<<7);
 line[3]=sign|(0x7f & (expo>>1));

}


/***************************************************
 * make au-file with encoding -6
 **************************************************/
make_au_file(name1,name3) char *name1,*name3;
{
 char line[132],line2[132];
 FILE *stream1,*stream3;
 float f1,f2;
 int i,counter1,len;

 printf("make_au_file\n");
 stream3=fopen(name3,"wb+");
 if(!stream3) return 1;

 strcpy(line,"dns.");                    /* magic word of au-files */
 fwrite(line,1,4,stream3);

 len=68+3060;                            /* header len 3128 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=line[2]=0xff;line[3]=0; /* data size unknown */
 fwrite(line,1,4,stream3);

 len=6;                                  /* encoding 6 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 len=44100;                              /* sampling rate 44100 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 len=1;                                  /* channels 1 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 strcpy(line,"AudacityBlockFile112");    /* name */
 fwrite(line,1,20,stream3);

 f1=-1.0;                              /* Min */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 f1= 1.0;                              /* Max */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 f1= 0.327736;                           /* RMS */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 f1=-1.0;                              /* Min */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 f1= 1.0;                              /* Max */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 f1= 0.299080;                           /* RMS */
 build_binary32(f1,line);
 fwrite(line,1,4,stream3);

 /* write 3060 zero bytes */
 line[0]=line[1]=line[2]=line[3]=0;
 for(i=0;i<765;i++) fwrite(line,1,4,stream3);

 /* writes as encoding=6, binary32 */
 stream1=fopen(name1,"rb");
 if(!stream1) {
  printf("make_au_file. no file %s\n",name1);fclose(stream3);return 1;
 }

 while(1) {
  if(!fgets(line,132,stream1)) break;
  sscanf(line,"%d %f\n",&counter1,&f1);
  build_binary32(f1,line);

 /* testing 
  sbinary(line2,line,32,&f2);
  printf("TEST: Encoded %f decoded %f line=%s\n",f1,f2,line2);
  if(getchar()=='q') break;
 */   


  fwrite(line,1,4,stream3);

 }

 fclose(stream1);
 fclose(stream3);
}



/***************************************************
 * make au-file with encoding 6
 * not used yet
 **************************************************/
make_au_file_32(name1,name3) char *name1,*name3;
{
 char line[132];
 FILE *stream1,*stream3;
 float f1;
 int i,counter1,len;

 printf("make_au_file_32\n");
 stream3=fopen(name3,"wb+");

 strcpy(line,"dns.");                    /* magic word of au-files */
 fwrite(line,1,4,stream3);

 len=68+3060;                            /* header len 3128 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=line[2]=0xff;line[3]=0; /* data size unknown */
 fwrite(line,1,4,stream3);

 len=6;                                  /* encoding 6 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 len=44100;                              /* sampling rate 44100 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 len=1;                                  /* channels 1 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream3);

 strcpy(line,"AudacityBlockFile112");    /* name */
 fwrite(line,1,20,stream3);

 line[0]=line[1]=0;
 f1=-1.875;                              /* Min */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=0;
 f1= 1.875;                              /* Max */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=0;
 f1= 1.663086;                           /* RMS */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=0;
 f1=-1.875;                              /* Min */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=0;
 f1= 1.875;                              /* Max */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 line[0]=line[1]=0;
 f1= 1.649414;                           /* RMS */
 build_binary16(f1,line+2);
 fwrite(line,1,4,stream3);

 /* write 3060 zero bytes */
 line[0]=line[1]=line[2]=line[3]=0;
 for(i=0;i<765;i++) fwrite(line,1,2,stream3);

 /* writes as encoding=6 (actually -6) */
 stream1=fopen(name1,"rb");

 if(!stream1) {printf("no file %s\n",name1);fclose(stream3);return 1;}
 while(1) {
  if(!fgets(line,132,stream1)) break;
  sscanf(line,"%d %f\n",&counter1,&f1);
  build_binary32(f1,line);  /* binary32 */
  fwrite(line,1,4,stream3);

 }

 fclose(stream1);
 fclose(stream3);
}


/********************************************/
/* input: binary string in line of length i */
/* returns: the number                      */
/********************************************/
int read_binary(char *line, int i)
{
 int res,j,k;
 
 res=0;

 j=i-1;
 for(i--;i>=0;i--) {
   k=(1<<i);
   if(line[j-i]=='1') res += k;
 }
 return res;
}
/*****************************************************************/
/* input: line has data of length i bits                         */
/* returns: line2 is line decoded in binary                      */
/* and f1, which is the number either binary32 or binary16       */
/* sbinary returns 0 on a number, 1 on not a number, -1 on error */
/*****************************************************************/
int sbinary(char *line2,char *line,int i,float *f1)
{

 unsigned long int k;
 unsigned long int n;
 char exponent[8];
 char mantissa[23];
 int expo, manti,sign,i1;
 float res;
 
 memcpy((char *)&n,line,4); 

 *line2=0;exponent[0]=mantissa[0]=0;

 /* IEEE 754 32-bit base-2 floating point binary32 */
 if (i==32) {
  for(i--;i>=0;i--) {
   k= (1<<i);
   if(k&n) strcat(line2,"1"); /* line2 is a return parameter */
   else strcat(line2,"0");

   if(i==31) { if(k&n) sign= -1; else sign= 1;}
   else if (i<31 && i>22) {
    if(k&n) strcat(exponent,"1");
    else strcat(exponent,"0");  
   }
   else if (i<=22 && i>=0) {
    if(k&n) strcat(mantissa,"1");
    else strcat(mantissa,"0");   
   }
  }
  expo=read_binary(exponent, 8);
  manti=read_binary(mantissa, 23);

  if (expo==0xff) {
   if(manti==0) {
     res=1.0;for(i1=0;i1<127;i1++) res=res*2; /* good enough as infinity */
   }
   else return 1; /* not a number */
  }
  else if (expo==0) { /* subnormal numbers (0.mantissa_2)*2^-14 */
   res=(float)manti;
   for (k=0;k<23;k++) res=res/2.0;
   for (k=0;k<126;k++) res=res/2.0; 
  }
  else { /* normalized values (1.mantissa_2)*2^(expo-15) */
   res=(float)manti;
   for (k=0;k<23;k++) res=res/2.0;

   res +=1.0;  /* res=1.mantissa_2 */
    
   expo -= 127; /* removing bias of the exponent */
   
   if(expo<0) {
     for (k=0;k<-expo;k++) res=res/2.0; /* base 2 */
   }
   else {
     for (k=0;k<expo;k++) res=res*2.0;
   }
  }
 }

 /* ieee 754 16-bit base-2 half precision floating point binary16 */
 else if (i==16) {
  for(i--;i>=0;i--) {
   k= (1<<i);
   if(k&n) strcat(line2,"1");  /* line2 is a return parameter */
   else strcat(line2,"0");
   if(i==15) { if(k&n) sign= -1; else sign= 1;} 
   else if (i<15 && i>9) {
    if(k&n) strcat(exponent,"1");
    else strcat(exponent,"0");  
   }
   else if (i<=9 && i>=0) {
    if(k&n) strcat(mantissa,"1");
    else strcat(mantissa,"0");   
   }
  }
  expo=read_binary(exponent, 5);
  manti=read_binary(mantissa, 10);

  if (expo==31) {
   if(manti==0) {
     res=1.0;for(i1=0;i1<23;i1++) res=res*2; /* good enough as infinity */
   }
   else return 1; /* not a number */
  }
  else if (expo==0) { /* subnormal numbers (0.mantissa_2)*2^-14 */
   res=(float)manti;
   for (k=0;k<10;k++) res=res/2.0;
   for (k=0;k<14;k++) res=res/2.0; 
  }
  else { /* normalized values (1.mantissa_2)*2^(expo-15) */
   res=(float)manti;
   for (k=0;k<10;k++) res=res/2.0;
   res +=1.0;  /* res=1.mantissa_2 */
    
   expo -= 15; /* removing bias of the exponent */
   
   if(expo<0) {
     for (k=0;k<-expo;k++) res=res/2.0; /* base 2 */
   }
   else {
     for (k=0;k<expo;k++) res=res*2.0;
   }
  }
 }

 *f1=sign*res;

 return 0;
}

/****************************************************/
/* prints differences in two files                  */
/****************************************************/
find_differences(name1,name2) char *name1;char *name2;
{
 char line[132], line2[132],lineb[132], line2b[132];
 FILE *stream1,*stream2;
 float f1,f2;
 int counter=0;

 stream1=fopen(name1,"rb");
 rewind(stream1);
 stream2=fopen(name2,"rb");
 rewind(stream2);

 while(1) {
  if(!fread(line,1,2,stream1)) break;
  line[2]=0;
  sbinary(line2,line,16,&f1);

  if(!fread(lineb,1,2,stream2)) break;
  lineb[2]=0;
  sbinary(line2b,lineb,16,&f2);
   
  if (strcmp(line2,line2b)) {
   printf("Difference at %d\n",counter);
   printf("in %s is  %s  %f\n",name1,line2, f1);
   printf("in %s is  %s  %f\n",name2,line2b, f2);
   if('q'==getchar()) break;
  }
  counter+=2;
 }
 fclose(stream1);
 fclose(stream2);
}

/***************************************************
 * open au-file and show the fields
 **************************************************/
analyse(name1) char *name1;
{
 char line[132], line2[132];
 FILE *stream1,*stream2;
 float f1,f2;
 int len,len2,counter1,headerlen,count_start,count_stop;
 int counter=0,show=1,print;
 int encoding,counter3,number;

 stream1=fopen(name1,"rb");

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 if(memcmp(line,"dns.",4)){printf("not au-file\n");return 1;}
 line[4]=0;  
 printf("%d AU-file header: %s\n",counter, line);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&headerlen,line,4); 
 printf("%d Data offset (=header length)=%d\n",counter, headerlen);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 sbinary(line2,line,32,&f1);
 printf("%d Data size (not known=FFFFFF00) %s\n",counter,line2); 
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&encoding,line,4); 
 printf("%d Encoding=%d\n",counter, encoding);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&len2,line,4); 
 printf("%d Sampling rate=%d\n",counter, len2);
 counter+=4;

 if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
 memcpy((char *)&len2,line,4); 
 printf("%d Channels=%d\n",counter, len2);
 counter+=4;

 if(!fread(line,1,20,stream1)) {printf("not au-file\n");return 1;}
 line[20]=0;
 printf("%d Name=%s\n",counter, line);
 counter+=20;
  
 if(encoding== -6) { /* binary16 */

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 Min=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 Min=%f\n",counter,f2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 Max=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 Max=%f\n",counter,f2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 RMS=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 RMS=%f\n",counter,f2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 Min=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 Min=%f\n",counter,f2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 Max=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 Max=%f\n",counter,f2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,16,&f1);
  printf("%d Ch1 RMS=%f\n",counter,f1);
  sbinary(line2,line+2,16,&f2);
  printf("%d Ch2 RMS=%f\n",counter,f2);
  counter+=4;

 }
 else if(encoding== 6) {  /* binary 32 */
  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d Min=%f line=%s\n",counter,f1,line2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d Max=%f line=%s\n",counter,f1,line2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d RMS=%f line=%s\n",counter,f1,line2);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d Min=%f\n",counter,f1);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d Max=%f\n",counter,f1);
  counter+=4;

  if(!fread(line,1,4,stream1)) {printf("not au-file\n");return 1;}
  sbinary(line2,line,32,&f1);
  printf("%d RMS=%f\n",counter,f1);
  counter+=4;
 }

 printf("...want to skip the header block... (y/n)\n");
 if(getchar()=='y') print=0;
 else print=1;
 len2=headerlen-68;
 counter1=len2;
 while(counter1>0) {
  if(!fread(line,1,2,stream1)) break;
  if(print) {
   sbinary(line2,line,16,&f1);
   printf("%d %s %f\n",counter, line2, f1);
   if('q'==getchar()) break;
  }
  counter1 -=2;
  counter+=2;
 }
 
 if(encoding==3) {   /* the data is in 16-bit linear PCM */
  while(1) {
   if(!fread(line,1,2,stream1)) break;
   memcpy((char *)&number,line,2);
   printf("%d %d\n",counter,number);
   if('q'==getchar()) break;
   counter+=2;
  }
 }
 else if (encoding==6){   /* the data is in binary32 */
  while(1) {
   if(!fread(line,1,4,stream1)) break;
   sbinary(line2,line,32,&f1);
   printf("%d f1=%f\n",counter,f1);
   if(getchar()=='q') break;
   counter+=4;
  }
 }
 else if (encoding== -6){   /* the data is in binary16, 2 channels */

  while(1) {
   if(!fread(line,1,4,stream1)) break;
   sbinary(line2,line,16,&f1);
   counter+=2;
   printf("%d f1=%f\n",counter,f1);
   sbinary(line2,line+2,16,&f2);
   printf("%d f2=%f\n",counter,f2);
   counter+=2;
   if(getchar()=='q') break;

  }
 }

 fclose(stream1);
}


int autocorrelation(name,id) char*name;char* id;
{
 int i,k;
 FILE *stream;
 int counter,num;
 char line[132];
 float f1;
 float *p1,*p2;
 double sum,ave,var;

 printf("in autocorrelation\n");
 stream=fopen(name,"r");
 if(!stream) return 1;
 p1=malloc(100000*sizeof(float));
 if(!p1) {fclose(stream);return 1;}
 p2=malloc(100000*sizeof(float));
 if(!p2) {fclose(stream);free(p1);return 1;}

 counter=0;
 while(1) {
  if(!fgets(line,132,stream)) break;
  sscanf(line,"%d %f\n",&num,&f1);
  if(counter==100000) break;
  p1[counter]=f1;
  counter+=1;
 }
 fclose(stream);

 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=p1[i];
 }
 ave=sum/counter;
 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=(p1[i]-ave)*(p1[i]-ave);
 }
 var=sum/counter;

 printf("got ave and variance\n");

 /* unscaled autocorrelation */
 for(k=0;k<counter;k++) {
  sum=0.0;
  for(i=0;i<counter-k;i++) {
   sum+=(p1[i]-ave)*(p1[i+k]-ave);
  } 
  p2[k]=sum/(counter-k);
 }

 /* print as autocorId.res, Id=1,2,3 */
 strcpy(line,"autocor");
 strcat(line,id);
 strcat(line,".res");
 stream=fopen(line,"w+");
 if(!stream) { free(p1);free(p2);return 1;}
 for(i=0;i<counter;i++) {
  fprintf(stream,"%d %f\n",i,p2[i]);
 }
 fclose(stream);

 free(p1);free(p2);
 printf("done\n");
 return 0;

}


int correlation(name1,name2,id) char*name1,*name2;char* id;
{
 int i,k;
 FILE *stream1,*stream2;
 int counter,num,counter1,counter2;
 char line[132];
 float f1;
 float *p1,*p2,*p3;
 double sum,ave1,var1,ave2,var2;

 printf("in correlation\n");
 stream1=fopen(name1,"r");
 if(!stream1) return 1;
 stream2=fopen(name2,"r");
 if(!stream2) {fclose(stream1);return 1;}
 p1=malloc(100000*sizeof(float));
 if(!p1) {fclose(stream1);fclose(stream2);return 1;}
 p2=malloc(100000*sizeof(float));
 if(!p2) {fclose(stream1);fclose(stream2);free(p1);return 1;}
 p3=malloc(100000*sizeof(float));
 if(!p3) {fclose(stream1);fclose(stream2);free(p1);free(p2);return 1;}

 counter=0;
 while(1) {
  if(!fgets(line,132,stream1)) break;
  sscanf(line,"%d %f\n",&num,&f1);
  if(counter==100000) break;
  p1[counter]=f1;
  counter+=1;
 }
 fclose(stream1);
 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=p1[i];
 }
 ave1=sum/counter;
 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=(p1[i]-ave1)*(p1[i]-ave1);
 }
 var1=sum/counter;
 counter1=counter;
 printf("got ave1=%f and var1=%f counter1=%d\n",ave1,var1,counter1);

 counter=0;
 while(1) {
  if(!fgets(line,132,stream2)) break;
  sscanf(line,"%d %f\n",&num,&f1);
  if(counter==100000) break;
  p2[counter]=f1;
  counter+=1;
 }
 fclose(stream2);
 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=p1[i];
 }
 ave2=sum/counter;
 sum=0.0;
 for(i=0;i<counter;i++) {
  sum+=(p2[i]-ave2)*(p2[i]-ave2);
 }
 var2=sum/counter;
 counter2=counter;
 printf("got ave2=%f and var2=%f counter2=%d\n",ave2,var2,counter2);

 if(counter1<counter2) counter=counter1;else counter=counter2;
 /* unscaled correlation */
 for(k=0;k<counter;k++) {
  sum=0.0;
  for(i=0;i<counter-k;i++) {
   sum+=(p1[i]-ave1)*(p2[i+k]-ave2);
  } 
  p3[k]=sum/(counter-k);
 }

 /* print as correId.res, Id=1,2,3 */
 strcpy(line,"corre");
 strcat(line,id);
 strcat(line,".res");
 stream1=fopen(line,"w+");
 if(!stream1) {free(p1);free(p2);free(p3);return 1;}
 for(i=0;i<counter;i++) {
  fprintf(stream1,"%d %f\n",i,p3[i]);
 }
 fclose(stream1); 

 free(p1);free(p2);free(p3);
 printf("done\n");
 return 0;

}

/*************************************************************/
/* here is the routine to calculate the proposed correlation */
/* it subtracts signal2(in name2) from signal1(in name1)     */
/*************************************************************/
my_correlation(name1,name2,name3,ave,xoff,yscale,remove,start_offset,samples) 
char *name1,*name2,*name3;float *ave;int *xoff;float *yscale;
int remove,start_offset;char *samples; 
{
 char line[132], line2[132];
 FILE *stream1,*stream2,*stream3;
 float f1,f2,f3;
 int counter1,counter2,num,lim;
 int i,j,k,counter=0, minstati, minoff;
 RESDATA *pointer;
 int statis[300];
 float scale,scale1,scale_best,valmax;
 int offset,j1,offset_best,lim1,lim2;
 float sum1,sum2,sum3,val1,val2,val3,ave1,ave2,ave3,ave3min;
 double sinf0,sin2f0,sin3f0,cosf0,cos2f0,cos3f0,b1,a0,a1,f11,f21,f0;
 double s1,s2,s3,t,st,sampling_best;
 int numsamples;

 printf("in my_correlation, start_offset=%d\n",start_offset);
 if(start_offset<0) {
  printf("start_offset must be nonnegative\n");
  return 0;
 }
 if(strcmp(samples,"all")) {
  numsamples=(int)string_to_int(samples);
  if(numsamples>100000) numsamples=100000;
 }
 else numsamples=100000;

 pointer=(RESDATA *)malloc(sizeof(RESDATA));
 if(!pointer) return 1;
 stream1=fopen(name1,"rb");
 if(!stream1) {free(pointer);return 1;}
 stream2=fopen(name2,"rb");
 if(!stream2) {free(pointer);fclose(stream1);return 1;}
 stream3=fopen(name3,"wb+");
 if(!stream3) {free(pointer);fclose(stream1);fclose(stream2);return 1;}

 /* read everything into a buffer */
 counter1=0;
 while(1) {
  if(!fgets(line,132,stream1)) break;
  sscanf(line,"%d %f\n",&num,&f1);
  if(counter1==numsamples) break;
  pointer->f1[counter1]=f1;
  counter1+=1;
 }
 counter2=0;
 while(1) {
  if(!fgets(line,132,stream2)) break;
  sscanf(line,"%d %f\n",&num,&f2);
  if(counter2==numsamples) break;
  pointer->f2[counter2]=f2;
  counter2+=1;
 }

 if(counter1<counter2) counter=counter1;else counter=counter2;
 lim=counter;
 /* counter is the number of samples we can use */
 if(counter<10000) {
   /* too short sample */
  free(pointer);
  fclose(stream1);
  fclose(stream2);
  fclose(stream3);
  return 1;
 }
 

 /* scale and offset are the numbers to adjust */

 /* calculate an average of absolute values for both files */
 sum1=0;
 for(i=0;i<counter1;i++) {
  val1=pointer->f1[i];
  if (val1<0) val1=-val1;
  sum1 += val1;
 }
 ave1=sum1/counter1;
 sum2=0;
 for(i=0;i<counter2;i++) {
  val2=pointer->f2[i];
  if (val2<0) val2=-val2;
  sum2 += val2;
 }
 ave2=sum2/counter2;
 

 printf("my_correlation, got ave1=%f ave2=%f counter1=%d counter2=%d\n",
   ave1,ave2,counter1,counter2);

 /* scale both files to the same average */
 for(i=0;i<counter1;i++) {
  val1=pointer->f1[i];
  pointer->f1[i]=val1/ave1;
 }
 for(i=0;i<counter2;i++) {
  val2=pointer->f2[i];
  pointer->f2[i]=val2/ave2;
 }
 ave1=ave2=1.0;

 /* this is our first guess for scale */
 scale= *yscale;

 /* start_offset is given for name2, it can only be positive        */
 /* vary to both directions for 1102 samples, that is 0.025 seconds  */
 /* minimize the sum of absolute values */
 minoff=start_offset-1102;if (minoff<0) minoff=0;
 ave3min=1000000.0;
 for(offset=minoff;offset<start_offset+1102;offset++) {
  if(counter2+offset<=counter1) counter=counter2;
  else counter=counter1-offset;
  sum3=0;

  for(i=0;i<counter;i++) {
   val3=pointer->f1[i+offset]-scale*pointer->f2[i];
   if(val3<0) val3= -val3;
   sum3 += val3;
  }
  ave3=sum3/counter;

  if(ave3<ave3min) {
   offset_best=offset;
   ave3min=ave3;
  }
 }
 /* found offset_best */
 printf("offset_best=%d ave3min=%f samples=%d\n",offset_best,ave3min,counter);

 /* with this offset tune the scale */
 /* vary the scale from scale-0.2 to scale+0.2 */
 offset=offset_best;
 if(counter2+offset<=counter1) counter=counter2;
 else counter=counter1-offset;

 ave3min=1000000.0; /* large */
 for(j1=-1000;j1<=1000;j1++) {
  scale1=scale+(float)j1/5000.0;
  sum3=0;
  for(i=0;i<counter;i++) {
   val3=pointer->f1[i+offset]-scale1*pointer->f2[i];
   if(val3<0) val3= -val3;
   sum3 += val3;
  }
  ave3=sum3/counter;
  if(ave3<ave3min) {
   scale_best=scale1;
   ave3min=ave3;
  }
 }
 /* found scale_best */

 printf("scale_best=%f ave3min=%f offset=%d\n",scale_best,ave3min,offset);
 printf("counter1=%d counter2=%d counter=%d\n",counter1,counter2,counter);

#ifdef SAMPLING_BEST
 /* the following step has only minor importance */
 /* the sampling rate is 44100 Hz, it is much higher than human voice       */
 /* therefore for matching human voice the sampling offset is not important */
 /* however, subtracting the signals causes high frequency noise            */
 /* this noise can be removed by resampling the signal with the Nyquist th. */
 /* notice, this is not shifting the signal in time, it would require all   */
 /* fourier components, and be slow to compute. This is only the high freq. */
 /* and it has no relevance for the voice signal, only removes noise        */
 /* save f1 to f4, we overwrite f1 */
 for(i=0;i<counter1;i++) {
  pointer->f4[i]=pointer->f1[i];
 }
 f0=44100.0*2.0*3.14/3.0;
 sinf0=sin(f0);sin2f0=sin(2.0*f0);sin3f0=sin(3.0*f0);
 cosf0=cos(f0);cos2f0=cos(2.0*f0);cos3f0=cos(3.0*f0);
 /* using Nyquist's theorem, we shift the sampling time */
 /* that is, we reconstruct the sinus curve and resample it */
 offset=offset_best;scale1=scale_best;
 ave3min=1000000.0; /* large */
 sampling_best=0.0;
 for(t=1.0;t<2.0;t+=0.1) {
  for(i=0;i<counter1;i++) {
   s1=pointer->f4[i];
   s2=pointer->f4[i+1];
   s3=pointer->f4[i+2];
   f11=(s2-s1)*(sin3f0-sin2f0)-(s3-s2)*(sin2f0-sinf0);
   f21=(cos2f0-cosf0)*(sin3f0-sin2f0)-(cos3f0-cos2f0)*(sin2f0-sinf0);
   b1=f11/f21;
   f11=s2-s1-b1*(cos2f0-cosf0);
   f21=sin2f0-sinf0;
   a1=f11/f21;
   a0=s1-a1*sinf0-b1*cosf0;
   st=a0+a1*sin(f0*t)+b1*cos(f0*t);
   pointer->f1[i]=st;
  }
  /* now we have resampled pointer->f1 to time t */
  if(offset>=0) { 
   if(counter2+offset<=counter1) counter=counter2;
   else counter=counter1-offset;
   sum3=0;
   for(i=0;i<counter;i++) {
    val3=pointer->f1[i+offset]-scale1*pointer->f2[i];
    if(val3<0) val3= -val3;
    sum3 += val3;
   }
   ave3=sum3/counter;
  }
  else {
   if(counter1<counter2+offset) counter=counter1;
   else counter=counter2+offset;
   sum3=0;
   for(i= -offset;i<counter-offset;i++) {
    val3=pointer->f1[i+offset]-scale1*pointer->f2[i];
    if(val3<0) val3= -val3;
    sum3 += val3;
   }
   ave3=sum3/counter;
  }
  if(ave3<ave3min) {
   sampling_best=t;
   ave3min=ave3;
  }
 }
 /* found sampling_best */
 printf("best sampling at %f ave3min=%f\n",sampling_best,ave3min);
 /* set the best sampling to f1 */
 if(sampling_best!=1.0) {
  for(i=0;i<counter1;i++) {
   s1=pointer->f4[i];
   s2=pointer->f4[i+1];
   s3=pointer->f4[i+2];
   f11=(s2-s1)*(sin3f0-sin2f0)-(s3-s2)*(sin2f0-sinf0);
   f21=(cos2f0-cosf0)*(sin3f0-sin2f0)-(cos3f0-cos2f0)*(sin2f0-sinf0);
   b1=f11/f21;
   f11=s2-s1-b1*(cos2f0-cosf0);
   f21=sin2f0-sinf0;
   a1=f11/f21;
   a0=s1-a1*sinf0-b1*cosf0;
   st=a0+a1*sin(f0*sampling_best)+b1*cos(f0*sampling_best);
   pointer->f1[i]=st;
  }
 }
#endif

 /* got all results: scale_best, offset_best, and we shifted the timeslot */
 /* set output parameters */
 *ave=ave3min;
 *xoff= -offset_best;
 *yscale=scale_best;

 /* what do we want to do ? */
 /* set in source code remove=1 in the call if you want just the file */ 

 if(remove) { /* removing the signal in name1 from name2 */

  offset=offset_best;
  scale1=scale_best;
  sum3=0.0;
  for(i=0;i<counter;i++) {
   val3=pointer->f1[i+offset]-scale1*pointer->f2[i];
   pointer->f3[i]=val3;
   if(val3<0) val3= -val3;
   sum3 += val3;
  }
  ave3=sum3/counter;

  /* the signal should have average zero, but lets be sure */
  sum3=0;
  for(i=0;i<counter;i++) {
   val3=pointer->f3[i];
   sum3  += val3;
  }
  ave1=sum3/counter; /* this is the average */
  for(i=0;i<counter;i++) {
    pointer->f3[i] -= ave1;
  }
  printf("removed the average, ave1=%f counter=%d\n",ave1,counter);

  sum3=valmax=0.0;
  for(i=0;i<counter;i++) {
   val3=pointer->f3[i];
   if(val3<0) val3= -val3;
   sum3  += val3;
   if(val3>valmax) valmax=val3;
  }
  ave3=sum3/counter; /* average of absolute values */
  printf("reduced average of absolute values ave3=%f\n",ave3);

  printf("largest absolute value %f, scale to one\n",valmax);
  for(i=0;i<counter;i++) {
   val3=pointer->f3[i];
   pointer->f3[i]=val3/valmax;
  }

  printf("name3=%s\n",name3);
  /* write to a file */
  for (i=0;i<counter;i++) {
   f3=pointer->f3[i];
   fprintf(stream3,"%d %f\n",i,f3);
  }
 }
 else {
  /* we want to plot something like a correlation */
  /* using sampling_best and scale_best, we vary */
  /* offset and plot ave3 */

  scale1=scale_best;
  offset=start_offset;

  /* we know the best offset and can set counter */
  if(counter2+offset_best<=counter1) {counter=lim2=counter2;lim1=0;}
  else {counter=lim2=counter1-offset_best;lim1=0;}

  for(j1=0;j1<counter;j1++) {
   sum3=0;
   for(i=lim1;i<lim2;i++) {
    val3=pointer->f1[i+offset]-scale1*pointer->f2[i+j1];
    if(val3<0) val3= -val3;
    sum3 += val3;
   }
   ave3=sum3/counter;
   val3=ave3-ave3min;
   if(offset+j1==offset_best) 
    printf("best val3=%f j1=%d offset=%d\n",val3,j1,offset);
   fprintf(stream3,"%d %f\n",j1,val3);
  }
  printf("done\n");
 }

 free(pointer);
 fclose(stream1);
 fclose(stream2);
 fclose(stream3);

 return 0;
}

/*************************************************************/
/* calculate power spectrum                                   */
/*************************************************************/
int power_spectrum(name1,name2,samples) 
char *name1,*name2,*samples;
{
 int k,n;
 char line[132];
 FILE *stream1,*stream2;
 int K, max,num,n_old;
 double a0,an,bn,sn,pi;
 float f2;int numsamples;
 RESDATA *pointer;

 if(strcmp(samples,"all")){
  numsamples=(int)string_to_int(samples);
  if(numsamples>100000) numsamples=100000;
 }
 else numsamples=100000;
 
 pointer=(RESDATA *)malloc(sizeof(RESDATA));
 if(!pointer) {printf("no memory\n");return 1;}

 printf("in power_spectrum\n");
 stream1=fopen(name1,"rb");
 if(!stream1) {printf("could not open %s\n",name1);return 1;}
 stream2=fopen(name2,"wb+");
 if(!stream2) {printf("could not open %s\n",name2);
               fclose(stream1);return 1;}

 /* read everything into a buffer */
 K=1;
 while(1) {
  if(!fgets(line,132,stream1)) break;
  sscanf(line,"%d %f\n",&num,&f2);
  if(K==numsamples) break;
  pointer->f1[K]=f2;
  K+=1;
 }

 if(K<10000) { /* this is 0.2268 seconds, maybe too small? */
  printf("not enough samples\n");
  free(pointer);
  fclose(stream1);
  fclose(stream2);
  return 1;
 }
 pointer1->size=K;
 fprintf(stream2,"size=%d\n",K); 
 
 /* K is the number of samples, max is the highest fourier component */
 max=K/2;
 pi=3.14159;


 /* first fourier component */
 for(a0=0,k=0;k<K;k++) a0 +=pointer->f1[k];
 a0=a0/(double)K;
 pointer1->f3[0]=a0*a0;
 pointer1->f1[0]=a0;
 pointer1->f2[0]=0;

 n_old=-1;
 /* fourier componets an and bn for n=1,...,max */
 for(n=1;n<=max;n++) {
  if(n/1000!=n_old) {
   printf("%d percent ready\n",(int)(100*n/max));
   n_old=n/1000;
  }
  an=bn=0.0;
  for(k=0;k<K;k++) {
   sn=pointer->f1[k];
   an += sn*cos(pi*(double)(2*n*k)/(double)K);
   bn += sn*sin(pi*(double)(2*n*k)/(double)K);
  }
  an=2.0*an/(double)K;
  bn=2.0*bn/(double)K;
  pointer1->f3[n]=an*an+bn*bn;
  pointer1->f1[n]=an;
  pointer1->f2[n]=bn;
 }

 /* write the power spectrum to a file */
 for (n=0;n<=max;n++) {
  f2=pointer1->f3[n];
  fprintf(stream2,"%d %f\n",n,f2);
 }

 free(pointer);
 fclose(stream1);
 fclose(stream2);
 
 return 0;
}


/*************************************************************/
/* filter power spectrum which is in pointer1                */
/*************************************************************/
int filter_spectrum(name1,name2,low1,high1,outofband) 
char *name1,*name2;int low1,high1,outofband;
{
 int k,n,i;
 char line[132];
 FILE *stream1,*stream2;
 int K, max,num,n_old;
 double a0,an,bn,sn,pi;
 float f2,val1,val2;int numsamples;
 int low,high;

 if(pointer1->size==0) {printf("run power spectrum\n");return 1;}

 K=pointer1->size;

 /* high1 and low1 are in hertz, change to indices */
 low=low1*K/44100;
 high=high1*K/44100;

 /* K is the number of samples, max is the highest fourier component */
 max=K/2;
 pi=3.14159;

 if(!outofband) {
  stream1=fopen(name1,"wb+");
  if(!stream1) return 1;
  /* reconstruct to stream1 the time signal filtered by low and high */
  for(i=0;i<K;i++) { /* loop over time */
   if(!(i%1000)) printf("%d percent ready\n",(int)100*i/K);
   f2=0.0;
   for (n=low;n<=high;n++) { /* loop over frequences */
    if(n==0) {
     val1= pointer1->f1[0];
     f2 += val1*44100.0/(float)K; /* (1/tau)*(1/K)=1/T */
    }
    else {
     an=pointer1->f1[n];
     bn=pointer1->f2[n];
     val1= an*cos(2*pi*(float)(i*n)/(float)K);
     val2= bn*sin(2*pi*(float)(i*n)/(float)K);
     f2 += (val1+val2)*2*44100.0/(float)K;    /* (1/tau)*(2/K)=2/T */
    }
   }
   fprintf(stream1,"%d %f\n",i,f2);
  }
 fclose(stream1);
 }

 if(outofband) {
  stream2=fopen(name2,"wb+");
  if(!stream2) return 1;
  /* reconstruct to stream2 the filtered part */
  for(i=0;i<K;i++) { /* loop over time */
   if(!(i%1000)) printf("%d percent ready\n",(int)100*i/K);
   f2=0.0;
   val1 = pointer1->f1[0];
   f2 += val1*44100.0/(float)K; /* (1/tau)*(1/K)=1/T */
   for (n=1;n<low;n++) { /* loop over frequences */
    an=pointer1->f1[n];
    bn=pointer1->f2[n];
    val1= an*cos(2*pi*(float)(n*i)/(float)K);
    val2= bn*sin(2*pi*(float)(n*i)/(float)K);
    f2 += (val1+val2)*2*44100.0/(float)K;    /* (1/tau)*(2/K)=2/T */
   }
   for (n=high+1;n<K;n++) { /* loop over frequences */
    an=pointer1->f1[n];
    bn=pointer1->f2[n];
    val1= an*cos(2*pi*(float)(n*i)/(float)K);
    val2= bn*sin(2*pi*(float)(n*i)/(float)K);
    f2 += (val1+val2)*2*44100.0/(float)K;    /* (1/tau)*(2/K)=2/T */
   }
   fprintf(stream2,"%d %f\n",i,f2);
  }
 fclose(stream2); 
 }

 printf("done\n");
 return 0;
}


