/*************************************************
* DIM3CROSS.C 	3-dimensional cross section editor
* Author:     	Jorma Jormakka
* Date:   	2.2.93
**************************************************/

#include "x.ext"
#include "win.ext"

extern int color,drawingpixels;
extern int bgcol;
extern void fillbox(),fillcube();
extern unsigned char code_mask();
extern void decode_mask(),code_header(),decode_header();


void clear_crosssect_editor()
{
 int k;
 
 clearwin(335,281,579,Y__max,bgcol);
 for(k=280;k<Y__max;k++) drawpixel((short)460,(short)k,(short)COLOR3);  
 for(k=320;k<580;k++) drawpixel((short)k,(short)380,(short)COLOR3);        
}
void cross_section_editor()
{ 
 fillbox(600,5*j,5,5,COLOR4);                   
 plot_one_line(cos_c,sin_c,cos_a,sin_a,j,0,0,0,(unsigned char *)plane_a);
 j=Y/5;
 fillbox(600,5*j,5,5,COLOR5);                                  
 plot_one_line(cos_c,sin_c,cos_a,sin_a,j,15,0,0,(unsigned char *)plane_a);
 plot_one_line((long)2048,(long)0,(long)2048,(long)0,j,3,320,280,(unsigned char *)plane_a);
}       	
int three_dim_ed()
{	
 int i,j,k,j1,j2;
 int xoff,zoff,Xlast,Ylast;
 char ch,*buf2;
 int X1,Z1,Y1,finish,ilength,length;
 long X2,Z2;

 Xlast=X;Ylast=Y;
 i=j=finish=0;

 resetmouse();
 setmouselim(0,0,X__max,Y__max);   
 X=(X__max+1)/2;Y=(Y__max+1)/2; 
 setmouse(X,Y); 
 showmouse();mouse_off=0;
 
 while(1) {	
  buttons=0;
  readmouse(&buttons,&X,&Y);
  if(!buttons) {
   if(mouse_off) { 
    showmouse();mouse_off=0;
    if(finish) { 
     update_stringlength(&plane_a[j][0],ilength-3,length);
     if(i<QSIZE) plane_a[j][i]=0;
     finish=0;
    }     
   }
  }
  else {
   if(!mouse_off) { 
    hidemouse();mouse_off=1;
    i=0;
    while(plane_a[j][i]&0x80 && i<QSIZE) {
     i+=3;i+=(int)plane_a[j][i];i++;  	
    }     
   }   	   	
  }
  if(buttons==1){

   if(X>=619) {    	

   }
   else if(X>=320 && X<580 && Y>= 280) {
    if(finish==0) {
     drawingpixels=0;
     code_header(plane_a,j,i,X-320,Y-280);
     i+=4;ilength=i-1;length=0;finish=1;
     interpolated[j]=0; 
     fillbox(610,5*j,5,5,(int)interpolated[j]);
    }     
    else {
     if(i<QSIZE) {
      mask=code_mask(X-Xlast,Y-Ylast);   	     	    	
      if(X!=Xlast || Y!=Ylast) {
       plane_a[j][i]=(unsigned char )(mask | (0x0f & color));
       length++;
       drawpixel((short)Xlast,(short)Ylast,(short)( 0x0f & plane_a[j][i]) );    
       decode_mask(mask,&xoff,&zoff);
       X=Xlast+xoff;Y=Ylast+zoff;       
       i++;
      }
     }
    }
   }       
  }
  Xlast=X;Ylast=Y;       
 }    
}
