/*******************************************
* DIM3PIXEL.C 	3-dimensional pixel editor
* Author:     	Jorma Jormakka
* Date:   	2.2.93
********************************************/

#include "x.ext"
#include "win.ext"

extern int colorZ,drawingpixels;
extern int bgcol;
extern void fillbox(),fillcube();
extern unsigned char code_mask();
extern void decode_mask(),code_header(),decode_header();

void modify_x(),modify_y(),modify_z(),clear_pixeldraw();
void from3dim_topixel();
int frompixel_to3dim();
void pixel_drawing();
void init_pixelfigure(),show_pixelfigure(),clear_pixelfigure();
void remove_3dimpixel(),change_to_3dimpixel();
void fix_stringlength(),glue_strings();
void push_string_forward(),push_string_backward();

void update_stringlength(plane,i1,l1)
unsigned char *plane;
int i1,l1;
{
 *(plane+i1+3)= 0xff & l1;
 *(plane+i1) &= 0xf8;
 *(plane+i1) |= 0x3 & (l1>>8); 
}
int find_stringend(plane)
unsigned char *plane;
{
 int i1=0,j11,k11,l1;
 
 while((*(plane+i1))&0x80 && i1<QSIZE) {
  decode_header(&l1,&j11,&k11,plane+i1);
  i1 += l1+4;
 }
 return(i1);
}

void clear_pixeldraw(i,X1last,Y1last,Z1last) int i,X1last,Y1last,Z1last;
{
 clear_pixelfigure(X1last,Y1last,Z1last);
 show_pixelfigure(wd_object[i].p2);
 drawingpixels=1;	
}

void from3dim_topixel(i,X1last,Y1last,Z1last,j1min,j2min,kmin) 
int i,X1last,Y1last,Z1last,j1min,j2min,kmin;
{
 init_pixelfigure(X1last,Y1last,Z1last,wd_object[i].p2);
 change_to_3dimpixel(wd_object[i].p2,wd_object[i].p1,j1min,kmin,j2min);
 show_pixelfigure(wd_object[i].p2);
 drawingpixels=1;
}    

int frompixel_to3dim(i,j1min,j2min,kmin) int i,j1min,j2min,kmin;
{
 int j1,j2,k;
 char *buf;
 unsigned char *xplane,*bpoints;
 
 /* thinning algoritm */
 for(j1=1;j1<31;j1++) {
  for(j2=1;j2<31;j2++) {
    for(k=1;k<31;k++) {
     buf=wd_object[i].p2+(j1<<10)+(j2<<5)+k;
     if(*(buf-1024)!=bgcol && *(buf+1024)!=bgcol && *(buf+1)!=bgcol &&
            *(buf-32)!=bgcol && *(buf+32)!=bgcol && *(buf-1)!=bgcol) 
      *buf=bgcol; 		
 }}}
 
 /* glueing strings */
 xplane=(unsigned char *)malloc(QSIZE);if(!xplane) return(1);
 bpoints=(unsigned char *)malloc(248);if(!bpoints) return(1);
 glue_strings(bpoints,wd_object[i].p1,wd_object[i].p2,xplane,j1min,kmin,j2min);
 free(xplane);free(bpoints);

 /* draw the result */
 draw3dimobj(i);     
 drawingpixels=0;
 return(0);    
}


void fix_stringlength(plane,oldpoint,length_increase)
unsigned char *plane;
int oldpoint,length_increase;
{
 int i1=0,j11,k11,l1;
 
 while((*(plane+i1))&0x80) { 	
  decode_header(&l1,&j11,&k11,plane+i1);
  if(i1+4+l1>=oldpoint) break;
  i1 += l1+4;
 }
 l1 += length_increase;
 *(plane+i1+3)= 0xff & l1;
 *(plane+i1) &= 0xf8;
 *(plane+i1) |= 0x3 & (l1>>8); 
}

void push_string_backward(source_end,dest_end,length)
unsigned char *source_end,*dest_end;
int length;
{
 int i;
 unsigned char *s,*d;
 s=source_end;d=dest_end;
 
 for(i=length;i>0;i--) { *d = *s; d--;s--;}
}
void push_string_forward(source_start,dest_start,length,endzero)
unsigned char *source_start,*dest_start;
int length,endzero;
{
 int i;
 unsigned char *s,*d;
 s=source_start;d=dest_start;
 
 for(i=length;i>0;i--) { *d = *s; d++;s++;}
 if(endzero) *d=0;
}
void clear_pixelfigure(X1last,Y1last,Z1last)
int X1last,Y1last,Z1last;
{
 register int k;
 
 clearwin(335,0,599,259,bgcol);
 modify_x(X1last,&X1last);
 modify_y(Y1last,&Y1last);
 fillcube(340,80,0,5,5,160,COLOR1,COLOR1,COLOR1);
 fillcube(340,80,Z1last,5,5,5,COLOR5,COLOR1,COLOR2);
   
 for(k=340;k<500;k++) { drawpixel((short)k,(short)100,(short)COLOR3);  
                        drawpixel((short)k,(short)260,(short)COLOR3);}
 for(k=420;k<580;k++)   drawpixel((short)k,(short)20,(short)COLOR3);       
 for(k=100;k<260;k++) { drawpixel((short)340,(short)k,(short)COLOR3);  
                        drawpixel((short)500,(short)k,(short)COLOR3);}
 for(k=20;k<180;k++)    drawpixel((short)580,(short)k,(short)COLOR3);       
 for(k=500;k<580;k++) { drawpixel((short)k,(short)600-k,(short)COLOR3);
                        drawpixel((short)k,(short)760-k,(short)COLOR3);}
 for(k=340;k<420;k++)   drawpixel((short)k,(short)440-k,(short)COLOR3);
}
void remove_3dimpixel(buf1,X1,Y1,Z1)
char *buf1;
int X1,Y1,Z1;
{
 register int k,j1,j2;
 int first,k1,k2,ka,kb,kc,xoff,zoff;
 char *buf;

 first=1;
       
 for(k1=32,k=Z1/5+2;k<32;k+=2) {
  j2=(Y1/5-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) { 	
    first=0;k1=k;         	                  	
    fillcube(j1*5+340,j2*5+100,5*k,5,5,5,(int)(*buf),COLOR1,COLOR2);
    break;
   }         	
  }
 }
 if(first) fillcube((X1/5)*5,(Y1/5)*5,5*(Z1/5),5,5,5,bgcol,bgcol,bgcol);
 zoff=(5*(Z1/5+1))/2-(5*(Z1/5))/2;
 xoff=7-zoff;
             
 for(ka=32,k=Z1/5+1;k<32;k+=2) {
  j2=(Y1/5-20)-(Z1/5+1)/2+k/2;
  if(j2>=0 && j2<32) {
   j1=(X1/5-68)+(Z1/5+1)/2-k/2;
   if(j1>=0 && j1<32) {             
    buf=buf1+j1*1024+j2*32+k;        	         
    if((*buf)!=bgcol) { 
     ka=k;
     fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+100+5-xoff,xoff,xoff,(int)(*buf));
     break;
    }
   }
  }
 }

 for(kb=32,k=Z1/5+1;k<32;k+=2) {
  j2=(Y1/5-20)-(Z1/5+1)/2+k/2;
  if(j2>=0 && j2<32) {
   j1=(X1/5-68-1)+(Z1/5+1)/2-k/2;
   if(j1>=0 && j1<32) {             
    buf=buf1+j1*1024+j2*32+k;        	         
    if((*buf)!=bgcol) { 
     kb=k;
     fillbox(5*j1+(5*k)/2+345-zoff,5*j2-(5*k)/2+100+5-xoff,zoff,xoff,(int)(*buf));
     break;
    }
   }
  }
 }
 for(kc=32,k=Z1/5+1;k<32;k+=2) {
  j2=(Y1/5-20+1)-(Z1/5+1)/2+k/2;
  if(j2>=0 && j2<32) {
   j1=(X1/5-68)+(Z1/5+1)/2-k/2;
   if(j1>=0 && j1<32) {             
    buf=buf1+j1*1024+j2*32+k;        	         
    if((*buf)!=bgcol) {
     kc=k; 
     fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+100,xoff,zoff,(int)(*buf));
     break;
    }
   }
  }
 }
       
 for(k=Z1/5+1;k<32;k+=2) {
  j2=(Y1/5-20+1)-(Z1/5+1)/2+k/2;
  if(j2>=0 && j2<32) {
   j1=(X1/5-68-1)+(Z1/5+1)/2-k/2;
   if(j1>=0 && j1<32) {             
    buf=buf1+j1*1024+j2*32+k;        	         
    if((*buf)!=bgcol) {
     fillbox(5*j1+(5*k)/2+345-zoff,5*j2-(5*k)/2+100,zoff,zoff,(int)(*buf));
     break;
    }
   }
  }
 }
  /* add shadows*/
 /*
 if(ka>kb) {
  for(k2= -2;k2<xoff-3;k2++)
   drawpixel(5*(X1/5)+(5*(Z1/5))/2+zoff,5*(Y1/5)-(5*(Z1/5))/2+k2,COLOR2);
  for(k2= -2;k2<xoff-4;k2++)
   drawpixel(5*(X1/5)+(5*(Z1/5))/2+zoff+1,5*(Y1/5)-(5*(Z1/5))/2+k2,COLOR2);
 }
 if(ka>kc) {
  for(k2= 0;k2<xoff-2;k2++)
   drawpixel(5*(X1/5)+(5*(Z1/5))/2+zoff+2+k2,5*(Y1/5)-(5*(Z1/5))/2+1,COLOR1);
  for(k2= 0;k2<xoff-1;k2++)
   drawpixel(5*(X1/5)+(5*(Z1/5))/2+zoff+1+k2,5*(Y1/5)-(5*(Z1/5))/2+2,COLOR1);
 } 
   */             
   /* cover previous shadows */
 for(k=Z1/5;k<ka;k+=2) {
  j2=(Y1/5-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68+1)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+100,2,3,(int)(*buf));
    break;
   }         	
  }
 }      
 for(k=Z1/5;k<kc;k+=2) {
  j2=(Y1/5-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68+1)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+103,2,2,(int)(*buf));
    break;
   }         	
  }
 }             
 for(k=Z1/5;k<ka;k+=2) {
  j2=(Y1/5-1-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    fillbox(5*j1+(5*k)/2+342,5*j2-(5*k)/2+103,3,2,(int)(*buf));
    break;
   }         	
  }
 }             
 for(k=Z1/5;k<kb;k+=2) {
  j2=(Y1/5-1-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+103,2,2,(int)(*buf));
    break;
   }         	
  }
 }                    
 for(k=Z1/5;k<ka;k+=2) {
  j2=(Y1/5-1-20)-(Z1/5)/2+k/2;
  j1=(X1/5+1-68)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    fillbox(5*j1+(5*k)/2+340,5*j2-(5*k)/2+103,2,2,(int)(*buf));
    break;
   }         	
  }
 }                    
 /* resume shadows */
 for(k=Z1/5;k<k1;k+=2) {
  j2=(Y1/5-20)-(Z1/5)/2+k/2;
  j1=(X1/5-68-1)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    for(k2=0;k2<5;k2++)
     drawpixel(5*j1+(5*k)/2+345,5*j2-(5*k)/2+100+k2,COLOR2);
    for(k2=0;k2<4;k2++)
     drawpixel(5*j1+(5*k)/2+346,5*j2-(5*k)/2+100+k2,COLOR2);          
    break;
   }         	
  }
 }      
 for(k=Z1/5;k<k1;k+=2) {
  j2=(Y1/5-20+1)-(Z1/5)/2+k/2;
  j1=(X1/5-68)+(Z1/5)/2-k/2;
  if(j2>=0 && j2<32 && j1>=0 && j1<32) {             
   buf=buf1+j1*1024+j2*32+k;
   if((*buf)!=bgcol) {
    for(k2=0;k2<3;k2++)
     drawpixel(5*j1+(5*k)/2+342+k2,5*j2-(5*k)/2+98,COLOR1);
    for(k2=0;k2<4;k2++)
     drawpixel(5*j1+(5*k)/2+341+k2,5*j2-(5*k)/2+99,COLOR1);          
    break;
   }         	
  }
 }             
}


int find_bpoints_and_pack(plane1,j1min,kmin,bpoints)
int j1min,kmin;
unsigned char *plane1,*bpoints;
{
 int i1,n,m=0;	
 short int i,j1,k;
 unsigned char *plane,*planestart,*planehead;
 int xoff,zoff,length,this_inside,next_inside,count,length1,remove;

  memset(bpoints,0,248);      
/* debug_string(plane1,j1min,kmin,-1); */
 plane=plane1;
 
 /* remove points where 0<k<31 and 0<j1<31 from plane1 */   	
 while((*plane)&0x80 && m<QSIZE) {   
  planehead=plane;
  decode_header(&length,&j1,&k,plane);plane+=4;
  m += length+4;
  j1 -= j1min; k -= kmin;
  if (k>=0 && k<=31 && j1>=0 && j1<=31) {remove=this_inside=1;count=0;planestart=plane;}
  else this_inside=0;
  for(i1=0;i1<length;i1++) {
   decode_mask((*plane)&0x70,&xoff,&zoff);
/*   if(length==10) {
    printf(" j1=%d ",j1);printf(" k=%d ",k);printf(" i1=%d \n",i1);
    getch();
   }*/            
   j1 += xoff;k += zoff;
   next_inside=(k>=0 && k<=31 && j1>=0 && j1<=31);
    
   if(!this_inside && next_inside) {remove=count=0;planestart=plane+1;}
   else if(this_inside && !next_inside) { 
    if(!remove) { 
     length1=(long)(planestart-planehead-3); 
     update_stringlength(planehead,0,length1);        
     code_header(planestart+1,0,0,(int)(j1+j1min),(int)(k+kmin));          
     length1=QSIZE-1-(long)(plane-plane1);
     if((long)(plane-planestart)>4) 
      push_string_forward(plane+1,planestart+5,length1,1);
     else {
      if(QSIZE-find_stringend(plane1)>=4-(long)(plane-planestart))	
       push_string_backward(plane+1,planestart+5,length1);
      else {     /* no place */
       sound(E2);delay(100);nosound();
       push_string_backward(plane+1,planestart+5,length1);/* what else to do??*/
      }
     }
     length1=length-(long)(plane-planehead)+3;
     update_stringlength(planestart,1,length1);            
     plane=planestart+1;this_inside=0;    
     break;
    }
    else {
    /* if(length==5) {
      printf(" next_inside==0, this_inside==1, remove==1 \n");
      getch();
     }*/                	
     code_header(planehead,0,0,(int)(j1+j1min),(int)(k+kmin));          
     length1=length-(long)(plane-planestart)-1;
     update_stringlength(planehead,0,length1);      
     length1=QSIZE-1-(long)(plane-plane1);
     push_string_forward(plane+1,planehead+4,length1,1);  
     plane=planehead;this_inside=0;    
     break;    
    }
   }
   else if(this_inside) count++;
   this_inside=next_inside;plane++;
  }  
  if(this_inside) {
   if(!remove) {
    /* if(length==10) {
      printf(" next_inside==1, this_inside==1, remove==0 \n");
      getch();
     }*/
    count--;
    update_stringlength(planehead,0,length-count);
    length1=QSIZE-1-(long)(planestart-plane1)-count;
    push_string_forward(planestart+1+count,planestart+1,length1,count);
    plane=planestart+1;  	    
   }
   else {
    length1=QSIZE-(long)(planehead-plane1)-4-length;
    push_string_forward(planehead+4+length,planehead,length1,1);   	
    plane=planehead;  	    
   }
  }
 } 
/* debug_string(plane1,j1min,kmin,-1); */
/* find boundary points */

 plane=plane1;
 i=n=0;
   	
 while((*plane)&0x80) {   
  decode_header(&length,&j1,&k,plane);plane+=4;i+=4;
  j1 -= j1min; k -= kmin;

  for(i1=0;i1<length;i1++) {
   if (k>=0 && k<=31) {
    if(j1==0) {memcpy(&bpoints[2*k],(char *)&i,2);n++;}
    else if(j1==31) {memcpy(&bpoints[2*(k+32)],(char *)&i,2);n++;}   
    else if (j1>0 && j1<31) {
     if(k==0) {memcpy(&bpoints[2*(j1+64)],(char *)&i,2);n++;}
     else if(k==31) {/*printf("find and pack, k= %d j1= %d \n",k,j1);*/
                     memcpy(&bpoints[2*(j1+94)],(char *)&i,2);n++;}
    }
   }
   decode_mask((*plane)&0x70,&xoff,&zoff);         
   j1 += xoff;k += zoff;           
   plane++;i++;   
  }
 }
  
 return(n);	
}

void init_pixelfigure(X1last,Y1last,Z1last,buf1)
int X1last,Y1last,Z1last;
char *buf1;
{
 register int k,j1,j2;
 char *buf;
 
 clear_pixelfigure(X1last,Y1last,Z1last);
 
 buf=buf1;
 for(j2=31;j2>=0;j2--) {     	     
  for(j1=31;j1>=0;j1--) {     	
   for(k=31;k>=0;k--) {  	
    *buf=bgcol;buf++;
 }}}
}
void show_pixelfigure(buf1)
char *buf1;
{
 register int k,j1,j2;
 char *buf,*bufsave;

 buf=buf1+1023;
 for(j1=0;j1<32;j1++) {
  bufsave=buf;     	    
  for(j2=31;j2>=0;j2--) {
   for(k=31;k>=0;k--) {  	
    if(*buf!=bgcol)
     fillcube(j1*5+340,j2*5+100,5*k,5,5,5,(int)(*buf),COLOR1,COLOR2);
    buf--;          
   }
  }
  buf=bufsave;
  buf += 1024;
 }
}
void change_to_3dimpixel(buf1,planea,j1min,kmin,j2min)
char *buf1;
unsigned char *planea;
int j1min,kmin,j2min;
{
 int i,j1,k,j2,m;
 unsigned char *plane;
 int xoff,zoff,length;
 char *buf;

 for(j2=31;j2>=0;j2--) {
  plane=planea+QSIZE*(j2+j2min);
  buf=buf1+(j2<<5);
  m=0; 	
  while((*plane)&0x80 && m<QSIZE) {   
   decode_header(&length,&j1,&k,plane);plane+=4;     
   j1 -= j1min; k -= kmin;m += length+4;
      
   for(i=length;i>0;i--) {
    if(j1>=0 && j1<= 31 && k>=0 && k<=31)
     *(buf+(j1<<10)+k)=(*plane)&0xf;
    decode_mask((*plane)&0x70,&xoff,&zoff);         
    j1 += xoff;k += zoff;           
    plane++;
   }
  }
 }
}
int good_boundary_point(buf1,j,i,k,bpoints) 
char *buf1;
int j,*i,*k;
unsigned char *bpoints;
{
 char *buf,*bufsave;
 int n;
 short int pp;
 
 buf=buf1+(j<<5);
 for(n=0;n<124;n++) {
  memcpy((unsigned char *)&pp,&bpoints[2*n],2);
  if(pp) {
   bufsave=buf;
   if(n<32)       {*i= 0;*k=n;} 
   else if(n<64)  {*i=31;*k=n-32;}    
   else if(n<94)  {*k= 0;*i=n-64;}    
   else if(n<124) {*k=31;*i=n-94;}
   /*
   printf("good boundary point considers pp=%d ",pp);  	       
   printf("with j1= %d k= %d n= %d \n",*i,*k,n);   */
   buf += ((*i)<<10)+(*k);  	
   if((0xf&(*buf))!=bgcol && !((*buf)&0x80)) {
    (*buf) |= 0x80;
/*    printf("good boundary point finds pp=%d \n",pp);*/
    return(pp);
   }
   buf=bufsave;
  }
 }
 return(0);
}  
int locate_point(buf1,j,i,k) 
char *buf1;
int j,*i,*k;
{
 char *buf,*bufsave;
 
 buf=buf1+(j<<5);
  
 for((*i)=0;(*i)<32;(*i)+=1) {
  bufsave=buf;
  for((*k)=0;(*k)<32;(*k)+=1) {
   if((0xf&(*buf))!=bgcol && !((*buf)&0x80)) {
    (*buf) |= 0x80; 	
    return(1);
   }
   buf++;	
  }
  buf=bufsave;
  buf += 1024;
 }
 return(0);
}
int findnewpoint(buf1,j,i,k,xoff,zoff,color) 
char *buf1;
int j,i,k,*xoff,*zoff,*color;
{
 char *buf,*buf2;
 int xmin,xmax,zmin,zmax;
 
 buf=buf1+(i<<10)+(j<<5)+k;
 *color=(*buf)&0xf;
 if(i>0) xmin= -1; else xmin=0;
 if(i<31) xmax=1; else xmax=0;
 if(k>0) zmin= -1; else zmin=0;
 if(k<31) zmax=1; else zmax=0; 

 for((*xoff)= xmax; (*xoff) >= xmin; (*xoff)-=1) {	
  for((*zoff)= zmax; (*zoff) >= zmin; (*zoff)-=1) {	
   buf2=buf+(*xoff)*1024+(*zoff);
   if((0xf&(*buf2))!=bgcol && !((*buf2)&0x80)) {
    (*buf2) |= 0x80;
    return(1);
   }
  }
 }
 return(0);
}

int debug_string(plane,j1min,kmin,debuglength)
unsigned char *plane;  
int j1min,kmin,debuglength;
{
 int i,n,j1,k,length,xoff,zoff;
 char skip;
  
 n=0;	
 while((*plane)&0x80 && n<QSIZE) {
  decode_header(&length,&j1,&k,plane);plane+=4;
  n += length+4;     
  j1 -= j1min; k-=kmin;
  if(debuglength<0 || debuglength==length) {
   printf("new string, length= %d \n",length);
   skip=0;skip=getch();}
  for(i=0;i<length;i++) {
   decode_mask((*plane)&0x70,&xoff,&zoff);
   if(skip!='p' && (debuglength<0 || debuglength==length))   {
    printf(" j1=%d ",j1);printf(" k=%d ",k);printf(" i=%d \n",i);
    getch();  }
   j1 += xoff;k += zoff;plane++;
  }   
 }    
 return(1);
}
void glue_strings(bpoints,planea,buf1,xplane,j1min,kmin,j2min)
unsigned char *bpoints,*planea,*buf1,*xplane;
int j1min,kmin,j2min;
{
 int i,j1,k,n,j2,oldbpoint,ilength,length,xoff,zoff,color;
 int j1next,knext,length1,stringend;
 unsigned char mask,*plane; 

 for(j2=0;j2<32;j2++) {
 
  plane=planea+QSIZE*(j2+j2min); 	
  i=oldbpoint=0;
/*  debug_string(planea+QSIZE*(j2+j2min),j1min,kmin,-1);  */

  n=find_bpoints_and_pack(plane,j1min,kmin,bpoints);
/*  printf(" n=%d \n",n);getch();*/

  while(1) {
   if(n) oldbpoint=good_boundary_point(buf1,j2,&j1,&k,bpoints);
   else oldbpoint=0;
   if(!oldbpoint) if(!locate_point(buf1,j2,&j1,&k)) break;
/*     printf(" oldbpoint=%d \n",oldbpoint);getch();       */
   if(i>=QSIZE-4) break;    	                      	
   code_header(xplane,0,i,(int)(j1+j1min),(int)(k+kmin));
   i+=4;ilength=i-1;length=0;

   while(findnewpoint(buf1,j2,j1,k,&xoff,&zoff,&color)) {     
/*    fillcube(j1*5+340,j2*5+100,5*k,5,5,5,COLOR4,COLOR1,COLOR2);         */
       
    if(i>=QSIZE) break;    	                
    mask=code_mask(xoff,zoff);
    xplane[i]=(unsigned char )(mask | (0x0f & color));    
    length++;j1 += xoff;k += zoff;i++;        
   }
   if(i<QSIZE) {    	                
    /* mask in xoff,zoff indicate next point, here unused*/
    xplane[i]=(unsigned char )(0x0f & color);
/*    fillcube(j1*5+340,j2*5+100,5*k,5,5,5,COLOR4,COLOR1,COLOR2); */
                
    length++;i++;
   }      
   update_stringlength(xplane,ilength-3,length);   
   if(i<QSIZE) xplane[i]=0;

   stringend=find_stringend(plane);
  /* if(j2==0) {printf(int_to_string((long)stringend));printf(" ");getch();}*/
   if(oldbpoint) {
    /* insert to old boundary point */
    decode_header(&length1,&j1next,&knext,plane+oldbpoint+1);
    xoff=j1next-j1min-j1;zoff=knext-kmin-k;

    if(xoff*xoff<=1 && zoff*zoff<=1) {
     if(QSIZE-stringend>=length-5) {
      mask=code_mask(xoff,zoff);
      xplane[ilength+length] |= (unsigned char )mask;
              		
      fix_stringlength(plane,oldbpoint,length-1+length1);
      if(length>4) {
       length1=QSIZE-oldbpoint-length;
       push_string_backward(plane+oldbpoint+4+length1,plane+QSIZE-1,length1);
      }
      else {
       length1=QSIZE-oldbpoint-5;
       push_string_forward(plane+oldbpoint+5,plane+oldbpoint+length,length1,1);
      }
      memcpy(plane+oldbpoint,xplane+ilength+1,length);
     }
     else {sound(E2);delay(100);nosound();/* no room!! */}
    }
    else {   
     if(QSIZE-stringend>=length-1) {
      if (length>0) {
       fix_stringlength(plane,oldbpoint,length-1);
       length1=QSIZE-oldbpoint-length;
       push_string_backward(plane+oldbpoint+length1,plane+QSIZE-1,length1);
       memcpy(plane+oldbpoint,xplane+ilength+1,length);         
      }
     }
     else {sound(E2);delay(100);nosound();/* no room!! */}     
    }
   }
   else {
    /* add new component */
    if(!join_string_to_end(plane,j1,k,j1min,kmin,xplane,ilength,length,stringend)) {
     if(QSIZE-stringend>=length+4) {
      oldbpoint=stringend;
      memcpy(plane+oldbpoint,xplane+ilength-3,length+4);
     }
     else {sound(E2);delay(100);nosound();/* no room!! */}           
    }
   }
  }
/*  debug_string(planea+QSIZE*(j2+j2min),j1min,kmin,-1);*/
 }
}
int join_string_to_end(plane,j1,k,j1min,kmin,xplane,ilength,length,stringend)
unsigned char *plane,*xplane;
int j1,k,j1min,kmin,ilength,length,stringend;
{
 int i=0,xoff,zoff,j1next,knext,length1;
 unsigned char mask;
 
 while(i<QSIZE && (*(plane+i))&0x80) {
  decode_header(&length1,&j1next,&knext,plane+i);
  xoff=j1next-j1min-j1;zoff=knext-kmin-k;
  if(xoff*xoff<=1 && zoff*zoff<=1) { /* matching end */ 
   if(QSIZE-stringend>=length) {
    mask=code_mask(xoff,zoff);
    xplane[ilength+length] |= (unsigned char )mask;       		
    update_stringlength(xplane,ilength-3,length+length1);
    length1=QSIZE-4-length-i;
    push_string_backward(plane+i+3+length1,plane+QSIZE-1,length1);
    memcpy(plane+i,xplane+ilength-3,length+4);
   }
   else {sound(E2);delay(100);nosound();/* no room!! */}        
   return(1);   
  }
  i += 4+length1;
 }
 return(0); /* no matching end found */
}

void modify_z(i,X,lastZ1p,highlight)
int i,X,*lastZ1p;
int highlight;
{
 int k,j1,j2,X1,Y1,Z1;
 char *buf,*bufsave,*bufsave2;

 fillcube(340,80,0,5,5,160,COLOR1,COLOR1,COLOR1);
 Z1=(X-340)*2;
 if(highlight) {
  fillcube(340,80,Z1,5,5,5,highlight,COLOR1,COLOR2);     	
  buf=wd_object[i].p2+992;
  for(j1=0;j1<32;j1++) {
   bufsave=buf;     	    
   for(j2=31;j2>=0;j2--) {
    bufsave2=buf;     	            	
    if(*(buf+ (*lastZ1p)/5)!=bgcol)
     fillcube(j1*5+340,j2*5+100,5*(*lastZ1p/5),5,5,5,
     	(int)(*(buf+(*lastZ1p)/5)),COLOR1,COLOR2);
    if(*(buf+Z1/5)!=bgcol)
     fillcube(j1*5+340,j2*5+100,5*(Z1/5),5,5,5,highlight,COLOR1,COLOR2);
    buf=bufsave2;
    buf -= 32;         
   }
   buf=bufsave;
   buf += 1024;
  }     	 
 }
 else  fillcube(340,80,Z1,5,5,5,COLOR5,COLOR1,COLOR2);
 
 *lastZ1p=Z1;       
}
void modify_x(X,lastX1p)
int X,*lastX1p;
{
 fillcube(340,270,0,160,5,5,COLOR1,COLOR1,COLOR1);
 fillcube(X,270,0,5,5,5,COLOR5,COLOR1,COLOR2); 
 *lastX1p=X;       
}
void modify_y(Y,lastY1p)
int Y,*lastY1p;
{
 fillcube(330,100,0,5,160,5,COLOR1,COLOR1,COLOR1);
 fillcube(330,Y,0,5,5,5,COLOR5,COLOR1,COLOR2); 
 *lastY1p=Y;       
}

void pixel_drawing(i,X,Y,Xlast,Ylast,lastX1p,lastY1p,lastZ1p,
		keepz,keepx,keepy)
int i,X,Y,Xlast,Ylast;
int *lastX1p,*lastY1p,*lastZ1p;
int keepz,keepx,keepy;
{
 int k,j1,j2,X1,Y1,Z1;
 char *buf;
 char buf2[80];

 if(!drawingpixels) {
  init_pixelfigure(*lastX1p,*lastY1p,*lastZ1p,wd_object[i].p2);        	
  drawingpixels=1;
 }   	   	
 else {  
  if(!keepz) {
   if(X>Xlast && Y<Ylast) {
    X1= *lastX1p;Y1= *lastY1p;Z1= *lastZ1p+2;if(Z1>159) Z1=159;
    fillcube(340,80,*lastZ1p,5,5,5,COLOR1,COLOR1,COLOR1);              
    fillcube(340,80,Z1,5,5,5,COLOR5,COLOR1,COLOR2);                   
   }
   else if(X<Xlast && Y>Ylast) { 
    X1= *lastX1p;Y1= *lastY1p;Z1= *lastZ1p-2;if(Z1<0) Z1=0;
    fillcube(340,80,*lastZ1p,5,5,5,COLOR1,COLOR1,COLOR1);              
    fillcube(340,80,Z1,5,5,5,COLOR5,COLOR1,COLOR2);                   
   }
  }    
  else { 
   X1=X- (*lastZ1p)/2;Y1=Y+ (*lastZ1p)/2;Z1= *lastZ1p;
   if(X1<340) X1=340; else if(X1>499) X1=499;
   if(Y1<100) Y1=100; else if(Y1>259) Y1=259;     
  }
  if(keepx) X1= *lastX1p;
  if(keepy) Y1= *lastY1p;
     
  if(X1!= *lastX1p || Y1!= *lastY1p || Z1!= *lastZ1p) { 
   buf=wd_object[i].p2+(X1/5-68)*1024+(Y1/5-20)*32+(Z1/5);     	     	
   if(colorZ==bgcol) {
    if((*buf)!=bgcol) {
     *buf=(char)colorZ;     	
     remove_3dimpixel(wd_object[i].p2,X1,Y1,Z1);
    }
   }
   else {
    *buf=(char)colorZ;        	
    fillcube((X1/5)*5,(Y1/5)*5,(Z1/5)*5,5,5,5,colorZ,COLOR1,COLOR2);    
    if(*(buf+1024)!=bgcol && X1<495)
     fillbox((X1/5)*5+((Z1/5)*5)/2+5,(Y1/5)*5-((Z1/5)*5)/2,3,5,*(buf+1024));
    if(*(buf-32)!=bgcol && Y1>104)
     fillbox((X1/5)*5+((Z1/5)*5)/2,(Y1/5)*5-3-((Z1/5)*5)/2,5,3,*(buf-32));
    if(*(buf+992)!=bgcol && Y1>104 && X1<495)
     fillbox((X1/5)*5+((Z1/5)*5)/2+5,(Y1/5)*5-3-((Z1/5)*5)/2,3,3,*(buf+992));
   }	        
   for(k=100;k<=Y1;k += 4)
    buf2[(k-100)/4]=(char)plot_point(X1+Z1/2,k-Z1/2,COLOR4);
   for(k=100;k<=Y1;k += 4)
    drawpixel(X1+Z1/2,k-Z1/2,(short)buf2[(k-100)/4]);    
            
   for(k=X1;k<500;k += 4)     
    buf2[(k-180)/4]=(char)plot_point(k+Z1/2,Y1-Z1/2,COLOR4);
   for(k=X1;k<500;k += 4)     
    drawpixel(k+Z1/2,Y1-Z1/2,(short)buf2[(k-180)/4]);           
  } 
  *lastZ1p=Z1;*lastX1p=X1;*lastY1p=Y1;       
 }   
}     
