/*******************************************
* EDITOR2.C 	3-dimensional picture editor
* Author:     	Jorma Jormakka
* Date:   	2.2.93
********************************************/

#include "x.ext"
#include "win.ext"
#include "text.ext"

extern int nocolor,pensize;
int colorZ;
int drawingpixels;
unsigned char palette[16]={0,1,2,3,4,5,7,20,56,57,58,59,60,61,62,63};
extern void clear_pixeldraw();
extern void from3dim_topixel();
extern void pixel_drawing();
extern void modify_z(),modify_x(),modify_y();
extern void clear_3dim_obj(),show_pixelfigure();
extern void draw3dimobj(),keep_on_rotating();
void show_minimums();
static int keepz=1,keepx=0,keepy=0,highlight=0;
static int Z1last=0,X1last=499,Y1last=99;
static int j1min=124,j2min=31,kmin=94;
static  int use_marker=0;


int main(argc,argv) int argc; char **argv;
{

 defaultfont=2;

 if(init_font(defaultfont)) 
 {printf("problems in loading font\n");getch();return 1;}   

 /* create and map a window in X11 */
 initgraph(argc,argv); 

 term=I86;lg=ENGL;plg=FINN | POLI;bgcol=1;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;

 init_texts();


 if(init_win(0,15)) return 1;

 editor2();

 endgraph();
 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 
 return 0;
}

/************************************************
*   editor2()
*************************************************/ 
int editor2()
{
 int i,j,x,y;
 if(init_win(0,0)) return(1);

 if(initPool(0,0,0,0)) return(1);
 nocolor=bgcol;
 clearwin(0,0,X__max,Y__max,nocolor);
 getdrawbar(700);
 fillbox(620,341,19,39,7); 
 fillbox(620,421,19,78,7);  
 for(j=0;j<Y__max;j++)   drawpixel((short)320,(short)j,(short)COLOR4);
 for(j=280;j<Y__max;j++) drawpixel((short)580,(short)j,(short)COLOR4); 
 for(i=320;i<580;i++)    drawpixel((short)i,(short)280,(short)COLOR4);  
 for(j=280;j<Y__max;j++) drawpixel((short)460,(short)j,(short)COLOR3);  
 for(i=320;i<580;i++)    drawpixel((short)i,(short)380,(short)COLOR3);   

 make_threedim_obj(3,0,0,"",320,200);
 clear_pixelfigure(X1last,Y1last,Z1last); 
 highlight=COLOR4; 
 fgbuffer=(char *)malloc(4*31*7*cr);if(!fgbuffer) return(1);
 fill_editor2menu(2,4,4,50,2,1*cs,340,30*cs,7,1,3,9,0);   

 do_edi2_engine(2);
 
/* savedrawbar();*/
 return(free_win(1,0));  
}
/***************************************************
* display manager of the editor
****************************************************/
int do_edi2_engine(maxi) int maxi;
{
 int command,i,k,set_palette=0;
 unsigned char ch;
 char line[20],**u2;
 int *chosen;
 int oldX,oldY;
 
 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   oldX=X;oldY=Y;
   command=do_operations();
   if(command==1) {
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi20_operations(popwindow)==1) return(1); /* exit asked */
   }
   else if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */
    if(X+Y<430 && X+Y>420 && X>=340 && X<420) modify_z(2,X,&Z1last,highlight);
    else if(X>=325 && X<335 && Y<260 && Y>=100) modify_y(Y,&Y1last);    
    else if(X>=340 && X<580 && Y<275) {
     if(Y>265 && X<500) modify_x(X,&X1last);         
     else if(Y<260 && X<580) {
      if(buttons==1) 
       pixel_drawing(2,X,Y,oldX,oldY,&X1last,&Y1last,&Z1last,
     			keepz,keepx,keepy);
      else show_pixelfigure(wd_object[2].p2);	
     }
    }
    else if(X>=608){
     printf("here\n");
     if(use_marker) {marker(X,Y,CUROFF,3,3);use_marker=0;}
     if(Y<320) {
      colorZ=Y/20;     	
      if(set_palette) {	
       k=palette[colorZ];
       while(1) {       
        ch=getch();
        if('y'==ch || 'Y'==ch) break;
        else if ('?'==ch) {
         xkoord=624;ykoord=colorZ*20+3;
         X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;  
         textn(int_to_string((long)k),0,15);         	
         ch=getch();
         fillbox(616,colorZ*20,24,20,1);           
         fillbox(619,colorZ*20,20,20,colorZ);
         if('y'==ch || 'Y'==ch) break;
        }
        else {
         k++;if(k==64) k=0;        	
         setVGApalette(colorZ,k);
         palette[colorZ]=k;        	
        }
       }
       set_palette=0;              
      }
     }
     else if (Y<340) {	colorZ=nocolor;
     			use_marker=1;marker(590,320,CURON,3,3);}
     else if (Y<360) { ;}
     else if (Y<380) {
     }
     else if (Y<400) {
      while(kbhit()) getch(); /* flush input */
      change_palette_info();
      set_palette=1;
     }     
     else if (Y<420) {
      if(wd_object[3].type==FREE_OBJ) {
       fill_d3pixelmenu(7,8,4,25,4,50*cs,390,25*cs,15,0,5,9,0);
       if(pull_down(4)) return(1);
      }
      else {
       X=wd_object[3].xcord+3*cs;Y=wd_object[3].ycord+cr;
       if(pop_up_menu(4,NORMAL_OPERATION)>0) return(1);      	
      }
      edi20_operations(4);
     }     
     else if (Y<440) {

     }     
     else if (Y<460) {

     }
     else if (Y<480) {

     }
    }
   }
  } while(!kbhit());
 }
}
/******************************
* edi20_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi20_operations(id)
int id;

{
 int i,j,m,n,x,y,color;
 int *chosen,class,col1,col2;
 LINE10 *u1;
 char **u2;
 FILE *stream;
 char line[30];
 unsigned char *tmpplane;
 short x2,y2,isize;
  	
 switch(id) {
  case 2:	/* edi2 menu */	
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   if(chosen[0] == 1) { /* quit */
    free_wd_objects();
    return(1); /* exit */	
   }
   else if(chosen[1] == 1) { /* read picture */
    strcpy(wd_object[2].name,u1[0].name);   
    load_drawing(2);
    if(wd_object[2].options & WINDOW_HIDDEN) wd_object[2].options ^=WINDOW_HIDDEN;
    put_wd_objects(3,3);
   }
   else if(chosen[2] == 1) { /* save picture */
    strcpy(wd_object[2].name,u1[1].name);      
    save_drawing(2);    	
   }
   else if(chosen[3] == 1) { /* pixel drawing */
    init_pixelfigure(X1last,Y1last,Z1last,wd_object[2].p2);
   }   
   else if(chosen[4] == 1) { /* rotate continously */   
    keep_on_rotating(2);
   }
   else if(chosen[5] == 1) { 
    from3dim_topixel(2,X1last,Y1last,Z1last,j1min,j2min,kmin);
   }
   else if(chosen[6] == 1) { 
    frompixel_to3dim(2,j1min,j2min,kmin);
   }
   else if(chosen[7] == 1) {    
    clear_3dim_obj(2);
   }
   break;
  case 4: /* d3pixel menu */
   j=id-1;
   u1=(LINE10 *)wd_object[j].p1;     
   chosen=(int *)wd_object[j].p3;
   if(chosen[0] == 1) { /* pixel drawing */
    init_pixelfigure(X1last,Y1last,Z1last,wd_object[2].p2);
    drawingpixels=1; 
   }   
   else if(chosen[1] == 1) { 
    from3dim_topixel(2,X1last,Y1last,Z1last,j1min,j2min,kmin);    
   }
   else if(chosen[2] == 1) { 
    frompixel_to3dim(2,j1min,j2min,kmin);    
   }
   else if(chosen[3] == 1) {
    if(u1[0].name[0]==1) highlight=0;    
    else highlight=COLOR4;
   }   
   else if(chosen[4] == 1) {
    if(u1[1].name[0]==1) keepx=0;    
    else keepx=1;   	   
   }
   else if(chosen[5] == 1) {
    if(u1[2].name[0]==1) keepy=0;    
    else keepy=1;   	   
   }
   else if(chosen[6] == 1) {
    if(u1[3].name[0]==1) keepz=0;    
    else keepz=1;   	   
   }      
   else if(chosen[7] == 1) {
    j1min=string_to_int(u1[4].name);   
    j2min=string_to_int(u1[5].name);   
    kmin=string_to_int(u1[6].name);       
    show_minimums(2,j1min,j2min,kmin);
   }
   break;
 }
 return(0);
} 
int fill_editor2menu(max,pmax,window,linelength,id,x,y,xsize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 int ysize;
 
 ysize=3*cs+window*cr;
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Quit ");
 strcpy(u2[1],"Load drawing ");
 strcpy(u2[2],"Save drawing ");
 strcpy(u2[3],"Clear drawing ");     
 
 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;
 strcpy(u1[0].name,"kolme1.fn3");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 strcpy(u1[1].name,"kolme1.fn3"); 
  
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}
int fill_d3pixelmenu(max,pmax,window,linelength,id,x,y,xsize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 int ysize;
 
 ysize=3*cs+window*cr;
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Clear pixel editor"); 
 strcpy(u2[1],"Copy to pixel editor");   
 strcpy(u2[2],"Copy from pixel editor");    
 strcpy(u2[3],"Highlight ");     
 strcpy(u2[4],"x-coordinate ");
 strcpy(u2[5],"y-coordinate ");
 strcpy(u2[6],"z-coordinate ");  
 strcpy(u2[7],"x=    y=    z=    ");   
 
 u1[0].xcord=strlen(u2[3])*cs; 
 u1[0].ycord=3*cr; 
 u1[0].parmax=1;u1[0].bsize=u1[0].size=3;
 u1[0].options |= SELECTION;
 strcpy(u1[0].name,"\001off\002on");
 if(highlight) next_selection(u1[0].name);
 
 u1[1].xcord=strlen(u2[4])*cs; 
 u1[1].ycord=4*cr; 
 u1[1].parmax=1;u1[1].bsize=u1[1].size=6;
 u1[1].options |= SELECTION;
 strcpy(u1[1].name,"\001moving\002fixed");
 if(keepx) next_selection(u1[1].name);
 
 u1[2].xcord=strlen(u2[5])*cs; 
 u1[2].ycord=5*cr; 
 u1[2].parmax=1;u1[2].bsize=u1[2].size=6;
 u1[2].options |= SELECTION;
 strcpy(u1[2].name,"\001moving\002fixed");
 if(keepy) next_selection(u1[2].name);
 
 u1[3].xcord=strlen(u2[6])*cs; 
 u1[3].ycord=6*cr; 
 u1[3].parmax=1;u1[3].bsize=u1[3].size=6;
 u1[3].options |= SELECTION;
 strcpy(u1[3].name,"\001moving\002fixed");
 if(keepz) next_selection(u1[3].name);
 
 u1[4].xcord=2*cs;u1[4].ycord=7*cr; 
 u1[4].parmax=3;u1[4].bsize=u1[4].size=3;
 strcpy(u1[4].name,int_to_string((long)j1min));
 
 u1[5].xcord=8*cs;u1[5].ycord=7*cr; 
 u1[5].parmax=2;u1[5].bsize=u1[5].size=3;
 strcpy(u1[5].name,int_to_string((long)j2min));
 
 u1[6].xcord=14*cs;u1[6].ycord=7*cr; 
 u1[6].parmax=1;u1[6].bsize=u1[6].size=3;
 strcpy(u1[6].name,int_to_string((long)kmin));
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}
#ifdef OLDWAY
change_mimimums(type) int type;
{
 if(type==1)
  change_minimum(&j1min,X,465,320,&j1min,&j2min,&kmin,cos_c,sin_c,cos_a,sin_a);
 else if(type==2)
  change_minimum(&j2min,X,470,PSIZE-32,&j1min,&j2min,&kmin,cos_c,sin_c,cos_a,sin_a);
 else if(type==3)
  change_minimum(&kmin,X,475,320,&j1min,&j2min,&kmin,cos_c,sin_c,cos_a,sin_a);
}        

interpolate()
{
  else if (Y>80 && Y<100) {    
   for(j1=j+1;j1<PSIZE;j1++) {
    if(!interpolated[j1] && (plane_a[j1][0] & 0x80) ) break;
    else {
     for(i=0;i<QSIZE;i++) plane_a[j1][i]=plane_a[j][i];     
     interpolated[j1]=COLOR4;      
     fillbox(610,5*j1,5,5,(int)interpolated[j1]);            	
    }
   }
  }             
 }
}  	  	
                    
#endif
void show_minimums(i,j1min,j2min,kmin) int i,j1min,j2min,kmin;
{
 long X,Z,Y;
 short int X1,Y1;
 long X2,Z2,Y2,Z1;
 COORDDATA *cd;

 cd=(COORDDATA *)wd_object[i].p3;

 X=j1min;
 Y=j2min; 
 Z=kmin;
 
 X2= 140+(100*cd->sin_a-140*cd->cos_a)/2048;
 Z2= (25*cd->cos_a+35*cd->sin_a)/512;
 Y2= 100-((Z2*cd->cos_c)+(25*cd->sin_c))/2048;   
        	 	 	
 X1=((X*cd->cos_a-Z*cd->sin_a)>>11)+X2; 
 Z1=(Z*cd->cos_a+X*cd->sin_a)>>11;
 Y1=((Z1*cd->cos_c+Y*cd->sin_c)>>11)+Y2;

 if(!use_marker) {use_marker=1;marker(X1,Y1,CURON,3,3);}
 else marker(X1,Y1,CURMOVE,3,3);
}
