/****************************************************
* MODULE:   HEXE.C  
* FUNCTION: hex editor, demonstrator or input_window()
* AUTHOR:   Jorma Jormakka
* DATE:     12.4.93
* Modified: March 2017 JJ, adapted to run in X11
*           Not much left from the old code. 
******************************************************/

#include <stdio.h>
#include <string.h>
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "pmenus.ext"
#include "linuxpaths.ext"

/* local messages in messages.txt */
#define First_open_a_file 22
#define Did_not_find 24
#define Found_one_at 26
#define Help_me 28

extern char *int_to_string();
extern  KeySym keysym;
static HEX_LIST *cur_hex_list=0;
static HEX_LIST *first_hex_list=0;
static HEX_LIST *last_hex_list=0;
static int hex_off=0;
static lines_exist=0;
extern int nocolor;
extern oldX,oldY;
extern int xxmin,yymin,xxmax,yymax;
int exit_vect_ed=1;
int debug=0;
JMPTABLE e_table[20];
int request_flag=0;
static int to_ascii=0; /* if 1, will not change, if 0 converts to ascii */
static int line_to_ascii=1;
/**********************/
int exit1_ope()
{
 exit_vect_ed=1;
 return 1;	
}
/**********************/
int edi16_ope()
{
 exit_vect_ed=1;
 message1(Help_me);
 return 0;	
}

/**********************/
int edi15_ope()
{
 int x,y;

 exit_vect_ed=1;

 truncate1=0;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 y=Y__max-233;
 x=X__max-39;
 clearwin(x-cs,y-2,x+36,y+30,15);

 if(wd_object[1].type==FREE_OBJ) { /* no file open */
   /* toggle the global to ascii/to hex flag */ 
  if(to_ascii==0) {
   xkoord=x-cs;ykoord=y;textn("ascii",0,nocolor);
   to_ascii=1;
  }
  else if(to_ascii==1){
   xkoord=x;ykoord=y;textn("--",0,nocolor);
   to_ascii=2;
  }
  else if(to_ascii==2){
   xkoord=x;ykoord=y;textn("hex",0,nocolor);
   to_ascii=0;
  }
 }
 else { /* if a file is already open, pressing the button sets another flag */ 
  /* toggle the ascii/hex flag for a selected line */
  if(line_to_ascii==0) {
   xkoord=x-cs;ykoord=y;textn("ascii",0,nocolor);
   line_to_ascii=1;
  }
  else if(line_to_ascii==1){
   xkoord=x;ykoord=y;textn("--",0,nocolor);
   line_to_ascii=2;
  }
  else if(line_to_ascii==2){
   xkoord=x;ykoord=y;textn("hex",0,nocolor);
   line_to_ascii=0;
  }
 }
 truncate1=1;
 return 0;	
}

/**********************/
int edi10_ope()
{
 flush_mouse();
 if(wd_object[1].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_hexemenu(3,3,3,50,3,2*cs,Y__max-4*cs-3*cr,
   40*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5); 

 put_wd_objects(3,3);
 buttons=0;

 return 0;	
}

/**********************/
int edi11_ope()
{
 LINE10 *u1;

 exit_vect_ed=1;
 /* this is our main menu */
 u1=(LINE10 *)wd_object[2].p1;

 edi12_ope(2,u1[0].name,8,8,91*cs,500); 
 return 0;	
}

/**********************/
int edi13_ope()
{
 FILE *stream,*stream2,*stream3;
 char line[90],buf[3],filename[30];
 int lines,i,num,len,startoff,sum,sum_old,startoff2,hex_off2;
 HEX_LIST *p,*q;char ch;
 int x,y,ysize,xsize,xcur,ycur,xoff,changed,ystart,lines_changed;
 int ymax;char *p1;
 int line_modified,linecount;

 exit_vect_ed=1;

 /* in this demo, use directly the information that input window */
 /* was created in hexe.c with the wd_object id=2, so id-1=1     */
 x=wd_object[1].xcord;
 y=wd_object[1].ycord;
 xsize=wd_object[1].xsize;
 ysize=wd_object[1].ysize;
 ystart=wd_object[1].ystart;
 strcpy(filename,wd_object[1].name);

 /* open an existing file, we require here that the file must exist     */
 /* that is, you do not use a hex editor to look at other than binaries */
 /* and existing binaries, nobody creates a file with a hex editor      */
 /* to create a binary, simply open a file with fopen and write to it   */
 stream=fopen(filename,"rb");  /* open only for reading, we write later */
 if (!stream) {
  strcpy(line,incpath);
  strcat(line,filename);
  stream=fopen(line,"rb");
  if(!stream) return 1; /* error cannot find file */
 }
 /* is there lines.txt file? File lines.txt is used in order to show     */ 
 /* the file in shorter lines than 29 bytes/line. The idea is that one   */
 /* can break lines shorter with carriage return and use tabulator       */
 /* cr and tab will not change the file, only lines.txt                  */
 /* if you are not happy with lines.txt, simply remove it. Then the file */
 /* is again shown with 29 bytes/line                                    */
 /* to remove a tab, move cursor to 0 and press backspace                */
 /* normally cursor jumps 1->4->7->10->... , but it goes to 0            */
 stream2=fopen("lines.txt","rb"); /* also open only for reading */
 if (!stream2) lines_exist=0;
 else lines_exist=1;

 /* First determine ymax. We need ymax for scrolling the file. */
 ymax=0;
 if(!lines_exist) { /* if lines.txt does not exist, lines are 29 bytes */
  while(1) {
   num=fread(line,1,29,stream);
   if(!num) break;
   ymax+=1;
  }
  rewind(stream);
 }
 else {
  while(1) {
   num=fread(line,1,2,stream2);
   if(!num) break;
   ymax+=1;
  }
  rewind(stream2);
 }
 /* xmax and ymax are storen in i1 and i2 for type=INPUTWIN_OBJ             */
 /* xstart is not used, no sense to scroll the file in horizontal direction */
 wd_object[1].i2=ymax;
 wd_object[1].i1=87;
 wd_object[1].xstart=0;

 /* ystart had been given when this routine was called, it may be too large */
 if(ystart>ymax) ystart=ymax;

 /* position stream to the line ystart */
 if(lines_exist) {
  startoff=0;
  for(i=0;i<ystart;i++) {
   /* lines.txt has two bytes for each line: buf[0]=len, buf[1]=indent  */
   /* but to buf[1] is added the first bit 0x80, which is show in ascii */
   if(2!=fread(buf,1,2,stream2)) {
    printf("lines.txt is corrupted, place1\n");return 1;
   }
   if((int)buf[0]<1 || (int)buf[0]>29) {
    printf("lines.txt is corrupted, place1.1 buf[0]=%d i=%d\n",(int)buf[0],i);
    /* tolerate this error, it is not so bad */
    if((int)buf[0]>29) buf[0]=29;
    if((int)buf[0]<1)  buf[0]=1;
   }
   startoff+=(int)buf[0];
  }
  fseek(stream,startoff,0); /* ystart points at startoff in the file */
 }
 else {
  startoff=29*ystart;sum=0; /* if there is no lines.txt, startoff can be */
  for(i=0;i<ystart;i++) {   /* calculated, each line is 29 bytes         */
   num=fread(line,1,29,stream);   
   if(!num) {startoff=sum;break;}
   sum+=num;                /* or almost, the last num can be <29        */ 
   if(sum==startoff) break; /* either sum=startoff or the file ended     */
  }
 }
 /* now startoff is a valid starting value and the file is read up to it */

 /* lines=how many lines can maximally be shown in the window */
 /* depends only on the window size                           */
 lines=(ysize-3*cs)/cr;

 /* allocate lines+1 hex_lists, there is a reason why one more than lines    */
 /* balloc,b_free allocate only at the first time, then use the same buffers */
 p=(HEX_LIST *)balloc((long)sizeof(HEX_LIST));if(!p) return 1;
 p->prev=0;
 p->indent=0;p->len=0;
 first_hex_list=cur_hex_list=p;
 for(i=0;i<=lines;i++) {
  p=(HEX_LIST *)balloc((long)sizeof(HEX_LIST));if(!p) return 1;
  p->prev=cur_hex_list;
  cur_hex_list->next=p;
  p->indent=0;p->len=0;
  cur_hex_list=p;
 }
 cur_hex_list->next=0;
 last_hex_list=cur_hex_list;

 /* the file may not have so many lines, get the correct number of lines    */
 /* notice however, that ystart<=ymax, so there is something to read        */
 /* reading stream from startoff, and if lines_exist, stream2 from ystart*2 */
 p=first_hex_list;
 hex_off=startoff;
 fseek(stream,startoff,0);

 if(!lines_exist) {
  for(i=0;i<lines;i++) {
   num=fread(line,1,29,stream);
   if(!num) {if(i<lines-1) lines=i+1;break;}
   hex_off+=num;
   p->len=num;     /* notice: set p->len before calling convert */
   if(to_ascii==1)      p->indent=0x80;
   else if(to_ascii==0) p->indent=0;
   len=convert_to_hex(num,line,p,(int)p->indent);
   p=p->next;   
  }
 }
 else {
  startoff2=2*ystart;
  hex_off2=startoff2;
  fseek(stream2,startoff2,0);
  for(i=0;i<lines;i++) {
   if(2!=fread(buf,1,2,stream2)) {
    printf("lines.txt is corrupted, place2\n");return 1;
   }
   if((int)buf[0]<1 || (int)buf[0]>29) {
    printf("lines.txt is corrupted, place2.1 buf[0]=%d i=%d\n",(int)buf[0],i);
    /* tolerate this error, it is not so bad */
    if((int)buf[0]>29) buf[0]=29;
    if((int)buf[0]<1)  buf[0]=1;
   }
   hex_off2+=2;
   num=fread(line,1,(size_t)buf[0],stream);
   if(!num) {if(i<lines-1) lines=i+1;break;}
   hex_off+=num;
   /* every line has a flag telling whether to show it in ascii or hex */
   /* but to_ascii==1 or to_ascii==0 overrrules this flag              */
   p->indent=buf[1]; 
   if(to_ascii==1)      p->indent |=0x80;
   else if(to_ascii==0 && 0x80&p->indent) p->indent ^=0x80;
   p->len=num;
   len=convert_to_hex(num,line,p,(int)p->indent);
   p=p->next;     
  }
 }
 /* stream (=file) is positioned to hex_off */
 /* stream2 (=lines.txt), if opened, is positioned to hex_off2 */

 /* split to actions 1) before object is visible and 2) normal operation */
 if(wd_object[1].options&OBJECT_NOT_PUT) { 
  if(stream) fclose(stream);if(stream2) fclose(stream2);
  edi14_ope(lines);
  return 0;
 }

 /* determine which line in the input window (X,Y) points to          */
 num=(Y-y-2*cs)/cr;      /* line number from top of the window        */
 ycur=y+2*cs+num*cr;     /* y+2*cs is the beginning of writing are    */
 xoff=(X-2*cs-x)/(3*cs); /* number of 3-bytes to X                    */
 xcur=x+2*cs+xoff*3*cs;  /* this is where mouse points in x-direction */
 
 /* find the correct p->data */
 for(i=0,p=first_hex_list;p;p=p->next,i++) {
  if(i==num) break;
 }
 
 /* changed!=0 means file changed, lines_changed!=0 that lines.txt changed */
 changed=lines_changed=0;

 /* if a file is opened with to_ascii==0 or to_ascii==1, data is already */
 /* converted to the desired form, so will not be changed here           */
 if(line_to_ascii==1) {
  /* change a selected line from hex to ascii */
  /* notice that we cannot always tell from data if it is hex or ascii */
  /* since only printable characters are in ascii, other are always in hex */ 
  if(!(0x80&p->indent)){
   convert_to_bin(line,p->data);
   len=p->len;
   convert_to_hex(len,line,p,line_to_ascii);
   clearwin(x+2*cs,ycur,x+xsize-2*cs,ycur+cr,15);
   xkoord=x+2*cs+3*cs*(0x7f&p->indent);
   ykoord=ycur;
   textn(p->data,0,nocolor);
   p->indent|=0x80;
   lines_changed=1;
  }
 } 
 else if(line_to_ascii==0) {
  /* change a line from ascii to hex */
  if(0x80&p->indent){
   convert_to_bin(line,p->data);    
   len=p->len;
   convert_to_hex(len,line,p,line_to_ascii);
   clearwin(x+2*cs,ycur,x+xsize-2*cs,ycur+cr,15);
   xkoord=x+2*cs+3*cs*(0x7f&p->indent);
   ykoord=ycur;
   textn(p->data,0,nocolor);
   p->indent ^=0x80;
   lines_changed=1;
  }
 }
 if(!lines_changed) { 
  len=show_one_line(p,xcur,ycur,87,0,bgcol,
                   &changed,&lines_changed,3*xoff);
 
  if(changed) {              /* actual data is changed               */
            /* only one line can change on this run of the routine  */
            /* and only by addition or deletation of a 3-byte       */

  /* p->len is changed, so rewrite lines.txt */
   p->len+=lines_changed;        
   line_modified=ystart+num;
  }       
 }

 if(lines_changed) {      /* lines.txt to be rewritten                  */
  if(lines_changed==13) { /* carriage return pressed, making a new line */
   q=last_hex_list;       /* the last hex_list is always free, since we */
   if(!q->len){           /* allocated one hex_list more than needed    */
     /* remove q from the double linked list */
    last_hex_list=q->prev;last_hex_list->next=0;
    /* insert q after p */
    q->next=p->next;
    q->prev=p;
    p->next->prev=q;
    p->next=q;
    /* coming here len gives the place where to break the line */
    if(len<=0) printf("hexe:error, setting p->len=\n",len);

    strcpy(q->data,&p->data[len]);
    p->data[len]=0;
    q->len=strlen(q->data)/3;
    p->len=strlen(p->data)/3;
    q->indent=p->indent;

    /* write text again */
    ykoord=ycur;
    for(q=p;q;q=q->next) {
     if(q->len) {
      xkoord=x+2*cs+3*cs*(0x7f&q->indent);
      clearwin(x+2*cs,ykoord,x+xsize-cs,ykoord+cr,bgcol);
      textn(q->data,0,nocolor);
      ykoord+=cr;      
     }      
    }
   }
  }
  else if (lines_changed==2) { /* remove a line */
    printf("removing line\n");
   q=p->prev;
   /* if two lines combined fit to 87 characters, combine them */
   if(strlen(q->data)+strlen(p->data)<=87) {
    printf("removing line1\n");
    /* p->data and q->data must both be in ascii or both in hex */
    if((0x80&q->indent) && !(0x80&p->indent)) {
      printf("q in ascii, p in hex\n");
     convert_to_bin(line,p->data);
     num=p->len;
     convert_to_hex(num,line,p,1);
    }
    else if(!(0x80&q->indent) && (0x80&p->indent)) {
      printf("q in hex, p in ascii\n");
     convert_to_bin(line,p->data);
     num=p->len;
     convert_to_hex(num,line,p,0);
    }
    strcat(q->data,p->data);
    q->len=strlen(q->data)/3;
    /* remove p from double linked list */
    q->next=p->next;
    p->next->prev=q;
    /* insert p to be the last in the double lined list */
    p->prev=last_hex_list;
    last_hex_list->next=p;   
    p->next=0;
    last_hex_list=p;
    p->len=0;p->indent=0;p->data[0]=0;

    /* write text again */
    ykoord=ycur-cr;
    for(p=q;p;p=p->next) {
     if(p->len) {
      clearwin(x+2*cs,ykoord,x+xsize-cs,ykoord+cr,bgcol);
      xkoord=x+2*cs+3*cs*(0x7f&p->indent);
      textn(p->data,0,nocolor);
      ykoord+=cr;      
     }
     else break;
    }

    /* if the file was not too short, we try to read one line more */
    /* p is already at a valid p, which has p->len=0               */
    if(lines==(ysize-3*cs)/cr) {
     fseek(stream,hex_off,0);
     if(!lines_exist) {
      num=fread(line,1,29,stream);
      if(num) {
       hex_off+=num;
       p->len=num;     
       if(to_ascii==1)      p->indent=0x80;
       else if(to_ascii==0) p->indent=0;
       len=convert_to_hex(num,line,p,(int)p->indent);
       clearwin(x+2*cs,ykoord,x+xsize-cs,ykoord+cr,bgcol);
       xkoord=x+2*cs+3*cs*(0x7f&p->indent);
       textn(p->data,0,nocolor);
      }
      else lines--;
     }
     else {
      /* hex_off2 is the place up to which linex.txt is read */
      fseek(stream2,hex_off2,0);
      len=fread(buf,1,2,stream2);
      if(len==2) {
       if((int)buf[0]<1 || (int)buf[0]>29) 
       {printf("lines.txt is corrupted, place2\n");return 1;}
       hex_off2+=2;
       num=fread(line,1,(size_t)buf[0],stream);
       if(num!=(int)buf[0]) printf("hexe:error, lines.txt corrupted\n");
       hex_off+=num;
       p->indent=buf[1]; 
       if(to_ascii==1)      p->indent |=0x80;
       else if(to_ascii==0 && 0x80&p->indent) p->indent ^=0x80;
       p->len=num;
       len=convert_to_hex(num,line,p,(int)p->indent);
       clearwin(x+2*cs,ykoord,x+xsize-cs,ykoord+cr,bgcol);
       xkoord=x+2*cs+3*cs*(0x7f&p->indent);
       textn(p->data,0,nocolor);
      }
      else lines--;
     }
    }
   }
  }
  /* use these lines_changed values only as an indicator */
  /* that linex.txt must be rewritten                    */
  else if (lines_changed==1 || lines_changed==-1) {
    ;/* do nothing here */ 
  }
  else if (lines_changed==9) { /* tabulator  pressed */
   p->indent+=1;
   clearwin(x+2*cs,ycur,x+xsize-cs,ycur+cr,bgcol);
   xkoord=x+2*cs+3*cs*(0x7f&p->indent);ykoord=ycur;   
   textn(p->data,0,nocolor);      
  }
  else if (lines_changed==8 && p->indent) {/* backspace, remove tabulator */
   p->indent-=1;
   clearwin(x+2*cs,ycur,x+xsize-cs,ycur+cr,bgcol);
   xkoord=x+2*cs+3*cs*(0x7f&p->indent);ykoord=ycur;   
   textn(p->data,0,nocolor);      
  }
 }

 /* create or rewrite lines.txt. the code always saves or creates the    */
 /* file lines.txt by using an intermediate file with the name lines.tmp */
 if(!lines_exist || lines_changed) {
  stream3=fopen("lines.tmp","wb+");
  if(!stream3) return 1;
  if(lines_exist) rewind(stream2); 

  /* write lines.txt up to ystart */
  sum=0;
  buf[0]=(char)29;buf[1]=(char)0;if(to_ascii==1) buf[1]|=0x80;
  startoff2=ystart*2; /* two bytes, len and indent */
  while(sum<startoff2) {
   if(lines_exist) {
    len=fread(line,1,2,stream2);
    if(to_ascii==0) if(0x80&line[1]) line[1]^=0x80;
    else if(to_ascii==1)             line[1]|=0x80;
    fwrite(line,1,2,stream3);
    sum+=len;
   }
   else {
    fwrite(buf,1,2,stream3);
    sum+=2;
   }
  }

  /* write hex_list buffers */
  for(p=first_hex_list;p;p=p->next) {
   if(p->len) {
    if(to_ascii==1 && !(0x80&p->indent)){
     convert_to_bin(line,p->data);
     convert_to_hex((int)p->len,line,p,to_ascii);
     p->indent|=0x80;
    }
    else if(to_ascii==0 && 0x80&p->indent){
     convert_to_bin(line,p->data);
     convert_to_hex((int)p->len,line,p,to_ascii);
     p->indent^=0x80;
    }
    buf[0]=p->len;buf[1]=p->indent;    
    fwrite(buf,1,2,stream3);
    sum+=2;
   }
   else break;
  }

  /* write the bytes after the hex_list  */
  if(lines_exist) {
   /* notice that hex_off2 does not always equal sum                  */
   /* if a line is split into two, or two lines are combined to one   */
   /* there are one more or one less hex_list buffers than originally */
   fseek(stream2,hex_off2,0); 
   while(1) {
    len=fread(line,1,2,stream2);
    if(!len) break;
    if(to_ascii==0) if(0x80&line[1]) line[1]^=0x80;
    else if(to_ascii==1)             line[1]|=0x80;
    fwrite(line,1,len,stream3);
    if(len!=2) break;
   }
   fclose(stream2);
  }
  else { 

   /* hex_off is the offset up to which the file was read */
   fseek(stream,hex_off,0);
   buf[0]=(char)29;buf[1]=(char)0;
   if(to_ascii==1) buf[1]|=0x80;
   while(1) {
    len=fread(line,1,29,stream);
    if(!len) break;
    if(len!=29) {
     buf[0]=(char)len;
     fwrite(buf,1,2,stream3);
     break;
    }
    else fwrite(buf,1,2,stream3);
   }
  }
  fclose(stream3);
  /* do not ask if copying is allowed, simply update lines.txt */
  strcpy(line,"cp lines.tmp lines.txt");
  system(line);
 }

 if(changed) {/* save the file */

  /* file length is always changed, we make a temporary file */
  /* at this point there is always valid lines.txt           */
  stream2=fopen("lines.txt","rb"); 
  stream3=fopen("output.tmp","wb+");
  rewind(stream);
  sum=0;linecount=0;
  /* up to ystart */
  while(sum<startoff) {
   if(2!=fread(buf,1,2,stream2) || (int)buf[0]<1 || (int)buf[0]>29)
   { printf("lines.txt corrupted, place3\n");return 1;}
   len=fread(line,1,(size_t)buf[0],stream);
   if(len!=(int)buf[0]) {
     printf("lines.txt length does not match,place 1\n");return 1;}
   fwrite(line,1,(size_t)len,stream3);
   sum+=len;
   linecount++;
  }
  if(linecount!=ystart) 
    printf("hexe:error in ystart=%d linecount=%d startoff=%d\n",
    ystart,linecount,startoff);

  /* lines in hex_lists buffers */
  for(p=first_hex_list;p;p=p->next) {
   if(p->len) {
    linecount++;
    convert_to_bin(line,p->data);
    fwrite(line,1,(size_t)p->len,stream3);
   }
   else break;
  }
  /* lines after hex_list buffers */
  fseek(stream,hex_off,0);
  fseek(stream2,hex_off2,0);
  while(1) {
   if(2!=fread(buf,1,2,stream2)) break;
   if((int)buf[0]<1 || (int)buf[0]>29)
   { printf("lines.txt corrupted, place4\n");return 1;}
   len=fread(line,1,(int)buf[0],stream);
   if(len!=(int)buf[0]) {
    printf("lines.txt length longer\n");
    fwrite(line,1,(size_t)len,stream3);
    break;
   }
   fwrite(line,1,(size_t)len,stream3);
  }     
  fclose(stream);fclose(stream3);fclose(stream2);
  strcpy(line,"cp output.tmp ");strcat(line,filename);
  if(!strchr(line,(int)'|')){/* cannot allow piping something to filename */
   system(line);
  }
 }

 /* free hex lists */
 for(p=first_hex_list;p;p=p->next) b_free(p);
 return 0;	
}


/**********************/
int edi14_ope(lines) int lines;
{
 int i;
 HEX_LIST *p;
 int x,y;

 x=wd_object[1].xcord;
 y=wd_object[1].ycord;

 /* show the text */
 ykoord=y+2*cs;
 p=first_hex_list;
 for(i=0;i<lines;i++) {
  xkoord=x+2*cs+3*cs*(0x7f&p->indent);
  textn(p->data,0,nocolor);
  ykoord+=cr;      
  p=p->next;
 }

 /* free hex lists */
 for(p=first_hex_list;p;p=p->next) b_free(p);

 return 0;	
}


/**********************/
int edi12_ope(id,name,x1,y1,xs,ys) int id;char *name; int x1,y1,xs,ys;
{
 FILE *stream,*stream2;
 char line[200];int ymax,xmax,bgnum,sum,num;

 flush_mouse();
 if(wd_object[id-1].type!=FREE_OBJ) return 1;
 vobjmode=0;
 
 stream=fopen("lines.txt","rb");
 if(stream) {  
  ymax=xmax=sum=0;
  while(1){
   if(!fgets(line,200,stream)) break;
   if(strlen(line)>xmax) xmax=strlen(line);
   ymax++;
   sum+=strlen(line);
  }
  fclose(stream);
  printf("there was lines, ymax=%d xmax=%d sum=%d\n",ymax,xmax,sum);
 }
 else { /* each line is 29 characters */
  stream=fopen(name,"rb");  
  ymax=sum=0;
  while(1){
   num=fread(line,1,29,stream);
   if(!num) break;
   ymax++;
   sum+=num;
  }
  fclose(stream);
  xmax=29;
  printf("no lines.txt ymax=%d xmax=%d sum=%d\n",ymax,xmax,sum);
 }


 bgnum=0; /* let put_wd_objects allocate background */

 make_input_window(id,x1,y1,xs,ys,15,Co2,Co3,Co4,
      name,bgnum,xmax,ymax,edi13_ope);

 /* allow only vertical scrolling */ 
 wd_object[id-1].options |=MOVE_AS_RECTANGLE; 
 wd_object[id-1].options |=NO_HORIZONTAL_SCROLLING; 
 wd_object[id-1].options |=NO_RESIZING;
 wd_object[id-1].options |=NO_KILLING;
 wd_object[id-1].options |=NO_ICONIZING;   
 wd_object[id-1].options |=OCTET_ALIGNED;   
 
 wd_object[id-1].ystart=0;

 put_wd_objects(id,id);
 buttons=0;
 return 0;	
}


int fill_hexemenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return -1;
 }
 strcpy(u2[0],"Open file ");
 strcpy(u2[1],"Search ");
 strcpy(u2[2],"Ascii/hex ");

 u1[0].xcord=cs*strlen("Open file ");
 u1[0].ycord=0*cr; 
 u1[0].parmax=1;
 u1[0].size=u1[0].bsize=20;
 strcpy(u1[0].name,"test.txt");

 u1[1].xcord=cs*strlen("Search ");
 u1[1].ycord=1*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=20;
 strcpy(u1[1].name,"e13da37951be");
 /* strcpy(u1[1].name,"search string");*/
 
 u1[2].xcord=cs*strlen("ascii/hex ");
 u1[2].ycord=2*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=10;
 strcpy(u1[2].name,"hex"); 
 /* strcpy(u1[2].name,"ascii"); */
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}

/********************************
*
*  main
*
********************************/
int main(argc,argv) int argc; char **argv;
{
 int i,x,y,xsize,ysize;

 defaultfont=2;
 xxmin=0;yymin=0;xxmax=773;yymax=559;
 if(init_font(defaultfont)) 
 {printf("problems in loading font\n");getch();return 1;}   
 bgcol=15;nocolor=16;
 
 if(initPool(0,0,0,0)) return 0;

 /* create and map a window in X11 */
 initgraph(argc,argv); 

 term=I86;lg=ENGL;plg=FINN | POLI;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 init_texts();
 if(init_win(0,15)) return 1;

 xsize=91*cs;ysize=500;
 fgbuffer=balloc((long)(xsize/8+1)*GPLANES*ysize);
 if(!fgbuffer) {no_memory();return 0;}
 bgbuffer=0;

 clearwin(X1_min,Y1_min,X1_max,Y1_max,1);

 i=0;
 
 y=Y__max-269;
 x=X__max-39;
 clearwin(x-cs,y-2,x+36,y+30,15);xsize=ysize=36;
 xkoord=x;ykoord=y;textn(" ? ",0,nocolor);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi16_ope);
 
 y=Y__max-233;
 x=X__max-39;
 edi15_ope();xsize=ysize=36;
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi15_ope);

 y=Y__max-197;
 x=X__max-39;
 clearwin(x-cs,y-2,x+36,y+30,15);xsize=ysize=36;
 xkoord=x;ykoord=y;textn("menu",0,nocolor);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi10_ope);

 y=Y__max-161;
 x=X__max-39;
 clearwin(x-cs,y-2,x+36,y+30,15);xsize=ysize=36;
 xkoord=x;ykoord=y;textn("exit",0,nocolor);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,exit1_ope);

 fill_jmptable(&e_table[i++],0,0,0,0,NULL);

 do_edi00_engine(1,e_table);

 b_free(fgbuffer);fgbuffer=0;   
 free_win(1,0);  
 endgraph();
 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 
 return 0;
}


/***************************************************
* display manager of the tool
****************************************************/
int do_edi00_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,k1,set_palette=0;
 unsigned char ch;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize;
 int col11;
 LINE10 *u1;
 char buf1[30];int col2;int pixel,color;


 if(init_engine(maxi)) return 1;

 while(1) {
  do {
   oldX=X;oldY=Y;
   if(!request_flag) { 
    command=do_operations();
   }
   else {
    readmouse(&buttons,&X,&Y);
    
    if(buttons==1 && Y<Y__max-45)
    {
      ;
    }
    break;         	
   }
   if(command==1) {
  
    /* hide the error message window if needed */
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) {
     return 1; /* exit asked */
    }
    delay(100);flush_mouse();buttons=0;
   }
   else if(command== -1) {
     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {

     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){

      exit_vect_ed=0;	
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return 1; /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) {
     vect_ed(buttons,X,Y);
    }     
    else 
    {
      ;
    }
   } 
  } while(!kbhit());
 }
}

/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;
{
 int *chosen;
 LINE10 *u1;
 char **u2;
 FILE *stream,*stream2;
 char ch;
 float tot_a,tot_b,cor_a,cor_b;
 long int start_time,offset,sum;
 int ystart,i,j,len;
 int ssave;char *p;
 char name[40],buf[15];
 HEX_LIST q;
    
 flush_mouse();
 
 switch(id) { /* put here cases */	
  case 1:     /* this is always the error message file window */
   break;
  case 3:  /* this is pop_up menu for starting input_window */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;
   if(chosen[0] == 1) {
    edi11_ope();
    input_window(2,NORMAL_OPERATION);
   } 
   else if(chosen[1]) {
    if (wd_object[1].type==FREE_OBJ) {
     message1(First_open_a_file,0);
     return 0;
    }
    if(!strcmp(u1[2].name,"hex")) {
     /* u1[1].name is in ascii but in hex format */
     for(i=0,j=0;i<strlen(u1[1].name);i+=2,j++) {
      buf[j]=(from_hex_form(u1[1].name[i]))<<4;
      buf[j]+=from_hex_form(u1[1].name[i+1]);
     }
    }
    else if(!strcmp(u1[2].name,"ascii")) {
     /* u1[1].name is in ascii */
     j=strlen(u1[1].name);
    }
    /* j is the length of the search data */
    offset=0;
    stream=fopen(u1[0].name,"rb");
    if(!stream) {cannot_find_file(u1[0].name);return 0;}
    while(1) 
    {
     len=fread(name,1,40,stream);
     if(!len) break;
     offset+=len;
     for(i=0;i<20;i++) {
      if(!memcmp(name+i,buf,j)) {
       message1(Found_one_at,offset);
       if(!lines_exist) wd_object[1].ystart=offset/29;
       else {
        rewind(stream);
	stream2=fopen("lines.txt","rb");
        sum=0;wd_object[1].ystart=0;
        while(1) {
	 fread(buf,1,2,stream2);
         len=(int)buf[0];
         /*
         fread(name,1,(size_t)len,stream);
         q.len=len;
         convert_to_hex(len,name,&q,0);
         printf("sum=%d line=%s\n",sum,q.data);
         printf("ystart=%d\n",wd_object[1].ystart);
         getchar();
         */
         sum+=len;
         if(sum>=offset) break;
         wd_object[1].ystart++;
        }
        fclose(stream2);        
       }
       if(wd_object[1].ystart>0) wd_object[1].ystart--;
       fclose(stream);
       if(wd_object[1].options&NO_BRING_TO_TOP)
         wd_object[1].options ^=NO_BRING_TO_TOP;    
       input_window(2,REFRESH);
       return 0;
      }
     }
     /* we go forward 40 bytes and every time back 20 bytes and recheck */
     /* so that the match is never missed by being in the buffer boundary */
     offset-=20;
     fseek(stream,offset,0);
    }
    message1(Did_not_find,0);
   }
   break;
  default:
   return edi2_operations(id);
   break;
 }
 return(0);
} 

/**********************************************/
/* convert character to 3 bytes of hex        */
/* 0x8f-> '8''f'' ' but  0x31 -> '"''1''"'    */
/* returns the number of converted characters */
int convert_to_hex(num1,line,p1,ascii)
int num1;char *line;HEX_LIST *p1;int ascii;
{
  int num,i,hex,hex2;unsigned char *p;

 if(num1<p1->len) num=num1;else num=p1->len;
 p=p1->data;

 for(i=0;i<num;i++) {
  hex=line[i];
  if(ascii && hex>=0x20 && hex<=0x7e) {
   *p='"';p++;
   *p=line[i];p++;
   *p='"';p++;   
   *p=0;
  }
  else {
   hex2=0x0f&(hex>>4);
   *p=(char)hex_form(hex2);p++;
   hex2=0x0f&hex;
   *p=(char)hex_form(hex2);p++;
   *p=' ';p++;
   *p=0;
  }
 }
 return num;
}
/* inverse of convert_to_hex */
int convert_to_bin(line,p)
char *line,*p;
{
 int len,i,j,hex,hex2;

 len=strlen(p);

 for(i=0,j=0;i<len;i+=3,j++) {
  hex=from_hex_form(p[i]);
  if(hex==-1) {
   line[j]=p[i+1];           /* character is in ascii */
  }
  else {                     /* character is in hex   */
   hex2=from_hex_form(p[i+1]);
   line[j]=(hex<<4)|hex2;
  } 
 }
 return len;
}

int hex_form(hex) int hex;
{
 if(hex<10) hex+=0x30; /* 0x30='0' ... 0x39='9' */
 else if (hex==10) hex=(int)'a'; 
 else if (hex==11) hex=(int)'b'; 
 else if (hex==12) hex=(int)'c';
 else if (hex==13) hex=(int)'d';
 else if (hex==14) hex=(int)'e'; 
 else if (hex==15) hex=(int)'f';
 return hex;   
}


int from_hex_form(ch) char ch; 
{
 int hex;
 if((int)ch>=0x30 && (int)ch<=0x39) hex=(int)ch-0x30;
 else if(ch=='a' || ch=='A') hex=10;
 else if(ch=='b' || ch=='B') hex=11;
 else if(ch=='c' || ch=='C') hex=12;
 else if(ch=='d' || ch=='D') hex=13;
 else if(ch=='e' || ch=='E') hex=14;
 else if(ch=='f' || ch=='F') hex=15;
 else hex= -1;
 return hex;   
}

int show_one_line(p,xcur,ycur,max,col1,col2,changed,lines_changed,off)
HEX_LIST *p;
int xcur,ycur;
int max;
int col1,col2;int *changed,*lines_changed;int off;
{
 int j,k,j1,Xmax,len;int oldj,lim,hex;
 char ch,*buf,*buf1;
 char cursor[8]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};

 /*
 printf("coming to show_one_line p->data+off=%s\n",p->data+off);
 if(-3*(0x7f&p->indent)+off>=0) {
  buf=p->data-3*(0x7f&p->indent)+off;
  xkoord=xcur;ykoord=ycur;
  clearwin(xkoord,ykoord,xkoord+50,ykoord+cr,14);
  textn(buf,4,14);
 }
 */


 lim=strlen(p->data)+3*(0x7f&p->indent);

 j=1;oldj=-off-1;

 while(j<max)
 {
  if(oldj+off>=0) {
  /* background color cursor */
   drawcursor(xcur+oldj*cs,ycur+ysize-2,col2,1,2,cursor);  
  }
  oldj=j;
  /* red cursor */
  drawcursor(xcur+j*cs,ycur+ysize-2,4,1,2,cursor);
   
  ch=getch();

  if(!ch)
  {
   if(keysym==XK_Left) {  /* arrow left */
    if(j+off>1) j-=3;
    else if(j+off==1) j= -off;
   }
   else {
    if(keysym==XK_Right) {  /* arrow right */
     if(j+off==0)     j=1-off;
     else {
      if(lim>off+j+2) j+=3;
     }
    }
   }      
  }
  else { 
   drawcursor(xcur+oldj*cs,ycur+ysize-2,col2,1,2,cursor);  

   if(ch==(char)27){ /* escape, stop editing */
    return 0;
   }
   else if(ch==(char)13 || ch==(int)9){ 
    /* carriage return or tabulator */
    *lines_changed=(int)ch;
    j=(oldj/3)*3+off;   	
    return j; /* j is relevant for carriage return */
   }
   else if ((int)ch==8) { /* backspace, remove a 3 byte unit */
    /* assuming there is indent */
    if(j+off<3*(0x7f&p->indent)) {
     *lines_changed=8;
     return 0;
    }
    else if(!(0x7f&p->indent) && j+off==0) {
     /* request to remove the line */
     *lines_changed=2;
     return 0;
    }
    /* else remove a 3-byte character */
    j1=(oldj/3)*3; /* j1 is on 3-byte boundary, usually one smaller than j */
    /* p->data normally starts at xcur, but can be shifted by p->indent    */
    /* off is the letter where the mouse pointed when coming here          */
    /* j1 is the value of the current cursor place in letter widths        */
    /* so the 3-byte that is pointed at is buf                             */
    buf=p->data-3*(0x7f&p->indent)+off+j1;
    len=strlen(buf);
    for(k=0,buf1=buf;k<=len-6;k+=3,buf1+=3) {
     *(buf1)  =*(buf1+3);
     *(buf1+1)=*(buf1+4);
     *(buf1+2)=*(buf1+5);
    }
    buf=p->data-3*(0x7f&p->indent)+off+j1;
    buf[len-3]=0;
    /* xcur points at the mouse position, corresponds to off */
    /* now we are at j1+off position                         */
    xkoord=xcur+j1*cs;ykoord=ycur;
    clearwin(xkoord,ykoord,xkoord+50,ykoord+cr,14);
    textn(buf,0,nocolor);
    /* the last 3-byte of the line is at the following position */
    xkoord=xcur+(j1+len-3)*cs;ykoord=ycur;
    textn("   ",0,nocolor);
    *changed=1;
    *lines_changed=-1;
    return 0;
   }
   else if((int)ch>=20 && (int)ch<=0x7e) {
    if(j+off<3*(0x7f&p->indent)) return 0; /* indent area, do nothing */ 
    /* printable keyhits, insert a 3 byte unit */
    j1=(oldj/3)*3;   	
    buf=p->data-3*(0x7f&p->indent)+off+j1;
    len=strlen(buf);
    if(len+off+j1+3>=max) return 0; /* can't insert, no place */
    for(k=len,buf1=buf+len;k>0;k-=3,buf1-=3) {
     *(buf1)  =*(buf1-3);
     *(buf1+1)=*(buf1-2);
     *(buf1+2)=*(buf1-1);
    }
    buf[len+3]=0;
    drawcursor(xcur+(j1+1)*cs,ycur+ysize-2,4,1,2,cursor);
    hex=from_hex_form(ch);
    buf=p->data-3*(0x7f&p->indent)+off;
    if(hex== -1){
     ch='"';     
     buf[j1]=ch;j1++; /* separator */
     ch=getch();
     drawcursor(xcur+(j1+1)*cs,ycur+ysize-2,col2,1,2,cursor);
     buf[j1]=ch;j1++; /* ascii character */
     ch='"';
     buf[j1]=ch;j1++; /* separator */
    }
    else {
     buf[j1]=ch;j1++;  /* first hex symbol */
     ch=getch();
     buf[j1]=ch;j1++;  /* second hex symbol */
     drawcursor(xcur+(j1+1)*cs,ycur+ysize-2,col2,1,2,cursor);
     ch=' ';
     buf[j1]=ch;j1++;  /* space separator */
    }
    xkoord=xcur;ykoord=ycur;    
    textn(buf,0,nocolor);
    *changed=1;
    *lines_changed=1;
    return 0;
   }
  }
 }
 return 0;
}

/******************************************/
int message1(id,offset) int id;long offset;
{
 char ch;char line[40];
 int saveysize;char *buf;long bufsize;int clength,isize;

 if(!remove_current_errormsg()) return 0;  
 while(1) { if(kbhit()) getch(); else break;}
 wd_object[0].xstart=0;
 wd_object[0].ystart=id;
 wd_object[0].col1=4;   	  
 wd_object[0].savexsize=wd_object[0].xsize;
 wd_object[0].xsize=40*cs;
 wd_object[0].xcord=400;
 wd_object[0].ycord=Y__max-4*cs-3*cr;


 if(id==First_open_a_file || id==Did_not_find)  {
  if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return 0;
  xkoord=wd_object[0].xcord+2*cs;
  ykoord=wd_object[0].ycord+2*cs+cr;
  textn("(press any key to continue)",0,15); 
 }
 else if(id==Found_one_at) {
  if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return 0;
  strcpy(line,int_to_string(offset));
  strcat(line," bytes. Continue searching?(y/n)");
  xkoord=wd_object[0].xcord+2*cs;
  ykoord=wd_object[0].ycord+2*cs+cr;
  textn(line,0,15);
 }
 else if(id==Help_me) {
  wd_object[0].xsize=60*cs;
  saveysize=wd_object[0].ysize;
  wd_object[0].ysize=2*cs+20*cr;
  clength=wd_object[0].clength;
  isize=wd_object[0].isize;
  wd_object[0].clength=(wd_object[0].xsize/8+1);
  wd_object[0].isize=GPLANES*(wd_object[0].xsize/8+1);
  buf=wd_object[0].background;
  bufsize=(long)wd_object[0].ysize*wd_object[0].isize;
  wd_object[0].background=balloc(bufsize);
  wd_object[0].foreground=fgbuffer;
  wd_object[0].xcord=80;
  wd_object[0].ycord=80;
  if(!wd_object[0].background || !wd_object[0].foreground) 
   {printf("out of memory\n");return 1;}
  if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return 0;
  xkoord=wd_object[0].xcord+2*cs+20*cs;
  ykoord=wd_object[0].ycord+2*cs+19*cr;
  textn("(press any key to continue)",0,15);
  ch=getch();
  wd_object[0].options ^= WINDOW_HIDDEN;
  update_over(1);
  remove_background(1);
  b_free(wd_object[0].background);
  wd_object[0].background=buf;
  wd_object[0].clength=clength;
  wd_object[0].isize=isize;
  wd_object[0].ysize=saveysize;
  wd_object[0].xsize=wd_object[0].savexsize;
  return 0;
 }

 ch=getch();
 if(ch=='n' || ch=='N') {
  xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;
  textn("no ",0,15);       
 }
 
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 wd_object[0].xsize=wd_object[0].savexsize;
 wd_object[0].col1=4;   	          
 if(ch=='n' || ch=='N') return 0;
 else return 1;	
}
