/*******************************************
* IMAGE_EDITOR.C   2-dimensional picture editor
* Author:     	Jorma Jormakka
* Date:   	Feb.2017
********************************************/
#include <string.h>
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "pmenus.ext"
/* the following directions mus circulate */
#define UtoD   0
#define URtoLD 1
#define RtoL   2
#define DRtoLU 3
#define DtoU   4
#define LDtoUR 5
#define LtoR   6
#define LUtoDR 7
#define CODE_LIKE_ROXIO 1
int garbled=0;
JMPTABLE e_table[20];
extern int vobjmode;
extern int colorZ;
extern int nocolor,pensize;
extern XColor *xcolor;
extern XColor *xcolor2;
extern VECTOR_OBJECT *cvobj,*firstvobj,*lastvobj;
extern VECTOR_OBJECT *create_vector_obj();
extern FILE *open_eps(); 
extern void draw_vobj();
extern int xxmin,yymin,xxmax,yymax;
extern oldX,oldY;
int exit_vect_ed=1;
int debug=0;
int oldertest=0;
int oldtest=0;
int curtest=0;
extern int set_mask;
extern Display *display;
extern Colormap colormap;
extern Drawable win;
extern GC gc;
extern XImage *screenbuf;

extern int dbug;
extern int ykoor;
extern int xkoor;
extern unsigned char *resbuf;

#ifdef CODE_LIKE_ROXIO
char interleave[15]={12,12,12,12,12,12,11,12,11,11,11,12,11,7,12};
#else
char interleave[15]={12,12,12,12,12,12,12,12,12,12,12,12,12,2,12};
#endif
/* colors are taken from the 256-color palette xcolor2 */
/* this palette is a list of selected 16 colors shown on the drawbar */
unsigned char palette[16]={0,1,2,3,4,5,7,20,56,57,58,59,60,61,62,63};

extern int palette256_used;

/***************************************************
 * Concerning any fill-routine
 * max=number of u1 fields, pmax=number of u2 fields
 * window= how many u2-lines are shown
 * linelength=max length of u2-line
 * id=identifier of the menu, use a free one
 * x,y= coordinates of the left upper corner
 * xsize,ysize=size of the window
 * col1,col2,col3,col4,col5= colors used in the menu 
 * make also actions and ope-rutine
 ***************************************************/

/*********************************************/
static int cutbuf2_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
  int col,col2,threshold; 
  unsigned long pixel,maskpixel;
  int k,j;
  int xsize,ysize,xcord,ycord,isize,clength;
  char *buf;

 if(chosen[0] & 1) { /* kill cut buffer */
  set_mask=0;
  if(wd_object[5].type!=FREE_OBJ)
  {       
   if_b_opt_bgfromfile(6);
   update_over(6);   
   free_transparent_card(6);       
  }
  free_pop_up_menu(15);  
 }
 else if(chosen[1] & 1) { /* read screen to cutbuffer */
  buttons=2;
  tcard_inside_operations(0,0,0,0,0,0,5);
 }
 else if(chosen[2] & 1) { /* dump cutbuffer to the screen */
  if(!set_mask) {
   buttons=2;
   tcard_inside_operations(0,0,0,0,0,0,5);
  }
  else {

   maskpixel=xcolor[palette[15]].pixel;
   
   xsize=wd_object[5].xsize-1;
   ysize=wd_object[5].ysize-1;
   xcord=wd_object[5].xcord;
   ycord=wd_object[5].ycord;
   clength=wd_object[5].clength;
   isize=wd_object[5].isize;
   buf=malloc(isize*wd_object[5].ylength);
   if(!buf) {printf("no memory\n");return 0;}
   memcpy(buf,wd_object[5].foreground,
     isize*wd_object[5].ylength);   
   free_transparent_card(6);
   for(k=1;k<xsize-1;k++) {
    for(j=1;j<ysize-1;j++) {
     pixel=point_from_fn2b(k,j,clength,isize,buf);
     if(pixel!=maskpixel) {
      drawpixel2b(xcord+k,ycord+j,pixel);
     }
    } 
   }
   free(buf);
  } 
 }
 else if(chosen[3] & 1) { /* set mask to cutbuffer with nocolor */
   set_mask=1;
 }

 return 0; 
}

int fill_cutbuf2_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"Kill cut buffer");
 strcpy(u2[1],"Screen to cut buffer");
 strcpy(u2[2],"Cut buffer to screen");
 strcpy(u2[3],"Set mask, nocolor=pal[15]");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int cutbuf2_ope()
{
 flush_mouse();
 if(wd_object[14].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 set_mask=0; /* you put this on, it will be on until cutbuffer killed */
 fill_cutbuf2_menu(0,4,4,80,15,40*cs,450+3*cr,25*cs,2*cs+5*cr,
  Co1,Co2,Co3,Co4,Co5);

 put_wd_objects(15,15);
 buttons=0;
 return(0);	
}

/*********************************************/
static int edi12_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
  int col,col2,threshold,threshold2;float mag;
  char line[30];

 if(chosen[0] & 1) { /* make black and white */
   sscanf(u1[0].name,"%d",&threshold);
   free_pop_up_menu(16);
   black_and_white();
 }
 else if(chosen[1] & 1) { /* replace color */
   sscanf(u1[1].name,"%d",&col);
   sscanf(u1[2].name,"%d",&col2);
   free_pop_up_menu(16);
   replace_col(col,col2);
 }
 else if(chosen[2] & 1) { /* remove small non-white parts */
   sscanf(u1[3].name,"%d",&threshold);
   sscanf(u1[4].name,"%d",&threshold2);
   free_pop_up_menu(16);
   read_allcolors(5,1.0,threshold,1.0,1.0,threshold2);
 }
 else if(chosen[3] & 1) { /* change to white if under threshold */
   sscanf(u1[5].name,"%f",&mag);
   sscanf(u1[6].name,"%d",&threshold);
   free_pop_up_menu(16);
   read_allcolors(1,mag,threshold,1.0,1.0,0);
 }
 else if(chosen[4] & 1) { /* find lines */
   sscanf(u1[7].name,"%f",&mag); /* treshold for RGB balance */
   sscanf(u1[8].name,"%d",&threshold);
   free_pop_up_menu(16);
   line_finder(mag,threshold);
 }
 else if(chosen[5] & 1) { /* add a figure to a figure */
   strcpy(line,u1[9].name);
   free_pop_up_menu(16);
   loadimage_1(line,3,1.0);

 }
 else if(chosen[6] & 1) { /* remove grid */
   strcpy(line,u1[8].name);
   free_pop_up_menu(16);
   remove_grid();

 }

 return 0; 
}

int fill_edi12_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"To black and white, threshold=");
 strcpy(u2[1],"Change col       to ");
 strcpy(u2[2],"Remove small points xsize=    ysize=");
 strcpy(u2[3],"Remove noise mag=         threshold=  ");
 strcpy(u2[4],"Find lines RGB=        R below=");
 strcpy(u2[5],"Add a picture  ");
 strcpy(u2[6],"Remove grid  ");

 len=strlen("To black and white, threshold=");
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=1;
 u1[0].size=u1[0].bsize=9;
 strcpy(u1[0].name,"14500000");

 len=strlen("Change col ");
 u1[1].xcord=len*cs; 
 u1[1].ycord=1*cr; 
 u1[1].parmax=2;
 u1[1].size=u1[1].bsize=5;
 strcpy(u1[1].name,"15");

 len=strlen("Change col       to ");
 u1[2].xcord=len*cs; 
 u1[2].ycord=1*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=5;
 strcpy(u1[2].name,"6");

 len=strlen("Remove small points xsize=");
 u1[3].xcord=len*cs; 
 u1[3].ycord=2*cr; 
 u1[3].parmax=2;
 u1[3].size=u1[3].bsize=3;
 strcpy(u1[3].name,"1");

 len=strlen("Remove small points xsize=    ysize=");
 u1[4].xcord=len*cs; 
 u1[4].ycord=2*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=3;
 strcpy(u1[4].name,"1");

 len=strlen("Remove noise mag=");
 u1[5].xcord=len*cs; 
 u1[5].ycord=3*cr; 
 u1[5].parmax=2;
 u1[5].size=u1[5].bsize=8;
 strcpy(u1[5].name,"1.0");

 len=strlen("Remove noise mag=         threshold=  ");
 u1[6].xcord=len*cs; 
 u1[6].ycord=3*cr; 
 u1[6].parmax=1;
 u1[6].size=u1[6].bsize=8;
 strcpy(u1[6].name,"213");

 len=strlen("Find lines RGB=");
 u1[7].xcord=len*cs; 
 u1[7].ycord=4*cr; 
 u1[7].parmax=2;
 u1[7].size=u1[7].bsize=4;
 strcpy(u1[7].name,"0.7");

 len=strlen("Find lines RBG=        R below=");
 u1[8].xcord=len*cs; 
 u1[8].ycord=4*cr; 
 u1[8].parmax=1;
 u1[8].size=u1[8].bsize=4;
 strcpy(u1[8].name,"180");

 len=strlen("Add a picture  ");
 u1[9].xcord=len*cs; 
 u1[9].ycord=5*cr; 
 u1[9].parmax=1;
 u1[9].size=u1[9].bsize=8;
 strcpy(u1[9].name,"res3.gif");


 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int edi12_ope()
{
 flush_mouse();
 if(wd_object[15].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_edi12_menu(10,7,7,80,16,20*cs,390+3*cr,45*cs,2*cs+8*cr,
  Co1,Co2,Co3,Co4,Co5);

 put_wd_objects(16,16);
 buttons=0;
 return(0);	
}

/*********************************************/
static int edi11_menu_actions(i,chosen,u1) 
int i;int *chosen;LINE10 *u1;
{
  int threshold;float mag,mag1,mag2;

 if(chosen[0] & 1) { /* adjust red green blue */
   sscanf(u1[0].name,"%f",&mag);
   sscanf(u1[1].name,"%f",&mag1);
   sscanf(u1[2].name,"%f",&mag2);
   free_pop_up_menu(12);
   read_allcolors(3,mag,0,mag1,mag2,0);
 }
 else if(chosen[1] & 1) { /* more contrast */
   sscanf(u1[3].name,"%f",&mag);
   sscanf(u1[4].name,"%d",&threshold);
   free_pop_up_menu(12);
   read_allcolors(4,mag,threshold,1.0,1.0,0);
 }
 else if(chosen[2] & 1) { /* less contrast */
   sscanf(u1[5].name,"%f",&mag);
   sscanf(u1[6].name,"%d",&threshold);
   free_pop_up_menu(12);
   read_allcolors(4,mag,threshold,1.0,1.0,0);
 }
 else if(chosen[3] & 1) { /* make lighter */
   sscanf(u1[7].name,"%f",&mag);
   free_pop_up_menu(12);
   read_allcolors(2,mag,0,1.0,1.0,0);
 }
 else if(chosen[4] & 1) { /* make darkes */
   sscanf(u1[8].name,"%f",&mag);
   free_pop_up_menu(12);
   read_allcolors(2,mag,0,1.0,1.0,0);
 }

 return 0; 
}

int fill_edi11_menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 int len;
 
 if(id<0) return(1);

 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return(-1);
 }

 strcpy(u2[0],"Red=     green=      blue= ");
 strcpy(u2[1],"More contrast        threshold=");
 strcpy(u2[2],"Less contrast        threshold=");
 strcpy(u2[3],"Make lighter  ");
 strcpy(u2[4],"Make darker   ");

 len=strlen("Red= ");
 u1[0].xcord=len*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=3;
 u1[0].size=u1[0].bsize=4;
 strcpy(u1[0].name,"1.0");

 len=strlen("Red=     green=");
 u1[1].xcord=len*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=2;
 u1[1].size=u1[1].bsize=4;
 strcpy(u1[1].name,"1.0");

 len=strlen("Red=     green=      blue= ");
 u1[2].xcord=len*cs; 
 u1[2].ycord=0*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=4;
 strcpy(u1[2].name,"1.0");

 len=strlen("More contrast ");
 u1[3].xcord=len*cs; 
 u1[3].ycord=1*cr; 
 u1[3].parmax=2;
 u1[3].size=u1[3].bsize=5;
 strcpy(u1[3].name,"0.001");

 len=strlen("More contrast        threshold=");
 u1[4].xcord=len*cs; 
 u1[4].ycord=1*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=5;
 strcpy(u1[4].name,"200");

 len=strlen("Less contrast ");
 u1[5].xcord=len*cs; 
 u1[5].ycord=2*cr; 
 u1[5].parmax=2;
 u1[5].size=u1[4].bsize=5;
 strcpy(u1[5].name,"-0.001");

 len=strlen("Less contrast        threshold=");
 u1[6].xcord=len*cs; 
 u1[6].ycord=2*cr; 
 u1[6].parmax=1;
 u1[6].size=u1[6].bsize=5;
 strcpy(u1[6].name,"0.95");

 len=strlen("Make lighter mag=");
 u1[7].xcord=len*cs; 
 u1[7].ycord=3*cr; 
 u1[7].parmax=1;
 u1[7].size=u1[7].bsize=8;
 strcpy(u1[7].name,"1.05");

 len=strlen("Make darker  mag=");
 u1[8].xcord=len*cs; 
 u1[8].ycord=4*cr; 
 u1[8].parmax=1;
 u1[8].size=u1[8].bsize=8;
 strcpy(u1[8].name,"0.95");


 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);

 wd_object[id-1].options |= NO_ICONIZING;
 return(0);
}

/**********************/
int edi11_ope()
{
 flush_mouse();
 if(wd_object[11].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_edi11_menu(9,5,5,80,12,20*cs,410+3*cr,45*cs,2*cs+6*cr,
  Co1,Co2,Co3,Co4,Co5);

 put_wd_objects(12,12);
 buttons=0;
 return(0);	
}

/**********************/
int edi10_ope()
{
 flush_mouse();
 if(wd_object[1].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_editor1menu(11,7,7,50,2,7*cs,400,60*cs,3*cs+7*cr,Co1,Co2,Co3,Co4,Co5); 

 put_wd_objects(2,2);
 buttons=0;
 return(0);	
}
/*****************************************/
int main(argc,argv) int argc; char **argv;
{
 int i;

 defaultfont=2;
 xxmin=0;yymin=0;xxmax=773;yymax=559;
 if(init_font(defaultfont)) 
 {printf("problems in loading font\n");getch();return 1;} 
 if(init_font2(6)) 
 {printf("problems in loading font\n");getch();return 1;}   
 if(initPool(0,0,0,0)) return 0;

 /* create and map a window in X11 */
 initgraph(argc,argv); 

 term=I86;lg=ENGL;plg=FINN | POLI;bgcol=1;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 firstvobj=lastvobj=cvobj=0;vobjmode=0; 
 nocolor=15;pensize=0;
 xxmin=0;xxmax=880;yymin=0;yymax=Y__max;
 for(i=0;i<16;i++) setVGApalette(i,(int)palette[i]); 

 editor();

 endgraph();
 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 return 0;
}
/************************************************
*   editor()
*************************************************/ 
int editor()
{
 int i,k,x,y,xsize,ysize;
 long int pixel;

 if(init_win(0,15)) return 1;
 fgbuffer=(char *)malloc(FGSIZE);if(!fgbuffer) return 1;
 bgbuffer=(char *)malloc(FGSIZE);if(!bgbuffer) return 1;
 if(initPool(1,1200*cr,0,0)) return(1);
 xcolor2=&xcolor[21]; /* this is used in readgif and readpcx */

 clearwin(0,0,X__max,Y__max,nocolor);

 /******************************/
 /* demo show on figure 4 
  loadimage_0("fig4b.gif",3,1.0);
  getchar(); 
  loadimage_0("fig4c.gif",3,1.0);
  getchar(); 
  loadimage_0("fig4d.gif",3,1.0); 
  getchar();
  loadimage_0("augustus_fig1.gif",3,1.0);
  getchar();
 */

 /*
 loadimage_0("fig4b.gif",3,1.0);
  write_avi("testavi.avi",0,0,320,240,1.0);
 */
 /*
 diffe_avi();
 */
 /*
 analyse2("testavi.avi",320,240,1.0);
 */

 /*
 pixel=xcolor[0].pixel;
 for(i=0;i<773;i++) drawpixel2b(i,110,pixel);
 */

 /*  loadimage_0("figure4.gif",3,1.0); */
 /*  loadimage_1("res3.gif",3,1.0); */ 

 /* put color bars for 256 and 16 color palettes */

 for(i=0;i<64;i++) {
  for(k=0;k<4;k++) {
   pixel=xcolor2[i+64*k].pixel;
   fillbox2(i*10,560+k*10,10,10,pixel);
  }
 }
 getdrawbar(780); 
 for(k=0;k<16;k++) {
  pixel=xcolor[k].pixel;
  fillbox2(LIMDBAR1,k*20,20,20,pixel);
  palette[k]=k;
 } 
 nocolor=palette[15];

 /* put icons */
 i=0;

 y=Y__max-79;
 x=X__max-29;
 getpicture("queue.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi12_ope);

 y=Y__max-53;
 x=X__max-29;
 getpicture("nodeic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi11_ope);

 y=Y__max-27;
 x=X__max-29;
 getpicture("start.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi10_ope);


 fill_jmptable(&e_table[i++],0,0,0,0,NULL);
 
 do_edi1_engine(1,e_table);


/* savedrawbar();*/
 return(free_win(1,0));  
}
/***************************************************
* display manager of the editor
****************************************************/
int do_edi1_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,set_palette=0;
 unsigned char ch;
 int color_area_flag=0;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize,color;

 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   oldX=X;oldY=Y;
   
   command=do_operations();
   if(command==1) {
    pensize=0;
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) return(1); /* exit asked */
   }
   else if(command== -1) {

     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {
     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){
       exit_vect_ed=1;	/* was 0 */
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return(1); /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) vect_ed(buttons,X,Y);     
    else {
     if(X<LIMDBAR1 && Y<560) {
      if(color_area_flag) {
       color_area_flag=0;
       flood_fill(X,Y,colorZ,0,0,LIMDBAR1,Y__max);
      }
      else {
       if(use_marker) marker(X,Y,CUROFF,3,3);
       else {
        if(X>oldX) X=oldX+(pensize<X-oldX?pensize:X-oldX);
        else X=oldX-(pensize<oldX-X?pensize:oldX-X);
        if(Y>oldY) Y=oldY+(pensize<Y-oldY?pensize:Y-oldY);
        else Y=oldY-(pensize<oldY-Y?pensize:oldY-Y);
       }

       fillbox(X,Y,pensize,pensize,colorZ);
       if(use_marker) marker(X,Y,CURON,3,3);      
      }
     }
     else {
      if(use_marker) {marker(X,Y,CUROFF,3,3);use_marker=0;pensize=oldpensize;}
      if(Y<320) {
	/* we do not use this palette */
       color=Y/20;
       if(!pensize) pensize=1;     	
       colorZ=palette[color];
       if(set_palette) {	
        k=palette[color];
        printf("starting with k=%d\n",k);
        while(1) {       
         ch=getch();
         if('y'==ch || 'Y'==ch) break;
         else if ('?'==ch) {
          X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;
          xkoord=LIMDBAR1+8;ykoord=color*20+3;
          textXYf(xkoord,&ykoord,int_to_string((long)k),0,15);         	
	  /* ch=getch();*/
          fillbox(LIMDBAR1,color*20,20,20,colorZ);
          palette[color]=colorZ;  
          /* if('y'==ch || 'Y'==ch) break; */

         }
         else {
          k++;if(k==256) k=0;
          fillbox(LIMDBAR1,color*20,20,20,k);        	
         }
         palette[color]=k;        	
         colorZ=k;
        }
        set_palette=0;              
       }
      }
      else if (Y<340) {	colorZ=nocolor;oldpensize=pensize;
     			pensize=10;use_marker=1;marker(590,340,CURON,3,3);}
      else if (Y<360) color_area_flag=1;
      else if (Y<380) {
       fill_pensizemenu(0,5,5,20,5,61*cs,360,15*cs,3*cs+5*cr,Co1,Co2,Co3,Co4,Co5);
       chosen=(int *)wd_object[4].p3;      
       u2=(char **)wd_object[4].p2;
       for(i=0;i<5;i++) {
        strcpy(line,u2[i]);line[7]=0; 	
        if(pensize==string_to_int(&line[5])) {chosen[i] |= 1;break;}
       }      
       if(pull_down(5)) return(1);
       edi1_operations(5);free_pop_up_menu(5);
      }
      else if (Y<400) {
       while(kbhit()) getch(); /* flush input */
       change_palette_info();
       set_palette=1;
      }     
      else if (Y<420) {
       if(wd_object[2].type==FREE_OBJ) {
        make_transparent_card(3,10,10,"lense.xxx",34,34,1);
        make_pixel_draw(4,35*cs,298,11+32*5+4,11+32*5+4, 4,1,"largened.xxx",3);        
        put_wd_objects(3,4);
        wd_object[3].options |=MOVE_AS_RECTANGLE; 
       }
      }     
      else if (Y<440) {
       if(wd_object[5].type==FREE_OBJ) {     	
        make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);     	       put_wd_objects(6,6);
       }      
       cutbuf2_ope();
      }      
      else if (Y<460) { /* replace color in cut buffer */
       if(wd_object[5].type==FREE_OBJ) {
        make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);     	       put_wd_objects(6,6);
        buttons=2;
        tcard_inside_operations(0,0,0,0,0,0,5);
        cutbuf2_ope();
       }       
       fill_chgcolormen(2,1,1,30,9,35*cs,420,40*cs,3*cs+1*cr,Co1,Co2,Co3,Co4,Co5);
       put_wd_objects(9,9);
      }
      else if (Y<480) { /* match pattern */
       if(wd_object[5].type==FREE_OBJ) {
        make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);     	       put_wd_objects(6,6);
        buttons=2;
        tcard_inside_operations(0,0,0,0,0,0,5);
        cutbuf2_ope();
       }       

       if(wd_object[9].type==FREE_OBJ) {
         make_replace_buffer(10,35*cs,298,3*cs+30*5+2,3*cs+30*5+2,7,0,"replace.xxx",6);
        put_wd_objects(10,10);
        
       }
      }

      else if(Y>559 && X<640) 
      {
       /* this is the 256 color palette, xcolor2 */
       if(!pensize) pensize=1;     	
       k=(Y-560)/10;
       i=X/10;
       colorZ=i+k*64+21;
       X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;
       xkoord=645;ykoord=560;
       fillbox2(xkoord,ykoord,3*cs,cr,xcolor[15].pixel);
       textXYf(xkoord,&ykoord,int_to_string((long)colorZ),0,15);         	
      }
     }     
    }
   }
  } while(!kbhit());
 }
}
/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;

{
 int i,j,k,i1,m,n,x,y,color;
 int *chosen,class,col1,col2;
 LINE10 *u1;
 char **u2,*pp;
 FILE *stream;
 char line[30];
 char buf[30];
 unsigned char *tmpplane;
 int x2,y2,isize,xstart,ystart,width,height;
 float magn;
 unsigned long pixel;
 
 switch(id) {

  case 2:	/* edi1 menu */	
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   if(chosen[0] == 1) { /* quit */
    free_wd_objects();
    return(1); /* exit */	
   }
   else if(chosen[1] == 1) { /* read picture */
    x2=LIMDBAR1;y2=180;isize=308; 
    pp=(char *)strchr(u1[0].name,(int)'.');
    if(pp && strcmp(pp,".pcx")) {
      if(!strcmp(pp,".gif")) {
       strcpy(line,u1[0].name);
       sscanf(u1[1].name,"%f",&magn);
       free_pop_up_menu(2);
       loadimage_0(line,3,(double)magn);
       if(palette256_used) {
        for(i1=0;i1<64;i1++) {
         for(k=0;k<4;k++) {
          pixel=xcolor2[i1+64*k].pixel;
          fillbox2(i1*10,560+k*10,10,10,pixel);
	 }
        }
       }
       else { /* write a black palette */
        for(i1=0;i1<64;i1++) {
         for(k=0;k<4;k++) {
          fillbox2(i1*10,560+k*10,10,10,xcolor[0].pixel);
	 }
        }
       }
       return 0;
      }
      else {
       strcpy(line,u1[0].name);
       free_pop_up_menu(2);
       printf("not supported yet\n");
       return 0;
      }
    }
    else if(pp && !strcmp(pp,".pcx")) {
     strcpy(line,u1[0].name);
     free_pop_up_menu(2);
     restore_screen(line);
     return 0;
    }
   }
   else if(chosen[2] == 1) { /* save picture */
    pp=(char *)strchr(u1[2].name,(int)'.');
    if(pp && strcmp(pp,".pcx")) {
     if(!strcmp(pp,".gif")) {
      sscanf(u1[3].name,"%d",&xstart);
      sscanf(u1[4].name,"%d",&ystart);
      strcpy(line,u1[2].name);
      free_pop_up_menu(2);
      redo_palette();
      writeGIF1(line,xstart,ystart,773,558);
     }
     else {
      strcpy(line,u1[1].name);
      free_pop_up_menu(2);
      if(save_picture(line,0,0,LIMDBAR1,180,308,palette)) return(0);
     }
    }
    else if(pp && !strcmp(pp,".pcx")) {
     strcpy(line,u1[2].name);
     free_pop_up_menu(2);
     save_as_pcxfile(0,0,LIMDBAR1,180,line); return 0;
    }
    return 0;
   }
   else if(chosen[3] & 1) { /* call cut buffer menu */
    fill_cutbuffermenu(2,3,3,20,8,
   	 wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	30*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5);
    if(pull_down(8)) return(1);
    edi1_operations(8);
    free_pop_up_menu(8);    
    free_pop_up_menu(2);    
    return 0;
   }   
   else if(chosen[4] & 1) { /* list files menu */   
    list_files(u1[5].name,11,
    	wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	30,5, Co1,Co2,Co3,Co4,Co5);
    free_pop_up_menu(2);       
    return 0;
   }
   else if(chosen[5] & 1) { /* clear screen */   
    free_pop_up_menu(2);
    clearwin(0,0,773,559,nocolor);
    return 0;       
   }
   else if(chosen[6] & 1) { /* write 6.48 sec avi clip */   
    free_pop_up_menu(2);
    sscanf(u1[6].name,"%d",&xstart);
    sscanf(u1[7].name,"%d",&ystart);   
    if(!strcmp(u1[8].name,"722x434")) {width=772;height=434;}
    else if(!strcmp(u1[8].name,"320x240")) {width=320;height=240;}
    else if(!strcmp(u1[8].name,"640x480")) {width=640;height=480;}
    else {width=320;height=240;} /* these are always good values */
    sscanf(u1[9].name,"%f",&magn);
    write_avi(u1[10].name,xstart,ystart,width,height,magn);
    return 0;       
   }
   break;

  case 5: /* pensize menu */  
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;
      
   for(i=0;i<5;i++) {
    if(chosen[i]&1) {
     strcpy(line,u2[i]);line[7]=0;
     pensize=string_to_int(&line[5]);break;}
   }
   break;
   

  case 8: /* cut buffer menu */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
 
   j=6;/* cut buffer identifier THIS Id IS RESERVED */  

   if(chosen[0] & 1) { /* kill cut buffer */
    set_mask=0;
    if(wd_object[j-1].type!=FREE_OBJ)
    {       
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
   }
   else if (chosen[1] & 1) { /* save cut buffer */
    j--;
    if(wd_object[j].type==FREE_OBJ) no_cutbuffer();
    else {        
     if(save_picture(u1[0].name,
    	wd_object[j].xcord+1,wd_object[j].ycord+1,
    	wd_object[j].xcord+wd_object[j].xsize-1,
        wd_object[j].ycord+wd_object[j].ysize-1,
        wd_object[j].isize,palette)) return(1);   
    }
   }
   else if(chosen[2] == 1) { /* read cut buffer */
    j--;
    if(wd_object[j-1].type!=FREE_OBJ)
    { 
     x=wd_object[j].xcord;
     y=wd_object[j].ycord;          
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
    else x=100;y=100;
       
    x2=250;y2=250; 	    
    if(get_picture(u1[1].name,x+1,y+1,
      &x2,&y2,&isize,palette)) return(1);
      
    make_transparent_card(j+1,x,y,"cutbuffer.xxx",x2-x,y2-y,0);     	
    wd_object[j].i1=0;         
    put_wd_objects(j+1,j+1);
               
    save_buf2(wd_object[j].xcord,wd_object[j].ycord,1,1,
  	wd_object[j].xsize-1,wd_object[j].ysize-1,wd_object[j].xcord&7,
  	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);
   }
   break;      

  case 9: /* change color in cut buffer menu */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   j=6; /* cut buffer identifier */   
   col1=string_to_int(u1[0].name);col2=string_to_int(u1[1].name);
   if(col1!=col2)
    change_color(col1,col2,
        	wd_object[j-1].xcord,wd_object[j-1].ycord,
        	wd_object[j-1].xsize,wd_object[j-1].ysize,
        	wd_object[j-1].clength,wd_object[j-1].isize,
        	wd_object[j-1].foreground);
   break;  
 
  case 10: /* replace buffer */
   j=wd_object[id-1].i1-1; /* cut buffer id -1 */
   wd_object[j].i1=0;      
   for(m=1;m<wd_object[j].xsize-1;m++) {
    for(n=1;n<wd_object[j].ysize-1;n++) { 
     if(match_replacebuffer(wd_object[j].foreground,wd_object[id-1].p1,
         	m,n,wd_object[j].clength,wd_object[j].isize,9))
     {
      replace(wd_object[j].foreground,(char *)wd_object[id-1].p2,
         	m,n,wd_object[j].clength,wd_object[j].isize,9,j);
     }         
    }
   }
   break;

 case 12: /* photographic actions */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;
   edi11_menu_actions(id-1,chosen,u1);
   break;

 case 15: /* cutbuffer was so hard to use, so I added a menu for it */
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;   
   cutbuf2_menu_actions(id-1,chosen,u1);
   break;

 case 16: /* special effects */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;
   edi12_menu_actions(id-1,chosen,u1);
   break; 

 }
 return(0);
} 
int fill_editor1menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Quit ");
 strcpy(u2[1],"Load picture             magn=");
 strcpy(u2[2],"Save picture             xstart=      ystart=");
 strcpy(u2[3],"Cut buffer menu "); 
 strcpy(u2[4],"List          files");
 strcpy(u2[5],"Clear screen ");     
 strcpy(u2[6],"Make AVI x1=   y1=   res=        mag=     name=");

 u1[0].xcord=13*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=2;
 u1[0].size=u1[0].bsize=12;
 strcpy(u1[0].name,"");

 u1[1].xcord=30*cs; 
 u1[1].ycord=1*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=8;
 strcpy(u1[1].name,"1.0");
 
 u1[2].xcord=13*cs; 
 u1[2].ycord=2*cr; 
 u1[2].parmax=3;
 u1[2].size=u1[2].bsize=12;
 strcpy(u1[2].name,""); 

 u1[3].xcord=32*cs; 
 u1[3].ycord=2*cr; 
 u1[3].parmax=2;
 u1[3].size=u1[3].bsize=5;
 strcpy(u1[3].name,"0"); 

 u1[4].xcord=45*cs; 
 u1[4].ycord=2*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=5;
 strcpy(u1[4].name,"0"); 

 u1[5].xcord=strlen("List ")*cs; 
 u1[5].ycord=4*cr; 
 u1[5].parmax=1; 
 u1[5].size= u1[5].bsize=8;
 strcpy(u1[5].name,"*.gif"); 

 u1[6].xcord=strlen("Make AVI x1=")*cs; 
 u1[6].ycord=6*cr; 
 u1[6].parmax=5; 
 u1[6].size= u1[6].bsize=3;
 strcpy(u1[6].name,"0"); 

 u1[7].xcord=strlen("Make AVI x1=   y1=")*cs;     
 u1[7].ycord=6*cr; 
 u1[7].parmax=4; 
 u1[7].size= u1[7].bsize=3;
 strcpy(u1[7].name,"0"); 

 u1[8].xcord=strlen("Make AVI x1=   y1=   res=")*cs;
 u1[8].ycord=6*cr; 
 u1[8].parmax=3; 
 u1[8].size= u1[8].bsize=8;
 strcpy(u1[8].name,"722x434"); 

 u1[9].xcord= strlen("Make AVI x1=   y1=   res=        mag=")*cs;
 u1[9].ycord=6*cr; 
 u1[9].parmax=2; 
 u1[9].size= u1[9].bsize=5;
 strcpy(u1[9].name,"1.05"); 

 u1[10].xcord=strlen("Make AVI x1=   y1=   res=        mag=     name=")*cs;
 u1[10].ycord=6*cr; 
 u1[10].parmax=1; 
 u1[10].size= u1[9].bsize=10;
 strcpy(u1[10].name,"graph.avi"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}

int fill_chgcolormen(max,pmax,window,linelength,id,x,y,xsize,ysize,
 col1,col2,col3,col4,col5)
int max,pmax,window,linelength,id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Change color    to    in Cutbuffer");
 
 u1[0].xcord=13*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].bsize=u1[0].size=2; 
 strcpy(u1[0].name,"1");
 
 u1[1].xcord=19*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].bsize=u1[1].size=2; 
 strcpy(u1[1].name,"1"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}

int exit1_ope()
{
 exit_vect_ed=1;
 return 0;	
}

int black_and_white()
{
 int x,y; unsigned long pix;

 for (x=0;x<773;x++) {
  for (y=0;y<559;y++) {
   pix=getpixel2c(x,y);
   if(almost_white(pix)) pix=xcolor[15].pixel;
   else pix=xcolor[0].pixel;
   drawpixel2c(x,y,(int)pix);
  }
 }
 XPutImage(display,win,gc,screenbuf,0,0,0,0,773,559);
}

int almost_white(pix) unsigned long pix;
{
 int col,col1,col2;


 if(pix>14500000L) return 1; else return 0;
}

int black_to_col(col) int col;
{
 int x,y; unsigned int pix,pix2;

 pix2=xcolor[col].pixel;
 for (x=0;x<773;x++) {
  for (y=0;y<559;y++) {
   pix=getpixel2c(x,y);
   if(pix==xcolor[0].pixel) drawpixel2c(x,y,(int)pix2);
  }
 }
 XPutImage(display,win,gc,screenbuf,0,0,0,0,773,559);
}
int replace_col(col,col2) int col,col2;
{
 int x,y; unsigned int pix,pix2;

 pix2=xcolor[col2].pixel;
 for (x=0;x<773;x++) {
  for (y=0;y<559;y++) {
   pix=getpixel2c(x,y);
   if(pix==xcolor[col].pixel) drawpixel2c(x,y,(int)pix2);
  }
 }
 XPutImage(display,win,gc,screenbuf,0,0,0,0,773,559);
}

int scanbinary(char *line,int n,int i)
{
 unsigned long int k;
 
 *line=0;

 if (i==32) {
  for(i--;i>=0;i--) {
   k= (1<<i);
   if(k&n) strcat(line,"1");
   else strcat(line,"0");
  }
 }
 return 0;
}


loadimage_1(name,clarity,magn) char *name;int clarity;double magn;
{
  int wWidth,wHeight;char *p;int xshift;

 p=strchr(name,(int)'.');
 if(p && !strcmp(p,".gif")) {

  free_palette256();
  wWidth=773;wHeight=559;
  if(read_and_mixGIF(name,&wWidth,&wHeight,clarity,magn,1)) {
   palette256_used=1;
   redo_palette(); 
  }
 } 
}



int read_allcolors(ope,mag,threshold,mag1,mag2,threshold2) 
     int ope;float mag;int threshold;float mag1,mag2;int threshold2;
{
 int k,j;

 /*
 while(kbhit()) getch();
 flush_mouse();
 */

 for(k=0;k<560;k++) {
  for(j=0;j<773;j++) {
   read_colors(j,k,ope,mag,threshold,mag1,mag2,threshold2);
  }
 }
 XPutImage(display,win,gc,screenbuf,0,0,0,0,773,559);
 return 0;
}

int read_colors(x,y,ope,mag,threshold,mag1,mag2,threshold2) 
     int x,y,ope;float mag;int threshold;float mag1,mag2;int threshold2;
{
  int i,j,k;
 XColor c;
 unsigned long pixel,pix,pix2;
 int red,green,blue;
 int red1,green1,blue1;
 int red2,green2,blue2;
 char line[40];
 int level;
 int upleft,left,downleft,up,down,upright,right,downright;

 pixel=getpixel2c(x,y);            

 blue=pixel&0xff;
 green=(pixel>>8)&0xff;
 red=(pixel>>16)&0xff;

 if(ope==0) { /* for debug purposes */
  pix=xcolor[0].pixel;

  /* values that XQueryColor gives are 16 bit. In pixel they are 8 bit */
  /* the values in pixel are the high bit values  */
  /* the low bit values are the same, as set in readgif (pale=3) */

  c.pixel=pixel;
  XQueryColor(display,colormap,&c);
  red1=c.red/256;
  green1=c.green/256;
  blue1=c.blue/256;
  red2=c.red&0xff;
  green2=c.green&0xff;
  blue2=c.blue&0xff;

  if(debug) {

   printf("from pixel:       red =%d green =%d blue =%d\n",red,green,blue);
   printf("high bits XQuery: red1=%d green1=%d blue1=%d\n",red1,green1,blue1); 
   printf("low bits  XQuery: red2=%d green2=%d blue2=%d\n",red2,green2,blue2); 

   scanbinary(line,(int)c.pixel,32);
   printf("pixel=%s\n",line);

   scanbinary(line,(int)c.red/256,32);
   printf("red/256=%s     %d\n",line,c.red/256);
   scanbinary(line,(int)c.green/256,32);
   printf("green/256=%s   %d\n",line,c.green/256);
   scanbinary(line,(int)c.blue/256,32);
   printf("blue/256=%s    %d\n",line,c.blue/256);
   printf("x=%d\n",x);
   if('q'==getchar()) debug=0;
  }

   drawpixel2b(x,y,pix);
 }
 else if(ope==1) { /* remove noise 1 */
   pix2=xcolor[15].pixel;

  if(red<=threshold && green<=threshold && blue<=threshold){ 
   curtest=1;
  }
  else curtest=0;

  if (curtest /* && oldtest */) {

   if(red*mag>255) red=255;
   else red=red*mag;
   if(green*mag>255) green=255;
   else green=green*mag;
   if(blue*mag>255) blue=255;
   else blue=blue*mag;
   pixel=(red<<16)|(green<<8)|blue;
 
   drawpixel2c(x,y,pixel);
  }
  else drawpixel2c(x,y,pix2);
 }

 else if(ope==2) { /* change lightness */
  if(red*mag>255) red=255;
  else red=red*mag;
  if(green*mag>255) green=255;
  else green=green*mag;
  if(blue*mag>255) blue=255;
  else blue=blue*mag;
  pixel=(red<<16)|(green<<8)|blue;
  drawpixel2c(x,y,pixel);
 }

 else if(ope==3) { /* adjust red green blue */
  if(red*mag>255) red=255;
  else red=red*mag;
  if(green*mag1>255) green=255;
  else green=green*mag1;
  if(blue*mag2>255) blue=255;
  else blue=blue*mag2;
  pixel=(red<<16)|(green<<8)|blue;
  drawpixel2c(x,y,pixel);
 }

 else if(ope==4) { /* change contrast */

  /* make light lighter and dark darker */
  /* but do not change the color balance */
  level=(red+blue+green)/3;
  if(level>=threshold) {
   red=  (int)(  (float)red*(1.0+mag*(255-level)));
   green=(int)((float)green*(1.0+mag*(255-level)));
   blue= (int)( (float)blue*(1.0+mag*(255-level)));
   if(red>255)   red=255;
   if(green>255) green=255;
   if(blue>255)  blue=255;
  }
  else {
   red=  (int)(  (float)red*(1.0-mag*(threshold-level)));
   green=(int)((float)green*(1.0-mag*(threshold-level)));
   blue= (int)( (float)blue*(1.0-mag*(threshold-level)));
   if(red<0)   red=0;
   if(green<0) green=0;
   if(blue<0)  blue=0;
  }
  pixel=(red<<16)|(green<<8)|blue;
  drawpixel2c(x,y,pixel);
 }
 else if(ope==5) { /* remove small non-white parts */
   /* the drawing is assumed to be treated to have white=15 */
  pix2=xcolor[15].pixel;
  if(getpixel2c(x,y)!=pix2) {
   i=x;j=y;

   upleft=downleft=left=0;
   if(i>0 && j>0   && pix2!=getpixel2c(i-1,j-1)) upleft  =1;
   if(i>0 && j<559 && pix2!=getpixel2c(i-1,j+1)) downleft=1;
   if(i>0 &&          pix2!=getpixel2c(i-1,j))   left    =1;  

   up=down=0;
   for(k=0;k<threshold;k++) {
    if(j>0   && i+k<=773 && pix2!=getpixel2c(i+k,j-1))   {up=1;  break;}
    if(j<559 && i+k<=773 && pix2!=getpixel2c(i+k,j+1))   {down=1;break;}
   }

   i+=(threshold-1);

   upright=downright=right=0;
   if(i<773 && j>0   && pix2!=getpixel2c(i+1,j-1)) upright  =1;
   if(i<773 && j<559 && pix2!=getpixel2c(i+1,j+1)) downright=1;
   if(i<773 &&          pix2!=getpixel2c(i+1,j))   right    =1;  
 
   if(!upleft && !left && !downleft && !up && !down &&
      !upright && !right && !downright) {

    for(i=x;i<x+threshold;i++) {
     if(i<773) drawpixel2c(i,y,pix2);
    }
   }
   else if (!upleft && !left && !up && !upright && !right) 
   {
    /* possible that downleft, down and downright are zero */
    /* if we move down by threshold2 */
    downleft=down=downright=0;
    for(k=1;k<threshold2;k++) {
     if(i>0   && j<559-threshold2 && pix2!=getpixel2c(i-1,j+1+k)) downleft=1;
    }

    for(k=1;k<threshold2;k++) {
     if(i+threshold<773 && j<559-threshold2 && 
      pix2!=getpixel2c(i+threshold,j+1+k)) downright=1;
    }

    for(k=0;k<threshold;k++) {
     if(j<560-threshold2 && i+k<=773 && 
      pix2!=getpixel2c(i+k,j+threshold2)){down=1;break;}
    }
    if(!down && !downleft && !downright) {
     for(i=x;i<x+threshold;i++) {
      for(j=y;j<y+threshold2;j++) {
       if(j<560 && i<773) drawpixel2c(i,j,pix2);
      }
     }
    }
   }
  }
 }

 oldertest=oldtest;
 oldtest=curtest;
}

int remove_grid()
{
 int i,j,k;
 unsigned long pix1,pix2,pix;
 int col,max,r,dont_draw;
 int col_rem[3];
 long int stat[256+21];

 pix1=xcolor[0].pixel;
 pix2=xcolor[15].pixel;

 for (i=0;i<733;i++){
   /* go horizontally, remove vertical lines */
  for (k=0;k<256+21;k++) stat[k]=0;
  for(j=0;j<559;j++) {
   pix=getpixel2c(i,j);
   color_by_pixel(pix,0,&col);
   stat[col]++;
  }
  /* if there are enough non-whites */
  if(stat[15]<400) {
    /* find 3 most common colors from 256-palette */
   for(r=0;r<3;r++) {
    max= -1;
    for(k=21;k<256+21;k++) { 
     if(stat[k]>max) {max=stat[k];col_rem[r]=k;}
    }
    stat[col_rem[r]]=0;
   }
   for(j=0;j<559;j++) {
    pix=getpixel2c(i,j);
    color_by_pixel(pix,0,&col);
    dont_draw=1;   
    for(r=0;r<1;r++) if(col==col_rem[r]) dont_draw=0;
    
    if(!dont_draw) drawpixel2b(i,j,pix2);
   }
  }
 }


 for (j=0;j<559;j++){
   /* go vertically, remove vertical lines */
  for (k=0;k<256+21;k++) stat[k]=0;
  for(i=0;i<773;i++) {
   pix=getpixel2c(i,j);
   color_by_pixel(pix,0,&col);
   stat[col]++;
  }
  /* if there are enough non-whites */

  if(stat[15]<600) {

    /* find 3 most common colors from 256-palette */
   for(r=0;r<3;r++) {
    max= -1;
    for(k=21;k<256+21;k++) { 
     if(stat[k]>max) {max=stat[k];col_rem[r]=k;}
    }
    stat[col_rem[r]]=0;
   }
   for(i=0;i<773;i++) {
    pix=getpixel2c(i,j);
    color_by_pixel(pix,0,&col);
    dont_draw=1;   
    for(r=0;r<1;r++) if(col==col_rem[r]) dont_draw=0;
    
    if(!dont_draw) drawpixel2b(i,j,pix2);
   }
  }
 }

 return 0;
}


int read_and_mixGIF(filename,width,height,clarity,magn,operation) 
     char *filename;int *width,*height;int clarity;double magn;
     int operation;
{
 char cBuffer[7];    
 FILE *stream;
 unsigned int uColors;
 char  cSDStatus;     
 short wWidth;        
 short wHeight;       
 unsigned char  cByte; 
 unsigned char  cBackgrnd;     
 unsigned int   bQuit = 0; 
 int   bResult;    
 int uBitPerPixel,u;
 int i,j,k;
 unsigned char *interlacebuf;
 unsigned long pixel,pix,pixel3;
 short top1,width1,height1;char status; 
 FILE *fd;
 unsigned long shade;
 int xoff,yoff,min_i;

 if(clarity==3) shade=0;
 else if (clarity==2) shade=0x8888;
 else if (clarity==1) shade=0xcccc;

 stream = fopen(filename,"rb");
 if (!stream)
 {
   cannot_find_file(filename);
  return 0;  
 }
 fread(cBuffer,1,6,stream);  

 if (strncmp(cBuffer, "GIF", 3)) 
 {
  unknown_parameter("not gif-file");
  fclose(stream);
  return 0; 
 }
 if (strncmp(&cBuffer[3], "87a", 3) && 
     strncmp(&cBuffer[3], "89a", 3))
 {
  unknown_parameter("gif-version");
  printf("Unknown GIF-Version: %c%c%c\n ",
             cBuffer[3], cBuffer[4], cBuffer[5]);
  fclose(stream);
  return 0; 
 }

 fread((char *)&wWidth,1,2,stream);
 fread((char *)&wHeight,1,2,stream);
 fread((char *)&cSDStatus,1,1,stream);
 fread((char *)&cBackgrnd,1,1,stream);
 fread((char *)&cByte,1,1,stream);

 /***************/
 dbug=0;
 cBuffer[6]=0;
 print_dbug(xkoor,ykoor,cBuffer,0);ykoor+=15;
 print_dbug(xkoor,ykoor,"cSDStatus=",(int)cSDStatus);ykoor+=15;
 print_dbug(xkoor,ykoor,"wWidth=",wWidth);ykoor+=15;
 print_dbug(xkoor,ykoor,"wHeight=",wHeight);ykoor+=15;
 /***************/

 resbuf=malloc((int)wWidth*wHeight); 

 uBitPerPixel = (cSDStatus & 0x07) + 1;
 if (uBitPerPixel != 1)
  if (uBitPerPixel <= 4) uBitPerPixel = 4;
  else uBitPerPixel = 8;

 if (cSDStatus & 0x80) 
 {
  uColors = 1 << ((cSDStatus & 0x07) + 1);
  /* uColors;  is the number of colors */

  for (u = 0; u < uColors; u++)   
  {
   cBuffer[0]=fgetc(stream);
   cBuffer[1]=fgetc(stream);
   cBuffer[2]=fgetc(stream);
   
   xcolor2[u].red=  ((int)(0xff&cBuffer[0])<<8);
   xcolor2[u].green=((int)(0xff&cBuffer[1])<<8);
   xcolor2[u].blue= ((int)(0xff&cBuffer[2])<<8);

   xcolor2[u].red   |=shade;
   xcolor2[u].green |=shade;
   xcolor2[u].blue  |=shade;

   if(XAllocColor(display,colormap,&xcolor2[u])==0) 
   {printf("problems with color %d\n",u);return 0;}
   
  }
 }
 
 do
 {
  cByte = '\0';
  cByte=fgetc(stream);
  print_dbug(xkoor,ykoor,"cByte=",(int)cByte);ykoor+=15;
  switch (cByte)
  {
    
    /* case '\0': break; */ 
   case (char)0: bQuit=1; break;

   case ',' :
     bResult = ReadImage(stream,&top1,&width1,&height1,&status); 
    if (!bResult) bQuit = 1; /* errors */        
    break;
   case ';' : bQuit = 1; 
    break;
   case '!' : 
    ReadExtension(stream);  
    break;
   default  : 
    printf("Illegal GIF-Block!\n");
    bQuit = 1;
    break;
  }
 }
 while (!bQuit);

 if (status & 0x40) {
   /* image is interlaced */

   print_dbug(xkoor,ykoor,"interlaced ",0);ykoor+=15;
  interlacebuf=(char *)malloc((int)wWidth*wHeight); 
  if(!interlacebuf) {no_memory();return 0;} 
  k=0;
  for(j=top1;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+4;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+2;j<(top1+height1);j+=4) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+1;j<(top1+height1);j+=2) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }

  k=0;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    pixel=xcolor2[(int)interlacebuf[k]].pixel;
    xoff=(int)((double)i*magn*10.7/12.8);
    yoff=(int)(magn*(double)j);
    if(xoff<=*width && yoff<=*height) {
     pix=getpixel2c(xoff,yoff);            
     mix_colors(pix,pixel,&pixel3,&min_i,operation);
     drawpixel2b(xoff,yoff,pixel3);
    }
    k++;
   }
  }
  free(interlacebuf);
 }
 else {
   print_dbug(xkoor,ykoor,"not interlaced ",0);ykoor+=15;
  k=0;

  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    pixel=xcolor2[(int)resbuf[k]].pixel;
    xoff=(int)((double)i*magn*10.7/12.8);
    yoff=(int)(magn*(double)j);
    if(xoff<=*width && yoff<=*height) {
     pix=getpixel2c(xoff,yoff);            
     mix_colors(pix,pixel,&pixel3,&min_i,operation);
     drawpixel2b(xoff,yoff,pixel3);
    }
    k++;
   }
  }
 }
 if((int)(magn*wWidth)<*width) *width=magn*wWidth;
 if((int)(magn*wHeight)<*height) *height=magn*wHeight;

 free(resbuf);
 fclose(stream);    
 return 1;   
}


int mix_colors(pixel1,pixel2,pixel3,min_i,ope) 
     unsigned long pixel1,pixel2,*pixel3;int *min_i;int ope;
{
 int red1,green1,blue1,red2,green2,blue2;

 if(ope==0) {*pixel3=pixel2;return 0;}

 /* pixel1 is from the screen, pixel2 from the file */
 if (ope==1) {

  /* if pixel1 is white, draw pixel2 */
  if(pixel1==xcolor[15].pixel) *pixel3=pixel2;
  else *pixel3=pixel1;
 }
 return 0;
}

unsigned long find_closest(pixel,col) unsigned long pixel;int *col;
{
 int i;
 unsigned long pixel2;
 int red1,red2,green1,green2,blue1,blue2;
 long min, val;

 min=3*255*255+1;*col=0;
 for(i=0;i<256;i++) {
  red1=  (pixel>>16)&0xff;            
  green1=(pixel>>8)&0xff;            
  blue1= (pixel>>8)&0xff;  
  pixel2=xcolor[i+21].pixel;
  red2=  (pixel>>16)&0xff;            
  green2=(pixel>>8)&0xff;            
  blue2= (pixel>>8)&0xff;  
  val=(red1-red2)*(red1-red2)
     +(green1-green2)*(green1-green2)
     +(blue1-blue2)*(blue1-blue2);
  if(val<min) {
    min=val;*col=i;
  }
 }
 return xcolor[*col].pixel;
}

int redo_palette()
{
 int i,j,k;
 unsigned long pixel,pix2,pix3;
 int red,green,blue,col;
 int new_colors,old_colors;
 int color_used[256];
 unsigned long unknown[256+21];

 if(!palette256_used) return 0;

 for(i=0;i<256;i++) color_used[i]=0;
 for(i=0;i<256+21;i++)  unknown[i]=0;
 
 /* count how many colors are used from palette2 */
 new_colors=old_colors=0;
 for(i=0;i<773;i++) {
  for(j=0;j<560;j++) {
   pixel=getpixel2c(i,j);
   color_by_pixel(pixel,2,&col);
   if(col>-1) { /* used from palette2 */
    color_used[col]++;
   }
   else { /* not from palette2 */
    for(col=-1,k=0;k<new_colors;k++) {
      if(pixel==unknown[k]) {col=k;break;} /* already have it */
    }
    if (col== -1){
     red=0xff&(pixel>>16);
     green=0xff&(pixel>>8);
     blue=0xff&pixel;
     unknown[new_colors]=pixel;/* new unknown color */
     new_colors++;
    }
   }
  }
 }
 old_colors=0;
 for(i=0;i<256;i++) {
  if(color_used[i]) old_colors++;
 }
 for(i=0;new_colors && i<256;i++) {
  if(!color_used[i]) {
   new_colors--;

   XFreeColors(display,colormap,&xcolor2[i].pixel,1,0);

   pixel=unknown[new_colors];
   red=  (pixel>>16)&0xff;            
   green=(pixel>>8)&0xff;            
   blue= pixel&0xff;

   xcolor2[i].red=   red<<8;
   xcolor2[i].green= green<<8;
   xcolor2[i].blue=  blue<<8;
   if(XAllocColor(display,colormap,&xcolor2[i])==0) 
    {printf("problems with color %d\n",i+21);return 0;}

  }
 }

 /* if we are left with unallocated colors */
 if(new_colors) {
   /* Too many colors. Removing some colors from the screen . */
   printf("too many colors, removing some\n");

  for(k=0;k<new_colors;k++) {
   new_colors--;
   pixel=unknown[new_colors];
   pix3=find_closest(pixel,&col);
   for(i=0;i<773;i++) {
    for(j=0;j<560;j++) {
     pix2=getpixel2c(i,j);
     if(pix2==pixel) drawpixel2b(i,j,pix3);
    }
   }
  }
 }

 /* draw the new palette2 */
 for(i=0;i<64;i++) {
  for(k=0;k<4;k++) {
   pixel=xcolor2[i+64*k].pixel;
   fillbox2(i*10,560+k*10,10,10,pixel);
  }
 }
 return 0;
}


int follow_line(pixel,i,j,dir,ioff,joff,dist) 
     unsigned long pixel;int i,j;int dir;int*ioff,*joff,*dist;
{
 unsigned long pixel_u0, pixel_u1, pixel_u2, pixel_u3, pixel_u4;
 unsigned long pixel_l0, pixel_l1, pixel_l2, pixel_l3, pixel_l4;
 unsigned long pixel_m0, pixel_m4, pixel_n0, pixel_n4, pixel_t0, pixel_t4;
 int dist1,dist2,dist3,wHeight,wWidth;

 wHeight=559;wWidth=773;
 *dist=0xffffff;

 if(j>1) {
  if(i>1) pixel_u0=getpixel2c(i-2,j-2);
  else pixel_u0=0xffffff;
  if(i>0) pixel_u1=getpixel2c(i-1,j-2);
  else pixel_u1=0xffffff;
  pixel_u2=getpixel2c(i,j-2);
  if(i<wHeight-1) pixel_u3=getpixel2c(i+1,j-2);
  else pixel_u3=0xffffff;
  if(i<wHeight-2) pixel_u4=getpixel2c(i+2,j-2);
  else pixel_u4=0xffffff;
 }
 else pixel_u0=pixel_u1=pixel_u2=pixel_u3=pixel_u4=0xffffff;
 /*
 printf("u0=%d u1=%d u2=%d u3=%d u4=%d\n",pixel_u0,pixel_u1,
	pixel_u2,pixel_u3,pixel_u4);
 */

 if(j<wHeight-2) {
  if(i>1) pixel_l0=getpixel2c(i-2,j+2);
  else pixel_l0=0xffffff;
  if(i>0) pixel_l1=getpixel2c(i-1,j+2);
  else pixel_l1=0xffffff;
  pixel_l2=getpixel2c(i,j+2);
  if(i<wHeight-1) pixel_l3=getpixel2c(i+1,j+2);
  else pixel_l3=0xffffff;
  if(i<wHeight-2) pixel_l4=getpixel2c(i+2,j+2);
  else pixel_l4=0xffffff;
 }
 else pixel_l0=pixel_l1=pixel_l2=pixel_l3=pixel_l4=0xffffff;

 /*
 printf("l0=%d l1=%d l2=%d l3=%d l4=%d\n",pixel_l0,pixel_l1,
	pixel_l2,pixel_l3,pixel_l4);
 */

 if(i>1) {
  if(j>0) pixel_n0=getpixel2c(i-2,j-1);
  else pixel_n0=0xffffff;
  pixel_t0=getpixel2c(i-2,j);
  if(j<wHeight-1) pixel_m0=getpixel2c(i-2,j+1);
  else pixel_m0=0xffffff;
 }
 else pixel_n0=pixel_t0=pixel_n0=0xffffff;

 if(i<wWidth-2) {
  if(j>0) pixel_n4=getpixel2c(i+2,j-1);
  else pixel_n4=0xffffff;
  pixel_t4=getpixel2c(i+2,j);
  if(j<wHeight-1) pixel_m4=getpixel2c(i+2,j+1);
  else pixel_m4=0xffffff;
 }
 else pixel_n4=pixel_t4=pixel_n4=0xffffff;

 /*
 printf("n0=%d to=%d m0=%d n4=%d t4=%d m4=%d\n",pixel_n0,pixel_t0,
	pixel_m0,pixel_n4,pixel_t4,pixel_m4);
 */

 if(dir==UtoD) {
  dist1=distance(pixel,pixel_l1);
  dist2=distance(pixel,pixel_l2);
  dist3=distance(pixel,pixel_l3);
  if(dist1<dist2) {*dist=dist1;*ioff=-1;}
  else            {*dist=dist2;*ioff=0;}
  if(dist3<*dist) {*dist=dist3;*ioff=1;}
  *joff=2;
 }
 else if (dir==URtoLD) {
  dist1=distance(pixel,pixel_m0);
  dist2=distance(pixel,pixel_l0);
  dist3=distance(pixel,pixel_l1);
  if(dist1<dist2) {*dist=dist1;*joff=1;*ioff=-2;}
  else            {*dist=dist2;*joff=2;*ioff=-2;}
  if(dist3<*dist) {*dist=dist3;*joff=2;*ioff=-1;}
 }
 else if (dir==RtoL) {
  dist1=distance(pixel,pixel_n0);
  /*  printf("hello to distance pixel_t0=%d pixel=%d\n",pixel_t0,pixel);*/
  dist2=distance(pixel,pixel_t0);
  /*   printf("LtoR dist2=%d i=%d j=%d\n",dist2,i,j);getchar();*/

  dist3=distance(pixel,pixel_m0);
  if(dist1<dist2) {*dist=dist1;*joff=-1;}
  else            {*dist=dist2;*joff=0;}
  if(dist3<*dist) {*dist=dist3;*joff=1;}
  *ioff=-2;
 }
 else if (dir==DRtoLU) {
  dist1=distance(pixel,pixel_n0);
  dist2=distance(pixel,pixel_u0);
  dist3=distance(pixel,pixel_u1);
  if(dist1<dist2) {*dist=dist1;*joff=-1;*ioff=-2;}
  else            {*dist=dist2;*joff=-2;*ioff=-2;}
  if(dist3<*dist) {*dist=dist3;*joff=-2;*ioff=-1;}
 }
 else if (dir==DtoU) {
  dist1=distance(pixel,pixel_u1);
  dist2=distance(pixel,pixel_u2);
  dist3=distance(pixel,pixel_u3);
  if(dist1<dist2) {*dist=dist1;*ioff=-1;}
  else            {*dist=dist2;*ioff=0;}
  if(dist3<*dist) {*dist=dist3;*ioff=1;}
  *joff=-2;
 }
 else if (dir==LDtoUR) {
  dist1=distance(pixel,pixel_u3);
  dist2=distance(pixel,pixel_u4);
  dist3=distance(pixel,pixel_n4);
  if(dist1<dist2) {*dist=dist1;*joff=-2;*ioff=1;}
  else            {*dist=dist2;*joff=-2;*ioff=2;}
  if(dist3<*dist) {*dist=dist3;*joff=-1;*ioff=2;}
 }
 else if (dir==LtoR) {
  dist1=distance(pixel,pixel_n4);
  dist2=distance(pixel,pixel_t4);
  dist3=distance(pixel,pixel_m4);
  if(dist1<dist2) {*dist=dist1;*joff=-1;}
  else            {*dist=dist2;*joff=0;}
  if(dist3<*dist) {*dist=dist3;*joff=1;}
  *ioff=2;
 }
 else if(dir==LUtoDR) {
  dist1=distance(pixel,pixel_l3);
  dist2=distance(pixel,pixel_l4);
  dist3=distance(pixel,pixel_m4);
  if(dist1<dist2) {*dist=dist1;*joff=2;*ioff=1;}
  else            {*dist=dist2;*joff=2;*ioff=2;}
  if(dist3<*dist) {*dist=dist3;*joff=1;*ioff=2;}
 }

 return 0;
}

int distance(pixel1,pixel2) unsigned long pixel1,pixel2;
{
 int red1,green1,blue1,red2,green2,blue2;
 int dist;

 red1=0xff&(pixel1>>16);
 green1=0xff&(pixel1>>8);
 blue1=0xff&pixel1;

 red2=0xff&(pixel2>>16);
 green2=0xff&(pixel2>>8);
 blue2=0xff&pixel2;

 dist=(red1-red2)*(red1-red2);
 dist+=(green1-green2)*(green1-green2);
 dist+=(blue1-blue2)*(blue1-blue2);

 return dist;
}

int routine(x,y,pixel) int x,y;unsigned long pixel;
{
 int dir_best;
 unsigned long pix1;
 int min,dir,ioff,joff,i,dist;


 if(pixel==xcolor[1].pixel) return 1;

 pix1=xcolor[1].pixel;

  /* chose a direction to follow */

 min=0xffffff;
 for(dir=0;dir<8;dir++) {
  follow_line(pixel,x,y,dir,&ioff,&joff,&dist);
  if(dist<min) { min=dist;dir_best=dir;}
 }
 dir=dir_best; 
 follow_line(pixel,x,y,dir,&ioff,&joff,&dist);
 /*
 printf("got ioff=%d joff=%d\n",ioff,joff);
 */
 for(i=0;i<1000;i++) {
  draw_line2b(x,y,x+ioff,y+joff,pix1);
  x+=ioff;y+=joff;
  /*
  printf("got x=%d y=%d  dir=%d\n",x,y,dir);
  getchar();
  */
  follow_line(pixel,x,y,dir,&ioff,&joff,&dist);
  /* printf("we got dist=%d dir=%d\n",dist,dir); */
  if(dist>1000){ /* not good? */ 
    /*    printf("dist1=%d trying better\n",dist);*/
    dir--;if(dir<0) dir=7; /* try turning left */
   follow_line(pixel,x,y,dir,&ioff,&joff,&dist);

   if(dist>1000) { /* not good? */
     /* printf("dist1=%d trying better\n",dist);*/
    dir+=2;dir=dir%8; /* try turning right */
    follow_line(pixel,x,y,dir,&ioff,&joff,&dist);

    if(dist>1000) { /* make a whole turn */
     min=0xffffff;
     for(dir=0;dir<8;dir++) {
      follow_line(pixel,x,y,dir,&ioff,&joff,&dist);
      if(dist<min) { min=dist;dir_best=dir;}
     }
     dir=dir_best;
     if(min>1000) break;
    }
   }
  }
 }
}

int line_finder(mag,threshold) float mag; int threshold;
{
  int i,j;
  unsigned long pixel;

  for(i=0;i<773;i++) {
    for(j=0;j<559;j++) {
    pixel=getpixel2c(i,j);
    if(is_grey(pixel,mag,threshold))
     routine(i,j,pixel);
   }
  }
  return 0;
}

int is_grey(pixel,mag,threshold) 
     unsigned long pixel;float mag;int threshold;
{
  float red,green,blue;
  int greyish;

  red=(float)((pixel>>16)&0xff);
  green=(float)((pixel>>8)&0xff);
  blue=(float)(pixel&0xff);

  /*  printf("red=%f green=%f blue=%f\n",red,green,blue);getchar();*/
  /* two things, red green blue balance and darkness */
  if (red/green>mag && green/red>mag && 
      blue/green>mag && green/blue>mag && 
      blue/red>mag && red/blue>mag)
    greyish=1;else greyish=0; 

  /* white is typically 200-255 */
  if(red<threshold && greyish) return 1; 
  else return 0;
}


/***************************************************
 * open avi-file and show the fields
 **************************************************/
analyse2(name1,width,height,magn) char *name1;int width,height;float magn;
{
 char line[132], line2[64];
 FILE *stream1;char ch;
 int len,print,counter4,counter5,len2,oldprint;
 int counter=0,counter2,counter1,old_type;
 char *buf;long offset;
 int i,entriesinuse;char fourCC[4];
 int entries,wbcount,dbcount,entries2,video_off,audio_off;

 print=0;
 
 printf("testavi y/n\n");
 ch=getchar();
 if(ch=='y') strcpy(line,"/home/jorma/audicity/testavi.avi");
 else strcpy(line,"/home/jorma/audicity/test.avi");
 
 
 buf=malloc(3*width*height+512);
 
 if(print) printf("opening file %s\n",line);
 stream1=fopen(line,"rb");
 
 if(!fread(line,1,4,stream1)) {printf("not av1-file\n");return 1;}
 if(print) { 
  line[4]=0; 
  printf("%d RIFF: %s\n",counter, line);
  getchar();
 }
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) {
  printf("%d length=%d\n",counter, len);
  getchar();
 }
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d AVI =%s\n",counter, line);
  getchar();
 }
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print){
  printf("%d LIST=%s\n",counter, line);
  getchar();
 }
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d length=%d\n",counter, len);
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d hdrl=%s\n",counter, line);
  getchar();
 }
 counter+=4;

 /* read avi header */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d avih=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 for(i=0;i<15;i++) {
  if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
  memcpy((char *)&len,line,4); 
  if(print) {printf("%d len=%d\n",counter, len);getchar();}
  counter+=4;
 }

 /* LIST vids */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d LIST=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d len=%d\n",counter, len);
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d strl=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d strh=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 for(i=0;i<27;i++){
  if(!fread(line,1,4,stream1)) break;
  line[4]=0;
  memcpy((char *)&len,line,4);
  binary(line2,line,32); 
  if(print) {
   printf("%d   len=%d bin=%s line=%s\n",counter,len,line2,line);
   getchar();
  }
  counter+=4;
 }
 /* read index of LIST vids */
 fread(line,1,4,stream1);
 line[4]=0;
 memcpy((char *)&len,line,4);
 binary(line2,line,32); 
 if(print) printf("%d   len=%d bin=%s line=%s\n",counter,len,line2,line);
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d length=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 4=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&entriesinuse,line,4); 
 if(print) printf("%d 1=%d\n",counter, entriesinuse);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 line[4]=0; 
 if(print) {printf("%d 00db=%s\n",counter, line);getchar();}
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) {printf("%d wDuration (entries for vid)=%d\n",counter,len);getchar();}
 counter+=4;  
 for(i=1;i<entriesinuse;i++) {
  fread(line,1,4,stream1);
  memcpy((char *)&offset,line,4);
  if(print) printf("%d offset=%d\n",counter,offset);
  counter+=4;
  fread(line,1,4,stream1);
  memcpy((char *)&len,line,4);
  if(print) printf("%d size=%d\n",counter, len);
  counter+=4;
 }
 /* read the unused bytes */
 counter4=32248-32-8*entriesinuse;
 if(print) printf("%d skipping %d bytes\n",counter,counter4);
 while(counter4>0) {
  fread(line,1,4,stream1);
  counter4-=4;
  counter+=4;
 }
 if(print) printf("over indx, over LIST vids\n");


 /* LIST auds */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d LIST=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d len=%d\n",counter, len);
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d strl=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d strh=%s\n",counter, line);
  getchar();
 }
 counter+=4; 
 for(i=0;i<24;i++){
  if(!fread(line,1,4,stream1)) break;
  line[4]=0;
  memcpy((char *)&len,line,4);
  binary(line2,line,32); 
  if(print) {
   printf("%d   len=%d bin=%s line=%s\n",counter,len,line2,line);
   getchar();
  }
  counter+=4;
 }
 /* read index of LIST auds */
 fread(line,1,4,stream1);
 line[4]=0;
 if(print) printf("%d line=%s\n",counter,line);
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d length=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 4=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&entriesinuse,line,4); 
 if(print) printf("%d 1=%d\n",counter, entriesinuse);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 line[4]=0; 
 if(print) printf("%d 01wb=%s\n",counter, line);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) {printf("%d 0=%d\n",counter, len);getchar();}
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d 0=%d\n",counter, len);
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) {printf("%d 0=%d\n",counter, len);getchar();}
 counter+=4;  
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d wDuration=%d\n",counter, len);
 counter+=4;  
 for(i=0;i<entriesinuse-1;i++) {
  fread(line,1,4,stream1);
  memcpy((char *)&offset,line,4);
  if(print) {printf("%d offset=%d\n",counter,offset);getchar();}
  counter+=4;
  fread(line,1,4,stream1);
  memcpy((char *)&len,line,4);
  if(print) printf("%d size=%d\n",counter, len);
  counter+=4;
 }
 /* read the unused bytes */
 counter4=32248-32-8*entriesinuse;
 if(print) printf("%d skipping %d bytes\n",counter,counter4);
 while(counter4>0) {
  fread(line,1,4,stream1);
  counter4-=4;
  counter+=4;
 }
 if(print) {printf("over indx, over LIST auds\n");getchar();}

 /* there may be LIST odml */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(!memcmp(line,"LIST",4)) {
  if(print){
   printf("%d (maybe LIST odml) LIST=%s\n",counter, line);
   getchar();
  }
  counter+=4;
  if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
  memcpy((char *)&len,line,4); 
  if(print) printf("%d length=%d\n",counter, len);
  counter+=4;
  if(len==260) {
   if(print) printf("It is LIST odml\n");
   counter2=len;
   oldprint=print;
   while(counter2>0) {
    if(!fread(line,1,4,stream1)) break;
    if(print) {
     line[4]=0;
     binary(line2,line,32); 
     memcpy((char *)&len,line,4); 
     printf("%d num=%d bin=%s line=%s\n",counter,len,line2,line);
     if('q'==getchar()) print=0;
    }
    counter+=4;
    counter2-=4;
   }
   if(oldprint) print=1;
  } 
  else {
    if(print) printf("some other LIST, reread it\n");
   counter-=4;
   fseek(stream1,counter,0); /* go back */
  }
 }

 /* there may be JUNK */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(!memcmp(line,"JUNK",4)) {
  if(print){
   printf("%d JUNK=%s\n",counter, line);
   getchar();
  }
  counter+=4;
  if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
  memcpy((char *)&len,line,4); 
  if(print) printf("%d length=%d\n",counter, len);
  counter+=4;
  counter2=len;
  while(counter2>0) {
   if(!fread(line,1,4,stream1)) break;
   counter+=4;
   counter2-=4;
  }  
 }/* over JUNK */
 else {
  counter-=4;
  fseek(stream1,counter,0); /* go back if there was no JUNK */
 }

 /* finally there must be LIST movi */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {
  printf("%d LIST=%s\n",counter, line);
  getchar();
 }
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy((char *)&len,line,4); 
 if(print) printf("%d length=%d\n",counter, len);
 counter+=4;
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 if(print) {printf("%d movi=%s\n",counter, line);getchar();}
 counter+=4;

 /* ix00 */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy(fourCC,line,4);fourCC[4]=0;
 if(print) {
  line[4]=0;
  binary(line2,line,32); 
  memcpy((char *)&len,line,4); 
  printf("%d fourCC=%s  num=%d bin=%s\n",counter, line,len,line2);
 }
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 32248=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 2=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&entries,line,4);
 if(print) printf("%d entries=%d\n",counter,entries); 
 counter+=4;   
 fread(line,1,4,stream1);
 line[4]=0;
 if(print) {printf("%d chunkId=%s\n",counter,line); getchar();}
 counter+=4;
 /* the next one is the offset to the beginning of video */
 fread(line,1,4,stream1);
 memcpy((char *)&video_off,line,4);
 if(print) printf("%d video chunks start at=%d\n",counter, video_off);
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 0=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 0=%d\n",counter, len); 
 counter+=4;   
 /* the first offset, substract it from video_off */
 fread(line,1,4,stream1);
 memcpy((char *)&offset,line,4);
 if(print) printf("%d 8=%d\n",counter,offset); 
 video_off-=offset;
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) {printf("%d size=%d\n",counter, len);getchar();} 
 counter+=4;   
 offset+=video_off;
 /* read the first video chunk */
 if(print) {
  printf("reading frame 0 from offset=%d\n",offset);
  if('q'==getchar()) print=0;
 }
 fseek(stream1,offset,0);
 if(fread(buf,1,3*width*height+512,stream1)) {
  if(draw_avi_buf(buf,0,0,width,height,magn)) {
   printf("garbled frame  %d offset=%d\n",i,offset);
   printf("%d size=%d looping index=%d of %d\n",counter, len, i,entries);
  }
 }        
 fseek(stream1,counter,0); /* return to reading index */
 oldprint=print;
 for(i=1;i<entries;i++) { /* read the rest of video chunks */
  fread(line,1,4,stream1);
  memcpy((char *)&offset,line,4);
  if(print) printf("%d offset=%d\n",counter,offset);
  counter+=4;
  fread(line,1,4,stream1);
  memcpy((char *)&len,line,4);
  if(print)
   printf("%d size=%d looping index=%d of %d\n",counter, len, i,entries);
  counter+=4;
  if(offset) { /* there are offset=0 size=2**32 entries. Ignore them. */
   offset+=video_off;
   if(print) {
    printf("reading chunk %d from offset=%d\n",i,offset);
    if('q'==getchar()) print=0;
   }
   fseek(stream1,offset,0);
   if(fread(buf,1,3*width*height+512,stream1)) {
    if(draw_avi_buf(buf,0,0,width,height,magn)) {
     printf("garbled chunk  %d offset=%d\n",i,offset);
     printf("%d size=%d looping index=%d of %d\n",counter, len, i,entries);
    }
   }        
   fseek(stream1,counter,0);
  }
 }
 print=oldprint;

 /* read the unused bytes */
 counter4=32248-24-8*entries;
 if(print) printf("%d skipping %d bytes\n",counter,counter4);
 while(counter4>0) {
  fread(line,1,4,stream1);
  counter4-=4;
  counter+=4;
 }
 if(print) printf("%d over LIST movi ix00\n",counter);

 print=1;
 /* ix01 audio index */
 if(!fread(line,1,4,stream1)) {printf("not avi-file\n");return 1;}
 memcpy(fourCC,line,4);fourCC[4]=0;
 if(print) {
  line[4]=0;
  binary(line2,line,32); 
  memcpy((char *)&len,line,4); 
  printf("%d fourCC=%s  num=%d bin=%s\n",counter, line,len,line2);
 }
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 32248=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 2=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&entries2,line,4);
 if(print) {printf("%d entries2=%d\n",counter,entries2);getchar();} 
 counter+=4;   
 fread(line,1,4,stream1);
 line[4]=0;
 if(print) printf("%d chunkId=%s\n",counter,line); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&audio_off,line,4);
 if(print) printf("%d audio_start=%d\n",counter, audio_off); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 0=%d\n",counter, len); 
 counter+=4;   
 fread(line,1,4,stream1);
 memcpy((char *)&len,line,4);
 if(print) printf("%d 0=%d\n",counter, len); 
 counter+=4;
 /* here starts audio index, offset,dwReserved is the first */
 audio_off-=8; /* we assume the first audio has offset 8 */
 oldprint=print;
 for(i=0;i<entries2;i++) {
  fread(line,1,4,stream1);
  memcpy((char *)&offset,line,4);
  if(print) printf("%d offset=%d\n",counter,offset);
  counter+=4;
  fread(line,1,4,stream1);
  memcpy((char *)&len,line,4);
  if(print) {
   printf("%d size=%d looping index=%d of %d\n",counter, len, i,entries2);
   if('q'==getchar()) print=0;
  }
  counter+=4;
  offset+=audio_off;
  fseek(stream1,offset,0);
  if(fread(buf,1,7168,stream1)) {  
   if(show_avi_audio(buf,offset,i)) {
    printf("garbled chunk  %d offset=%d\n",i,offset);
    printf("%d size=%d looping index=%d of %d\n",counter, len, i,entries);
   }
  }
  fseek(stream1,counter,0);
 }
 /* read the unused bytes */
 counter4=32248-24-8*entries2;
 if(print) printf("%d skipping %d bytes\n",counter,counter4);
 while(counter4>0) {
  fread(line,1,4,stream1);
  counter4-=4;
  counter+=4;
 }
 print=oldprint;
 if(print) printf("%d over LIST movi ix01\n",counter);

 /* go through the actual data chunks */
 print=0;
 old_type=counter1=counter2=0;
 counter4=counter5=0;
 counter=130048;
 fseek(stream1,130048,0);
 while(1) {
  if(!fread(fourCC,1,4,stream1)) break;
  fourCC[4]=0;
  if(!fread(line,1,4,stream1)) break;
  memcpy((char *)&len,line,4);
  if(!strcmp(fourCC,"00db")) {
   counter4++;
   if (old_type==0)    {counter1=1;old_type=1;}
   else if(old_type==1) counter1++;
   else if(old_type==2) {
    if(print) {
     printf("01wb chunks %d. Read 00db chunks=%d, 01wb cunks=%d\n",
     counter2,counter4,counter5);
     getchar();
    }
    counter1=counter2=1;old_type=1;
   }
   if(print) {
    printf("%d chunkId=%s  count=%d\n",counter,fourCC,counter4);
    printf("%d len    =%d\n",counter+4,len);
    if('q'==getchar()) break;
   }
  }
  if(!strcmp(fourCC,"01wb")) {
   counter5++;
   if (old_type==0)    {counter2=1;old_type=2;}
   else if(old_type==2) counter2++;
   else if(old_type==1) {
    if(print) {
     printf("00db chunks %d. Read 00db chunks=%d, 01wb cunks=%d\n",
     counter1,counter4,counter5);
     getchar();
    }
    counter1=counter2=1;old_type=2;
   }
   if(print) {
    printf("%d chunkId=%s  count=%d\n",counter,fourCC,counter5);
    printf("%d len    =%d\n",counter+4,len);
    if('q'==getchar()) break;
   }
  }
  counter+=8;
 }
 if(print) printf("number of 00db is %d\n",counter4);
 if(print) printf("number of 01wb is %d\n",counter5);



 free(buf);
 fclose(stream1);
 return 1;
}


int binary(line2,line,i1)
char *line2,*line;int i1;
{
 int i;
 unsigned long int k;
 unsigned long int n;
 
 memcpy((char *)&n,line,4); 

 *line2=0;

 i=i1;

 for(i--;i>=0;i--) {
  k= (1<<i);
  if(k&n) strcat(line2,"1");
  else strcat(line2,"0");
 }
}
int show_avi_audio(buf,offset,i0) char *buf;int offset,i0;
{
  int n,i;char line2[32];char line3[5];

  if(strncmp(buf,"01wb",4)) {
   printf("show_avi_audio: garbled audio chunk %d at %d\n",i0,offset);
   getchar();
   return 1;
  } 
  memcpy((char *)&n,buf+4,4);

 if(debug) {
  memcpy(line2,buf,4);line2[4]=0;
  printf("fourcc=%s \n",line2);
  printf("chunk len=%d\n",n);

  for(i=2;i<1792;i++) {
   memcpy(line3,buf+4*i,4);line3[4]=0;
   memcpy((char *)&n,buf+4*i,4);
   binary(line2,buf+4*i,32);
   printf("%d binaryDWORD=%s %d %s\n",4*i,line2,n,line3);
   if('q'==getchar()) {debug=0;break;}
  }
 }
 return 0;
}
int set_avi_audio(buf) char *buf;
{
 int n;

 strcpy(buf,"01wb"); 
 n=7056;
 memcpy(buf+4,(char *)&n,4);
 memset(buf+8,0,7056);
}


int draw_avi_buf(buf,xstart,ystart,width,height,magn) 
     char *buf;int xstart,ystart,width,height;float magn;
{
 int i,j,off,off1,red,green,blue;int n,ykoord,xkoord;
 unsigned long pixel;int col,xsize,ysize;
 int yc,xc;char line2[32],line3[2];
 char *buf1;

 if(strncmp(buf,"00db",4)) {
   garbled++;
   printf("garbled chunk count=%d\n",garbled);
  return 1; /* there can be garbage */
 }
 memcpy((char *)&n,buf+4,4);

 if(debug) {
   memcpy(line2,buf,4);line2[4]=0;
   printf("fourcc buf=%s\n",line2);
   printf("chunk  len=%d\n",n);

   for(i=0;i<504;i++) {
     printf("byte[%d]=%c =%d\n",i,buf[i+230408],(int)buf[i+230408]);
     line3[0]=buf[i+3*width*height+8];line3[1]=0;
     binary(line2,line3,32); 
     printf("in binary %s\n",line2);
    if('q'==getchar()) break;
   }
   if('q'== getchar()) debug=0;
 }
 
 buf1=buf+8;


 off1=3*width+8;
 /* j=0 */
 for(i=-width;i<width;i++) {
  off=3*i+off1;
  xc=i;
  yc=height-1; 
  if(xc<0) {xc+=width;yc=0;}
  green=      buf1[off];
  blue=       buf1[off+1];
  red=        buf1[off+2];

  pixel=((0xff&red)<<16)|((0xff&green)<<8)|(0xff&blue);
  ykoord=ystart+(int)(magn*(19.0/16.0)*(float)yc);
  xkoord=xstart+(int)(magn*(float)xc);
  drawpixel2c(xkoord,ykoord,pixel);
 }

 /* j=1,...,height-2 */
 for(j=1;j<height-1;j++) {
  for(i=0;i<width;i++) {
   off=3*(i+width*j)+off1;
   yc=height-1-j; 
   green=     buf1[off];
   blue=      buf1[off+1];
   red=       buf1[off+2];

   pixel=((0xff&red)<<16)|((0xff&green)<<8)|(0xff&blue);
   ykoord=ystart+(int)(magn*(19.0/16.0)*(float)yc);
   xkoord=xstart+(int)(magn*(float)xc);
   drawpixel2c(xkoord,ykoord,pixel);
  }
 }
 xsize=(int)((float)width*magn);
 ysize=(int)((float)height*magn*19.0/16.0);
 XPutImage(display,win,gc,screenbuf,xstart,ystart,xstart,ystart,
  xstart+xsize,ystart+ysize);
 return 0;
}        

int write_video_avi_header(stream1,width,height,entries,entries2,
entries_real) 
FILE *stream1;int width,height,entries,entries2;
int entries_real; 
{
 char line[5];
 int len,i,count,k,k0,lim,audios,offset,counter,video_off,empties;

 strcpy(line,"RIFF");       /* 0 */
 fwrite(line,1,4,stream1);
 len=130048-8+entries_real*(3*width*height+512)+entries2*7168;
 /* number 130048 is the size of this header we write here */
 /* it does not depend on the size or number of data chunks */
 /* 7168 is the size of audio chunks, depends only on audio codec */
 /* we do not put audio, but need an audio stream to have video */
 /* len the end of the file is: */

 /* beginning                 0-    88 =   88 bytes */
 /* LIST stream1 (video)     88- 32468 =32380 bytes */
 /* LIST stream2 (audio)  32468- 64836 =32368 bytes */
 /* LIST odml             64836- 65104 =  268 bytes */
 /* JUNK                  65104- 65524 =  420 bytes */
 /* LIST movi header      65524- 65536 =   12 bytes */
 /* LIST movi ix00(video) 65536- 97792 =32256 bytes */
 /* LIST mov  ix01(audio) 97792-130048 =32256 bytes */
 /* sum =130048 bytes, then comes data                             */
 /* LIST odml and JUNK were added because they may be needed for   */
 /* certain applications in order to place data on some boundaries */

 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"AVI ");       /* 8 */
 fwrite(line,1,4,stream1);
 strcpy(line,"LIST");       /* 12 */
 fwrite(line,1,4,stream1);
 len=65084;                 /* to 65104  JUNK */ 
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"hdrl");      /* 20 */
 fwrite(line,1,4,stream1);
 strcpy(line,"avih");      /* 24 aviheader */
 fwrite(line,1,4,stream1);
 len=56;                   /* 28 len 32+56=88 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=40000;                /* 32, dwMicroSecPerFrame, 40 ms=25 fps */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);

 len=(int)((double)(25*(512+3*width*height+7168))*1.0577778); 
                 /* dwMaxBytesPerSec, a bit more than needed */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=512;                        /* dwReserved1 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=2048;                        /* dwFlags */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries2;                 /* dwTotalFrames */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;
 memcpy(line,(char *)&len,4);  /* dwInitialFrame */
 fwrite(line,1,4,stream1);
 len=2;                        
 memcpy(line,(char *)&len,4);  /* dwStreams */
 fwrite(line,1,4,stream1);
 len=8+3*width*height;         /* dwSuggestedBufferSize */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=width;                    /* dwWidth */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=height;                   /* dwHeight */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwScale */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwRate */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwStart */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwLenght */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);

 /* LIST stream 1, video */
 strcpy(line,"LIST");          /* 88 */
 fwrite(line,1,4,stream1);
 len=32372;                    /* to 32468  LIST auds  */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"strl");          /* 96 */
 fwrite(line,1,4,stream1);
 strcpy(line,"strh");          /* 100 */
 fwrite(line,1,4,stream1);
 len=56;                        /* strh len 56 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"vids");          /* video stream */
 fwrite(line,1,4,stream1);
 strcpy(line,"DIB ");          /* uncompressed */
 fwrite(line,1,4,stream1);
 len=0;                        /* dwFlags */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* wPriority | wLanguage */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwInitialFrames */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=400000;                   /* dwScale */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=10000000;                 /* dwRate   dwRate/dwScale=frames per sec */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwStart */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries;                   /* dwLength */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=8+3*width*height;         /* dwSuggestedBufferSize */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwQuality */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwSampleSize */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* rcFrame */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* rcFrame */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"strf");          /* 164 */
 fwrite(line,1,4,stream1);
 len=40;                        /* len, 172+40=212 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=40;                        /* biSize, structure size */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=width;                     /* biWidth */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=height;                    /* biHeight */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=1572865;                  /* biPlanes | biBitCount (biPlanes must be 1) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* biCompression, 0=RGB no compression */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=3*width*height;           /* biSizeImage */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* biXPelsPerMeter */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* biYPelsPerMeter */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* biClrUsed */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* biClrImportant, can be 0 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);

 strcpy(line,"indx");          /* 212 */
 fwrite(line,1,4,stream1);
 len=32248;                    /* index has a fixed size 32248 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=4;                        /* wLongsPerEntry|bIndexSubType|bIndexType */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=1;                        /* nEntriesInUse */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"00db");          /* dwChunkId, uncompressed video */
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[0] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[1] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[2] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=65536;                    /* qwOffset, to "ix00" in LIST movi */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwOffset */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=32256;                    /* dwSize, 32248+8 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries;                        /* dwDuration, =entries for video */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 count=32248-40;
 while(count>0) { /* write unused entries */
  len=0;                        /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  len=0;                        /* dwDuration */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  count-=8;
 }

 /*  auds stream 2 must be added if video is stream 1 as vids DIB */
 strcpy(line,"LIST");          /* 32468 LIST auds */
 fwrite(line,1,4,stream1);
 len=32360;                    /* to 64836 LIST odml */     
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"strl");          
 fwrite(line,1,4,stream1);
 strcpy(line,"strh");          
 fwrite(line,1,4,stream1);
 len=56;                        /* strh len 56 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"auds");          /* audio stream */
 fwrite(line,1,4,stream1);
 len=0;                    
 memcpy(line,(char *)&len,4);  /* dwHandler, not used for audio */
 fwrite(line,1,4,stream1);
 len=0;                        /* dwFlags */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* wPriority | wLanguage */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwInitialFrames */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=4;                        /* dwScale, as sample size */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=176400;                  /* dwRate, dwRate/dwScale=44100, sampling rate */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwStart */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries2*(0.04*44100.0); /* dwLength, duration */
            /* video chunk takes 0.04 sec. audio chunk the same */ 
            /* dwLength=audiochunks*0.04*44100 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=7068;                    /* dwSuggestedBufferSize */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwQuality */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=4;                        /* dwSampleSize */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* rcFrame */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* rcFrame */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"strf");          /* line 32544 */
 fwrite(line,1,4,stream1);
 len=18;                       
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=131073;
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=44100;                    /* sample rate */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=176400;                   /* these numbers are for codec 18 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=1048580;                  /* these numbers are for codec 18 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=1430913024;               /* these numbers are for codec 18 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);     /* these numbers are for codec 18 */
 len=150350; 
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;      
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);

 strcpy(line,"indx");          /* line 32580 */
 fwrite(line,1,4,stream1);
 len=32248;                    /* index has a fixed size 32248 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=4;                        /* wLongsPerEntry|bIndexSubType|bIndexType */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=1;                        /* nEntriesInUse */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"01wb");          /* dwChunkId, audio */
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[0] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[1] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* dwReserved[2] */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=97792;                    /* qwOffset, to "ix01" in LIST movi */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwOffset */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=32256;                    /* dwSize, 32248+8, constant */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries2*(0.04*44100.0); /* dwDuration */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 count=32248-40;
 while(count>0) { /* write unused entries */
  len=0;                        /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  len=0;                        /* dwDuration */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  count-=8;
 }

/* add here LIST odml                                  */
 strcpy(line,"LIST");          /* line 64836 */
 fwrite(line,1,4,stream1);
 len=260;                     
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"odml");
 fwrite(line,1,4,stream1);
 strcpy(line,"dmlh");
 fwrite(line,1,4,stream1);
 len=248;                     
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries;                     
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                     
 memcpy(line,(char *)&len,4);
 for(i=244;i>0;i-=4) fwrite(line,1,4,stream1);

/* add here JUNK                                  */
 strcpy(line,"JUNK");          /* line 65104 */
 fwrite(line,1,4,stream1);
 len=412;                     
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                     
 memcpy(line,(char *)&len,4);
 for(i=412;i>0;i-=4) fwrite(line,1,4,stream1);

 /* LIST movi */
 strcpy(line,"LIST");          /* line 65524 */
 fwrite(line,1,4,stream1);
 len=130048-65532+entries_real*(3*width*height+512)+entries2*7168; 
 /* len to the end */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"movi");          
 fwrite(line,1,4,stream1);
 strcpy(line,"ix00");          /* fcc, index to stream 1 */
 fwrite(line,1,4,stream1);
 len=32248;                    /* cb, fixed len of index ix00 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=16777218;                 /* wLongsPerEntry|bIndexSubType|bIndexType */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries;                  /* nEntriesInUse */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"00db");          /* dwChunkId */
 fwrite(line,1,4,stream1);
 video_off=130048;             /* qwBaseOffset (int 64) */
 /* this number is constant and depends only on the header we write */
 /* not at all on the size and number of data (video or audio) chunks */ 
 memcpy(line,(char *)&video_off,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwBaseOffset (int 64) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwBaseOffset (int 64) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=8;                        /* qwBaseOffset (int 64), first offset */
 video_off-=8;                 /* if we wrote 8 as the first offset... */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=3*width*height;           /* dwReserved, data size of the first chunk */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);     /* entry 0 is now written */ 
 empties=0;
 for(i=1;i<entries_real;i++){ /* write the entries 1...entries_real-1 */
  /* entries_real=entries-empties, empties are give below      */ 
  /* the address of a video chunk is                           */
  /* 130048+i*(3*width*height+512)+audios*7168                 */
  /* where i= the number of video chunks before this chunk and */
  /*  audios= the number of audio chunks before this chunk     */
  /* the i=0 index entry is 8 and points to 8+130040=130048    */
  /* so, index entry i is                                      */
  /* 130048+i*(3*width*height+512)+audios*7168-130040          */

#ifdef CODE_LIKE_ROXIO
  /* find how many audio blocks were before this frame */
  for(k=0,lim=0;k<15 && lim<=i;lim+=interleave[k++]);
  audios=(k-1)*12; /* audios are in blocks of 12 */
  if(k>=9) audios+=1;  /* but there is one block with 13 */
  if(k>=11) audios-=1; /* and one with 11 */
  len=8+i*(3*width*height+512)+audios*7168;
#else
  audios=(i/12)*12; /* audios are in blocks of 12 */
  len=8+i*(3*width*height+512)+audios*7168;
#endif

  /* this is the 5 empties,   empties=entries-entries-real       */
  /* insert an index entry with offset=0 and size has bit 32 set */
  if(i==79 || i==94 || i==105 || i==117 || i==148) {
   k=0;
   memcpy(line,(char *)&k,4);
   fwrite(line,1,4,stream1);
   memcpy(line,(char *)&k,4);
   line[3]=0x80; /* set bit 32 */
   fwrite(line,1,4,stream1);
   empties++;
  }

  /*  printf("write_video 00dbchunk i=%d index_offset=%d\n",i,len);getchar();*/
  memcpy(line,(char *)&len,4); /* dwOffset */
  fwrite(line,1,4,stream1);
  len=3*width*height;          /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
 }
 /* how many did we write? from i=0 to i=entries-1-empties and */
 /* additionally we wrote empties*8-bytes  */
 count=32248-24-entries*8;
 while(count>0) { /* write unused entries to the index */
  len=0;                        /* dwOffset */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  len=0;                        /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  count-=8;
 }

 /* audio index  starting at 97792 */
 strcpy(line,"ix01");          /* fcc, index to stream 1 */
 fwrite(line,1,4,stream1);
 len=32248;                    /* cb, fixed len of index ix01 */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=16777218;                 /* wLongsPerEntry|bIndexSubType|bIndexType */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=entries2;                  /* nEntriesInUse */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 strcpy(line,"01wb");          /* dwChunkId */
 fwrite(line,1,4,stream1);
 len=130048+12*(3*width*height+512); /* qwBaseOffset (int 64) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwBaseOffset (int 64) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 len=0;                        /* qwBaseOffset (int 64) */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);
 /* here starts audio index, the first offset is 8 */
 offset=8;                        /* first offset */
 memcpy(line,(char *)&offset,4);
 fwrite(line,1,4,stream1);
 len=7056;                     /* first entry size */
 memcpy(line,(char *)&len,4);
 fwrite(line,1,4,stream1);

 for(i=1;i<entries2;i++){    /* write entries 1...entries2-1        */

#ifdef CODE_LIKE_ROXIO
  if(i==96)       k=8;
  else if(i==108) k=9;
  else            k=(i/12)+1;
 
  for(k0=0,lim=0;k0<k && k0<15;lim+=interleave[k0++]);
  len=offset+(lim-interleave[0])*(3*width*height+512)+i*7168;
#else

  /* the correct place of the audio chunk in the file is            */
  /* place_i=130048+lim*(3*width*height+512)+i*7168                 */
  /* where i is the number of audio chunks before this chunk        */
  /* and lim is the number of video chunks before this audio frame  */
  /* i=0 index=offset corresponds to 130048+12*(3*width*height+512) */
  /* i.e., index=offset+place_0-place_0                             */
  /* yielding for any i the formula                                 */
  /* index=offset+place_i-place_0.    Simplified it gives           */
  /* index=offset+(lim-12)*(3*width*height+512)+i*7168              */

  lim=12*((i/12)+1);
  len=offset+(lim-12)*(3*width*height+512)+i*7168;
#endif

  memcpy(line,(char *)&len,4); /* dwOffset */
  fwrite(line,1,4,stream1);
  len=7056;                     /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
 }
 count=32248-24-entries2*8;
 while(count>0) { /* write unused entries to the index */
  len=0;                        /* dwOffset */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  len=0;                        /* dwSize */
  memcpy(line,(char *)&len,4);
  fwrite(line,1,4,stream1);
  count-=8;
 }
 /* header countains now 130048 bytes */

}

int next_chunk(stream,name,offset) 
FILE *stream;char *name;int *offset;
{
  char line[5];

 fseek(stream,*offset,0);
 while(1) {
  if(!fread(line,1,4,stream)) return 1;
  if(!memcmp(line,name,4)) break;  
  *offset+=4;
 }
 fseek(stream,*offset,0); /* unread name */
 *offset+=4;
 return 0;
}

diffe_avi()
{
 char line3[32],line1[5],line2[5];
 FILE *stream1,*stream2;
 int counter,n1,n2;

 stream1=fopen("/home/jorma/audicity/testavi.avi","rb");
 stream2=fopen("/home/jorma/audicity/test.avi","rb");
 rewind(stream1);rewind(stream2);
 counter=0;
 while(1) {
   if(!fread(line1,1,4,stream1)) break;
   if(!fread(line2,1,4,stream2)) break;
   if(memcmp(line1,line2,4)) {
     printf("%d difference\n", counter);
     memcpy((char *)&n1,line1,4);
     binary(line3,line1,32);
     printf("stream1(test) %s %d\n",line3,n1);
     memcpy((char *)&n2,line2,4);
     binary(line3,line2,32);
     printf("stream2(orig) %s %d\n",line3,n2);
     getchar();  
   }
   counter+=4;
 }
 printf("finished\n");
 fclose(stream1);fclose(stream2);
 return 1;
}

/**********************************************************************
 * write_avi
 * writes uncompressed video avi where is silent audio stream
 * interleaving is 12 chunks video 12 chunks audio
 * the header adds 5 index=0 size=2**32 entries, which are here
 * called empties. With entries=163 codes 6.48 sec video.
 * as uncompressed makes very big files, it is better to code
 * video in such short clips. Convert then to MP4 with VLC MediaPlayer.
 **********************************************************************/
write_avi(name,xstart,ystart,width,height,magn)
char *name;int xstart,ystart,width,height;float magn;
{
 int i,len,lim,num,dbsize;
 int entries, entries2,entries_real;
 char *buf;
 FILE *stream;
 char line[30];
#ifdef CODE_LIKE_ROXIO
 int counter,off1,off2,wb_entry,k,offset,i0,size;
 FILE *stream2;
 stream2=fopen("/home/jorma/audicity/test.avi","rb");
#endif

 strcpy(line,"/home/jorma/audicity/");
 strcat(line,name);
 stream=fopen(line,"wb+");
 if(!stream) {printf("cannot create a file\n");return 1;}

 /*
 width=320;height=240;
 width=640;height=480;
 width=772;height=434; 
 xstart=0;ystart=20;magn=1.2;
 */


 entries=163;entries2=162;
 /* entries_real is entries-empties */
 /* we decide how many empties to put to video index, now it is 5 */
 entries_real=entries-5;

 dbsize=8+3*width*height; /* 00db data size, 8 byte beader and data */ 
 len=dbsize+504;          /* 00db chunk size data+512 bytes         */
 buf=malloc(len);
 if(!buf) {printf("no memory\n");return 1;}

 /* write the header */
 write_video_avi_header(stream,width,height,entries,entries2,
    entries_real);

#ifdef CODE_LIKE_ROXIO
 counter=off1=off2=130048; /* header size, constant */
 offset=97828; /* first 01wb size is at index at 97828, constant */
 i0=1;
 /* write 12 video chunks, then 12 audiochunks, almost so */
 k=0;wb_entry=0;
 while(entries_real>0) {
  if(entries_real<interleave[k]) lim=entries_real; 
  else lim=interleave[k];
  entries_real-=lim;
  k++;
  for(i=0;i<lim;i++) {     
    /*
   if(next_chunk(stream2,"00db",&off1)) {entries_real=0;break;} 
   fread(buf,1,230912,stream2); 
   fseek(stream,counter,0);
    */
   read_avi_buf(buf,xstart,ystart,width,height,magn);
   strcpy(buf+dbsize,"JUNK"); 
   buf[dbsize+4]=0xf0;
   buf[dbsize+5]=1;
   memset(buf+dbsize+6,0,498);

   fwrite(buf,1,dbsize+504,stream);
   counter+=dbsize+504;
  }
  if(entries2<12) lim=entries2; 
  else lim=12;
  if(wb_entry==84) lim=13;
  else if(wb_entry==109) lim=11;
  entries2-=lim;
  for(i=0;i<lim;i++) {
    /*
   if(next_chunk(stream2,"01wb",&off2)) {entries2=0;break;}
   fread(buf,1,7168,stream2); 
   memcpy((char *)&size,buf+4,4);
   fseek(stream,offset,0);   
   fwrite(buf+4,1,4,stream); 
   offset+=8;
   fseek(stream,counter,0);  
    */
   
   set_avi_audio(buf);
   strcpy(buf+7064,"JUNK");
   num=96;
   memcpy(buf+7068,(char *)&num,4);
   memset(buf+7072,0,96);
   

   fwrite(buf,1,7168,stream);
   counter+=7168;
   wb_entry++;
  }
 }
 for(i=0;i<entries2;i++) {
   /*
  if(next_chunk(stream2,"01wb",&off2)) {entries2=0;break;}
  fread(buf,1,7168,stream2); 
  memcpy((char *)&size,buf+4,4);
  fseek(stream,offset,0);   
  fwrite(buf+4,1,4,stream); 
  offset+=8;
  fseek(stream,counter,0);  
   */
  
  set_avi_audio(buf);
  strcpy(buf+7064,"JUNK");
  num=96;
  memcpy(buf+7068,(char *)&num,4);
  memset(buf+7072,0,96);
  

  fwrite(buf,1,7168,stream);
 }
#else

 /* write 12 video chunks, then 12 audiochunks */
 while(entries_real>0) {
  if(entries_real<12) lim=entries_real; 
  else lim=12;
  entries_real-=lim;

  for(i=0;i<lim;i++) {
   read_avi_buf(buf,xstart,ystart,width,height,magn);
   strcpy(buf+dbsize,"JUNK"); 
   buf[dbsize+4]=0xf0;
   buf[dbsize+5]=1;
   memset(buf+dbsize+6,0,498);
   fwrite(buf,1,dbsize+504,stream);
  }

  if(entries2<12) lim=entries2; 
  else lim=12;
  entries2-=lim;

  for(i=0;i<lim;i++) {
   set_avi_audio(buf); /* set empty audio chunk */
   strcpy(buf+7064,"JUNK");
   num=96;
   memcpy(buf+7068,(char *)&num,4);
   memset(buf+7072,0,96);
   fwrite(buf,1,7168,stream);
  }
 }
 for(i=0;i<entries2;i++) {
  set_avi_audio(buf); /* set empty audio chunk */
  strcpy(buf+7064,"JUNK");
  num=96;
  memcpy(buf+7068,(char *)&num,4);
  memset(buf+7072,0,96);
  fwrite(buf,1,7168,stream); 
 }
#endif
 free(buf);
 fclose(stream);

#ifdef CODE_LIKE_ROXIO
 fclose(stream2);
#endif
}


int read_avi_buf(buf,xstart,ystart,width,height,magn) 
     char *buf;int xstart,ystart,width,height;float magn;
{
 int i,j,off,off1,red,green,blue,n,id;
 int yc,xc,ykoord,xkoord;
 unsigned long pixel;char *buf1;

 n=0;
 memcpy(buf,"00db",4);         /* fcc */
 memcpy(buf+4,(char *)&n,4);   /* cb */
 
 buf1=buf+8;
 off1=3*width+8;
 /* j=0 */
 for(i=-width;i<width;i++) {
  off=3*i+off1;
  xc=i;
  yc=height-1;
  if(xc<0) {xc+=width;yc=0;}
  ykoord=ystart+(int)(magn*(19.0/16.0)*(float)yc);
  xkoord=xstart+(int)((float)xc*magn);
  pixel=getpixel2c(xkoord,ykoord);
  red=(pixel>>16)&0xff;
  green=(pixel>>8)&0xff;
  blue=pixel&0xff;
  buf1[off]=green;
  buf1[off+1]=blue;
  buf1[off+2]=red;
 }

 /* j=1,...,height-2 */
 for(j=1;j<height-1;j++) {
  for(i=0;i<width;i++) {
   off=3*(i+width*j)+off1;
   yc=height-1-j; 
   ykoord=ystart+(int)(magn*(19.0/16.0)*(float)yc);
   xkoord=xstart+(int)((float)i*magn);
   pixel=getpixel2c(xkoord,ykoord);
   red=(pixel>>16)&0xff;
   green=(pixel>>8)&0xff;
   blue=pixel&0xff;
   buf1[off]=green;
   buf1[off+1]=blue;
   buf1[off+2]=red;
  }
 }
 return 0;
}        
