/*******************************************
* EDITOR1.C 	2-dimensional picture editor
* Author:     	Jorma Jormakka
* Date:   	2.9.92
********************************************/
#include <string.h>
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "pmenus.ext"
#define LIMDBAR 680
JMPTABLE e_table[12];
extern JMPTABLE *c_table;
extern int vobjmode;
int debug;
extern int nocolor,pensize,color;
extern VECTOR_OBJECT *cvobj,*firstvobj,*lastvobj;
extern VECTOR_OBJECT *create_vector_obj();
extern FILE *open_eps(); 
extern void draw_vobj();
extern int xxmin,yymin,xxmax,yymax;
extern oldX,oldY;
int exit_vect_ed=1;
/*unsigned char palette[16]={0,1,2,3,4,5,7,20,56,57,58,59,60,61,62,63};*/
unsigned char palette[16]={0,9,26,54,36,13,10, 7,56,59,58, 6,37,61,62,63};
int saved=0;

int main(argc,argv) int argc; char **argv;
{
 int i;
 defaultfont=2;
 xxmin=0;yymin=0;xxmax=500;yymax=350;
 if(init_font(defaultfont)) {printf("problems in loading font\n");getch();return(1);} 
 if(init_font2(6)) {printf("problems in loading font\n");getch();return(1);}   
 if(initPool(0,0,0,0)) return(0);

#ifdef DOS_SYSTEM
#ifdef NO_SUPER_VGA 
 initgraph(18,1); 
#else
 initvesagraph(0x102,1);
#endif
#else
 /* create and map a window in X11 */
 initgraph(argc,argv); 
#endif 

 term=I86;lg=ENGL;plg=FINN | POLI;bgcol=1;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 firstvobj=lastvobj=cvobj=0;vobjmode=0; 
 for(i=0;i<16;i++) setVGApalette(i,(int)palette[i]); 


 editor();

#ifdef DOS_SYSTEM
#ifdef NO_SUPER_VGA  
 endgraph();
#else
 endvesagraph();
#endif  
#else
 endgraph();
#endif

 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 return(0);
}
/************************************************
*   editor()
*************************************************/ 
int editor()
{
 int i,x,y;
 if(init_win(0,0)) return(1);

 fgbuffer=(char *)malloc(88*200);if(!fgbuffer) return(1);

 if(initPool(1,1200*cr,0,0)) return(1);
 nocolor=15;pensize=0;

 clearwin(0,0,X__max,Y__max,nocolor);


 getdrawbar(LIMDBAR+8);

 nsedi_ope();
  
 loadimage();
 
 /* fill_editor1menu(8,11,11,50,2,7*cs,365,30*cs,3*cs+11*cr,7,1,3,9,0);   */

 /*       
 make_input_window(2,0,0,65*cs,3*cs+30*cr,15,1,0,0,"cedi.edi",9,60,-1,vect_ed);
 */

 do_engine1(2,c_table);

 /*
 do_edi1_engine(2,e_table);
 */

/* savedrawbar();*/
 return(free_win(1,0));  
}
/***************************************************
* display manager of the editor
****************************************************/
int do_edi1_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,set_palette=0;
 unsigned char ch;
 int color_area_flag=0;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize;

 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   oldX=X;oldY=Y;
   
   command=do_operations();
   if(command==1) {
    pensize=0;
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) return(1); /* exit asked */
   }
   else if(command== -1) {
     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {
     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){
      exit_vect_ed=0;	
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return(1); /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) vect_ed(buttons,X,Y);     
    else {
     if(X<LIMDBAR) {
      if(color_area_flag) {
       color_area_flag=0;
       flood_fill(X,Y,color,0,0,607,Y__max);
      }
      else {
       if(use_marker) marker(X,Y,CUROFF,3,3);
       else {
        if(X>oldX) X=oldX+(pensize<X-oldX?pensize:X-oldX);
        else X=oldX-(pensize<oldX-X?pensize:oldX-X);
        if(Y>oldY) Y=oldY+(pensize<Y-oldY?pensize:Y-oldY);
        else Y=oldY-(pensize<oldY-Y?pensize:oldY-Y);
       }
       fillbox(X,Y,pensize,pensize,color);
       if(use_marker) marker(X,Y,CURON,3,3);      
      }
     }
     else {
      if(use_marker) {marker(X,Y,CUROFF,3,3);use_marker=0;pensize=oldpensize;}
      if(Y<320) {
       color=Y/20;if(!pensize) pensize=1;     	
       if(set_palette) {	
        k=palette[color];
        while(1) {       
         ch=getch();
         if('y'==ch || 'Y'==ch) break;
         else if ('?'==ch) {
          xkoord=LIMDBAR+16;ykoord=color*20+3;
          X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;  
          textn(int_to_string((long)k),0,15);         	
          ch=getch();
          fillbox(LIMDBAR+8,color*20,24,20,1);           
          fillbox(LIMDBAR+9,color*20,20,20,color);
          if('y'==ch || 'Y'==ch) break;
         }
         else {
          k++;if(k==64) k=0;        	
          setVGApalette(color,k);
          palette[color]=k;        	
         }
        }
        set_palette=0;              
       }
      }
      else if (Y<340) {	color=nocolor;oldpensize=pensize;
     			pensize=10;use_marker=1;marker(590,340,CURON,3,3);}
      else if (Y<360) color_area_flag=1;
      else if (Y<380) {
       fill_pensizemenu(0,5,5,20,5,61*cs,360,15*cs,3*cs+5*cr,15,0,5,9,0);
       chosen=(int *)wd_object[4].p3;      
       u2=(char **)wd_object[4].p2;
       for(i=0;i<5;i++) {
        strcpy(line,u2[i]);line[7]=0; 	
        if(pensize==string_to_int(&line[5])) {chosen[i] |= 1;break;}
       }      
       if(pull_down(5)) return(1);
       edi1_operations(5);free_pop_up_menu(5);
      }
      else if (Y<400) {
       while(kbhit()) getch(); /* flush input */
       change_palette_info();
       set_palette=1;
      }     
      else if (Y<420) {
       if(wd_object[2].type==FREE_OBJ) {
	 
        make_transparent_card(3,10,10,"lense.xxx",34,34,1);
	 
        make_pixel_draw(4,35*cs,298,11+32*5+4,11+32*5+4, 15,0,"largened.xxx",3);        
        put_wd_objects(3,4);
       }
      }     
      else if (Y<440) {
       if(wd_object[5].type==FREE_OBJ) {     	
        make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);     	
        put_wd_objects(6,6);
       }      
      }      
      else if (Y<460) { /* replace color in cut buffer */
       if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
       else {
        fill_chgcolormen(2,1,1,30,9,35*cs,420,40*cs,3*cs+1*cr,7,0,5,9,0);
        if(pull_down(9)) return(1); 
        edi1_operations(9);free_pop_up_menu(9);       
       }
      }
      else if (Y<480) { /* match pattern */
       if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
       else {     
        if(wd_object[9].type==FREE_OBJ) {
         make_replace_buffer(10,35*cs,298,3*cs+30*5+2,3*cs+30*5+2,7,0,"replace.xxx",6);
         put_wd_objects(10,10);
        }
       }
      }     
     }     
    }
   }
  } while(!kbhit());
 }
}
/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;

{
 int i,j,m,n,x,y,color;
 int *chosen,class,col1,col2;
 LINE10 *u1;
 char **u2,*pp;
 FILE *stream;
 char line[30];
 char buf[30];
 unsigned char *tmpplane;
 int x2,y2,isize;
 
 if(id!=2) saved=0; 	
 switch(id) {
  case 2:	/* edi1 menu */	
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   if(chosen[0] == 1) { /* quit */
    free_wd_objects();
    return(1); /* exit */	
   }
   else if(chosen[1] == 1) { /* read picture */
    x2=LIMDBAR;y2=180;isize=308; 
    pp=(char *)strchr(u1[0].name,(int)'.');
    if(pp && strcmp(pp,".pcx")) {
     if(get_picture(u1[0].name,0,0,&x2,&y2,&isize,palette)) return(0);
    }
    else if(pp && !strcmp(pp,".pcx")) {
     restore_screen(u1[0].name);
     return 0;
    }
   }
   else if(chosen[2] == 1 && saved==0) { /* save picture */
    pp=(char *)strchr(u1[0].name,(int)'.');
    if(pp && strcmp(pp,".pcx")) {
     if(save_picture(u1[1].name,0,0,LIMDBAR,180,308,palette)) return(0);
    }
    else if(pp && !strcmp(pp,".pcx")) {
     save_as_pcxfile(0,0,LIMDBAR,180,u1[1].name); return 0;
    }
    saved=1;    
   }
   else if(chosen[3] & 1) { /* call cut buffer menu */
    fill_cutbuffermenu(2,3,3,20,8,
   	 wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	30*cs,3*cs+3*cr,30,0,5,9,0);
    if(pull_down(8)) return(1);
    edi1_operations(8);free_pop_up_menu(8);    
   }   
   else if(chosen[4] & 1) { /* list files menu */   
    list_files(u1[2].name,11,
    	wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	30,5, 7,1,3,9,0);   
   }
   else if(chosen[5] == 1) { /* read screen */
    x2=LIMDBAR;y2=180;isize=308;
    strcpy(line,u1[3].name);strcat(line,"0.fn2");    
    if(get_picture(line,0,0,&x2,&y2,&isize,palette)) return(0);
    x2=LIMDBAR;y2=360;isize=308;
    strcpy(line,u1[3].name);strcat(line,"1.fn2");    
    if(get_picture(line,0,180,&x2,&y2,&isize,palette)) return(0);    
   }
   else if(chosen[6] == 1) { /* save screen */
    strcpy(line,u1[4].name);strcat(line,"0.fn2");
    if(save_picture(line,0,0,LIMDBAR,180,308,palette)) return(0);
    strcpy(line,u1[4].name);strcat(line,"1.fn2");    
    if(save_picture(line,0,180,LIMDBAR,360,308,palette)) return(0);    
   }   
   else if(chosen[7] == 1) { /* convert to PS */
    strcpy(line,u1[5].name);   
    if(convert_picture(line,0,0,500,350)) return(0);
    delay(100);buttons=0;
   }      
   else if(chosen[8] == 1) { /* clear screen */
    clearwin(0,0,500,350,15);
   }         
   else if(chosen[9] == 1) { /* put label */
    vobj_ope();
    label_ope(u1[6].name);
   }
   else if(chosen[10] == 1) { /* clean pcx */
    pp=(char *)strchr(u1[7].name,(int)'.');
    if(pp && !strcmp(pp,".pcx")) {
     *pp=0;
     strcpy(buf,u1[7].name);
     *pp='.';
     strcat(buf,"b.pcx");
     clean_pcx(u1[7].name,buf);
     return 0;
    }    
   }   
   if(chosen[2] != 1) saved=0;
   break;

  case 5: /* pensize menu */  
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;
      
   for(i=0;i<5;i++) {
    if(chosen[i]&1) {
     strcpy(line,u2[i]);line[7]=0;
     pensize=string_to_int(&line[5]);break;}
   }
   break;
   
  case 8: /* cut buffer menu */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   j=6;/* cut buffer identifier */  
   if(chosen[0] & 1) { /* kill cut buffer */
    if(wd_object[j-1].type!=FREE_OBJ)
    {       
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
   }
   else if (chosen[1] & 1) { /* save cut buffer */
    j--;
    if(wd_object[j].type==FREE_OBJ) no_cutbuffer();
    else {        
     if(save_picture(u1[0].name,
    	wd_object[j].xcord+1,wd_object[j].ycord+1,
    	wd_object[j].xcord+wd_object[j].xsize-1,
        wd_object[j].ycord+wd_object[j].ysize-1,
        wd_object[j].isize,palette)) return(1);   
    }
   }
   else if(chosen[2] == 1) { /* read cut buffer */
    j--;
    if(wd_object[j-1].type!=FREE_OBJ)
    { 
     x=wd_object[j].xcord;
     y=wd_object[j].ycord;          
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
    else x=100;y=100;
       
    x2=250;y2=250; 	    
    if(get_picture(u1[1].name,x+1,y+1,
      &x2,&y2,&isize,palette)) return(1);
      
    make_transparent_card(j+1,x,y,"cutbuffer.xxx",x2-x,y2-y,0);     	
    wd_object[j].i1=0;         
    put_wd_objects(j+1,j+1);
               
    save_buf2(wd_object[j].xcord,wd_object[j].ycord,1,1,
  	wd_object[j].xsize-1,wd_object[j].ysize-1,wd_object[j].xcord&7,
  	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);
   }   
   break;      
  case 9: /* change color in cut buffer */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   j=6; /* cut buffer identifier */   
   col1=string_to_int(u1[0].name);col2=string_to_int(u1[1].name);
   if(col1!=col2)
    change_color(col1,col2,
        	wd_object[j-1].xcord,wd_object[j-1].ycord,
        	wd_object[j-1].xsize,wd_object[j-1].ysize,
        	wd_object[j-1].clength,wd_object[j-1].isize,
        	wd_object[j-1].foreground);
   break;  
  case 10: /* replace buffer */
   j=wd_object[id-1].i1-1; /* cut buffer id -1 */
   wd_object[j].i1=0;      
   for(m=1;m<wd_object[j].xsize-1;m++) {
    for(n=1;n<wd_object[j].ysize-1;n++) { 
     if(match_replacebuffer(wd_object[j].foreground,wd_object[id-1].p1,
         	m,n,wd_object[j].clength,wd_object[j].isize,9))
     {
      replace(wd_object[j].foreground,(char *)wd_object[id-1].p2,
         	m,n,wd_object[j].clength,wd_object[j].isize,9,j);
     }         
    }
   }
   break;
  case 11: /* list files menu */
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;   
   for(n=0;!(chosen[n] & 1) && n<wd_object[id-1].i2 ;n++);       
   if(n<wd_object[id-1].i2) {
    x2=LIMDBAR;y2=180;isize=308;
    if(get_picture(u2[n],0,0,&x2,&y2,&isize,palette)) return(0);   	
   }  
   break;
 }
 return(0);
} 
int fill_editor1menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Quit ");
 strcpy(u2[1],"Load picture ");
 strcpy(u2[2],"Save picture ");
 strcpy(u2[3],"Cut buffer menu "); 
 strcpy(u2[4],"List       files");
 strcpy(u2[5],"Load screen ");
 strcpy(u2[6],"Save screen ");   
 strcpy(u2[7],"Save to PS ");    
 strcpy(u2[8],"Clear screen ");     
 strcpy(u2[9],"Make label ");      
 strcpy(u2[10],"Clean pcx ");       
 
 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;
 strcpy(u1[0].name,"");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 strcpy(u1[1].name,""); 
 
 u1[2].xcord=strlen("List ")*cs; 
 u1[2].ycord=4*cr; 
 u1[2].parmax=1; u1[2].size= u1[2].bsize=5;
 strcpy(u1[2].name,"*.fn2"); 
 
 u1[3].xcord=strlen(u2[1])*cs; 
 u1[3].ycord=5*cr; 
 u1[3].parmax=1;
 strcpy(u1[3].name,"screen");
 
 u1[4].xcord=strlen(u2[2])*cs; 
 u1[4].ycord=6*cr; 
 u1[4].parmax=1;
 strcpy(u1[4].name,"screen"); 
 
 u1[5].xcord=strlen(u2[6])*cs; 
 u1[5].ycord=7*cr; 
 u1[5].parmax=1;
 strcpy(u1[5].name,"figure.ps"); 
 
 u1[6].xcord=strlen(u2[7])*cs; 
 u1[6].ycord=9*cr; 
 u1[6].parmax=1;
 strcpy(u1[6].name,"A"); 
 
 u1[7].xcord=strlen(u2[10])*cs; 
 u1[7].ycord=10*cr; 
 u1[7].parmax=1;
 strcpy(u1[7].name,""); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}

int fill_chgcolormen(max,pmax,window,linelength,id,x,y,xsize,ysize,
 col1,col2,col3,col4,col5)
int max,pmax,window,linelength,id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Change color    to    in Cutbuffer");
 
 u1[0].xcord=13*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].bsize=u1[0].size=2; 
 strcpy(u1[0].name,"1");
 
 u1[1].xcord=19*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].bsize=u1[1].size=2; 
 strcpy(u1[1].name,"1"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}
/***********************************************
* converts and prints to pdf
***********************************************/

int convert_picture(line,x1,y1,x2,y2) char *line;int x1,y1,x2,y2;
{
 int i,j,i1,j1,i2,j2,i3,j3,k,color,point,drawn,found;
 int table[8][2];int ix,jy,ix2,jy2;
 FILE *stream;
 VECTOR_OBJECT *o,*v1; 
 
 /* hide vector objects */
 for(o=lastvobj;o;o=o->last) {
  draw_vobj(2,o,o->buf,o->x1,o->y1,0,0,o->x2,o->y2,1,o->color);         
 }	
 
 stream=open_eps(line,"psexampl.dat");
 /* straight corners first */
 table[0][0]=1;table[0][1]=0;
 table[1][0]=0;table[1][1]=1;  
 table[2][0]=-1;table[2][1]=0;    
 table[3][0]=0;table[3][1]=-1;          
 /* angles then */
 table[4][0]=1;table[4][1]=-1;
 table[5][0]=1;table[5][1]=1; 
 table[6][0]=-1;table[6][1]=1;   
 table[7][0]=-1;table[7][1]=-1;

 color=0;drawn=4;

 while (1) {
  found=0;

  for (i=x1;i<x2;i++) {
   for (j=y1;j<y2;j++) { 	
    point=put_point1(i,j,drawn,x1,y1,x2,y2);
    if(point!=color) put_point1(i,j,point,x1,y1,x2,y2);   
    else {
     i1=i;j1=j;found=1;
    }
    if(found) break;
   }
   if(found) break;   
  }
  if(found) {
   /* follow the point */
   i2=j2=-1;i3=i1;j3=j1;
   while (found) {
    found=0;
    for (k=0;k<8;k++) {
     i=i1+table[k][0];j=j1+table[k][1];
     if(1 /*i2!=i || j2!=j*/) {
      if(i>=x1 && i<=x2 && j>=y1 && j<=y2) {
       point=put_point1(i,j,drawn,x1,y1,x2,y2);
       if(point!=color) {
        put_point1(i,j,point,x1,y1,x2,y2);
       }
       else {
        /* smoothen corners*/
        if(j!=j1 && i!=i1) { /* i1,j1, i,j meet at corners */ 
         ix=i+i-i1;jy=j;ix2=i;jy2=j+j-j1;
       	
         point=put_point1(ix,jy,drawn,x1,y1,x2,y2);
         if(point!=color) {
          put_point1(ix,jy,point,x1,y1,x2,y2);
          point=put_point1(ix2,jy2,drawn,x1,y1,x2,y2);         	
          if(point!=color) {put_point1(ix2,jy2,point,x1,y1,x2,y2);}
          else j=jy2;
         }
         else i=ix;
        }
        draw_line(i1,j1,i,j,0,1);
        i2=i1;j2=j1;i1=i;j1=j;found=1;break;
       }
      }      
     }
    }
    if(!found) {
     /* last drawn is i1,j1 */
     if(i2!=-1) { /* if there was drawn a point before */
      i=i1+(i1-i2);
      j=j1+(j1-j2);      
      point=put_point1(i,j,drawn,x1,y1,x2,y2);
      /* if drawn point at (i,j), connect i1,j1 to i,j */      
      if(point!=drawn) put_point1(i,j,point,x1,y1,x2,y2);
      else {draw_line(i1,j1,i,j,0,1);found=1;}            
     }
     /* still not found */
     if(!found) { /*looping in wrong direction */
      for (k=0;k<8;k++) {
       i=i1+table[k][0];j=j1+table[k][1];
       point=put_point1(i,j,drawn,x1,y1,x2,y2);
       if(point!=drawn) put_point1(i,j,point,x1,y1,x2,y2);
       else draw_line(i1,j1,i,j,0,1);   
      }
     } 
     /* connect the first point to all red points */
     for (k=0;k<8;k++) {
      i=i3+table[k][0];j=j3+table[k][1];
      point=put_point1(i,j,drawn,x1,y1,x2,y2);
      if(point!=drawn) put_point1(i,j,point,x1,y1,x2,y2);
      else draw_line(i3,j3,i,j,0,1);
     }         	
     found=0;
    }
   }

  }
  else break;

 }

 for(o=lastvobj;o;o=o->last) { 	
  draw_vobj(2,o,o->buf,o->x1,o->y1,o->x2,o->y2,0,0,2,o->color);
 }	

 /* write all vector objects on a file and remove them */
 for(o=lastvobj;o;o=v1){
  v1=o->last;
  draw_vobj(4,o,o->buf,o->x1,o->y1,o->x2,o->y2,0,0,2,o->color);
  remove_vobj(o);
 }	
 firstvobj=lastvobj=cvobj=0; 
 close_eps(stream);
 return 0;
}
/************************************************
* Chain editor menu contains push buttons for submenus
*
* Arrow
* Pointer		
* Exit
*************************************************/ 
int vobj_ope()
{
 int i;int x,y,xsize,ysize;VECTOR_OBJECT *nextvobj;

/* put icons */i=0;
 x=X__max-150;y=40;getpicture("arrow.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,arrow_ope);
  
 x=X__max-150;y=70;getpicture("pointer.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,pointer_ope);
   
 x=X__max-150;y=100;getpicture("exit.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&e_table[i++],x,y,xsize,ysize,exit1_ope);
   
 fill_jmptable(&e_table[i++],0,0,0,0,NULL);

 return(0); 
}
int exit1_ope()
{
 exit_vect_ed=1;
 return 0;	
}

