/*******************************************
* NSEDI.C       input data editor
* Author:     	Jorma Jormakka
* Date:   	18.3.2005
********************************************/
#include <string.h>
#include "x.ext"
#include "pmenus.ext"
#include "win.ext"
#include "text.ext"

extern double browness();
#define CEDI_MODULE
extern double exp_distr();
extern double erl_distr();
extern double unif_distr();
extern long even_distr();
PathData *pathdata[40];
int pathsize[40];
int pathcol[40];
int pathindex;
extern unsigned long getpixel2c();
extern XImage   *screenbuf;
extern XImage   *screenbuf1;
extern XColor *xcolor;
extern XColor *xcolor2;
extern int xxmin,yymin,xxmax,yymax;
extern unsigned long getpixel2c();
int X1_image=0,Y1_image=0,X2_image=474,Y2_image=549;
JMPTABLE c_table[30];
int color_area_flag=0; 
int color_request_flag=0;
extern int vobjmode;
int debug;
extern int nocolor,pensize,colorZ;
extern VECTOR_OBJECT *cvobj,*firstvobj,*lastvobj;
extern VECTOR_OBJECT *create_vector_obj();
extern FILE *open_eps(); 
extern void draw_vobj();
extern int xxmin,yymin,xxmax,yymax;
extern oldX,oldY;
int exit_vect_ed=1;
extern int old_i,old_j,older_i,older_j,oldest_i,oldest_j;
unsigned char palette[16]={0,9,26,54,36,13,10, 7,56,59,58, 6,37,61,62,63};
int saved=0;

int main(argc,argv) int argc; char **argv;
{
 int i,j;
 /* defaultfont=2; standard system font */
 /* defaultfont=35; is greek letters */
 defaultfont=7;

 xxmin=0;yymin=0;xxmax=500;yymax=350;
 if(init_font(defaultfont)) {printf("problems in loading font\n");getch();return(1);} 
 if(init_font2(6)) {printf("problems in loading font\n");getch();return(1);}   
 if(initPool(0,0,0,0)) return(0);

#ifdef DOS_SYSTEM
#ifdef NO_SUPER_VGA 
 initgraph(18,1); 
#else
 initvesagraph(0x102,1);
#endif
#else
 /* create and map a window in X11 */
 initgraph(argc,argv); 
#endif 

 term=I86;lg=ENGL;plg=0 /*FINN | POLI*/;bgcol=1;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 firstvobj=lastvobj=cvobj=0;vobjmode=0; 
 for(i=0;i<16;i++) setVGApalette(i,(int)palette[i]); 


 editor();

#ifdef DOS_SYSTEM
#ifdef NO_SUPER_VGA  
 endgraph();
#else
 endvesagraph();
#endif  
#else
 endgraph();
#endif

 if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 return(0);
}
/************************************************
*   editor()
*************************************************/ 
int editor()
{
 int i,x,y,m;
 int xsize,ysize;VECTOR_OBJECT *nextvobj;

 if(init_win(0,15)) return(1);

 fgbuffer=(char *)malloc(FGSIZE);if(!fgbuffer) return(1);
 bgbuffer=(char *)malloc(FGSIZE);if(!bgbuffer) return(1);

 if(initPool(1,1200*cr,0,0)) return(1);
 nocolor=15;pensize=0;

 for(i=0;i<40;i++) {
  pathdata[i]=0;
  pathsize[i]=0;
  pathcol[i]=0;
 }
 pathindex=-1;

 xxmin=0;xxmax=LIMDBAR;yymin=0;yymax=Y__max;
 clearwin(0,0,X__max,Y__max,nocolor);

 /* drawing possibilities of GRPAH have been demonstrated in other demos */
#ifdef DRAWING_ACTIONS
 getdrawbar(LIMDBAR+8);
#endif

 firstvobj=lastvobj=cvobj=0;vobjmode=0;

 /* put icons */
 i=0;
 x=X__max-47;y=1;getpicture("plicon.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,plotter_ope);
 
 x=X__max-47;y=1+45*1;getpicture("simulate.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,simul_ope);
 
 x=X__max-47;y=1+45*2;getpicture("print.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,print_ope);

#ifdef NETEDI_ACTIONS
 x=X__max-47;y=1+45*3;getpicture("netedi.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,file_ope);
#endif

 x=X__max-47;y=1+45*4;getpicture("texit.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,texit_ope);


 y=240;
 x=X__max-40;getpicture("readic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,read_ope);
 
 x=X__max-80;getpicture("writeic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,write_ope);

 y+=35;
 x=X__max-40;getpicture("nodeic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,node_ope);
 
 x=X__max-80;getpicture("arrow.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,arrow_ope);
 
 y+=35;
 x=X__max-40;getpicture("queue.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,queue_ope);
 
 x=X__max-80;getpicture("pointer.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,pointer_ope);
 
 y+=35;
 x=X__max-40;getpicture("compile.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,compile_ope);
 
 x=X__max-80;getpicture("start.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,start_ope);

#ifdef NETEDI_ACTIONS
 y+=35;
 x=X__max-40;getpicture("teleic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,tele_ope);
 
 x=X__max-80;getpicture("exit.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,exit1_ope);

 y+=35;
 x=X__max-40;getpicture("vboxic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,vbox_ope);
 
 x=X__max-80;getpicture("vlineic.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,vline_ope);

 y+=35;
 x=X__max-40;getpicture("flag.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,nodeb_ope);  
   
 x=X__max-80;getpicture("plane.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,nodec_ope);  

 y+=35;
 x=X__max-80;getpicture("path.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,path_ope);  

 x=X__max-40;getpicture("pathed.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&c_table[i++],x,y,xsize,ysize,pathed_ope);  
#endif

 fill_jmptable(&c_table[i++],0,0,0,0,NULL);
 
 do_edi1_engine(1,c_table);

 for(i=0;i<40;i++) {
  if(pathdata[i]) free(pathdata[i]);pathdata[i]=0;
  pathsize[i]=0;pathcol[i]=0;
 }
 pathindex=-1;
/* savedrawbar();*/
 if(fgbuffer) free(fgbuffer);
 if(bgbuffer) free(bgbuffer);
 return(free_win(0,15));  
}
/***************************************************
* display manager of the editor
****************************************************/
int do_edi1_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,k1,set_palette=0;
 unsigned char ch;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize;
 int col11;
 LINE10 *u1;
 char buf1[30];int col2;int pixel,color;
 PathData *pathdata1;

 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   oldX=X;oldY=Y;
   if(!color_request_flag) {
    set_newpathdata(); 
    command=do_operations();
   }
   else {
    readmouse(&buttons,&X,&Y);

#ifdef DRAWING_ACTIONS    
    if(buttons==1 && !(X>=LIMDBAR+8 && X<LIMDBAR+8+20 && Y>=400 && Y<420))
    {
     color_request_flag=0;
     pixel=plot_point2(X,Y,0);
     drawpixel2(X,Y,pixel);
     color_by_pixel((unsigned long)pixel,0,&color,&col2);
     xkoord=LIMDBAR;ykoord=500;
     X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;
     strcpy(buf1,"x=     ");
     textn(buf1,0,15);  
     strcpy(buf1,"x=");
     strcat(buf1,int_to_string((long)X));
     textn(buf1,0,15);
     ykoord+=cr;
     strcpy(buf1,"y=     ");
     textn(buf1,0,15);  
     strcpy(buf1,"y=");
     strcat(buf1,int_to_string((long)Y));
     textn(buf1,0,15);
     ykoord+=cr;
     strcpy(buf1,"color1=     ");
     textn(buf1,0,15);  
     strcpy(buf1,"color1=");
     strcat(buf1,int_to_string((long)color));
     textn(buf1,0,15);
     ykoord+=cr;
     strcpy(buf1,"color2=     ");
     textn(buf1,0,15);    
     strcpy(buf1,"color2=");    
     strcat(buf1,int_to_string((long)col2));
     textn(buf1,0,15);
    }
#endif
    break;         	
   }
   if(command==1) {
    pensize=0;
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) return(1); /* exit asked */
    delay(100);flush_mouse();buttons=0;
   }
   else if(command== -1) {
     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {

     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){

      exit_vect_ed=0;	
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return(1); /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) vect_ed(buttons,X,Y);     
    else 
    {
#ifdef DRAWING_ACTIONS
     if(X<LIMDBAR) {
      if(color_area_flag) {
       color_area_flag=0;
       flood_fill(X,Y,colorZ,0,0,475,Y__max);
      }
      else {
       if(use_marker) marker(X,Y,CUROFF,3,3);
       else {
        if(X>oldX) X=oldX+(pensize<X-oldX?pensize:X-oldX);
        else X=oldX-(pensize<oldX-X?pensize:oldX-X);
        if(Y>oldY) Y=oldY+(pensize<Y-oldY?pensize:Y-oldY);
        else Y=oldY-(pensize<oldY-Y?pensize:oldY-Y);
       }
       fillbox(X,Y,pensize,pensize,colorZ);
       if(use_marker) marker(X,Y,CURON,3,3);      
      }
     }
     else if(X>=LIMDBAR+8 && X<LIMDBAR+8+20){
      if(use_marker) {marker(X,Y,CUROFF,3,3);use_marker=0;pensize=oldpensize;}
      if(Y<320) {
       colorZ=Y/20;if(!pensize) pensize=1;     	
       if(set_palette) {	
        k=palette[colorZ];
        while(1) {       
         ch=getch();
         if('y'==ch || 'Y'==ch) break;
         else if ('?'==ch) {
          xkoord=LIMDBAR+16;ykoord=colorZ*20+3;
          X1_max=X__max;Y1_max=Y__max;X1_min=Y1_min=0;  
          textn(int_to_string((long)k),0,15);         	
          ch=getch();
          fillbox(LIMDBAR+8,colorZ*20,24,20,1);           
          fillbox(LIMDBAR+9,colorZ*20,20,20,colorZ);
          if('y'==ch || 'Y'==ch) break;
         }
         else {
          k++;if(k==64) k=0;        	
          setVGApalette(colorZ,k);
          palette[colorZ]=k;
	 }        	
        }
       }
       set_palette=0;              
      }
      else if (Y<340) {	colorZ=nocolor;oldpensize=pensize;
     			pensize=10;use_marker=1;marker(590,340,CURON,3,3);}
      else if (Y<360) color_area_flag=1;
      else if (Y<380) {
       if(wd_object[4].type!=FREE_OBJ) break;
       fill_pensizemenu(0,5,5,20,5,61*cs,360,15*cs,3*cs+5*cr,15,0,5,9,0);
       chosen=(int *)wd_object[4].p3;      
       u2=(char **)wd_object[4].p2;
       for(i=0;i<5;i++) {
        strcpy(line,u2[i]);line[7]=0; 	
        if(pensize==string_to_int(&line[5])) {chosen[i] |= 1;break;}
       }      
       if(pull_down(5)) return(1);
       edi1_operations(5);free_pop_up_menu(5);
      }
      else if (Y<400) {
       if(GPLANES==16) color_request_flag=1;
       else if (GPLANES==4) {
        while(kbhit()) getch(); /* flush input */
        change_palette_info();
        set_palette=1;
       }
      }     
      else if (Y<420) {
       if(wd_object[2].type==FREE_OBJ) {	 
	make_transparent_card(3,10,10,"lense.xxx",34,34,1);
        make_pixel_draw(4,60*cs,298,11+32*5+4,11+32*5+4, 15,0,
         "largened.xxx",3);        
        wd_object[3].options |= MOVE_AS_RECTANGLE;
	put_wd_objects(3,4);
       }
      }     
      else if (Y<440) {
       if(wd_object[5].type==FREE_OBJ) {     	
        make_transparent_card(6,100,100,"cutbuffer.xxx",150,150,0);
	put_wd_objects(6,6);
       }      
      }      
      else if (Y<460) { /* replace color in cut buffer */
       if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
       else {
        fill_chgcolormen(2,1,1,30,9,35*cs,420,40*cs,3*cs+1*cr,7,0,5,9,0);
        if(pull_down(9)) return(1); 
        edi1_operations(9);free_pop_up_menu(9);       
       }
      }
      else if (Y<480) { /* match pattern */
       if(wd_object[5].type==FREE_OBJ) no_cutbuffer();
       else {     
        if(wd_object[9].type==FREE_OBJ) {
         make_replace_buffer(10,35*cs,298,
          3*cs+30*5+2,3*cs+30*5+2,7,0,"replace.xxx",6);
         put_wd_objects(10,10);
        }
       }
      }
     }
#endif
    }
   }
  } while(!kbhit());
 }
}
/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;

{
 int i,j,m,n,x,y,color;
 int *chosen,class,col1,col2;
 LINE10 *u1;
 char **u2,*pp;
 FILE *stream;
 char line[30];
 char buf[30];
 unsigned char *tmpplane;
 int x2,y2,isize,k1;
 double curspeed,dist,totaltime;
 int x2a,y2a,isizea;
 PathData *pathdata1;
 int xsave1,ysave1,col11;
 
 if(id!=2) saved=0; 	
 switch(id) {
  case 2:	/* edi1 menu */	
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;
   if(chosen[0] == 1) { 
     X1_image=string_to_int(u1[8].name);
     Y1_image=string_to_int(u1[9].name);
     X2_image=string_to_int(u1[10].name);
     Y2_image=string_to_int(u1[11].name);
    return 0; 	
   }    
   else if(chosen[1] == 1) { /* read picture */
    pp=(char *)strchr(u1[0].name,(int)'.');
    if(pp && !strcmp(pp,".fn2")) {
     if(get_picture(u1[0].name,0,0,&x2a,&y2a,&isizea,palette)) return(0);
     printf("x2a=%d y2a=%d isizea=%d\n",x2a,y2a,isizea);
    }
    else if(pp && (!strcmp(pp,".pcx") || !strcmp(pp,".gif"))) {
     loadimage(u1[0].name,(int)string_to_int(u1[12].name));
     return 0;
    }
   }
   else if(chosen[2] == 1 && saved==0) { /* save picture */
    pp=(char *)strchr(u1[1].name,(int)'.');
    if(pp && !strcmp(pp,".fn2")) {
      x2a=32;y2a=28;isizea=84;
     if(save_picture(u1[1].name,0,0,x2a,y2a,isizea,palette)) return(0);
    }
    else if(pp && !strcmp(pp,".pcx")) {
     X1_image=string_to_int(u1[8].name);
     Y1_image=string_to_int(u1[9].name);
     X2_image=string_to_int(u1[10].name);
     Y2_image=string_to_int(u1[11].name);
     writepcx(u1[1].name,X1_image,Y1_image,X2_image,Y2_image);
     return 0;
    }
    else if(pp && !strcmp(pp,".gif")) {
     X1_image=string_to_int(u1[8].name);
     Y1_image=string_to_int(u1[9].name);
     X2_image=string_to_int(u1[10].name);
     Y2_image=string_to_int(u1[11].name);
     writeGIF1(u1[1].name,X1_image,Y1_image,X2_image,Y2_image);
     return 0;
    }
    saved=1;    
   }
   else if(chosen[3] & 1) { /* call cut buffer menu */
    if(wd_object[7].type!=FREE_OBJ) return 0;
    if(wd_object[id-1].xcord+wd_object[id-1].xsize<X1_max) 
     fill_cutbuffermenu(2,3,3,20,8,
   	 wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	30*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5);
    else
     fill_cutbuffermenu(2,3,3,20,8,
   	 wd_object[id-1].xcord-31*cs,wd_object[id-1].ycord,
    	30*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5);

    if(pull_down(8)) return(1);
    edi1_operations(8);free_pop_up_menu(8);    
   }   
   else if(chosen[4] & 1) { /* list files menu */ 
    if(wd_object[10].type!=FREE_OBJ) return 0;  
    if(wd_object[id-1].xcord+wd_object[id-1].xsize<X1_max) 
     list_files(u1[2].name,11,
    	wd_object[id-1].xcord+wd_object[id-1].xsize,wd_object[id-1].ycord,
    	15,5,Co1,Co2,Co3,Co4,Co5);
     else    
      list_files(u1[2].name,11,
    	wd_object[id-1].xcord-16*cs,wd_object[id-1].ycord,
    	15,5,Co1,Co2,Co3,Co4,Co5);
   }
   else if(chosen[5] == 1) { /* make altitude curves */
    loadimage2(u1[3].name);
    return 0;
   }
   else if(chosen[6] == 1) { /* calculate altitude curves */
    altitude_algorithm1(u1[4].name);
    delay(100);flush_mouse();buttons=0;
    return 0;
   }   
   else if(chosen[7] == 1) { /* convert to PS */
    strcpy(line,u1[5].name);   
    if(convert_picture(line,0,0,500,350)) return(0);
    delay(100);buttons=0;
   }      
   else if(chosen[8] == 1) { /* clear screen */
    clearwin(0,0,476,Y__max,15);
   }         
   else if(chosen[9] == 1) { /* put label */
    label_ope(u1[6].name);
   }
   else if(chosen[10] == 1) { /* clean pcx */
    pp=(char *)strchr(u1[7].name,(int)'.');
    if(pp && !strcmp(pp,".pcx")) {
     *pp=0;
     strcpy(buf,u1[7].name);
     *pp='.';
     strcat(buf,"b.pcx");
     clean_pcx(u1[7].name,buf);
     return 0;
    }
   }    
   else if(chosen[11] == 1) { /* make distance data */
  
     strcpy(line,u1[14].name);  
     set_visibility_data(line,u1[15].name,u1[16].name,
      (int)string_to_int(u1[13].name));
  
   }   
   if(chosen[2] != 1) saved=0;
   break;

  case 5: /* pensize menu */  
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;
      
   for(i=0;i<5;i++) {
    if(chosen[i]&1) {
     strcpy(line,u2[i]);line[7]=0;
     pensize=string_to_int(&line[5]);break;}
   }
   break;
   
  case 8: /* cut buffer menu */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   j=6;/* cut buffer identifier */  
   if(chosen[0] & 1) { /* kill cut buffer */
    if(wd_object[j-1].type!=FREE_OBJ)
    {       
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
   }
   else if (chosen[1] & 1) { /* save cut buffer */
    j--;
    if(wd_object[j].type==FREE_OBJ) no_cutbuffer();
    else {        
     if(save_picture(u1[0].name,
    	wd_object[j].xcord+1,wd_object[j].ycord+1,
    	wd_object[j].xcord+wd_object[j].xsize-1,
        wd_object[j].ycord+wd_object[j].ysize-1,
        wd_object[j].isize,palette)) return(1);   
    }
   }
   else if(chosen[2] == 1) { /* read cut buffer */
    j--;
    if(wd_object[j-1].type!=FREE_OBJ)
    { 
     x=wd_object[j].xcord;
     y=wd_object[j].ycord;          
     if_b_opt_bgfromfile(j);
     update_over(j);   
     free_transparent_card(j);       
    }
    else x=100;y=100;
       
    x2=250;y2=250; 	    
    if(get_picture(u1[1].name,x+1,y+1,
      &x2,&y2,&isize,palette)) return(1);
      
    make_transparent_card(j+1,x,y,"cutbuffer.xxx",x2-x,y2-y,0);     	
    wd_object[j].i1=0;         
    put_wd_objects(j+1,j+1);
               
    save_buf2(wd_object[j].xcord,wd_object[j].ycord,1,1,
  	wd_object[j].xsize-1,wd_object[j].ysize-1,wd_object[j].xcord&7,
  	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);
   }   
   break;      
  case 9: /* change color in cut buffer */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    
   j=6; /* cut buffer identifier */   
   col1=string_to_int(u1[0].name);col2=string_to_int(u1[1].name);
   if(col1!=col2)
    change_color(col1,col2,
        	wd_object[j-1].xcord,wd_object[j-1].ycord,
        	wd_object[j-1].xsize,wd_object[j-1].ysize,
        	wd_object[j-1].clength,wd_object[j-1].isize,
        	wd_object[j-1].foreground);
   break;  
  case 10: /* replace buffer */
   j=wd_object[id-1].i1-1; /* cut buffer id -1 */
   wd_object[j].i1=0;      
   for(m=1;m<wd_object[j].xsize-1;m++) {
    for(n=1;n<wd_object[j].ysize-1;n++) { 
     if(match_replacebuffer(wd_object[j].foreground,wd_object[id-1].p1,
         	m,n,wd_object[j].clength,wd_object[j].isize,9))
     {
      replace(wd_object[j].foreground,(char *)wd_object[id-1].p2,
         	m,n,wd_object[j].clength,wd_object[j].isize,9,j);
     }         
    }
   }
   break;
  case 11: /* list files menu */
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;   
   for(n=0;!(chosen[n] & 1) && n<wd_object[id-1].i2 ;n++);       
   if(n<wd_object[id-1].i2) {
    x2=LIMDBAR;y2=180;isize=308;
    if(get_picture(u2[n],0,0,&x2,&y2,&isize,palette)) return(0);   	
   }  
   break;
  case 12: /* pathdata menu */  
   chosen=(int *)wd_object[id-1].p3;
   u2=(char **)wd_object[id-1].p2;
   u1=(LINE10 *)wd_object[id-1].p1;
   if(pathindex>=0) {   
    pathdata1=pathdata[pathindex];
    if(!pathdata1) {printf("error, pathdata1=0\n");break;}
    if(chosen[6]==1) { /* set speed */
     k1=string_to_int(u1[0].name);
     get_float(u1[5].name,&pathdata1[k1].speed);
     set_pathtimes(pathdata1,pathsize[pathindex]);
    }
    else if(chosen[1]==1) { /* select index */
     k1=string_to_int(u1[0].name);
     strcpy(u1[1].name,int_to_string((long)pathdata1[k1].x)); 
     strcpy(u1[2].name,int_to_string((long)pathdata1[k1].y)); 
     strcpy(u1[3].name,int_to_string((long)pathdata1[k1].z)); 
     strcpy(u1[4].name,int_to_string((long)pathdata1[k1].time));
     sprintf(u1[5].name,"%g",pathdata1[k1].speed);
     for(i=0;i<6;i++) { 
      if(chosen[i] & 1) display_line(u1,u2,7,i,0,0,5,9);
      else display_line(u1,u2,7,i,0,0,15,9);
     } 
    }
    else if(chosen[7]==1) { /* set z coordinates */
     z_from_image(u1[7].name);
     k1=string_to_int(u1[0].name);
     strcpy(u1[3].name,int_to_string((long)pathdata1[k1].z));
     display_line(u1,u2,7,3,0,0,15,9); 
    }
    else if(chosen[8]==1) { /* recalculate path */
     xsave1=X;ysave1=Y;
     X=pathdata1[0].x; Y=pathdata1[0].y;
     memset(pathdata1,0,10000*sizeof(PathData));
     pathsize[pathindex]=get_pathdata(pathdata1,&col11,0);
     X=xsave1;Y=ysave1;
     draw_path(pathdata1,pathsize[pathindex],col11);
     pathdata1[0].speed=2.0; /* initialize to walking speed */
     pathdata1[0].time=0;
     set_pathtimes(pathdata1,pathsize[pathindex]);
    }
    else if(chosen[9]==1) { /* kill this menu */
     free_one_wd_object(id);
     pathindex=-1;
    }
    else if(chosen[12]==1) { /* save pathdata */
     save_pathdata(u1[8].name);
    }

   }
   else { /* no pathindex */
    if(chosen[0]==1) {
     pathindex=string_to_int(u1[6].name);
     if(!pathdata[pathindex]) load_pathdata(u1[8].name,0);
     pathdata1=pathdata[pathindex];
     if(pathdata1) {
      draw_path(pathdata1,pathsize[pathindex],pathcol[pathindex]);
     }
    }
    else if(chosen[9]==1) { /* kill this menu */
     free_one_wd_object(id);
     pathindex=-1;
    }
   }
   break;
 default:
   return edi2_operations(id);
   break;
 }
 return(0);
} 
int fill_editor1menu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 if(wd_object[id-1].type!=FREE_OBJ) return 1; 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Image at (   ,   ,   ,   ) cl=");
 strcpy(u2[1],"Load image ");
 strcpy(u2[2],"Save image ");
 strcpy(u2[3],"Cut buffer menu "); 
 strcpy(u2[4],"List       files");
 strcpy(u2[5],"Altitude curves ");
 strcpy(u2[6],"Convert  ");   
 strcpy(u2[7],"Save to PS ");    
 strcpy(u2[8],"Clear screen ");     
 strcpy(u2[9],"Make label ");      
 strcpy(u2[10],"Clean pcx ");       
 strcpy(u2[11],"Visibility data, animate= ");       
 strcpy(u2[12],"Paths data= ");       
 strcpy(u2[13],"Altitude data= ");       
 strcpy(u2[14],"Artillery attack ");       
 
 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;
 strcpy(u1[0].name,"map1.gif");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 strcpy(u1[1].name,""); 
 
 u1[2].xcord=strlen("List ")*cs; 
 u1[2].ycord=4*cr; 
 u1[2].parmax=1; u1[2].size= u1[2].bsize=5;
 strcpy(u1[2].name,"*.fn2"); 
 
 u1[3].xcord=strlen(u2[5])*cs; 
 u1[3].ycord=5*cr; 
 u1[3].parmax=1;
 strcpy(u1[3].name,"map1.gif");
 
 u1[4].xcord=strlen(u2[6])*cs; 
 u1[4].ycord=6*cr; 
 u1[4].parmax=1;
 strcpy(u1[4].name,"map1.gif"); 
 
 u1[5].xcord=strlen(u2[7])*cs; 
 u1[5].ycord=7*cr; 
 u1[5].parmax=1;
 strcpy(u1[5].name,"figure.ps"); 
 
 u1[6].xcord=strlen(u2[9])*cs; 
 u1[6].ycord=9*cr; 
 u1[6].parmax=1;
 strcpy(u1[6].name,""); 
 
 u1[7].xcord=strlen(u2[10])*cs; 
 u1[7].ycord=10*cr; 
 u1[7].parmax=1;
 strcpy(u1[7].name,""); 

 u1[8].xcord=strlen("Image at (")*cs; 
 u1[8].ycord=0; 
 u1[8].parmax=5; u1[8].size=u1[8].bsize=3;
 strcpy(u1[8].name,"0"); 

 u1[9].xcord=strlen("Image at (   ,")*cs; 
 u1[9].ycord=0; 
 u1[9].parmax=4; u1[9].size=u1[9].bsize=3;
 strcpy(u1[9].name,"0"); 

 u1[10].xcord=strlen("Image at (   ,   ,")*cs; 
 u1[10].ycord=0; 
 u1[10].parmax=3; u1[10].size=u1[10].bsize=3;
 strcpy(u1[10].name,"474"); 

 u1[11].xcord=strlen("Image at (   ,   ,   ,")*cs; 
 u1[11].ycord=0; 
 u1[11].parmax=2; u1[11].size=u1[11].bsize=3;
 strcpy(u1[11].name,"549"); 

 u1[12].xcord=strlen("Image at (   ,   ,   ,   ) cl=")*cs; 
 u1[12].ycord=0; 
 u1[12].parmax=1; u1[12].size=u1[12].bsize=1;
 strcpy(u1[12].name,"3"); 

 u1[13].xcord=strlen(u2[11])*cs; 
 u1[13].ycord=11*cr; 
 u1[13].parmax=1; u1[13].size=u1[13].bsize=1;
 strcpy(u1[13].name,"3"); 

 u1[14].xcord=strlen(u2[12])*cs; 
 u1[14].ycord=12*cr; 
 u1[14].parmax=1; u1[14].size=u1[14].bsize=15;
 strcpy(u1[14].name,"test6.in"); 
 
 u1[15].xcord=strlen(u2[13])*cs; 
 u1[15].ycord=13*cr; 
 u1[15].parmax=1; u1[15].size=u1[15].bsize=15;
 strcpy(u1[15].name,"altitude.pcx");

 u1[16].xcord=strlen(u2[14])*cs; 
 u1[16].ycord=14*cr; 
 u1[16].parmax=1; u1[16].size=u1[16].bsize=15;
 strcpy(u1[16].name,"artillery1.dat");  

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}

int fill_chgcolormen(max,pmax,window,linelength,id,x,y,xsize,ysize,
 col1,col2,col3,col4,col5)
int max,pmax,window,linelength,id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 if(wd_object[id-1].type!=FREE_OBJ) return 1; 
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Change color    to    in Cutbuffer");
 
 u1[0].xcord=13*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].bsize=u1[0].size=2; 
 strcpy(u1[0].name,"1");
 
 u1[1].xcord=19*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].bsize=u1[1].size=2; 
 strcpy(u1[1].name,"1"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}

int path_ope()
{
 int k1,col11;PathData *pathdata1;
 char **u2; LINE10 *u1;
 int *chosen;

 flush_mouse();
 /* new menu for setting path data */
 /* check if there is pathdata on this place */
 if(wd_object[11].type!=FREE_OBJ) return 1;
 if(pathindex>=0) return 0;
 vobjmode=0;
 k1=find_pathdata(); /* sets pathindex if k1!=-1 */ 
 if(k1==-1) { /* there was no existing pathdata, create new */
  for(pathindex=0;pathindex<40;pathindex++) {
   if(pathsize[pathindex]==0) break;
  } 
  if(!pathdata[pathindex])  
   pathdata[pathindex]=malloc(10000*sizeof(PathData));
  if(!pathdata[pathindex]) {no_memory();getch();pathindex=-1;return 0;}
 }
 pathdata1=pathdata[pathindex];
 fill_pathdatamenu(9,13,11,40,12,61*cs,360,17*cs,3*cs+11*cr,Co1,Co2,Co3,Co4,Co5);   
 chosen=(int *)wd_object[11].p3;      
 u2=(char **)wd_object[11].p2;
 u1=(LINE10 *)wd_object[11].p1;

 if(k1==-1) { 
  memset(pathdata1,0,10000*sizeof(PathData));
  pathsize[pathindex]=get_pathdata(pathdata1,&col11,1);
  pathcol[pathindex]=col11;
  draw_path(pathdata1,pathsize[pathindex],col11);
  pathdata1[0].speed=2.0; /* initialize to walking speed */
  pathdata1[0].time=0;
  set_pathtimes(pathdata1,pathsize[pathindex]);
  strcpy(u1[4].name,int_to_string((long)pathdata1[0].time));
  k1=0;
 }

 strcpy(u1[0].name,int_to_string((long)k1)); 
 strcpy(u1[1].name,int_to_string((long)pathdata1[k1].x)); 
 strcpy(u1[2].name,int_to_string((long)pathdata1[k1].y)); 
 strcpy(u1[3].name,int_to_string((long)pathdata1[k1].z)); 
 strcpy(u1[4].name,int_to_string((long)pathdata1[k1].time)); 
 sprintf(u1[5].name,"%g",pathdata1[k1].speed); 
 strcpy(u1[6].name,int_to_string((long)pathindex)); 
        
 put_wd_objects(12,12);
}

int pathed_ope()
{
 flush_mouse();
 /* new menu for setting path data */
 /* check if there is pathdata on this place */
 if(wd_object[11].type!=FREE_OBJ) return 1;
 vobjmode=0; 
 fill_pathdatamenu(9,13,11,40,12,61*cs,360,17*cs,3*cs+11*cr,Co1,Co2,Co3,Co4,Co5);   
 put_wd_objects(12,12);
}

int exit1_ope()
{
 exit_vect_ed=1;
 vobjmode=0;
 return 0;	
}

int get_pathdata(p,col11,read_place) PathData *p;int *col11;int read_place;
{
 int i,j;
 int new_i,new_j;
 unsigned long pixel,pixel_t0,pixel_t2;
 unsigned long pixel_u0,pixel_u1,pixel_u2;
 unsigned long pixel_l0,pixel_l1,pixel_l2;
 int k,col,found;unsigned long ourblack;

 ourblack=xcolor[18].pixel;
 if(read_place) {
  buttons=0;
  while(X>LIMDBAR || buttons==0) { buttons=0;readmouse(&buttons,&X,&Y);}
 }
  /* now mouse is pressed on some path */
 *col11=15;
 found=0;
 for(i=X-1;i<X+3;i++) {
  for(j=Y-1;j<Y+3;j++) {
   pixel=getpixel2c(i,j);

   for(k=0;k<15;k++) { /* notice, we do not accept white as a path color */
    if(pixel==xcolor[k].pixel) {found=1;break;}
   }
   if(found) break;
  }
  if(found) break;
 }
 if(!found) return 0;
 
 *col11=k;

 old_i=i-1;old_j=j-1;
 k=0;col=0;
 while(1) {

  pixel_t0=getpixel2c(i-1,j);
  pixel_t2=getpixel2c(i+1,j);

  pixel_u0=getpixel2c(i-1,j-1);
  pixel_u1=getpixel2c(i,j-1);
  pixel_u2=getpixel2c(i+1,j-1);

  pixel_l0=getpixel2c(i-1,j+1);
  pixel_l1=getpixel2c(i,j+1);
  pixel_l2=getpixel2c(i+1,j+1);

   if(old_i==i && old_j<j) {
     if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_t0==pixel && !(old_i==i-1 && old_j==j)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_u1==pixel && !(old_i==i && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_u0==pixel && !(old_i==i-1 && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i==i && old_j>j) {
     if(pixel_u1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_u0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else if(pixel_t0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_l0==pixel && !(old_i==i-1 && old_j==j+1)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_l1==pixel && !(old_i==i && old_j==j+1)) 
      {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i<i && old_j==j) {
     if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_t0==pixel && !(old_i==i-1 && old_j==j)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_u1==pixel && !(old_i==i && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_u0==pixel && !(old_i==i-1 && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i>i && old_j==j) {
     if(pixel_t0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_u0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_u1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_t2==pixel && !(old_i==i+1 && old_j==j)) 
      {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_u2==pixel && !(old_i==i && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i<i && old_j<j) {
     if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_t0==pixel && !(old_i==i-1 && old_j==j)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_u1==pixel && !(old_i==i && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_u0==pixel && !(old_i==i-1 && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i<i && old_j>j) {
     if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_u1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_u0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else if(pixel_t0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_l0==pixel && !(old_i==i-1 && old_j==j+1)) 
      {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_l1==pixel && !(old_i==i && old_j==j+1)) 
      {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else {
      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i>i && old_j<j) {
     if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_t0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_u0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else if(pixel_l2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j+1;}
     else if(pixel_u1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_t2==pixel && !(old_i==i+1 && old_j==j)) 
      {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else if(pixel_u2==pixel && !(old_i==i && old_j==j-1)) 
      {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else {

      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }
   else if(old_i>i && old_j>j) {
     if(pixel_u0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j-1;}
     else if(pixel_t0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j;}
     else if(pixel_u1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j-1;}
     else if(pixel_l0==pixel) {p[k].x=i;p[k].y=j;new_i=i-1;new_j=j+1;}
     else if(pixel_u2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j-1;}
     else if(pixel_l1==pixel) {p[k].x=i;p[k].y=j;new_i=i;new_j=j+1;}
     else if(pixel_t2==pixel) {p[k].x=i;p[k].y=j;new_i=i+1;new_j=j;}
     else {
      col=jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
			    i,j,&new_i,&new_j,ourblack);
      if(!col) return k; /* finished */
      else {p[k].x=i;p[k].y=j;}
     }
   }

  k++; if (k>=10000) break;
  drawpixel2b(i,j,ourblack);col=0;
  old_i=i;old_j=j;i=new_i;j=new_j;
 }
 return k;
}


int find_pathdata()
{
 int i,k1;
 PathData *pathdata1;

 buttons=0;
 while(X>LIMDBAR || buttons==0) { buttons=0;readmouse(&buttons,&X,&Y);}
 
  /* now mouse is pressed on some path */
 k1=-1;
 for(pathindex=0;pathindex<40;pathindex++) {
  pathdata1=pathdata[pathindex];
  if(pathsize[pathindex] && pathdata1) {

   for(i=0;i<pathsize[pathindex];i++) {
    if((pathdata1[i].x<=X+2 && pathdata1[i].x>=X-2) && 
       (pathdata1[i].y<=Y+2 && pathdata1[i].y>=Y-2)) 
    {k1=i;break;}
   }
  }
  if(k1>=0) break;
 }       
 return k1;
}

int draw_path(p,k,col) PathData *p;int k;int col; 
{
  int m;
  for(m=0;m<k;m++)
  drawpixel(p[m].x,p[m].y,col);
}

int jmp_over_crossing2(pixel,i1,j1)
unsigned long pixel;
int i1,j1;
{
  int ret;
  unsigned long pixel_u0,pixel_u1,pixel_u2;
  unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2;
 
  pixel_t0=getpixel2c(i1-1,j1);
  pixel_t2=getpixel2c(i1+1,j1);

  pixel_u0=getpixel2c(i1-1,j1-1);
  pixel_u1=getpixel2c(i1,j1-1);
  pixel_u2=getpixel2c(i1+1,j1-1);

  pixel_l0=getpixel2c(i1-1,j1+1);
  pixel_l1=getpixel2c(i1,j1+1);
  pixel_l2=getpixel2c(i1+1,j1+1);

  ret=jmp_over_crossing1(pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,pixel);

  return ret;
}

int jmp_over_crossing(pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2,
                      i,j,newi,newj,ourcol)
unsigned long pixel,pixel_u0,pixel_u1,pixel_u2,
		      pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2;
int i,j;int *newi,*newj;unsigned long ourcol;

{
  if(ourcol==pixel_u0 && jmp_over_crossing2(pixel,i-1,j-1)) { 
    *newi=i-1;*newj=j-1;return 1;}
  if(ourcol==pixel_u1 && jmp_over_crossing2(pixel,i,j-1)) { 
   *newi=i;*newj=j-1;return 1;}
  if(ourcol==pixel_u2 && jmp_over_crossing2(pixel,i+1,j-1)) { 
   *newi=i+1;*newj=j-1;return 1;}
  if(ourcol==pixel_l0) {
   if(jmp_over_crossing2(pixel,i-1,j+1)) { 
     *newi=i-1;*newj=j+1;return 1;}}
  if(ourcol==pixel_l1 && jmp_over_crossing2(pixel,i,j+1)) { 
   *newi=i;*newj=j+1;return 1;}
  if(ourcol==pixel_l2 && jmp_over_crossing2(pixel,i+1,j+1)) { 
   *newi=i+1;*newj=j+1;return 1;}
  if(ourcol==pixel_t0 && jmp_over_crossing2(pixel,i-1,j)) { 
   *newi=i-1;*newj=j;return 1;}
  if(ourcol==pixel_t2 && jmp_over_crossing2(pixel,i+1,j)) { 
   *newi=i+1;*newj=j;return 1;}
  return 0;
}
int jmp_over_crossing1(pixel_u0,pixel_u1,pixel_u2,
		       pixel_l0,pixel_l1,pixel_l2,
                       pixel_t0,pixel_t2,ourcol)
unsigned long pixel_u0,pixel_u1,pixel_u2;
unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_t0,pixel_t2;
unsigned long ourcol;

{
  if(ourcol==pixel_u0) return 1;
  if(ourcol==pixel_u1) return 1;
  if(ourcol==pixel_u2) return 1;
  if(ourcol==pixel_l0) return 1;
  if(ourcol==pixel_l1) return 1;
  if(ourcol==pixel_l2) return 1;
  if(ourcol==pixel_t0) return 1;
  if(ourcol==pixel_t2) return 1;
  return 0;
}



int not_the_last_points(i1,j1) int i1,j1;
{
  if((i1==old_i && j1==old_j) || (i1==older_i && j1==older_j)) return 0;
  return 1;
}
int is_close(pixel) unsigned long pixel;
{
 int col1,col2;

 color_by_pixel(pixel,2,&col1,&col2);
 
 return(looks_brown(col2));
}

int set_newpathdata()
{
 int i,k1,id;
 char **u2;
 int *chosen;
 LINE10 *u1;
 PathData *pathdata1;

 if(pathindex<0) return 0;
 else {

  if(wd_object[11].type==FREE_OBJ) {pathindex=-1;return 0;}
  readmouse(&buttons,&X,&Y);
  pathdata1=pathdata[pathindex];
  k1=-1;
  for(i=0;i<pathsize[pathindex];i++) {
   if((pathdata1[i].x<=X+2 && pathdata1[i].x>=X-2) && 
      (pathdata1[i].y<=Y+2 && pathdata1[i].y>=Y-2)) 
   {
    k1=i;break;}
   
  }       
  if(k1==-1) return 0;
  
  id=12; /* pathdata menu */  
  chosen=(int *)wd_object[id-1].p3;
  u2=(char **)wd_object[id-1].p2;
  u1=(LINE10 *)wd_object[id-1].p1;

  strcpy(u1[0].name,int_to_string((long)k1)); 
  strcpy(u1[1].name,int_to_string((long)pathdata1[k1].x)); 
  strcpy(u1[2].name,int_to_string((long)pathdata1[k1].y)); 
  strcpy(u1[3].name,int_to_string((long)pathdata1[k1].z)); 
  strcpy(u1[4].name,int_to_string((long)pathdata1[k1].time));
  sprintf(u1[5].name,"%g",pathdata1[k1].speed);
  strcpy(u1[6].name,int_to_string((long)pathindex));
  for(i=0;i<7;i++) { 
   display_line(u1,u2,7,i,0,0,15,9);
  }
 } 
 return 1;
}

int set_pathtimes(pathdata1,pathsize) PathData *pathdata1;int pathsize; 
{
 int i;
 double curspeed,totaltime,dist;
   /* set time using the speed data */
   /* let us assume one pixel=9 m */
   /* then 10 km/h is about 3 m/s */
   
 pathdata1[0].time=0;curspeed=0.0;totaltime=0.0;
 for(i=1;i<pathsize;i++) {
  curspeed+=pathdata1[i-1].speed;
  dist=(double)(pathdata1[i].x-pathdata1[i-1].x)*
            (pathdata1[i].x-pathdata1[i-1].x);
  dist+=(double)(pathdata1[i].y-pathdata1[i-1].y)*
            (pathdata1[i].y-pathdata1[i-1].y);
  dist=9.0*sqrt(dist);
  if(curspeed) totaltime=totaltime+dist/curspeed;
  else totaltime=10000.0; /* maximum */
  pathdata1[i].time=(int)totaltime;
 } 
 return 0;
}
int save_pathdata(name1) char *name1;
{
 int i,j;FILE *fd1;char name[30];
 PathData *pathdata1;char *p;

 p=strstr(name1,".in");
 if(!p) return 1;
 *p=0;
 strcpy(name,name1);strcat(name,".pat"); 
 *p=(int)'.';

 for(j=0,i=0;i<40;i++) if(pathsize[i]) j=1;
 if(!j) return 1;

 fd1=(FILE *)fopen(name,"r+");
 if(fd1) {
  fclose(fd1);
  if(!copy_on_existing_file()) return;
 }
 fd1=(FILE *)fopen(name,"w+");
 if(!fd1) {cannot_create_file(name);return 1;}
 fseek(fd1,0,0);

 for(i=0;i<40;i++) {
  if(pathsize[i]) {
   fprintf(fd1,"i=%d size=%d color=%d\n",i,pathsize[i],pathcol[i]);
   pathdata1=pathdata[i];
   if(pathdata1) { 
    for(j=0;j<pathsize[i];j++) {
      fprintf(fd1,"%d %d %d %d %g\n",pathdata1[j].x,
	      pathdata1[j].y,pathdata1[j].z,pathdata1[j].time,
              pathdata1[j].speed);
    }
   }
  }
 }
 fprintf(fd1,"i=%d size=%d color=%d\n",41,0,0);
 fclose(fd1);
 return 0;
}
int load_pathdata(name1,draw) char *name1;int draw;
{
 int i,j;FILE *fd1;char name[30];
 PathData *pathdata1;char *p;int size,col;
 char buf[200];char *q;

 p=strstr(name1,".in");
 if(!p) return 1;
 *p=0;
 strcpy(name,name1);strcat(name,".pat"); 
 *p=(int)'.';

 fd1=(FILE *)fopen(name,"r");
 if(!fd1) return 1;
 fseek(fd1,0,0);

 while(1) {
  if(3!=fscanf(fd1,"i=%d size=%d color=%d\n",&i,&size,&col)) return 1;
  if(i==41) break;
   pathsize[i]=size;pathcol[i]=col;

  if(pathsize[i]) {
   if(!pathdata[i]) pathdata[i]=(PathData *)malloc(sizeof(PathData)*10000);

   pathdata1=pathdata[i];
   if(pathdata1) {
    for(j=0;j<pathsize[i];j++) {
     if(!fgets(buf,200,fd1)) {not_valid_input_file(name);return 1;}
     strip(buf);
     p=buf;q=strstr(p," ");*q=0;
     pathdata1[j].x=string_to_int(p);   
     p=q+1;q=strstr(p," ");*q=0;
     pathdata1[j].y=string_to_int(p);   
     p=q+1;q=strstr(p," ");*q=0;
     pathdata1[j].z=string_to_int(p);
     p=q+1;q=strstr(p," ");*q=0;
     pathdata1[j].time=string_to_int(p);
     p=q+1;
     get_float(p,&pathdata1[j].speed);

     if(draw)
      fillbox(pathdata1[j].x,pathdata1[j].y,2,2,pathcol[i]);
    }
   }
   else {no_memory();getch();return 1;}
  }
 }
 fclose(fd1);

 return 0;
}

int set_visibility_data(name1,name2,name3,animate) 
char *name1,*name2,*name3;int animate;
{
 int i,j,time,k[41];
 PathData *pathdata1;
 int nodex[41],nodey[41],nodez[41],valid[41];
 int oldnodex[41],oldnodey[41];
 unsigned long pix[41],pix1[41],pix2[41],pix3[41];
 double distance;
 int scalex,scaley,scalez,maxscale;
 int scale2x,scale2y,scale2z;
 int x,y,z;double b;int no_visibility;
 FILE *fd1;char name[50];
 char *p;
 ANIMATDATA u[40][41];
 int stop_time,next_explosion,xbomb,ybomb;
 int alive[40],no_cross[40];int x1,y1;
 int wWidth,wHeight;
 XImage *screenbufsav;
 int ammunition_count;
 int distribution, parameter;
 int firex1,firey1,firex2,firey2,killrange;double firerate,killprob;

 load_pathdata(name1,0);

 p=strstr(name1,".in");
 if(!p) return 1;
 *p=0;
 strcpy(name,name1);strcat(name,".dst"); 
 *p=(int)'.';

 fd1=(FILE *)fopen(name,"r+");
 if(fd1) {
  fclose(fd1);
  if(!copy_on_existing_file()) return;
 }
 fd1=(FILE *)fopen(name,"w+");
 if(!fd1) {cannot_create_file(name);return 1;}
 fseek(fd1,0,0);

 next_explosion=-1;
 get_artillery_data(name3,&next_explosion,&ammunition_count,
    &distribution,&firerate,&parameter,
		    &firex1,&firey1,&firex2,&firey2,&killrange,&killprob);
 for(i=0;i<41;i++) {
  nodex[i]=oldnodex[i]=-1;nodey[i]=oldnodey[i]=-1;
 }
 for(i=0;i<40;i++) {
  k[i]=0;alive[i]=no_cross[i]=1;
 }

 if(animate&1) {
   for(i=0;i<40;i++) for(j=0;j<41;j++) {
    u[i][j].ox1=u[i][j].x1=-1;
    u[i][j].oy1=u[i][j].y1=-1;
    u[i][j].ox2=u[i][j].y2=-1;
    u[i][j].oy2=u[i][j].x2=-1;
   }
 }
 rand1=1111;rand2=12221;rand_u1=255;

 /* find last valid time */
 stop_time=0;
 for(i=0;i<40;i++) {
  if(pathsize[i]) {
   pathdata1=pathdata[i];
   if(pathdata1[pathsize[i]-1].time>stop_time)
    stop_time=pathdata1[pathsize[i]-1].time;
  }
 }

 make_screenbuf1();
 screenbufsav=screenbuf;
 screenbuf=screenbuf1;

 p=strchr(name2,(int)'.');
 if(p && !strcmp(p,".gif")) {
  readGIF(name2,&wWidth,&wHeight,3);
  if(wWidth>680) wWidth=680; /* do not show whole figure */
 }
 else if(p && !strcmp(p,".pcx")) {
  readpcx(name2,&wWidth,&wHeight);
  if(wWidth>680) wWidth=680; /* do not show whole figure */
 }
 else printf("format not recognized\n");

 /* restore screenbuf */
 screenbuf=screenbufsav;
 /* we have the altitude figure in screenbuf1 */

 for(time=0;time<stop_time+1;time++) {

  fprintf(fd1,"*\ntime=%d\n",time);
  for(i=0;i<41;i++) valid[i]=0;
  if(time==next_explosion) {
   ammunition_count--;
   xbomb=firex1+even_distr()%(firex2-firex1);
   ybomb=firey1+even_distr()%(firey2-firey1);
   if(animate&1) {
    xored_oval(xbomb,ybomb,10.0,1.0,xcolor[4].pixel,wWidth,wHeight);
    xored_oval(xbomb,ybomb,10.0,1.0,xcolor[4].pixel,wWidth,wHeight);
   }
   if(ammunition_count>0) {
    if(distribution==1) next_explosion+=1/firerate;
    else next_explosion +=(int)erl_distr(parameter,firerate); 
   }
   valid[40]=1;
   nodex[40]=xbomb;
   nodey[40]=ybomb;
   nodez[40]=ground_level(xbomb,ybomb,wWidth,wHeight);
  }
  else nodex[40]=-1;

  for(i=0;i<40;i++) {
   pathdata1=pathdata[i];
   if(alive[i]){  
    if(pathsize[i] && k[i]<pathsize[i]) {
     if(pathdata1[k[i]].time<time)
      while(k[i]+1<pathsize[i] && pathdata1[k[i]+1].time<time) k[i]++;
     if(k[i]<pathsize[i]) {
      valid[i]=1;
      nodex[i]=pathdata1[k[i]].x;
      nodey[i]=pathdata1[k[i]].y;
      nodez[i]=pathdata1[k[i]].z;
     }
    }
   }
   else nodex[i]=-1;
  }

  /* now valid[i]=1 if a node has a point in time */
  /* and the point coordinates are in nodex,y,z */
  for(i=0;i<40;i++) {
   for(j=i+1;j<41;j++) { /* a matrix of connectivity (i,j) j>i */
    if(valid[i] && valid[j]) {
     no_visibility=0;

      /* each pixel in x,y, plane is 9 meters */
     distance=81.0*(nodex[i]-nodex[j])*(nodex[i]-nodex[j]);
     distance+=81.0*(nodey[i]-nodey[j])*(nodey[i]-nodey[j]);
     /* each altitude value is in meters */
     distance+= (nodez[i]-nodez[j])*(nodez[i]-nodez[j]);
     distance=sqrt(distance);
     /* there is a maximum distance depending on signal strength */
     /* now simply the disturbing distance of VLAN */
     if(j<40) if(distance>500.0) no_visibility=1;
     if(j==40) {
      if(distance>killrange) no_visibility=1; /* this is bomb */
      else printf("in killing distance\n");
     }


     if(!no_visibility) {
      /* check if there is line-of-sight */
      scalex=nodex[i]-nodex[j];
      scaley=nodey[i]-nodey[j];
      scalez=nodez[i]-nodez[j];
      scale2x=scalex*scalex;
      scale2y=scaley*scaley;
      scale2z=scalez*scalez;

      if(scale2x>=scale2y) {
       if(scale2x>=scale2z) { /* scalex is largest */
        if(scalex>0) {
	 for(x=nodex[i];x<nodex[j];x++) {
          b=(double)(nodex[j]-nodex[i]);
          y=(int)((double)x*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          z=(int)((double)x*(double)(nodez[j]-nodez[i])/b)+nodez[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
        else if(scalex<0) {
	 for(x=nodex[j];x<nodex[i];x++) {
          b=(double)(nodex[j]-nodex[i]);
          y=(int)((double)x*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          z=(int)((double)x*(double)(nodez[j]-nodez[i])/b)+nodez[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
       }
       else { /* scalez is largest */
        if(scalez>0) {
	 for(z=nodez[i];z<nodez[j];z++) {
          b=(double)(nodez[j]-nodez[i]);
          y=(int)((double)z*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          x=(int)((double)z*(double)(nodez[j]-nodez[i])/b)+nodex[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
        else if(scalez<0){
	 for(z=nodez[j];z<nodez[i];z++) {
          b=(double)(nodez[j]-nodez[i]);
          y=(int)((double)z*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          x=(int)((double)z*(double)(nodez[j]-nodez[i])/b)+nodex[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
       }
      }
      else {
       if(scale2y>=scale2z) { /* scaley is largest */
        if(scaley>0) {
	 for(y=nodey[i];y<nodey[j];y++) {
          b=(double)(nodey[j]-nodey[i]);
          x=(int)((double)x*(double)(nodex[j]-nodex[i])/b)+nodex[i];
          z=(int)((double)x*(double)(nodez[j]-nodez[i])/b)+nodez[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
        else if(scaley<0){
	 for(y=nodey[j];y<nodey[i];y++) {
          b=(double)(nodey[j]-nodey[i]);
          x=(int)((double)x*(double)(nodex[j]-nodex[i])/b)+nodex[i];
          z=(int)((double)x*(double)(nodez[j]-nodez[i])/b)+nodez[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
       }
       else { /* scalez is largest */
        if(scalez>0) {
	 for(z=nodez[i];z<nodez[j];z++) {
          b=(double)(nodez[j]-nodez[i]);
          y=(int)((double)z*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          x=(int)((double)z*(double)(nodez[j]-nodez[i])/b)+nodex[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
        else if(scalez<0){
	 for(z=nodez[j];z<nodez[i];z++) {
          b=(double)(nodez[j]-nodez[i]);
          y=(int)((double)z*(double)(nodey[j]-nodey[i])/b)+nodey[i];
          x=(int)((double)z*(double)(nodez[j]-nodez[i])/b)+nodex[i];
          if(obstacle(x,y,z)) {no_visibility=1;break;}
	 }
        }
       }
      }
     }
     /* now we have no_visibility=1 if there is no visibility */
     /* either because of distance or because of an obstacle */ 
     if(!no_visibility) {
      if(j<40) {
       fprintf(fd1,"i=%d j=%d d=%g\n",i,j,distance); 
      }
      else { /* the bomb was close and line-of-sight to it */
	printf("could die\n");
       if(unif_distr()<=killprob) 
	 alive[i]=0;
      }

      if(animate&1) {
       if(nodex[i]!=nodex[j] || nodey[i]!=nodey[j]) {  
        u[i][j].x1=nodex[i];u[i][j].y1=nodey[i];
        u[i][j].x2=nodex[j];u[i][j].y2=nodey[j];
       }
      } 
     }
     else { /* there is no visibility */
      u[i][j].x1=-1;
     } 
    }
   }
  }

  if(animate&1) {
   for(i=39;i>=0;i--) {
    if((animate & 2) &&oldnodex[i]!=-1) {
     drawpixel2b(oldnodex[i]+1,oldnodey[i]+1,pix3[i]);
     drawpixel2b(oldnodex[i],oldnodey[i]+1,pix2[i]);
     drawpixel2b(oldnodex[i]+1,oldnodey[i],pix1[i]);
     drawpixel2b(oldnodex[i],oldnodey[i],pix[i]);
     oldnodex[i]=-1;
    }

    for(j=39;j>i;j--) {
     if(u[i][j].ox1!=-1) {
      draw_vline(0,u[i][j].buf,u[i][j].ox1,u[i][j].oy1,0,0,
         u[i][j].ox2,u[i][j].oy2,1,xcolor[4].pixel);
      u[i][j].ox1=-1;  
     }
    }
   }
   for(i=0;i<40;i++) {
    if(alive[i]==0 && no_cross[i]) {
     x1=nodex[i]-3;if(x1<0) x1=0;
     y1=nodey[i]-3;if(y1<0) y1=0;
     draw_line1(x1,nodey[i],nodex[i]+3,nodey[i],0);
     draw_line1(nodex[i],y1,nodex[i],nodey[i]+6,0);
     no_cross[i]=0;
    }

    if(time<stop_time) {
     for(j=i+1;j<40;j++) {
      if(u[i][j].x1!=-1) {
       draw_vline(0,u[i][j].buf,u[i][j].x1,u[i][j].y1,
         u[i][j].x2,u[i][j].y2,0,0,2,xcolor[4].pixel);
       u[i][j].ox1=u[i][j].x1;
       u[i][j].oy1=u[i][j].y1;
       u[i][j].ox2=u[i][j].x2;
       u[i][j].oy2=u[i][j].y2;
      }
     }
    }
    if(nodex[i]!=-1) {
     pix[i]=getpixel2c(nodex[i],nodey[i]);
     drawpixel(nodex[i],nodey[i],pathcol[i]);

     pix1[i]=getpixel2c(nodex[i]+1,nodey[i]);
     drawpixel(nodex[i]+1,nodey[i],pathcol[i]);

     pix2[i]=getpixel2c(nodex[i],nodey[i]+1);
     drawpixel(nodex[i],nodey[i]+1,pathcol[i]);

     pix3[i]=getpixel2c(nodex[i]+1,nodey[i]+1);
     drawpixel(nodex[i]+1,nodey[i]+1,pathcol[i]);

     oldnodex[i]=nodex[i];
     oldnodey[i]=nodey[i];
    }
   }
  }
 }

 fclose(fd1);

 free_screenbuf1();

 return 0;       
}
int obstacle(x,y,z) int x,y,z;
{
 int col;
 unsigned long pix;

 if(x<475 && y<550) {
  pix=getpixel2d(x,y);
  for(col=0;col<15;col++) {
   if(xcolor[col].pixel==pix) break;
  }
  if(col && z<col*5) return 1;
 }

 return 0;
}

int ground_level(x,y,wWidth,wHeight) int x,y,wWidth,wHeight;
{
 int col,j;
 unsigned long pix,pix2;

 if(x<wWidth && y<wHeight && x>=0 && y>=0) {
  pix=getpixel2d(x,y);
  for(col=0;col<15;col++) {
   if(xcolor[col].pixel==pix) break;
  }
  if(col) return col*5;
  else { /* on the altitude curve, take the point right from it */
   for(j=x+1;j<wWidth;j++) {
    pix2=getpixel2d(j,y);
    if(pix2!=pix) break;
   }
   for(col=0;col<15;col++) {
    if(xcolor[col].pixel==pix2) break;
   }
  }
 }
 return 0;
}
int get_artillery_data(name,start,ammunition,distribution,rate,parameter,
x1,y1,x2,y2,killrange,killprob)
     char *name;     
int *start,*ammunition,*distribution; 
double *rate;int *parameter,*x1,*y1,*x2,*y2;
int *killrange;double *killprob;
{
 FILE *fd1;
 char *p;char *q;
 char buf[200];

 fd1=(FILE *)fopen(name,"r");
 if(!fd1) return 1;
 fseek(fd1,0,0);

 if(!fgets(buf,200,fd1)) {not_valid_input_file(name);return 1;}
 strip(buf);

 p=buf;q=strstr(p,"ammunition=");*q=0;
 p+=strlen("start=");
 *start=string_to_int(p);   

 p=q+strlen("ammunition=");q=strstr(p,"distribution=");*q=0;
 *ammunition=string_to_int(p);

 p=q+strlen("distribution=");q=strstr(p,"rate=");*q=0;
 if(!strncmp(p,"deterministic",strlen("deterministic"))) *distribution=1;
 else *distribution=0; /* have not implemented more */   

 p=q+strlen("rate=");q=strstr(p,"parameter=");*q=0;
 get_float(p,rate);

 p=q+strlen("parameter=");
 *parameter=string_to_int(p);

 if(!fgets(buf,200,fd1)) {not_valid_input_file(name);return 1;}
 strip(buf);

 p=buf;q=strstr(p,"y1=");*q=0;
 p+=strlen("x1=");
 *x1=string_to_int(p);

 p=q+strlen("y1=");q=strstr(p,"x2=");*q=0;
 *y1=string_to_int(p);

 p=q+strlen("x2=");q=strstr(p,"y2=");*q=0;
 *x2=string_to_int(p);

 p=q+strlen("y2=");;q=strstr(p,"killrange=");*q=0;
 *y2=string_to_int(p);

 p=q+strlen("killrange=");;q=strstr(p,"killprob=");*q=0;
 *killrange=string_to_int(p);

 p=q+strlen("killprob=");
 get_float(p,killprob);

 fclose(fd1);
}
