/*******************************************
* MODULE:	NSPUSHMEN.C 	
* FUNCTION:	Push button menu definitions.
* Author:     	Jorma Jormakka
*
* For explanation of push button menus refer 
* to GRAPH document.
*
* original date: 27.11.94
* last modified: 8.11.96 JJ
********************************************/

#include <string.h>
#include "x.ext"
#include "pmenus.ext"
#include "win.ext"
#include "text.ext"

JMPTABLE main_table[11];
JMPTABLE plot_table[3];
JMPTABLE sim_table[4];
extern JMPTABLE *c_table;

extern long max_chains;
extern int classes,elements;

extern int sim_operations,trace_part,trace_elem;
extern CNVTBL bb5[];
extern int mouse_off;
extern int simulate1();


extern int nocolor,pensize,color;
char version_string[]="Version 4.11.1999"; /* version of the simulator */


/************************************************
* main menu contains push buttons for submenus
* Chain editor		Plotter
* Simulate		Print
* Net editor		Appr editor
* Exit
*************************************************/ 
int main_menu()
{
 int xsize,ysize,x,y;int i;
 
 if(init_win(0,0)) return(1);
 if(initPool(1,1200*cr,0,0)) return(1);
 
 nocolor=1;pensize=1;
 clearwin(X__max-109,0,X__max,Y__max,1);
 clearwin(0,0,X__max-109,Y__max,15); 

 xkoord=10;ykoord=Y__max-12;textf("Copyright: J",1,15,33);
 xkoord=10+13*6-1;ykoord=Y__max-16;textf("2",1,15,33);

 
 xkoord=10+32*6;ykoord=Y__max-12;textf(version_string,1,15,33);
  
 free_font();  
 if(init_font(defaultfont)) {printf("problems in loading font\n");getch();return(1);}

/* put icons */i=0;
 x=X__max-103;y=1;getpicture("chicon.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,cedi_ope);
 
 x=X__max-47;y=1;getpicture("plicon.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,plotter_ope);
 
 x=X__max-103;y=46;getpicture("simulate.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,simul_ope);
 
 x=X__max-47;y=46;getpicture("print.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,print_ope);
 
 x=X__max-103;y=91;getpicture("netedi.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,nedi_ope);
 
 x=X__max-47;y=91;getpicture("apprs.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,aedi_ope);
 
 x=X__max-103;y=136;getpicture("texit.fn2",x,y,&xsize,&ysize);
 fill_jmptable(&main_table[i++],x,y,xsize,ysize,exit_ope); 

 fill_jmptable(&main_table[i++],0,0,0,0,NULL);
 
 cvobj=0; 
 mouse_off=1;
 do_engine1(1,main_table);
 return(free_win(0,0)); 
}

/**********************/
int print_ope()
{
  if(vobjmode!=MAKE_PCX_FILE) pcxdump_to_file();
 vobjmode=MAKE_PCX_FILE;
 flush_mouse();buttons=0;
 return(0);	
}


/***********************************************
* compile_ope()
*
* Call vectob_to_simdata in order to translate
* vobj data to simulator data. 
* vectob_to_simdata allocates call type buffers,
* this routine frees them. This routine cannot
* be called twice since it frees some vobj data.
************************************************/
int compile_ope()
{int new_class,new_elem;

 initialize_call_types_and_elem(&classes,&elements);	
 vectob_to_simdata(0,0,&new_class,&new_elem,1);  
 free_call_types();
 flush_mouse();buttons=0;
 return(0); 
}


/******************************************
* start_ope
*
* Starting of the simulator.
*******************************************/
int start_ope()
{
 LINE10 *u1;int k;char buf[30];int id=4;double x;
 FILE *fd;int new_class,new_elem;int i;
 
 VECTOR_OBJECT *o,*v1;	


  if(wd_object[3].type==FREE_OBJ) {printf("no data\n");return 0;}
 if(vobjmode!=SIMULATING) {
  vobjmode=SIMULATING;

  u1=(LINE10 *)wd_object[3].p1;
  /* hide simulation menu */
  wd_object[id-1].options |= WINDOW_HIDDEN;
  remove_background(id);
  save_winlimits();
  max_winlimits();  

  /* input data may be several files, open the list of input files */
  fd=(FILE *)fopen(u1[1].name,"r");
  if(!fd) {cannot_find_file(u1[1].name);getch();return(1);}  
  fseek(fd,0,0);
  initialize_call_types_and_elem(&classes,&elements);
  
  while(1) {
   if(!fgets(buf,30,fd)) break;
   strip(buf);
   if(!buf[0]) break;

   /* take one input data and draw on screen */     
   if(read_simdata(buf,2)) {printf("fails at %s\n",buf);getch();return 1;}
   load_pathdata(buf,1);
   /* translate vobj data to the data to simulation data */
   if(vectob_to_simdata(classes,elements,&new_class,&new_elem,0)<0) 
     {printf("error in conversion\n");return 1;}

   classes=new_class;elements=new_elem;
      
   /* correction JJ 2003 */
   for(i=0;i<NUM_ELEMENTS;i++) {elem[i].x=elem[i].y1=elem[i].y2=0;elem[i].queue=0;}	
   
   /* remove the vector objects from the screen */
   free_vector_objects(2);
  }
  restore_winlimits();  


  /* draw the simulation menu again */
  if(wd_object[id-1].options & WINDOW_HIDDEN) {  	
   wd_object[id-1].options -= WINDOW_HIDDEN;   
   update_over(id);
  }
  put_wd_objects(id,id); 

  /* get parameters from simulation menu to the simulator */

  cnvtbl_s_to_i(bb5,&sim_operations,u1[0].name);
  measuring_time.sec=string_to_int(u1[4].name);
  measuring_time.sec10_7=0;
  ignore_up_to.sec=string_to_int(u1[5].name);
  ignore_up_to.sec10_7=0;
  rand2=string_to_int(u1[7].name);
  rand1=string_to_int(u1[8].name); 
  rand_u1=(double)string_to_int(u1[9].name); 
  high=string_to_int(u1[10].name);
  low=string_to_int(u1[11].name); 
  sstep=string_to_int(u1[12].name);        
  max_chains=string_to_int(u1[6].name);

 /* trace_part is the index of a part from which statistics is taken */ 
  trace_part=0;
 /* trace_elem is the index of an element from which statistics is taken */ 
  trace_elem=0;
 
  /* set koordinates for possible printing of debug info */
  X1_max=X__max;X1_min=0;Y1_max=Y__max;Y1_min=0;
  
 /* call the simulator */ 
  simulate1(u1[2].name,u1);

  free_call_types();
 }
 flush_mouse();buttons=0;	
 return(0); 	
}

/**********************/
int read_ope()
{unsigned int options;int i=1;

 flush_mouse();
 if(wd_object[10].type!=FREE_OBJ) return 0;
 if(vobjmode==SIMDATA_IN) return 0;
 vobjmode=0;
 save_winlimits();
 free_vector_objects(2);
 options=wd_object[i].options;
 wd_object[1].options |=NO_BRING_TO_TOP;
 free_wd_objects_gt1();  
 wd_object[1].options=options;
 if(wd_object[10].type==FREE_OBJ) {
  vobjmode=SIMDATA_IN;
  list_files("*.in",11,336,200,15,5, Co1,Co2,Co3,Co4,Co5);  
  flush_mouse();
 }
 buttons=0; 
 return(0); 
}

/**********************/
int write_ope()
{
 if(vobjmode!=SIMDATA_OUT) ; 
  simdata_to_file();
 vobjmode=SIMDATA_OUT;
 flush_mouse();buttons=0;
 return(0); 
}

int file_ope()
{
 char line[20],**u2;
 int *chosen;

 if(wd_object[1].type!=FREE_OBJ) return 0;
 flush_mouse();buttons=0; 
 fill_editor1menu(17,15,15,50,2,(X__max/cs)*cs-36*cs,368-3*cr,36*cs,3*cs+15*cr,
   Co1,Co2,Co3,Co4,Co5);
 strcpy(wd_object[1].name,"nedi");
 chosen=(int *)wd_object[1].p3;      
 u2=(char **)wd_object[1].p2;

 put_wd_objects(2,2);
 flush_mouse();buttons=0; 
}

int plotter_ope()
{
 char line[20],**u2;
 int *chosen;

 if(wd_object[2].type!=FREE_OBJ) return 0;
 flush_mouse();buttons=0; 
 nocolor=15;pensize=1;

 fill_plottermenu(9,8,8,50,3,48*cs,330,
   30*cs,3*cs+8*cr,Co1,Co2,Co3,Co4,Co5);   

 strcpy(wd_object[2].name,"plotter");

 put_wd_objects(3,3);
 flush_mouse();buttons=0;
}

int simul_ope()
{
 if(wd_object[3].type!=FREE_OBJ) return 0;
 flush_mouse();buttons=0; 

 fill_sim_menu(16,12,9,50,4,(X__max/cs)*cs-63*cs,415,
  35*cs,3*cs+9*cr,Co1,Co2,Co3,Co4,Co5);   
         
 strcpy(wd_object[3].name,"simulate");

 put_wd_objects(4,4);
 flush_mouse();buttons=0; 
 return(0);
}
