/************************************
* X.C  Synchronizising subtitles
* 
* Normally, from opensubtitles.org or
* subscema.com, the subtitles are not
* synchronized. This program does it.
*
* To move the subtitle file to Linux, remember
* su
* (give root password)
* mount /dev/sda1 /mnt/usb
* cp /mnt/usb/rififi/Rififi.srt .
* chmod 777 name.srt
* exit
* (make the new file not as a root)
*
* Move back to the usb-stick:
* su
* (give root password)
* cp name.srt /mnt/usb/rififi
* umount /mnt/usb
*
* This program is run as follows:
* ./x -s name.txt            - shows subtitles from 
*                              name.txt timed as in the file.
* ./x -s name.txt hh:mm:ss   - shows subtitles from 
*                              name.txt timed as in the file 
*                              starting from hh:mm:ss
* ./x -s name.srt            - shows subtitles from 
*                              name.srt timed as in the file.
* ./x -s name.srt hh:mm:ss   - shows subtitles from 
*                              name.srt timed as in the file 
*                              starting from hh:mm:ss
* ./x -a name                - creates name.srt from name.txt without
*                              changing the timing.
* ./x -c name                - creates correctly timed name.srt
*                              from a given name.txt
* ./x -c name hh:mm:ss       - creates correctly timed name.srt
*                              from a given name.txt, specifying 
*                              the video length in hh:mm:ss. This means
*                              that the second timing place will be close to
*                              the end of the video.
* ./x -r name hh:mm:ss       - creates correctly timed name.srt
*                              from a given temp.srt, specifying 
*                              the video length in hh:mm:ss. This means
*                              that the second timing place will be close to
*                              the end of the video.
* ./x -f name                - converts name.txt to temp.srt
*
*      Jorma Jormakka
*      15.9.2016
*************************************/
#include <stdio.h>
extern int debug;
extern long int string_to_int(); 
extern char *int_to_string(); 
extern char *strchr();

text_main(argc,argv) int argc;char **argv; 
{
 long int tot,cor;
 char name[132],mode[3],offset[10];
 char *p;
 char name1[30]; 

 debug=0;

 if (argc<3 || argc>4) {printf("usage: ./x -option name [time]\n");return 1;}
 if (strlen(argv[1])>2){printf("usage: option is -s, -a or -c\n");return 1;}

 strcpy(name,argv[2]);
 strcpy(mode,argv[1]);
 if (!strcmp(mode,"-s")) {
  p=strchr(name,(int)'.');
  if(!p) {printf("usage: ./x -s name.txt or ./x -s name.srt\n");return 1;}
  if (!strcmp(p,".txt")) {
   if(argc==4) strcpy(offset,argv[3]);
   else strcpy(offset,"00:00:00");
   show_subtext_txt(name,0.0,0.0,2,offset,1);
  } 
  else if (!strcmp(p,".srt")) {
   if(argc==4) strcpy(offset,argv[3]);
   else strcpy(offset,"00:00:00");
   show_subtext_srt(name,0.0,0.0,2,offset,1); 
  }
 }
 else if (!strcmp(mode,"-c")) {
  if(argc==4) {
   strcpy(offset,argv[3]);
   combined_solution(name,2,offset);
  }
  else combined_solution(name,1,offset);
 }
 else if (!strcmp(mode,"-r")) {
  if(argc==4) {
   strcpy(offset,argv[3]);
   srt_solution(name,2,offset);
  }
  else srt_solution(name,1,offset);
 }
 else if (!strcmp(mode,"-a")) {
  strcpy(name1,name);
  p=strchr(name1,'.');*p=0;
  convert_txt_to_srt(name,name1); 
 }
 else if (!strcmp(mode,"-t")) {
  convert_tx1_to_txt(name);
 }
 else if (!strcmp(mode,"-f")) {
  convert_txt_to_srt(name,"temp.srt"); 
 }

}

