/*******************************************
* SUBTITLE_TOOL.C   
* Author:     	Jorma Jormakka
* Date:   	March.2017
********************************************/
#include <stdio.h>
#include <string.h>
#include "x.ext"
#include "win.ext"
#include "text.ext"
#include "pmenus.ext"
#include "linuxpaths.ext"

extern VECTOR_OBJECT *cvobj,*firstvobj,*lastvobj;
extern int vobjmode;
extern int xxmin,yymin,xxmax,yymax;
extern oldX,oldY;
extern int ykoor;
extern int xkoor;
extern int strangesize;
extern LETTERTABLE strangelist[];

extern Display *display;
extern XColor *xcolor;
extern XColor *xcolor2;
extern Colormap colormap;
extern Drawable win;
extern GC gc;
extern XImage *screenbuf;

extern unsigned char *resbuf;
extern int colorZ;
extern int nocolor,pensize;
extern int set_mask;
extern long convert_hhmmss_to_long();

int exit_vect_ed=1;
int debug=0;
JMPTABLE e_table[20];
int request_flag=0;
static int order=0;
static float tot_a,tot_b,cor_a,cor_b;
/**********************/
int exit1_ope()
{
 exit_vect_ed=1;
 return 1;	
}

/**********************/
int edi13_ope()
{
 fontedit();
 return 0;	
}


/**********************/
int edi10_ope()
{
 flush_mouse();
 if(wd_object[1].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_subtitlemenu(6,6,6,50,2,7*cs,400,60*cs,3*cs+6*cr,Co1,Co2,Co3,Co4,Co5); 

 put_wd_objects(2,2);
 buttons=0;

 return 0;	
}

/**********************/
int edi11_ope(id,name,x1,y1,xs,ys) int id;char *name; int x1,y1,xs,ys;
{
 FILE *stream,*stream2;
 char line[200];int ymax,xmax;

 flush_mouse();
 if(wd_object[2].type!=FREE_OBJ) return 1;
 vobjmode=0;
 
 stream=fopen(name,"rb+");
 ymax=xmax=0;
 while(1){
  if(!fgets(line,200,stream)) break;
  if(strlen(line)>xmax) xmax=strlen(line);
  ymax++;
 }
  
 make_file_window(id,x1,y1,xs,ys,Co1,Co2,Co3,Co4,name,xmax,ymax);

 put_wd_objects(id,id);
 wd_object[id-1].options |=MOVE_AS_RECTANGLE; 
 buttons=0;
 return 0;	
}

/**********************/
int edi12_ope()
{
 flush_mouse();
 if(wd_object[4].type!=FREE_OBJ) return 1;
 vobjmode=0; 

 fill_subtitlemenu2(5,3,3,50,5,7*cs,400,60*cs,3*cs+3*cr,Co1,Co2,Co3,Co4,Co5); 

 put_wd_objects(5,5);
 buttons=0;

 return 0;	
}

/***********************************************/
int main(argc,argv) int argc; char **argv;
{
 int x,y,xsize,ysize;
 int i,text_mode=0;
 LETTERTABLE *p;int j;

 /* to run in text mode, set text_mode=1 */

 if(text_mode) {
  text_main(argc,argv);
 }
 else {
  defaultfont=2;
  xxmin=0;yymin=0;xxmax=773;yymax=559;
  if(init_font(defaultfont)) 
  {printf("problems in loading font\n");return 1;} 

  if(init_font2(2)) 
  {printf("problems in loading font\n");return 1;}   
  

  if(initPool(0,0,0,0)) return 0;

  /* create and map a window in X11 */
  initgraph(argc,argv); 

  term=I86;lg=ENGL;plg=FINN | POLI;bgcol=1;
  X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
  firstvobj=lastvobj=cvobj=0;vobjmode=0;
  nocolor=15;pensize=0;
  xxmin=0;xxmax=880;yymin=0;yymax=Y__max;

  if(init_win(0,15)) return 1;
  fgbuffer=(char *)malloc(FGSIZE);if(!fgbuffer) return 1;
  bgbuffer=(char *)malloc(FGSIZE);if(!bgbuffer) return 1;
  if(initPool(1,1200*cr,0,0)) return 1;

  clearwin(X1_min,Y1_min,X1_max,Y1_max,nocolor);
  /* put icons */
  i=0;

  y=Y__max-269;
  x=X__max-40;
  getpicture("queue.fn2",x,y,&xsize,&ysize);
  fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi13_ope);

  y=Y__max-233;
  x=X__max-40;
  getpicture("nodeic.fn2",x,y,&xsize,&ysize);
  fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi12_ope);

  y=Y__max-197;
  x=X__max-40;
  getpicture("start.fn2",x,y,&xsize,&ysize);
  fill_jmptable(&e_table[i++],x,y,xsize,ysize,edi10_ope);

  y=Y__max-161;
  x=X__max-40;
  getpicture("texit.fn2",x,y,&xsize,&ysize);
  fill_jmptable(&e_table[i++],x,y,xsize,ysize,exit1_ope);

  fill_jmptable(&e_table[i++],0,0,0,0,NULL);
 
  escapePolishAndScandiChars(strangelist);
  
  do_edi1_engine(1,e_table);
 
  free_win(1,0);  
  endgraph();
  if(free_font()) {printf("problems in freeing font\n");getch();return(1);}
 }
 return 0;
}


/***************************************************
 * Concerning any fill-routine
 * max=number of u1 fields, pmax=number of u2 fields
 * window= how many u2-lines are shown
 * linelength=max length of u2-line
 * id=identifier of the menu, use a free one
 * x,y= coordinates of the left upper corner
 * xsize,ysize=size of the window
 * col1,col2,col3,col4,col5= colors used in the menu 
 * make also actions and ope-rutine
 ***************************************************/

int fill_subtitlemenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return -1;
 }
 strcpy(u2[0],"Load subtitle file ");
 strcpy(u2[1],"Time subtitle file ");
 strcpy(u2[2],"First start time  ");
 strcpy(u2[3],"Second start time "); 
 strcpy(u2[4],"Output file ");
 strcpy(u2[5],"List       files");     

 u1[0].xcord=cs*strlen("Load subtitle file ");
 u1[0].ycord=0*cr; 
 u1[0].parmax=1;
 u1[0].size=u1[0].bsize=20;
 strcpy(u1[0].name,"indiana3.txt");

 u1[1].xcord=cs*strlen("Time subtitle file ");
 u1[1].ycord=1*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=20;
 strcpy(u1[1].name,"indiana3.txt");
 
 u1[2].xcord=cs*strlen("First start time  ");
 u1[2].ycord=2*cr; 
 u1[2].parmax=1;
 u1[2].size=u1[2].bsize=12;
 strcpy(u1[2].name,"00:00:10"); 

 u1[3].xcord=cs*strlen("Second start time ");
 u1[3].ycord=3*cr; 
 u1[3].parmax=1;
 u1[3].size=u1[3].bsize=12;
 strcpy(u1[3].name,"00:38:00"); 

 u1[4].xcord=cs*strlen("Output file ");
 u1[4].ycord=4*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=20;
 strcpy(u1[4].name,"indiana3.srt"); 

 u1[5].xcord=strlen("List ")*cs; 
 u1[5].ycord=5*cr; 
 u1[5].parmax=1; 
 u1[5].size= u1[5].bsize=5;
 strcpy(u1[5].name,"*.txt"); 

 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}

int fill_subtitlemenu2(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return -1;
 }
 strcpy(u2[0],"Convert                 to ");
 strcpy(u2[1],"Convert                 to ");
 strcpy(u2[2],"Show subtitles ");

 u1[0].xcord=cs*strlen("Convert ");
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].size=u1[0].bsize=15;
 strcpy(u1[0].name,"ally5p20.txt");

 u1[1].xcord=cs*strlen("Convert                 to ");
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].size=u1[1].bsize=15;
 strcpy(u1[1].name,"ally5p20.srt");
 
 u1[2].xcord=cs*strlen("Convert ");
 u1[2].ycord=1*cr; 
 u1[2].parmax=2;
 u1[2].size=u1[2].bsize=15;
 strcpy(u1[2].name,"file.tx1"); 

 u1[3].xcord=cs*strlen("Convert                 to ");
 u1[3].ycord=1*cr; 
 u1[3].parmax=1;
 u1[3].size=u1[3].bsize=15;
 strcpy(u1[3].name,"file.txt"); 

 u1[4].xcord=cs*strlen("Show subtitles ");
 u1[4].ycord=2*cr; 
 u1[4].parmax=1;
 u1[4].size=u1[4].bsize=15;
 strcpy(u1[4].name,"ally5p20.txt"); 

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}


/***************************************************
* display manager of the tool
****************************************************/
int do_edi1_engine(maxi,jtable) int maxi;JMPTABLE *jtable;
{
 int command,i,k,k1,set_palette=0;
 unsigned char ch;
 char line[20],**u2;
 int *chosen;
 int use_marker=0,oldpensize;
 int col11;
 LINE10 *u1;
 char buf1[30];int col2;int pixel,color;


 if(init_engine(maxi)) return 1;

 while(1) {
  do {
   oldX=X;oldY=Y;
   if(!request_flag) {
    command=do_operations();
   }
   else {
    readmouse(&buttons,&X,&Y);
    
    if(buttons==1 && Y<Y__max-45)
    {
      ;
    }
    break;         	
   }
   if(command==1) {
    pensize=0;
    if(!(wd_object[0].options & WINDOW_HIDDEN)) {
     update_over(popwindow);
     update_over(1);
     remove_background(1);
     update_over(1);     
     update_over(popwindow);        	
    }
    if(edi1_operations(popwindow)==1) {
     return 1; /* exit asked */
    }
    delay(100);flush_mouse();buttons=0;
   }
   else if(command== -1) {

     /* buttons pressed, user action testing {buttons,X,Y} */
    for(i=0;jtable[i].jmpfunc;i++) {

     if(jtable[i].x1<X && jtable[i].x2>X && 
        jtable[i].y1<Y && jtable[i].y2>Y){

      exit_vect_ed=0;	
      if((*jtable[i].jmpfunc)(buttons,X,Y)) return 1; /* exit asked */
      delay(100);buttons=0;      
      break;
     }
    }
    if(!exit_vect_ed) {
     vect_ed(buttons,X,Y);
    }     
    else 
    {
      ;
    }
   } 
  } while(!kbhit());
 }
}

/******************************
* edi1_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi1_operations(id)
int id;
{
 int *chosen;
 LINE10 *u1;
 char **u2;
 FILE *stream;
 char ch;

 long int start_time,offset;
 int ystart;
 int ssave;char *p;
 char name[30];
    
 strangesize=0;
 flush_mouse();
 
 switch(id) { /* put here cases */	
  case 1:     /* this is always the error message file window */
   break;
  case 2:  /* main menu */
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    

   if(chosen[0] == 1) { /* load a subtitle file, only to look */
     init_font(1);strangesize=43; 
    edi11_ope(3,u1[0].name,8,50,95*cs,3*cs+14*cr);
    file_window(3,NORMAL_OPERATION,0);
    init_font(defaultfont);strangesize=0; 
    order=0;
   }
   else if(chosen[1] == 1) { /* set the first start time to the menu */
    if(order) break;
    edi11_ope(4,"submessages.dat",8,8,85*cs,3*cs+5*cr);
    order=1;
   }
   else if(chosen[2] == 1){/* clicking first start time, continue timing */
    if(order!=1) break;
    hide_wd_object(4);
    wd_object[3].ystart=6;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0);/* show next help text */
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;

    init_font(1);strangesize=43; 
    edi11_ope(3,u1[1].name,8,20+3*cs+6*cr,95*cs,3*cs+10*cr);
    file_window(3,NORMAL_OPERATION,1); /* show subtitle file */
    init_font(defaultfont);strangesize=0; 

    /* start_time is the time when the user clicks the up-left point in */
    /* subtitle window. Must be clicked when video is at start_time     */ 
    start_time=time_stamp();
    printf("clock started at clockstart1=%d\n",start_time);
    
    flush_mouse();buttons=0;
    hide_wd_object(4);
    wd_object[3].ystart=12;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0); /* next help text */
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;

    init_font(1);strangesize=43; 
    flush_mouse();buttons=0;
    file_window(3,NORMAL_OPERATION,1); /* show subtitle file and get a click */
    init_font(defaultfont);strangesize=0; 

    /* user clicked up-left corner in subtitle file */
    ystart=wd_object[2].ystart; /* the first line from the subtitle window */
    printf("first subtitle line=%d\n",ystart);
    offset=convert_hhmmss_to_long(u1[2].name);
    printf("first offset=%d\n",offset);

    p=strchr(u1[1].name,'.');
    if(!strcmp(p,".txt"))
     read_one_txt_line(u1[1].name,ystart,start_time,offset,&tot_a,&cor_a); 
    else if(!strcmp(p,".srt"))
     read_one_srt_line(u1[1].name,ystart,start_time,offset,&tot_a,&cor_a); 
    else {printf("not supported\n");break;}

    /* hello */
        

    printf("got tot_a=%f cor_a=%f\n",tot_a,cor_a);
 
    hide_wd_object(4);
    wd_object[3].ystart=18;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0); /* next help text */
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;

    order=2;
   }
   else if(chosen[3] == 1) { /* selected Second start time, continue timing */
    if(order!=2) break;
    hide_wd_object(4);
    wd_object[3].ystart=24;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0);/* show next help text */
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;

    init_font(1);strangesize=43; 
    file_window(3,NORMAL_OPERATION,1); /* show subtitle file */
    init_font(defaultfont);strangesize=0;  

    /* user clicked subtitle window */
    start_time=time_stamp();
    printf("clock started at clockstart2=%d\n",start_time);

    flush_mouse();buttons=0;
    hide_wd_object(4);
    wd_object[3].ystart=30;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0);
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;

    flush_mouse();buttons=0; 
    init_font(1);strangesize=43; 
    file_window(3,NORMAL_OPERATION,1);
    init_font(defaultfont);strangesize=0; 

    /* user clicked the upper left corner of the subtitle window */
    ystart=wd_object[2].ystart+5;
    printf("second subtitle line=%d\n",ystart);
    offset=convert_hhmmss_to_long(u1[3].name);
    printf("second offset=%d\n",offset);
    p=strchr(u1[1].name,'.');
    if(!strcmp(p,".txt"))
     read_one_txt_line(u1[1].name,ystart,start_time,offset,&tot_b,&cor_b); 
    else if(!strcmp(p,".srt"))
     read_one_srt_line(u1[1].name,ystart,start_time,offset,&tot_b,&cor_b); 
    else {printf("not supported\n");break;}
    printf("got tot_b=%f cor_b=%f\n",tot_b,cor_b);
   
    flush_mouse();buttons=0; 
    hide_wd_object(4);
    wd_object[3].ystart=36;
    file_window(4,DRAW_ONLY_DO_NOT_STAY,0);
    if(wd_object[3].options & WINDOW_HIDDEN)
      wd_object[3].options -= WINDOW_HIDDEN;
    free_one_wd_object(2);
    free_one_wd_object(3);

    flush_mouse();buttons=0;
    order=0;
    printf("going to calculate\n");
    /* go to calculate and write a timed subtitle file */
    p=strchr(u1[4].name,(int)'.'); if(p) *p=0;/* name must be without suffix */
    printf("to synchronize tot_a=%f cor_a=%f tot_b=%f cor_b=%f\n",
     tot_a,cor_a,tot_b,cor_b);
    synchronize((char *)u1[1].name,(char *)u1[4].name,tot_a,cor_a,tot_b,cor_b);
    if(p) *p='.';
    printf("finished\n");
    free_one_wd_object(4);
   }
   break;
 case 5:
   chosen=(int *)wd_object[id-1].p3;
   u1=(LINE10 *)wd_object[id-1].p1;    

   if(chosen[0] == 1) {
    strcpy(name,u1[0].name);
    p=strchr(name,'.');
    if(p && !strcmp(p,".txt")) {
     *p=0;
     convert_txt_to_srt(name,u1[1].name);
    }
   }
   else if(chosen[1] == 1) {
    strcpy(name,u1[2].name);
    p=strchr(name,'.');
    if(p && !strcmp(p,".tx1")) {
     *p=0;
     convert_tx1_to_txt(name,u1[3].name);
    }
   }
   else if(chosen[2] == 1) {
    strcpy(name,u1[4].name);
    p=strchr(name,'.');
    if(p && !strcmp(p,".txt")) {
     init_font(1);strangesize=43;
     show_subtext_txt(name,0.0,0.0,2,"00:00:00",0); 
     init_font(defaultfont);strangesize=0; 
    }
    else if(p && !strcmp(p,".srt")) {
     init_font(1);strangesize=43; 
     show_subtext_srt(name,0.0,0.0,2,"00:00:00",0);
     init_font(defaultfont);strangesize=0;  
    }
   }

   break;
 default:
   return edi2_operations(id);
   break;
 }
 return(0);
} 



int escapePolishAndScandiChars(p1) LETTERTABLE *p1;
{
 int j;
 LETTERTABLE *p;


 p=p1;
 strangesize=43;

 /* two byte set of Polish letter escape sequences */
 p->escape[0]=-59; p->escape[1]=-68; p->letter=0x07;  /* z. */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-123;p->letter=0x02;  /* a, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-121;p->letter=0x04;  /* c' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-126;p->letter=0x01;  /* l/ */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-101; p->letter=0x05; /* s' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-70; p->letter=0x06;  /* z' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-103;p->letter=0x03;  /* e, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-124;p->letter=0x10;  /* n' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-77;p->letter=0x08;   /* o' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-102;p->letter=0x0d;  /* S' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-127; p->letter=0x09; /* L/ */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-69; p->letter=0x0e;  /* Z' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-124; p->letter=0x0a; /* A, */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-104;p->letter=0x0b;  /* E, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-78;p->letter=0x17;   /* O' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-60; p->escape[1]=-122;p->letter=0x0c;  /* C' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-125;p->letter=0x18;  /* N' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-59; p->escape[1]=-69; p->letter=0x0f; /* Z. */ 
 p+=sizeof(LETTERTABLE);

 /* scandi chars */
 p->escape[0]=-61; p->escape[1]=-91; p->letter=0x11; /* a0 */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-92; p->letter=0x12; /* a" */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-74; p->letter=0x13; /* o" */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-126; p->letter=0x11; /* A0 */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-124; p->letter=0x12; /* A" */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-61; p->escape[1]=-106; p->letter=0x13; /* O" */ 
 p+=sizeof(LETTERTABLE);

 /* the second set of Polish chars, one byte escapes */
 p->escape[0]=-100; p->escape[1]=0;p->letter=0x05; /* s' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-26; p->escape[1]=0;p->letter=0x04;  /* c' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-22; p->escape[1]=0;p->letter=0x03;   /* e, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-77; p->escape[1]=0;p->letter=0x01;  /* l/ */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-13; p->escape[1]=0;p->letter=0x08;   /* o' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-71; p->escape[1]=0;p->letter=0x02;  /* a, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-65; p->escape[1]=0; p->letter=0x07;  /* z. */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-97; p->escape[1]=0; p->letter=0x06;  /* z' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-15; p->escape[1]=0;p->letter=0x10;  /* n' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-93; p->escape[1]=0; p->letter=0x09; /* L/ */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-116; p->escape[1]=0;p->letter=0x0d;  /* S' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-113; p->escape[1]=0; p->letter=0x0e;  /* Z' */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-87; p->escape[1]=0; p->letter=0x0a; /* A, */ 
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-38; p->escape[1]=0;p->letter=0x0b;  /* E, */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-29; p->escape[1]=0;p->letter=0x17;   /* O' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-42; p->escape[1]=0;p->letter=0x0c;  /* C' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-31; p->escape[1]=0;p->letter=0x18;  /* N' */
 p+=sizeof(LETTERTABLE);
 p->escape[0]=-81; p->escape[1]=0; p->letter=0x0f; /* Z. */ 
 p+=sizeof(LETTERTABLE);

 /* French e' replace by e */
 p->escape[0]=-23; p->escape[1]=0; p->letter='e';
 p+=sizeof(LETTERTABLE);

 return 0;
}

/******************************************************
 * fix times in a subtitle file *.txt or *.srt
 * the routine overwrites temp.srt if name is *.txt
 * name1 must be without suffix.
 ******************************************************/
int synchronize(name,name1,tot_a,cor_a,tot_b,cor_b)
char *name,*name1; float tot_a,cor_a,tot_b,cor_b;
{
 float r,k,del_a,del_b;
 char *p;
 char name2[60];

 /* this is simply fitting a straight line to two points            */
 /* let's see. Usually films are 24 fps. VLC plays 25 fps.          */
 /* so tot_i = frames_i/24. cur_i=frames_i/25, where i=a or b       */
 /* so del_i=frames_i/(24*25) and k=1/25=0.04 and r can be anything */
 /* in practise k can differ a bit from 0.04                        */
 printf("synchronize tot_a=%f cor_a=%f tot_b=%f cor_b=%f\n",
  tot_a,cor_a,tot_b,cor_b);
 del_a=tot_a-cor_a; del_b=tot_b-cor_b;
 k=(del_b-del_a)/((float)tot_b-(float)tot_a);
 r=del_a-k*((float)tot_a);
 printf("synchronize del_a=%f del_b=%f k=%f r=%f\n",del_a,del_b,k,r);


 strcpy(name2,name);
 p=strchr(name2,'.');
 if(!p) return 1;

 if(!strcmp(p,".srt")) {
  p=strchr(name1,(int)'.');
  if(p) *p=0;                      /* name1 must be without suffix */
  synchronize_str(name1,name,r,k); /* takes name and writes name1.srt */
 }
 else if (!strcmp(p,".txt")) {
  *p=0;
  convert_txt_to_srt(name2,"temp.srt");  /* takes name2.txt,writes temp.srt */
  p=strchr(name1,(int)'.');
  if(p) *p=0;                            /* name1 must be without suffix */
  synchronize_str(name1,"temp.srt",r,k); /* takes temp.srt,writes name1.srt */ 
 }
 else return 1;

 return 0;
}

read_one_txt_line(name,ystart,start_time,offset,totx,cor) 
char *name;int ystart;long start_time,offset; float *totx,*cor;
{
 int i;
 FILE *stream;
 char line[1000];
 char *pointer,*pointer2;
 long tot1,tot2,tot;
 int h1,m1,s1,ms1;


 /* first move to ystart lines from the beginning of the file */
 stream=fopen(name,"rb");
 for(i=0;i<ystart+1;i++) fgets(line,1000,stream);

 /* data is {tot1}{tot2}, get tot1 and tot2 */
 /* actually, we do not need tot2, but only check that it is there */
 if( line[0]!='{') return 1; 
 pointer=line+1;
 while (*pointer!='}') pointer++;
 *pointer=0;pointer++;
 tot1=string_to_int(line+1);
 if(*pointer!='{') {printf("error\n"); return 1;}
 else pointer++; pointer2=pointer; 
 while (*pointer!='}') pointer++;
 *pointer=0;pointer++;
 tot2=string_to_int(pointer2);

 /* the real time is *cor, it is in sec */
 *cor=time_stamp();
 *cor=*cor-start_time;
 *cor=*cor+offset;

 /* for timing we use only tot1 */
 /* it is not in ms, but in 4ms units, so convert to sec */

 ms1=tot1%25; 
 tot=tot1/25; 
 *totx=tot;

 if(debug) {
  s1=tot%60;
  tot=tot/60; 
  m1=tot%60; 
  h1=tot/60; 
  printf("hour1=%d\n",h1);  
  printf("minute1=%d\n",m1);  
  printf("second1=%d\n",s1);  
  printf("millisecond1=%d\n",ms1);
 }

 fclose(stream);
 return 0;
}

read_one_srt_line(name,ystart,start_time,offset,totx,cor) 
char *name;int ystart;long start_time,offset;float *totx,*cor;
{
 int i;
 FILE *stream;
 char line[1000];
 char *pointer,*pointer2;
 long tot1,tot2,tot,totf;
 int h1,m1,s1,ms1;
 long int curtime;
 
 /* first move to ystart-1 lines from the beginning of the file */
 stream=fopen(name,"rb");
 for(i=0;i<ystart;i++) fgets(line,1000,stream);

 /* the timing line is just before the subtext line */
 /* 00:01:00.000 --> 00:02:00.000 */

 if( line[2]==':'  && line[5]==':'  && line[13]=='-'
   && line[14]=='-' && line[15]=='>' && line[19]==':') 
 {
  /* this is the timing line */ 
  line[2]=0; line[5]=0; line[8]=0; line[12]=0;
  h1=string_to_int(line);
  m1=string_to_int(line+3);
  s1=string_to_int(line+6);
  tot=h1*3600+m1*60+s1;
  ms1=string_to_int(line+9);
  totf=(float)ms1;
  totf=totf/1000.0;
  totf=totf+(float)tot;

  /* the real time is *cor, it is in sec */
  /* and it does not have the precision of a millisecond */
  curtime=time_stamp()-start_time+offset;
  *cor=(float)curtime;

  /* time tot1 is in sec and has the milliseconds */
  *totx=totf;

  fclose(stream);
  return 0;
 }

 if(stream) fclose(stream);
 return 1;
}
