/************************************
* Y1.C  subtitle routines
* 
* 
*      Jorma Jormakka 
*      15.9.2016 
*************************************/ 
#include <stdio.h> 
#include <string.h> 

extern long int time_stamp(); 
extern long int convert_hhmmss_to_long();
extern int debug;
extern char *int_to_string();
extern long string_to_int();

long int time_stamp()
{
 char time[132];
 char *pointer;
 long int h1,m1,s1,tot;
 FILE *stream3;

 time[0]=0;
 system("date -u >log.txt");
 stream3=fopen("log.txt","r");
 fgets(time,132,stream3);
 system("rm log.txt");

 pointer=time;

 while(*pointer && *pointer!=':') pointer++;
 /* pointer points to : between hour and minute */
 pointer-=2;

 *(pointer+2)=0; *(pointer+5)=0; *(pointer+8)=0;

 h1=string_to_int(pointer);
 m1=string_to_int(pointer+3);
 s1=string_to_int(pointer+6);
 
 tot=h1*3600+m1*60+s1;

 return tot;
}

/************************************
* Synchronize subtitles
* 
* old subtitles are in 24 fps, while 
* DVD decrypter makes a file with 25 fps
* the scaling is in k and r. r is the constant delay, 
* k is the scaling factor.
* Thus, we should get 25/24=1.0416666 and k=0.0416666,
* but for some reason k is not exactly this value. 
* Both k and the delay must be given. They can be 
* determined from two timed subtitle places, it is 
* a linear function.
*
*      Jorma Jormakka
*      15.9.2016
*************************************/
synchronize_str(name,name1,r,k) char *name,*name1;float r;float k;
{
 long int h1,m1,s1,h2,m2,s2,tot,ms;
 char save;
 char line1[132];	
 char line[132];
 FILE *stream1,*stream2; 	
 float totf,delay;
 char name2[132];

 printf("synchronize_str r=%f k=%f\n",r,k);
 strcpy(name2,name);
 strcat(name2,".srt");
 stream1=fopen(name1,"r");
 stream2=fopen(name2,"wb+");

 rewind(stream1);
 rewind(stream2);

 while(1) {

  if(!fgets(line,132,stream1)) break;
 
  if (debug) printf(line);
  
  if( line[2]==':'  && line[5]==':'  && line[13]=='-'
   && line[14]=='-' && line[15]=='>' && line[19]==':'
  ) {

   line[2]=0; line[5]=0; line[8]=0;
   line[19]=0; line[22]=0; line[25]=0;
   h1=string_to_int(line);
   m1=string_to_int(line+3);
   s1=string_to_int(line+6);
 
   h2=string_to_int(line+17);
   m2=string_to_int(line+20);
   s2=string_to_int(line+23);

   tot=h1*3600+m1*60+s1;

   save=line[12];line[12]=0;
   ms=string_to_int(line+9);
   if(debug) printf("first millisecond=%d\n",ms);
   line[12]=save;
   totf=(float)ms;
   totf=totf/1000.0;
   totf=totf+(float)tot;

   if(debug) printf("tot=%d totf=%f\n",tot,totf);

   delay=k*totf+r;

   if(debug) printf("delay=%f\n",delay);
   totf=totf-delay;

   if(debug) printf("after substracting delay totf=%f\n",totf);
   tot=(long)(totf*1000.0);
   if(debug) printf("before ripping milliseconds tot=%d\n",tot);
   ms=tot%1000;
   tot=tot/1000;
   if(debug) printf("after ripping milliseconds tot=%d\n",tot);
   s1=tot%60;
   tot=tot/60;
   m1=tot%60;
   h1=tot/60;

   if(debug) {
     printf("h1=%d m1=%d s1=%d\n",h1,m1,s1);

   }


   line1[0]=0;
   if(strlen(int_to_string(h1))==1) strcat(line1,"0");
   strcat(line1,int_to_string(h1));
   strcat(line1,":");
   if(debug) printf("beginning of line=%s\n",line);
   if(strlen(int_to_string(m1))==1) strcat(line1,"0");
   strcat(line1,int_to_string(m1));
   strcat(line1,":");
   if(strlen(int_to_string(s1))==1) strcat(line1,"0");
   strcat(line1,int_to_string(s1));
   line1[8]=',';line1[9]=0;
   
   if(strlen(int_to_string(ms))==1) strcat(line1,"00");
   else if(strlen(int_to_string(ms))==2) strcat(line1,"0");
   strcat(line1,int_to_string(ms));
   strcat(line1,line+12);
   
   tot=h2*3600+m2*60+s2;

   save=line[29];line[29]=0;
   ms=string_to_int(line+26);
   line[29]=save;

   if(debug) printf("second millisecond=%d\n",ms);
   totf=(float)ms;
   totf=totf/1000.0;
   totf=totf+(float)tot;

   totf=totf-delay;
   tot=(long)(totf*1000.0);
   ms=tot%1000;
   tot=tot/1000;


   s2=tot%60;
   tot=tot/60;
   m2=tot%60;
   h2=tot/60;

   line1[17]=0;
   if(strlen(int_to_string(h2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(h2));
   strcat(line1,":");
   if(strlen(int_to_string(m2))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(m2));
   strcat(line1,":");
   if(strlen(int_to_string(s2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(s2));
   line1[25]=',';line1[26]=0;
   if(strlen(int_to_string(ms))==1) strcat(line1,"00");
   else if(strlen(int_to_string(ms))==2) strcat(line1,"0");
   strcat(line1,int_to_string(ms));
   strcat(line1,line+29);

   if(debug) printf("line1 is=%s\n",line1);
   fputs(line1,stream2);
  }
  else {
   if(line[0]=='/') fputs(line+1,stream2);
   else fputs(line,stream2);
  }

  /*  
  if(debug) {
   line1[0]=0; 
   gets(line1); 	
   if(line1[0]=='q') break;
  }
  */
  
 }
 fclose(stream1);
 fclose(stream2);
}

/******************************************
* converts subtext name.txt to name1 (.srt)
* name has no suffix
* name1 is a full name, with suffix
*
*      Jorma Jormakka 
*      15.9.2016 
******************************************/ 
 
convert_txt_to_srt(name,name1) char *name,*name1; 
{ 
 long int h1,m1,s1,h2,m2,s2,tot,ms1,ms2,ms1fix; 
 char save; 
 char line1[1000];	 
 char line[1000]; 
 FILE *stream1,*stream2;
 char *pointer,*pointer2; 	 
 long int linecounter;
 char test; 
 char carreturn[5];
 long int tot1,tot2,tot2old;
 char name2[1000];

 carreturn[0]=(char)13;carreturn[1]=(char)10;carreturn[2]=0;
 strcpy(name2,name);
 strcat(name2,".txt");

 if(debug) printf("convert_txt_to:srt opening %s\n",name2);

 if((stream1=fopen(name2,"r"))==NULL) { 
  printf("no file1 %s\n",name2); return 1;} 
 if(debug) printf("file1 opened\n");

 if((stream2=fopen(name1,"wb+"))==NULL) { 
  printf("could not create %s\n",name1); return 1;} 

 rewind(stream1); 
 rewind(stream2); 
 
 linecounter=1;
 /* to get a different starting linenumber to *.srt, put it here e.g. */
 /*  linecounter=358; */ 
 tot2old=0;
 line[0]=0;
 ms1fix=0;

 if(debug) printf("got so far\n");

 while(1) { 
 
  if(debug) printf("looping linecounter=%d\n",linecounter);
  if(!fgets(line,1000,stream1)) break; 
  if (debug) printf(line); 
   
  if( line[0]=='{') { 
   
   pointer=line+1;
   while (*pointer!='}') pointer++;
   *pointer=0;pointer++;
   tot1=string_to_int(line+1);
   if (debug) printf("tot1=%d pointer=%s\n",tot1,pointer); 

   if(*pointer!='{') {printf("error\n"); break;}
   else pointer++; pointer2=pointer;
   while (*pointer!='}') pointer++;
   *pointer=0;pointer++;
   tot2=string_to_int(pointer2);
   if (debug) printf("tot2=%d pointer2=%s pointer=%s\n",tot2,pointer2,pointer); 
   if(debug) printf("before tot2old=%d tot1=%d tot2=%d\n", tot2old, tot1,tot2);

   /* ending time of the last subtitle is tot2old */
   /* starting time of the next subtitle is tot1 */
   /* the line of the last subtitle was already written */
   if(tot2old>tot1) { /* if it really is delayed by seconds */
    if(tot2old<tot2) tot=tot2old;
   }
   else if(tot2old==tot1) {
     tot=tot2old;ms1fix=2; /* add 0.02 seconds to the starting time */
   }
   else tot=tot1;
   if(debug) printf("after tot2old=%d tot1=%d tot2=%d\n", tot2old, tot1,tot2);

   ms1=tot%25; ms1+=ms1fix;ms1fix=0;
   tot=tot/25; 
   s1=tot%60; 
   tot=tot/60; 
   m1=tot%60; 
   h1=tot/60; 

   if(debug) {
    printf("hour1=%d\n",h1);  
    printf("minute1=%d\n",m1);  
    printf("second1=%d\n",s1);  
    printf("millisecond1=%d\n",ms1);  
   }
   tot=tot2;
   tot2old=tot2;
 
   ms2=tot%25;
   tot=tot/25;
   s2=tot%60;
   tot=tot/60;
   m2=tot%60;
   h2=tot/60;

   if(debug) {
    printf("hour2=%d\n",h2);  
    printf("minute2=%d\n",m2);  
    printf("second2=%d\n",s2);  
    printf("millisecond2=%d\n",ms2);  
   }

   line1[0]=0; 
   if(strlen(int_to_string(h1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(h1)); 
   strcat(line1,":"); 
   if(strlen(int_to_string(m1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(m1)); 
   strcat(line1,":"); 
   if(strlen(int_to_string(s1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(s1)); 
   line1[8]=',';line1[9]=0; 
   if(strlen(int_to_string(ms1))==1) strcat(line1,"00"); 
   else if(strlen(int_to_string(ms1))==2) strcat(line1,"0"); 
   strcat(line1,int_to_string(ms1)); 
   strcat(line1," --> "); 

   line1[17]=0;
   if(strlen(int_to_string(h2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(h2));
   strcat(line1,":");
   if(strlen(int_to_string(m2))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(m2));
   strcat(line1,":");
   if(strlen(int_to_string(s2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(s2));
   line1[25]=',';line1[26]=0;
   if(strlen(int_to_string(ms2))==1) strcat(line1,"00");
   else if(strlen(int_to_string(ms2))==2) strcat(line1,"0");
   strcat(line1,int_to_string(ms2));
   strcat(line1,carreturn);


   if(debug) printf("line1 is=%s\n",line1);
   fputs(int_to_string((long)linecounter),stream2);
   fputs(carreturn,stream2); 
   fputs(line1,stream2); 

   if(*pointer=='/') pointer++;

   pointer2=pointer;
   while(*pointer2) {
    if(*pointer2=='|') break;
    pointer2++;
   }
   if(*pointer2) {
    if(debug) printf("found second line\n");
    *pointer2=0;pointer2++;
    fputs(pointer,stream2);
    if(debug) printf("printing first line %s\n",pointer);
    fputs(carreturn,stream2); 
    if(*pointer2=='/') pointer2++;
    if(debug) printf("printing second line %s\n",pointer2); 

    if(13==(int)pointer2[strlen(pointer2)-2] &&
       10==(int)pointer2[strlen(pointer2)-1])
     pointer2[strlen(pointer2)-2]=0; 
    fputs(pointer2,stream2);
    fputs(carreturn,stream2);

   }
   else {
    if(13==(int)pointer[strlen(pointer)-2] &&
       10==(int)pointer[strlen(pointer)-1])
     pointer[strlen(pointer)-2]=0; 
    fputs(pointer,stream2);
    fputs(carreturn,stream2);
   }
   fputs(carreturn,stream2);
   linecounter++;
  } 
  /*
  if(debug) { 
   line1[0]=0;  
   gets(line1); 	 
   if(line1[0]=='q') break; 
  } 
  */
 } 
 fclose(stream1); 
 fclose(stream2); 
} 


int locate_by_timestamping(name,r,k,argc,offs,totx,cor) 
char *name;float r;float k;int argc;char *offs; long int *totx;
long int *cor;
{ 
 long int h1,m1,s1,h2,m2,s2,tot,ms1,ms2,ms1fix; 
 char save; 
 char line1[1000];	 
 char line[1000]; 
 FILE *stream1,*stream2;
 char *pointer,*pointer2; 	 
 long int linecounter;
 char test; 
 char carreturn[5];
 long int tot1,tot2,tot2old,tot1b,tot2b,start_time,cur_time,delay;
 char instring[10];
 long int linecounter1,offset;
 float totf;
 int time_stamping;
 char name2[1000];
 int debug1=1;

 strcpy(name2,name);
 strcat(name2,".txt");
 if(debug) printf("opening %s\n",name2);
 carreturn[0]=(char)13;carreturn[1]=(char)10;carreturn[2]=0;

 if((stream1=fopen(name2,"r"))==NULL) { 
  printf("no file %s\n",name2); return 1;} 

 if(debug) printf("file %s opened\n",name2); 
 if (argc!=1) { /* start as ./x hh:mm:ss */
  if(argc!=2) {printf("bad input\n");return 1;}
  if(debug) printf("got here\n"); 
  if(debug) printf("offset=%s\n",offs); 
  /* decode offset hh:mm:ss */
  strcpy(instring,offs);
  if(*(instring+2)!=':' || *(instring+5)!=':'){
    printf("wrong input\n"); return 1;}
  *(instring+2)=0; *(instring+5)=0;*(instring+8)=0;
  h1=string_to_int(instring);
  m1=string_to_int(instring+3);
  s1=string_to_int(instring+6);
  offset=h1*3600+m1*60+s1;
  if(debug) printf("offset=%d\n",offset);
 }
 else offset=0;

 if(debug) printf("here2 offset=%d\n",offset);
 if(debug) printf("r=%f k=%f\n",r,k); 
 rewind(stream1); 
 linecounter=1;  

 if(offset>0) {  /* advance up to offset */
  linecounter1=1;
  while(1) {
   memset(line,0,1000); 
   if(!fgets(line,1000,stream1)) break; 
   if(line[0]=='{') {    
    pointer=line+1;
    while (*pointer!='}') pointer++;
    *pointer=0;pointer++;
    tot1=string_to_int(line+1);
    totf=tot1/25.0;
    totf=(1.0-k)*totf-r;
    tot1=(long)totf;
    if(tot1>=offset) break;
    linecounter1++;
   } 
  }
  /* now we have read a line that is just a bit after offset */
  /* we rewind the stream and run up to the previous line */
  rewind(stream1); 
  while(1) { 
   memset(line,0,1000); 
   if(!fgets(line,1000,stream1)) break; 
   if( line[0]=='{') {    
    pointer=line+1;
    while (*pointer!='}') pointer++;
    *pointer=0;pointer++;
    tot1=string_to_int(line+1);
    totf=tot1/25.0;
    totf=(1.0-k)*totf-r;
    tot1=(long)totf;

    if(linecounter>=linecounter1-1) {linecounter++; break;}
    linecounter++;
   }
  }
  /* next line to read is the first to be bigger than offset */ 
 }
 
 if(debug) printf("after offset loops linecounter=%d\n",linecounter);

 if((stream2=fopen("temp1.srt","wb+"))==NULL) { 
  printf("cound not create temp1.srt\n"); return 1;} 

 rewind(stream2); 
 
 tot2old=0;
 line[0]=0;
 ms1fix=0;

 time_stamping=1;
 start_time=time_stamp();
 while(1) { 
  memset(line,0,1000); 
  if(!fgets(line,1000,stream1)) break; 
  if (debug1) printf("reading line %s\n",line); 
   
  if( line[0]=='{') { 
   
   pointer=line+1;
   while (*pointer!='}') pointer++;
   *pointer=0;pointer++;
   tot1=string_to_int(line+1);
   if (debug1) printf("tot1=%d pointer=%s\n",tot1,pointer); 

   if(*pointer!='{') {printf("error\n"); break;}
   else pointer++; pointer2=pointer;
   while (*pointer!='}') pointer++;
   *pointer=0;pointer++;
   tot2=string_to_int(pointer2);
   if (debug1) printf("tot2=%d pointer2=%s\n",tot2,pointer2); 
   if (debug1) printf("wrote tot2 pointer2 press a key\n");
   if (debug1) getchar();

   /* ending time of the last subtitle is tot2old */
   /* starting time of the next subtitle is tot1 */
   /* the line of the last subtitle was already written */
   if(tot2old>tot1) { /* if it really is delayed by seconds */
    if(tot2old<tot2) tot=tot2old;
   }
   else if(tot2old==tot1) {
     tot=tot2old;ms1fix=2; /* add 0.02 seconds to the starting time */
   }
   else tot=tot1;
   if (debug1) {printf("hello1 press a key\n");getchar();}
   if(debug1) printf("after tot2old=%d tot1=%d tot2=%d\n", tot2old, tot1,tot2);

   ms1=tot%25; ms1+=ms1fix;ms1fix=0;
   tot=tot/25; 

   if (debug1) {printf("hello2 press a key\n");getchar();}

   /* in time stamping, we overwrite the time from the file */
   /* but we keep the old time in tot1b */
   if(time_stamping) {
    tot1b=tot;
    line1[0]=0;
    if(debug1) printf("waiting here\n"); 
    printf("%s",pointer);
    line1[0]=getchar(); /* here we wait for the user to press a key */
    if(debug1) printf("got a key press\n"); 
    if(debug1) getchar();
    tot=time_stamp();
    tot=tot-start_time;
    tot=tot+offset;
    tot2b=tot; 	

    if(line1[0]=='q') return 1;
    else if (line1[0]=='c') time_stamping=0;
    else if (line1[0]=='s') {
     *totx=tot1b;
     *cor=tot;
     if(debug1) printf("printing timestamped\n"); 
     printf("timestamped as=%s\n",line1);
     return 0;
    }
   }
   if (debug1) {printf("hello3 press a key\n");getchar();}
   s1=tot%60; 
   tot=tot/60; 
   m1=tot%60; 
   h1=tot/60; 

   if(debug) {
    printf("hour1=%d\n",h1);  
    printf("minute1=%d\n",m1);  
    printf("second1=%d\n",s1);  
    printf("millisecond1=%d\n",ms1);  
   }
   tot=tot2;
   tot2old=tot2;
 
   ms2=tot%25;
   tot=tot/25;

   /* we also overwrite this time */
   if(time_stamping) {
    tot=tot-tot1b+tot2b;
   } 

   s2=tot%60;
   tot=tot/60;
   m2=tot%60;
   h2=tot/60;

   if(debug) {
    printf("hour2=%d\n",h2);  
    printf("minute2=%d\n",m2);  
    printf("second2=%d\n",s2);  
    printf("millisecond2=%d\n",ms2);  
   }

   line1[0]=0; 
   if(strlen(int_to_string(h1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(h1)); 
   strcat(line1,":"); 
   if(strlen(int_to_string(m1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(m1)); 
   strcat(line1,":"); 
   if(strlen(int_to_string(s1))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(s1)); 
   line1[8]=',';line1[9]=0; 
   if(strlen(int_to_string(ms1))==1) strcat(line1,"00"); 
   else if(strlen(int_to_string(ms1))==2) strcat(line1,"0"); 
   strcat(line1,int_to_string(ms1)); 
   strcat(line1," --> "); 

   line1[17]=0;
   if(strlen(int_to_string(h2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(h2));
   strcat(line1,":");
   if(strlen(int_to_string(m2))==1) strcat(line1,"0"); 
   strcat(line1,int_to_string(m2));
   strcat(line1,":");
   if(strlen(int_to_string(s2))==1) strcat(line1,"0");
   strcat(line1,int_to_string(s2));
   line1[25]=',';line1[26]=0;
   if(strlen(int_to_string(ms2))==1) strcat(line1,"00");
   else if(strlen(int_to_string(ms2))==2) strcat(line1,"0");
   strcat(line1,int_to_string(ms2));
   strcat(line1,carreturn);

   fputs(int_to_string((long)linecounter),stream2);
   fputs(carreturn,stream2); 
   fputs(line1,stream2); 

   if(*pointer=='/') pointer++;

   pointer2=pointer;
   while(*pointer2) {
    if(*pointer2=='|') break;
    pointer2++;
   }
   if(*pointer2) {
    *pointer2=0;pointer2++;
    fputs(pointer,stream2);
    fputs(carreturn,stream2); 
    if(*pointer2=='/') pointer2++;

    if(13==(int)pointer2[strlen(pointer2)-2] &&
       10==(int)pointer2[strlen(pointer2)-1])
     pointer2[strlen(pointer2)-2]=0; 
    fputs(pointer2,stream2);
    fputs(carreturn,stream2);

   }
   else {
    if(13==(int)pointer[strlen(pointer)-2] &&
       10==(int)pointer[strlen(pointer)-1])
     pointer[strlen(pointer)-2]=0; 
    fputs(pointer,stream2);
    fputs(carreturn,stream2);
   }
   fputs(carreturn,stream2);
   linecounter++;
  } 
 } 
 fclose(stream1); 
 fclose(stream2); 
} 


int locate_srt_by_timestamping(name,r,k,argc,offs,totx,cor) 
char *name;float r;float k;int argc;char *offs; long int *totx;
long int *cor;
{ 
 int first_text_line,wait_for_space;
 long int h1,m1,s1,ms1; 
 long int tot,tot1,start_time;
 long int linecounter,linecounter1,offset;
 char test;
 char line[1000]; 
 char instring[10];
 FILE *stream1;
 float totf;

 if((stream1=fopen("temp.srt","r"))==NULL) { 
  printf("no file temp.srt\n"); return 1;} 

 if (argc!=1) { /* start as ./x hh:mm:ss */
  if(argc!=2) {printf("bad input\n");return 1;}

  /* decode offset hh:mm:ss */
  strcpy(instring,offs);
  if(*(instring+2)!=':' || *(instring+5)!=':'){
    printf("wrong input\n"); return 1;}
  *(instring+2)=0; *(instring+5)=0;*(instring+8)=0;
  h1=string_to_int(instring);
  m1=string_to_int(instring+3);
  s1=string_to_int(instring+6);
  offset=h1*3600+m1*60+s1;
 }
 else offset=0;

 rewind(stream1); 
 linecounter=1;  

 if(offset>0) {  /* advance up to offset */
  linecounter1=1;
  while(1) { 
   if(!fgets(line,1000,stream1)) break;

   if( line[2]==':'  && line[5]==':'  && line[13]=='-'
    && line[14]=='-' && line[15]=='>' && line[19]==':'
   ) {
    /* this is a timing line from temp.srt */ 
    line[2]=0; line[5]=0; line[8]=0; line[12]=0;
    h1=string_to_int(line);
    m1=string_to_int(line+3);
    s1=string_to_int(line+6);
    tot=h1*3600+m1*60+s1;
    ms1=string_to_int(line+9);
    totf=(float)ms1;
    totf=totf/1000.0;
    totf=totf+(float)tot;
    totf=(1.0-k)*totf-r;
    tot1=(long)totf;
    if(tot1>=offset) break;
    linecounter1++;
   }
  } 

  /* now we have read a line that is just a bit after offset */
  /* we rewind the stream and run up to the previous line */
  rewind(stream1); 

  while(1) { 
   if(!fgets(line,1000,stream1)) break;

   if( line[2]==':'  && line[5]==':'  && line[13]=='-'
    && line[14]=='-' && line[15]=='>' && line[19]==':'
   ) {
    /* this is a timing line from temp.srt */ 
    line[2]=0; line[5]=0; line[8]=0; line[12]=0;
    h1=string_to_int(line);
    m1=string_to_int(line+3);
    s1=string_to_int(line+6);
    tot=h1*3600+m1*60+s1;
    ms1=string_to_int(line+9);
    totf=(float)ms1;
    totf=totf/1000.0;
    totf=totf+(float)tot;
    totf=(1.0-k)*totf-r;
    tot1=(long)totf;

    if(linecounter>=linecounter1-1) break;
    linecounter++;
   }
  } 
  /* next line to read is the first to be bigger than offset */ 
 } 

 line[0]=0;
 wait_for_space=0;
 first_text_line=0;
 start_time=time_stamp();
 printf("locate3 start_time=%d\n",start_time);

 while(1) { 

  if(!fgets(line,1000,stream1)) break; 
  
  if( line[2]==':'  && line[5]==':'  && line[13]=='-'
   && line[14]=='-' && line[15]=='>' && line[19]==':') 
  {
    /* this is the timing line from temp.srt */ 
   line[2]=0; line[5]=0; line[8]=0; line[12]=0;
   h1=string_to_int(line);
   m1=string_to_int(line+3);
   s1=string_to_int(line+6);
   tot=h1*3600+m1*60+s1;
   ms1=string_to_int(line+9);
   totf=(float)ms1;
   totf=totf/1000.0;
   totf=totf+(float)tot;
   totf=(1.0-k)*totf-r;
   tot1=(long)totf;
   first_text_line=1;
   linecounter++;

   /* the time when to show first text is in tot1 */

  }
  else 
  {
   /* can be text line and there can be more of them */
   /* can be empty line, or the line number line */
   /* show the first line in the correct time */
 
   if(first_text_line) {

    /* we print the first text line */
    /* we wait for the user to press a key */
    /* if he presses s, we get a time stamp */    
    printf(line);       
    test=getchar(); 
    tot=time_stamp();
    tot=tot-start_time;
    tot=tot+offset;

    if(test=='q') return 1;
    else if (test=='s') {
     *totx=tot1;
     *cor=tot;
     return 0;
    }
    first_text_line=0;
    wait_for_space=1;
   }
   else if (wait_for_space) {
    printf(line); 
    wait_for_space=0;      
   }
  }
 } 
 fclose(stream1); 
 return 0;
} 

int combined_solution(name,argc,offs) char *name;int argc;char *offs;
{
 char offset[10],offset1[10];
 float r,k,del_a,del_b;
 long tot_a,tot_b,cor_a,cor_b,off;

 printf("SYNCHRONIZING SUBTEXT %s\n",name);
 strcpy(offset,"00:00:10");
 strcpy(offset1,offset);
 
 printf("start video from beginning. When video is at %s hit cr\n",offset); 
 getchar();

 printf("LOCATE A BEGINNING PHRASE: press cr until known phrase found\n");
 printf("Write s and hit cr to set.\n");

 if(locate_by_timestamping(name,0.0,0.0,2,offset,&tot_a,&cor_a)) return 1;
 
 printf("GOT PLACE cor_a=%d tot_a=%d, press cr to continue\n",cor_a,tot_a); 
 getchar();

 if(argc==2) {
  strcpy(offset1,offs);
  off=convert_hhmmss_to_long(offset1);
  off=off-10; /* ten seconsd to the end of the video */
  convert_long_to_hhmmss(off,offset);
 }
 else strcpy(offset,"00:38:00");

 printf("Move in video just before %s and let run.\n",offset);
 printf("When video is at %s press carriage return\n",offset);
 getchar();

 printf("LOCATE AN ENDING PHRASE: do as before\n");
 if(locate_by_timestamping(name,0.0,0.0,2,offset,&tot_b,&cor_b)) return 1;

 printf("GOT PLACE cor_b=%d tot_b=%d\n",cor_b,tot_b); 
 printf("EARLIER   cor_a=%d tot_a=%d\n",cor_a,tot_a); 
 del_a=tot_a-cor_a; del_b=tot_b-cor_b;
 k=(del_b-del_a)/((float)tot_b-(float)tot_a);
 r=del_a-k*((float)tot_a);

 printf("FOUND r=%f k=%f  printf any key\n",r,k);
 getchar();

 convert_txt_to_srt(name,"temp.srt"); 
 printf("WROTE temp.srt\n");
 
 synchronize_str(name,"temp.srt",r,k); 
 printf("WROTE %s.srt\n",name);
 
 return 0;
}

int srt_solution(name,argc,offs) char *name;int argc;char *offs;
{
 char offset[10],offset1[10];
 float r,k,del_a,del_b;
 long tot_a,tot_b,cor_a,cor_b,off;
 char name1[30];

 printf("SYNCHRONIZING SUBTEXT %s\n",name);
 strcpy(offset,"00:00:10");
 strcpy(offset1,offset);
 
 printf("start video from beginning. When video is at %s hit cr\n",offset); 
 getchar();

 printf("LOCATE A BEGINNING PHRASE: press cr until known phrase found\n");
 printf("Write s and hit cr to set.\n");

 if(locate_srt_by_timestamping(name,0.0,0.0,2,offset,&tot_a,&cor_a)) return 1;
 
 printf("GOT PLACE cor_a=%d tot_a=%d, press cr to continue\n",cor_a,tot_a); 
 getchar();

 if(argc==2) {
  strcpy(offset1,offs);
  off=convert_hhmmss_to_long(offset1);
  off=off-10; /* ten seconsd to the end of the video */
  convert_long_to_hhmmss(off,offset);
 }
 else strcpy(offset,"00:38:00");

 printf("Move in video just before %s and let run.\n",offset);
 printf("When video is at %s press carriage return\n",offset);
 getchar();

 printf("LOCATE AN ENDING PHRASE: do as before\n");
 if(locate_srt_by_timestamping(name,0.0,0.0,2,offset,&tot_b,&cor_b)) return 1;

 printf("GOT PLACE cor_b=%d tot_b=%d\n",cor_b,tot_b); 
 printf("EARLIER   cor_a=%d tot_a=%d\n",cor_a,tot_a); 
 del_a=tot_a-cor_a; del_b=tot_b-cor_b;
 k=(del_b-del_a)/((float)tot_b-(float)tot_a);
 r=del_a-k*((float)tot_a);

 printf("FOUND r=%f k=%f\n",r,k);

 strcpy(name1,name);strcat(name1,"1");
 synchronize_str(name1,name,r,k); 
 printf("WROTE %s.srt\n",name1);
 
 return 0;
}

