/****************************************************
* G1.C 	Graphical window package
*	- basic graphics routines
*      	Author:		Jorma Jormakka
*      	original date:	26.1.93
*	last modified:	6.11.99
*	Copyright: Jorma Jormakka, all rights reserved
* History: 26.10.99 JJ getpicture was indicated as 
*          PCX-uncompress, it is not
*	6.11.99 JJ draw_frame2, improved print of scale
*       Ported to Linux, switch LINUX flag on
******************************************************/
#ifdef DOS_VERSION
#include <dir.h>
#else
#include "bunny"
#include "linuxpaths.txt"
#define BITMAPDEPTH 1
#endif

#include "x.ext"
#include "text.ext"
#include "win.ext"
#include <string.h>
#define MAX_MAPPED_STRING_LENGTH 20
extern int nocolor;
extern int strangesize;
extern LETTERTABLE *strangelist;
extern int exit_vect_ed;
extern unsigned char swap_byte();
extern int mouse_off;
extern int gplanes;
int oldX,oldY,fg1col;
extern unsigned char *resbuf; /* result will be here */
typedef struct vesablock{
 char vesasig[4];
 unsigned int version;
 char *oemstring;
 char capabilities[4];
 unsigned int *videomode;
 unsigned int memory;
 char reserved[242];
} VESABLOCK;

void strip_off_ending();
int old_mode;
int lineLen;
int ybanksize;
int pathsize[40];
PathData *pathdata[40];

unsigned int palette256[256]={
  0,1,2,3,4,5,7,20,56,57,58,59,60,61,62,63,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
    
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
      
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,  

  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,	
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,      
};
int cur_button=0;
int as_rectangle=0;
int xxmin,yymin,xxmax,yymax;
extern int ysizeb,csb;
static int xxmins,yymins,xxmaxs,yymaxs;
FILE *outstream;
char *int_to_string();
extern FILE *fopen();
char *int_to_string();

#ifndef DOS_VERSION
Display *display;
int screen;
Drawable win;
/* Window win;  2017*/
GC gc;
unsigned int window_width, window_height;
XEvent report;
XKeyEvent keyreport;
XSizeHints size_hints;
XFontStruct *font_info;
int window_size=0;
Colormap colormap;
/* Window window; */
Drawable window;
XColor *xcolor;
int charcount=0,cur_keypress=0;
XImage *screenbuf=NULL;
XImage *screenbuf1=NULL;
KeySym keysym;
char keybuffer[MAX_MAPPED_STRING_LENGTH];
int X1mouse,Y1mouse,X2mouse,Y2mouse;
#endif


/******************
* CONTENTS:
***********************************
* basic graphics routines
************************************/
void initgraph();
void initvesagraph();
void endvesagraph();
void setVGApalette();
int  change_pixel();
int  plot_point2();
int  put_point1();
int  put_point();
void plot_pointlim();
void plot_pointlim2();
void drawpixellim();
void drawpixellim2();
unsigned char read_byte();
void movewin2();

/*****************************************
* drawing simple geometrical forms
******************************************/
void drawLine();
void draw_line();
void draw_line1();
void fillcube();
void fillbox();
void rectangle();

/*****************************************
* parts of a menu look
******************************************/
void putVertArrows();
void putHorArrows();
void putWinFrame();
void update_yscrollbar();
void update_xscrollbar();
void draw_frame2();

/*****************************************
* filling irregular area with color
******************************************/
void fill_hump();
void fill_area();
int line_right_or_left();
void flood_fill();

/*********************************************
* save/load uncompressed pictures
**********************************************/
void savedrawbar();
void getdrawbar();
int  savebuf_tofile();
int  loadbuf_fromfile();
int  save_picture();
int  get_picture();
void getpicture();

/************************************
* save and read 16-color palette
************************************/
int getpalette();
int savepalette();
int getuserpalette();
int saveuserpalette();

/********************************************************
* PCX-compression for screen image, 16-color VGA 18 mode. 
********************************************************/
int save_as_pcxfile();

static char buffer123[32];
/*********************************
*
*  string_to_int
*
*********************************/
long int string_to_int(c)
char *c;
{
 long int  n=0,sign=1;
 char *p;
 
 for(p=c;*p==' ';p++);
 if(*p=='-') {sign= -1;p++;} else if(*p=='+') p++;
 
 while (*p>='0' && *p<='9') {n= 10*n+(long)*p-(long)'0';p++;}
 return(sign*n);
}

/*********************************
*
*  int_to_string
*
*********************************/
char *int_to_string(n)
long int n;
{
 register int i,sign=1;

 if(n<0) {sign= -1;n= -n;}
 if(!n) {strcpy(buffer123,"0");return(buffer123);}
 i=31;
 buffer123[31]=(char)0;
 while(n) {
  buffer123[--i]=(char)(n%10+48);
  n=n/10;
 }
 if(sign<0) buffer123[--i]='-';
 	
 return(buffer123+i);
}

/*****************************************
* draws a pixel and returns original color 
* if point inside limits, else does nothing
******************************************/
int put_point1(X,Y,color,xmin,ymin,xmax,ymax)
int X,Y,color;
int xmin,ymin,xmax,ymax;
{
 if(X>xmax || X<xmin || Y>ymax || Y<ymin) return(color);
 return(plot_point(X,Y,color));
}
/*****************************************
* draws a pixel and returns original color 
* if point inside limits, else does nothing
* sets a byte in plane
******************************************/
int put_point(X,Y,color,plane,xmin,ymin,xmax,ymax)
int X,Y,color;
char *plane;
int xmin,ymin,xmax,ymax;
{
 int x,y;
 
 if(X>xmax || X<xmin || Y>ymax || Y<ymin) return(color);
 x=(X-xmin)>>1;y=(Y-ymin)>>1;
 *(plane+ISIZE*y+x)=color;
 return(plot_point(X,Y,color));
}
/*****************************************
* draws a pixel and reads original color 
* if point inside limits xxmin,yymin,xxmax,yymax
* sets original color to buf
******************************************/
void plot_pointlim(x,y,color,buf) int x,y,color;unsigned char *buf;
{
 if(x>=xxmin && x<xxmax && y>=yymin && y<yymax)
 *buf=(char)plot_point(x,y,color);
}
void plot_pointlim2(x,y,color,buf) int x,y,color;VUNIT *buf;
{
 if(x>=xxmin && x<xxmax && y>=yymin && y<yymax)
 *buf=(VUNIT)plot_point2(x,y,color);
}

/*****************************************
* draws a pixel 
* if point inside limits xxmin,yymin,xxmax,yymax
******************************************/
void drawpixellim(x,y,color) int x,y,color;
{
 if(x>=xxmin && x<xxmax && y>=yymin && y<yymax) 
 drawpixel(x,y,color);
}     
void drawpixellim2(x,y,color) int x,y,color;
{
 if(x>=xxmin && x<xxmax && y>=yymin && y<yymax) 
 drawpixel2(x,y,color);
}     
/************************************************
*  bit-aligned movewin:
*   moves a rectangle (x1,y1,x2,y2) to
*   (x3,y3,x3+x2-x1,y3+y2-y1)
*   Destroys fgbuffer, data must fit in fgbuffer 
*************************************************/
void movewin2(x1,y1,x2,y2,x3,y3) int x1,y1,x2,y2,x3,y3;
{int isize,clength;
 clength=(x2-x1)/8+1;isize=gplanes*clength;
 save_buf2(x1,y1,0,0,x2-x1,y2-y1,x1&7,clength,isize,fgbuffer);  	
 draw_buf2(x3,y3,0,0,x2-x1,y2-y1,x3&7,clength,isize,fgbuffer);  	     
}
/**************************************************
* byte aligned move window
***************************************************/
void movewin(x1,y1,x2,y2,x3,y3) int x1,y1,x2,y2,x3,y3;
{
 move_win(x1,y1,x2,y2,x3,y3,lineLen);
}

/*****************************************
* drawing simple geometrical forms
******************************************/
/*****************************************
* straight line drawing
******************************************/
void drawLine(x1, y1, x2, y2, color, linewidth, pattern)
int x1, y1, x2, y2, color, linewidth;
unsigned long pattern;
{
 int dx,dy,dxabs,dyabs,i,j,px,py,sdx,sdy,x,y;
 unsigned long mask=0x80000000;
 
 x1 += 320;
 y1 = 175 -((y1*93)>>7);
 x2 += 320;
 y2 = 175 - ((y2*93)>>7);
 dx = x2 - x1;
 dy = y2-y1;
 sdx = sign(dx);
 sdy = sign(dy);
 dxabs= (dx>=0? dx : -dx);
 dyabs= (dy>=0? dy : -dy);
 x=0;
 y=0;
 px=x1;
 py=y1;
 if(dxabs>=dyabs){
  for (i=0;i<dxabs;i++)
  {
   mask = mask ? mask : 0x80000000;
   y += dyabs;
   if(y>=dxabs)
   {
    y -= dxabs;
    py += sdy;
   }
   px += sdx;
     
   if (pattern & mask)
   {
    for (j= -linewidth/2;j<= linewidth/2;j++)
     drawpixel(px,py+j,color);
   }
   mask >>= 1;
  }
 }
 else {
  for (i=0;i<dyabs;i++){
   mask = mask ? mask : 0x80000000;
   x += dxabs;
   if(x>=dyabs){
    x -= dyabs;
    px += sdx;
   }
   py += sdy;
   if (pattern & mask)
   {
    for (j= -linewidth/2;j<=linewidth/2;j++)
     drawpixel(px+j,py,color);
   }
   mask >>= 1;
  }
 }
}

/*****************************************
* straight line drawing or writing Postcript
* to outstream.
******************************************/
void draw_line(x1,y1,x2,y2,col,print1)
int x1,y1,x2,y2,col,print1;
{
 char line[300];
 
 if(!print1) draw_line1(x1,y1,x2,y2,col);
 else {
  strcpy(line,"Or moveto ");
  strcat(line,int_to_string((long)x1));
  strcat(line," CX ");	
  strcat(line,int_to_string((long)(Y1_max-Y1_min-y1) ));  
  strcat(line," CX rmoveto ");
  strcat(line,int_to_string((long)(x2-x1)));
  strcat(line," CX ");	
  strcat(line,int_to_string((long)(-y2+y1) ));  
  strcat(line," CX rlineto stroke\n");
  fputs(line,outstream);	
 }
}
/*****************************************
* straight line drawing
******************************************/
void draw_line1(x1,y1,x2,y2,col)
int x1,y1,x2,y2,col;
{	
 int i,j;
 int a1,b1,a2,b2;long z;
 
 if(x1<=x2) {a1=x1;a2=x2;} else {a1=x2;a2=x1;}
 if(y1<=y2) {b1=y1;b2=y2;} else {b1=y2;b2=y1;} 
 
 if(a1==a2) {
  for(j=b1;j<=b2;j++) drawpixel(a1,j,col);
  return;
 }
 if(b1==b2) {
  for(i=a1;i<=a2;i++) drawpixel(i,b1,col);  	
  return;
 }
 if((a2-a1)>=(b2-b1)) {
  for(i=a1;i<=a2;i++){
   z=(y2-y1)*(i-x1);
   j=z/(x2-x1)+y1;
   drawpixel(i,j,col);
  }
 } 
 else {
  for(j=b1;j<=b2;j++){
   z=(x2-x1)*(j-y1);
   i=z/(y2-y1)+x1;
   drawpixel(i,j,col);
  }
 }
}
void draw_line2b(x1,y1,x2,y2,pixel)
int x1,y1,x2,y2;unsigned long pixel; 
{	
 int i,j;
 int a1,b1,a2,b2;long z;
 
 if(x1<=x2) {a1=x1;a2=x2;} else {a1=x2;a2=x1;}
 if(y1<=y2) {b1=y1;b2=y2;} else {b1=y2;b2=y1;} 
 
 if(a1==a2) {
  for(j=b1;j<=b2;j++) drawpixel2b(a1,j,pixel);
  return;
 }
 if(b1==b2) {
  for(i=a1;i<=a2;i++) drawpixel2b(i,b1,pixel);  	
  return;
 }
 if((a2-a1)>=(b2-b1)) {
  for(i=a1;i<=a2;i++){
   z=(y2-y1)*(i-x1);
   j=z/(x2-x1)+y1;
   drawpixel2b(i,j,pixel);
  }
 } 
 else {
  for(j=b1;j<=b2;j++){
   z=(x2-x1)*(j-y1);
   i=z/(y2-y1)+x1;
   drawpixel2b(i,j,pixel);
  }
 }
}
/*****************************************
* draw a cube
******************************************/
void fillcube(XC,YC,ZC,HX,HY,HZ,col1,col2,col3) 
int XC,YC,ZC,HX,HY,HZ,col1,col2,col3;
{ 
 register int i,j;
 int JC,IC;

 JC=YC-ZC/2;
 IC=XC+ZC/2; 
 for (i=0;i<HX;i++) {
  for (j=0;j<HY;j++) { 	
   drawpixel((int)(IC+i),(int)(JC+j),(int)col1);
  }
 }
 for (i=0;i<HX;i++) {
  for (j=1;j<(HZ+1)/2;j++) { 	
   drawpixel((int)(IC+i+j),(int)(JC-j),(int)col2);
  }
 } 
 for (i=0;i<HZ/2;i++) {
  for (j=0;j<HY;j++) { 	
   drawpixel((int)(IC+HX+i),(int)(JC+j-i),(int)col3);
  }
 }  
}    
clearwin(x1,y1,x2,y2,col) int x1,y1,x2,y2,col;
{
 unsigned long pixel;
 pixel=xcolor[col].pixel;
 clear_win1(x1,y1,x2,y2,pixel);
}
/*****************************************
* draw a square
******************************************/
void fillbox(XC,YC,HX,HY,color) 
int XC,YC,HX,HY, color;
{ 
 clearwin(XC,YC,XC+HX,YC+HY,color);
}
void fillbox_c(XC,YC,HX,HY,color) 
int XC,YC,HX,HY, color;
{ 
 clearwin_c(XC,YC,XC+HX,YC+HY,color);
}
int fillbox2(x1,y1,HX,HY,pixel) 
int x1,y1,HX,HY,pixel;
{
  int i,j,x2,y2;unsigned long pixel1;

  x2=x1+HX;y2=y1+HY;
  pixel1=pixel;

 for(i=x1;i<x2;i++) for(j=y1;j<y2;j++) 
  drawpixel2c(i,j,pixel1);
 
 XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,HX,HY);
 return 1;
}
int fillbox3(x1,y1,HX,HY,pixel) 
int x1,y1,HX,HY,pixel;
{
  int i,j,x2,y2;unsigned long pixel1;

  x2=x1+HX;y2=y1+HY;
  pixel1=pixel;

 for(i=x1;i<x2;i++) for(j=y1;j<y2;j++) 
  drawpixel2c(i,j,pixel1);
 
 return 1;
}
    
/*****************************************
* draw a rectangle
******************************************/

void rectangle(x1,y1,x2,y2,col) int x1,y1,x2,y2,col;
{int i;
 for(i=x1;i<x2;i++) {drawpixel(i,y1,col);drawpixel(i,y2,col);}
 for(i=y1;i<y2;i++) {drawpixel(x1,i,col);drawpixel(x2,i,col);}
}

/*****************************************
* parts of a menu look
******************************************/
/*****************************************
* draw arrow heads for vertical scrolling
******************************************/
void putVertArrows(x,y,size,color) int x,y,size,color;
{  
 int i,j;
 unsigned long pix;
 
 if(color+16<21)
  pix=xcolor[color+16].pixel;
 else pix=xcolor[color].pixel;

 for(j=0;j<9;j++) { 
  for(i=(j+1)/2;i<9-(j+1)/2;i++) {
   drawpixel2b(x+i,y+8-j,pix);
  }
 }
 for(j=0;j<9;j++) { 
  for(i=(j+1)/2;i<9-(j+1)/2;i++) {
   drawpixel2b(x+i,y+size-8+j,pix);
  }
 }
}
/*****************************************
* draw arrow heads for horizontal scrolling
******************************************/
void putHorArrows(x,y,size,color) int x,y,size,color;
{  
 int i,j;
 unsigned long pix;
 
 if(color+16<21)
  pix=xcolor[color+16].pixel;
 else pix=xcolor[color].pixel;

 for(i=0;i<9;i++) { 
  for(j=4-i/2;j<5+i/2;j++) {
   drawpixel2b(x+i,y+j,pix);
  }
 }
 for(i=0;i<9;i++) { 
  for(j=4-i/2;j<5+i/2;j++) {
   drawpixel2b(x+size-i,y+j,pix);
  }
 }
}
/*****************************************
* draw window frame for a menu/text window
******************************************/
void putWinFrame(x,y,ysize,xsize,xfrom,yfrom,xmax,ymax,percentx,percenty,color,options,mode)
int x,y,ysize,xsize,xfrom,yfrom;
int xmax,ymax;
long *percentx,*percenty;
int color;
unsigned int options;
int mode;
{
 int j;
 long result;
 unsigned long pix,pix2;

 pix2=xcolor[15].pixel;

 if(color>=0) pix=xcolor[color].pixel;
 else pix=xcolor[15].pixel;

 if(!mode) {
  for(j=x;j<x+xsize;j++) {
   drawpixel2c(j,y,pix);
   drawpixel2c(j,y+1,pix2);
   drawpixel2c(j,y+10,pix);
   drawpixel2c(j,y+11,pix2);
   drawpixel2c(j,y+ysize-2,pix2);  
   drawpixel2c(j,y+ysize-1,pix);  
  }
  for(j=y+1;j<y+ysize-1;j++) {
   drawpixel2c(x,j,pix);
   drawpixel2c(x+1,j,pix2);
   drawpixel2c(x+10,j,pix);  
   drawpixel2c(x+11,j,pix2);  
   drawpixel2c(x+xsize-2,j,pix2);
   drawpixel2c(x+xsize-1,j,pix);
  }

  for(j=x+11;j<x+xsize-3;j++) drawpixel2c(j,y+ysize-4,pix);
 
  for(j=y+11;j<y+ysize-3;j++) drawpixel2c(x+xsize-4,j,pix);  
 
  for(j=y+1;j<y+10;j++) drawpixel2c(x+xsize-11,j,pix);   
  for(j=y+1;j<y+10;j++) drawpixel2c(x+xsize-12,j,pix2);   

  for(j=y+3;j<y+7;j++) drawpixel2c(x+3,j,pix2);     	
  for(j=x+3;j<x+7;j++) drawpixel2c(j,y+3,pix2);     	
  fillbox3(x+4,y+4,4,4,pix);	       	/* move window marker */

  for(j=y+3;j<y+7;j++) drawpixel2c(x+xsize-8,j,pix2);     	
  for(j=x+xsize-8;j<x+xsize-1;j++) drawpixel2c(j,y+3,pix2);
  fillbox3(x+xsize-7,y+4,4,4,pix);     	/* kill window marker */

  XPutImage(display,win,gc,screenbuf,(int)x,(int)y,(int)x,(int)y,
   (unsigned int)(x+xsize-1),(unsigned int)(y+ysize-1));
 }
 if(ymax>0)  
  *percenty=result=(yfrom<<MAGFACT)/ymax;
 else *percenty=0;

 if(xmax>0)  
  *percentx=result=(xfrom<<MAGFACT)/xmax;
 else *percentx=result=0;
   
 if(!(options & NO_VERTICAL_SCROLLING)) {
  if(!mode) putVertArrows(x+1,y+11,ysize-13,color);  /* vertical scrollbar */
  update_yscrollbar(percenty,result,Co1,color,x,y,y+ysize-1);
 }
 if(!(options & NO_HORIZONTAL_SCROLLING)) { 
  if(!mode) putHorArrows(x+11,y+1,xsize-23,color);   /* horizontal scrollbar */
  update_xscrollbar(percentx,result,Co1,color,x,x+xsize,y);
 }
}
void putWinFrame_old(x,y,ysize,xsize,xfrom,yfrom,xmax,ymax,percentx,percenty,color,options,mode)
int x,y,ysize,xsize,xfrom,yfrom;
int xmax,ymax;
long *percentx,*percenty;
int color;
unsigned int options;
int mode;
{
 int j;
 long result;

 if(!mode) {
  for(j=x;j<x+xsize;j++) {
   drawpixel(j,y,color);
   drawpixel(j,y+10,color);
   drawpixel(j,y+ysize-1,color);  
  }
  for(j=y+1;j<y+ysize-1;j++) {
   drawpixel(x,j,color);
   drawpixel(x+10,j,color);  
   drawpixel(x+xsize-1,j,color);
  }
 
  for(j=x+11;j<x+xsize-3;j++) drawpixel(j,y+ysize-4,color);
  for(j=y+11;j<y+ysize-3;j++) drawpixel(x+xsize-4,j,color);  
  
  for(j=y+1;j<y+10;j++) drawpixel(x+xsize-11,j,color);   

  fillbox(x+3,y+3,5,5,color);			/* move window marker */  	
  fillbox(x+xsize-8,y+3,5,5,color);		/* kill window marker */
 }
 if(ymax>0)  
  *percenty=result=(yfrom<<MAGFACT)/ymax;
 else *percenty=0;

 if(xmax>0)  
  *percentx=result=(xfrom<<MAGFACT)/xmax;
 else *percentx=result=0;
   
 if(!(options & NO_VERTICAL_SCROLLING)) {
  if(!mode) putVertArrows(x+1,y+11,ysize-13,color);  /* vertical scrollbar */
  update_yscrollbar(percenty,result,Co1,color,x,y,y+ysize-1);
 }
 if(!(options & NO_HORIZONTAL_SCROLLING)) { 
  if(!mode) putHorArrows(x+11,y+1,xsize-23,color);   /* horizontal scrollbar */
  update_xscrollbar(percentx,result,Co1,color,x,x+xsize,y);
 }
}
/*****************************************
* update vertical scroll bar
******************************************/
void update_yscrollbar(percent,new_value,col1,col2,x1min,y1min,y1max)
long *percent;
long new_value;
int col1,col2;
int x1min,y1min,y1max;
{
 long result;
 int j,x,y;
 unsigned long pix,pix2,pix1;

 pix2=xcolor[15].pixel;
 if(col1>=0) pix=xcolor[col1].pixel;
 if(col2>=0) pix1=xcolor[col2].pixel;

 result=(*percent)*(y1max-y1min-39);result=result>>MAGFACT;

 y=y1min+22+(int)result;
 x=x1min+3;
 fillbox2(x,y,5,5,pix);     	
 
    
 *percent=new_value;
 result=(*percent)*(y1max-y1min-39);result=result>>MAGFACT;

 y=y1min+22+(int)result;
 x=x1min+3;
 
 for(j=y;j<y+4;j++) drawpixel2b(x,j,pix2);     	
 for(j=x;j<x+4;j++) drawpixel2b(j,y,pix2);     	
 fillbox2(x+1,y+1,4,4,pix1);
       	
}
/*****************************************
* update horizontal scroll bar
******************************************/
void update_xscrollbar(percent,new_value,col1,col2,x1min,x1max,y1min)
long *percent;
long new_value;
int col1,col2;
int x1min,x1max,y1min;
{
 long result;
 int j,x,y;
 unsigned long pix,pix2,pix1;

 pix2=xcolor[15].pixel;
 if(col1+16<21)
  pix=xcolor[col1+16].pixel;
 else if(col1>=0) pix=xcolor[col1].pixel;
 if(col2+16<21)
  pix1=xcolor[col2+16].pixel;
 else if(col2>=0) pix1=xcolor[col2].pixel;
 
 result=(*percent)*(x1max-x1min-49);result=result>>MAGFACT;

 y=y1min+3;
 x=x1min+22+(int)result;
 fillbox2(x,y,5,5,pix);     	

 *percent=new_value;
 result=(*percent)*(x1max-x1min-49);result=result>>MAGFACT;

 y=y1min+3;
 x=x1min+22+(int)result;
 for(j=y;j<y+4;j++) drawpixel2b(x,j,pix2);     	
 for(j=x;j<x+4;j++) drawpixel2b(j,y,pix2);     	
 fillbox2(x+1,y+1,4,4,pix1);
}
/*****************************************
* draw frame for plotting
******************************************/
void draw_frame2(x1,y1,x2,y2,a1,col1,col2,
		xscale,yscale,xpow,ypow,xstart,ystart,
		clear,yl,nogrid,noxs,noys,xnum,print1,xx,yy1)
int x1,y1,x2,y2,a1,col1,col2;
double xscale,yscale;
int xpow,ypow;
double xstart,ystart;
int clear,yl,nogrid,noxs,noys,xnum,print1,xx,yy1;
{int i,xc,yc,j;double num1;long num,prevnum;

 if(clear) clearwin(x1,y1,x2,y2,col2);
 draw_line(x1+2*a1,y1,x2,y1,col1,print1);
 draw_line(x1+2*a1,y2-a1,x2,y2-a1,col1,print1);
 draw_line(x2,y1,x2,y2-a1,col1,print1);  
 draw_line(x1+2*a1,y1,x1+2*a1,y2-a1,col1,print1);   
 ykoord=y2-a1/2-5;
 for(i=0,prevnum=-1;i<=xnum;i++) {
  num1=((double)i)*xscale+xstart;
  for(j=0;j<xpow;j++) num1*=10.0;
  num=num1;
  xkoord=2*a1+xx*i+x1-cs;
  if(num1-(double)num>0.0999) {
   num=10*num1;
   if(!noxs) text1(print1,num,xpow+1,0,15);
  }
  else {
   if(!noxs) {if(num!=prevnum) text1(print1,num,xpow,0,15);}  	
  }
  prevnum=num;
  xkoord+=cs;
  draw_line(xkoord,y2-a1,xkoord,y2-a1+3,col1,print1);
  if(!nogrid)   
  for(yc=y2-a1-10;yc>y1;yc-=10) {
   draw_line(xkoord,yc,xkoord,yc,col1,print1); 
  }  
 }
 xkoord=x1+8;
 for(i=0;i<=yl;i++) {
  num1=i*yscale+ystart;
  for(j=0;j<ypow;j++) num1*=10;num=num1;
  ykoord=y2-a1-yy1*i-cr/2;
  xkoord-=4;
  if(!noys) text1(print1,num,ypow,0,15);
  xkoord+=4;
  draw_line(x1+2*a1-3,ykoord+cr/2,x1+2*a1,ykoord+cr/2,col1,print1);     
  if(!nogrid)
  for(xc=x1+2*a1+10;xc<x2;xc+=10) {
   draw_line(xc,ykoord+cr/2,xc,ykoord+cr/2,col1,print1);
  }       
 }
}

/*****************************************
* filling irregular area with color
******************************************/
/*****************************************
* part of flood_fill
******************************************/
void fill_hump(xlast,xnew,y,color,color1,xmin,ymin,xmax,ymax,off1,off2)
int xlast,xnew,y,color,color1,xmin,ymin,xmax,ymax,off1,off2; 
{
 int x,color2;
 
 if(xnew<xlast-1) {
  for(x=xnew+1;x<xlast;x++) {
   color2=plot_point(x,y-off1,color);drawpixel(x,y-off1,color2);
   if(color2==color1) flood_fill(x,y-off1,color,xmin,ymin,xmax,ymax);
  }
 }
 else if(xnew>xlast+1) {
  for(x=xlast+1;x<xnew;x++) {   	
   color2=plot_point(x,y-off2,color);drawpixel(x,y-off2,color2);
   if(color2==color1) flood_fill(x,y-off2,color,xmin,ymin,xmax,ymax);
  }
 }
}

/*****************************************
* kind of flood fill
******************************************/
void fill_area(X,Y,color,plane,xmin,ymin,xmax,ymax)
int X,Y,color;
char *plane;
int xmin,ymin,xmax,ymax;
{ int Xleft,Xright,YYa,YY1,YY2,i;

  Xleft=Xright=X;
  while(put_point(Xleft,Y,color,plane,xmin,ymin,xmax,ymax)!=color) Xleft--;
  Xright++;
  while(put_point(Xright,Y,color,plane,xmin,ymin,xmax,ymax)!=color) Xright++;
  
  X=(Xleft+Xright)>>1;

  YY1=Y+1;
  while(put_point(X,YY1,color,plane,xmin,ymin,xmax,ymax)!=color){
   Xleft=Xright=X;
   while(put_point(Xleft-1,YY1,color,plane,xmin,ymin,xmax,ymax)!=color) 
    Xleft--;
   while(put_point(Xright+1,YY1,color,plane,xmin,ymin,xmax,ymax)!=color) 
    Xright++;
   X=(Xleft+Xright)>>1;
   YY1++;
  }
  YY2=Y-1;
  while(put_point(X,YY2,color,plane,xmin,ymin,xmax,ymax)!=color){
   Xleft=Xright=X;
   while(put_point(Xleft-1,YY2,color,plane,xmin,ymin,xmax,ymax)!=color) 
    Xleft--;
   while(put_point(Xright+1,YY2,color,plane,xmin,ymin,xmax,ymax)!=color) 
    Xright++;
   X=(Xleft+Xright)>>1;
   YY2--;
  }  
}
/*****************************************
* part of flood fill
******************************************/
int line_right_or_left(x,y,color,color1,xmin,ymin,xmax,ymax,direc) 
int x,y,color,color1,xmin,ymin,xmax,ymax,direc;
{
 int x1,color2;
 
 x1=x+direc;
 while(1){
  color2=put_point1(x1,y,color,xmin,ymin,xmax,ymax);
  if(color2!=color1) {drawpixel(x1,y,color2);break;}
  x1+=direc;
  if(x1>X__max || x1<-1) break;
 }
 return(x1);
}
/*****************************************
* flood fill fills irregular area with color
******************************************/     
void flood_fill(X,Y,color,xmin,ymin,xmax,ymax)
int X,Y,color;
int xmin,ymin,xmax,ymax;
{ 
 int Xl,Xr,Xleft,Xright,lastX,Y0,color1,color2,k;
 color1=put_point1(X,Y,color,xmin,ymin,xmax,ymax);
 
 Xl=line_right_or_left(X,Y,color,color1,xmin,ymin,xmax,ymax,-1);
 if(Xl<-1) return;
 Xr=line_right_or_left(X,Y,color,color1,xmin,ymin,xmax,ymax,1); 
 if(Xr>X__max) return;
 
 for(k= -1;k<2;k+=2) {
  Xright=Xr;Xleft=Xl;Y0=Y+k;
  while(1) {
   for(X=Xright-1;X>Xleft;X--) {
    color2=put_point1(X,Y0,color,xmin,ymin,xmax,ymax);
    if(color2==color1) break;
    drawpixel(X,Y0,color2);
   }
   if(X==Xleft) break;
   lastX=Xleft;
   Xleft=line_right_or_left(X,Y0,color,color1,xmin,ymin,xmax,ymax,-1);
   if(Xleft<-1) return;
   fill_hump(lastX,Xleft,Y0,color,color1,xmin,ymin,xmax,ymax,k,0);
   lastX=Xright;
   Xright=line_right_or_left(X,Y0,color,color1,xmin,ymin,xmax,ymax,1);    
   if(Xright>X__max) return;
   fill_hump(lastX,Xright,Y0,color,color1,xmin,ymin,xmax,ymax,0,k);
   Y0+=k;
  }
 }
}
/*********************************************
* save/load uncompressed pictures
**********************************************/
/******************
* save drawbar.fn2
*******************/
void savedrawbar()
{int ymax;
 char *plane;	
 plane=(char *)malloc(480*20);
 ymax=479;if(ymax>Y__max) ymax=Y__max;
 if(plane) { 
  save_buf1(616,0,24,ymax,5,20,plane); 
  savebuf_tofile("drawbar.fn2",32,ymax,20,plane);  
  free(plane);plane=0;
 }
 else no_memory(); 	
}
/******************
* read drawbar.fn2
*******************/
void getdrawbar(place) int place;
{char *plane;int ymax;
 int xsize=32,isize=20,ysize;
 
 ysize=Y__max-1;
 ymax=479;if(ymax>Y__max) ymax=Y__max; 
 

 plane=(char *)malloc(480*20*4);
 if(plane) {
  if(loadbuf_fromfile("drawbar.fn2",&xsize,&ysize,&isize,plane)) {
   gplanes=GPLANES;
   return;
  }  

  draw_buf1(place,0,24,ymax,5,20,plane);
 
  gplanes=GPLANES;
  free(plane);plane=0;
 }
 else no_memory();	
}
/************************************
* save a drawing uncompressed (*.fn2)
*************************************/
int savebuf_tofile(file_name,xsize,ysize,isize,plane) 
char *file_name;
int xsize,ysize,isize;
char *plane;
{
 register int j;
 FILE *stream;
 unsigned char s[8];
 int clength;
 
 clength=xsize/8+1;
 stream=fopen(file_name,"r+b"); 	
 if(!stream) stream=fopen(file_name,"w+b"); 	 
 if (!stream)
 {  
  cannot_create_file(file_name);getch();
  return(1);
 }  
 fseek(stream,0,0);
 s[0]=0xff & isize;s[1]=0xff & (isize>>8);
 s[2]=(char)(0xff & gplanes); /* use as gplanes */
 s[3]=0;/* reserve, not used yet */   
 s[4]=0xff & ysize;s[5]=0xff & (ysize>>8);  
 s[6]=0xff & xsize;s[7]=0xff & (xsize>>8);
 fwrite(s,1,8,stream);
 for(j=0;j<ysize;j++) fwrite(plane+j*isize,1,(long)(gplanes*clength),stream);
 fclose(stream); 
 return(0);
}
/************************************
* read uncompressed (*.fn2) drawing
* the routine changes gplanes
*************************************/
int loadbuf_fromfile(file_name,xsize,ysize,isize,plane) 
char *file_name;
int *xsize,*ysize,*isize;
char *plane;
{
 int j,i;
 FILE *stream;
 unsigned char s[8],*buf,*bufsave;
 int xsize2,ysize2,isize2; 
 long length,off;
 char line[200];
 
 stream=fopen(file_name,"r+b");

 if (!stream)
 {  
  /* try full name */

#ifdef DOS_VERSION
  strcpy(line,"X:\\");
  line[0]='A'+getdisk();
  getcurdir(0,line+3);
  strcat(line,"\\FN2");
  chdir(line);
  stream=fopen(file_name,"r+b"); 	
#else
  strcpy(line,fn2path);
  strcat(line,file_name);
  stream=fopen(line,"r+b"); 
#endif
  if (!stream)
  { 
   cannot_find_file(file_name);
   return 1;
  }
 } 

 /* fn2 is just a simple format I made in old PC times */
 /* there were only four color planes. There are no 24 planes */
 fseek(stream,0,0);
 fread(s,1,8,stream);     /* 8 byte header */
 isize2=s[0] | (s[1]<<8); /* isize in two bytes s[0],s[1] */
 if(!s[2]) gplanes=4;     /* s[2]=number of color planes, or 0 */
 else gplanes=(int)s[2]; 
                          /* s[3] was never used */
 ysize2=s[4] | (s[5]<<8); /* ysize in s[4],s[5] */
 xsize2=s[6] | (s[7]<<8); /* xsize in s[6],s[7] */

 if(*ysize>ysize2) *ysize=ysize2; /* usually set ysize=7fff */  	
 if(*isize>isize2) *isize=isize2; /* usually set isize=7fff */ 
          /* in the call, so they get downgraded to the real values */ 	 	  
 if(*xsize>=xsize2) {  /* the same with xsize */
   *xsize=xsize2; 
  length=gplanes*((*xsize)/8+1);
  
  for(buf=plane,j=0;j<*ysize;j++) {
   fread(buf,1,length,stream);  /* just read (*ysize)*(*isize) bytes */
   buf += (*isize);
  } 
 }
 else {  
  off=xsize2/8 - (*xsize)/8;
  length= (*xsize)/8+1;

  for(buf=plane,j=0;j<*ysize;j++) {
   bufsave=buf;
   for(i=0;i<gplanes;i++) {
    fread(buf,1,length,stream);
    fseek(stream,off,1);
    buf += length;    
   }
   buf=bufsave;
   buf += (*isize);
  }
 }
 fclose(stream);
 return 0;
}
/******************************************
* save a image uncompressed (*.fn2)
* save palette only in DOS (i.e. GPLANES=4)
*******************************************/
int save_picture(name,x1,y1,x2,y2,isize,palet) 
char *name;
int x1,y1,x2,y2,isize;
unsigned char *palet;
{
 FILE *stream; char *tmpplane; char line[30];
 int clength;
 
 clength=(x2-x1)/8+1;
 tmpplane=(char *)malloc(isize*(y2-y1+1));
 if(!tmpplane) no_memory();    
 else {
  stream=0;
  stream=fopen(name,"r");
  if(stream) { /* copy on a existing file? */
   fclose(stream);
   if(!copy_on_existing_file()) {
    return(-1);
    stream=fopen(name,"rb+");     
   }
  }
  if(!stream) stream=fopen(name,"wb+"); 
  if(!stream) { /* error can't create file */
   cannot_create_file();getch();return(-1);
  }
  fclose(stream);       	
  sound(E2);
  save_buf2(x1,y1,0,0,x2-x1,y2-y1,x1%8,clength,isize,tmpplane);     
  savebuf_tofile(name,x2-x1,y2-y1,isize,tmpplane);
  free(tmpplane);
  if(palet && GPLANES==4) {
   line[0]=0;strcpy(line,name);strip_off_ending(line);strcat(line,".pal");     
   saveuserpalette(palet,line);     
  }
  nosound();       
 }
 return(0);
}        

/************************************
* read uncompressed (*.fn2) image
* read and set palette
*************************************/
int get_picture(name,x1,y1,x2,y2,isize,palet) 
char *name;
int x1,y1,*x2,*y2,*isize;
unsigned char *palet;
{
 int i; FILE *stream; char *tmpplane; char line[30];
 int clength,xsize,ysize;
 
 tmpplane=(char *)malloc(55440*4);
 if(!tmpplane) {no_memory();return(1);}
 else {
  xsize= *x2-x1;ysize= *y2-y1;
  if(loadbuf_fromfile(name,&xsize,&ysize,isize,tmpplane)) 
  {free(tmpplane);gplanes=GPLANES;return(1);}
  clength= xsize/8+1;

  draw_buf2(x1,y1,0,0,xsize,ysize,x1%8,clength,*isize,tmpplane);       
  free(tmpplane);
  if(GPLANES==4) { /* set palette only in DOS, that is GPLANES=4 */
   line[0]=0;strcpy(line,name);strip_off_ending(line);strcat(line,".pal");
   if(getuserpalette(palet,line)) return (1);
   for(i=0;i<16;i++) setVGApalette(i,(int)palet[i]);
  }
  else gplanes=GPLANES; /* restore the original gplanes */
  *x2=xsize+x1;*y2=ysize+y1;  
 }
 return(0);
}     
/************************************
* save and read 16-color palette
*************************************/
int getpalette(palette) unsigned char *palette;
{
 return(getuserpalette(palette,"palette.dat"));
}
int savepalette(palette) unsigned char *palette;
{
 return(saveuserpalette(palette,"palette.dat"));
}
int getuserpalette(palette,name)
unsigned char *palette;char *name;
{
 FILE *stream;int i;char buf[6];

 stream=fopen(name,"r+b"); 	
 if (!stream){sound(E2);delay(100);nosound();return(1);}  
 fseek(stream,0,0);	   	
 for(i=0;i<16;i++) {	   	
  memset(buf,0,6);
  fread(buf,1,2,stream);
  palette[i]=string_to_int(buf);
 }
 return(0);
}
int saveuserpalette(palette,name)
unsigned char *palette;char *name;
{
 FILE *stream;int i;char buf [6];

 stream=fopen(name,"r+b"); 	
 if(!stream) stream=fopen(name,"w+b"); 	 
 if (!stream){cannot_create_file(name);return(1);} 
 fseek(stream,0,0);
 for(i=0;i<16;i++) {
  memset(buf,0,6);
  strcpy(buf,int_to_string((long)palette[i]));
  if(buf[1]==0) {
   buf[1]=buf[0];buf[0]=' ';	
  }
  fwrite(buf,1,2,stream);   
 }
 return(0);
}

/****************************************************************
* For viewing the plotted curves in Windows compress the image to 
* a PaintBrush *.pcx-file
* - the routine works for graphics mode 18 with VGA-display
*****************************************************************/
int save_as_pcxfile(x1,y1,x2,y2,file_name)
int x1,y1,x2,y2;char *file_name;
{	
 int i,j,k,add1,add2,number,num_out,line_length,end,start_line,end_line;
 unsigned char ch,ch1,old_ch,red,green,blue;
 FILE *fsave;int bits;
 
 fsave=fopen(file_name,"wb+");
 if(!fsave) return(1);
 fputc(0x0a,fsave); /*password */ 
 fputc(0x05,fsave); /*version 3.0 */
 fputc(0x01,fsave); /*run length encoding */
 fputc(0x01,fsave); /* bits per pixel */
 putw(x1,fsave);    /* window dimensions */   
 putw(y1,fsave);       
 putw(x2,fsave);       
 putw(y2,fsave);         
 putw(X__max+1,fsave);   /* horizontal resolution */    
 putw(Y__max+1,fsave);   /* vertical resolution */

 for(i=0;i<16;i++) { /* color map */
  bits=palette256[i];
  red=  (((bits & 0x20)>>5)|((bits & 0x04)>>1))*85;
  green=(((bits & 0x10)>>4)|((bits & 0x02)))*85;
  blue= (((bits & 0x08)>>3)|((bits & 0x01)<<1))*85;
  fputc(red,fsave);
  fputc(green,fsave);
  fputc(blue,fsave);
 }
     
 fputc(0x00,fsave); /* reserved */
 fputc(0x04,fsave); /* number of color planes */
 start_line=x1/8;end_line=x2/8+1;
 line_length=end_line-start_line;
 putw(line_length,fsave); /* number of bytes per line in a color plane */
 putw(1,fsave);		  /* color/monochrome palette */
 for(i=70;i<128;i++) fputc(' ',fsave); /* fill to the end of header */

 ch=0x00; 
 end=start_line+line_length*4+1;
 for(k=y1;k<=y2;k++) {
  add1=lineLen*k;
  number=1;
  j=0;
  add2= (start_line);
  old_ch=read_byte(add1+add2++,0);
  for(i=add2;i<end;i++) {
   if(i==end-1) ch=old_ch-1;
   else {
    if((add2)== end_line) { 
     j++;
     add2= start_line;
    }     
    ch=read_byte(add1+add2,j);
   }
   if((ch==old_ch) && number<63) number++;
   else {
    num_out=((unsigned char)number | 0xc0);
    if((number != 1) || ((old_ch & 0xc0)==0xc0)) fputc(num_out,fsave);
    fputc(old_ch,fsave);
    old_ch=ch;
    number=1;
   }
   add2++;
  }
 }
 fclose(fsave);
 return(0);
}  

/********************************************/
void getpicture(name,x1,y1,xsize,ysize) 
char *name;int x1,y1;int *xsize,*ysize;
{
 char *plane;
 int isize;char *name2;
 LETTERTABLE *p;int j;
 FILE *stream;
#ifdef DOS_VERSION
 char curdir[MAXPATH];
 
 strcpy(curdir,"X:\\");
 curdir[0]='A'+getdisk();
 getcurdir(0,curdir+3);
 strcat(curdir,"\\FN2");
 chdir(curdir);
 name2=name;
#else
 char curdir[100];
 strcpy(curdir,fn2path);
 strcat(curdir,name);
 name2=curdir;
#endif 
 *xsize=*ysize=isize=0x7fff;

 /* just check that the fn2-file is there */ 
 stream=fopen(name2,"r");
 if(stream) fclose(stream);
 else {
   strcpy(name2,name); /* try if there is a local fn2-file */
 }

 plane=(char *)malloc(80*80*4);
 if(plane) {

  if(loadbuf_fromfile(name2,xsize,ysize,&isize,plane)) {
    gplanes=GPLANES;return;}
 
  draw_buf1b(x1,y1,*xsize,*ysize,(*xsize)/8+1,isize,x1%8,plane); 	
  free(plane);
  /* loadbuf_fromfile may change gplanes, restore it after drawing */
  gplanes=GPLANES; 
 }
 else no_memory();	
 curdir[strlen(curdir)-4]=0;
 chdir(curdir); 
 
}

/********************************************************
* superVGA related changes
*********************************************************/
#ifdef SuperVGA
int clearwin(x1,y1,x2,y2,col) int x1,y1,x2,y2,col;
{	
 check_bank(y1);	
 if(y1<ybanksize) {
  if(y2<ybanksize) clear_win(x1,y1,x2,y2,col,lineLen);
  else {
   clear_win(x1,y1,x2,511,col,lineLen);
   check_bank(ybanksize);
   clear_win(x1,0,x2,y2-ybanksize,col,lineLen);
  }
 }
 else clear_win(x1,y1-512,x2,y2-512,col,lineLen);
 return 0;
}
int draw_buf2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,b)
int xcord,ycord,xstart,ystart,xsize,ysize,r,c,i;char *b;
{	

 check_bank(ycord);	
 if(ycord<ybanksize) {
  if(ycord+ysize<ybanksize) draw_buf_2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,lineLen,b);
  else {
   draw_buf_2(xcord,ycord,xstart,ystart,xsize,ybanksize-ycord,r,c,i,lineLen,b);
   check_bank(ybanksize);
   draw_buf_2(xcord,0,xstart,ystart+ybanksize,xsize,ysize-ybanksize+ycord,r,c,i,lineLen,b);
  }
 }
 else draw_buf_2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,lineLen,b);
 return 0;
}
int save_buf2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,b)
int xcord,ycord,xstart,ystart,xsize,ysize,r,c,i;char *b;
{	
 check_bank(ycord);	
 if(ycord<ybanksize) {
  if(ycord+ysize<ybanksize) save_buf_2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,lineLen,b);
  else {
   save_buf_2(xcord,ycord,xstart,ystart,xsize,ybanksize-ycord,r,c,i,lineLen,b);
   check_bank(ybanksize);
   save_buf_2(xcord,0,xstart,ystart+ybanksize,xsize,ysize-ybanksize+ycord,r,c,i,lineLen,b);
  }
 }
 else {
  save_buf_2(xcord,ycord,xstart,ystart,xsize,ysize,r,c,i,lineLen,b);
 }
 return 0;
}
int drawpixel(x,y,col) int x,y,col;
{
 check_bank(y);
 if(y>=ybanksize) draw_pixel(x,y-ybanksize,col,lineLen);
 else draw_pixel(x,y,col,lineLen);
 return 0;
}
#endif

int circle(XC,YC,R,color) 
int XC,YC;double R;int color;
{ double x,y;
  int old_x=-1,old_y1,old_y2;
  
 x= -R;
 while(1) {
  y=sqrt(R*R-x*x);
  if(old_x>=0){
   draw_line1(old_x,old_y1,(int)x+XC,YC-(int)y,color);
   draw_line1(old_x,old_y2,(int)x+XC,YC+(int)y,color);     
  }
  else {
   drawpixel((int)x+XC,YC-(int)y,color);
   drawpixel((int)x+XC,YC+(int)y,color);  
  }
  old_x=(int)x+XC;old_y1=YC-(int)y;old_y2=YC+(int)y;
  x+=0.5;
  if(x>R) break;
 }
 return 0;
}    

int xored_oval(XC,YC,R,A,pixel,wWidth,wHeight) 
int XC,YC;double R,A;unsigned long pixel;int wWidth,wHeight;
{ 
 double x,y;int j;int x1,oldx1=-1,first=1;
 unsigned long pix;

 for(y=0.0;y<=R;y+=0.1) {
  x=sqrt(R*R-y*y);
  x1=(int)(A*x);
  if(x1 && oldx1!=x1) {
   for(j=-y;j<=+y;j++) {
    if(j+YC>=0 && j+YC<wHeight) {
     if(XC-x1>=0) {
      pix=getpixel2c(XC-x1,YC+j);
      drawpixel2b(XC-x1,YC+j,pix^pixel);
     }
     if(XC+x1<wWidth) { 
      pix=getpixel2c(XC+x1,YC+j);
      drawpixel2b(XC+x1,YC+j,pix^pixel);
     }
    }
   }
   oldx1=x1;
  }
  if(!x1 && first) {
   first=0;
   for(j=-R;j<=R;j++) {
    if(j+YC>=0 && j+YC<wHeight) {
     pix=getpixel2c(XC,YC+j);
     drawpixel2b(XC,YC+j,pix^pixel);
    } 
   }
  }
 }
 return 0;
}    

/*********************/
arch1(XC1,YC1,xmin,xmax,R,color) 
int XC1,YC1,xmin,xmax;double R;int color;
{ double x,y;
  int old_x1=-1,old_y1;
  
 x= -R;
 while(1) {
  y=sqrt(R*R-x*x);
  if(old_x1>=0){
   if((x<0 && x>=-xmin) || (x>=0 && x<xmax)) 
    draw_line1(old_x1,old_y1,(int)x+XC1,YC1-(int)y,color);
  }
  else {
   if((x<0 && x>=-xmin) || (x>=0 && x<xmax))   	
    drawpixel((int)x+XC1,YC1-(int)y,color);
  }
  old_x1=(int)x+XC1;old_y1=YC1-(int)y;
  x+=1.0;
  if(x>R) break;
 }
 return 0;
}    
/*********************/
arch2(XC,YC,xmin,xmax,R,color) 
int XC,YC,xmin,xmax;double R;int color;
{ double x,y;
  int old_x=-1,old_y1;
  
 x= -R;
 while(1) {
  y=sqrt(R*R-x*x);
  if(old_x>=0){
   if((x<0 && x>=-xmin) || (x>=0 && x<xmax)) 
    draw_line1(old_x,old_y1,(int)x+XC,YC+(int)y,color);
  }
  else {
   if((x<0 && x>=-xmin) || (x>=0 && x<xmax))   	
    drawpixel((int)x+XC,YC+(int)y,color);
  }
  old_x=(int)x+XC;old_y1=YC+(int)y;
  x+=1.0;
  if(x>R) break;
 }
 return 0;
}
/*******/    
arch3(XC,YC,ymin,ymax,R,color) 
int XC,YC,ymin,ymax;double R;int color;
{ double x,y;
  int old_x=-1,old_y1,old_y2;
  
 x= -R;
 while(1) {
  y=sqrt(R*R-x*x);
  if(old_x>=0){
   if(y<=ymin && YC-old_y1>=-ymax) 
    draw_line1(old_x,old_y1,(int)x+XC,YC-(int)y,color);
   if(y<=ymax && old_y2-YC>=-ymin) 
    draw_line1(old_x,old_y2,(int)x+XC,YC+(int)y,color);     
  }
  else {
   if(y<=ymin && YC-old_y1>=-ymax)   	
    drawpixel((int)x+XC,YC-(int)y,color);
   if(y<=ymax && old_y2-YC>=-ymin)     
    drawpixel((int)x+XC,YC+(int)y,color);  
  }
  old_x=(int)x+XC;old_y1=YC-(int)y;old_y2=YC+(int)y;
  x+=0.5;
  if(x>0) break;
 }
 return 0;
}    
/*******/    
arch4(XC,YC,ymin,ymax,R,color) 
int XC,YC,ymin,ymax;double R;int color;
{ double x,y;
  int old_x=-1,old_y1,old_y2=0;
  
 x=R;
 while(1) {
  y=sqrt(R*R-x*x);
  
  if(old_x>=0){
   if(y<=ymin && YC-old_y1>=-ymax) 
    draw_line1(old_x,old_y1,XC+(int)x,YC-(int)y,color);
   if(y<=ymax && old_y2-YC>=-ymin) 
    draw_line1(old_x,old_y2,XC+(int)x,YC+(int)y,color);     
  }
  else {
   if(y<=ymin && YC-old_y1>=-ymax)   	
    drawpixel((int)x+XC,YC-(int)y,color);
   if(y<=ymax && old_y2-YC>=-ymin)     
    drawpixel((int)x+XC,YC+(int)y,color);  
  }
  old_x=(int)x+XC;old_y1=YC-(int)y;old_y2=YC+(int)y;
  x-=0.5;
  if(x<0) break;
 }
 return 0;
}    

/*******************************/
int check_bank(y) int y;
{
 ;	
}
DefaultCursor()
{
 static char cursor[]={
 	0xff,0x3f,0xff,0x1f,
 	0xff,0x0f,0xff,0x07, 		
 	0xff,0x03,0xff,0x01,
 	0xff,0x00,0x7f,0x00,
 	0x3f,0x00,0x1f,0x00,
 	0xff,0x01,0xff,0x10,
 	0xff,0x30,0x7f,0xf8,
 	0x7f,0xf8,0x7f,0xfc,
 	0x00,0x00,0x00,0x40,
 	0x00,0x60,0x00,0x70,
 	0x00,0x78,0x00,0x7c,
 	0x00,0x7e,0x00,0x7f,
 	0x80,0x7f,0x00,0x7c,
 	0x00,0x6c,0x00,0x46, 
 	0x00,0x06,0x00,0x03,
 	0x00,0x03,0x00,0x00};
 	setmouseshape(cursor,0,0);
 return 0;	 		 	 	
}

Arrow4Cursor()
{
 static char cursor[]={
  	
  	/* mask */
  	0x7f,0xfe,
  	0x3f,0xfc,
 	0x1f,0xf8,
 	0x0f,0xf0, 		
 	0x37,0xec,
 	0x33,0xcc,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00,
 	0x33,0xcc,
 	0x37,0xec,
 	0x0f,0xf0,
 	0x1f,0xf8,
 	0x3f,0xfc,
 	0x7f,0xfe,

	/* pointer */
 	0x00,0x00,
 	0x80,0x01,
 	0xc0,0x03,
 	0xa0,0x05,
 	0x80,0x01,
 	0x88,0x11,
 	0x84,0x21,
 	0xfe,0x7f,
 	0xfe,0x7f,
 	0x84,0x21,
 	0x88,0x11,
 	0x80,0x01, 
 	0xa0,0x05,
 	0xc0,0x03,
 	0x80,0x01,
 	0x00,0x00
 	};
 	setmouseshape(cursor,0,0);
 return 0;	 		 	 	
}

ArrowHorCursor()
{
 static char cursor[]={
  	
  	/* mask */
  	0x7f,0xfe,
  	0x3f,0xfc,
 	0x1f,0xf8,
 	0x0f,0xf0, 		
 	0x07,0xe0,
 	0x3f,0xfc,
 	0x3f,0xfc,
 	0x3f,0xfc,
 	0x3f,0xfc,
 	0x3f,0xfc,
 	0x3f,0xfc,
 	0x07,0xe0,
 	0x0f,0xf0,
 	0x1f,0xf8,
 	0x3f,0xfc,
 	0x7f,0xfe,

	/* pointer */
 	0x00,0x00,
 	0x80,0x01,
 	0xc0,0x03,
 	0xe0,0x07,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01,
 	0x80,0x01, 
 	0xe0,0x07,
 	0xc0,0x03,
 	0x80,0x01,
 	0x00,0x00
 	};
 	setmouseshape(cursor,0,0);
 return 0;	 		 	 	
}

ArrowVerCursor()
{
 static char cursor[]={
  	
  	/* mask */
  	0xff,0xff,
  	0xff,0xff,
 	0xff,0xff,
 	0xef,0xf7, 		
 	0xe7,0xe7,
 	0xe3,0xc7,
 	0x01,0x80,
 	0x00,0x00,
 	0x00,0x00,
 	0x01,0x80,
 	0xe3,0xc7,
 	0xe7,0xe7,
 	0xef,0xf7,
 	0xff,0xff,
 	0xff,0xff,
 	0xff,0xff,

	/* pointer */
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00, 
 	0x00,0x00,
 	0x08,0x10,
 	0x0c,0x30,
 	0xfe,0x7f,
 	0xfe,0x7f,
 	0x0c,0x30,
 	0x08,0x10,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00,
 	0x00,0x00
 	};
 	setmouseshape(cursor,0,0);
 return 0;	 		 	 	
}

/***************************
* for using drawpixellim
* change the limits.
****************************/
int save_winlimits()
{
 xxmins=xxmin;yymins=yymin;xxmins=xxmax;yymaxs=yymax;	
 return(0);
}
/*******************/
int restore_winlimits()
{
 xxmin=xxmins;yymin=yymins;xxmin=xxmaxs;yymax=yymaxs;	
 return(0);
}
/*******************/
int max_winlimits()
{
 xxmin=0;yymin=0;xxmax=X__max;yymax=Y__max;	
 return(0);	
}
/********************************************************
* Open/close files for making EPS-file. 
********************************************************/
FILE *open_eps(name1,name2) char *name1,*name2; 
{
 FILE *stream1;char line[100];
 
 stream1=fopen(name2,"rb");
 if(!stream1) {
  strcpy(line,incpath);
  strcat(line,"psexampl.dat");
  stream1=fopen(line,"rb");
  if(!stream1) return 0;
 } 
 outstream=fopen(name1,"wb+");
 if(!outstream) {fclose(stream1); return 0;}  

 line[0]=0;
 while(1) {
  fgets(line,100,stream1);fputs(line,outstream);
  if(!strncmp(line,"%%End_Setup",strlen("%%End_Setup"))) break;
 }
 fgets(line,100,stream1);fputs(line,outstream);

 return stream1;
}

int close_eps(stream1) FILE *stream1;
{char line[100];
 while(fgets(line,100,stream1)) fputs(line,outstream);
 fclose(outstream);fclose(stream1);
 return 0;	
}


#ifdef DOS  /* the routines for DOS */
/***********************************
* start graphics mode
************************************/
void initgraph(mode,background_color) int mode,background_color;
{
 union REGS r;

 graphinit((int)mode);
 if(!startmouse()) {printf("no mouse driver\n");endgraph();exit(1);}  
 if(mode==16) {	
  X__max=639;Y__max=349;
  lineLen=80;ybanksize=350;  
 }
 else if (mode==18) {
  X__max=639;Y__max=479;
  lineLen=80;ybanksize=480;  
 }
 else if (mode==0x5d) { 
  /* cirrus logic super VGA 542/3/4x 1024x770x16 */
  lineLen=128;ybanksize=512;
  X__max=1023;Y__max=769;
 } 
 X1_min=0;X1_max=X__max;
 Y1_min=0;Y1_max=Y__max;
 bgcol=background_color;fgcol=15;
 xkoord=ykoord=0;
 DefaultCursor(); 
}

/******************************/
void initvesagraph(mode,background_color) int mode,background_color;
{
 union REGS r;

 /* find old graphics mode */
 r.x.ax=0x4f03;
 int86(0x10,&r,&r);
 old_mode=r.x.bx;
 
 X__max=639;Y__max=479;
 lineLen=80;ybanksize=480;  
  
 /* set new graphics mode */
 r.x.ax=0x4f02;
 r.x.bx=mode;
 int86(0x10,&r,&r);
 if(!startmouse()) {printf("no mouse driver\n");endgraph();exit(1);} 
    
 if (mode==0x102) { /* 800x600 16 colors */
  X__max=799;Y__max=599;
  lineLen=100;ybanksize=600;    
 } 
 else if (mode==0x104) { /* 1024x768 16 colors */
  X__max=1023;Y__max=767;ybanksize=512;  
  lineLen=128;
 }  
 else if (mode==0x106) { /* 1280x1024 16 colors */
  X__max=1279;Y__max=1023;ybanksize=512;/* ??? */  
  lineLen=160;  
 }   
 else {
  printf("unsupported mode\n");sound(E2);delay(100);nosound();
 }
 X1_min=0;X1_max=X__max;
 Y1_min=0;Y1_max=Y__max;
 bgcol=background_color;fgcol=15;
 xkoord=ykoord=0;
 DefaultCursor();

}
/***********************************/
void endvesagraph()
{
 union REGS r;

 stopmouse();  
 /* set old graphics mode */
 r.x.ax=0x4f02;
 r.x.bx=old_mode;
 int86(0x10,&r,&r);
}
/***********************************
* change colors in palette
************************************/
void setVGApalette(palette,color) int palette,color;
{
 union REGS reg;

 reg.h.ah=0x10;
 reg.h.al=0;
 reg.h.bh=color;
 reg.h.bl=palette;	
 int86(0x10,&reg,&reg);
}
void show_byte(unsigned long int address,int color_pl, unsigned char ch)
{
 char far * mem_addr;

 mem_addr=(char far *)0xa0000000L+address;
 outp(0x3c4,2);outp(0x3c5,(1<<color_pl)); 
 *mem_addr=ch;
}
/*****************************************
* draws a pixel and returns original color 
******************************************/
int change_pixel(int x, int y, int color) {
 int index,old_color=0;
 unsigned char mask, exist_color;
 char far *mem_address;

#ifdef SuperVGA
 check_bank(y);
 if(y>=512) y-=512;
#endif
 mem_address=(char far *)(0xa0000000L+( (long)y*(long)lineLen+((long)x/8L))); 
 mask=0;mask=(0x80>>(x%8))&0xff;
 for(index=0;index<4;index++) {
  outp(0x3ce,4);outp(0x3cf,index);
  outp(0x3ce,5);outp(0x3cf,0);
  exist_color= *mem_address & mask;
  if (exist_color !=0) old_color |= (0x01<<index);
 }
 outp(0x3ce,8);outp(0x3cf,mask);
 outp(0x3c4,2);outp(0x3c5,0x0f);
 *mem_address=0;
 outp(0x3c4,2);outp(0x3c5,color);
 *mem_address=0xff;
 outp(0x3c4,2);outp(0x3c5,0x0f);
 outp(0x3ce,3);outp(0x3cf,0);
 outp(0x3ce,8);outp(0x3cf,0xff);
 return(old_color);
}

/*****************************************
* reads a byte from the screen
******************************************/
unsigned char read_byte(int address,int color_plane) {
 char far * mem_address;
 unsigned char pixel_data;
 mem_address=(char far *)0xa0000000L+address;
 outp(0x3ce,4);outp(0x3cf,color_plane); 
 outp(0x3ce,5);outp(0x3cf,0); 
 pixel_data= *mem_address;
 return(pixel_data);
}

/******************************/
int is_it_S3() {
 int old_value;
 unsigned char new_value_1,new_value_2;

 unlockS3();
 outp(0x3d4,0x47);
 outp(0x3d5,0xff);
 new_value_1=inp(0x3d5);
 outp(0x3d5,0x00);
 new_value_2=inp(0x3d5);
 if((new_value_2==0x00) && (new_value_1==0xff))
  return 1;
 return 0;
}

/********************************/
int which_S3()
{unsigned char value;
 outp(0x3d4,0x30);
 value=inp(0x3d5)&0xf0;
 switch(value) {
  case 0x80: case 0x81: case 0x91:
   return 1;
  case 0x90:case 0x94: case 0x95:
   return 2;
  case 0xa0:case 0xa2: case 0xa3:
   return 3;
  case 0xa5:case 0xa8:
   return 4;
  case 0xC0:
   return 5;
 }
 return 0;
}

/****************************/
int what_vesa_is_supported()
{
 VESABLOCK vb;
 union REGS r;
 struct SREGS sr;
  
 r.x.ax=0x4f00;
 r.x.di=FP_OFF((char *)&vb);
 sr.es=FP_SEG((char *)&vb);
 int86x(0x10,&r,&r,&sr);
 if(r.x.ax!=0x004f || memcmp(vb.vesasig,"VESA",4)) 
 {printf("no VESA present\n");return 0;}
 printf("VESA version %d.%d present\n",vb.version>>8,vb.version&0xff);
 printf("%s\n",vb.oemstring);
 printf("%lu kilobytes of memory on board\n",(long)vb.memory*64L);
 printf("Graphic modes:\n");
 for(;;*vb.videomode++) {
  if(*vb.videomode==0xffff) break;
  printf("Mode %04.4X \n",*vb.videomode);	
 }
 return 1;
}
#endif /* end of DOS_VERSION */


/*************************************
* take of ending .xxx from a file name
**************************************/
void strip_off_ending(file_name)
char *file_name;
{register int j; char *p;

 p=file_name;
 for(j=strlen(file_name)-1;j>=0;j--){
  if(p[j]=='.') {p[j]=0;break;}
 }
}



/*****************************************
* textXYv
******************************************/
void textXYv(x,y,str,len,where,save,operation,max,color) 
int x,y;
char *str;
int len,where;
VUNIT *save;
int operation,max;
int color;
{ 
 int j,k,i,xoff,place,m=0;
 unsigned char *buf;
 unsigned char bit;   

 if(!chlist2) {illegal_pointer(35);return;} 
 place=x;

 for(i=0;i<len;i++)
 { 
  if(str[i] && str[i+1]) {
   if(!chdist2) xoff= csb;
   else xoff=get_xoff(chdist2,str,i);
   if(!xoff) xoff=csb;
  }
  buf=chlist2+(int)str[i]*ysizeb;
  if(operation&1) {
   for(j=0;j<ysizeb;j++) {
    for(k=0,bit=0x80;bit;k++,bit=bit>>1) {  	
     if((*buf)&bit) {     
      if(where==2) drawpixellim2(place+k,j+y,(int)save[m++]);
      else if(where==1) put_to_fg(place+k,j+y,(int)save[m++]);
      else  drawpixel2(place+k,j+y,(int)save[m++]);
      if(m>=max) return;      
     }
    }
    buf++;
   }   
  }  
  else {

   for(j=0;j<ysizeb;j++) {
    for(k=0,bit=0x80;bit;k++,bit=bit>>1) {  	
     if((*buf)&bit) {     
      if(where==2) plot_pointlim2(place+k,j+y,color,&save[m]);
      else if(where==1) change_in_fg(place+k,j+y,color,&save[m]);
      else  save[m]=plot_point2(place+k,j+y,color);
      m++;
      if(m>=max) return;
     }
    }
    buf++;
   }
  }    
  place +=xoff;  
 }

#ifndef DOS_SYSTEM
  XPutImage(display,win,gc,screenbuf,x,y,x,y,place,ysizeb);
#endif

}

int color_by_pixel(pixel,pale,color1)
     unsigned long pixel; int pale,*color1;
{
  unsigned long shade;
  return (color_by_pixel1(pixel,pale,color1,&shade));
}

int color_by_pixel1(pixel,pale,color1,shade)
     unsigned long pixel; int pale,*color1;unsigned long *shade;
{
int i;
 *shade=0;

 *color1= -1;
 if(!pale) {
  for(i=0;i<21+256;i++) {
   if(xcolor[i].pixel==pixel) {*color1=i;break;}
  }
 }
 else if(pale==1) {
  for(i=0;i<21;i++) {
   if(xcolor[i].pixel==pixel) {*color1=i;break;}
  }
 }
 else if(pale==2) {
  for(i=0;i<256;i++) {
   if(xcolor[i+21].pixel==pixel) {*color1=i;break;}
  }
 }
 else if(pale==3) {
  /* if clarity=2, one can still recognize colors */
  for(i=0;i<256;i++) {
   if(xcolor[i+21].pixel|0x8888==pixel) {*color1=i;*shade=0x8888;break;}
  }
 } 

 return 0;
}


z_from_image(name) char *name;
{
 int i,k,j,m,col,lev1,lev2,wWidth,wHeight;char *p;
 XImage *screenbufsav;
 unsigned long pix;
 PathData *pathdata1;
 double angle;

 screenbufsav=screenbuf;
 make_screenbuf1();
 screenbuf=screenbuf1;

 p=strchr(name,(int)'.');
 if(p && !strcmp(p,".gif")) {
  readGIF(name,&wWidth,&wHeight,3);
  if(wWidth>680) wWidth=680; /* do not show whole figure */
 }
 else if(p && !strcmp(p,".pcx")) {
  readpcx(name,&wWidth,&wHeight);
  if(wWidth>680) wWidth=680; /* do not show whole figure */
 }
 else printf("format not recognized\n");

 /* we have the altitude figure in screenbuf */
 for(i=0;i<40;i++) {
  pathdata1=pathdata[i];
  if(pathdata1) {
    /* get initial height information */
   for(k=0;k<pathsize[i];k++) {
    if(pathdata1[k].x<wWidth && pathdata1[k].y<wHeight) {
     pix=getpixel2c(pathdata1[k].x,pathdata1[k].y);
     for(col=0;col<15;col++) { /* this is slow, but how? */
      if(xcolor[col].pixel==pix)
      break;
     }
     pathdata1[k].z=col*5; /* this is in meters */
    }
   }
   /* process height information, now it is in steps */
   for(k=0;k<pathsize[i];k++) {
    if(pathdata1[k].x<wWidth && pathdata1[k].y<wHeight) {
     if(!pathdata1[k].z) { /* z==0 on altitude curve */ 
      lev2=pathdata1[k+1].z;
      lev1=pathdata1[k-1].z;
      for(m=1;m<k;m++) if(!pathdata1[k-m].z) break;
      /* now k-m is the previous altitude curve */
      m=m/2; 
      if(m>2) {
       angle=(double)(lev2-lev1)/(double)(m-2);
       for(j=0;j<m-1;j++) 
        pathdata1[j+k-m+1].z=lev1+(int)(angle*(double)j);
      }
      else if(m==1) pathdata1[k-1].z=(lev1+lev2)/2;
      else if(m==2) {
       pathdata1[k-1].z=(2*(lev1+lev2))/3;
       pathdata1[k-2].z=(lev1+lev2)/3;
      }
     }
    }
   }
   /* remove altitude curves */

   for(k=1;k<pathsize[i];k++) {
    if(pathdata1[k].x<wWidth && pathdata1[k].y<wHeight) {
     if(!pathdata1[k].z) { /* z==0 on altitude curve */
      if(pathdata1[k-1].z) pathdata1[k].z=pathdata1[k-1].z;
      else {
	for(m=1;m<pathsize[i]-k;m++) {
         if(pathdata1[k+m].z) pathdata1[k].z=pathdata1[k+m].z;
         break;
	}
      } 
     }
    }
   }

  }
 }

 screenbuf=screenbufsav;
 free_screenbuf1();
 return 0; 
}

int free_screenbuf1()
{
 if(screenbuf1) {
  if(screenbuf1->data) free(screenbuf1->data);
  free(screenbuf1);
 }
 return 0;
}


/*************************************************
 * X11 routines
 *************************************************/

#ifndef DOS_SYSTEM

unsigned char read_byte(int address,int color_plane) {
 return 1;
}
int is_it_S3() {
 return 0;
}
int which_S3()
{
 return 0;
}
int what_vesa_is_supported()
{
 return 1;
}
void initvesagraph(mode,background_color) int mode,background_color;
{
  ;
}
void endvesagraph()
{
  ;
}
void setVGApalette(palette,color) int palette,color;
{
  ;
}
void show_byte(unsigned long int address,int color_pl, unsigned char ch)
{
  ;
}

#endif


int make_screenbuf1()
{
 char *data;
 Visual visual;
 XVisualInfo vinfo;

 data=(char *)malloc(800*600*16);
 memset(data,0xf,800*600*16);

#ifndef DOS_SYSTEM
 vinfo.visual=&visual;
 XMatchVisualInfo(display, screen, 16,PseudoColor, &vinfo);
 screenbuf1=XCreateImage(display,&visual,16,XYPixmap,0,data,800,600,8,100);
#else
 printf("not implemented yet\n");
#endif
 return 1;
}


#ifndef DOS_VERSION
/***********************************************************
 * this version does not plot points directly for each point
 * but calls XPutImage after the whole line is drawn
 * handling of colors is different, it is not color
 * but pixel we store, but is a pointer to integers
 ***********************************************************/
void draw_vector(where,buf,x1,y1,x2,y2,oldx2,oldy2,operation,color,max)
int where;
VUNIT *buf;int x1,y1,x2,y2,oldx2,oldy2,operation,color,max;
{
 int i;int xsabs,ysabs,step,x,y;   	

 if(operation==2 && where==4) {
  /* write in postscript to a file */ 
  draw_line(x1,y1,x2,y2,0,1);
  where=2; /* go on drawing on the screen */
 }
 if(operation & 1) 
 {   	
  /* draw from buf line from (x1,y1) to (oldx2,oldy2) */
  xsabs= (oldx2-x1>=0? oldx2-x1 : -oldx2+x1);   
  ysabs= (oldy2-y1>=0? oldy2-y1 : -oldy2+y1);
  i=0;
  if(xsabs>=ysabs) {
   step= (oldx2>x1? 1 : -1);
   if(ysabs) {
    for(x=x1;x!=oldx2;x+=step) {
     y=y1+(long)(oldy2-y1)*(long)(x-x1)/(oldx2-x1);
     if(!where) drawpixel2(x,y,(int)buf[i++]);
     else if(where==1) put_to_fg(x,y,buf[i++]);
     else drawpixellim2(x,y,(int)buf[i++]);     
     if(i>=max) return;
    }
   }
   else {
    for(x=x1;x!=oldx2;x+=step) {
     if(!where) drawpixel2(x,y1,(int)buf[i++]);
     else if(where==1) put_to_fg(x,y1,buf[i++]);
     else drawpixellim2(x,y1,(int)buf[i++]);          
     if(i>=max) return;     
    }
   }   
  }
  else {
   step= (oldy2>y1? 1 : -1);
   for(y=y1;y!=oldy2;y+=step) {
    x=x1+(long)(oldx2-x1)*(long)(y-y1)/(oldy2-y1);
    if(!where) drawpixel2(x,y,(int)buf[i++]);
    else if(where==1) put_to_fg(x,y,buf[i++]);
    else drawpixellim2(x,y,(int)buf[i++]);         
    if(i>=max) return;    
   }  	
  }
  
  step= (oldx2>x1? 1 : -1);
  if(step>0) {
   step= (oldy2>y1? 1 : -1);
   if(step>0) XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xsabs+1,ysabs+1); 
   else XPutImage(display,win,gc,screenbuf,x1,oldy2,x1,oldy2,xsabs+1,ysabs+1); 
  }
  else {
   step= (oldy2>y1? 1 : -1);
   if(step>0) 
    XPutImage(display,win,gc,screenbuf,oldx2,y1,oldx2,y1,xsabs+1,ysabs+1); 
   else 
    XPutImage(display,win,gc,screenbuf,oldx2,oldy2,oldx2,oldy2,xsabs+1,ysabs+1); 
  }
 }
 if(operation & 2) 
 {   	  
  /* read to buf and fill with color line from (x1,y1) to (x2,y2) */
  xsabs= (x2-x1>=0? x2-x1 : -x2+x1);   
  ysabs= (y2-y1>=0? y2-y1 : -y2+y1);
  i=0;

  if(xsabs>=ysabs) {
   step= (x2>x1? 1 : -1);     	
   if(ysabs) {
    for(x=x1;x!=x2;x+=step) {
     y=y1+(long)(y2-y1)*(long)(x-x1)/(x2-x1);
     if(!where) buf[i]=(VUNIT)plot_point2(x,y,color);
     else if(where==1) change_in_fg(x,y,(VUNIT)color,&buf[i]);
     else plot_pointlim2(x,y,color,&buf[i]);
     i++;
     if(i>=max) return;     
    }
   }
   else {
    for(x=x1;x!=x2;x+=step){
     if(!where) buf[i]=(VUNIT)plot_point2(x,y1,color);   	
     else if(where==1) change_in_fg(x,y1,(VUNIT)color,&buf[i]);
     else plot_pointlim2(x,y1,color,&buf[i]);     
     i++;
     if(i>=max) return;     
    }
   }
  }
  else {
   step= (y2>y1? 1 : -1);   
   for(y=y1;y!=y2;y+=step) {
    x=x1+(long)(x2-x1)*(long)(y-y1)/(y2-y1);
    if(!where) buf[i]=(VUNIT)plot_point2(x,y,color);
    else if(where==1) change_in_fg(x,y,(VUNIT)color,&buf[i]);
    else plot_pointlim2(x,y,color,&buf[i]);
    i++;
    if(i>=max) return;    
   }  	
  }   

  step= (x2>x1? 1 : -1);
  if(step>0) {
   step= (y2>y1? 1 : -1);   
   if(step>0) XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xsabs+1,ysabs+1); 
   else XPutImage(display,win,gc,screenbuf,x1,y2,x1,y2,xsabs+1,ysabs+1); 
  }
  else {
   step= (y2>y1? 1 : -1);   
   if(step>0) 
    XPutImage(display,win,gc,screenbuf,x2,y1,x2,y1,xsabs+1,ysabs+1); 
   else 
    XPutImage(display,win,gc,screenbuf,x2,y2,x2,y2,xsabs+1,ysabs+1); 
  }

 
 }
}

draw_text(win,gc,font_info,win_width,win_height)
     Window win;
     GC gc;
     XFontStruct *font_info;
     unsigned int win_width,win_height;
{
  int y=20;
  char *string1="Hi! I'am a window, who are you?";
  char *string2="To terminate program: Press any key";
  char *string3="or button while in this window";
  char *string4="Screen dimensions:";
  int len1,len2,len3,len4;
  int width1,width2,width3;
  char cd_height[50],cd_width[50],cd_depth[50];
  int font_height;
  int initial_y_offset,x_offset;
  len1=strlen(string1);
  len2=strlen(string2);
  len3=strlen(string3);
  width1=XTextWidth(font_info,string1,len1);
  width2=XTextWidth(font_info,string2,len2);
  width3=XTextWidth(font_info,string3,len3);
  XDrawString(display,win,gc,(win_width-width1)/2,y,string1,len1);
  XDrawString(display,win,gc,(win_width-width2)/2,(int)(win_height-35),
   string2,len2);
  XDrawString(display,win,gc,(win_width-width3)/2,(int)(win_height-15),
   string3,len3);
  (void)sprintf(cd_height," Height - %d pixels",DisplayHeight(display,screen));
  (void)sprintf(cd_width," Width - %d pixels",DisplayWidth(display,screen));
  (void)sprintf(cd_depth," Depth - %d plane(s)",DefaultDepth(display,screen));
  len4=strlen(string4);
  len1=strlen(cd_height);
  len2=strlen(cd_width);
  len3=strlen(cd_depth);
  font_height=font_info->max_bounds.ascent+font_info->max_bounds.descent;
  initial_y_offset=win_height/2-font_height-font_info->max_bounds.descent;
  x_offset=(int)win_width/4;
  XDrawString(display,win,gc,x_offset,(int)initial_y_offset,string4,len4);

  XDrawString(display,win,gc,x_offset,(int)initial_y_offset+
    font_height,cd_height,len1);
  XDrawString(display,win,gc,x_offset,(int)initial_y_offset+
    2*font_height,cd_width,len2);
  XDrawString(display,win,gc,x_offset,(int)initial_y_offset+
    3*font_height,cd_depth,len3);

}

draw_graphics(win,gc,window_width,window_height)
     Window win;
     GC gc;
     unsigned int window_width, window_height;
{
  int x,y;
  unsigned int width, height;
  height=window_height/2;
  width=3*window_width/4;
  x=window_width/2-width/2;
  y=window_height/2-height/2;
  XDrawRectangle(display,win,gc,x,y,width,height);
}

TooSmall(win,gc,font_info)
     Window win;
     GC gc;
     XFontStruct *font_info;
{
  char *string1="Too Small";
  int y_offset,x_offset;
  y_offset=font_info->max_bounds.ascent+2;
  x_offset=2;
  XDrawString(display,win,gc,x_offset,y_offset,string1,strlen(string1));
}

load_font(font_info) XFontStruct **font_info;
{
  char *fontname="9x15";
  if((*font_info=XLoadQueryFont(display,fontname))==NULL) {
    printf("cannot open font\n");exit(-1);
  }
}

get_GC(win,gc,font_info)
     Window win;
     GC *gc;
     XFontStruct *font_info;
{
  unsigned long valuemask=0;
  XGCValues values;
  unsigned int line_width=6;
  int line_style=LineOnOffDash;
  int cap_style=CapRound;
  int join_style=JoinRound;
  int dash_offset=0;
  static char dash_list[]={
    12,24};
  int list_length=2;
  *gc=XCreateGC(display,win,valuemask,&values);
  XSetFont(display,*gc,font_info->fid);
  XSetForeground(display,*gc,BlackPixel(display,screen));
  XSetLineAttributes(display,*gc,line_width,line_style,cap_style, join_style);
  XSetDashes(display,*gc,dash_offset,dash_list,list_length);
}

/***********************************
* start graphics mode
************************************/
void initgraph(argc,argv) int argc; char **argv;
{
  int x=0,y=0,i,plane;
  int wWidth,wHeight;
  int xres,yres;
  char ch;
  unsigned int border_width=4;
  unsigned int display_width, display_height;
  char window_name[20];
  char bunny_name[20];
  Pixmap bunny_pixmap;
  char *display_name = NULL;
  char *data;
  Visual *visual;
  XVisualInfo vinfo;
  XSetWindowAttributes  swa;
  int res1;

   
  strcpy(window_name,"GRAPH application");
  strcpy(bunny_name,"basicwin");

  xres=800;yres=600;
  xcolor=(XColor *)malloc((21+256)*sizeof(XColor));
  if(!xcolor) {
   printf("no memory for colormap\n"); exit(1);}

  gplanes=GPLANES;
  display=XOpenDisplay(display_name);
  if(display==NULL)
  {
    printf("X not started\n");exit(-1);
  }

  screen=DefaultScreen(display);

  visual=DefaultVisual(display,screen);  /* 2017 */

  display_width=DisplayWidth(display,screen);
  display_height=DisplayHeight(display,screen);

  /*
 printf("screen=%d display_width=%d display_height=%d\n",screen,display_width,display_height);
  */

  window_width=xres;window_height=yres;

  /* I moved creation of screenbuf here and win made with depth specified */
  data=(char *)malloc(xres*yres*16);
  memset(data,0xf,xres*yres*16);
  vinfo.visual=visual;

  /*  res1=XMatchVisualInfo(display, screen, 16, PseudoColor, &vinfo);*/
  /*  res1=XMatchVisualInfo(display, screen, 16, InputOutput, &vinfo); */
  /*
  if(!res1) {printf("no visual found, press a key\n");getchar();}
  */

  screenbuf=XCreateImage(display,visual,24,XYPixmap,0,data,xres,yres,8,100);

  colormap=DefaultColormap(display,screen);

  /*  
  win=XCreateSimpleWindow(display,RootWindow(display,screen),
      x,y,window_width,window_height,border_width, 
      BlackPixel(display,screen),
      WhitePixel(display,screen));
  
  */

  swa.background_pixel=WhitePixel(display,screen); 
  
  win=XCreateWindow(display,RootWindow(display,screen),
      x,y,window_width,window_height,border_width,
		    24,InputOutput,visual,CWBackPixel,&swa);

  bunny_pixmap=XCreateBitmapFromData(display,win,bunny_bits,
				    bunny_width, bunny_height);
  size_hints.flags=PPosition|PSize|PMinSize;
  size_hints.x=x;
  size_hints.y=y;
  size_hints.height=window_height;
  size_hints.width=window_width;
  size_hints.min_height=yres;
  size_hints.min_width=xres;

  XSetStandardProperties(display,win,window_name,bunny_name,
   bunny_pixmap,argv,argc,&size_hints);

  XSelectInput(display,win, ExposureMask|KeyPressMask|
     ButtonMotionMask|ButtonPressMask|ButtonReleaseMask|StructureNotifyMask);
  load_font(&font_info);

  get_GC(win,&gc,font_info);
    
 
  xcolor[0].red=(0<<8);xcolor[0].green=(0<<8);xcolor[0].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor[0])==0) 
    printf("problems with color %d\n",0);

  xcolor[1].red=(0<<8);xcolor[1].green=(0<<8);xcolor[1].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor[1])==0) 
    printf("problems with color %d\n",1);

  xcolor[2].red=(0<<8);xcolor[2].green=(255<<8);xcolor[2].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor[2])==0) 
    printf("problems with color %d\n",2);

  xcolor[3].red=(0<<8);xcolor[3].green=(255<<8);xcolor[3].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor[3])==0) 
    printf("problems with color %d\n",3);

  xcolor[4].red=(255<<8);xcolor[4].green=(0<<8);xcolor[4].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor[4])==0) 
    printf("problems with color %d\n",4);

  xcolor[5].red=(188<<8);xcolor[5].green=(143<<8);xcolor[5].blue=(143<<8);
  if(XAllocColor(display,colormap,&xcolor[5])==0) 
    printf("problems with color %d\n",5);

  xcolor[6].red=(255<<8);xcolor[6].green=(0<<8);xcolor[6].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor[6])==0) 
    printf("problems with color %d\n",6);

  xcolor[7].red=(192<<8);xcolor[7].green=(192<<8);xcolor[7].blue=(192<<8);
  if(XAllocColor(display,colormap,&xcolor[7])==0) 
    printf("problems with color %d\n",7);

  xcolor[8].red=(168<<8);xcolor[8].green=(168<<8);xcolor[8].blue=(168<<8);
  if(XAllocColor(display,colormap,&xcolor[8])==0) 
    printf("problems with color %d\n",8);

  xcolor[9].red=(191<<8);xcolor[9].green=(216<<8);xcolor[9].blue=(216<<8);
  if(XAllocColor(display,colormap,&xcolor[9])==0) 
    printf("problems with color %d\n",9);

  xcolor[10].red=(143<<8);xcolor[10].green=(188<<8);xcolor[10].blue=(143<<8);
  if(XAllocColor(display,colormap,&xcolor[10])==0) 
    printf("problems with color %d\n",10);

  xcolor[11].red=(204<<8);xcolor[11].green=(50<<8);xcolor[11].blue=(50<<8);
  if(XAllocColor(display,colormap,&xcolor[11])==0) 
    printf("problems with color %d\n",11);

  xcolor[12].red=(79<<8);xcolor[12].green=(47<<8);xcolor[12].blue=(79<<8);
  if(XAllocColor(display,colormap,&xcolor[12])==0) 
    printf("problems with color %d\n",12);

  xcolor[13].red=(216<<8);xcolor[13].green=(216<<8);xcolor[13].blue=(191<<8);
  if(XAllocColor(display,colormap,&xcolor[13])==0) 
    printf("problems with color %d\n",13);

  xcolor[14].red=(255<<8);xcolor[14].green=(255<<8);xcolor[14].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor[14])==0) 
    printf("problems with color %d\n",14);

  xcolor[15].red=(252<<8);xcolor[15].green=(252<<8);xcolor[15].blue=(252<<8);
  if(XAllocColor(display,colormap,&xcolor[15])==0) 
    printf("problems with color %d\n",15);

  /* colors for dialog frames */
  /* light grey */
  xcolor[16].red=(180<<8);xcolor[16].green=(250<<8);xcolor[16].blue=(200<<8);
  if(XAllocColor(display,colormap,&xcolor[16])==0) 
    printf("problems with color %d\n",16);

  /* a different blue */
  xcolor[17].red=(43<<8);xcolor[17].green=(130<<8);xcolor[17].blue=(150<<8);
  if(XAllocColor(display,colormap,&xcolor[17])==0) 
    printf("problems with color %d\n",17);

  xcolor[18].red=(10<<8);xcolor[18].green=(200<<8);xcolor[18].blue=(50<<8);
  if(XAllocColor(display,colormap,&xcolor[18])==0) 
    printf("problems with color %d\n",18);

  xcolor[19].red=(20<<8);xcolor[19].green=(85<<8);xcolor[19].blue=(155<<8);
  if(XAllocColor(display,colormap,&xcolor[19])==0) 
    printf("problems with color %d\n",19);

  /* a different red */
  xcolor[20].red=(210<<8);xcolor[20].green=(20<<8);xcolor[20].blue=(15<<8);
  if(XAllocColor(display,colormap,&xcolor[20])==0) 
    printf("problems with color %d\n",20);

  X__max=xres-1;Y__max=yres-1;lineLen=80;
  X1_min=0;X1_max=X__max;
  Y1_min=0;Y1_max=Y__max;
  bgcol=0;fgcol=15;fg1col=fgcol;
  xkoord=ykoord=0;
  X1mouse=X1_min;Y1mouse=Y1_min; X2mouse=X1_max;Y2mouse=Y1_max-5;

  XMapWindow(display,win);

  while(1) {
   XNextEvent(display,&report);
   if(report.type==Expose) {
    while(XCheckTypedEvent(display,Expose,&report));
    break;
   }
  }

  /*
  
  XFlush(display);
  */
}



/****************************************/
int point_to_fn2(x,y,col,clength,isize,buf)
     int x,y,col,clength,isize;char *buf;
{
 unsigned int pixel;
 char *di;
 unsigned char ch,dl,ah,bl,bh;
 int dh,mask1,mask2;

 di=buf;
 di += y*isize;
 di += (x>>3); 

 dl= 7-x&0x7;
 mask1=1<<dl;
 mask2=mask1;
 mask2 ^= 0xff;

 pixel=xcolor[col].pixel;

 dh=(1<<15);
 while(dh) {
  ah=*di;
  if(pixel&dh) ah |= mask1;
  else         ah &= mask2;
  *di=ah;
  di += clength;
  dh=(dh>>1);
 }		
}


/*****************************************
* draws a pixel and returns original color 
******************************************/
int change_pixel(int x, int y, int color) {
 int old_color;
 unsigned long pix,pixel;

 pix=getpixel2c(x,y);
 for(old_color=0;old_color<21;old_color++) { /* this is slow, but how? */
  if(xcolor[old_color].pixel==pix)
   break;
 }
 pixel=xcolor[color].pixel;
 drawpixel2c(x,y,pixel);
 XPutImage(display,win,gc,screenbuf,x,y,x,y,1,1);
 return old_color;
}

int plot_point2(int x, int y, unsigned int pixel) {
 unsigned int oldpixel;

 oldpixel=getpixel2c(x,y);
 drawpixel2c(x,y,(unsigned int)pixel);
 return (int)oldpixel;
}


/*****************************************
* draws a pixel  
******************************************/
int drawpixel(int x, int y, int color) {
  unsigned long pixel;
 pixel=xcolor[color].pixel;
 drawpixel2c(x,y,pixel);
 XPutImage(display,win,gc,screenbuf,x,y,x,y,1,1);
 return 1;
}

int drawpixel2b(int x, int y, unsigned long pixel) 
{
 drawpixel2c(x,y,pixel);

 XPutImage(display,win,gc,screenbuf,x,y,x,y,1,1);
 return 1;
}

int drawpixel2c(int x, int y, unsigned long pixel) 
{
 int plane,m,k;
 unsigned char ch,ch3,ch4,ch2;

 ch=1;      
 ch=(ch<<(x&7));
 ch2=0xff-ch;
 k=x/8+(y%8)*100+800*(y/8);
 if(GPLANES==24) m=0x800000;
 else if(GPLANES==16) m=0x8000;

 for(plane=0;plane<GPLANES;plane++){
  ch3=screenbuf->data[k+800*75*plane];
  if(pixel&m) ch4=(ch3&ch2)|ch; 
  else ch4=ch3&ch2;
  screenbuf->data[k+800*75*plane]=ch4;
  m=(m>>1);
 }
 return 1;
}

unsigned long getpixel2c(int x, int y) 
{
 int plane,m,k;unsigned char ch,ch3;
 unsigned long pixel;

 ch=1;      
 ch=(ch<<(x&7));

 pixel=0;
 k=x/8+(y%8)*100+800*(y/8);
 if(GPLANES==24) m=0x800000;
 else if (GPLANES==16) m=0x8000;

 for(plane=0;plane<GPLANES;plane++){
  ch3=screenbuf->data[k+800*75*plane];
  if(ch&ch3) pixel|=m;
  m=(m>>1);
 }
 return pixel;
}

/* getpixel2d is as getpixel2c, but reads from screenbuf1 */
unsigned long getpixel2d(int x, int y) 
{
 int plane,m,k;unsigned char ch,ch3;
 unsigned long pixel;

 ch=1;      
 ch=(ch<<(x&7));

 pixel=0;

 if(GPLANES==24) m=0x800000;
 else if (GPLANES==16) m=0x8000;

 k=x/8+(y%8)*100+800*(y/8);
 for(plane=0;plane<GPLANES;plane++){
  ch3=screenbuf1->data[k+800*75*plane];
  if(ch&ch3)     pixel|=m;
  m=(m>>1);
 }
 return pixel;
}

int drawpixel2(int x, int y, int pixel) {

 drawpixel2c(x,y,(unsigned long)pixel);
 return 1;
}

int drawcursor(x,y,col,a,b,cursor)
int x,y,col,a,b,cursor;
{int i,j;
  for(i=x;i<x+a*8;i++) for(j=y;j<y+b;j++) drawpixel(i,j,col);
  return 0;
}

int clear_win1(x1,y1,x2,y2,pixel) 
     int x1,y1,x2,y2;unsigned long pixel;
{
 register int j,ch0,i,lim3,k,plane;
 char ch,ch1,ch2,ch3;
 char *buf,*sav1;
 int lim1,lim2,first,last;

 if(x1>=x2 || y1>=y2) return 1;

 lim1=(x1>>3)<<3;
 lim2=(x2>>3)<<3;
 lim3=(x2>>3)-(x1>>3);
 first=x1-lim1;
 last=x2-lim2;

 /* if x1 and x2 are in the same byte and it is not full */
 /* this is a special case and requires special code     */
 if(!lim3 && (first|last)) {
  if(GPLANES==24) k=0x800000;
  else if (GPLANES==16) k=0x8000;
  ch=0xff>>(8-last);
  ch3=0xff<<first;
  ch&=ch3;
  ch2=0xff^ch;
  buf=screenbuf->data;
  buf+=100*y1;
  buf+=lim1>>3;
  sav1=buf;
  for(plane=0;plane<GPLANES;plane++) {
   for(j=y1;j<y2;j++) {
    ch1= *buf; 
    if(!(pixel&k)) ch1&=ch2;
    *buf=ch1;
    buf+=100;
   }
   k=(k>>1);
   buf=sav1;
   buf+=800*75;
   sav1=buf;
  }
 }

 /* if first byte is not full */
 if(first) {
  if(GPLANES==24) k=0x800000;
  else if (GPLANES==16) k=0x8000;
  ch2=0xff>>(8-first);
  buf=screenbuf->data;
  buf+=100*y1;
  buf+=lim1>>3;
  sav1=buf;
  for(plane=0;plane<GPLANES;plane++) {
   for(j=y1;j<y2;j++) {
    ch1= *buf; 
    if(!(pixel&k)) ch1&=ch2;
    *buf=ch1;
    buf+=100;
   }
   k=(k>>1);
   buf=sav1;
   buf+=800*75;
   sav1=buf;
  }
 }

 /* full bytes from lim1 to lim2                          */
 /* the loop is probably as fast as it can be in C-code   */
 /* the slowness comes from XPutImage and 24 color planes */
 if(GPLANES==24) k=0x800000;
 else if (GPLANES==16) k=0x8000;
 i=y2-y1;
 buf=screenbuf->data;
 buf+=100*y1;
 buf+=x1>>3; 
 sav1=buf;
 for(plane=0;plane<GPLANES;plane++) {
  if(!(pixel&k)) ch0=0;
  else ch0=0xff;
  for(j=i;j>0;j--) {
   memset(buf,ch0,lim3);
   buf+=100;
  }
  k=(k>>1);
  buf=sav1;
  buf+=800*75;
  sav1=buf;
 }

 /* if last byte is not full */
 if(last) {
  if(GPLANES==24) k=0x800000;
  else if (GPLANES==16) k=0x8000;
  ch2=0xff<<last;
  buf=screenbuf->data;
  buf+=100*y1;
  buf+=lim2>>3;
  sav1=buf;
  for(plane=0;plane<GPLANES;plane++) {
   for(j=y1;j<y2;j++) {
    ch1= *buf; 
    if(!(pixel&k)) ch1&=ch2;
    *buf=ch1;
    buf+=100;
   }
   k=(k>>1);
   buf=sav1;
   buf+=800*75;
   sav1=buf;
  }
 }
 XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,x2-x1,y2-y1);

 return 1;
}

int displaychar(p,y,ysize,col, bgcol,linelen,buf)
int p,y,ysize,col, bgcol,linelen;char *buf;
{
  int j,plane,k,shift;
  unsigned long pixel,pixel1;
  char ch,ch1,ch2,ch3,ch4,ch5;
  char chb,ch1b,ch2b,ch3b,ch4b;
  char *buf1,*sav1;
  /* display one character from string str */
  /* we cannot use XDrawString since it will not copy to image     */
  /* better to ignore bgcol */

  if(GPLANES==24) k=0x800000;
  else if (GPLANES==16) k=0x8000;

  pixel=xcolor[col].pixel;
  pixel1=xcolor[bgcol].pixel;
  shift=p%8;

  if(!shift) {
   buf1=screenbuf->data;
   buf1+=(p>>3)+100*y;
   sav1=buf1;
   for(plane=0;plane<GPLANES;plane++) {
    for(j=0;j<ysize;j++) {
     ch1=buf[j];
     ch=swap_byte(ch1);
     /* ch = byte from character buffer to show */
     ch2=0xff-ch;
     if(bgcol==nocolor) {
      /* ch3 = byte on background on this color plane */
      ch3=*buf1;
      /* if pixel&k is zero, remove from ch3 bits that are on in ch */
      if(pixel&k) ch4=ch3;
      else ch4=ch3&ch2;
     }
     else {
      if(pixel1&k) ch5=0xff; else ch5=0;
      if(pixel&k) ch4=ch5;
      else ch4=ch5&ch2;
     }
     /* write a new byte on this color plane */
     *buf1=ch4;
     buf1+=100;
    } 
    k=(k>>1);
    buf1=sav1;
    buf1+=800*75;
    sav1=buf1;
   }	   
  }
  else {
    /* byte is not on byte boundary */
   buf1=screenbuf->data;
   buf1+=(p>>3)+100*y;
   sav1=buf1;
   for(plane=0;plane<GPLANES;plane++) {
    for(j=0;j<ysize;j++) {
     ch1=buf[j]>>shift;
     ch=swap_byte(ch1);
     ch2=0xff-ch;
     ch3=*buf1;

     ch1b=buf[j]<<(7-shift);
     ch=swap_byte(ch1b);
     ch2b=0xff-chb;
     ch3b=*(buf1+1);
     /* if pixel&k is zero, remove from ch3 bits that are on in ch */
     if(pixel&k) {ch4=ch3;ch4b=ch3b;}
     else {ch4=ch3&ch2;ch4b=ch3b&ch2b;}
     /* write a new byte on this color plane */
     *buf1=ch4;
     *(buf1+1)=ch4b;
     buf1+=100;
    } 
    k=(k>>1);
    buf1=sav1;
    buf1+=800*75;
    sav1=buf1;
   }	   






  }
  XPutImage(display,win,gc,screenbuf,p,y,p,y,8,ysize);
  return 0;
}


int move_win(x1,y1,x2,y2,x3,y3,linelen) 
int x1,y1,x2,y2,x3,y3,linelen;
{
  ;
}
int clear_win(x1,y1,x2,y2,col,linelen) 
int x1,y1,x2,y2,col,linelen;
{
 int i,j;unsigned long pixel;

 pixel=xcolor[col].pixel;

 if(x1>=x2 || y1>=y2) return 1;
 for(i=x1;i<x2;i++) for(j=y1;j<y2;j++)
   drawpixel2c(i,j,pixel);

 XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,x2-x1,y2-y1);

 return 1;
}
int clearwin2c(x1,y1,x2,y2,col) 
int x1,y1,x2,y2,col;
{
 int i,j;unsigned long pixel;

 pixel=xcolor[col].pixel;

 if(x1>=x2 || y1>=y2) return 1;
 for(i=x1;i<x2;i++) for(j=y1;j<y2;j++)
   drawpixel2c(i,j,pixel);

 return 1;
}
void textnb(str,color,bckgcol) char *str;int color,bckgcol;
{
 int len;

 len=strlen(str)*cs;
 textXYb(xkoord,&ykoord,str,color,bckgcol);
 XPutImage(display,win,gc,screenbuf,xkoord,ykoord,xkoord,ykoord,len,cr);
}

/* very basic version */
void textXYc(x,y,str,color,bckgcol) 
int x;
int y;
char *str;
int color,bckgcol;
{ 
 register int i;
 int len, place;  
 unsigned char *buf;
 int k,j,xoff;
 unsigned char bit;
 unsigned long int pix; 
   
 len=strlen(str);
 place=x;

 pix=xcolor[color].pixel;

 for(i=0;i<len;i++)
 { 
  if(!chdist) xoff= cs;
  else xoff=get_xoff(chdist,str,i);

  buf=chlist+(int)str[i]*ysize;
  for(j=0;j<ysize;j++) {
   for(k=0,bit=0x80;bit;k++,bit=bit>>1) {  	
    if((*buf)&bit) drawpixel2c((int)(place+k),(int)(j+y),pix);
   }
   buf++;   
  }  
  place +=xoff;   
 }

}

int clearwin_c(x1,y1,x2,y2,col) 
int x1,y1,x2,y2,col;
{
 int i,j;unsigned long pixel;

 pixel=xcolor[col+21].pixel;

 if(x1>=x2 || y1>=y2) return 1;
 for(i=x1;i<x2;i++) for(j=y1;j<y2;j++)
   drawpixel2c(i,j,pixel);

 XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,x2-x1,y2-y1);

 return 1;
}

int save_buf_2(x1,y1,a,b,xz,yz,z,clength,isize,u,fgbuffer) 
int x1,y1,a,b,xz,yz,z,clength,isize,u;char *fgbuffer;
{
  save_buf2c(x1,y1,a,b,xz,yz,z,clength,isize,fgbuffer);
  return 0;
}  	
int draw_buf_2(x1,y1,a,b,xz,yz,z,clength,isize,u,fgbuffer) 
int x1,y1,a,b,xz,yz,z,clength,isize,u;char *fgbuffer;
{
  draw_buf2c(x1,y1,a,b,xz,yz,z,clength,isize,fgbuffer);
  /*  XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xz+1,yz+1);*/
  XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xz,yz);
  return 0;
}
int save_buf_1(x1,y1,xz,yz,clength,isize,u,fgbuffer)  
int x1,y1,xz,yz,clength,isize,u;char *fgbuffer;
{
  save_buf2c(x1,y1,0,0,xz,yz,0,clength,isize,fgbuffer);
  return 0;
}  	
int draw_buf_1(x1,y1,xz,yz,clength,isize,u,fgbuffer) 
int x1,y1,xz,yz,clength,isize,u;char *fgbuffer;
{
 int i,j;unsigned long pixel;int col2;

  draw_buf2c(x1,y1,0,0,xz,yz,0,clength,isize,fgbuffer);

  /* this loop is only to draw correct colors to fn2 that were */
  /* saved in DOS and have gplanes=4, do not loop here otherwise */
  if(gplanes==4) { /* get col from pixel */
   for(i=x1;i<x1+xz;i++) {
    for(j=y1;j<y1+yz;j++) {
      pixel=getpixel2c(i,j);
     if(GPLANES==24) col2=(pixel>>20)&0xf;
     else if(GPLANES==16) col2=(pixel>>12)&0xf;
     drawpixel2c(i,j,xcolor[col2].pixel);
    }
   }
  }
  if(gplanes==16 && GPLANES==24) { /* get col from pixel */
   for(i=x1;i<x1+xz;i++) {
    for(j=y1;j<y1+yz;j++) {
     pixel=getpixel2c(i,j);
     col2=(pixel>>8)&0xf;
     drawpixel2c(i,j,xcolor[col2].pixel);
    }
   }
  }

  XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xz+1,yz+1);
  return 0;
}

int draw_buf1b(x1,y1,xz,yz,clength,isize,u,fgbuffer) 
int x1,y1,xz,yz,clength,isize,u;char *fgbuffer;
{
 int i,j;unsigned long pixel;int col2;

  draw_buf2c(x1,y1,0,0,xz,yz,u,clength,isize,fgbuffer);


  if(gplanes==4) { /* get col from pixel for DOS fn2 */
   for(i=x1;i<x1+xz;i++) {
    for(j=y1;j<y1+yz;j++) {
     pixel=getpixel2c(i,j);
     if(GPLANES==24) col2=(pixel>>20)&0xf;
     else if(GPLANES==16) col2=(pixel>>12)&0xf;
     drawpixel2c(i,j,xcolor[col2].pixel);
    }
   }
  }
  if(gplanes==16 && GPLANES==24) { /* get col from pixel */
   for(i=x1;i<x1+xz;i++) {
    for(j=y1;j<y1+yz;j++) {
     pixel=getpixel2c(i,j);
     col2=(pixel>>8)&0xf;
     drawpixel2c(i,j,xcolor[col2].pixel);
    }
   }
  }

  XPutImage(display,win,gc,screenbuf,x1,y1,x1,y1,xz+1,yz+1);
  return 0;
}


int flush_mouse()
{
 while(XCheckTypedEvent(display,ButtonPress,&report));
 report.type=0;
}
int flush_key()
{
 while(XCheckTypedEvent(display,KeyPress,&report));
 report.type=0;
}
char getch()
{
 char ch;
 XComposeStatus compose;
 int bufsize=MAX_MAPPED_STRING_LENGTH;

 while(1) {
  XNextEvent(display,&report);
  if(report.type== KeyPress) {
   memset(keybuffer,0,3);
   charcount=XLookupString(&report,keybuffer, bufsize, &keysym, &compose);
   while(XCheckTypedEvent(display,KeyPress,&report));
   report.type=0;
   break;
  }
 }

 ch=keybuffer[0];
 return ch;
}
int altitude_algorithm1(name) char *name;
{
 
 altitude_algorithm(name,475,550,1); 
 altitude_algorithmb(name,473,548,1);
 
/*
 algorithm4b(475,549);
 algorithm4(475,549);
*/
 algorithm2(475,549);
 /*
 algorithm5(475,550);
*/

 algorithm3("map1.pcx");

}

loadimage(name,clarity,magn) char *name;int clarity;double magn;
{
  int wWidth,wHeight;char *p;int xshift,ret=0;

 p=strchr(name,(int)'.');
 if(p && !strcmp(p,".gif")) {
   /* wWidth and wHeight are input-output parameters */
   /* wHeight<600, wWidth<800, otherwise comes problems with X11 */
  wHeight=599;
  wWidth=773; /* set smaller maximum */
  ret=readGIF1(name,&wWidth,&wHeight,clarity,magn);
  if(ret)
   XPutImage(display,win,gc,screenbuf,0,0,0,0,wWidth,wHeight);
 }
 else if(p && !strcmp(p,".pcx")) {
  wHeight=599;
  wWidth=773; /* set smaller maximum */
  ret=readpcx(name,&wWidth,&wHeight);
  if(ret)
   XPutImage(display,win,gc,screenbuf,0,0,0,0,wWidth,wHeight);
 }
 else printf("format not recognized\n");

 return ret;
}
loadimage2(name) char *name;
{
 int wWidth,wHeight;

 /* altitude_from_pcx_map("map1.pcx",&wWidth,&wHeight,3,17,360);*/
 altitude_from_pcx_map("map1.pcx",&wWidth,&wHeight,1,0,0);

}

int kbhit()
{
  return 0;
}
int kbhit1()
{
 XCheckTypedEvent(display,KeyPress,&report);
 if(report.type==KeyPress) return 1;
 return 0;
}

int kbhit2()
{
 XCheckTypedEvent(display,KeyPress,&report);
 if(report.type==KeyPress) {
   /* while(XCheckTypedEvent(display,KeyPress,&report));*/
  return 1;
 }
 XCheckTypedEvent(display,Expose,&report);
 if(report.type==Expose) {
   /* while(XCheckTypedEvent(display,Expose,&report));*/
  XPutImage(display,win,gc,screenbuf,0,0,0,0,window_width,window_height);
  return 0;
 }
 return 0;
}


int endgraph()
{
 free(xcolor);
 XUnloadFont(display,font_info->fid);
 XFreeGC(display,gc);
 XCloseDisplay(display);
 if(screenbuf) {
  if(screenbuf->data) free(screenbuf->data);
  free(screenbuf);
 }
 return 0;
}

int delay(time) int time;
{
  int i,j;
  for(i=0;i<time;i++) for(j=0;j<10000L;j++) {i=i;j=j;}
  return 0;
}
int sound(x) int x;
{
  return 0;
}
int nosound() 
{
  return 0;
}

#endif

/********************************************************
* MouseGA4 related changes 
*********************************************************/
int cirrusbank(y) int y; 
{
 return 0;
}
int setmouseshape(cursor,x,y) char *cursor;int x, y; { return 0;}
int startmouse() { return 1;}
int stopmouse() { return 1;}

int showmouse() {
#ifdef DOS_VERSION
 show_mouse();
 delay(100);
#endif
 mouse_off=0;
 return 0;	
}

int hidemouse() {
#ifdef DOS_VERSION
 hide_mouse();
 delay(100);
#endif
 mouse_off=1;
 return 0;	
}

int resetmouse() {
#ifdef DOS_VERSION
 reset_mouse();
 clearwin(0,0,10,10,63);delay(100);
#endif
 return 0;	
}

int setmouse(x,y) {
#ifdef DOS_VERSION
 set_mouse(x,y);
 clearwin(0,0,10,10,63);delay(100);
#endif
 return 0;	
}

int setmouselim(x1,y1,x2,y2) int x1,y1,x2,y2; {
#ifdef DOS_VERSION
 set_mouselim(x1,y1,x2,y2);
 clearwin(0,0,10,10,63);delay(100);
#else
 X1mouse=x1;Y1mouse=y1; X2mouse=x2;Y2mouse=y2; 
#endif
 return 0;	
}

int readmouse(buttons,x,y) int *buttons,*x,*y;
{
  XComposeStatus compose;
  int bufsize=MAX_MAPPED_STRING_LENGTH;

#ifdef DOS_VERSION
 read_mouse(buttons,x,y);
#else
 XNextEvent(display,&report);
 switch(report.type) {
   case Expose:
    while(XCheckTypedEvent(display,Expose,&report));
    XPutImage(display,win,gc,screenbuf,0,0,0,0,window_width,window_height);
    break;
   case ConfigureNotify:
    window_width=report.xconfigure.width;
    window_height=report.xconfigure.height;
    break;
   case ButtonPress:
    *buttons=cur_button=report.xbutton.button;
    if(*buttons==3) *buttons=cur_button=2; /* prefer pressing right button */
    *x=report.xbutton.x;
    *y=report.xbutton.y;
    if(*x<X1mouse) *x=X1mouse;
    else if(*x>=X2mouse) *x=X2mouse;
    if(*y<Y1mouse) *y=Y1mouse;
    else if(*y>=Y2mouse) *y=Y2mouse;

    oldX=*x;oldY=*y;
    flush_mouse();
    break;
   case ButtonRelease:
     *buttons=cur_button=0; /*report.xbutton.button;*/
    *x=report.xbutton.x;
    *y=report.xbutton.y;
    if(*x<X1mouse) *x=X1mouse;
    else if(*x>=X2mouse) *x=X2mouse;
    if(*y<Y1mouse) *y=Y1mouse;
    else if(*y>=Y2mouse) *y=Y2mouse;
    oldX=*x;oldY=*y;
    break;
   case MotionNotify:
    *buttons=cur_button;
    *x=report.xmotion.x;
    *y=report.xmotion.y;
    if(*x<X1mouse) *x=X1mouse;
    else if(*x>=X2mouse) *x=X2mouse;
    if(*y<Y1mouse) *y=Y1mouse;
    else if(*y>=Y2mouse) *y=Y2mouse;
    break;
   case KeyPress:
     memset(keybuffer,0,3);
     charcount=XLookupString(&report,keybuffer, bufsize, &keysym, &compose);
     break;
   default:
    break;
 }
#endif
 return 0;
}



