/****************************************************
* G2.C 	Graphical window package
*	-error messages
*      	Author:		Jorma Jormakka
*      	original date:	7.7.92
*	last modified:	8.6.95
*	Copyright: Jorma Jormakka, all rights reserved
******************************************************
* CONTENTS:
******************************************************
* error/information messages from messages.txt being
* shown in the text window wd_object with id=1.
******************************************************/
#define GRAPH_OK
extern int gplanes;
void hide_errormsg();
int cannot_find_file();
int cannot_create_file();
int no_memory();
int copy_on_existing_file();
int illegal_pointer();
int file_error();
int change_palette_info();
int no_cutbuffer();
int change_background();
int remove_current_errormsg();
int unknown_parameter();

#include "x.ext"
#include "win.ext"
#include "text.ext"

#define CANNOT_FIND_FILE	0 
#define CANNOT_CREATE_FILE 	2
#define NO_MEMORY 		4
#define COPY_ON_EXISTING_FILE 	6
#define ILLEGAL_POINTER 	8
#define FILE_ERROR		10
#define USE_BGEDITOR            12
#define USE_AEEDITOR            14
#define CHANGE_PALETTE_INFO	16
#define NO_CUTBUFFER		18
#define UNKNOWN_PARAMETER	20
/******************************************/
void hide_errormsg()
{
 int i;
 if(term==VT100) return;	 
 if(!(wd_object[0].options & WINDOW_HIDDEN) && !(wd_object[0].type&ICON) ) {
  wd_object[0].options ^= WINDOW_HIDDEN;
  update_over(1); 	
  remove_background(1);  
 }
}
void hide_wd_object(id) int id;
{
 int i;
 if(term==VT100) return;	 
 if(!(wd_object[id-1].options & WINDOW_HIDDEN) && 
    !(wd_object[id-1].type&ICON) ) {
  wd_object[id-1].options ^= WINDOW_HIDDEN;
  update_over(id); 	
  remove_background(id);  
 }
}
/******************************************/
int cannot_find_file(filename)
char *filename;
{

 if(term==VT100) {printf("cannot_find_file\n");return 0;}		

 if(!remove_current_errormsg()) return 1;
 wd_object[0].xstart=0;wd_object[0].ystart=CANNOT_FIND_FILE;   	  
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;  
 textn("             ",15,4);
 textn(filename,15,4);
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
 return 0;	
}
/******************************************/
int unknown_parameter(name)
char *name;
{
 if(term==VT100) {printf("unknown_parameter\n");return 0;}		
#ifdef GRAPH_OK
 if(!remove_current_errormsg()) return 1;
 wd_object[0].xstart=0;wd_object[0].ystart=UNKNOWN_PARAMETER;
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;  
 textn(name,15,4);
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
#endif
 return 0;	
}
/******************************************/
int cannot_create_file(filename)
char *filename;
{
 if(term==VT100) {printf("cannot_create_file\n");return 0;}			
#ifdef GRAPH_OK
 if(!remove_current_errormsg()) return 1;	
 wd_object[0].xstart=0;wd_object[0].ystart=CANNOT_CREATE_FILE;   	  
 
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;  
 textn(filename,15,4);
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
#endif
 return(0);	
}
/******************************************/
int no_memory()
{
 if(term==VT100) {printf("no_memory\n"); return 0;}	
#ifdef GRAPH_OK
 if(!remove_current_errormsg()) return 1;	
 wd_object[0].xstart=0;wd_object[0].ystart=NO_MEMORY;   	  
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
#endif
 return 0; 	
}
/******************************************/
int copy_on_existing_file()
{
 char ch;

 if(term==VT100) {
  printf("copy_on_existing_file\n");
  ch=getch();
  if(ch=='n' || ch=='N') return 0;
  return 1;
 }
 if(!remove_current_errormsg()) return 0;  
 while(1) { if(kbhit()) getch(); else break;}
 wd_object[0].xstart=0;wd_object[0].ystart=COPY_ON_EXISTING_FILE;   	  
 wd_object[0].col1=4;   	  
 wd_object[0].savexsize=wd_object[0].xsize;
 wd_object[0].xsize=23*cs;
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(0);

 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;
 textn("yes",15,0);       
 ch=getch();
 if(ch=='n' || ch=='N') {
  xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;
  textn("no ",15,0);       
 }
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 wd_object[0].xsize=wd_object[0].savexsize;
 wd_object[0].col1=4;   	          
 if(ch=='n' || ch=='N') return(0);	
 return(1); /* yes, copy */
}
/******************************************/
int illegal_pointer(debuginfo)
int debuginfo;
{
 if(term==VT100) {printf("illegal_pointer\n");return 0;}	

 if(!remove_current_errormsg()) return 1;	
 wd_object[0].xstart=0;wd_object[0].ystart=ILLEGAL_POINTER;   	  
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;  
 textn(int_to_string((long)debuginfo),15,4); 
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
 return(0); 	
}
/******************************************/
int  file_error(debuginfo)
int debuginfo;
{
 if(term==VT100) {printf("file_error\n");return 0;}	
#ifdef GRAPH_OK
 if(!remove_current_errormsg()) return 1;
 	
 wd_object[0].xstart=0;wd_object[0].ystart=FILE_ERROR;   	  
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 xkoord=wd_object[0].xcord+2*cs;ykoord=wd_object[0].ycord+2*cs+cr;  
 textn(int_to_string((long)debuginfo),15,4); 
 if(wd_object[0].options & WINDOW_HIDDEN) {  	
  wd_object[0].options ^= WINDOW_HIDDEN;   
  update_over(1);
 }
#endif
 return(0); 	
}
/******************************************/
int change_palette_info()
{
 int oldxsize,oldysize,oldx,oldy;

 if(term==VT100) {printf("change_palette_info\n");return 0;}
 if(!remove_current_errormsg()) return 1;
 oldxsize=wd_object[0].xsize;oldysize=wd_object[0].ysize;
 oldx=wd_object[0].xcord;oldy=wd_object[0].ycord;
  
 wd_object[0].xsize=60*cs;wd_object[0].ysize=5*cr;
 change_background(0); 
 wd_object[0].xcord=120;wd_object[0].ycord=400;  

 wd_object[0].col1=1; 
 wd_object[0].xstart=0;wd_object[0].ystart=CHANGE_PALETTE_INFO;
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 getchar();
 /*
 while(1) {
  if(kbhit()) {getch(); while(kbhit()){ getch();} break;}
 }
 */
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 
 wd_object[0].xsize=oldxsize;wd_object[0].ysize=oldysize;
 change_background(0);
 wd_object[0].xcord=oldx;wd_object[0].ycord=oldy;wd_object[0].col1=4;
 return(0); 	
} 
/******************************************/
int no_cutbuffer()
{
 int oldxsize,oldysize,oldx,oldy;
 
 if(term==VT100) {printf("no_cut_buffer\n");return 0;}

 if(!remove_current_errormsg()) return 1;
 wd_object[0].xstart=0;wd_object[0].ystart=NO_CUTBUFFER;   	  
 wd_object[0].col1=1;   	             
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 getchar(); 
  /*
 while(1) {
  if(kbhit()) {getch(); while(kbhit()){ getch();} break;}
 }
 */
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 wd_object[0].col1=4;
    	            
 return(0); 	
} 
/******************************************/
int change_background(i)
{
 if(term==VT100) {printf("change_background\n");return 0;}	

 if(!remove_current_errormsg()) return 1;	
 wd_object[i].clength=wd_object[i].xsize/8+1;
 wd_object[i].isize=gplanes*wd_object[i].clength;
 wd_object[i].ylength=wd_object[i].ysize; 
 b_free(wd_object[i].background);
 wd_object[0].background=balloc((long)wd_object[i].isize*wd_object[i].ylength);
 if(wd_object[0].background) return(0);
 else return(1);
}
/******************************************/
int remove_current_errormsg()
{
 if(term==VT100) return 1;	
 if(!(wd_object[0].options & WINDOW_HIDDEN)) return 0; 
 if(wd_object[0].type&ICON) return 0;
 return 1; /* removed */
}

/******************************************/
int use_bgeditor()
{
 int oldxsize,oldysize,oldx,oldy;
 
 if(term==VT100) {printf("Only for the background editor\n");return 0;}

 if(!remove_current_errormsg()) return 1;
 wd_object[0].xstart=0;wd_object[0].ystart=USE_BGEDITOR;   	  
 wd_object[0].col1=1; 
 oldxsize=wd_object[0].xsize;
 wd_object[0].xsize=40*cs;             
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
 getchar(); 
 /* 
 while(1) {
  if(kbhit()) {getch(); while(kbhit()){ getch();} break;}
 }
 */
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 wd_object[0].col1=4;
 wd_object[0].xsize=oldxsize;                 	            
 return(0); 	
} 
int use_aeeditor()
{
 int oldxsize,oldysize,oldx,oldy;
 
 if(term==VT100) {printf("Only for the animation editor\n");return 0;}

 if(!remove_current_errormsg()) return 1;
 wd_object[0].xstart=0;wd_object[0].ystart=USE_AEEDITOR;   	  
 wd_object[0].col1=1;   	       
 oldxsize=wd_object[0].xsize;
 wd_object[0].xsize=40*cs;                   
 if(file_window(1,DRAW_ONLY_DO_NOT_STAY,0)>0) return(1);
  getchar(); 
 /* 
 while(1) {
  if(kbhit()) {getch(); while(kbhit()){ getch();} break;}
 }
 */
 wd_object[0].options ^= WINDOW_HIDDEN;
 update_over(1);
 remove_background(1);
 wd_object[0].col1=4;
 wd_object[0].xsize=oldxsize;    	            
 return(0); 	
} 
