/****************************************************
* G3.C 	Graphical window package
*	-text handling
*      	Author:		Jorma Jormakka
*      	original date:	26.1.93
*	last modified:	17.Nov.96 JJ 
*	Copyright: Jorma Jormakka, all rights reserved
******************************************************
* CONTENTS:
***********************************/
#include "x.ext"
#ifndef DOS_SYSTEM
#include <X11/keysymdef.h>
#include "linuxpaths.ext"
extern  KeySym keysym;
#endif
extern int nocolor;
extern int xxmin,yymin,xxmax,yymax;
int YD_koord=0;
/*****************************************************
* init_font, free_font
* reads fonts from font files fontxx.dat, fontxx.dis
* for some reasons separate routines for chlist,chdist
* and for chlist2,chdist2 
******************************************************/

int init_font();
int init_font2();
int free_font();
int free_font2();
int read_chlist(); /*subroutine*/
int read_chdist(); /*subroutine*/

/********************************************************
* prints a text string to xkoord, ykoord
* font in chlist, chdist
*********************************************************/

extern void textn();
void textXY(); 	/*subroutine of textn*/
void textf();
void textXYf(); /*subroutine of textf*/

/*********************************************************
* prints a text string for vector graphics, text can print 
* PostScript to a file or graphics to screen
* font in chlist2, chdist2
**********************************************************/

void text1();
void textn1(); 	/*subroutine of text1*/
void textXYv(); /*subroutine of text1*/
int fntlen2();	/*string length of font in chlist2,chdist2 */
int get_xoff(); /*subroutine of fntlen2*/

/*******************************************************
* print routines which call printf or textn depending on 
* if term is set to VT100 or to I86
* the routines use prompts in a buffer Txx[3][HELPSIZE]
* the buffer could countain Yes, No in English, Finnish etc.
* not much used anymore.
********************************************************/
void osprint1();
void osprint();
void otext();
void promptStr();
void osprints();
int not_ok();
int is_ok();
int got_string();
int insertPolishChars();
int insertScandiChars();
void remove_spaces();
int init_texts();

/********************************************
* handle input boxes in menus, these routines
* are called from menu handling
*********************************************/

int got_parstring();
void modify_line();
void display_line();
void modboxes();
void next_selection();

/*****************************************
* print, use this for debug texts to code
******************************************/

int print();

/*******************************************
* global variables for GRAPH 
********************************************/
extern int lineLen;
/* COORDINATES */
int X__max,Y__max;	/* global size limits for the screen */
int X1_min,X1_max;	/* limits for the current window */
int Y1_min,Y1_max;	/* limits for the current window */
int xkoord,ykoord;	/* current coordinates, textn uses them */
int X,Y;		/* coordinates read from mouse */

/* TEXT HANDLING */
int defaultfont=2; 	/* default font number */
int curfnt=0;		/* current font number */
char *chlist=0; 	/* font buffer 1, characters */
char *chdist=0; 	/* font buffer 1, distances of letters*/
char *chlist2=0; 	/* font buffer 2, characters */
char *chdist2=0; 	/* font buffer 2, distances of letters*/
int ysize=0; 		/* hight of font in pixels*/
int fsize=0; 		/* width of font in pixels */
int truncate1=0; /* if set text is truncated if limits are exceeded */
int   plg;		/* language for insertion of scandi/polish letters */
int   term;	/* two values VT100 which results to printf and 
		/* I86 printing with textn (Intel x86 series assembly)*/
int   cs;	/* length of a letter in fixed size font, usually 8 */
int   cr;	/* line shift in pixels (carriage return) */
int bgcol,fgcol;  	/* background color, foreground color */
char *Txx[3][HELPSIZE];	/* a buffer for pointers to help strings */
int   lg=0;		/* language in Txx string, this must be set*/

/* MOVING WD_OBJECTS */
int buttons=0;		/* mouse buttons */
int mouse_off=0,curon=0;
int popwindow=0;	/* currently active (popped up) window id */
int moving=0,mov=0;	/* moving window id */
int markershape;	/* shape of a marker if the routine marker() is used */	

/* MISCELLANEOUS */
char *our_time_zone="-0200";

/********************
* local variables 
*********************/
int ysizeb,csb;
static int xcur;
static int ycur;
static char line1[132];

extern char *int_to_string();
extern void *malloc();
extern FILE *outstream;

/*****************************************************
* read fonts from font files fontxx.dat, fontxx.dis
* free font buffers after use
* 	int init_font();
* 	int init_font2();
* 	int free_font();
* 	int free_font2();
* 	int read_chlist();
* 	int read_chdist();
*****************************************************/ 
/*****************************************************
* init_font, reads a font of name font<fontnumber>.dat
* 	     from a file to memory.
* init_font prints error messages in text mode. 
* returns: 0 normal, 1 error
******************************************************/
int init_font(fontnumber) int fontnumber;
{
 curfnt=fontnumber;
 if(read_chlist(fontnumber,&ysize,&fsize,&chlist)) return(1);
 cr=ysize+1;cs=8;
 if(read_chdist(fontnumber,&chdist)) return(1);
 return(0);    
}
int init_font2(fontnumber) int fontnumber;
{
 int fsizeb;

 if(read_chlist(fontnumber,&ysizeb,&fsizeb,&chlist2)) return(1);
 csb=8;
 if(read_chdist(fontnumber,&chdist2)) return(1);
 return(0);    
}
/*****************************************************
* free_font, deallocates memory allocated for a font
* returns: 0 normal, 1 error
******************************************************/
int free_font()
{
 curfnt=0;ysize=fsize=cr=cs=0;
 if(chlist) free(chlist);chlist=0;
 if(chdist) free(chdist);chdist=0; 
 return(0);	
}
int free_font2()
{
 ysizeb=csb=0;
 if(chlist2) free(chlist2);chlist2=0;
 if(chdist2) free(chdist2);chdist2=0; 
 return(0);	
}
/**************************************
 *
 **************************************/
#ifdef DOS_VERSION 
int chdir(directory) char *directory;
{
  return 1; /* do nothing */
}
#endif
/*****************************************
* read font.dat file to chlist
* -the data is the shapes of the letters
******************************************/
int read_chlist(fontnumber,ysiz,fsiz,chl) 
int fontnumber;int *ysiz,*fsiz;char **chl;
{
 FILE *stream;
 char fname[30];
 unsigned char line[3];
#ifdef DOS_VERSION 
 char curdir[MAXPATH];
 char fontdir[MAXPATH]; 
 
 strcpy(curdir,"X:\\");
 curdir[0]='A'+getdisk();
 getcurdir(0,curdir+3);
 strcpy(fontdir,"A:\\GRAPH\\FONT"); 
 chdir(fontdir);  	
#else
 char curdir[100];
 char fontdir[100]; 
#endif

 strcpy(fname,"font");
 strcat(fname,int_to_string((long)fontnumber));
 strcat(fname,".dat");
 stream=fopen(fname,"r+");

#ifndef DOS_SYSTEM
 /* try adding the font directory */
 if(!stream) {
  strcpy(fontdir,fontpath);
  strcat(fontdir,fname);
  stream=fopen(fontdir,"r+");
 }
#endif
 if(!stream) {printf("can't open font file %s\n",fname);
  chdir(curdir); 
  return(1);}
 fread(line,1,2,stream);
 *ysiz=(line[0])&0xff;*fsiz=(line[1])&0xff;
 if(*chl) free(*chl);
 *chl=(unsigned char *)malloc((int)((*fsiz)*(*ysiz)) );     
 if(!(*chl)) {
  printf("malloc fails fsize=%d ysize=%d\n",fsize,ysize);
  chdir(curdir);return(1);}
 fread(*chl,1,(long)(*fsiz)*(*ysiz),stream);
 fclose(stream);
 chdir(curdir);  
 return(0);
}
/*****************************************
* read font.dis file to chdist
* -the data gives spaces between letters
******************************************/
int read_chdist(fontnumber,chd) 
int fontnumber;char **chd;
{
 FILE *stream;
 char fname[30];
#ifdef DOS_VERSION
 char curdir[MAXPATH];
 char fontdir[MAXPATH]; 
 
 strcpy(curdir,"X:\\");
 curdir[0]='A'+getdisk();
 getcurdir(0,curdir+3);
 strcpy(fontdir,"C:\\GRAPH\\FONT");
 chdir(fontdir);  	
#else
 char curdir[100];
 char fontdir[100]; 
#endif
   
 if(*chd) free(*chd);
 strcpy(fname,"font");
 strcat(fname,int_to_string((long)fontnumber));
 strcat(fname,".dis");
 stream=fopen(fname,"rb+");

#ifndef DOS_SYSTEM
 if(!stream) {
  strcpy(fontdir,fontpath);
  strcat(fontdir,fname);
  stream=fopen(fontdir,"rb+");
 }
#endif
 if(!stream) {
  chdir(curdir);  	
  return(0);
 }
 *chd=(unsigned char *)malloc(60*60);     
 if(!(*chd)) {
  printf("malloc fails allocating 3600 bytes\n");
  chdir(curdir);return(1);}
 fread(*chd,1,(long)60*60,stream);
 fclose(stream);
 chdir(curdir);  
 return(0);
}

/********************************************************
* prints a text string to xkoord, ykoord
* font in chlist, chdist
*	void textn();
*	void textXY(); 
*	void textf();
*	void textXYf();
*********************************************************/
/********************************************************
* textn, prints a text string where letters are of color
*        and background has the color bckgcol
*********************************************************/
void textn(str,color,bckgcol) char *str;int color,bckgcol;
{ 
 if(term==VT100) printf("%s\n",str);
 else {
  if(curfnt!=defaultfont) {free_font();init_font(defaultfont);}
  if(bckgcol!=nocolor)
   clearwin(xkoord,ykoord,cs*strlen(str),ysize,15);
  textXY(xkoord,&ykoord,str,color,bckgcol);
 }
}


void textn2(str,color,bckgcol) char *str;int color,bckgcol;
{ 
 if(term==VT100) printf("%s\n",str);
 else {
  if(curfnt!=defaultfont) {free_font();init_font(defaultfont);}
  clearwin(xkoord,ykoord,cs*strlen(str),ysize,15);
  textXYf(xkoord,&ykoord,str,color,bckgcol);
 }
}

/*****************************************
* textXY
******************************************/
void textXY(X,Y,str,color,bckgcol) 
int X;
int *Y;
char *str;
int color,bckgcol;
{ 
 register int i;
 int len, place,maxplace;  
 char *buf;
  
 maxplace=((X1_max-1)/8)*8;
 len=strlen(str);
 place=X;

 for(i=0;i<len;i++)
 { 
  if(place>maxplace) {
   if(truncate1) break;
   place=X1_min;(*Y) += cr; 
  }
  else if(place<X1_min) {
   place=X1_min;
  }     
  if(*Y>Y1_max) {
   if(bckgcol!=nocolor) clearwin(X1_min,Y1_min,X1_max,Y1_max,15);
   *Y=Y1_min;     
  }
  else if(*Y<Y1_min) *Y=Y1_min;
    
  buf=chlist+(int)str[i]*ysize;
  displaychar(place,*Y,ysize,color,bckgcol,lineLen,buf);
  place += cs;
 }
}
/*****************************************
* textf
******************************************/
void textf(str,color,bckgcol,fn) char *str;int color,bckgcol,fn;
{ 
 if(curfnt!=fn) {free_font();init_font(fn);}
 textXYf(xkoord,&ykoord,str,color,bckgcol);
}
/*****************************************
* textXYf
******************************************/
void textXYf(X,Y,str,color,bckgcol) 
int X;
int *Y;
char *str;
int color,bckgcol;
{ 
 register int i;
 int len, place,maxplace;  
 unsigned char *buf;
 int k,j,xoff;
 unsigned char bit; 
   
 maxplace=((X1_max-1)/8)*8;
 len=strlen(str);
 place=X;

 if(*Y>Y1_max) { /* for scrolling */
  clearwin(X1_min,Y1_min,X1_max,Y1_max,bgcol);
  *Y=Y1_min;     
 }
 else if(*Y<Y1_min) *Y=Y1_min;

 for(i=0;i<len;i++)
 { 
  if(place>maxplace) { /* for breaking long lines by carriage returns */
   if(truncate1) break;
   place=X1_min;(*Y) += cr; 

   if(*Y>Y1_max) { /* we may redo the scrolling */
    clearwin(X1_min,Y1_min,X1_max,Y1_max,bgcol);
    *Y=Y1_min;     
   }
   else if(*Y<Y1_min) *Y=Y1_min;
  }
  else if(place<X1_min) place=X1_min;
       

  if(str[i] && str[i+1]) {
   if(!chdist) { /* if the font does not have letter separation info, use cs */
    xoff= cs;
    clearwin(place,*Y,place+xoff,*Y+ysize,bckgcol);/* make place for letter */
   }
   else { /* get the displacement of letters */
    xoff=get_xoff(chdist,str,i); /* make place for a letter */
    for(j=0;j<ysize;j++)
     for(k=0;k<xoff;k++) drawpixel((int)(place+k),(int)(j+ *Y),bckgcol);
   }
  }
  /* draw one letter */
  buf=chlist+(int)str[i]*ysize;
  for(j=0;j<ysize;j++) {
   for(k=0,bit=0x80;bit;k++,bit=bit>>1) {  	
    if((*buf)&bit) drawpixel((int)(place+k),(int)(j+ *Y),color);
   }
   buf++;   
  }  
  place +=xoff;  
 }
}

/*****************************************
* textXYb
* like textXYf but does not call XPutImage
* and is more streamlined
******************************************/
void textXYb(X,Y,str,color,bckgcol) 
int X;
int *Y;
char *str;
int color,bckgcol;
{ 
 register int i;
 int len, place,maxplace;  
 unsigned char *buf;
 int k,j,xoff;
 unsigned char bit; 
   
 maxplace=((X1_max-1)/8)*8;
 len=strlen(str);
 place=X;

 /* just truncate too long lines */
 if(X+len*cs>maxplace) {
  str[(maxplace-X)/cs]=0; 
  len=strlen(str);
 }

 /* scrolling */
 if(*Y>Y1_max) {
  clearwin(X1_min,Y1_min,X1_max,Y1_max,bgcol);
  *Y=Y1_min;     
 }
 else if(*Y<Y1_min) *Y=Y1_min;

 /* clear the whole line, assuming letter spacing cs */
 clearwin(place,*Y,place+cs*len,*Y+ysize,bckgcol);

 for(i=0;i<len;i++)
 { 
  if(!chdist) xoff= cs;
  else xoff=get_xoff(chdist,str,i);

  buf=chlist+(int)str[i]*ysize;
  for(j=0;j<ysize;j++) {
   for(k=0,bit=0x80;bit;k++,bit=bit>>1) {  	
    if((*buf)&bit) drawpixel2c((int)(place+k),(int)(j+ *Y),color);
   }
   buf++;   
  }  
  place +=xoff;   
 }
}


/*********************************************************
* prints a text string for vector graphics, text can print 
* PostScript to a file or graphics to screen
* font in chlist2, chdist2
*	void text1();
*	void textn1();
*	void textXYv();
*	int fntlen2();
*	int get_xoff();
**********************************************************/
/*****************************************
* text1
******************************************/
void text1(print,num,power,col1,col2) 
int print;long num;int power,col1,col2;
{
 int i,j;long n;char *p1;char buf1[10];char bufb[10];
 
 strcpy(bufb,int_to_string(num));
 
 p1=buf1+8;buf1[9]=0;
 j=strlen(bufb);
 i=power;
 while(1) {
  if(!i && power) {*p1='.';p1--;}
  if(j) {j--;*p1=bufb[j];}
  else {if(i<0) break;*p1='0';}
  p1--;
  i--;
 }
 textn1(33,print,p1+1,col1,col2);	
}
/*****************************************
* textn1
******************************************/
void textn1(font,print,s,col1,col2) int font,print;char *s;int col1,col2;
{
 char line[200];
 
 if(!print) {
  textf(s,col1,col2,font);
 }
 else {
  strcpy(line,"Or moveto ");
  strcat(line,int_to_string((long)xkoord));
  strcat(line," CX ");	
  strcat(line,int_to_string((long)(Y1_max-Y1_min-ykoord-cr/2) ));  
  if(font==6)
   strcat(line," CX rmoveto /Times-Roman findfont 12 CX scalefont setfont (");
  else if(font==35)
   strcat(line," CX rmoveto /Symbol findfont 10 CX scalefont setfont (");   
  else 
   strcat(line," CX rmoveto /Times-Roman findfont 10 CX scalefont setfont (");
  strcat(line,s);
  strcat(line,") show\n");
  fputs(line,outstream);  	  
 }
}

/*****************************************
* fntlen2
******************************************/
int fntlen2(str) 
unsigned char *str;
{ 
 int i,xoff,len;

 len=csb;
 if(!chlist2) return(0); 
 for(i=0;str[i] && str[i+1];i++) {
  if(!chdist2) xoff= csb;
  else xoff=get_xoff(chdist2,str,i);
  if(!xoff) xoff=csb;
  len +=xoff;  
 }
 return(len);
}
/*****************************************
* get_xoff
******************************************/
int get_xoff(chd,str,i) char *chd,*str;int i;
{
 int i1,pos1,pos2;  	
    
 pos1=pos2=0;
 if((int)str[i]>=(int)'a' && (int)str[i]<=(int)'z') pos1=(int)str[i]-(int)'a';
 else if((int)str[i]>=(int)'A' && (int)str[i]<=(int)'Z') 
  pos1=(int)str[i]-(int)'A'+30;
 i1=i+1;   
 if((int)str[i1]>=(int)'a' && (int)str[i1]<=(int)'z') 
  pos2=(int)str[i1]-(int)'a';
 else if((int)str[i1]>=(int)'A' && (int)str[i1]<=(int)'Z') 
  pos2=(int)str[i1]-(int)'A'+30;
 return((int)chd[pos1*60+pos2]);     	
}
/*******************************************************
* print routines which call printf or textn depending on 
* if term is set to VT100 or to I86
* the routines use prompts in a buffer Txx[3][HELPSIZE]
* the buffer could countain Yes, No in English, Finnish etc.
* not much used anymore.
*
*	void osprint();
*	void otext();
*	void promptStr();
*	void osprints();
*	int not_ok();
*	int is_ok();
*	int got_string();
*	int insertPolishChars();
*	int insertScandiChars();
*	void remove_spaces();
*	int init_texts();
********************************************************/
/*****************************************
* osprint
******************************************/
void osprint(txt,xcur,ycur)
int txt;
int xcur;
int ycur;
{
 int yoff;
 if(term==VT100) {
  printf("%s",Txx[lg][txt]);
  if(ycur!=ykoord)
   printf("\n");
  xkoord=xcur%HORRES;ykoord=ycur%VERRES1;   
 }
 else if (term==I86) {
  yoff=ycur-ykoord;
  otext(Txx[lg][txt],fgcol,bgcol);  
  if(ykoord<=Y1_min){
   ykoord=Y1_min+cr; textn("                              ",fgcol,bgcol);}
  else   ykoord += yoff;
  xkoord=xcur;
 }
}
/****************************************************
* osprint1
* this is used only by the SIMTOOL simulator 
*****************************************************/
void osprint1(txt)
int txt;
{
 int lim;

 xkoord=0;
 ykoord=YD_koord;
 lim=ykoord+2*cr; if (lim>400) lim=401;
 clearwin(xkoord,ykoord,LIMDBAR-1,lim,15);
 textnb(txt,0,15);
 YD_koord+=cr;
 if(YD_koord>400) YD_koord=0;
}

/*****************************************
* otext
******************************************/
void otext(buf,col,bckgcol) char *buf; int col,bckgcol;
{int i;

 memcpy(line1,buf,132);
 if(plg & POLI)
  insertPolishChars(line1);

 if (plg & FINN || plg & SWED) 
 {
  for(i=0;i<strlen(line1);i++) insertScandiChars(&line1[i]);    	
 }     
 textnb(line1,col,bckgcol);
} 
/*****************************************
* promptStr
******************************************/
void promptStr(prompt,result,len)
int prompt;
char *result;
int  len;
{
 int savexcor;
 savexcor=xkoord;
 osprint(prompt,xkoord,ykoord);
 xkoord += 8*( strlen( Txx[lg][prompt] )+1 );
 got_string(line1,EMPTYSTR,xkoord,ykoord,30);
 remove_spaces(line1,result,len);
 xkoord=savexcor;
}
/*****************************************
* osprints
******************************************/
void osprints(buf,xcur,ycur)
char *buf;
int xcur;
int ycur;
{
 int yoff;
 if(term==VT100) {
  printf("%s",buf);
  if(ycur!=ykoord)
   printf("\n");
  xkoord=xcur%HORRES;ykoord=ycur%VERRES1;   
 }
 else if (term==I86) {
  yoff=ycur-ykoord;
  otext(buf,fgcol,bgcol);    
  if(ykoord<Y1_min){
   clearwin(X1_min,Y1_min,X1_max,Y1_max,bgcol);
   ykoord=Y1_min+cr;
  }
  else   ykoord += yoff;  
 }
}
/*****************************************
* not_ok
******************************************/
int not_ok(txt,xcur,ycur)
int txt;
int xcur;
int ycur;
{
  char con[25];int i;

 if(term==VT100) {
  printf("%s",Txx[lg][txt]);
  if(ycur!=ykoord)
   printf("\n");
  memset(line1,0,130);con[0]=0;
  /* gets(line1);*/
  for(i=0;i<132;i++) {
   line1[i]=getch();
   if(line1[i]==0xd) {
    line1[i]=0;
    break; /* cr pressed */
   }
  }
  sscanf(line1,"%24s",con);
  conv_toupper(con);
  xkoord=xcur%HORRES;ykoord=ycur%VERRES1;
  return(strncmp(con,Txx[lg][YES],1));
 }
 else if (term==I86) {
  otext(Txx[lg][txt],fgcol,bgcol);
  memset(line1,0,2);con[0]=0;
  line1[0]=getch();line1[1]=0;
  if(line1[0]==(char)13) line1[0]=0;
  if(line1[0]) {
   xkoord += 8*(strlen(Txx[lg][txt])+1);
   otext(line1,fgcol,bgcol);    
   sscanf(line1,"%24s",con);
  }
  else con[0]=0;
  conv_toupper(con);
  xkoord=xcur;ykoord=ycur;  
  return(memcmp(con,Txx[lg][YES],1));
 }
 return(0);
}
/*****************************************
* is_ok
******************************************/
int is_ok(txt,xcur,ycur)
int txt;
int xcur;
int ycur;
{
  char con[25];int i;

 if(term==VT100) {
  printf("%s",Txx[lg][txt]);
  if(ycur!=ykoord)
   printf("\n");
  memset(line1,0,130);con[0]=0;
  /* gets(line1);*/
  for(i=0;i<132;i++) {
   line1[i]=getch();
   if(line1[i]==0xd) {
    line1[i]=0;
    break; /* cr pressed */
   }
  }
  sscanf(line1,"%24s",con);
  conv_toupper(con);
  xkoord=xcur%HORRES;ykoord=ycur%VERRES1;
  return(strncmp(con,Txx[lg][NO],1));
 }
 else if (term==I86) {
  otext(Txx[lg][txt],fgcol,bgcol);
  memset(line1,0,120);con[0]=0;
  line1[0]=getch();line1[1]=0;
  if(line1[0]==(char)13) line1[0]=0;
  xkoord += 8*(strlen(Txx[lg][txt])+1);
  otext(line1,fgcol,bgcol);  
  sscanf(line1,"%24s",con);
  conv_toupper(con);
  xkoord=xcur;ykoord=ycur;  
  return(memcmp(con,Txx[lg][NO],1));
 }
 return(0);
}
/*****************************************
* got_string
******************************************/
int got_string(buf,txt,xcur,ycur,max)
char *buf;
int txt;
int xcur;
int ycur;
int max;
{
 int j,xsav;	
 int k;

 if(term==VT100) {
  printf("%s",Txx[lg][txt]);
  if(ycur!=ykoord)
   printf("\n");
  buf[0]=(char)0;
  /* gets(buf);*/
  for(j=0;j<132;j++) {
   buf[j]=getch();
   if(buf[j]==0xd) {
    buf[j]=0;
    break; /* cr pressed */
   }
  }
  xkoord=xcur%1024;ykoord=ycur%1024;
  if(!buf[0]) return(0);
  else return(1);
 }
 else if (term==I86) {
  xsav=xcur;
  xkoord=xcur;ykoord=ycur;otext(Txx[lg][txt],fgcol,bgcol);
  k=strlen(Txx[lg][txt])*8+8;  
  xcur += k;
  ycur += cr*( (int) ( (xcur-X1_min)/(X1_max-X1_min) ));  
  xcur=X1_min+(xcur-X1_min)%(X1_max-X1_min);

  buf[0]=0;
  j=0;
  while(j<max)
  {
    buf[j]=getch();
   if(j+1<max) buf[j+1]=0;
   if(!j){
    xkoord=xcur;ykoord=ycur;
    textn("         ",fgcol,bgcol);
   }
   if(buf[j]==(char)13) {buf[j]=0;break;}
   if(!buf[j] && j>0)
   {
#ifdef DOS_VERSION
    buf[j]=getch();
    if(buf[j]==(char)75){
#else
    if(keysym==XK_Left) {
#endif
     buf[j]=(char)0;j--;buf[j]=(char)0;
     if(j>=0) {xkoord=xcur+8*j;ykoord=ycur;textn(" ",fgcol,bgcol);}
    }
   }
   else if ((int)buf[j]==8) {
    buf[j]=(char)0;j--;buf[j]=(char)0;
    if(j>=0) {xkoord=xcur+8*j;ykoord=ycur;textn(" ",fgcol,bgcol);}   	
   }
   else {
    if(plg & FINN || plg & SWED) insertScandiChars(&buf[j]);    	    	
    if(plg & POLI) { 
     if(insertPolishChars(buf)) j--;
    }
    j++;    
   } 
   xkoord=xcur;ykoord=ycur;   
   textn(buf,fgcol,bgcol);
  }
  ycur += cr;   
  xkoord=xsav;ykoord=ycur;
  if(!buf[0]) return(0);
  else return(1);
 }
 return(0);
}
/*****************************************
* insertPolishChars
******************************************/
int insertPolishChars(word)
char *word;
{
 int k,t=0;
 char help[100];
 for (k=0;k<strlen(word);k++) {
  if(!strncmp(&word[k+1],"'",1)) {
   if (word[k]=='c') { t=1,word[k]=0x04;}
   else if (word[k]=='s') {t=1;word[k]=0x05;}
   else if (word[k]=='z') {t=1;word[k]=0x06;}
   else if (word[k]=='o') {t=1;word[k]=0x08;}
   else if (word[k]=='C') {t=1;word[k]=0x0c;}
   else if (word[k]=='S') {t=1;word[k]=0x0d;}  
   else if (word[k]=='n') {t=1;word[k]=0x10;}
   else if (word[k]=='O') {t=1;word[k]=0x17;}   
   else if (word[k]=='N') {t=1;word[k]=0x18;}
   else if (word[k]=='Z') {t=1;word[k]=0x0e;}      
   else t=0;
   if (t){     
   strcpy(help,&word[k+2]);
   strcpy(&word[k+1],help);}
  }
  else if(!strncmp(&word[k+1],",",1)) {
   if (word[k]=='a') {t=1;word[k]=0x02;}
   else if (word[k]=='e') {t=1;word[k]=0x03;}
   else if (word[k]=='A') {t=1;word[k]=0x0a;}
   else if (word[k]=='E') {t=1;word[k]=0x0b;}
   else t=0;
   if(t){
   strcpy(help,&word[k+2]);
   strcpy(&word[k+1],help);}
  }
  else if(!strncmp(&word[k+1],"/",1)) {
   if (word[k]=='l') {t=1;word[k]=0x01;}
   else if (word[k]=='L') {t=1;word[k]=0x09;}
   else t=0;
   if(t){
   strcpy(help,&word[k+2]);
   strcpy(&word[k+1],help);}
  }
  else if(!strncmp(&word[k+1],".",1)) {
   if (word[k]=='z') {t=1;word[k]=0x07;}
   else if (word[k]=='Z') {t=1;word[k]=0x0f;}
   else t=0;
   if(t){
   strcpy(help,&word[k+2]);
   strcpy(&word[k+1],help);}
  }    
 }
 return(t);
}
/*****************************************
* insertScandiChars
******************************************/
int insertScandiChars(letter)
char *letter;
{
 if(*letter=='') *letter=0x11;
 else if(*letter=='') *letter=0x12;
 else if(*letter=='') *letter=0x13;
 else if(*letter=='') *letter=0x14;
 else if(*letter=='') *letter=0x15; 
 else if(*letter=='') *letter=0x16;
 return 0;  
}  	
/************************************
* remove_spaces
************************************/
void remove_spaces(inline1,result1,len)
char *inline1;
char *result1;
int  len;
{ 
 register int i,j;

 strcpy(result1, "");i=j=0;
 while (inline1[i]) 
 {
  if (i && inline1[i-1]!=' ' && inline1[i]==' ' && inline1[i+1]) {
   result1[j]=' ';j++; }
  while(inline1[i]==' ') i++;
  result1[j]=inline1[i];i++;
  if (inline1[i-1]==' ') break;
  j++;
  if (j>len) {result1[j]=(char)0;  return;} }
 result1[j]=(char)0;
}
/*****************************************
* init_texts
******************************************/
int init_texts()
{int i;
 for(i=0;i<3;i++) Txx[i][EMPTYSTR]="";
 return(0);	
}

/********************************************
* handle input boxes in menus, these routines
* are called from menu handling
*	int got_parstring();
*	void modify_line();
*	void display_line();
*	void modboxes();
*	void next_selection();
*********************************************/
/*****************************************
* got_parstring
******************************************/
int got_parstring(u1,u2,box,xfrom,xcur,ycur,max,col3,col4)
LINE10 *u1;
char **u2;
int box;
int xfrom;
int xcur,ycur;
int max;
int col3,col4;
{
 int j,k,horline,Xmax;int oldj;
 char *buf,ch;
 char cursor[8]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
 
 if (term==I86) {
  buf=u1[box].name;
  horline=u1[box].ycord/cr;
  xkoord=xcur;ykoord=ycur;      
  textn(buf,fgcol,col4);      
  j=0;oldj=-1;
  while(j<max)
  {

   if(oldj>=0 && oldj<max) {
    drawcursor(xcur+oldj*cs,ycur+ysize-2,col4,1,2,cursor);  
   }
   oldj=j;
   drawcursor(xcur+j*cs,ycur+ysize-2,14,1,2,cursor);
   
   ch=getch();

   if(ch==(char)13) {
    if(oldj>=0 && oldj<max) {
     drawcursor(xcur+oldj*cs,ycur+ysize-2,col4,1,2,cursor);  
    }   	
    break;
   }
   if(!ch)
   {
#ifdef DOS_VERSION
    ch=getch();
    if(ch==(char)75){
#else
    if(keysym==XK_Left) {
#endif
     if(j>0) j--;
    } /* arrow left */
    else 
#ifdef DOS_VERSION
    if(ch==(char)77) {
#else
    if(keysym==XK_Right) {
#endif
    if(j<strlen(buf)) j++;} /* arrow right */    
    xkoord=xcur;ykoord=ycur;    
    textn(buf,fgcol,col4);      
   }
   else if ((int)ch==8) {   	
    j--;
    for(k=j;k<strlen(buf);k++) buf[k]=buf[k+1];
    if(j>u1[box].bsize) modify_line(u1,u2,box,horline,ycur,xfrom,col3,col4,-1);
    xkoord=xcur;ykoord=ycur;
    textn(buf,fgcol,col4);
    xkoord=xcur+strlen(buf)*cs;ykoord=ycur;
    textn(" ",fgcol,col4);      
   }
   else {
    if(j==strlen(buf)) {if(j+1<max) buf[j+1]=0;}
    else if(j<strlen(buf)) {
     if(strlen(buf)==max) buf[max-1]=0;
     for(k=strlen(buf);k>j;k--) buf[k]=buf[k-1];	
    }
    buf[j]=ch;
    if(plg & FINN || plg & SWED) insertScandiChars(&buf[j]);    	    	
    if(plg & POLI) { 
     if(insertPolishChars(buf)) j--;
    }
    j++;    
    if(j<u1[box].size) {
     xkoord=xcur;ykoord=ycur;    
     textn(buf,fgcol,col4);  
    }
    else 
     modify_line(u1,u2,box,horline,ycur,xfrom,col3,col4,+1);
   }
  }
  if(!buf[0]) return(0);
  else return(1);
 }
 return(0);	
}
/*****************************************
* modify_line
******************************************/
void modify_line(u1,u2,box,horline,ycur,xfrom,col,col4,direction)
LINE10 *u1;
char **u2;
int box,horline;
int ycur,xfrom;
int col,col4;
int direction;
{
 int k,hormax,hormin;
 
 hormax=strlen(u2[horline]);
 if(direction>0) {
  hormin=u1[box].xcord/cs+u1[box].size;
  for(k=hormax-1;k>hormin;k--) u2[horline][k]=u2[horline][k-1];
 }
 else {
  hormin=u1[box].xcord/cs+u1[box].size-1;
  for(k=hormin;k<hormax;k++) u2[horline][k]=u2[horline][k+1];
 }
 if(hormax<100) u2[horline][hormax]=0;
  	 
 xkoord=X1_min+hormin*cs; ykoord=ycur;
 if(xkoord<X1_max) clearwin(xkoord,ykoord,X1_max,ykoord+cr,col);
 if(hormin+xfrom<hormax) textn(&u2[horline][hormin+xfrom],fgcol,col);

 modboxes(u1,box,xfrom,ycur,col4,direction);
}
/*****************************************
* display_line
******************************************/
void display_line(u1,u2,max,horline,xfrom,yfrom,col,col4)
LINE10 *u1;
char **u2;
int max,horline,xfrom,yfrom;
int col,col4;
{
 int box,go_on=0,ycur;

 if(horline<yfrom) return;
 xkoord=X1_min;
 ykoord=(horline-yfrom)*cr+Y1_min;
 if(xkoord<X1_max) clearwin(xkoord,ykoord,X1_max,ykoord+cr-2,col);
 if(xfrom<strlen(u2[horline])) textn(&u2[horline][xfrom],fgcol,col);
 for(box=0;box<max;box++) {
  if(u1[box].ycord/cr==horline) {go_on=1;break;}	
 }
 if(!go_on) return;
 ycur=u1[box].ycord-yfrom*cr+Y1_min;
 modboxes(u1,box,xfrom,ycur,col4,0);
}
/*****************************************
* modboxes
******************************************/
void modboxes(u1,box,xfrom,ycur,col4,direction)
LINE10 *u1;
int box,xfrom,ycur;
int col4;
int direction;
{
 char savebuf[LINE10MAX];
 int i,k,j,Xmax,Xmin,place;

 for(k=box,i=0;i<u1[box].parmax;k++,i++) {     
  if(!i) u1[k].size += direction;
  else u1[k].xcord += cs*direction;
   
  xkoord=u1[k].xcord+X1_min-xfrom*cs;
  ykoord=ycur;

  Xmin=(X1_min>xkoord?X1_min:xkoord);
  Xmax=(xkoord+u1[k].size*cs<X1_max?xkoord+u1[k].size*cs:X1_max);

  place=(X1_min<xkoord?0:(Xmin-xkoord)/cs);  
  xkoord=Xmin;
  
  if(xkoord<Xmax) clearwin(xkoord,ykoord,Xmax,ykoord+cr-2,col4);
  
  if(place<u1[k].size) {
   if(u1[k].options & SELECTION) {
    for(j=1;u1[k].name[j]>0x10 && j<LINE10MAX;j++) savebuf[j-1]=u1[k].name[j];
    j--;savebuf[j]=0;
    if(place<j) textn(&savebuf[place],fgcol,col4);
   }
   else textn(&u1[k].name[place],fgcol,col4);
  }
 }  
}
/*****************************************
* next_selection
******************************************/
void next_selection(name) 
char *name;
{
 int k;
 char savebuf[LINE10MAX];
 
 for(k=1;name[k]>0x10 && k<LINE10MAX;k++);
 memcpy(savebuf,name,k);savebuf[k]=0;
 strncpy(name,&name[k],LINE10MAX);
 strcat(name,savebuf);
}
/*****************************************
* print, use this for debug texts to code
******************************************/
/*****************************************
* print
******************************************/
int print(x,y,str,i) int x,y;char *str;int i;
{
 int X1_sav,Y1_sav,X2_sav,Y2_sav;int savefont;
 
 savefont=curfnt;
 if(curfnt!=defaultfont) {
  free_font(curfnt);curfnt=defaultfont;init_font(curfnt);}
 X1_sav=X1_min;Y1_sav=Y1_min;X2_sav=X1_max;Y2_sav=Y1_max;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max;
 xkoord=x;ykoord=y;textn(str,1,15);
 xkoord=x+strlen(str)*cs;textn("   ",1,15);
 xkoord=x+strlen(str)*cs;textn(int_to_string((long)i),1,15);
 X1_min=X1_sav;Y1_min=Y1_sav;X1_max=X2_sav;Y1_max=Y2_sav;
 
 if(savefont!=defaultfont) {
  free_font(curfnt);curfnt=savefont;init_font(curfnt);}
 return 0;
}
int printb(x,y,str) int x,y;char *str;
{
 int X1_sav,Y1_sav,X2_sav,Y2_sav;int savefont;
 
 savefont=curfnt;
 if(curfnt!=defaultfont) {
  free_font(curfnt);curfnt=defaultfont;init_font(curfnt);}
 X1_sav=X1_min;Y1_sav=Y1_min;X2_sav=X1_max;Y2_sav=Y1_max;
 X1_min=0;Y1_min=0;X1_max=X__max;Y1_max=Y__max; 
 xkoord=x;ykoord=y;textn(str,1,15);
 X1_min=X1_sav;Y1_min=Y1_sav;X1_max=X2_sav;Y1_max=Y2_sav;
 
 if(savefont!=defaultfont) {
  free_font(curfnt);curfnt=savefont;init_font(curfnt);}
 return 0;
}

