/****************************************************
* G5.C 	Graphical window package
*	-routines for picking up wd-objects
*      	Author:		Jorma Jormakka
*      	original date:	27.11.94
*	last modified:	26.10.99
*	Copyright: Jorma Jormakka, all rights reserved
* History: 26.10.99 JJ added delay to do_operations1
*          so, that used user buttons are not read more 
*          than once
******************************************************
* CONTENTS:
**********************************************
* Routines to manage wd_objects on the screen:
**********************************************/
#include "x.ext"
#define YDIF 8
#define YPOS 100
int naks=0;
int do_engine1();
int edi2_operations();
int do_operations();
int init_engine();
int serve_wd_objects();
int double_click();
int debug311=0; /* as do_operations is a model, it has prints */
/**********************************************
* Routines to show and hide wd_objects:
***********************************************/

void free_one_wd_object();
int put_one_wd_object();
int refresh_one_wd_object();
int put_wd_objects();
int free_wd_objects();
int free_wd_objects_gt1();
int free_wd_objects_gt1_u();

/**********************************************************
* Routines to manage the order (top, bottom) of wd_objects:
***********************************************************/

int update_over();
int force_over();
int pop_up_wanted();
int get_top_card();
int get_one_under();

/*******************************************
* Routines which are used to reorder objects
********************************************/

int bring_to_top();
int any_window_under();
int bring_id_to_top();
int put_back_order();
int find_stacking_order();
int find_stacking_order_by_coord();
int find_stacking_order_by_coord_to_len1();
int draw_away();
int copy_part_of_bg();
COVEREDSQUARE *update_list();
int substract_one_cover();
int make_new_rectangles();
COVEREDSQUARE *new_cur();
int move_pack();
void put_pack();

#include "win.ext"
#include "text.ext"
#define YDIF 8
extern void bitcpy();
extern void free_user_defined_types();
extern void hide_errormsg();

/**********************************************************************
* Routines to manage wd_objects on the screen:
* do_engine1(maxi,table)	default display manager
* edi2_operations(id)		subroutine
* do_operations()		subroutine
* init_engine(maxi)	initialization of display manager, puts ids<=maxi
* serve_wd_objects(id)	runs action code for wd_object[id-1]
* double_click		recognize double click
***********************************************************************/
/***************************************************
* display manager
****************************************************/
int do_engine1(maxi,table) 
int maxi;JMPTABLE *table;
{
 int command,i;
  
 if(mouse_off) {
  if(init_engine(maxi)) return(1);
 }

 while(1) {	
  do {
   command=do_operations();
   if(command==1) {
    if(popwindow==1) hide_errormsg();
    if(edi2_operations(popwindow)==1) return 1; /* exit asked */    
   }
   else if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */
    hidemouse(); /* JJ 23.9.03 */
    for(i=0;table[i].jmpfunc;i++) {
     if(table[i].x1<X && table[i].x2>X && 
        table[i].y1<Y && table[i].y2>Y){
      
      if((*table[i].jmpfunc)(buttons,X,Y)) {
       return(1); /* exit asked */
      }
      delay(100);buttons=0; /* JJ 26.10.99 */
      break;
     }
    }
    showmouse(); /* 23.9.03 JJ */
   }
  } while(!kbhit());
  if(getch()=='q') break;
 }
 return 0;
}
/******************************
* edi2_operations()
*
* returns.	0=continue
*		1=exit
*******************************/
int edi2_operations(id)
int id;
{
 int *chosen;
 LINE10 *u1;
 char **u2;

 chosen=(int *)wd_object[id-1].p3;
 u2=(char **)wd_object[id-1].p2;  
 u1=(LINE10 *)wd_object[id-1].p1;  	
   	
 if(wd_actions[id-1].jmpfunc) 
  return((*wd_actions[id-1].jmpfunc)(id-1,chosen,u1,u2));
 
 if(wd_actions[MAX_WINDOWS].jmpfunc) 
  return((*wd_actions[MAX_WINDOWS].jmpfunc)(id-1,chosen,u1,u2));
 return 0;
}

/******************************************************
* check if some operation should be made to a wd-object 
*******************************************************/
int do_operations()
{
 int i,command,lastpopwindow;
 int xnew;int another_window,num_under;
 	
 buttons=0;

 readmouse(&buttons,&X,&Y);
 if(!buttons) {
  if(mouse_off) { 
   if(moving) {

    if(as_rectangle) { /* moving must be valid */

      if(debug311) printf("moving as rectangle\n");
      as_rectangle=0;

     /* remove current box by writing background */
     draw_vbox(0,wd_object[moving-1].background,
            wd_object[moving-1].xcord,
            wd_object[moving-1].ycord,
            0,0,
            wd_object[moving-1].xsize-1+wd_object[moving-1].xcord,
            wd_object[moving-1].ysize-1+wd_object[moving-1].ycord,
            1,0);

      /* draw window */
     if(wd_object[moving-1].options & OCTET_ALIGNED) {
      xnew= (wd_object[moving-1].xcord>>3) <<3;
      movingPicture(xnew,wd_object[moving-1].ycord,0,moving);	
     }
     else {
      movingPicture(wd_object[moving-1].xcord,
       wd_object[moving-1].ycord,0,moving);	
     }
     /* put it down */
     if(debug311) printf("putting down moving=%d\n",moving);
     if_b_opt_bgtofile(moving);
     wd_object[moving-1].options ^= WINDOW_HIDDEN;      
     update_over(moving);
    }
    else {
     if(debug311)  printf("moving, not as rectangle\n");

     if(wd_object[moving-1].options & OCTET_ALIGNED) {
      xnew=(wd_object[moving-1].xcord>>3)<<3;
      movingPicture(xnew,wd_object[moving-1].ycord,1,moving);	
     }
     /* put the object down */
     if(debug311) printf("putting down moving=%d\n",moving);
     if_b_opt_bgtofile(moving);
     wd_object[moving-1].options ^= WINDOW_HIDDEN;      
     update_over(moving);
    }
    popwindow=moving=0;
    setmouselim(0,0,X__max,Y__max-5);

   }
   else if(popwindow) {
    if(debug311)  printf("moving=0, popwindow is true\n");
    popwindow=0;
    if(oldmarkershape!=0) {
     DefaultCursor();
     oldmarkershape=markershape=0;
    }
   }    	   
   showmouse();mouse_off=0; 

  }
 }
 else {
  /* mouse buttons pressed */
   
  if(!mouse_off) { 
   if(debug311)  printf("buttons pressed, mouse off, calling bring_to_top\n");
   hidemouse();mouse_off=1;
   popwindow=bring_to_top(X,Y);         
   if(popwindow) {
    if(debug311) printf("bring_to_top found popwindow=%d\n",popwindow);
    if(popwindow!=1) hide_errormsg();

    if(debug311) printf("taking popwindow=%d up\n",popwindow);
    /* hide the object and remove from the stacking order */
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;      
    update_over(popwindow);
    if_b_opt_bgfromfile(popwindow);
    moving=0;
   }
  }
  if(moving) { 
   if(debug311) printf("moving true, moving=%d\n",moving);
   if(as_rectangle) {
     if(debug311) printf("as rectangle\n");
 
     if(X-wd_object[moving-1].xcord>10 || X-wd_object[moving-1].xcord<-10
	|| Y-wd_object[moving-1].ycord>10 || Y-wd_object[moving-1].ycord<-10)
       {
      /* remove current box by writing background */
      draw_vbox(0,wd_object[moving-1].background,
            wd_object[moving-1].xcord,
            wd_object[moving-1].ycord,
            0,0,
            wd_object[moving-1].xsize-1+wd_object[moving-1].xcord,
            wd_object[moving-1].ysize-1+wd_object[moving-1].ycord,
            1,0);

      wd_object[moving-1].xcord=X;
      wd_object[moving-1].ycord=Y;
     /* draw a new box and save background */
      draw_vbox(0,wd_object[moving-1].background,
            X,Y,
            wd_object[moving-1].xsize-1+X,
            wd_object[moving-1].ysize-1+Y,
            0,0,
            2,0);
       }
   }
   else {

    if(debug311)  printf("not as rectangle\n");
    if(wd_object[moving-1].options & MOVE_AS_RECTANGLE) {
      /* remove window */
     movingPicture(X-cxoff,Y-cyoff,2,moving);
     wd_object[moving-1].xcord=X-cxoff;
     wd_object[moving-1].ycord=Y-cyoff;
     /* draw a new box and save background */
     draw_vbox(0,wd_object[moving-1].background,
            wd_object[moving-1].xcord,
            wd_object[moving-1].ycord,
            wd_object[moving-1].xsize-1+wd_object[moving-1].xcord,
            wd_object[moving-1].ysize-1+wd_object[moving-1].ycord,
            0,0,
            2,0);
     as_rectangle=1;
    }
    else movingPicture(X-cxoff,Y-cyoff,1,moving);

   }
  }
  else if(popwindow) { /* picked up object */
   i=popwindow-1;
   if(debug311) printf("to serve_wd_objects with popwindow=%d\n",popwindow);
   command=serve_wd_objects(i);
   if(debug311) printf("served popwindow=%d, command=%d\n",popwindow,command);
   if(command== -2) { /* user possibly left a current window */
    if(debug311) printf("command=-2, putting popwindow down\n");
    /* put the popwindow down */
    if_b_opt_bgtofile(popwindow);
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;             	
    update_over(popwindow);
    showmouse();mouse_off=0;return -1;  /* user action */
   }   
   if(command== -4) { /* move window */
    if(debug311) printf("command=-4, moving\n");

    /* moving object must be hidden and removed from the stack */
    moving=popwindow;
    /*
    cxoff=X-wd_object[i].xcord;
    cyoff=Y-wd_object[i].ycord;
    setmouselim(cxoff,cyoff,
     X__max-wd_object[i].xsize+cxoff,
     Y__max-wd_object[i].ysize+cyoff);
    */ 
    setmouselim(0,0,
     X__max-wd_object[i].xsize,
     Y__max-wd_object[i].ysize);

    if(fg_to_fgbuf(moving)) return(2);    
   }
   else if(command== -3) {
    if(debug311) printf("command=-3, make menu to an icon\n");

    /* put the popwindow down */
    if_b_opt_bgtofile(popwindow);
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;             	
    update_over(popwindow);

    /* draw_icon is called when window is not hidden */
    draw_icon(popwindow,DRAW_ONLY_DO_NOT_STAY);
    popwindow=0;
   }
   else if(command== -1) {
    if(debug311) printf("command=-1 free popwindow \n");

    /* this frees popwindow, it is removed from the stack */
    /* does not come here e.g. if killing a popup menu is disabled */
    free_one_wd_object(popwindow);popwindow=0;
    flush_mouse();delay(500);return 0;
   }
   else if(command== -5) {
    if(debug311) printf("command=-5 move popwindow and put it down \n");

    /* move popwidow */
    movingPicture(wd_object[popwindow-1].xcord,
    		  wd_object[popwindow-1].ycord,2,popwindow);

    /* put popwidow down */
    if_b_opt_bgtofile(popwindow);  /* 2017 */
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;
    update_over(popwindow);
    popwindow=0;
   }     
   else if(command==  0) {
    if(debug311) printf("command=0 put popwindow down, call operations \n");

    /* put popwidow down and call its operations */
    if_b_opt_bgtofile(popwindow);
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;
    update_over(popwindow);
    return 1;
   } 
   else {
    /* also with errors, put popwindow down */
    if_b_opt_bgtofile(popwindow);
    wd_object[popwindow-1].options ^= WINDOW_HIDDEN;
    update_over(popwindow);
    if(command==1) cannot_find_file(wd_object[i].name);
    if(command==2) no_memory();
    return 0;
   }
  }
  else {
   showmouse();mouse_off=0;return -1; /* user action */
  } 
 }
 return 0;
}

/***************************************************
* make error message object to object id 1
* put objects from 1 to maxi.
****************************************************/
int init_engine(maxi) int maxi;
{
 /* special hidden error e.t.c. message window */
 if(wd_object[0].type==FREE_OBJ) {
  make_file_window(1,20*cs,200,20*cs,3*cs+2*cr,4,2,15,15,"messages.txt",20,-1);  
  wd_object[0].options=
   WINDOW_HIDDEN | NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING | NO_RESIZING | NO_KILLING; 
 }

 if(put_wd_objects(2,maxi)) {
  printf("fail\n");	
  return 1;}

 resetmouse();
 setmouselim(0,0,X__max,Y__max);

 X=(X__max+1)/2;Y=(Y__max+1)/2;
 setmouse(X,Y);
 showmouse(); 

 mouse_off=0;popwindow=moving=0; 
 return(0);
}

/***************************************************
* according to object type call object routine
****************************************************/
int serve_wd_objects(i) int i;
{
 switch(wd_object[i].type) {
  default:
  if(wd_object[i].type & ICON) return(draw_icon(popwindow,NORMAL_OPERATION)); 
  else return(serve_user_defined_types(wd_object[i].type,popwindow));
  case POPUP_OBJ:	return(pop_up_menu(popwindow,NORMAL_OPERATION));
  case TEXTWIN_OBJ:	return(file_window(popwindow,NORMAL_OPERATION,0));
  case INPUTWIN_OBJ:	return(input_window(popwindow,NORMAL_OPERATION));  
  case CARD_OBJ:	return(draw_card(popwindow,NORMAL_OPERATION));
  case LABEL_OBJ:	return(draw_label(popwindow,NORMAL_OPERATION));  
  case ANIMATION_OBJ:	return(animate(popwindow,NORMAL_OPERATION));
  case PIXEL_DRAW_OBJ:	return(pixel_draw(popwindow,NORMAL_OPERATION));
  case TCARD_OBJ:   return(draw_transparent_card(popwindow,NORMAL_OPERATION));
  case REPLACE_BUFFER_OBJ:return(replace_buffer(popwindow,NORMAL_OPERATION));  
  case THREEDIM_OBJ:    return(draw_threedim_obj(popwindow,NORMAL_OPERATION));
 }
}
/********************************************************
* recognize double click, this works with counters
* and needs readjusting if computer is of different speed
*********************************************************/
int doubleclick_and_submenu(chosen,pmax,curX,curY,curbuttons,oldX,oldY,
				counter1,counter2,lim2)
int *chosen;
int pmax;
int curX,curY,curbuttons,oldX,oldY;
long *counter1,*counter2;
long lim2;
{
 int i,res=0;
 
 for(i=0;i<pmax;i++) if(chosen[i] & 1) {res=1;break;}
 if(!res || !curbuttons || oldY!=curY) return(0);
 if(oldX==curX 	&& *counter1 && *counter2>=lim2)  /* double click */  
 {*counter1=*counter2=0;chosen[i] |=2;return(1);}
 else if(oldX<curX) {chosen[i] |= 2;return(1);}
 return(0);	
}

/**********************************************************************
* Routines to show and hide wd_objects:
*
* free_one_wd_object(id)	hides and frees wd_object[id-1]
* put_one_wd_object(id)		draws first time wd_object[id-1]
* refresh_one_wd_object(id)	redraws wd_object[id-1]
* put_wd_objects(min_id,max_id)	puts ids from min_id to max_id
* free_wd_objects()		hides and frees id>=1
* free_wd_objects_gt1()		hides and frees id>=2
***********************************************************************/
void free_one_wd_object(i)
int i;
{
 switch(wd_object[i-1].type) {
  default: free_user_defined_types(wd_object[i-1].type,i); return;     	
  case TEXTWIN_OBJ:	free_file_window(i);	  return;
  case INPUTWIN_OBJ:	free_input_window(i);	  return;  
  case POPUP_OBJ:	free_pop_up_menu(i);	  return;
  case CARD_OBJ:	free_card(i);		  return;
  case LABEL_OBJ:	free_label(i);		  return;  
  case ANIMATION_OBJ: 	free_animation(i);	  return; 
  case PIXEL_DRAW_OBJ: 	free_pixel_draw(i);	  return;
  case TCARD_OBJ:	free_transparent_card(i); return;
  case REPLACE_BUFFER_OBJ: free_replace_buffer(i);return;      
  case THREEDIM_OBJ:    free_threedim_obj(i);     return;
 }
}

/****************************************
* show one wd-object on screen
*****************************************/
int put_one_wd_object(id) int id;
{
 int ret=0;
 switch(wd_object[id-1].type) {
  default:
   if(wd_object[id-1].type & ICON) ret=draw_old_icon(id);  
   else ret=put_user_defined_types(wd_object[id-1].type,id);
   break;
  case TEXTWIN_OBJ:
   ret=file_window(id,DRAW_ONLY_DO_NOT_STAY,0);break;
  case INPUTWIN_OBJ:
   ret=input_window(id,DRAW_ONLY_DO_NOT_STAY);break;   
  case POPUP_OBJ:
   ret=pop_up_menu(id,DRAW_ONLY_DO_NOT_STAY);break;
  case CARD_OBJ:
   ret=draw_card(id,DRAW_ONLY_DO_NOT_STAY);break; 
  case LABEL_OBJ:
   ret=draw_label(id,DRAW_ONLY_DO_NOT_STAY);break;    
  case ANIMATION_OBJ:
   ret=animate(id,DRAW_ONLY_DO_NOT_STAY);break;
  case PIXEL_DRAW_OBJ:		
   ret=pixel_draw(id,DRAW_ONLY_DO_NOT_STAY);break;
  case TCARD_OBJ:		
   ret=draw_transparent_card(id,DRAW_ONLY_DO_NOT_STAY);break;
  case REPLACE_BUFFER_OBJ:	
   ret=replace_buffer(id,DRAW_ONLY_DO_NOT_STAY);break;   
  case THREEDIM_OBJ:
   ret=draw_threedim_obj(id,DRAW_ONLY_DO_NOT_STAY);break;   
 }
 if(ret>0) return(1); return(0);
}

/****************************************
* redraw foreground of one wd-object on screen
*****************************************/
int refresh_one_wd_object(id) int id;
{
 int ret=0;
 switch(wd_object[id-1].type) {
  default:
   if(wd_object[id-1].type & ICON) ret=draw_old_icon(id); 
   else ret=refresh_user_defined_types(wd_object[id-1].type,id);   
   break;
  case TEXTWIN_OBJ:
   ret=file_window(id,REFRESH,0);break;
  case INPUTWIN_OBJ:
   ret=input_window(id,REFRESH);break;   
  case POPUP_OBJ:
   ret=pop_up_menu(id,REFRESH);break;
  case CARD_OBJ:
   ret=draw_card(id,REFRESH);break; 
  case LABEL_OBJ:
   ret=draw_label(id,REFRESH);break;    
  case ANIMATION_OBJ:
   ret=refresh_animation(id);break;
  case PIXEL_DRAW_OBJ:		
   ret=pixel_draw(id,REFRESH);break;
  case TCARD_OBJ:		
   ret=draw_transparent_card(id,REFRESH);break;
  case REPLACE_BUFFER_OBJ:	
   ret=replace_buffer(id,REFRESH);break;           
  case THREEDIM_OBJ:
   ret=draw_threedim_obj(id,REFRESH);break;   
 }
 if(ret>0) return 1; return 0;
}   

/****************************************
* show wd-objects on screen
*****************************************/
int put_wd_objects(min1,maxi) int min1,maxi;
{
 int i,type; 
 for(i=min1;i<=maxi;i++) {
  if(wd_object[i-1].type!=FREE_OBJ) {
   if(put_one_wd_object(i)) {
    return(1);
   }
   /* an object is created (make) with OBJECT_NOT_PUT set */
   /* then put_wd_objects is assumed to call update_over  */
   /* and keep the assignment of WINDOW_HIDDEN as it is   */
   /* object type 5 sets the window hidden and not put    */
   /* it calls update_over in make                        */

   /* animation objects call update_over in animate, so exclude them */
   if(wd_object[i-1].type!=ANIMATION_OBJ) {
    if_b_opt_bgtofile(i);
    zero_over(i-1);
    if(wd_object[i-1].options & OBJECT_NOT_PUT) {   
     wd_object[i-1].options ^= OBJECT_NOT_PUT;
     update_over(i);
    }
   }
  }
 }
 return 0;
}

/****************************************
* remove wd-objects from screen
*****************************************/
int free_wd_objects()
{
 int i;
 for(i=MAX_WINDOWS;i>=1;i--) {
  if(wd_object[i-1].type!=FREE_OBJ) { 
   if_b_opt_bgfromfile(i);update_over(i);  
   free_one_wd_object(i);
  }
 }
 return(0);
}

/****************************************
* remove wd-objects id>1 from screen
*****************************************/
int free_wd_objects_gt1()
{
 int i;
 for(i=MAX_WINDOWS;i>=2;i--) {
  if(wd_object[i-1].type!=FREE_OBJ 
     && !(wd_object[i-1].options&NO_BRING_TO_TOP)) { 
   if_b_opt_bgfromfile(i);  
   update_over(i);  
   free_one_wd_object(i);
  }
 }
 return(0);
}
/****************************************
* remove wd-objects id>1 from screen
* regardless if no_bring_to_top is on
*****************************************/
int free_wd_objects_gt1_u()
{
 int i;
 for(i=MAX_WINDOWS;i>=2;i--) {
  if(wd_object[i-1].type!=FREE_OBJ) { 
   if_b_opt_bgfromfile(i);  
   update_over(i);  
   free_one_wd_object(i);
  }
 }
 return(0);
}

/**********************************************************************
* Routines to manage the order (top, bottom) of wd_objects:
* update_over(id) 	updates vectors "object on top of another"
* update_over1(id)	subroutine of update_over
* pop_up_wanted(x,y)	returns id if wd_object at (x,y)
* get_top_card((x1,y1,x2,y2) returns top id containing (x1,y1,x2,y2) 
* get_one_under(id)
***********************************************************************/
/*************************************
* update_over
* returns: 	0=normal return
*		1=too many wd_objects
*
* this is a flip_flop, when called, each second time
* brings the object on top of the stacking order, 
* each second time it removes the object 
* from the stacking order. (Makes XOR )
*****************************************************/
int update_over(id) int id;
{
 int i,x,y,xsize,ysize;	
 unsigned long mask1,mask2,mask3,mask4;
#ifdef WINDOW_MAX_256
 unsigned long mask5,mask6,mask7,mask8;

 mask5=mask6=mask7=mask8=0;
#endif
 mask1=mask2=mask3=mask4=0;
 
 /* four mask bits limits the number of visible objects to 128 */
 if     (id<=16 && id>0)    mask1=(0x1<<(id-1));
 else if(id<=32 && id>16)   mask1=(0x10000<<(id-17));
 else if(id<=48 && id>32)   mask2=(0x1<<(id-33));
 else if(id<=64 && id>48)   mask2=(0x10000<<(id-49));
 else if(id<=80 && id>64)   mask3=(0x1<<(id-65));
 else if(id<=96 && id>80)   mask3=(0x10000<<(id-81));
 else if(id<=112 && id>96)  mask4=(0x1<<(id-97));
 else if(id<=128 && id>112) mask4=(0x10000<<(id-113));

#ifdef WINDOW_MAX_256  /* need more objects? */

 else if(id<=144 && id>128) mask5=(0x1<<(id-129));
 else if(id<=160 && id>144) mask5=(0x10000<<(id-145));
 else if(id<=176 && id>160) mask6=(0x1<<(id-161));
 else if(id<=192 && id>176) mask6=(0x10000<<(id-177));

 else if(id<=208 && id>192) mask7=(0x1<<(id-193));
 else if(id<=224 && id>208) mask7=(0x10000<<(id-209));
 else if(id<=240 && id>224) mask8=(0x1<<(id-225));
 else if(id<=256 && id>240) mask8=(0x10000<<(id-241));
 
#endif
 else return(1); 
 
 x=wd_object[id-1].xcord;
 y=wd_object[id-1].ycord; 
 xsize=wd_object[id-1].xsize;
 ysize=wd_object[id-1].ysize;
   
 /* for all other objects put mask bit on or off */ 
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ && id-1!=i) {
   if((wd_object[i].options & WINDOW_HIDDEN) ||
      (wd_object[i].options & OBJECT_NOT_PUT)) {
    /* for hidden or not put objects over1-8 has no meaning */
   }
   else { /* object is visible */
    if(! ((wd_object[i].xcord + wd_object[i].xsize <= x) ||
         (wd_object[i].xcord >= x+xsize) || 
         (wd_object[i].ycord + wd_object[i].ysize <= y) ||
         (wd_object[i].ycord >= y+ysize) )) {
      /* object is overlapping with id */

      wd_object[i].over1 ^= mask1;
      wd_object[i].over2 ^= mask2;
      wd_object[i].over3 ^= mask3;
      wd_object[i].over4 ^= mask4;
#ifdef WINDOW_MAX_256
      wd_object[i].over5 ^= mask5;
      wd_object[i].over6 ^= mask6;
      wd_object[i].over7 ^= mask7;
      wd_object[i].over8 ^= mask8;
#endif   
    }           
   }
  }
 }
 return(0);
}

int force_over(id) int id;
{
 int i,x,y,xsize,ysize;	
 unsigned long mask1,mask2,mask3,mask4;
#ifdef WINDOW_MAX_256
 unsigned long mask5,mask6,mask7,mask8;

 mask5=mask6=mask7=mask8=0;
#endif
 mask1=mask2=mask3=mask4=0;
 
 /* four mask bits limits the number of visible objects to 128 */
 if     (id<=16 && id>0)    mask1=(0x1<<(id-1));
 else if(id<=32 && id>16)   mask1=(0x10000<<(id-17));
 else if(id<=48 && id>32)   mask2=(0x1<<(id-33));
 else if(id<=64 && id>48)   mask2=(0x10000<<(id-49));
 else if(id<=80 && id>64)   mask3=(0x1<<(id-65));
 else if(id<=96 && id>80)   mask3=(0x10000<<(id-81));
 else if(id<=112 && id>96)  mask4=(0x1<<(id-97));
 else if(id<=128 && id>112) mask4=(0x10000<<(id-113));

#ifdef WINDOW_MAX_256  /* need more objects? */

 else if(id<=144 && id>128) mask5=(0x1<<(id-129));
 else if(id<=160 && id>144) mask5=(0x10000<<(id-145));
 else if(id<=176 && id>160) mask6=(0x1<<(id-161));
 else if(id<=192 && id>176) mask6=(0x10000<<(id-177));

 else if(id<=208 && id>192) mask7=(0x1<<(id-193));
 else if(id<=224 && id>208) mask7=(0x10000<<(id-209));
 else if(id<=240 && id>224) mask8=(0x1<<(id-225));
 else if(id<=256 && id>240) mask8=(0x10000<<(id-241));
 
#endif
 else return(1); 
 
 x=wd_object[id-1].xcord;
 y=wd_object[id-1].ycord; 
 xsize=wd_object[id-1].xsize;
 ysize=wd_object[id-1].ysize;
   
 /* for all other objects put mask bit on or off */ 
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ && id-1!=i) {
   if((wd_object[i].options & WINDOW_HIDDEN) ||
      (wd_object[i].options & OBJECT_NOT_PUT)) {
    /* for hidden or not put objects over1-8 has no meaning */
   }
   else { /* object is visible */
    if(! ((wd_object[i].xcord + wd_object[i].xsize <= x) ||
         (wd_object[i].xcord >= x+xsize) || 
         (wd_object[i].ycord + wd_object[i].ysize <= y) ||
         (wd_object[i].ycord >= y+ysize) )) {
      /* object is overlapping with id */

      /* or followed by xor means zero bit unconditionally */
      wd_object[i].over1 |= mask1;
      wd_object[i].over2 |= mask2;
      wd_object[i].over3 |= mask3;
      wd_object[i].over4 |= mask4;
#ifdef WINDOW_MAX_256
      wd_object[i].over5 |= mask5;
      wd_object[i].over6 |= mask6;
      wd_object[i].over7 |= mask7;
      wd_object[i].over8 |= mask8;
#endif   

      wd_object[i].over1 ^= mask1;
      wd_object[i].over2 ^= mask2;
      wd_object[i].over3 ^= mask3;
      wd_object[i].over4 ^= mask4;
#ifdef WINDOW_MAX_256
      wd_object[i].over5 ^= mask5;
      wd_object[i].over6 ^= mask6;
      wd_object[i].over7 ^= mask7;
      wd_object[i].over8 ^= mask8;
#endif   
    }           
   }
  }
 }
 return 0;
}
/************************************************
* Which wd-object should be taken up if mouse 
* is clicked at x,y? 
*************************************************/ 
int pop_up_wanted(x,y)
int x,y;
{
 int i;

 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
     && !(wd_object[i].options & WINDOW_HIDDEN)
     && !(wd_object[i].options & OBJECT_NOT_PUT))
  {
   if(x >= wd_object[i].xcord && x<= wd_object[i].xcord + wd_object[i].xsize &&
   y >= wd_object[i].ycord && y<= wd_object[i].ycord + wd_object[i].ysize)  
   {
    if(over_is_zero(i)) return(i+1);
   }
  }
 }
 return 0;
}

/************************************************
* which object is on top under given rectangle
*************************************************/ 
int get_top_card(x11,y11,x12,y12) int x11,y11,x12,y12;
{
 int i,x21,y21,x22,y22;
 	
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
  && !(wd_object[i].options & WINDOW_HIDDEN)
     && !(wd_object[i].options & OBJECT_NOT_PUT)) 
  {
   x21=wd_object[i].xcord;
   x22=wd_object[i].xcord + wd_object[i].xsize;
   y21=wd_object[i].ycord;
   y22=wd_object[i].ycord + wd_object[i].ysize;
   if(!(y11>=y22 || y21>=y12 || x11>=x22 || x21>=x12)) {
    if(over_is_zero(i))
    {
     /* in case windows overlap, return i+1 */
     return(i+1);
    }
   }
  }
 }
 return(0);	
}
int get_any_card(x11,y11,x12,y12) int x11,y11,x12,y12;
{
 int i,x21,y21,x22,y22;
 	
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
  && !(wd_object[i].options & WINDOW_HIDDEN)
     && !(wd_object[i].options & OBJECT_NOT_PUT)) 
  {
   x21=wd_object[i].xcord;
   x22=wd_object[i].xcord + wd_object[i].xsize;
   y21=wd_object[i].ycord;
   y22=wd_object[i].ycord + wd_object[i].ysize; 
   if(!(y11>=y22 || y21>=y12 || x11>=x22 || x21>=x12)) {
     /* in case windows overlap, return i+1 */
    return(i+1);
   }
  }
 }
 return(0);	
}

/******************************************************
* take a object which is on top of id and not under any 
*******************************************************/ 
int get_one_under(id)
int id;
{
 int i,x11,y11,x12,y12,x21,y21,x22,y22;
 
 i=id-1;
 x11=wd_object[i].xcord;
 x12=wd_object[i].xcord + wd_object[i].xsize;
 y11=wd_object[i].ycord;
 y12=wd_object[i].ycord + wd_object[i].ysize; 
 
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
  && !(wd_object[i].options & WINDOW_HIDDEN)
  && !(wd_object[i].options & OBJECT_NOT_PUT)  
  && i+1!=id && over_is_zero(i))
  {
   x21=wd_object[i].xcord;
   x22=wd_object[i].xcord + wd_object[i].xsize;
   y21=wd_object[i].ycord;
   y22=wd_object[i].ycord + wd_object[i].ysize;
   if(!(y11>=y22 || y21>=y12 || x11>=x22 || x21>=x12)) return(i+1);
  }
 }
 return(0);
}

/*******************************************************************
* Routines which are used to reorder objects
* bring_to_top(x,y)     		bring to top window under x,y
* any_window_under(x,y,num_under)  	check if any window is under x,y
* bring_id_to_top(id,refresh) 		brings to top a window with given id
* put_back_order(order,len) 		put the hidden windows back
* find_stacking_order(id,len,order) 	puts stacking order to order[]
* find_stacking_order_by_coord(x,y,len,order)
* subroutines of bring_to_top:
* 	draw_away(order,len) 			
* 	copy_part_of_bg(j,i,rect)		
* 	COVEREDSQUARE *update_list(covered,new,new_id) 
* 	substract_one_cover(rect,this,cur,first,new_id)
* 	make_new_rectangles(x11,y11,x12,y12,x21,y21,x22,y22,cur,new_id)
* 	COVEREDSQUARE *new_cur(x1,x2,y1,y2,id) 
*
* Playcards are moved by making a pack, moving it and breaking it:
* move_pack()		makes a pack and moves it as one wd_object
* put_pack()		breaks pack to its parts
*
********************************************************************/
/*******************************************************************
 * bring_to_top    brings to top the window visible at (x,y)
 *
 *******************************************************************/

int bring_to_top(x,y)
int x,y;
{
 int i,k,is_one_under,len=0;int order[MAX_WINDOWS];

 /* find out if anything should be taken up */
 /* any_window_under returns the id on top in the place (x,y) */
 /* and in is_one_under the number of windows in the place (x,y) */
 i=any_window_under(x,y,&is_one_under);

 /* if i is nonzero, there is a window on top at (x,y). */
 /* then the wanted window is i and it is on top */
 if(i) return i;

 /* if i=0, there is no window on top at (x,y). If is_one_under=0, there is */
 /* no window under other windows in (x,y), so return 0. No window on (x,y) */
 if(!is_one_under) return 0;
  
 /* now we know that under the point (x,y) are <is_one_under> windows */
 /* but none of them is on top */
 
 /* we still need to know which one is the one most on top */
 /* the desired one is order[len] */
 if(find_stacking_order_by_coord(x,y,&len,order)) return 0;

 /* find_stacking_order_by_coord removes from window stack all windows in */
 /* the order vector. Notice that len is the last index, that is number-1 */
 /* if len=0, how do we know there is one? Because the routine is called  */
 /* only when we know there is at least one                               */

 /* if the window we want cannot be brought to top (like with playing cards */
 if(wd_object[order[len]-1].options&NO_BRING_TO_TOP) {     	
   /* restore stacking order and return <no window here> */
  put_back_order(order,len);  
  return 0;  	
 }
 
 /* this routine copies the background of order[len] to the background of   */
 /* windows that partially cover order[len], there can be many of them      */
 /* all of them are in the order vector, just see how much each of them has */
 draw_away(order,len);

 /* restore stacking order for other than the removed window */  
 put_back_order(order,len-1);

 /* put order[len] on top of the stacking order */
 refresh_one_wd_object(order[len]);
 wd_object[order[len]-1].options ^= WINDOW_HIDDEN;
 update_over(order[len]); 

 return order[len]; 
}  
/****************************************
* check if any window is under x,y
* changed 2017 to return in *num_under
* the total number of windows under found
*****************************************/
int any_window_under(x,y,num_under) int x,y;int *num_under;
{
  int i;int found;
 
  *num_under=0;found=0;
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
  && !(wd_object[i].options & WINDOW_HIDDEN)
  && !(wd_object[i].options & OBJECT_NOT_PUT))
  {
   if(x >= wd_object[i].xcord && x< wd_object[i].xcord + wd_object[i].xsize &&
      y >= wd_object[i].ycord && y< wd_object[i].ycord + wd_object[i].ysize)  
   {
    if(over_is_zero(i)) found=i+1;
    else (*num_under)+=1;
   }
  }
 }
 return found;	
}
/*******************************************
* bring_id_to_top(id,refresh) 
*	brings to top a window with given id
*	if refresh, refreshes id
********************************************/
int bring_id_to_top(id,refresh)
int id,refresh;
{
 int i,j,len=0;
 int order[MAX_WINDOWS];     

 i=id-1;

 /* ignore free or hidden windows */
 if(wd_object[i].type==FREE_OBJ || (wd_object[i].options & WINDOW_HIDDEN))
  return 0;

 /* if id is on top, nothing to do */
 if(over_is_zero(i)) return(id);

 /* if it is not allowed to bring to top, nothing to do */
 if(wd_object[i].options & NO_BRING_TO_TOP) return 0;
 
 /* the routine removes from stack all that cover id (and more) */
 /* the window we want is order[len]                            */
 if(find_stacking_order(id,&len,order)) return 0;
 
 if(order[len]!=id) {printf("error in bring_id_to_top\n");}

 /* copy background of order[len] to windows that partically cover it */  
 draw_away(order,len);
 
 /* restore stacking order for other that order[len], that is id */
 put_back_order(order,len-1);

 /* put id to the stacking order */ 
 if(refresh) refresh_one_wd_object(id);
 wd_object[id-1].options ^= WINDOW_HIDDEN;        
 update_over(id);  
 return(id);
}
/************************************************
* subroutine of bring_to_top
*  put the hidden windows back
*************************************************/
int put_back_order(order,len) int *order;int len;
{
 int j,i;
 for(j=len;j>=0;j--) {
  i=order[j];
  wd_object[i-1].options ^= WINDOW_HIDDEN;       
  update_over(i);
 }
 return 0;
}
/************************************************
* the routine returns vector order where all
* window ids up to the given id <id> are in the
* stacking order (that is first coming is on top)
* *len gives the length of order
* returns 0 on success, 1 on error
*************************************************/
int find_stacking_order(id,len,order) int id;int *len,*order;
{
 int i,found;

 if(id<=0 || id>MAX_WINDOWS) { 
  illegal_pointer(311);
  printf("find_stacking_order: invalid id=%d\n",id);
  return 1;
 }
 if(wd_object[id-1].type==FREE_OBJ) {
  illegal_pointer(312); 
  printf("find_stacking_order: id=%d is free\n",id);
  return 1;
 }
 if(wd_object[id-1].options & OBJECT_NOT_PUT) { 
  illegal_pointer(313);
  printf("find_stacking_order: id=%d is not put\n",id);
  return 1;
 }
 	
 *len=*order=0;
 while(1) {
  found=0;
  /* each time there must be some window on top */
  /* we remove so many windows from the stacking order that finally */
  /* id is on top */
  for(i=0;i<MAX_WINDOWS;i++) {
   if(wd_object[i].type!=FREE_OBJ 
      && !(wd_object[i].options & WINDOW_HIDDEN)
      && !(wd_object[i].options & OBJECT_NOT_PUT) 
      && over_is_zero(i)) 
   {
    found=1;
    wd_object[i].options ^= WINDOW_HIDDEN; /* hide the window */
    update_over(i+1);           /* remove from stacking order */ 
    order[*len]=i+1;            /* store to order vector      */
    if(i==id-1) return 0;
    break;
   }
  }
  if(!found) break; /* not a single window on top on this round */
  *len+=1;
 }
 /* we have removed all that were on top, but did not find id */
 /* id is in the range, not free, it is put, so what can be?  */
 /* only it either is hidden or does not come on top          */ 
 if(wd_object[id-1].options & WINDOW_HIDDEN) {
  illegal_pointer(314);
  printf("find_stacking_order: id=%d is hidden\n",id);
 }
 /* it may be possible to recover from this error */
 /* let there be in order what there so far is    */
 /* we add id as the last to order                */
 force_over(id);     /* remove id unconditionally from stack */
 *len+=1;
 order[*len]=id;     /* store as last to the order vector */
 return 0;
}
/*********************************************************
* returns in order[] a list of window ids what were higher
* on stacking order than the one visible at (x,y). The one
* visible at (x,y) is order[len]. Remember to put back the
* stacking order by put_back_order(order,len);
* returns 0 on success, 1 on error
**********************************************************/
int find_stacking_order_by_coord(x,y,len,order) int x,y;int *len,*order;
{
 int i,found;
 	
 *len=0;
 while(1) {
  found=0;
  /* each time there must be at least some window on top somewhere */
  for(i=0;i<MAX_WINDOWS;i++) {
   if(wd_object[i].type!=FREE_OBJ 
      && !(wd_object[i].options & WINDOW_HIDDEN)
      && !(wd_object[i].options & OBJECT_NOT_PUT)      
      && over_is_zero(i)) 
   {
     /* the routine removes a top window and checks if it is at (x,y) */
    found=1;
    wd_object[i].options ^= WINDOW_HIDDEN;      
    update_over(i+1);
    order[*len]=i+1;   
    if(x >= wd_object[i].xcord && x< wd_object[i].xcord + wd_object[i].xsize &&
       y >= wd_object[i].ycord && y< wd_object[i].ycord + wd_object[i].ysize){
   /* when we get here, order has a list of windows that were removed from*/
   /* the stacking order. The first one on (x,y) is the one visible at (x,y)*/
   /* it is the one we want */ 
     return 0; /* success */
    }
    break; /* find one, remove from stacking order, find next in while loop */
   }
  }
  if(!found) {
    /* how could we get here? Only by calling the routine without knowing */
    /* that there is a window at (x,y), that is wrong usage */
   illegal_pointer(32);
   printf("find_stacking_order_by_coord, could not find a window at (x,y)\n");
   return 1;
  }
  /* at while loop, increase the length of order vector */
  *len+=1;
  if(*len>MAX_WINDOWS) {illegal_pointer(33);return 0;}      
 }	
 return 1; /* you should not call this routine if no window at (x,y) */ 
}


/************************************''''''''''******************
* subroutine of bring_to_top
*
* draw_away order(order,len)
*
* The routine removes window with the id order[len] 
* from the backgrounds of partially covering windows 
* without needing to swap backgrounds and foregrounds of 
* two closest windows and then eventually get the desired 
* window up. (We cannot do this since foregrounds are not saved.)
* 
* The solution is to make a list of rectangles that partially 
* cover the window at order[len]. The list contains rectangles
* that overlap window order[len] and they are ordered
* from lowest to highest in the stacking order.  
* After the list is made, parts of background of order[len] is
* copied to the background of order[i], i=len-1,...,0.  
******************************************************************/
int draw_away(order,len) int *order;int len;
{
 int i,j,k;
 int x11,x12,y11,y12,x21,x22,y21,y22;
 COVEREDSQUARE *covered,*new,*last;int count;
 
 i=order[len]-1; 
 if_b_opt_bgfromfile(i+1);

 /* this is the square we want to be taken away */
 x11= wd_object[i].xcord;
 x12= wd_object[i].xcord+wd_object[i].xsize;
 y11= wd_object[i].ycord; 
 y12= wd_object[i].ycord+wd_object[i].ysize;
  	
 covered=last=new_cur(0,0,0,0,1);/* last is in the end of covered */

 /* start from the id that was most covered by other windows     */
 /* and work backwards to the ones not covered by other windows  */
 for(k=len-1;k>=0;k--) {
  j=order[k]-1;
  x21= wd_object[j].xcord;
  x22= wd_object[j].xcord+wd_object[j].xsize;
  y21= wd_object[j].ycord; 
  y22= wd_object[j].ycord+wd_object[j].ysize; 	
    
  /* check if this window partially covers the square we want to remove */
  if(x21>=x12 || x11>=x22 || y21>=y12 || y11>=y22) {;}
  else { 
   /* yes, it partially covers, store the covered part to a list */
   new=new_cur(0,0,0,0,j+1);  
   new->x1=(x11>x21?x11:x21);
   new->x2=(x12<x22?x12:x22);  
   new->y1=(y11>y21?y11:y21);
   new->y2=(y12<y22?y12:y22);
   last->next=update_list(covered,new,j+1);/* append result to last */
   for(count=0;last->next;last=last->next,count++) { /* run last to end */
    if(count>1000) {
     printf("draw_away: probably an error, so many windows \n");
     if('q'==getch()) break;count=0;
    }
   }
  }
 }
 /* now <covered->next> contains a linked list where background parts are
    visible from the corresponding window */
    
 /* copy parts of background from id to new */
 for(new=covered->next;new;new=new->next) 
  copy_part_of_bg(new->cover_id-1,i,new);

 if_b_opt_bgtofile(i+1);
 
 for(new=covered;new;new=covered) {covered=new->next;b_free(new);} 
 return 0;   
}
/********************************************
* subroutine of bring_to_top
* copy part of background buffer
*********************************************/
int copy_part_of_bg(j,i,rect) int i,j;COVEREDSQUARE *rect;
{
 int x11,x12,y11,y12,x21,x22,y21,y22,x31,x32,y31,y32;	
 int cplane,y,off1,off2,n;	
 char *bg1,*bg2,*savebg1,*savebg2;
 	
 if_b_opt_bgfromfile(j+1);
 bg1= wd_object[i].background;
 bg2= wd_object[j].background;  

 x31=rect->x1;x32=rect->x2;y31=rect->y1;y32=rect->y2;  
 x11= wd_object[i].xcord;y11= wd_object[i].ycord; 
 x21= wd_object[j].xcord;y21= wd_object[j].ycord; 

 bg1 += (y31-y11)*wd_object[i].isize;  
 bg2 += (y31-y21)*wd_object[j].isize;   
 off1= x31-x11;off2= x31-x21;
 bg1 += (off1>>3);off1 &= 7;
 bg2 += (off2>>3);off2 &= 7;n= x32-x31;

 for(y=y31;y<y32;y++){
  savebg1=bg1;
  savebg2=bg2;   	
  for(cplane=0;cplane<4;cplane++) {
   bitcpy(bg2,bg1,off2,off1,n);
   bg1 += wd_object[i].clength;  
   bg2 += wd_object[j].clength;       
  }
  bg1=savebg1;
  bg2=savebg2;  
  bg1 += wd_object[i].isize;  
  bg2 += wd_object[j].isize;    
 }
 save_buf2(x11,y11,x31-x11,y31-y11,x32-x11,y32-y11,x11&7,
 	wd_object[i].clength,wd_object[i].isize,wd_object[i].background); 

 if_b_opt_bgtofile(j+1);   	
 return 0;
}
/**************************************************
* subroutine of bring_to_top
* COVEREDSQUARE *update_list(covered,new,new_id)
* List <covered->next> contains rectangles. 
* A <new> window with id <new_id> intersects draw_window at 
* a rectangle R=(new->x1, new->y1,new->x2,new->y2).
* The new window is on top of all windows in the list <covered>. 
* Any subrectangle of R which is in the list <covered->next>
* is covered by a previous window and any subrectangle of R that 
* remains (is not covered by <covered->next>) is covered by <new_id>.
* The routine returns the list of all remaining rectangles of <new>. 
****************************************************************/
COVEREDSQUARE *update_list(covered,new,new_id)
COVEREDSQUARE *covered,*new;
int new_id;
{
 COVEREDSQUARE *rect,*this,*next,*cur,*first;

 cur=new_cur(0,0,0,0,1);first=new_cur(0,0,0,0,1);/* headers */
 if(!cur || !first) return 0;

 this=new;
 for(rect=covered->next;rect;rect=rect->next) {
  cur->next=first->next=0;
  substract_one_cover(rect,this,cur,first,new_id);
  this=first->next;
 }
 b_free(cur);b_free(first);
 return this; 
}

/**************************************************
* subroutine of bring_to_top
* the routine returns in <first->next> a list where
* rect has been substracted from all rectangles in
* the list <this>
* <cur> is only a header which we do not want to allocate many times.
****************************************************/
int  substract_one_cover(rect,this,cur,first,new_id)
COVEREDSQUARE *rect,*this,*cur,*first;
int new_id;
{
 COVEREDSQUARE *next,*old;
 int x11,x12,y11,y12;
 int x21,x22,y21,y22;
  
 x21=rect->x1;
 x22=rect->x2;
 y21=rect->y1;
 y22=rect->y2;
   
 next=first;

 /* there is a list <this> which contains rectangles */
 while(this) {
  x11=this->x1;
  x12=this->x2;
  y11=this->y1;
  y12=this->y2;

  /* substracting <rect> from one rectangle (x21,y21,x22,y22) of this
  /* produces another list <cur->next> */
  cur->next=0; 
  make_new_rectangles(x11,y11,x12,y12, x21,y21,x22,y22,cur,new_id);

  /* we free the rectangle (x21,y21,x22,y22) of this */
  old=this;this=this->next;b_free(old);

  next->next=cur->next; /* and put cur->next to the end of list <next> */
  for(;next->next;next=next->next);
 }
 
 /* now <first->next> contains the result */
 return 0;
}
/**********************************************************
* subroutine of bring_to_top
* this routine continues linked list cur and the list will
* contain first the empty starting cur by which this is called,
* then 0-4 rectangles by which x11,y11,x12,y12 and x21,y21,x22,y22
* intersect, the rectangle 2 (x2*,y2*) is substracted.
************************************************************/
int make_new_rectangles(x11,y11,x12,y12,x21,y21,x22,y22,cur,new_id)
int x11,y11,x12,y12,x21,y21,x22,y22;
COVEREDSQUARE *cur;int new_id;
{
 if(x21>=x12 || x11>=x22 || y21>=y12 || y11>=y22) {
  cur->next=new_cur(x11,x12,y11,y12,new_id);/*do not substract anything */
  return 0;
 }
 if(x11<x21 && x12>x22 && y11>=y21 && y12>y22) {
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x22,y22,y12,new_id);cur=cur->next;
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;     
 }
 else if(x11<x21 && x12>x22 && y11>=y21 && y12<=y22) {
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;            	
 }
 else if(x11<x21 && x12>x22 && y11<y21 && y12>y22) {
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x22,y22,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x22,y11,y21,new_id);cur=cur->next;     
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;       	
 }
 else if(x11<x21 && x12>x22 && y11<y21 && y12<=y22) {
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x22,y11,y21,new_id);cur=cur->next;     
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;              	
 }
 else if(x11<x21 && x12<=x22 && y11>=y21 && y12>y22) {  
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x12,y22,y12,new_id);cur=cur->next;              	
 }
 else if(x11<x21 && x12<=x22 && y11>=y21 && y12<=y22) {
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
 }    
 else if(x11<x21 && x12<=x22 && y11<y21 && y12>y22) {  
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x12,y22,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x12,y11,y21,new_id);cur=cur->next;     
 }
 else if(x11<x21 && x12<=x22 && y11<y21 && y12<=y22) {  
  cur->next=new_cur(x11,x21,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x21,x12,y11,y21,new_id);cur=cur->next;     
 }
 else if(x11>=x21 && x12>x22 && y11>=y21 && y12>y22) {   
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x11,x22,y22,y12,new_id);cur=cur->next;
 }
 else if(x11>=x21 && x12>x22 && y11>=y21 && y12<=y22) {  
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;              	
 }
 else if(x11>=x21 && x12>x22 && y11<y21 && y12>y22) {   
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x11,x22,y22,y12,new_id);cur=cur->next;
  cur->next=new_cur(x11,x22,y11,y21,new_id);cur=cur->next;              	
 }
 else if(x11>=x21 && x12>x22 && y11<y21 && y12<=y22) {
  cur->next=new_cur(x22,x12,y11,y12,new_id);cur=cur->next;
  cur->next=new_cur(x11,x22,y11,y21,new_id);cur=cur->next;
 }
 else if(x11>=x21 && x12<=x22 && y11>=y21 && y12>y22) {   
  cur->next=new_cur(x11,x12,y22,y12,new_id);cur=cur->next;
 }
 else if(x11>=x21 && x12<=x22 && y11>=y21 && y12<=y22) {
  /* whole square covered */;
 }
 else if(x11>=x21 && x12<=x22 && y11<y21 && y12>y22) {   
  cur->next=new_cur(x11,x12,y11,y21,new_id);cur=cur->next;
  cur->next=new_cur(x11,x12,y22,y12,new_id);cur=cur->next;     
 }
 else if(x11>=x21 && x12<=x22 && y11<y21 && y12<=y22) {   
  cur->next=new_cur(x11,x12,y11,y21,new_id);cur=cur->next;               	
 }
 return 1;
}
/*****************************************
* subroutine of bring_to_top
******************************************/   
COVEREDSQUARE *new_cur(x1,x2,y1,y2,id)
{
 COVEREDSQUARE *cur;
 cur=(COVEREDSQUARE *)balloc(sizeof(COVEREDSQUARE));
 if(!cur) {no_memory();exit(1);}
 cur->x1=x1;
 cur->y1=y1;        
 cur->x2=x2;
 cur->y2=y2;
 cur->cover_id=id;
 cur->next=0;
 return cur;
}

/*********************************************************
* in order to lift up a pack of cards make a combined
* card which can be moved with movingPicture as any
* ordinary wd-object.
* move_pack hides and removes from stacking all cards 
* that are to be moved, including newcard for a pack move.
* if move_card returns 0, no cards are hidden or removed
* from stacking order.
**********************************************************/ 
int move_pack(x,y,order,max,control,newid)
int x,y;
int *order;
int *max;
int control;
int newid;
{
 int i,j,k,k1,found,previ;
 char *buf1,*buf2;
 int any_object_under[MAX_WINDOWS];
 int x1,y1,x2,y2;
 
 *max= -1;k= -1;
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ 
  && !(wd_object[i].options & WINDOW_HIDDEN)
  && !(wd_object[i].options & OBJECT_NOT_PUT))
  {
   if(x >= wd_object[i].xcord && 
      x<= wd_object[i].xcord + wd_object[i].xsize &&
      y >= wd_object[i].ycord && 
      y<= wd_object[i].ycord + wd_object[i].ysize)  
   {
    if(over_is_zero(i)) { /* if the item we point at is on top */
     wd_object[i].options ^= WINDOW_HIDDEN; /* hide it */
     update_over(i+1);     /* remove it from stacking order */
     return(i+1);          /* give it to be moved */
    }
    any_object_under[++k]=i+1;
   }
  }
 }
 if(k== -1 || control) return 0;
 /* k is the total number of all cards at the coordinates x,y */

 /* cards in any_object_under[] are not removed from the stacking order */
 /* and they are not hidden */

 j= -1;
 i=previ=0;

 x1=x;
 y1=y;
 x2=x+1;
 y2=y+13*YDIF;
 /* 13*YDIF comes from the fact that can't lift more than a suite */

 /* This loop orders windows by over, that is top card comes first.        */
 /* Which ever card comes on first top and equals one of the objects under */
 /* x,y, then it is the highest window under the coordinates x,y           */  
 found=0;
 while(1) {
  i=get_top_card(x1,y1,x2,y2);
  if(!i) break;
  /* remove the top card from the stacking order */
  wd_object[i-1].options ^= WINDOW_HIDDEN;     
  update_over(i);
  order[++j]=i;
  /* check if i is under x,y */
  for(k1=0,found=0;k1<=k;k1++) { 
   if(i==any_object_under[k1]) {found=1;break;}
  }
  if(found) break;
  if(i==previ) {illegal_pointer(17);break;}
  previ=i;  
 }
 *max=j;
 if(j== -1) {
  printf("move_pack: error, j== -1\n");
  /* this means that the stacking order is corrupted. */
  /* no card is on top */
  /* we will fix this error for solitaire             */
  fix_order(x);
  /* next time the user tries, the pile is fixed */
  return 0;
 }
 /* cards in the pack to move are now removed from stacking order  */
 /* other cards on x1,y1,x2,y2 are not removed from stacking order */

 i=newid-1;
 wd_object[i].type=CARD_OBJ;
 wd_object[i].options=NO_FLIPPING_OVER | WINDOW_HIDDEN;   
 wd_object[i].xcord=wd_object[order[j]-1].xcord;
 wd_object[i].xsize=wd_object[order[j]-1].xsize;
 wd_object[i].ycord=wd_object[order[j]-1].ycord;
 wd_object[i].ysize=YSIZE+YDIF*j; 
 wd_object[i].clength=wd_object[order[j]-1].clength; 
 wd_object[i].isize=ISIZE;  
 wd_object[i].ylength=wd_object[i].ysize; 
 zero_over(i);    
 wd_object[i].p2=(char **)tplane1;   	
 wd_object[i].foreground=fgbuffer;  
 wd_object[i].background=
   balloc((long)(wd_object[i].ysize)*ISIZE);

 buf1=wd_object[i].background;
 if(!buf1) {no_memory();return(0);}
 if(if_b_opt_bgfromfile(order[j])>0) return(0);
 buf2=wd_object[order[j]-1].background; 
 
 for(k1=0;k1<YSIZE;k1++) { /* size of buf1 must be >= YSIZE*ISIZE */
  memcpy(buf1,buf2,ISIZE);
  buf1 += ISIZE;buf2 += ISIZE; 
 }
 if_b_opt_bgtofile(order[j]); 
 j--;                      
 for(;j>=0;j--) {/* from j= *max-1 to 0 is *max times */
  if(if_b_opt_bgfromfile(order[j])>0) return(0); 	
  buf2=wd_object[order[j]-1].background;
  buf2 += ISIZE*(YSIZE-YDIF); 
  for(k1=0;k1<YDIF;k1++) { /* copies (*max)*YDIF*ISIZE bytes to buf1 */
   memcpy(buf1,buf2,ISIZE);  	
   buf1 += ISIZE;buf2 += ISIZE;
  }
  if_b_opt_bgtofile(order[j]);  
 } 
 /* buf1 size must be YSIZE*ISIZE+(*max)*YDIF*ISIZE           */
 /* =(YSIZE+(*max)*YDIF)*ISIZE=wd_object[newid-1].ysize*ISIZE */

 /* newid was made here, it is not hidden */
 /* and it is not in the stacking order   */

 return(newid);
 
}
/**************************************************
* put pack of cards down and and make them 
* again separate objects, destroy the combined card
***************************************************/ 
void put_pack(max,order,newid) int max;int *order;int newid;
{   
 int i,j,k1;
 char *buf1,*buf2;
 
 if(max<0 || max>13 || newid!=MAX_WINDOWS || !wd_object[newid-1].background){
  illegal_pointer(15);
  printf("put_pack: error, max=%d newid=%d wd_object[newid-1].background=%d\n",   max,newid,(int)wd_object[newid-1].background);
  return;}

 for(j=0;j<=max;j++) {
  if(order[j]<2 || order[j]>DECK_SIZE+1) {illegal_pointer(16);return;}
 }
 j=max;i=newid-1;  
 buf1=wd_object[i].background;
 if(if_b_opt_bgfromfile(order[j])>0) return;
 buf2=wd_object[order[j]-1].background; 
 
 for(k1=0;k1<YSIZE;k1++) {
  memcpy(buf2,buf1,ISIZE);
  buf1 += ISIZE;buf2 += ISIZE; 
 }
 if_b_opt_bgtofile(order[j]); 
 j--;
 for(;j>=0;j--) {
  if(if_b_opt_bgfromfile(order[j])>0) return;  
  buf2=wd_object[order[j]-1].background;
  buf2 += ISIZE*(YSIZE-YDIF); 
  for(k1=0;k1<YDIF;k1++) {
   memcpy(buf2,buf1,ISIZE);  	
   buf1 += ISIZE;buf2 += ISIZE;
  }
  if_b_opt_bgtofile(order[j]);  
 } 

 /* Coming here all order[j] are hidden and removed from stacking order. */
 /* only order[max] has correct xcord and ycord, other order[j] have old */
 /* coordinate values. */

 for(j=max;j>=0;j--) {
  i=order[j];
  wd_object[i-1].xcord=wd_object[newid-1].xcord;
  wd_object[i-1].ycord=wd_object[newid-1].ycord+(max-j)*YDIF;

  /* just a test for errors */
  if(!(wd_object[i-1].options&WINDOW_HIDDEN))
    printf("put_pack:error, window %d not hidden\n",i);
  else {
   wd_object[i-1].options ^= WINDOW_HIDDEN;
   update_over(i);
  }
 }
 wd_object[newid-1].type=FREE_OBJ; 
 if(wd_object[newid-1].background) {
  b_free(wd_object[newid-1].background);
  wd_object[newid-1].background=0;
 }
}

int zero_over(i) int i;
{
 wd_object[i].over1=0;
 wd_object[i].over2=0;
 wd_object[i].over3=0;
 wd_object[i].over4=0;
#ifdef WINDOW_MAX_256
 wd_object[i].over5=0;
 wd_object[i].over6=0;
 wd_object[i].over7=0;
 wd_object[i].over8=0;
#endif 
 return 0;  	 
}

int over_is_zero(i) int i;
{
 if(wd_object[i].over1) return 0;
 if(wd_object[i].over2) return 0;
 if(wd_object[i].over3) return 0;
 if(wd_object[i].over4) return 0;
#ifdef WINDOW_MAX_256
 if(wd_object[i].over5) return 0;
 if(wd_object[i].over6) return 0;
 if(wd_object[i].over7) return 0;
 if(wd_object[i].over8) return 0;
#endif 
 return 1;  	 
}

/*************************************************************************
 * find_stacking_order_by_coord_to_len1(x,y,len,order,len1) 
 * This differs from find_stacking_order_by_coord
 * in the aspect that this routine puts to order len1 
 * windows under the x,y, provided that they exist.
 * After this routine call put_back_order
 * Notice that this routine gives len as one higher than
 * find_stacking_order_by_coord  
 * This is not a general purpose routine:
 * it assumes that each time there must be one window on top at (x,y) 
 * this is not in general true of windows, since window could be partially 
 * under a window that does not reach to (x,y) 
 *************************************************************************/
int find_stacking_order_by_coord_to_len1(x,y,len,order3,len1) 
int x,y;int *len,*order3;int len1;
{
 int i,j,found,y1;

 *len=0;

 while(1) {

  found=0;
  for(i=0;i<MAX_WINDOWS;i++) {
    /* if a visible vindow */
   if(wd_object[i].type!=FREE_OBJ && 
      !(wd_object[i].options & WINDOW_HIDDEN) && 
      !(wd_object[i].options & OBJECT_NOT_PUT))
   {      
     /* is under (x,y) */ 
    if(x >= wd_object[i].xcord && 
       x< wd_object[i].xcord + wd_object[i].xsize &&
       y >= wd_object[i].ycord && 
       y< wd_object[i].ycord + wd_object[i].ysize)
    {  
     /* and is on top, we assume that there must be exactly one such */
     if(over_is_zero(i)) 
     {
      found=1;                              /* found one such */
      wd_object[i].options ^= WINDOW_HIDDEN;/* hide it */
      update_over(i+1);   /* remove it from stacking order */
      order3[*len]=i+1;   /* store the id  to the order vector */
      *len+=1;
      if(*len>=len1) return 0; /* maximum depth reached */
     }
    }
   }
  }
  /* still not found, it may be a long pack */
  /* we will do a very solitaire specific thing */ 
  y1=YPOS+13*YDIF;
  for(i=0;i<MAX_WINDOWS;i++) {
    /* if a visible vindow */
   if(wd_object[i].type!=FREE_OBJ && 
      !(wd_object[i].options & WINDOW_HIDDEN) && 
      !(wd_object[i].options & OBJECT_NOT_PUT))
   {      
     /* is under x and y is between YPOS, YPOS+(13- *len)*YDIF */ 
    if(x >= wd_object[i].xcord && 
       x < wd_object[i].xcord + wd_object[i].xsize &&
    YPOS <= wd_object[i].ycord &&
      y1 >= wd_object[i].ycord)
    {  
     /* and is on top, we assume that there must be exactly one such */
     if(over_is_zero(i)) 
     {
      found=1;                              /* found one such */
      wd_object[i].options ^= WINDOW_HIDDEN;/* hide it */
      update_over(i+1);   /* remove it from stacking order */
      order3[*len]=i+1;   /* store the id  to the order vector */
      *len+=1;
      y1-=YDIF;
      if(*len>=len1) return 0; /* maximum depth reached */
     }
    }
   }
  }
  if(!found) return 0; /* all visible windows under (x,y) are made hidden */
 }
 return 0;
}

int fix_order(x) int x;
{
 int i,j,maxy,maxi,found,order2[52];
 
 printf("fix_order:this is an error but recovering\n");
 j=0;
 while(1) {

  /* each time pick up card that is larger on y-dimension */
  found=0;maxy=-1;maxi=-1;
  for(i=0;i<MAX_WINDOWS;i++) {
   if(wd_object[i].type==CARD_OBJ &&
    x >= wd_object[i].xcord && 
    x <= wd_object[i].xcord + wd_object[i].xsize &&
      wd_object[i].ycord>=100) /* YPOS=100 */
   {
    if(wd_object[i].ycord>maxy) {
     maxy=wd_object[i].ycord;
     maxi=i;
     found=1;
    }
   }
  }
  if(!found) break;
  /* found=1 and the largest ycord has maxi */
  wd_object[maxi].type=FREE_OBJ;
  wd_object[maxi].options|=WINDOW_HIDDEN;
  zero_over(maxi);
  order2[j]=maxi;j++;
 }
 if(!j) return 0; /* no cards on this x-coordinate */
 j--;
 /* put the windows back in reverse order */
 printf("fix_order:putting cards back\n");
 for(;j>=0;j--) {
  i=order2[j];
  wd_object[i].type=CARD_OBJ;  
  wd_object[i].options-=WINDOW_HIDDEN;
  update_over(i+1);
 }
 return 0;
}
