/***************************************
* MODULE:   G6.C  
* FUNCTION: Routines for a 3-dimensional 
*	    picture editor 
* AUTHOR:   Jorma Jormakka
* DATE:     23.7.92
****************************************/
#include "x.ext"
#include "win.ext"
#define C_ONE_LINE /* use C-routines instead of assembly */
extern int gplanes;
void draw3dim();
extern void point_to_fn2();
void rotate_angle(),step_angle();
void decode_header(),code_header();
unsigned char code_mask();
void decode_mask();
/**************************************
* draw3dim is the routine for drawing a
* 3-dimensional picture in this simple
* representation.
***************************************/
void draw3dim(planea,buf1,cos_c,sin_c,cos_a,sin_a,psize,qsize,x,y,xsize,ysize)
unsigned char *planea;
char *buf1;
long cos_c,sin_c,cos_a,sin_a;
int psize,qsize,x,y,xsize,ysize;
{
 register int i;
 char *buf; 
 unsigned char *plane,*planesave;

 int X1last,Z1last;
 long X,Z,Y;
 int k,X1,Y1,Z1;
 int X3,color,xoff,zoff,length;
 long X2,Z2,Y2;
 unsigned char m1,m2,m3,m4;
 int clength,isize;
 
 clength=xsize/8+1;isize=gplanes*clength;
 
 X2= 140+(100*sin_a-140*cos_a)/2048;
 Z2= (25*cos_a+35*sin_a)/512;
 Y2= 100-((Z2*cos_c)+(25*sin_c))/2048;   
 
 if(bgcol&8) m1=0xff; else m1=0;  
 if(bgcol&4) m2=0xff; else m2=0;  
 if(bgcol&2) m3=0xff; else m3=0;  
 if(bgcol&1) m4=0xff; else m4=0;  
    
 for(buf=buf1,k=0;k<ysize;k++) {
  for(i=0;i<clength;i++) {*buf=m1;buf++;}
  for(i=0;i<clength;i++) {*buf=m2;buf++;}
  for(i=0;i<clength;i++) {*buf=m3;buf++;}
  for(i=0;i<clength;i++) {*buf=m4;buf++;}      
 }

 plane=planea+(psize-1)*qsize;
 for(k=psize-1;k>=0;k--) {
  planesave=plane;
  while((*plane)&0x80) {
   decode_header(&length,&X,&Z,plane);plane+=4;   
   
#ifndef C_ONE_LINE

   one_line((int)cos_a,(int)sin_a,(int)cos_c,(int)sin_c,
	(int)X2,(int)Y2,(int)X,(int)Z,k,length,plane,buf1);
   plane += length;

#else
   for(i=length;i>0;i--) {
    color=0x0f & (*plane);

    X1=((X*cos_a-Z*sin_a)>>11)+X2; 
    Z1=(Z*cos_a+X*sin_a)>>11;  
    Y1=((Z1*cos_c+k*sin_c)>>11)+Y2;

    if(i==length) {X1last=X1;Z1last=Z1;}
    
    if(*(plane)&0x80) color ^=2;
    if(X1<X1last) color ^= 8; 
    if(Z1>Z1last) color ^= 1;

    if(X1last<X1) { 
     for(X3=X1last+1;X3<=X1;X3++)        
     point_to_fn2(X3,Y1,color,clength,isize,buf1);
    }
    else {
     for(X3=X1;X3<=X1last;X3++)        
     point_to_fn2(X3,Y1,color,clength,isize,buf1);    	
    }
    decode_mask((*plane)&0x70,&xoff,&zoff);    
    X=X+xoff;Z=Z+zoff;        
    X1last=X1;Z1last=Z1;
    plane++;
   }
#endif   
  }
  plane=planesave;
  plane -= qsize;
 }
 draw_buf2(x,y,0,0,xsize,ysize,x%8,clength,isize,buf1);
}

/****************************************
* subroutine of draw3dim
*****************************************/
void rotate_angle(angle_i,cosx,sinx)
int angle_i;
long *cosx,*sinx;
{
 register int i;
 long cos_sum,sin_sum;

 *cosx=2048;*sinx=0;
 
 /* more precisely should be
  COSB/(*cosx)=0.996917333733120;
  SINB/(*cosx)=0.078459095727844;
 */ 
     
 for(i=0;i<angle_i;i++) {
  cos_sum= ((*cosx)*COSB-(*sinx)*SINB)/2048;
  sin_sum=((*sinx)*COSB+(*cosx)*SINB)/2048;
  *cosx=cos_sum;*sinx=sin_sum;     
 }
}
/****************************************
* subroutine of draw3dim
*****************************************/
void step_angle(cosx,sinx,dir) long *cosx,*sinx;int dir;
{
 long cos_sum,sin_sum;

 cos_sum= ((*cosx)*COSB-dir*(*sinx)*SINB)/2048;
 sin_sum=((*sinx)*COSB+dir*(*cosx)*SINB)/2048;
 *cosx=cos_sum;*sinx=sin_sum;     
}

/************************************
* loading and saving the drawings
*************************************/
int load_drawing(i) int i;
{
 register int j;
 FILE *stream;
 char line5[4],*buf3;
 int number1,number2;

 stream=fopen(wd_object[i].name,"rb+"); 	
 if (!stream) {return(1);}
  
 fseek(stream,0,0);	   	
 fread(line5,1,4,stream);
 memcpy((unsigned char *)&number2,line5,2);
 memcpy((unsigned char *)&number1,&line5[2],2);
 
 if(number1>wd_object[i].i1)  number1=wd_object[i].i1;  
 buf3=wd_object[i].p1; 
 for(j=0;j<number1;j++) {
  fread(buf3,1,(long)number2,stream);
  buf3 += (long)number2;
 }
 fclose(stream);
 return 0;
}
int save_drawing(i) int i;
{
 register int j;
 FILE *stream;
 unsigned char line5[4];
 char *buf3;
 int number1,number2;
 
 stream=fopen(wd_object[i].name,"rb+"); 	 
 if (!stream)
 {  
  stream=fopen(wd_object[i].name,"wb+");
  if(!stream) cannot_create_file(wd_object[i].name);
  return 1;
 } 
 fseek(stream,0,0);
 number1=wd_object[i].i1;
 number2=wd_object[i].i2; 
 memcpy(line5,(char *)&number2,2);
 memcpy(&line5[2],(char *)&number1,2); 
 fwrite(line5,1,4,stream);
 buf3=wd_object[i].p1; 
 for(j=0;j<number1;j++) {
  fwrite(buf3,1,(long)number2,stream);
  buf3 += (long)number2;
 } 	   	
 fclose(stream);
 return 0;
}

/*****************************************
* the images are expressed with structures
* containing mask and header
******************************************/
unsigned char code_mask(xoff,zoff)
int xoff,zoff;
{
 unsigned char mask;
 
 mask=0; 	
 if(zoff>0) 			mask |= 0x10;
 if(xoff>0) {			mask |= 0x40;
   if(!zoff) 			mask |= 0x10;
   else				mask |= 0x20;}
 else if (!xoff) {if(zoff<0)	mask |= 0x40;}
 else { if(zoff>=0) 		mask |= 0x20;}

 return(mask);
}
void decode_mask(mask,xoff,zoff)
unsigned char mask;
int *xoff,*zoff;
{
 if(mask&0x10) 	{ *zoff=  1;if(mask==0x50) *zoff=0;}
 else		{ *zoff= -1;if(mask==0x20) *zoff=0;}
 if(mask&0x40) 	{ *xoff=  1;if(mask==0x40) *xoff=0;}
 else		{ *xoff= -1;if(mask==0x10) *xoff=0;}       
}

void code_header(planea,j,i,x,z)
unsigned char *planea;
int j,i,x,z;
{
 unsigned char *plane;
 	
 plane=planea+QSIZE*j+i;
 
 *plane=0x80;
 /*
 *(plane) |= (0xc&((x>>8)<<2));
 *(plane) |= (0x30&((z>>8)<<4)); 
 */
 plane++;    	
 *plane= 0xff & x;plane++;
 *plane= 0xff & z;
}
void decode_header(length,x,z,plane)
int *length,*x,*z;
unsigned char *plane;
{
 *length=0x3&(*plane);
/* *x=0x3&((*plane)>>2);
 *z=0x3&((*plane)>>4);*/
 plane++;
 /*
 *x=((*x)<<8)|(0xff&(*plane));plane++;
 *z=((*z)<<8)|(0xff&(*plane));plane++;
 */
 *x=0xff&(*plane);plane++;
 *z=0xff&(*plane);plane++;
 *length=((*length)<<8)|(0xff&(*plane));  
}
