/***************************************
* MODULE:   G6C.C  
* FUNCTION: Routines for a 3-dimensional 
*	    picture editor, 
*	    c-language versions 
* AUTHOR:   Jorma Jormakka
* DATE:     23.7.92
****************************************/
#include <stdio.h>
#include <string.h>
#include "x.ext"
#include "text.ext"
#include "win.ext"

/*#define C_POINT_TO_FN2*/
#define C_POINT_FROM_FN2

extern int gplanes;
#ifndef DOS_SYSTEM
extern XColor   *xcolor;
#endif

#ifdef C_POINT_TO_FN2
/* puts a color */
int point_to_fn2(x,y,color,clength,isize,buf1)
int x,y,color,clength,isize;
char *buf1;
{
 int  pcol,lim;
 unsigned char bit,bit1; 
 char *buf;
 int bitnumber;
 unsigned log pixel;

 pixel=xcolor[color].pixel;

 buf=buf1+(long)(y*isize+x/8);
 bitnumber=7-(x%8);
 bit= (0x1<<bitnumber);
 bit1=0xff^bit;
  
 lim=(1<<(gplanes-1));  
 for(pcol=lim;pcol>0;pcol = (pcol>>1)) {
  if(pixel & pcol)  *buf |= bit;
  else *buf &= bit1; 
  buf += clength;
 }      
}
#endif
/* put a pixel */
int point_to_fn2b(x,y,pixel,clength,isize,buf1)
int x,y,pixel,clength,isize;
char *buf1;
{
 int  pcol;
 unsigned char bit,bit1; 
 char *buf,*buf2;
 int bitnumber,lim;

 buf=buf1+(long)(y*isize+x/8);
 buf2=buf+(long)isize;
 bitnumber=7-(x%8);
 bit= (0x1<<bitnumber);
 bit1=0xff^bit;

 lim=(1<<(gplanes-1));  
 for(pcol=lim;pcol>=1;pcol = pcol/2) {
  if(pixel & pcol)  {*buf |= bit;*buf2 |= bit;}
  else {*buf &= bit1; *buf2 &= bit1;}
  buf += clength;
  buf2 += clength;  
 }      
}

#ifdef C_POINT_FROM_FN2
/* returns color */
int point_from_fn2(x,y,clength,isize,buf1)
int x,y,clength,isize;
char *buf1;
{
 int  pcol;int lim;
 unsigned char bit; 
 char *buf;
 int bitnumber;
 unsigned long pixel=0;
 int col1;

 buf=buf1+(long)(y*isize+x/8);
 bitnumber=7-(x%8);
 bit= (0x1<<bitnumber);
  
 lim=(1<<(gplanes-1));
 for(pcol=lim;pcol>=1;pcol = pcol/2) {
  if((*buf) & bit) pixel |= pcol;
  buf += clength;
 } 
 color_by_pixel(pixel,0,&col1);
 return col1;     
}

/* returns pixel */
int point_from_fn2b(x,y,clength,isize,buf1)
int x,y,clength,isize;
char *buf1;
{
 int  pcol;int lim;
 unsigned char bit; 
 char *buf;
 int bitnumber;
 unsigned long pixel=0;

 buf=buf1+(long)(y*isize+x/8);
 bitnumber=7-(x%8);
 bit= (0x1<<bitnumber);
  
 lim=(1<<(gplanes-1));
 for(pcol=lim;pcol>=1;pcol = pcol/2) {
  if((*buf) & bit) pixel |= pcol;
  buf += clength;
 } 
 return (int)pixel;     
}
#endif
void point_to_fn2_b(x,y,color,clength,isize,buf1)
int x,y,color,clength,isize;
char *buf1;
{
 int  pcol;
 unsigned char bit,bit1; 
 char *buf,*buf2;
 int bitnumber;int lim;

 buf=buf1+(long)(y*isize+x/8);
 buf2=buf+(long)isize;
 bitnumber=7-(x%8);
 bit= (0x1<<bitnumber);
 bit1=0xff^bit;
  
 lim=(1<<(gplanes-1));
 for(pcol=lim;pcol>=1;pcol = pcol/2) {
  if(color & pcol)  {*buf |= bit;*buf2 |= bit;}
  else {*buf &= bit1; *buf2 &= bit1;}
  buf += clength;
  buf2 += clength;  
 }      
}
