/****************************************************
* G7.C 	Graphical window package
*       -handling of a resizable window
*       -handling of scrolling
*       -handling of background of a window
*      	Author:		Jorma Jormakka
*      	original date:	26.1.93
*	last modified:	26.10.99
*	Copyright: Jorma Jormakka, all rights reserved
* History:
* JJ April 1999: Error located in make_background
*  April 1999 mysterious error appeared here, CMOS was written over, BIOS
*  was later written over, always causing at least hanging of the computer.
*  Debugging the problem located the bug here, calling the routine 
*  save_buf2. No error was found at that time and the problem disappeared by itself(?)
*  without any code fixing. The parameters for the call were
*   save_buf2(8,330,0,0,240,144,0,31,124,*backg_buf);
*  after this call graphics was mixed up and the computer hanged.
*  One reason could be that some times a buffer is not in the correct
*  addressing space? The problem appears to be the old computer killing bug. 
*  Later the error apparently was fixed by correcting allocation in balloc  
*  There is a CD where the old binary still is. 
******************************************************
* CONTENTS:
***********************************
* updating background while resizing
************************************/

void update_backgrnd1();
void update_backgrnd2();
int buf_in_extmem();
int set_fgbg_to_ext();
void update_backgrnd();
void update_tcard_backgrnd();

/*************************************
* window operations resizing, scrolling
***************************************/

int check_scrolling();
int check_resizing();
void init_menu(); 
void marker();

/**************************************
* allocating/freeing background buffer
* reading(drawing screen area
***************************************/

int make_background();
int remove_background();
int remove_win();

/*****************************************
* occasionally foreground is stored in fgbuffer
* and then this routine does the job.
******************************************/ 

int fg_to_fgbuf();
int get_foreground();

#include "x.ext"
#include "win.ext"
#include "text.ext"
static int Xo,Yo;
#ifdef OLD_MARKER
unsigned char markerstore[45];
#endif
extern void strip_off_ending();
extern void movewin2();
int oldmarkershape=0;

extern int gplanes;
extern XColor *xcolor;

/***********************************************************************
* update_backgrnd1()
*
************************************************************************/
void update_backgrnd1(x,y,xsize,ysize,clength,isize,ylength,backg_buf,direction,col1,col2)
int *x,*y,*xsize,*ysize;
int *clength,*isize,*ylength;
char **backg_buf;
int *direction;
int col1,col2;
{
 int off;
 
 if(*direction & 1) { /* right + */    
  if(*clength>=((*xsize+cs)/8+1)) {
   off= *xsize/cs;
   save_buf2(*x+ *xsize,*y,0,0,cs,*ysize,(*x+*xsize)&7,*clength,*isize,*backg_buf+off);
   		   
   movewin2(*x+ *xsize-20,*y,*x+ *xsize,*y+ 11,*x+ *xsize-20+cs,*y);   		
   movewin2(*x+ *xsize-4,*y+11,*x+ *xsize,*y+ *ysize-4,*x+ *xsize-4+cs,*y+11);   
   movewin2(*x+ *xsize-20,*y+ *ysize-4,	*x+ *xsize,*y+ *ysize,
   		*x+ *xsize-20+cs,*y+ *ysize-4);   		   		
      
   *xsize += cs;
   X1_max += cs;    
   clearwin(*x+20,*y+1,*x+ *xsize-21,*y+9,col1);   
  }
  else *direction ^= 1;
 }
 else if(*direction & 2) { /* right - */
  if(*xsize>=50+cs) {
   movewin2(*x+ *xsize-20,*y,*x+ *xsize,*y+ 11,*x+ *xsize-20-cs,*y);
   movewin2(*x+ *xsize-4,*y+11,	*x+ *xsize,*y+ *ysize-4,
   		*x+ *xsize-4-cs,*y+11);  	
   movewin2(*x+ *xsize-20,*y+*ysize-4,	*x+ *xsize,*y+*ysize,
   		*x+ *xsize-20-cs,*y+*ysize-4);   
   		  	
   *xsize -= cs;
   X1_max -= cs;       
   off= *xsize/cs;
   draw_buf2(*x+ *xsize,*y,0,0,cs,*ysize,(*x+*xsize)&7,*clength,*isize,*backg_buf+off); 
   clearwin(*x+20,*y+1,*x+ *xsize-21,*y+9,col1);
  }
  else *direction ^= 2;
 }
 if(*direction & 4) { /* down + */     
  if(*ylength>= *ysize+cr) { 
   off= (*isize)*(*ysize);
   save_buf2(*x,*y+ *ysize,0,0,*xsize,cr,(*x)&7,*clength,*isize,*backg_buf+off);
   movewin2(	*x+11,*y+ *ysize-4,*x+ *xsize-4,*y+ *ysize,
   		*x+11,*y+ *ysize-4+cr);
   movewin2(	*x,*y+ *ysize-20,	*x+ 11,*y+ *ysize,
   		*x,*y+ *ysize-20+cr);   		
   movewin2(	*x+ *xsize-4,*y+ *ysize-20,*x+ *xsize,*y+ *ysize,
   		*x+ *xsize-4,*y+ *ysize-20+cr);   		   		
   *ysize += cr;
   clearwin(*x+1,*y+20,*x+10,*y+ *ysize-12,col1);      
   Y1_max += cr;      
  }  
  else *direction ^= 4;
 }
 else if(*direction & 8) { /* down - */
  if(*ysize>=3*cs+cr && *ysize>=38+cr) {
   movewin2(*x+11,*y+ *ysize-4,		*x+*xsize-4,*y+*ysize,
   		*x+11,*y+*ysize-4-cr);
   movewin2(*x,*y+ *ysize-20,		*x+11,*y+*ysize,
   		*x,*y+*ysize-20-cr);
   movewin2(*x+*xsize-4,*y+*ysize-20,	*x+*xsize,*y+*ysize,
   		*x+*xsize-4,*y+*ysize-20-cr);   		   		
   *ysize -= cr;
   
   off= (*isize)*(*ysize);
   draw_buf2(*x,*y+ *ysize,0,0,*xsize,cr,(*x)&7,*clength,*isize,*backg_buf+off);
   Y1_max -= cr;          
  }    
  else *direction ^= 8;
 }
}
/***********************************************************************
* update_backgrnd2()
*
************************************************************************/
void  update_backgrnd2(x,y,xsize,ysize,clength,isize,ylength,bgnum,direction,col1,col2)
int x,y,*xsize,*ysize;
int clength,isize,ylength;
int bgnum;
int *direction;
int col1,col2;
{
 int off;
 int k;int ysize1,ysize2,ystart;
  
 if(*direction & 1) { /* right + */    
  if(clength>=((*xsize+cs)/8+1)) {
   ysize1=FGSIZE/isize;k=(*ysize)/ysize1;
   ysize2=(*ysize)%ysize1;
   if(ysize2) k++;else ysize2=ysize1;
   ystart=(*ysize)-ysize2;      	
   off= *xsize/cs;

   while(k) {
    get_b(k+(int)bgnum-1,bgbuffer);
    save_buf2(x+ *xsize,y+ystart,0,0,cs,ysize2,(x+*xsize)&7,clength,isize,bgbuffer+off);    
    ysize2 = ysize1;
    ystart -= ysize1;
    save_b(k+(int)bgnum-1,bgbuffer);   
    k--;    
    if(!k) break;
   }
   movewin2(x+ *xsize-20,y,		x+ *xsize,y+ 11,
   		x+ *xsize-20+cs,y);   		
   movewin2(x+ *xsize-4,y+11,		x+ *xsize,y+ *ysize-4,
   		x+ *xsize-4+cs,y+11);   
   movewin2(x+ *xsize-20,y+ *ysize-4,	x+ *xsize,y+ *ysize,
   		x+ *xsize-20+cs,y+ *ysize-4);   		   		
      
   *xsize += cs;
   X1_max += cs;    
   clearwin(x+20,y+1,x+ *xsize-21,y+9,col1);   
  }
  else *direction ^= 1;
 }
 if(*direction & 4) { /* down + */     
  if(ylength>= *ysize+cr && Y1_max+cr<=Y__max) { 
   ysize1=FGSIZE/isize;k=(*ysize+cr)/ysize1;
   ysize2=(*ysize+cr)%ysize1;
   if(ysize2) k++;else ysize2=ysize1; 
   ystart=(*ysize+cr)-ysize2;
       
   if(*ysize<ystart) {
    off= isize*(*ysize-ystart+ysize1);	
    get_b(k+(int)bgnum-2,bgbuffer);  
    ysize2=ystart-*ysize;
    save_buf2(x,y+ *ysize,0,0,*xsize,ysize2,x&7,clength,isize,bgbuffer+off);   
    save_b(k+(int)bgnum-2,bgbuffer);      
    get_b(k+(int)bgnum-1,bgbuffer);  
    ysize2=*ysize+cr-ystart;
    save_buf2(x,y+ ystart,0,0,*xsize,ysize2,x&7,clength,isize,bgbuffer);
    save_b(k+(int)bgnum-1,bgbuffer);      
   }
   else {
    off= isize*(*ysize-ystart);	   	
    get_b(k+(int)bgnum-1,bgbuffer);  
    ysize2=ystart+ysize2-*ysize;
    save_buf2(x,y+ *ysize,0,0,*xsize,ysize2,x&7,clength,isize,bgbuffer+off);        
    save_b(k+(int)bgnum-1,bgbuffer);      
   }  
   movewin2(	x+11,y+ *ysize-4,x+ *xsize-4,y+ *ysize,
   		x+11,y+ *ysize-4+cr);
   movewin2(	x,y+ *ysize-20,	x+ 11,y+ *ysize,
   		x,y+ *ysize-20+cr);   		
   movewin2(	x+ *xsize-4,y+ *ysize-20,x+ *xsize,y+ *ysize,
   		x+ *xsize-4,y+ *ysize-20+cr);   		   		
   *ysize += cr;
   clearwin(x+1,y+20,x+10,y+ *ysize-12,col1);      
   Y1_max += cr;         
  }  
  else *direction ^= 4;
 }
 if(*direction & 8) { /* down - */   
  if(*ysize>=3*cs+cr && *ysize>=38+cr) {
   		
   movewin2(x+11,y+ *ysize-4,		x+*xsize-4,y+*ysize,
   		x+11,y+*ysize-4-cr);
   movewin2(x,y+ *ysize-20,		x+11,y+*ysize,
   		x,y+*ysize-20-cr);
   movewin2(x+*xsize-4,y+*ysize-20,	x+*xsize,y+*ysize,
   		x+*xsize-4,y+*ysize-20-cr);   		   		
     
   ysize1=FGSIZE/(long)isize;k=(*ysize)/ysize1;
   ysize2=(*ysize)%ysize1;
   if(ysize2) k++;else ysize2=ysize1; 
   ystart=(*ysize)-ysize2;
   *ysize -= cr;   
   if(*ysize<ystart) {
    off= isize*(*ysize-(ystart-ysize1));	
    get_b(k+(int)bgnum-2,bgbuffer);  
    ysize2=ystart-*ysize;
    draw_buf2(x,y+ *ysize,0,0,*xsize,ysize2,x&7,clength,isize,bgbuffer+off);   
    get_b(k+(int)bgnum-1,bgbuffer);  
    ysize2=*ysize+cr-ystart;
    draw_buf2(x,y+ ystart,0,0,*xsize,ysize2,x&7,clength,isize,bgbuffer);
   }
   else {
    off= isize*(*ysize-ystart);	   	
    get_b(k+(int)bgnum-1,bgbuffer);  
    draw_buf2(x,y+ *ysize,0,0,*xsize,cr,x&7,clength,isize,bgbuffer+off);        
   }
   Y1_max -= cr;          
  }    
  else *direction ^= 8;
 }
 if(*direction & 2) { /* right - */
  if(*xsize>=50+cs && X1_max+cs<=X__max) {  	
   ysize1=FGSIZE/isize;k=(*ysize)/ysize1;
   ysize2=(*ysize)%ysize1;
   if(ysize2) k++;else ysize2=ysize1;
   ystart=(*ysize)-ysize2;
     	
   movewin2(x+ *xsize-20,y,		x+ *xsize,y+ 11,
   		x+ *xsize-20-cs,y);
   movewin2(x+ *xsize-4,y+11,		x+ *xsize,y+ *ysize-4,
   		x+ *xsize-4-cs,y+11);  	
   movewin2(x+ *xsize-20,y+*ysize-4,	x+ *xsize,y+*ysize,
   		x+ *xsize-20-cs,y+*ysize-4);   
   *xsize -= cs;
   X1_max -= cs;       
   off= *xsize/cs;
   while(k) {
    get_b(k+(int)bgnum-1,bgbuffer);  
    draw_buf2(x+ *xsize,y+ystart,0,0,cs,ysize2,(x+*xsize)&7,clength,isize,bgbuffer+off);    
    ysize2 = ysize1;
    ystart -= ysize1;
    k--;    
    if(!k) break;
   }        
   clearwin(x+20,y+1,x+ *xsize-21,y+9,col1);   
  }
  else *direction ^= 2;
 } 
}
/***********************************************************************
* buf_in_extmem()
*
************************************************************************/
int buf_in_extmem(buf) char *buf;
{int res=0;
 if((long)buf>=1L && (long)buf<=72L) res=1;
 return(res);
}
/**************************************
* by default many objects use fgbuffer
* if the image is large, it will not
* fit and messes up when moved, call
* the following routine directly after
* make_x object and set fgnum and bgnum
* to numbers 1<= n*8+1 <=65 best to reuse
* fgnum as 1 all the time.
***************************************/
int set_fgbg_to_ext(i,fgnum,bgnum) int i,fgnum,bgnum;
{
 wd_object[i].background=(char *)bgnum;    
 wd_object[i].foreground=(char *)fgnum;          	
}
/***********************************************************************
* update_backgrnd()
*
************************************************************************/
void update_backgrnd(x,y,xsize,ysize,clength,isize,ylength,backg_buf,direction,col1,col2)
int *x,*y,*xsize,*ysize;
int *clength,*isize,*ylength;
char **backg_buf;
int *direction;
int col1,col2;
{ 
 if(!buf_in_extmem(*backg_buf)) 
  update_backgrnd1(x,y,xsize,ysize,clength,isize,ylength,backg_buf,direction,col1,col2);
 else 
  update_backgrnd2(*x,*y,xsize,ysize,*clength,*isize,*ylength,(int)(*backg_buf),direction,col1,col2);    	
}
/***********************************************************************
* update_tcard_backgrnd()
*
************************************************************************/
void  update_tcard_backgrnd(X,Y,x,y,xsize,ysize,clength,isize,
			ylength,backg_buf,direction,xsizemax,ysizemax)
int X,Y,*x,*y,*xsize,*ysize;
int *clength,*isize,*ylength;
char **backg_buf;
int *direction;
int xsizemax,ysizemax;
{
 int off;
 
 if(*direction & 1) { /* right + */
  off=X- *x- *xsize+3;if(off>1) off=cs;
  if(xsizemax>= *xsize+off ) {
   save_buf2(*x,*y,*xsize,0,*xsize+off,*ysize,(*x)&7,*clength,*isize,*backg_buf);
   *xsize += off;
   X1_max += off;    
  }
  else *direction ^= 1;
 }
 else if(*direction & 2) { /* right - */
   off= *x+ *xsize-3 -X;if(off>1) off=cs;
  if(*xsize>=1+off) {
   *xsize -= off;
   X1_max -= off;       
   draw_buf2(*x,*y,*xsize,0,*xsize+off,*ysize,(*x)&7,*clength,*isize,*backg_buf);   
  }
  else *direction ^= 2;
 }
 if(*direction & 4) { /* down + */
  off=Y- *y- *ysize+3;if(off>1) off=cs;
  if(ysizemax>= *ysize+off) { 
   save_buf2(*x,*y,0,*ysize,*xsize,*ysize+off+1,(*x)&7,*clength,*isize,*backg_buf);   
   *ysize += off;
   Y1_max += off;      
  }  
  else *direction ^= 4;
 }
 else if(*direction & 8) { /* down - */
  off= *y+ *ysize-3 -Y;if(off>1) off=cs;
  if(*ysize>=1+off) {
   *ysize -= off;
   draw_buf2(*x,*y,0,*ysize,*xsize,*ysize+off+1,(*x)&7,*clength,*isize,*backg_buf);      
   Y1_max -= off;          
  }    
  else *direction ^= 8;
 }
}

/***************************************************************************
* check_scrolling
*
* inparameters:	X,Y current coordinates
*		x1min,y1min,x1max,y1max -coordinates of the window
*		*yfrom,*xfrom,*percentx,*percenty -to be updated by scrollbars
*		xmax,ymax= maximum values for scroll bars
*		col1=background color for scroll bars
*		col2=foreground color for scroll bars
*
* returns:	0=scrolling asked  *xfrom,*yfrom,*percentx,*percenty updated
*		1=upper left corner marker pressed
*		2=lower left corner marker pressed
*		-2=pressed point outside rectangle x1min,y1min,x1max,y1max
*		-1=pointer inside window
***************************************************************************/
int check_scrolling(X,Y,x1min,y1min,x1max,y1max,xfrom,yfrom,percentx,percenty,xmax,ymax,col1,col2,options)
int X,Y,x1min,y1min,x1max,y1max;
int *xfrom,*yfrom;
long *percentx,*percenty;
int xmax,ymax,col1,col2;
unsigned int options;
{
 long result;
 
 if (X<x1min || X>x1max || Y<y1min || Y>y1max) {
  return(-2);/* button used outside, leave this menu */    	
 }    	
 if (X<x1min+10) {
  if(Y<y1min+10) return(2);       	/* move window marker */
   
  else if (Y<y1min+20) {          	/* vertical scrolling */ 
   if(!(options & NO_VERTICAL_SCROLLING)) {
    if(*yfrom>0) (*yfrom)-=1;         	/* up, one line at a time */
    if(ymax>0) result=((*yfrom)<<MAGFACT)/ymax;
    else result=0;
    update_yscrollbar(percenty,result,col1,col2,x1min,y1min,y1max);
   }
  }                                
  else if (Y< y1max-10) {	      	/* scroll bar */ 
   if(!(options & NO_VERTICAL_SCROLLING)) {   
    result=Y-y1min-20;
    result=(result<<MAGFACT)/(y1max-y1min-31);
    *yfrom=(result*ymax)>>MAGFACT;
    if(ymax>0) result=((*yfrom)<<MAGFACT)/ymax;
    else result=0;
    update_yscrollbar(percenty,result,col1,col2,x1min,y1min,y1max);
   }
  }          
  else if (Y<y1max) {      		/* down, one line at a time */
   if(!(options & NO_VERTICAL_SCROLLING)) {   
    if(*yfrom<ymax) (*yfrom)+=1;
    if(ymax>0) result=((*yfrom)<<MAGFACT)/ymax;
    else result=0;
    update_yscrollbar(percenty,result,col1,col2,x1min,y1min,y1max);
   }
  }
  return(0);      
 }  	 
 else if (Y<y1min+10) {          /* horizontal scrolling */
  if(X<x1min+20) {
   if(!(options & NO_HORIZONTAL_SCROLLING)) {   	
    if(*xfrom>0) (*xfrom)-=1;             /* left, one line at a time*/
    if(xmax>0) result=((*xfrom)<<MAGFACT)/xmax;
    else result=0;
    update_xscrollbar(percentx,result,col1,col2,x1min,x1max,y1min);
   }
  }	
  else if (X< x1max-20) {	      	/* scroll bar */
   if(!(options & NO_HORIZONTAL_SCROLLING)) {   	    
    result=X-x1min-20;
    result=(result<<MAGFACT)/(x1max-x1min-41);
    *xfrom=(result*xmax)>>MAGFACT;
    if(xmax>0) result=((*xfrom)<<MAGFACT)/xmax;
    else result=0;
    update_xscrollbar(percentx,result,col1,col2,x1min,x1max,y1min);
   }
  }                
  else if (X< x1max-10) {         	/* right, one char at a time*/
   if(!(options & NO_HORIZONTAL_SCROLLING)) {   	   
    if(*xfrom<xmax) (*xfrom)+=1;
    if(xmax>0) result=((*xfrom)<<MAGFACT)/xmax;
    else result=0;
    update_xscrollbar(percentx,result,col1,col2,x1min,x1max,y1min);
   }
  }
  else return(1);			/* kill window marker */
  return(0); 	  
 }
 return(-1); /* pointer inside window */   	
}
/***************************************************************************
* check_resizing
*
* inparameters:	X,Y current coordinates
*		x1min,y1min,x1max,y1max -coordinates of the window
*
* returns:	returns in bits 1,2,3,4 where to resize
*		*shape=shape of mouse or marker
***************************************************************************/
int check_resizing(X,Y,x1min,y1min,x1max,y1max,shape)
int X,Y,x1min,y1min,x1max,y1max;
int *shape;
{
 int ymid,xmid,yhalf,xhalf;
 int ret;
 
 ymid=(y1min+y1max)/2;yhalf=(y1max-ymid)/2;
 xmid=(x1min+x1max)/2;xhalf=(x1max-xmid)/2; 
 *shape=0;
 if (Y<ymid+yhalf && Y>ymid-yhalf) {
  if(x1max-2<=X && X<=x1max+4) {*shape=1;return(1);}
  if(x1max-8<=X && X<=x1max-3) {*shape=1;return(2);}
 }
 if (X<xmid+xhalf && X>xmid-xhalf) {
  if(y1max-2<=Y && Y<=y1max+4) {*shape=2;return(4);}
  if(y1max-8<=Y && Y<=y1max-3) {*shape=2;return(8);}
 } 
 if(x1max-8<=X && X<=x1max+4 && y1max-8<=Y && Y<=y1max+4) {
  ret=0;
  if(x1max-2<=X && X<=x1max+4) ret |=1;
  else if(x1max-8<=X && X<=x1max-3) ret |=2;
  if(y1max-2<=Y && Y<=y1max+4) ret |=4;
  else if(y1max-8<=Y && Y<=y1max-3) ret |= 8;
  *shape=3;        
  return(ret);	
 }
 return(0);
}
/**************************************
* putting scrollbars to initial places
***************************************/

void init_menu(x,y,xsize,ysize,xmax,ymax,xfrom,yfrom,percentx,percenty) 
int *x,*y,*xsize,*ysize,*xmax,*ymax,*xfrom,*yfrom;
long *percentx,*percenty;
{
 if(*xmax<0) *xmax=0; 
 if(*ymax<0) *ymax=0;
 X1_min= *x+2*cs;X1_max= *x+ *xsize-cs;
 Y1_min= *y+2*cs;Y1_max= *y+ *ysize-cs;
 if(*xmax>0) *percentx=((*xfrom)<<MAGFACT)/(*xmax);else *percentx=0;
 if(*ymax>0) *percenty=((*yfrom)<<MAGFACT)/(*ymax);else *percenty=0;  
}

/**************************************
* poor mans pointer if mouse does not
* work correctly
***************************************/
#ifdef OLD_MARKER
void marker(x,y,operation,color,shape)
int x,y,operation,color,shape;
{
 int i,j;	
 
 if(shape==1) {
  if(operation & 1)
  {
   i=0;
   for(j=Xo-5;j<=Xo+5;j++) {
    drawpixel(j,Yo,(int)markerstore[i]);i++;
   }
   for(j=Xo-4;j<=Xo+4;j++) {
    drawpixel(j,Yo-1,(int)markerstore[i]);i++;  
    drawpixel(j,Yo+1,(int)markerstore[i]);i++;   
   } 
   for(j=Xo-3;j<=Xo-2;j++) {
    drawpixel(j,Yo-2,(int)markerstore[i]);i++;
    drawpixel(j,Yo+2,(int)markerstore[i]);i++;   
   }   
   for(j=Xo+2;j<=Xo+3;j++) {
    drawpixel(j,Yo-2,(int)markerstore[i]);i++;
    drawpixel(j,Yo+2,(int)markerstore[i]);i++;   
   }     
   drawpixel(Xo-2,Yo-3,(int)markerstore[i]);i++;
   drawpixel(Xo-2,Yo+3,(int)markerstore[i]);i++;     
   drawpixel(Xo+2,Yo-3,(int)markerstore[i]);i++;
   drawpixel(Xo+2,Yo+3,(int)markerstore[i]);i++;       
  }
  if(operation & 2) 
  {   	
   Xo=x;Yo=y;
   i=0;
   for(j=Xo-5;j<=Xo+5;j++) {
    markerstore[i]=(char)plot_point(j,Yo,color);i++;  	
   }
   for(j=Xo-4;j<=Xo+4;j++) {
    markerstore[i]=(char)plot_point(j,Yo-1,color);i++;  	
    markerstore[i]=(char)plot_point(j,Yo+1,color);i++;  	     	
   } 
   for(j=Xo-3;j<=Xo-2;j++) {
    markerstore[i]=(char)plot_point(j,Yo-2,color);i++;  	
    markerstore[i]=(char)plot_point(j,Yo+2,color);i++;  	     	  	
   }   
   for(j=Xo+2;j<=Xo+3;j++) {
    markerstore[i]=(char)plot_point(j,Yo-2,color);i++;
    markerstore[i]=(char)plot_point(j,Yo+2,color);i++;
   }     
   markerstore[i]=(char)plot_point(Xo-2,Yo-3,color);i++;
   markerstore[i]=(char)plot_point(Xo-2,Yo+3,color);i++;  
   markerstore[i]=(char)plot_point(Xo+2,Yo-3,color);i++;
   markerstore[i]=(char)plot_point(Xo+2,Yo+3,color);i++;    
  }
 }

 if(shape==2) { 
  if(operation & 1)
  {
   i=0;
   for(j=Yo-5;j<=Yo+5;j++) {
    drawpixel(Xo,j,(int)markerstore[i]);i++;
   }
   for(j=Yo-4;j<=Yo+4;j++) {
    drawpixel(Xo-1,j,(int)markerstore[i]);i++;  
    drawpixel(Xo+1,j,(int)markerstore[i]);i++;   
   } 
   for(j=Yo-3;j<=Yo-2;j++) {
    drawpixel(Xo-2,j,(int)markerstore[i]);i++;
    drawpixel(Xo+2,j,(int)markerstore[i]);i++;   
   }   
   for(j=Yo+2;j<=Yo+3;j++) {
    drawpixel(Xo-2,j,(int)markerstore[i]);i++;
    drawpixel(Xo+2,j,(int)markerstore[i]);i++;   
   }     
   drawpixel(Xo-3,Yo-2,(int)markerstore[i]);i++;
   drawpixel(Xo+3,Yo-2,(int)markerstore[i]);i++;     
   drawpixel(Xo-3,Yo+2,(int)markerstore[i]);i++;
   drawpixel(Xo+3,Yo+2,(int)markerstore[i]);i++;       
  }
  if(operation & 2) 
  {   	
   Xo=x;Yo=y;
   i=0;
   for(j=Yo-5;j<=Yo+5;j++) {
    markerstore[i]=(char)plot_point(Xo,j,color);i++;  	
   }
   for(j=Yo-4;j<=Yo+4;j++) {
    markerstore[i]=(char)plot_point(Xo-1,j,color);i++;  	
    markerstore[i]=(char)plot_point(Xo+1,j,color);i++;  	     	
   } 
   for(j=Yo-3;j<=Yo-2;j++) {
    markerstore[i]=(char)plot_point(Xo-2,j,color);i++;  	
    markerstore[i]=(char)plot_point(Xo+2,j,color);i++;  	     	  	
   }   
   for(j=Yo+2;j<=Yo+3;j++) {
    markerstore[i]=(char)plot_point(Xo-2,j,color);i++;
    markerstore[i]=(char)plot_point(Xo+2,j,color);i++;
   }     
   markerstore[i]=(char)plot_point(Xo-3,Yo-2,color);i++;
   markerstore[i]=(char)plot_point(Xo+3,Yo-2,color);i++;  
   markerstore[i]=(char)plot_point(Xo-3,Yo+2,color);i++;
   markerstore[i]=(char)plot_point(Xo+3,Yo+2,color);i++;    
  }
 }
 if(shape==3) {
  if(operation & 1)
  {
   i=0;
   for(j=Xo-5;j<=Xo+5;j++) {
    drawpixel(j,Yo,(int)markerstore[i]);i++;
   }
   for(j=Xo-2;j<=Xo+2;j++) {
    drawpixel(j,Yo-3,(int)markerstore[i]);i++;  
    drawpixel(j,Yo+3,(int)markerstore[i]);i++;   
   } 
   for(j=Xo-1;j<=Xo+1;j++) {
    drawpixel(j,Yo-4,(int)markerstore[i]);i++;
    drawpixel(j,Yo+4,(int)markerstore[i]);i++;   
   }   
   for(j=Xo-4;j<=Xo-3;j++) {
    drawpixel(j,Yo-1,(int)markerstore[i]);i++;
    drawpixel(j,Yo+1,(int)markerstore[i]);i++;   
   }     
   for(j=Xo+3;j<=Xo+4;j++) {
    drawpixel(j,Yo-1,(int)markerstore[i]);i++;
    drawpixel(j,Yo+1,(int)markerstore[i]);i++;   
   }        
   drawpixel(Xo,Yo-5,(int)markerstore[i]);i++;
   drawpixel(Xo,Yo+5,(int)markerstore[i]);i++; 
   for(j=Yo+1;j<=Yo+2;j++)     
    drawpixel(Xo,j,(int)markerstore[i]);i++;     
   for(j=Yo-2;j<=Yo-1;j++)     
    drawpixel(Xo,j,(int)markerstore[i]);i++;     
        
   drawpixel(Xo+3,Yo-2,(int)markerstore[i]);i++;
   drawpixel(Xo+3,Yo+2,(int)markerstore[i]);i++;       
   drawpixel(Xo-3,Yo-2,(int)markerstore[i]);i++;
   drawpixel(Xo-3,Yo+2,(int)markerstore[i]);i++;          
  }
  if(operation & 2) 
  {   	
   Xo=x;Yo=y;
   i=0; 
   for(j=Xo-5;j<=Xo+5;j++) {
    markerstore[i]=(char)plot_point(j,Yo,color);i++;  	   	
   }
   for(j=Xo-2;j<=Xo+2;j++) {
    markerstore[i]=(char)plot_point(j,Yo-3,color);i++;
    markerstore[i]=(char)plot_point(j,Yo+3,color);i++;       	
   } 
   for(j=Xo-1;j<=Xo+1;j++) {
    markerstore[i]=(char)plot_point(j,Yo-4,color);i++;
    markerstore[i]=(char)plot_point(j,Yo+4,color);i++;       	   	
   }   
   for(j=Xo-4;j<=Xo-3;j++) {
    markerstore[i]=(char)plot_point(j,Yo-1,color);i++;
    markerstore[i]=(char)plot_point(j,Yo+1,color);i++;       	   	
   }     
   for(j=Xo+3;j<=Xo+4;j++) {
    markerstore[i]=(char)plot_point(j,Yo-1,color);i++;
    markerstore[i]=(char)plot_point(j,Yo+1,color);i++;       	   	
   }        
   markerstore[i]=(char)plot_point(Xo,Yo-5,color);i++;
   markerstore[i]=(char)plot_point(Xo,Yo+5,color);i++;
   for(j=Yo+1;j<=Yo+2;j++)     
    markerstore[i]=(char)plot_point(Xo,j,color);i++;   
   for(j=Yo-2;j<=Yo-1;j++)     
    markerstore[i]=(char)plot_point(Xo,j,color);i++;      
        
   markerstore[i]=(char)plot_point(Xo+3,Yo-2,color);i++;
   markerstore[i]=(char)plot_point(Xo+3,Yo+2,color);i++;
   markerstore[i]=(char)plot_point(Xo-3,Yo-2,color);i++;
   markerstore[i]=(char)plot_point(Xo-3,Yo+2,color);i++;   
  }
 } 
}
#else

void marker(x,y,operation,color,shape)
int x,y,operation,color,shape;
{
 ;
}
#endif
/**************************************
* allocates memory if needed and saves
* area from screen to backg_buf
***************************************/
int make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,com_par)
int *clength,*isize,*ylength;
int *x,*y,*xsize,*ysize;
char **backg_buf;
int com_par;
{
 int off,ysize1,ysize2,ystart;int k;
 
 if(*clength<0) *clength=(*xsize)/8+1;
 if(*isize<0) *isize=gplanes*(*clength);
 if(*ylength<0) *ylength= *ysize;
 if(com_par!=DRAW_ONLY_DO_NOT_STAY) return 0;
 off= *x%8; 

 if(buf_in_extmem(*backg_buf)) {

  ysize1=FGSIZE/(*isize);    
  k=(*ysize)/ysize1;
  ysize2=(*ysize)%ysize1;
  if(ysize2) k++;else ysize2=ysize1;
  ystart=*ysize-ysize2;

  if(!bgbuffer) return 0; /* otherwise this loops, 23.9.03 JJ */

  while(k) {
   save_buf2(*x,*y+ystart,0,0,*xsize,ysize2,off,*clength,*isize,bgbuffer);
   ysize2 = ysize1;
   ystart -= ysize1;
   k--;    
   save_b(k+(int)(*backg_buf),bgbuffer);
   if(!k) break;
  }
 }
 else {  
  if(!(*backg_buf)) {

   *backg_buf=balloc((long)(*ylength)*(*isize));
   if(!(*backg_buf)) return(2);


   save_buf2(*x,*y,0,0,*xsize,*ysize,off,*clength,*isize,*backg_buf);  
  }
  else {
   save_buf2(*x,*y,0,0,*xsize,*ysize,off,*clength,*isize,*backg_buf);        
  }
  
 }
 return 0;	     
}
/**************************************
* draws background buffer to the screen
* and frees the buffer
***************************************/
int remove_background(id)
int id;
{
 int i,release=1;
 i=id-1;
 if(id<0) {illegal_pointer(8);return(1);}
 if(wd_object[i].options & WINDOW_HIDDEN) release=0;
 if(wd_object[i].background) {
  if(!buf_in_extmem(wd_object[i].background)) {

   if(wd_object[i].options & OCTET_ALIGNED) {
    remove_win(
  	wd_object[i].xcord,
  	wd_object[i].ycord,
  	wd_object[i].xsize,
  	wd_object[i].ysize,  	
  	wd_object[i].clength,
  	wd_object[i].isize,
  	&(wd_object[i].background),
  	release);
   }
   else {
    movingPicture(0,0,2,id);
    if(release) {b_free(wd_object[i].background);wd_object[i].background=0;}
   }
  }
  else {
   movingPicture(0,0,2,id);
   if(release) {wd_object[i].background=0;}  	
  }
 }
 return(0);
}
/*****************************************
* routine to remove a wd-object
******************************************/
int remove_win(x,y,xsize,ysize,clength,isize,backg_buf,release)
int x,y,ysize,xsize,clength,isize;
char **backg_buf;
int release;
{
 if(!(*backg_buf)) return(1);
 	
 draw_buf1(x,y,xsize,ysize,clength,isize,*backg_buf);             	
 if(release) {b_free(*backg_buf);*backg_buf=0;}
 return(0);
}

/*****************************************
* occasionally foreground is stored in fgbuffer
* and then this routine does the job.
******************************************/ 
int fg_to_fgbuf(id)
int id; 
{
 register int i,j,k;
 char *fg_buf;
 int xcur,ycur,ysize,ysize1,ystart;
 
 i=id-1;
 if(i<0) {illegal_pointer(10);return(1);}
 
 fg_buf=wd_object[i].foreground; 
 if(!fg_buf) {printf("no fgbuf\n");getch();illegal_pointer(100);return(1);}
 
 xcur=wd_object[i].xcord;ycur=wd_object[i].ycord;
 if(buf_in_extmem(fg_buf)) {
  ysize1=FGSIZE/wd_object[i].isize;    
  k=wd_object[i].ysize/ysize1;
  ysize=wd_object[i].ysize%ysize1;

  if(ysize) k++;else ysize=ysize1;
  ystart=wd_object[i].ysize-ysize;
  while(k) {
   save_buf2(xcur,ycur+ystart,0,0,wd_object[i].xsize,ysize,
  	xcur%8,wd_object[i].clength,wd_object[i].isize,fgbuffer);
   ysize = ysize1;
   ystart -= ysize1;
   k--;   
   save_b(k+(int)fg_buf,fgbuffer);
   if(!k) break;
  }
 }
 else {
  save_buf2(xcur,ycur,0,0,wd_object[i].xsize,wd_object[i].ysize,
  	xcur%8,wd_object[i].clength,wd_object[i].isize,fg_buf);
 } 
 return(0);
}
/*************************************
* possibly foreground is in a file and
* must first be read from there
**************************************/
int get_foreground(i) int i;
{
 int j,k;int ysize,ysizet,ysize1;
 FILE *stream;char *fg_buf;
 int clength,xsize,shift,n,m,color,byte,isize,isize1,isize2;
 unsigned long pixel;char *buf,*buf2;
 	
 stream=fopen(wd_object[i].name,"r+b"); 	
 if (!stream) /* error message, cannot find file */
 {
  printf("get_foreground i=%d\n",i);
  cannot_find_file(wd_object[i].name);
  return(1);
 } 
 if(!wd_object[i].foreground) {illegal_pointer(5);return(1);} 
    
 fseek(stream,8,0);	   
 fg_buf=wd_object[i].foreground; /* this is fgbuffer */
 if(!buf_in_extmem(fg_buf)) {	

  if(GPLANES==24 && gplanes==4) { 
   clength=wd_object[i].clength;
   xsize=wd_object[i].xsize;
   isize1=gplanes*clength;
   isize=wd_object[i].isize; /* isize was set to 100, not to isize1 */
   isize2=GPLANES*clength;
   
   wd_object[i].isize=isize2;
   
   buf=malloc(isize1); /* this is 7*4=28 bytes */
   if(!buf) {printf("no memory\n");exit(1);}

   for(j=0;j<wd_object[i].ysize;j++) {
     /* read one j data to buf */
    if(isize1!=fread(buf,1,(long)isize1,stream)) {file_error(1);return(1);}

     /* then copy buf to fg_buf so that there are 24 color planes */
    for(m=0;m<xsize;m++) { /* loop over horizontal pixels */

     /* get the color of each 4-color plane pixel */
     shift=m%8;color=0;
     for(n=gplanes-1;n>=0;n--) {
      byte=*(buf+m/8+n*clength);
      byte=(byte>>(7-shift));
      color +=(byte&0x01)<<n; 
     }
     if(color==3) color=4;
     /*     printf("color=%d\n",color);getchar();*/

     /* color is a four bit color at (m,j) */
     pixel=xcolor[color].pixel;
     /* pixel has 24 bits as RGB, the 24 color planes */
     /*
     printf("red  =%d\n",0xff&(pixel>>16));
     printf("green=%d\n",0xff&(pixel>>8));
     printf("blue =%d\n",0xff&(pixel));
     */

     buf2=fg_buf+j*isize2;

     for(n=GPLANES-1;n>=0;n--) {
      color=(pixel>>(23-n))&0x01;
      byte=color<<(7-shift);
      if(!shift) *(buf2+m/8+n*clength) =byte;
      else *(buf2+m/8+n*clength) +=byte;
     }     
    }
   }
   gplanes=GPLANES;
   free(buf);
  }
  else if(GPLANES==4) { /* the way it was in DOS */
   for(j=0;j<wd_object[i].ysize;j++) {
    if((gplanes*wd_object[i].clength)!=
     fread(fg_buf+j*wd_object[i].isize,1,
       (long)(gplanes*wd_object[i].clength),stream))
    {file_error(1);return(1);}
   }
  }
 }
 else {
   /* buffer in extended memory, here only if DOS */
  ysize1=FGSIZE/wd_object[i].isize;    
  ysizet=wd_object[i].ysize;
  for(k=0;k<8;k++) {
   if(ysizet<ysize1) ysize=ysize1;else ysize=ysizet;
   for(j=0;j<ysize;j++) { 
    if((gplanes*wd_object[i].clength)!=
     fread(fgbuffer+j*wd_object[i].isize,1,(long)(gplanes*wd_object[i].clength),stream))
     {file_error(1);return(1);}
   }  	
   save_b(k+(int)fg_buf,fgbuffer);
   ysizet -= ysize;
   if(!ysizet) break;
  }  	
 } 	
 fclose(stream);
 return(0);
}
