/****************************************************************
* MENUS.C Some more simple menu routines to be used if the pop up
*	  menu in o1.c is not suitable.	
*
*      Jorma Jormakka
*      2.9.92
*****************************************************************/
#include "x.ext"
#include "text.ext"

extern void putVertArrows();
void form();
int selectSomeTypes();
void gg1();

/************************************************
*   selectSomeTypes
*
*   Description: This routine displays on screen a
*      menu of items in buffer pointed by <list>.
*      <list> is LINE10 array.
*      <num_supp_types is the number of names in the list array.
*      <chosen_size> is number of entries in <chosen>-buffer
*      The selected types are returned in  int *chosen, chosen[i]=1
*      if the type i is chosen, else chosen[i]=0.
*      Caller must set xkoord,ykoord to be coordinates for the upper
*      left corner of the selection box.
*      A type is selected by mouse left button. Mouse right button ends. 
*
*   Returns: 0=normal return, 1=error.
*************************************************/
int selectSomeTypes(chosen,list, num_supp_types,chosen_size,
			rowsize,window,col1,col2,col3)
int *chosen;
LINE10 *list;
int num_supp_types;
int chosen_size;
int rowsize,window,col1,col2,col3;
{
 int len;
 int i,j,col;
 int *chosen1,from,last_from,number;

 from=last_from=0; 
 
 chosen1=(int *)malloc(chosen_size*sizeof(int));
 if(!chosen1) return(1);
 for (i=0;i<chosen_size;i++) chosen[i]=chosen1[i]=0;

 clearwin(X1_min,Y1_min,X1_min+rowsize*cs+16,Y1_min+window*cr,col1);
 
 ykoord=Y1_min;
 
 for(i=0;i<10 && i<num_supp_types;i++) {
  xkoord=X1_min+16;
  if (chosen[i]) col=col3; else col=col1;  
  clearwin(xkoord-6,ykoord,xkoord+rowsize*cs,ykoord+cr,col);  
  textn(list[i].name,fgcol,col);
  ykoord += cr;
 }
 putVertArrows(X1_min,Y1_min,window*cr-20,col2);
             
 do {
  if(!buttons) {
   if(mouse_off) {showmouse();mouse_off=0;}
  } 	
  else if(buttons==2){ 
   if(!mouse_off) {hidemouse();mouse_off=1;}
   break;
  }
  else if(buttons==1){
   if(!mouse_off) {hidemouse();mouse_off=1;}  	
   if(X>=X1_min+16 && X<= X1_min+rowsize*cs) { 
    if(!(chosen[from+(Y-Y1_min)/cr]==1)) chosen[from+(Y-Y1_min)/cr]=1;
    else chosen[from+(Y-Y1_min)/cr]=0;
   }
   else if (X>X1_min && X< X1_min+10) {
   	 
    if(Y<10+Y1_min) {if(from>0) from--; }       
    else if (Y>Y1_min+window*cr-10) {
     if(from<num_supp_types-1) from++;
    }
    else {
     from=num_supp_types*(Y-Y1_min+10)/(cr*window-5);
    }          
   }
   else if(pop_up_wanted(X,Y)) break;  
  } 	
  if(from!=last_from) {
   ykoord=Y1_min;   
   for(i=from;i<window+from && i<num_supp_types;i++) {
    xkoord=X1_min+16;
    if (chosen[i]) col=col3; else col=col1;    
    clearwin(xkoord-6,ykoord,xkoord+rowsize*cs,ykoord+cr,col);
    textn(list[i].name,fgcol,col);
    ykoord += cr;
   }    	
   last_from=from;        	
  }    	
  for(i=from;i<window+from && i<num_supp_types;i++) {
   if(chosen1[i]!=chosen[i]) {
    xkoord = X1_min+16;
    ykoord = Y1_min + (i-from)*cr;
    if (chosen[i]) col=col3; else col=col1;
    clearwin(xkoord-6,ykoord,xkoord+rowsize*cs,ykoord+cr,col);
    textn(list[i].name,fgcol,col);
    chosen1[i]=chosen[i];
   }
   ykoord += cr;     
  }
  buttons=0;
  readmouse(&buttons,&X,&Y);   
 } while(!kbhit());

 xkoord=X1_min;ykoord=Y1_min;
 free(chosen1);
 return(0);
}

/************************************************
*   form
*************************************************/ 
void form(u1,u2,max,window,pmax,dmax)
LINE10 *u1;
char **u2;
int max,window,pmax,dmax;
{
 int jx,jy,i,j,go1on,go_on,tmax;
 int from,last_from;
 char savebuf[LINE10MAX];

 from=last_from=0;
 clearwin(X1_min,Y1_min,X1_max,Y1_max,bgcol); 
 putVertArrows(X1_min,Y1_min,window*cr,7);   
 gg1(u1,u2,max,pmax,window,from,X1_min+16,Y1_min); 

 while(1) {	
  do {
   if(!buttons) {
    if(mouse_off) {showmouse();mouse_off=0;}       
   }
   else if(buttons==2) {
    if(!mouse_off) {hidemouse();mouse_off=1;}          	
    xkoord=X1_min;ykoord=Y1_min;
    return;
   }   	
   else if(buttons==1){ 
    if(!mouse_off) {hidemouse();mouse_off=1;}          
    if(X>=X1_min+16 && X<= X1_max && Y>=Y1_min && Y<= Y1_max) 
    { 
     jy=from+(Y-Y1_min)/cr;
     jx=(X-X1_min-16)/cs;go_on=0;
     for(j=0;j<max;j++) {
      if( (u1[j].xcord>=jx && u1[j].xcord<jx+u1[j].bsize) && u1[j].ycord==jy){
       go_on=1;break;
      }
     }
     while(go_on && u1[j].ycord<window+from && u1[j].ycord>=from) {
      ykoord= Y1_min+cr*(u1[j].ycord-from);  
      xkoord= X1_min+16+cs*u1[j].xcord;       
      clearwin(xkoord,ykoord,xkoord+u1[j].bsize*cs,ykoord+ysize-1,0);    
      xkoord -= cs;
      memcpy(savebuf,u1[j].name,LINE10MAX);
      if(u1[j].options & TRUNCATE) tmax=u1[j].bsize; else tmax=LINE10MAX;
      if(got_string(u1[j].name,EMPTYSTR,xkoord,ykoord,tmax))
       j++;
      else {go_on=0;
       memcpy(u1[j].name,savebuf,LINE10MAX);         
       ykoord= Y1_min+cr*(u1[j].ycord-from);  
       xkoord= X1_min+16+cs*u1[j].xcord;       
       textn(savebuf,fgcol,bgcol);                
      }             
     }     
    }
    else if (X<X1_min+10) {
     if (Y<Y1_min+10) 
     {
      if(from>0) from--;
     }       
     else if (Y>Y1_min+cr*window-15) {
      if(from<max+window) from++;      
     }
     else {
      from=dmax*(Y-Y1_min+10)/(cr*window-5);
     }
    }
    else if(pop_up_wanted(X,Y)) {
     xkoord=X1_min;ykoord=Y1_min;
     return;   	    	
    }
   }
   if(from>last_from) {
    movewin(	X1_min+16,Y1_min+(from-last_from)*cr, X1_max,Y1_max,
    		X1_min+16,Y1_min);
    		
    clearwin(X1_min+16,Y1_min+(window-from+last_from)*cr,X1_max,Y1_max,bgcol);
    gg1(u1,u2,max,pmax,window,window+last_from+1,
    	X1_min+16,Y1_min+(window-from+last_from)*cr);
    last_from=from;        	
   }    	
   else if(from<last_from) {
    movewin(	X1_min+16,Y1_min,X1_max,Y1_min+(window-last_from+from+1)*cr,
    		X1_min+16,Y1_min+(last_from-from)*cr);    
    clearwin(X1_min+16,Y1_min,X1_max,Y1_min+(last_from-from)*cr,bgcol);
    gg1(u1,u2,max,pmax,last_from-from,from,X1_min+16,Y1_min); 
    last_from=from;        	
   }    	   
   buttons=0;
   readmouse(&buttons,&X,&Y);

  } while(!kbhit());	
 }
}  	

/************************************************
*   gg1
*************************************************/
void gg1(buf,u2,max,pmax,window,from,xmin,ymin)
LINE10 *buf;
char   **u2;
int max,pmax,window;
int from,xmin,ymin;
{
 int i;
 
 ykoord=ymin; 
 for(i=from;i<=window+from && i<pmax;i++) { 
  xkoord=xmin;    
  osprints(u2[i],xkoord,ykoord+cr);
 }

 for(i=0;i<max;i++) { 
  if(buf[i].ycord<=window+from && buf[i].ycord>=from) { 	
   ykoord= ymin+cr*(buf[i].ycord-from);  
   xkoord= xmin+cs*buf[i].xcord; 
   clearwin(xkoord,ykoord,xkoord+buf[i].bsize*cs,ykoord+ysize-1,0);
   otext(buf[i].name,fgcol,bgcol);
  }
 }             
}	  
int saveform(filename,u1,u2,max,pmax) 
char *filename;LINE10 *u1;char **u2;int max,pmax;
{
 int i;long length;
 FILE *stream;
 unsigned char line[1],*s;
  
 stream=fopen(filename,"rb+");
 if(!stream) stream=fopen(filename,"wb+"); 	
 if (!stream)
 {  
  osprints("saveform, error in creating ",10,100);osprints(filename,8*18+10,100);
  return(1);
 } 
 rewind(stream); 

 for(i=0;i<pmax;i++) {
  s=u2[i];length=line[0]=strlen(s);
  fwrite(line,1,1,stream);
  fwrite(s,1,length,stream);
 }

 length=sizeof(LINE10);
 for(i=0;i<max;i++) {
  fwrite((char *)&u1[i],1,length,stream);
 } 
  
 fclose(stream);  
 return(0);
}
int loadform(filename,u1,u2,max,pmax) 
char *filename;LINE10 *u1;char **u2;int max,pmax;
{
 int i;long length;
 FILE *stream;
 unsigned char line[1],*s;
  
 stream=fopen(filename,"rb+");
 if (!stream)
 {  
  osprints("loadform, can't find ",10,100);osprints(filename,8*18+10,100);
  return(1);
 } 
 rewind(stream);
 
 for(i=0;i<pmax;i++) {
  fread(line,1,1,stream);
  length=(int)line[0];s=u2[i]=(char *)malloc(length+1);
  fread(s,1,length,stream);
  s[length]=0;
 }
 length=sizeof(LINE10);
 for(i=0;i<max;i++) {
  fread((char *)&u1[i],1,length,stream);
 }   
 fclose(stream);  
 return(0);
}
