
/*****************************************************************************
* O1.C		CODE FOR WD_OBJECT TYPE pop_up_menu     
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
#define Lim1 5000L
#define Lim2 50L
#define Lim3 50L
int pensize=1,nocolor=15;
void init_popupmenu();
/**********************************************************
* The pop_up_menu wd_object-type has the 3 routines:
*	make_popup_menu
*	pop_up_menu
*	free_pop_up_menu
*
* The routine pop_up_menu calls the main window routine
* 	popUpMenu 
* to do the work. It has subroutines 
*	check_command,init_popupmenu 
* 
* You should write a fill_yourmenu routine which creates a
* specific menu that you want. This fill routine then calls
* make_popup_menu. As an example there is 
*	fill_pensizemenu
* There are two useful routines for (de)allocating structures:
*	create_menustructure
*	free_menustructure
***********************************************************/
/**********************************************************
* The wd_object type pop_up_menu
***********************************************************/
int make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
						max,pmax,window,linelength)
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
LINE10 *u1;
char **u2;
int *chosen;
int max,pmax,window,linelength;
{
 int i;
 i=id-1;
 
 wd_object[i].type=POPUP_OBJ;
 wd_object[i].options=OCTET_ALIGNED; 
 wd_object[i].options|=OBJECT_NOT_PUT;  
 wd_object[i].xcord=x;
 wd_object[i].ycord=y;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize;
 if(xsize*ysize>XSIZE*YSIZE) wd_object[i].options |=MOVE_AS_RECTANGLE; 
 wd_object[i].xstart=0;
 wd_object[i].ystart=0;  
 wd_object[i].clength= -1;
 wd_object[i].isize= -1;   
 wd_object[i].ylength= -1;    
 wd_object[i].background=(char *)0;    
 wd_object[i].foreground=fgbuffer;          
 wd_object[i].col1=(unsigned char )col1;  
 wd_object[i].col2=(unsigned char )col2;  
 wd_object[i].col3=(unsigned char )col3;  
 wd_object[i].col4=(unsigned char )col4;  
 wd_object[i].col5=(unsigned char )col5;  
 wd_object[i].i1= (int)max;   
 wd_object[i].i2= (long)pmax;      
 wd_object[i].i3= (long)window;   
 wd_object[i].i4= (int)linelength;       
 wd_object[i].p1=(char *)u1;
 wd_object[i].p2=(char **)u2;
 wd_object[i].p3=(int *)chosen;
 zero_over(i);
 return(0);
}

int pop_up_menu(id,com_par)
int id,com_par;
{
 int i;int ret,i3;
 i=id-1;
 i3=wd_object[i].i3;
 ret=popUpMenu(
	(int *)&(wd_object[i].xcord),
	(int *)&(wd_object[i].ycord),
	(int *)&(wd_object[i].xsize),
	(int *)&(wd_object[i].ysize),
	(int *)&(wd_object[i].xstart),
	(int *)&(wd_object[i].ystart),

	(LINE10 *)wd_object[i].p1,
	(char **)wd_object[i].p2,
	(int *)wd_object[i].p3,

	(int)wd_object[i].i1,
	(int)wd_object[i].i2,
	(int *)&i3,
	(int)wd_object[i].i4,
       	(char **)&(wd_object[i].background),       	
       	(int *)&(wd_object[i].clength),
       	(int *)&(wd_object[i].isize),
       	(int *)&(wd_object[i].ylength),
       	(int)wd_object[i].col1,
       	(int)wd_object[i].col2,
       	(int)wd_object[i].col3,
       	(int)wd_object[i].col4,

       	(int)wd_object[i].col5,
       	wd_object[i].options,
       	(int)com_par);
 wd_object[i].i3=i3;
 return ret;       
}

int free_pop_up_menu(id) 
int id;
{
 LINE10 *u1;
 char **u2;
 int *chosen; 
 int i,max,pmax,linelength;

 i=id-1;
 if(i<0) {illegal_pointer(7);return 1;}
 if(wd_object[i].type==FREE_OBJ) return 0;   
 remove_background(id); 
 wd_object[i].type=FREE_OBJ;   
 u1=(LINE10 *)wd_object[i].p1;
 u2=(char **)wd_object[i].p2; 
 chosen=(int *)wd_object[i].p3;
 max=wd_object[i].i1;
 pmax=wd_object[i].i2;
 linelength=wd_object[i].i4;
 
 free_menustructure(&u1,&u2,&chosen,max,pmax,linelength);
 return 0;
}

/*********************************************************
* the window routine doing the work, and its subroutines
**********************************************************/
int popUpMenu(x,y,xsize,ysize,xstart,ystart,
	u1,u2,chosen,max,pmax,window,linelength,
       	backg_buf,clength,isize,ylength,col1,col2,col3,col4,
       	fgcol1,options,com_par)
int *x,*y,*xsize,*ysize,*xstart,*ystart;      
LINE10 *u1;char **u2;
int *chosen;
int max,pmax,*window,linelength;
char **backg_buf;
int *clength,*isize,*ylength;
int col1,col2,col3,col4,fgcol1;
unsigned int options;
int com_par;
{ 
 int i,j,oldbuttons;
 int xmax,ymax,oldX,oldY;
 long counter1=0,counter2=0;
 int last_ystart,last_xstart,ret,save1;
 long percentx,percenty;
 fgcol=fgcol1;


 if(make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,com_par)) 
  return(2); 
 truncate1=1;      
 last_xstart= *xstart;last_ystart= *ystart;
 init_popupmenu(pmax,*window,linelength,xsize,&xmax,&ymax);
 init_menu(x,y,xsize,ysize,&xmax,&ymax,xstart,ystart,&percentx,&percenty);

 if(com_par==DRAW_ONLY_DO_NOT_STAY || com_par==REFRESH) {
  clearwin(*x,*y,*x+ *xsize,*y+ *ysize-1,18);
  clearwin(*x+14,*y+14,*x+ *xsize-7,*y+ *ysize-1-7,col1);

  putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,xmax,ymax,&percentx,&percenty,col2,options,0);

  for(i= *ystart;i<*window+ *ystart && i<pmax;i++) {
   if(chosen[i] & 1) display_line(u1,u2,max,i,*xstart,*ystart,col3,col4);
   else display_line(u1,u2,max,i,*xstart,*ystart,col1,col4);
  }

  return(-2); /* exit, do nothing */
 }
 oldX=X;oldY=Y;oldbuttons=buttons;


 while(1) {	
  do {
   if(!buttons){
    if(!(options & NO_RESIZING)) {
     if(!mouse_off) {
      check_resizing(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,&markershape);
      if(oldmarkershape!=markershape) {
       hidemouse();
       if(markershape==0) DefaultCursor();
       else if(markershape==1) ArrowVerCursor();      
       else if(markershape==2) ArrowHorCursor();            
       else if(markershape==3) Arrow4Cursor();                  
       oldmarkershape=markershape; 
       showmouse();
      }
     }
    }
    if(curon) {marker(X,Y,CUROFF,fgcol,markershape);curon=0;}   
    if(mouse_off) {showmouse();mouse_off=0;}
   }
   else {
   
    if(!mouse_off) {hidemouse();mouse_off=1;}
    
    if(!(options & NO_RESIZING)) {
     mov=check_resizing(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,&markershape);
    }
    else mov=0;
    if(!mov) { 
     if(curon) {marker(X,Y,CUROFF,fgcol,markershape);curon=0;}    	
     ret=check_scrolling(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,
    	xstart,ystart,&percentx,&percenty,xmax,ymax,col1,col2,options);

     if(ret== -2) {
      resetmouse(); /* 23.9.2003 JJ */
      return(-2); /* exit, do nothing */
     }
     else if(ret==2) { /* move window marker pressed */
      if(buttons==1) {
       resetmouse(); /* 23.9.2003 JJ */      	
       return(0); /* call operations */
      }
      if(buttons==2) {
       resetmouse(); /* 23.9.2003 JJ */      	
       return(-4); /* move window */     
      }
     }
     else if(ret==1) { /* kill window marker pressed */
      resetmouse(); /* 23.9.2003 JJ */            
      if(buttons==2) {
      	if(options & NO_ICONIZING) return(-2); /* do nothing */
     	return(-3); /* make icon */      
      }      
      if(options & HIDE_ON_EXIT) return(-5); /* hide */
      if(options & NO_KILLING) return(-2); /* do nothing */
      if(buttons==1) return(-1); /* kill window */    
     }
     else if (ret==0 || ret==-1) {
      /* if command chosen and horizontal pull to the right pop up submenus */
      if(doubleclick_and_submenu(chosen,pmax,X,Y,buttons,
         oldX,oldY,&counter1,&counter2,Lim2)) return(0);
      check_command(u1,u2,chosen,*xstart,*ystart,max,pmax,*window,col1,col3,col4,X,Y);    
     }
    }
    else {
     if(!curon) {marker(X,Y,CURON,fgcol,markershape);curon=1;}
     else marker(X,Y,CURMOVE,fgcol,markershape);    
    }
   }  	      
   if(mov) {
    if(curon) marker(X,Y,CUROFF,fgcol,markershape);   	
    update_backgrnd(x,y,xsize,ysize,clength,isize,ylength,backg_buf,&mov,col1,col2);
    if(mov & 1) {
     clearwin(*x+*xsize-4-cs,*y+11,*x+*xsize-4,*y+*ysize-5,col1); 
     save1=X1_min;X1_min=X1_max-cs;*xstart += (X1_max-save1)/cs-1;
     for(j= *ystart;j<*window+ *ystart && j<pmax;j++) {
      /* */   
      if(chosen[j] & 1) display_line(u1,u2,max,j,*xstart,*ystart,col3,col4);
      else display_line(u1,u2,max,j,*xstart,*ystart,col1,col4);

     }
     *xstart -= (X1_max-save1)/cs-1;X1_min=save1;
     X= *x+ *xsize-2;
    }
    if(mov & 2) X= *x+ *xsize-3;
    if(mov & 4) {
     clearwin(*x+11,*y+*ysize-5-cr,*x+*xsize-4,*y+*ysize-5,col1);    	
     if(*window<pmax) (*window)+=1;    	
     for(j= *ystart;j<*window+ *ystart && j<pmax;j++) {
      if(chosen[j] & 1) display_line(u1,u2,max,j,*xstart,*ystart,col3,col4);
      else display_line(u1,u2,max,j,*xstart,*ystart,col1,col4);
     }    	          
     Y= *y+ *ysize-2;
    }
    if(mov & 8) {
     if(*window>0) (*window)-=1;
     Y= *y+ *ysize-3; 
    }
    if(mov) {
     setmouse(X,Y);
     mov=0;
     putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,xmax,ymax,&percentx,&percenty,col2,options,1);
    }
    if(curon) marker(X,Y,CURON,fgcol,markershape);
   }
       	
   if((*ystart!=last_ystart)||(*xstart!=last_xstart)){
    clearwin(X1_min,Y1_min,X1_max,Y1_max,col1);   	
    for(j= *ystart;j<*window+ *ystart && j<pmax;j++) {
     if(chosen[j] & 1) display_line(u1,u2,max,j,*xstart,*ystart,col3,col4);
     else display_line(u1,u2,max,j,*xstart,*ystart,col1,col4);
    }    	
    last_ystart= *ystart;last_xstart= *xstart;              	
   }
   oldX=X;oldY=Y;oldbuttons=buttons;
   buttons=0;
   readmouse(&buttons,&X,&Y);
   if(!counter1) {
    if(buttons && !oldbuttons) {
     counter1=1;counter2=0;
    }
   }
   else {
    if(counter1>Lim1) counter1=counter2=0;
    else counter1++;
   } 
   if(!counter2) {
    if(!buttons && oldbuttons && counter1>Lim3) {
     counter2=1;
    }
   }
   else counter2++;
  } while(!kbhit());
 }     
}

void init_popupmenu(pmax,window,linelength,xsize,xmax,ymax) 
int pmax,window,linelength;
int *xsize,*xmax,*ymax;
{
 *ymax=(pmax-window>0?pmax-window:0);
 *xmax=linelength-(*xsize)/cs-3;
 if(*xmax<0) *xmax=0;
}

int check_command(u1,u2,chosen,xstart,ystart,max,pmax,window,col1,col3,col4,X,Y)
LINE10 *u1;
char **u2;
int *chosen;
int xstart,ystart;
int max,pmax,window;
int col1,col3,col4;
int X,Y;
{ 
 int i,j,j1,k,go_on,tmax;
 char savebuf[LINE10MAX];
 int linenum;

 if(Y>=Y1_min && Y<Y1_min+cr*window && X>=X1_min && X<X1_max) { 
  linenum=ystart+(Y-Y1_min)/cr;
  
  for(j=0;j<pmax;j++) {	 /* remove highlight color from old line(s) */
   chosen[j] &= 0xfffd;
   if(j!=linenum && chosen[j] & 1) {   	
    chosen[j] ^= 1;
    if(j>=ystart && j<ystart+window) {  
       display_line(u1,u2,max,j,xstart,ystart,col1,col4);  
    }
   }
  }
  chosen[linenum] |= 1;		/* highlight this line */
  display_line(u1,u2,max,linenum,xstart,ystart,col3,col4);  
  go_on=0;   /* find parameters of the line */
  for(j=0;j<max;j++) { 
   if(u1[j].ycord/cr==linenum){go_on=1;break;} 
  }  
  if(!go_on) return(1); /* return 1 if no parameters */
 
  j1=(X-X1_min)/cs + xstart;
  go_on=0;

  for(i=j;i<j+u1[j].parmax;i++){ /* find this parameter box */
   if(u1[i].xcord/cs<=j1 && u1[i].xcord/cs+u1[i].size>j1) {
    go_on=1;
    break;
   } 
  }
  if(!go_on) return(1);	/* return 1 if no parameter identified */

  ykoord= Y1_min+u1[i].ycord-cr*ystart;
  xkoord= X1_min+u1[i].xcord-cs*xstart;

  if(u1[i].options & TRUNCATE) tmax=u1[i].bsize; else tmax=LINE10MAX;
  if(u1[i].options & SELECTION) {
   next_selection(u1[i].name);
   display_line(u1,u2,max,linenum,xstart,ystart,col3,col4);
  }
  else {
   memcpy(savebuf,u1[i].name,LINE10MAX);
   if(!got_parstring(u1,u2,i,xstart,xkoord,ykoord,tmax,col3,col4)) {
    memcpy(u1[i].name,savebuf,LINE10MAX);               
    ykoord= Y1_min+u1[i].ycord-cr*ystart;  
    xkoord= X1_min+u1[i].xcord-cs*xstart;       
    textn(savebuf,fgcol,col1);
    return(2); /* old value restored */
   }
  }
  return(3); /* parameter i on line linenum updated */
 }
 return(0); /* no line found */
}

/*************************************************************
* useful subroutines
**************************************************************/  
int create_menustructure(u1p,u2p,chosenp,max,pmax,linelength)
LINE10 **u1p;
char ***u2p;
int **chosenp;
int max,pmax,linelength;
{
 register int i;
 char *s;
 LINE10 *u1;
 char **u2;
 int *chosen; 
 
 if(max>0) {
  u1=(LINE10 *)malloc(max*sizeof(LINE10));
  if(!u1) return(1);
  *u1p=u1;
  for(i=0;i<max;i++) {
   memset(u1[i].name,0,LINE10MAX); 
   u1[i].xcord=X__max;u1[i].ycord=Y__max;
   u1[i].parmax=u1[i].options=0;
   u1[i].size=LINE10MAX;
   u1[i].bsize=LINE10MAX;
  }  
 }
 if(pmax>0) {
  u2=(char **)malloc(pmax*sizeof(char *));	
  if(!u2) return(1);
  *u2p=u2;
  chosen=(int *)malloc(pmax*sizeof(int));
  if(!chosen) return(1);
  *chosenp=chosen;
  
  for(i=0;i<pmax;i++) {
   chosen[i]=0;
   u2[i]=0; 
  }  
    
  if(linelength) {
   for(i=0;i<pmax;i++) {
    s=(char *)malloc(linelength);
    if(!s) return(1);
    memset(s,0,linelength);
    u2[i]=s; 
   }
  }
 }
 return(0);	
}
int free_menustructure(u1p,u2p,chosen,max,pmax,linelength)
LINE10 **u1p;
char ***u2p;
int **chosen;
int max,pmax,linelength;
{
 register int i;
 char *s;

 if(max>0) {
  if(!(*u1p)) return(1);
  free((*u1p));
  *u1p=0;
 }
 if(pmax>0) {
  if(!(*chosen)) return(1);
  free((*chosen)); *chosen=0;
  
  if(!(*u2p)) return(1);
  
  if(linelength>0) {
   for(i=0;i<pmax;i++) {
    s=(*u2p)[i];
    if(!s) return(1);
   }
  }
  free((*u2p)); 
  (*u2p)=(char **)0;   
 }
 return(0);	
}

int pull_down(id) int id;
{
 if(pop_up_menu(id,DRAW_ONLY_DO_NOT_STAY)>0) return(1);
 X=wd_object[id-1].xcord+3*cs;Y=wd_object[id-1].ycord+cr;
 if(pop_up_menu(id,NORMAL_OPERATION)>0) return(1);
 return(0);   
}
/*****************************************************************
* Example of a fill routine
******************************************************************/
int fill_pensizemenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Pen: 1 point ");
 strcpy(u2[1],"Pen: 2 point ");
 strcpy(u2[2],"Pen: 4 point ");
 strcpy(u2[3],"Pen: 6 point ");
 strcpy(u2[4],"Pen:10 point "); 

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 
 return(0); 
}
/*****************************************************************
* Example of a fill routine
******************************************************************/
int fill_pathdatamenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Path =");
 strcpy(u2[1],"index=");
 strcpy(u2[2],"x=");
 strcpy(u2[3],"y=");
 strcpy(u2[4],"z="); 
 strcpy(u2[5],"time="); 
 strcpy(u2[6],"speed="); 
 strcpy(u2[7],"set z"); 
 strcpy(u2[8],"refind path"); 
 strcpy(u2[9],"exit menu"); 
 strcpy(u2[10],"alt="); 
 strcpy(u2[11],".in="); 
 strcpy(u2[12],"save"); 

 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;u1[0].size= u1[0].bsize=5;
 strcpy(u1[0].name,"0");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1; u1[1].size= u1[1].bsize=5;
 strcpy(u1[1].name,""); 
 
 u1[2].xcord=strlen(u2[3])*cs; 
 u1[2].ycord=3*cr; 
 u1[2].parmax=1; u1[2].size= u1[2].bsize=5;
 strcpy(u1[2].name,""); 
 
 u1[3].xcord=strlen(u2[4])*cs; 
 u1[3].ycord=4*cr; 
 u1[3].parmax=1; u1[3].size= u1[3].bsize=5;
 strcpy(u1[3].name,"");
 
 u1[4].xcord=strlen(u2[5])*cs; 
 u1[4].ycord=5*cr; 
 u1[4].parmax=1; u1[4].size= u1[4].bsize=5;
 strcpy(u1[4].name,""); 
 
 u1[5].xcord=strlen(u2[6])*cs; 
 u1[5].ycord=6*cr; 
 u1[5].parmax=1; u1[5].size= u1[5].bsize=5;
 strcpy(u1[5].name,""); 

 u1[6].xcord=strlen(u2[0])*cs; 
 u1[6].ycord=0; 
 u1[6].parmax=1; u1[6].size= u1[6].bsize=5;
 strcpy(u1[6].name,"0"); 

 u1[7].xcord=strlen(u2[10])*cs; 
 u1[7].ycord=10*cr; 
 u1[7].parmax=1; u1[7].size= u1[7].bsize=15;
 strcpy(u1[7].name,"altitude.pcx"); 

 u1[8].xcord=strlen(u2[11])*cs; 
 u1[8].ycord=11*cr; 
 u1[8].parmax=1; u1[8].size= u1[8].bsize=15;
 strcpy(u1[8].name,"test6.in"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 
 return(0); 
}

