/*****************************************************************************
* O2.C		CODE FOR WD_OBJECT TYPE file_window
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
#include "linuxpaths.ext"
extern unsigned char markerstore[45];
void init_resizable(),show_text(),move_text();
LETTERTABLE strangelist[43];
int strangesize=0;
/**********************************************************
* The file_window wd_object-type has the 3 routines:
*	make_file_window
*	file_window
*	free_file_window
*
* The routine file_window calls the main window routine
* 	resizable_window 
* to do the work. It has subroutines 
*	show_text,move_text,init_resizable 
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
***********************************************************/
/**********************************************************
* The wd_object type file_window
***********************************************************/

int make_file_window(id,x,y,xsize,ysize,col1,col2,col3,col4,filename,xmax,ymax)
int id;
int x,y,xsize,ysize,col1,col2,col3,col4;
char *filename;
int xmax,ymax;
{
 int i;
 i=id-1;if(i<0) return(1);
 
 wd_object[i].type=TEXTWIN_OBJ;
 wd_object[i].options=OCTET_ALIGNED; 
 wd_object[i].options|=OBJECT_NOT_PUT;   
 wd_object[i].xcord=(x/8)*8; /* this window type is octet aligned */
 wd_object[i].ycord=y;
 wd_object[i].xsize=(xsize/8)*8;
 wd_object[i].ysize=ysize;
 wd_object[i].xstart=0;
 wd_object[i].ystart=0;  
 wd_object[i].clength= -1;
 wd_object[i].isize= -1;   
 wd_object[i].ylength= -1;    
 wd_object[i].background=0;     
 wd_object[i].foreground=fgbuffer;      
 wd_object[i].col1=col1;  
 wd_object[i].col2=col2;
 wd_object[i].col3=col3;   
 wd_object[i].col4=col4;     
 strcpy(wd_object[i].name,filename);
 wd_object[i].i1= xmax;   
 wd_object[i].i2= ymax;
 zero_over(i);
 return(0);
}

int file_window(id,com_par,ignore)
int id,com_par,ignore;
{int ret;int i2;
 i2=wd_object[id-1].i2;
 ret=resizable_window(
  	&(wd_object[id-1].xcord),
 	&(wd_object[id-1].ycord),
 	&(wd_object[id-1].xsize),
 	&(wd_object[id-1].ysize),
 	&(wd_object[id-1].xstart),
 	&(wd_object[id-1].ystart),
 	&(wd_object[id-1].i1),
 	&i2, 
	wd_object[id-1].name, 		
       	&(wd_object[id-1].background),
       	&(wd_object[id-1].clength),
       	&(wd_object[id-1].isize),
       	&(wd_object[id-1].ylength),
       	(int)wd_object[id-1].col1,
       	(int)wd_object[id-1].col2,
       	(int)wd_object[id-1].col3,
       	(int)wd_object[id-1].col4,
       	wd_object[id-1].options,
	com_par,ignore);
 wd_object[id-1].i2=i2;
 return ret;	
} 		

int free_file_window(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) {illegal_pointer(6);return(1);}
 remove_background(id);
 wd_object[i].type=FREE_OBJ;    
 return(0);      
}

/*********************************************************
* the window routine doing the work, and its subroutines
**********************************************************/
/******************************************************************************
*   resizable_window()
*   Description: x,y are coordinates where to put a window of ysize vertical
*                lines with xsize characters in a line. The window is read from
*                a file <file_name>. Window can be resized.
******************************************************************************/ 
int resizable_window(x,y,xsize,ysize,xstart,ystart,xmax,ymax,filename,
			backg_buf,clength,isize,ylength,bgcol1,boxcol,editcol,fgcol1,options,mode,ignore)
int *x,*y,*xsize,*ysize,*xstart,*ystart,*xmax,*ymax;
char *filename,**backg_buf;
int *clength,*isize,*ylength;
int boxcol,editcol;
unsigned int options;
int mode,ignore;
{

 FILE *stream;
 int last_ystart,last_xstart,ret,save1;
 long percentx,percenty;
 char line[50];
 
 if(mode!=REFRESH)
  if(make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,mode)) return(2);
 bgcol=bgcol1;fgcol=fgcol1;
 truncate1=1;
 X1_min=*x;Y1_min=*y;X1_max=*x+*xsize;Y1_max=*y+*ysize;  
 xkoord= *x;ykoord= *y;
 last_xstart= *xstart;last_ystart= *ystart;  

 stream=fopen(filename,"rb+");
 if (!stream) {
  strcpy(line,incpath);
  strcat(line,filename);
  stream=fopen(line,"rb+");
  if(!stream) return(1); /* error cannot find file */
 }
    
 init_resizable(stream,x,y,xsize,ysize,xmax,ymax,xstart,ystart,&percentx,&percenty);    

 if(mode==DRAW_ONLY_DO_NOT_STAY || mode==REFRESH) { 
      
  clearwin(*x,*y,*x+ *xsize,*y+ *ysize-1,bgcol); 
  show_text(stream,xstart,ystart);
  
  putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,*xmax,*ymax,&percentx,&percenty,boxcol,options,0); 
  
  fclose(stream);
  return(-2); /* exit, do nothing */
 }

 mov=0; 
 while(1) {	
  do {
   if(!buttons){
    if(curon) {marker(X,Y,CUROFF,editcol,markershape);curon=0;}   	
    if(mouse_off) {showmouse();mouse_off=0;}
   }
   else {
    if(!mouse_off) {hidemouse();mouse_off=1;}
    if(!(options & NO_RESIZING)) {
     mov=check_resizing(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,&markershape);
    }
    else mov=0;
    if(!mov) {
     if(curon) {marker(X,Y,CUROFF,editcol,markershape);curon=0;}    	
     ret=check_scrolling(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,
    	xstart,ystart,&percentx,&percenty,*xmax,*ymax,bgcol,boxcol,options);
     if(ret== -2 && !ignore) { /* pointer pressed outside the window */
      fclose(stream);	
      return(-2); /* exit, do nothing */
     }
     else if(ret==2) { /* move window marker pressed */	
      if(buttons==1) {fclose(stream);return(0);} /* operations */
      if(buttons==2 && !ignore) 
       {fclose(stream);return(-4);} /* move window */	
     }
     else if(ret==1 && !ignore) { /* kill window marker pressed */
      fclose(stream);           
      if(buttons==2) {
      	if(options & NO_ICONIZING) return(-2); /* do nothing */
      	return(-3); /* make icon */      
      }
      if((options & NO_KILLING) && !ignore) return(-2); /* do nothing */
      if(buttons==1 && !ignore) return(-1); /* kill window */
     }	
    }
    else {
     if(!curon) {marker(X,Y,CURON,editcol,markershape);curon=1;}
     else marker(X,Y,CURMOVE,editcol,markershape);    
    }
   }  	
  
   if(mov) {
    if(curon) marker(X,Y,CUROFF,editcol,markershape);   	
    update_backgrnd(x,y,xsize,ysize,clength,isize,ylength,backg_buf,&mov,bgcol,boxcol);
    if(mov & 1) {
     save1=X1_min;*xstart += (X1_max-X1_min)/cs-1;X1_min=X1_max-cs;
     move_text(stream,xstart,ystart);    	
     X1_min=save1;*xstart -= (X1_max-X1_min)/cs-1;
     X= *x+ *xsize-2; 
    }
    if(mov & 2) X= *x+ *xsize-3;
    if(mov & 4) {
     save1=Y1_min;*ystart += (Y1_max-Y1_min)/cr-1;
     Y1_min=Y1_max-cr;
     move_text(stream,xstart,ystart);    	
     Y1_min=save1;*ystart -= (Y1_max-Y1_min)/cr-1;
     Y= *y+ *ysize-2;
    }
    if(mov & 8) Y= *y+ *ysize-3; 
    if(mov) {
     setmouse(X,Y);
     setmouselim(0,0,X__max-4,Y__max-4);
     mov=0;
     putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,*xmax,*ymax,&percentx,&percenty,boxcol,options,1);
     
    }
    if(curon) marker(X,Y,CURON,editcol,markershape);
   }
   
   if(!buttons && (*ystart!=last_ystart || *xstart!=last_xstart)) {
    move_text(stream,xstart,ystart);
    last_ystart= *ystart;last_xstart= *xstart;        	    
   }
   buttons=0;
   readmouse(&buttons,&X,&Y);
  } while(!kbhit());
 }    
}

void init_resizable(stream,x,y,xsize,ysize,xmax,ymax,xfrom,yfrom,percentx,percenty)
FILE *stream;
int *x,*y,*xsize,*ysize,*xmax,*ymax,*xfrom,*yfrom;
long *percentx,*percenty;
{
 unsigned char line[132];

 if(*xmax<0) *xmax=2+(*xsize)/cs; 
 if(*ymax<0) {
  *ymax=0;         
  while(*ymax<2+(*ysize/cr)) {
   line[0]=0;
   if(!fgets(line,132,stream)) break;
   if(strlen(line)> *xmax) *xmax=strlen(line);
   (*ymax)+=1;
  }
 }
 init_menu(x,y,xsize,ysize,xmax,ymax,xfrom,yfrom,percentx,percenty);  
}

void show_text(stream,xstart,ystart)
FILE *stream;
int *xstart,*ystart;
{
 int t,xlen; 
 unsigned char line[132];

 rewind(stream);				     /* position file to */
 for(t=0;t<*ystart;t++) fgets(line,132,stream);	     /* the *ystart'th line */

 ykoord= Y1_min;xkoord=X1_min;
 while(1) {
  line[0]=0;
  if(fgets(line,132,stream)) {
   t=strlen(line)-1;
   if(line[t]==0x0a && line[t-1]==0x0d) line[t-1]=0; /* if carriage return, */
   else if(line[t]==0x0d) line[t]=0;        		/* truncate line */
   else if(line[t]==0x0a) line[t]=0;        		/* truncate line */

   replace_strange_characters(line);
   xlen=strlen(line)- *xstart;
   if(xlen>0) {
     
    if(X1_min+xlen*cs<X1_max)
     clearwin(X1_min+xlen*cs,ykoord,X1_max,ykoord+cr,bgcol);
      
     textnb(&line[*xstart],fg1col,bgcol); 
   }
   else clearwin(X1_min,ykoord,X1_max,ykoord+cr,bgcol);
   ykoord += cr;
   if(ykoord>Y1_max-cr) break;   
  }
  else {
   if(ykoord<Y1_max)  	
    clearwin(X1_min,ykoord,X1_max,Y1_max,bgcol);
   break;
  }
 }     
}

int show_one_line_of_text(line) char *line;
{
 int t; 

 t=strlen(line)-1;
 if(line[t]==0x0a && line[t-1]==0x0d) line[t-1]=0; /* if carriage return, */
 else if(line[t]==0x0d) line[t]=0;        		/* truncate line */
 else if(line[t]==0x0a) line[t]=0;        		/* truncate line */
 replace_strange_characters(line);

 textXYc(xkoord,ykoord,line,0,15);
 return 0;
}

void move_text(stream,xstart,ystart)
FILE *stream;
int *xstart,*ystart;
{
 int t,xlen; 
 unsigned char line[132];

 rewind(stream);				 /* position file to */
 for(t=0;t<*ystart;t++) fgets(line,132,stream);	 /* the *ystart'th line */

 ykoord= Y1_min;xkoord=X1_min;
 while(1) {
  line[0]=0;
  if(fgets(line,132,stream)) {
   t=strlen(line)-1;
   if(line[t]==0x0a && line[t-1]==0x0d) line[t-1]=0; /* if carriage return, */
   else if(line[t]==0x0d) line[t]=0;        		/* truncate line */

   replace_strange_characters(line);

   xlen=strlen(line)- *xstart;
   if(xlen>0) {
    if(X1_min+xlen*cs<X1_max)
     clearwin(X1_min+xlen*cs,ykoord,X1_max,ykoord+cr,bgcol);
    textnb(&line[*xstart],fgcol,bgcol);               
   }
   else clearwin(X1_min,ykoord,X1_max,ykoord+cr,bgcol);
   ykoord += cr;
   if(ykoord>Y1_max-cr) break;   
  }
  else {
   if(ykoord<Y1_max)
    clearwin(X1_min,ykoord,X1_max,Y1_max,bgcol);
   break;
  }   
 }     
}
/*****************************************************************
* put a replacement table to strangelist, so this routine will
* replace an excape sequence with an entry of the font in the table
******************************************************************/
int replace_strange_characters(line) char *line;
{
 int i,j,lim,found,k;
 char line2[132];
 char *p1,*p2;
 LETTERTABLE *p;char ch;

 if(!strangesize) return 0;

 p1=line;p2=line2;
 lim=strlen(line); 

 for(i=0;i<lim;i++) {
  if(*p1<0) { /* escape sequence */
   p=strangelist;found=0;
   for(j=0;j<strangesize;j++) {  
    if(p->escape[0]==*p1 && 
       ( p->escape[1]==*(p1+1) || p->escape[1]==0) ) {
     *p2=p->letter;
     p2++;
     if(p->escape[1]) p1+=2;
     else p1++;
     found=1;i++;
     break;
    }
    p+=sizeof(LETTERTABLE);
   }
   if(!found) { 
    printf("missing escape      %d %d\n",(int)*p1,(int)*(p1+1));
    printf("strangesize=%d strangelist=%d\n",strangesize,(int)strangelist);

    for(k=0;k<132 && line[k];k++) {
      ch=line[k];
      if(ch>0x18) printf("%c",ch);
      else printf("%d",(int)ch);
    }
    printf("\n");
    p1+=1;i++;  /* get over it */
    *p2='?';p2++;
   }
  }
  else {/* if not escape sequence, copy *p1 to *p2 */
   *p2= *p1;p1++;p2++;
  }
 }
 *p2=0; /* terminate line2 */
 strcpy(line,line2); /* replace the line with a corrected one */
 return 0;
}
