/*****************************************************************************
* O2B.C		CODE FOR WD_OBJECT TYPE input_window
* 
******************************************************************************/#include "x.ext"
#include "text.ext"
#include "win.ext"
#include "draw.ext"
#include "linuxpaths.ext"
extern unsigned char markerstore[45];
extern int xxmin,yymin,xxmax,yymax;
extern int extended_mem_enough;
extern char *balloc();
void init_input_resizable(),move_input1();

/**********************************************************
* The input_window wd_object-type has the 3 routines:
*	make_input_window
*	input_window
*	free_input_window
*
* The routine input_window calls the main window routine
* 	resizable_input_window 
* to do the work. It has subroutines 
*	move_input,init_input_resizable 
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
***********************************************************/
/**********************************************************
* The wd_object type input_window
***********************************************************/

int make_input_window(id,x,y,xsize,ysize,col1,col2,col3,col4,filename,bgnum,xmax,ymax,jmpf)
int id;
int x,y,xsize,ysize,col1,col2,col3,col4;
char *filename;
int bgnum;
int xmax,ymax;
int (*jmpf)();
{
 int i;
 i=id-1;if(i<0) return(1);
 
 wd_object[i].type=INPUTWIN_OBJ;
 wd_object[i].options=OBJECT_NOT_PUT;   
 wd_object[i].xcord=x;
 wd_object[i].ycord=y;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize;
 wd_object[i].xstart=0;
 wd_object[i].ystart=0;  
 wd_object[i].clength= -1;
 wd_object[i].isize= -1;   
 wd_object[i].ylength= -1;    
 wd_object[i].background=(char *)bgnum;     
 wd_object[i].foreground=(char *)1;      
 wd_object[i].col1=col1;  
 wd_object[i].col2=col2;
 wd_object[i].col3=col3;   
 wd_object[i].col4=col4;     
 strcpy(wd_object[i].name,filename);
 wd_object[i].i1= xmax;   
 wd_object[i].i2= ymax;
 zero_over(i);      
 wd_object[i].jmpf=jmpf;
 return(0);
}

int input_window(id,com_par)
int id,com_par;
{int ret;int i2;
 i2=wd_object[id-1].i2;
 ret=resizable_input_window(
  	&(wd_object[id-1].xcord),
 	&(wd_object[id-1].ycord),
 	&(wd_object[id-1].xsize),
 	&(wd_object[id-1].ysize),
 	&(wd_object[id-1].xstart),
 	&(wd_object[id-1].ystart),
 	&(wd_object[id-1].i1),
 	&i2,
 	wd_object[id-1].name, 		
       	&(wd_object[id-1].background),
       	&(wd_object[id-1].clength),
       	&(wd_object[id-1].isize),
       	&(wd_object[id-1].ylength),
       	(int)wd_object[id-1].col1,
       	(int)wd_object[id-1].col2,
       	(int)wd_object[id-1].col3,
       	(int)wd_object[id-1].col4,
       	&wd_object[id-1].options,
       	wd_object[id-1].jmpf,       	
	com_par,id);
 wd_object[id-1].i2=i2;
 return ret;
} 		

int free_input_window(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) {illegal_pointer(6);return(1);}
 remove_background(id);
 wd_object[i].type=FREE_OBJ;    
 return(0);      
}

/*********************************************************
* the window routine doing the work, and its subroutines
**********************************************************/
/******************************************************************************
*   resizable_input_window()
*   Description: x,y are coordinates where to put a window of ysize vertical
*                lines with xsize characters in a line. The window is read from
*                a file <file_name>. Window can be resized.
******************************************************************************/ 
int resizable_input_window(x,y,xsize,ysize,xstart,ystart,xmax,ymax,filename,
 backg_buf,clength,isize,ylength,bgcol1,boxcol,editcol,fgcol1,options,jmpf,mode,id)

int *x,*y,*xsize,*ysize,*xstart,*ystart,*xmax,*ymax;
char *filename,**backg_buf;
int *clength,*isize,*ylength;
int bgcol1,boxcol,editcol,fgcol1;
unsigned int *options;
int (*jmpf)();
int mode,id;
{
 int last_ystart,last_xstart,ret;
 long percentx,percenty;int save_options;

 extended_mem_enough=0;
 if(!(*options&NO_BRING_TO_TOP)) {       
  if(mode!=REFRESH) {
   if(extended_mem_enough) { 
    /* if there is not enough memory, skip the background */
    if(make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,mode)) {
     return 2;
    }
   }
  }
 }
 bgcol=bgcol1;fgcol=fgcol1;
 truncate1=1;
 X1_min=*x;Y1_min=*y;X1_max=*x+*xsize;Y1_max=*y+*ysize;  
 xxmin=X1_min+11;yymin=Y1_min+11;xxmax=X1_max-5;yymax=Y1_max-5; 
 xkoord= *x;ykoord= *y;
 last_xstart= *xstart;last_ystart= *ystart;

 /* this routine works in the following way: Code for scrolling etc. is here */
 /* but for the actions inside the window a jumpfunction is called           */

 init_input_resizable(x,y,xsize,ysize,xmax,ymax,xstart,ystart,
   &percentx,&percenty);

 if(mode==DRAW_ONLY_DO_NOT_STAY || mode==REFRESH) {

  if(!(*options&NO_BRING_TO_TOP)) { 

   clearwin(*x,*y,*x+ *xsize,*y+ *ysize-1,bgcol); 

   putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,
    *xmax,*ymax,&percentx,&percenty,boxcol,*options,0); 

   /* ACTIONS ARE HERE: calling jumpfunction in the application */
   save_options=wd_object[id-1].options;
   wd_object[id-1].options=OBJECT_NOT_PUT; /* cheat the jumpfunc to write */
   (*jmpf)();
   wd_object[id-1].options=save_options;     
   return(-2); /* exit, do nothing */
  }
 }
 mov=0; 
 *options |=NO_BRING_TO_TOP;
 
 while(1) {	
  do {
   if(!buttons){
    if(curon) {marker(X,Y,CUROFF,editcol,markershape);curon=0;}   	
    if(mouse_off) {showmouse();mouse_off=0;}
   }
   else {
    if(!mouse_off) {hidemouse();mouse_off=1;}
    if(!(*options & NO_RESIZING)) {
     mov=check_resizing(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,&markershape);
    }
    else mov=0;
    if(!mov) {
     if(curon) {marker(X,Y,CUROFF,editcol,markershape);curon=0;}

     ret=check_scrolling(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,
    	xstart,ystart,&percentx,&percenty,*xmax,*ymax,bgcol,boxcol,*options);
    	
     if(ret== -2) { /* pointer pressed outside the window */
      return(-2); /* exit, do nothing */
     }
     else if(ret== -1) { /* pointer pressed inside the window */
      xxmin=X1_min+11;yymin=Y1_min+11;xxmax=X1_max-5;yymax=Y1_max-5;
      /* ACTIONS ARE HERE: calling jumpfunction in the application */
      (*jmpf)();
      /* what if we stay here ? */
      /* return(-2); */ /* exit, do nothing */      
     }     
     else if(ret==2) { /* move window marker pressed */	
      if(buttons==1) return(0); /* operations */           	
      if(buttons==2) return(-4); /* move window */	
     }
     else if(ret==1) { /* kill window marker pressed */
      if(buttons==2) {
      	if(*options & NO_ICONIZING) return(-2); /* do nothing */
      	return(-3); /* make icon */      
      }
      if(*options & NO_KILLING) return(-2); /* do nothing */
      if(buttons==1) return(-1); /* kill window */
     }	
    }
    else {
     if(!curon) {marker(X,Y,CURON,editcol,markershape);curon=1;}
     else marker(X,Y,CURMOVE,editcol,markershape); 
    }
   }  	
  
   if(mov) {
    if(curon) marker(X,Y,CUROFF,editcol,markershape);   	
    update_backgrnd(x,y,xsize,ysize,clength,isize,ylength,backg_buf,
     &mov,bgcol,boxcol);
    if(mov & 1) {
     clearwin(X1_max-4-cs,Y1_min+11,X1_max-4,Y1_max-5,bgcol);
     refresh_cvobj(X1_max-4-cs,Y1_min+11,X1_max-4,Y1_max-5);     
     X= *x+ *xsize-2; 
    }
    if(mov & 2) X= *x+ *xsize-3;
    if(mov & 4) {
     clearwin(X1_min+11,Y1_max-5-cr,X1_max-4,Y1_max-5,bgcol);
     refresh_cvobj(X1_min+11,Y1_max-5-cr,X1_max-4,Y1_max-5);     
     Y= *y+ *ysize-2;
    }
    if(mov & 8) Y= *y+ *ysize-3; 
    if(mov) {
     setmouse(X,Y);
     setmouselim(0,0,X__max-4,Y__max-4);
     mov=0;
     putWinFrame(*x,*y,*ysize,*xsize,*xstart,*ystart,*xmax,*ymax,
      &percentx,&percenty,boxcol,*options,1);
    }
    if(curon) marker(X,Y,CURON,editcol,markershape);
   }
   
   if(*ystart!=last_ystart || *xstart!=last_xstart) {

    /* we do not now go to move_input1, but rewrite with the jmpfunc */
    clearwin(*x+2*cs,*y+2*cs,*x+ *xsize-cs,*y+ *ysize-cs,bgcol); 
    wd_object[id-1].ystart=*ystart;
    save_options=wd_object[id-1].options;
    wd_object[id-1].options=OBJECT_NOT_PUT; 
    (*jmpf)();
    wd_object[id-1].options=save_options;     
   /*
    move_input1(*xstart-last_xstart,*ystart-last_ystart);
   */
    last_ystart= *ystart;last_xstart= *xstart;        	    
   }
   buttons=0;
   readmouse(&buttons,&X,&Y);
  } while(!kbhit());
 }    
}

void init_input_resizable(x,y,xsize,ysize,xmax,ymax,
xfrom,yfrom,percentx,percenty)
int *x,*y,*xsize,*ysize,*xmax,*ymax,*xfrom,*yfrom;
long *percentx,*percenty;
{
 unsigned char line[132];

 if(*xmax<0) *xmax=2-(*xsize)/cs; 
 if(*ymax<0) *ymax= 2-(*ysize)/cr;
   
 if(*xmax>0) *percentx=((*xfrom)<<MAGFACT)/(*xmax);else *percentx=0;
 if(*ymax>0) *percenty=((*yfrom)<<MAGFACT)/(*ymax);else *percenty=0;  
}

void move_input1(xoff,yoff) int xoff,yoff; 
{
 VECTOR_OBJECT *ob;
 int y1min,y1max,x1min,x1max,x2min,x2max,xoff3;

 y1min=Y1_min+11;y1max=Y1_max-5; 
 x1min=X1_min+11;x2min=x1min&7;if(x2min) x1min=x1min-x2min+8;
 x1max=X1_max-4;x2max=x1max&7;x1max=x1max-x2max;
 xoff3=xoff*8;
 if(!fgbuffer) {
  illegal_pointer(33);return;
 }
 
 for(ob=firstvobj;ob;ob=ob->next) {
  ob->x1+=xoff3;ob->x2+=xoff3;
  ob->y1+=yoff*cr;ob->y2+=yoff*cr;  
 }
  
/* xoff!=0 yoff=0 */ 
 if(xoff>0) {
  if(x1min<x1max-xoff3-1) { 	
   if(x2max) {
    save_buf2(x1max-xoff3,y1min,0,0,x2max,y1max-y1min,0,1,4,fgbuffer);
    draw_buf2(x1max,y1min,0,0,x2max,y1max-y1min,0,1,4,fgbuffer);
   }   
   movewin(x1min,y1min,x1max-xoff3-1,y1max,x1min+xoff3,y1min);
   if(x2min) {
    save_buf2(X1_min+11,y1min,0,0,8-x2min,y1max-y1min,x2min,1,4,fgbuffer);
    draw_buf2(X1_min+11+xoff3,y1min,0,0,8-x2min,y1max-y1min,x2min,1,4,
     fgbuffer);  	    
   }
  }   
  if(X1_min+11+xoff3<X1_max-4) {
   clearwin(X1_min+11,y1min,X1_min+11+xoff3,y1max,bgcol);
   refresh_cvobj(X1_min+11,y1min,X1_min+11+xoff3,y1max);        
  }
  else {
   clearwin(X1_min+11,y1min,X1_max-4,y1max,bgcol);
   refresh_cvobj(X1_min+11,y1min,X1_max-4,y1max);
  }
 }
 else if(xoff<0) {
  if(x1min-xoff3<x1max-1) { 	   	
   if(x2min) {
    save_buf2(X1_min+11-xoff3,y1min,0,0,8-x2min,y1max-y1min,x2min,1,4,
     fgbuffer);  	
    draw_buf2(X1_min+11,y1min,0,0,8-x2min,y1max-y1min,x2min,1,4,
     fgbuffer);  	    
   } 	
   movewin(x1min-xoff3,y1min,x1max-1,y1max,x1min,y1min);
   if(x2max) {
    save_buf2(x1max,y1min,0,0,x2max,y1max-y1min,0,1,4,fgbuffer);  	
    draw_buf2(x1max+xoff3,y1min,0,0,x2max,y1max-y1min,0,1,4,
     fgbuffer);  	    
   }
  }   
  if(X1_max-4+xoff3>X1_min+11) {
   clearwin(X1_max-4+xoff3,y1min,X1_max-4,y1max,bgcol);
   refresh_cvobj(X1_max-4+xoff3,y1min,X1_max-4,y1max);   
  }
  else {
   clearwin(X1_min+11,y1min,X1_max-4,y1max,bgcol);
   refresh_cvobj(X1_min+11,y1min,X1_max-4,y1max);   
  }   
 } 

/* xoff=0 yoff!=0 */ 
 if(yoff>0) {
  if(y1min<y1max-yoff*cr) {
   if(x2max) {
    save_buf2(x1max,y1min,0,0,x2max,y1max-yoff*cr-y1min,0,1,4,fgbuffer); 
    draw_buf2(x1max,y1min+yoff*cr,0,0,x2max,y1max-yoff*cr-y1min,0,1,4,
     fgbuffer);  	    
   }   
   movewin(x1min,y1min,x1max-1,y1max-yoff*cr,x1min,y1min+yoff*cr);
   if(x2min) {
    save_buf2(X1_min+11,y1min,0,0,8-x2min,y1max-yoff*cr-y1min,x2min,1,4,
     fgbuffer);  	
    draw_buf2(X1_min+11,y1min+yoff*cr,0,0,8-x2min,y1max-yoff*cr-y1min,
     x2min,1,4,fgbuffer);  	    
   }
  }   		
  if(y1min+yoff*cr<y1max) {
   clearwin(X1_min+11,y1min,X1_max-4,y1min+yoff*cr,bgcol); 
   refresh_cvobj(X1_min+11,y1min,X1_max-4,y1min+yoff*cr); 
  }   
  else {
   clearwin(X1_min+11,y1min,X1_max-4,y1max,bgcol); 
   refresh_cvobj(X1_min+11,y1min,X1_max-4,y1max); 
  }   
 }
 else if(yoff<0) {
  if(y1min-yoff*cr<y1max) {
   if(x2max) {
    save_buf2(x1max,y1min-yoff*cr,0,0,x2max,y1max+yoff*cr-y1min,0,1,4,
     fgbuffer);  	
    draw_buf2(x1max,y1min,0,0,x2max,y1max+yoff*cr-y1min,0,1,4,fgbuffer); 
   }   
   movewin(x1min,y1min-yoff*cr,x1max-1,y1max,x1min,y1min);
   if(x2min) {
    save_buf2(X1_min+11,y1min-yoff*cr,0,0,8-x2min,y1max+yoff*cr-y1min,
     x2min,1,4,fgbuffer);  	
    draw_buf2(X1_min+11,y1min,0,0,8-x2min,y1max+yoff*cr-y1min,x2min,
     1,4,fgbuffer);  	    
   }
  }
  if(y1max+yoff*cr>=y1min) {
   clearwin(X1_min+11,y1max+yoff*cr,X1_max-4,y1max,bgcol); 
   refresh_cvobj(X1_min+11,y1max+yoff*cr,X1_max-4,y1max);    
  }
  else {
   clearwin(X1_min+11,y1min,X1_max-4,y1max,bgcol);    
   refresh_cvobj(X1_min+11,y1min,X1_max-4,y1max);    
  }   
 }
}

