/*****************************************************************************
* O3.C		CODE FOR WD_OBJECT TYPE card
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
extern int gplanes;
extern XColor *xcolor;
short homex,homey;
static int tracecount;
extern int debug311;
int spider_xoff;
void flip_card();
void savetrace();
/**********************************************************
* The card wd_object-type has the 3 routines:
*	make_card
*	draw_card
*	free_card
*
* The routine draw_card contains the main window routine
* to do the work. It has subroutines 
*	flip_card
* 
* There are useful subroutines 
*	cardname
*	load_onef
*	load_onef2
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
*
* As an example there are playcard filling routines
*	load_one_card
*	load_card_back   
***********************************************************/
/**********************************************************
* The wd_object type card
***********************************************************/
int make_card(id,xcord,ycord,file_name)
int id,xcord,ycord;
char *file_name;
{
 int i;
 i=id-1;if(i<0) return(1);
 	
 wd_object[i].type=CARD_OBJ;
 wd_object[i].options=BACKG_IN_FILE;  
 wd_object[i].options|=OBJECT_NOT_PUT;   
 wd_object[i].xcord=xcord;
 wd_object[i].ycord=ycord;      
 wd_object[i].xsize=XSIZE; 
 wd_object[i].ysize=YSIZE;
 wd_object[i].clength=(XSIZE/8+1); 
 wd_object[i].isize=ISIZE;  
 wd_object[i].ylength= YSIZE;     
 wd_object[i].i4=0; /* use this for flip indication */     
 strcpy(wd_object[i].name,file_name);
 zero_over(i);
 wd_object[i].background=
  balloc((long)(wd_object[i].ysize+1)*wd_object[i].clength*GPLANES);
 wd_object[i].foreground=fgbuffer; 
 wd_object[i].p2=(char **)tplane1;      
 return(0);
}


test_buffer(i) int i;
{
 int j,m,shift,n,clength,xsize,isize,byte;
 char *buf;unsigned long pixel;

 clength=wd_object[i].clength;
 xsize=wd_object[i].xsize;
 isize=GPLANES*clength;
   
 for(j=0;j<wd_object[i].ysize;j++) {
  buf=wd_object[i].background+j*isize;
  for(m=0;m<xsize;m++) { 

   shift=m%8;pixel=0;
   for(n=23;n>=0;n--) {
    byte=*(buf+m/8+n*clength);
    byte=(byte>>(7-shift));
    pixel +=(byte&0x01)<<(23-n); 
   }
   printf("pixel (%d, %d)\n",m,j);
   printf("red  =%d\n",0xff&(pixel>>16));
   printf("green=%d\n",0xff&(pixel>>8));
   printf("blue =%d\n",0xff&(pixel));
  }
 }
}


int draw_card(id,com_par)
int id,com_par;
{
 int j;
 char *fg_buf;
 int xcur,ycur;

 if(id<2 || !wd_object[id-1].background || !wd_object[id-1].foreground ||
 	!wd_object[id-1].p2) {
   printf("draw_card:error id=%d\n",id);
   if(id && id<=MAX_WINDOWS) {
    printf("wd_object[id-1].background=%d\n",(int)wd_object[id-1].background);
    printf("wd_object[id-1].foreground=%d\n",(int)wd_object[id-1].foreground);
    printf("wd_object[id-1].p2=%d\n",(int)wd_object[id-1].p2);
   }
  illegal_pointer(20);
  return(-2);
 }    	
 if(com_par==DRAW_ONLY_DO_NOT_STAY || com_par==REFRESH) {
  get_foreground(id-1); 
  if(buttons==2) {
   if(!(wd_object[id-1].options & NO_FLIPPING_OVER)) {
    flip_card(id-1);
    homex=wd_object[id-1].xcord;homey=wd_object[id-1].ycord;
    savetrace(id,2,homex,homey,0,0);
   }
   else {
    if(id!=MAX_WINDOWS) 
    {xkoord=100;ykoord=100;textn("forbidden turning",15,0);}
   }
  }

  if(com_par!=REFRESH) {
   movingPicture(wd_object[id-1].xcord,wd_object[id-1].ycord,0,id);
  }
  else {
   j=id-1;
   draw_buf2(wd_object[j].xcord,wd_object[j].ycord,0,0,
   	wd_object[j].xsize,wd_object[j].ysize,wd_object[j].xcord&7,
   	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);     
  }
  return(-2); /* do nothing */
 }
 else {
  if(buttons==2) { /* trying to flip the card */
   if(!(wd_object[id-1].options & NO_FLIPPING_OVER)){
    if(wd_object[id-1].options & WINDOW_HIDDEN) {
     flip_card(id-1);
     homex=wd_object[id-1].xcord;homey=wd_object[id-1].ycord;
     savetrace(id,2,homex,homey,0,0);
     xcur=wd_object[id-1].xcord;ycur=wd_object[id-1].ycord; 
     draw_buf2(xcur,ycur,0,0,(int)wd_object[id-1].xsize,
        (int)wd_object[id-1].ysize,xcur%8,wd_object[id-1].clength,
        wd_object[id-1].isize,wd_object[id-1].foreground);
     return(-2); /* do nothing */  	
    }
    else { 
     printf("draw_card: error, not hidden window %d,fixing\n",id);
     wd_object[id-1].options |= WINDOW_HIDDEN;
     update_over(id);
     return -2;
    }
   }
   else {
    /* the only card that has NO_FLIPPING_OVER on is the pack */
    if(id!=MAX_WINDOWS) 
    {xkoord=80;ykoord=100;textn("draw_card:error, 1",0,15);}

    /* if i4 is on, background is shown, this cannot be so with a pack */
    if(wd_object[id-1].i4)
    {xkoord=80;ykoord=100;textn("draw_card:error, 2",0,15);}
    return(-4); /* it is a pack, so move card */
   }
  }
  else return(-4); /* move card */
 }
}

int free_card(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) return(1);
 movingPicture(0,0,2,id); 
 wd_object[i].type=FREE_OBJ;   
 if(wd_object[i].background) {
  b_free(wd_object[i].background);
  wd_object[i].background=0;
 }
 return(0);      
}

/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/
/* main routine is draw_card */

void flip_card(i) int i;
{ 
 int j;
 char *fg_buf;
 
 wd_object[i].i4 ^=1; /* if background shown, then i4=1 */
  
 if(!wd_object[i].i4) {
  wd_object[i].foreground=fgbuffer;
  wd_object[i].p2=(char **)tplane1;
  gplanes=4;get_foreground(i);
 }
 else {
  wd_object[i].foreground=(char *)tplane1;
  wd_object[i].p2=(char **)fgbuffer;
  gplanes=4;load_card_back(1,tplane1); 
 }
}

/***************************************************
* useful subroutines
****************************************************/
int cardname(filename,id)
char *filename;
int id;
{
 long id1;
 
 if(id<=0) strcpy(filename,"blanko");
 else { 	
  strcpy(filename,"pcard");
  if(id<=13) {id1=id;strcat(filename,"d");}
  else if(13<id && id<=26) {id1=id-13;strcat(filename,"s");}
  else if(26<id && id<=39) {id1=id-26;strcat(filename,"h");}
  else if(39<id && id<=52) {id1=id-39;strcat(filename,"c");}   

  else if(52<id && id<=65)   {id1=id-52;strcat(filename,"d");}
  else if(65<id && id<=78)   {id1=id-65;strcat(filename,"s");}
  else if(78<id && id<=91)   {id1=id-78;strcat(filename,"h");}
  else if(91<id && id<=104)  {id1=id-91;strcat(filename,"c");}   

#ifdef WINDOW_MAX_256
  else if(104<id && id<=117) {id1=id-104;strcat(filename,"d");}
  else if(117<id && id<=130) {id1=id-117;strcat(filename,"s");}
  else if(130<id && id<=143) {id1=id-130;strcat(filename,"h");}
  else if(143<id && id<=156) {id1=id-143;strcat(filename,"c");}   

  else if(156<id && id<=169) {id1=id-156;strcat(filename,"d");}
  else if(169<id && id<=182) {id1=id-169;strcat(filename,"s");}
  else if(182<id && id<=195) {id1=id-182;strcat(filename,"h");}
  else if(195<id && id<=208) {id1=id-195;strcat(filename,"c");}   
#endif
  else {
   printf("cardname error id=%d\n",id);
   osprints("load, erroneous id",10,60);getch();
   return(1);}
  if(id1>13) printf("erroneous id1=%d\n",id1);  
  strcat(filename,int_to_string(id1));
  strcat(filename,".fn2");
 }
 return(0);
}
int load_onef2(buf,file_name2)
char *buf;
char *file_name2;
{
 int i,j;
 FILE *stream;
 int clength,xsize,shift,n,m,color,byte,isize1,isize2;
 unsigned long pixel;char *buf1,*buf2;

 strcat(file_name2,".fn2");
 stream=fopen(file_name2,"r+b"); 	
 if (!stream)
 {  
  osprints("load_onef2, error opening ",10,60);
  osprints(file_name2,8*24+10,60);      
  getch();                     
  return(1);
 } 
 fseek(stream,8,0);
 if(GPLANES==4) { /* in DOS */
  for(j=0;j<YSIZE;j++) {
   fread((char *)(buf+ISIZE*j),1,(long)(gplanes*(XSIZE/8+1)),stream);
  }
 } 	
 else if(GPLANES==24 && gplanes==4) { /* much harder in X11 */
  clength=XSIZE/8+1;
  xsize=XSIZE;
  isize1=gplanes*clength;
  isize2=GPLANES*clength;
   
  /* wd_object[i].isize=isize2; do this at calling routine if needed */
   
  buf1=malloc(isize1); /* this is 7*4=28 bytes */
  if(!buf1) {printf("no memory\n");exit(1);}

  for(j=0;j<YSIZE;j++) {
    /* read one j data to buf */
   if(isize1!=fread(buf1,1,(long)isize1,stream)) {file_error(1);return(1);}
    /* then copy buf to fg_buf so that there are 24 color planes */
   for(m=0;m<xsize;m++) { /* loop over horizontal pixels */

     /* get the color of each 4-color plane pixel */
    shift=m%8;color=0;
    for(n=gplanes-1;n>=0;n--) {
     byte=*(buf1+m/8+n*clength);
     byte=(byte>>(7-shift));
     color +=(byte&0x01)<<n; 
    }
    if(color==3) color=4; /* the palette was different */

    /* color is a four bit color at (m,j) */
    pixel=xcolor[color].pixel;
    /* pixel has 24 bits as RGB, the 24 color planes */

    buf2=buf+j*isize2;

    for(n=GPLANES-1;n>=0;n--) {
     color=(pixel>>(23-n))&0x01;
     byte=color<<(7-shift);
     if(!shift) *(buf2+m/8+n*clength) =byte;
     else  *(buf2+m/8+n*clength) +=byte;
    }     
   }
  }
  gplanes=GPLANES;
  free(buf1);
 }
 fclose(stream);     
 return(0);
}

int load_onef(id,xcord,ycord,file_name)
int id,xcord,ycord;
char *file_name;
{
int i,j;
FILE *stream;
char file_name2[30];

 strcpy(file_name2,file_name);  
 strcat(file_name2,".fn2");
 
 stream=fopen(file_name2,"r+b"); 	
 if (!stream)
 {  
  osprints("load_onef, error in opening ",10,60);
  osprints(file_name2,8*24+10,60);      
  getch();                     
  return(1);
 } 

 if(id>0) {
  fseek(stream,8,0);	   	
  for(j=0;j<YSIZE;j++) {
   fread(plane1+j*ISIZE,1,(long)(gplanes*(XSIZE/8+1)),stream);
  } 	
  fclose(stream);       
  wd_object[id-1].type=CARD_OBJ;
  wd_object[id-1].options=0;  
  wd_object[id-1].xsize=XSIZE; 
  wd_object[id-1].ysize=YSIZE;
  wd_object[id-1].clength=(XSIZE/8+1); 
  wd_object[id-1].isize=ISIZE;
  zero_over(id-1);  
  wd_object[id-1].xcord=xcord;
  wd_object[id-1].ycord=ycord;       
  movingPicture(wd_object[id-1].xcord,wd_object[id-1].ycord,0,id);
  pushf_to_shadow(id,file_name);  
  update_over(id); /* window not hidden, options=0 */     
 }
 else {
  fseek(stream,8,0);
  for(j=0;j<YSIZE;j++) {
   fread(plane1+j*ISIZE,1,(long)(gplanes*(XSIZE/8+1)),stream);
  }        
  draw_buf2((int)xcord,(int)ycord,(int)0,(int)0,
  		(int)XSIZE,(int)YSIZE,(int)xcord%8,7,100,plane1); 	

  fclose(stream);      	
 }
 return(0);
}

/*****************************************************************
* Example of a fill routine
******************************************************************/
int load_one_card(id,xcord,ycord,flip)
int id,xcord,ycord,flip;
{
 long id1;	
 char file_name[30];

 cardname(file_name,id-1);
 make_card(id,xcord,ycord,file_name);
 wd_object[id-1].i4=0;
 if(flip) buttons=2;
 else buttons=0; 
 put_wd_objects(id,id);
 wd_object[id-1].i4=flip;
 return(0);
}

int load_card_back(id,buf)
int id;
char *buf;
{
 char file_name2[30];

 strcpy(file_name2,"pcard");
 strcat(file_name2,"b");   
 strcat(file_name2,int_to_string((long)id)); 
 
 return(load_onef2(buf,file_name2)); 	
}

/*****************************************
 * trace of a game is saved
 * to take a move back we must know the id
 * of the card and where it was before the 
 * move. The old place is homex,homey.
 * the new place is in coordinates of id.
 *****************************************/
void savetrace(id,res,xnew,ynew,order3,max) 
     int id;int res;int xnew,ynew;int *order3;int max;
{
 char line[60];
 FILE *stream;
 int j;

 /* cannot open the trace at the end, since it is possible to take moves */
 /* back, and it is done so that they also disappear from the trace      */
 stream=fopen("trace.tmp","rb+");
 if(!stream) return;       /* the file exists as inititrace was called */
 for(j=0;j<tracecount;j++) fgets(line,60,stream); 
 /* line has the last move that was not taken back */

 if(res==1) { /* normal or pack move */
  strcpy(line,int_to_string((long)id));
  strcat(line," ");
  strcat(line,int_to_string((long)homex));
  strcat(line," ");
  strcat(line,int_to_string((long)homey));
  strcat(line," ");
  strcat(line,int_to_string((long)xnew));
  strcat(line," ");
  strcat(line,int_to_string((long)ynew));
  strcat(line,"\n");
 }
 else if(res==2) { /* flip */
  strcpy(line,int_to_string((long)id));
  strcat(line," ");
  strcat(line,int_to_string((long)homex));
  strcat(line," ");
  strcat(line,int_to_string((long)homey));
  strcat(line," flip\n");
 }
 else if(res==-1) {
  /* bound of type suite, id must be an ace */
  /* bound id x y list of ids (2,3,...,13)  */
  if((id-2)%13) printf("savetrace: wrong usage id=%d not an ace\n",id);
  strcpy(line,"bound ");
  strcat(line,int_to_string((long)id));
  strcat(line," ");
  strcat(line,int_to_string((long)xnew));
  strcat(line," ");
  strcat(line,int_to_string((long)ynew));
  for(j=0;j<max;j++) {
   strcat(line," ");
   strcat(line,int_to_string((long)order3[j]));
  }
  strcat(line,"\n");
 }
 else if(res==-2) { 
  /* absolute bound of type bound 0, not to be crossed */
  strcpy(line,"bound 0\n");
 }
 else if(res==-3) { /* bound of type deal */
  /* bound 0 list of dealt card ids in inverse order (last as first) */
  strcpy(line,"bound 0");
  if(id) printf("savetrace: error, wrong usage id=%d not zero \n",id);
  for(j=0;j<=max;j++) {
   strcat(line," ");
   strcat(line,int_to_string((long)order3[max-j]));
  }
  strcat(line,"\n");
 }
 else printf("savetrace:unrecognized command\n");

 if(debug311) printf("savetrace: tracecount=%d move=%s\n",tracecount,line);
 fputs(line,stream);
 fclose(stream);
 tracecount++;
}


int take_move_back(current,deck,deckmax,spider) 
int *current;unsigned char *deck;int deckmax,spider;
{
 int i,id,id2;char *p,*q,*p1;char line[60];FILE *stream;
 int xold,yold,xnew,ynew,j;
 int max11,id_move,order11[14];
 
 stream=fopen("trace.tmp","rb");
 if(!stream) return 1;
 for(i=0;i<tracecount;i++) fgets(line,60,stream); 
 fclose(stream);
 /* line is the last move */
 if(debug311) 
  printf("take_move_back: tracecount=%d line=%s\n",tracecount,line);
 line[strlen(line)-1]=0; /* remove the carriage return */

 if(!strncmp(line,"bound",5)) {
  p=strchr(line,(int)' ');
  if(!p) return 1; /* trace corrupted */
  q=strchr(p+1,(int)' ');
  if(q) *q=0;
  id=string_to_int(p+1);
  if(!q) { /* type bound 0 */
   return 1; /* will not go futher back */
  }
  if(!id) { /* deal cards, list of ids follows */
   for(i=0;i<10;i++) {
    p=strchr(q+1,(int)' ');
    if(p) *p=0;
    id2=string_to_int(q+1);
    /* we are not physically moving the card, just freeing it   */
    /* lift up a card (save background,hide,release from stack) */
    if_b_opt_bgfromfile(id2);
    wd_object[id2-1].options ^= WINDOW_HIDDEN;
    update_over(id2); 
    free_one_wd_object(id2);
    if(*current>0) {(*current)-=1;deck[*current]=id2;}
    if(!p) break;
    q=p;
   }
   tracecount--;
   /* draw the card back on upper left corner */ 
   draw_buf2(40,10,0,0,XSIZE,YSIZE,40&7,XSIZE/8+1,ISIZE,tplane1);
   return 0;
  }
  else if(spider) { /* full suite, bound id x y id2 id3.... */
    /* id is an ace */
   p=strchr(q+1,(int)' ');
   if(!p) return 1; /* trace corrupted */
   *p=0;
   xnew=string_to_int(q+1);
   q=p;
   p=strchr(q+1,(int)' ');
   if(!p) return 1; /* trace corrupted */
   *p=0;
   ynew=string_to_int(q+1);
   q=p;
   /* xnew and ynew are coordinates of the ace id */
   order11[0]=id;
   for(max11=1;max11<=12;max11++) {
    p=strchr(q+1,(int)' ');
    if(p) *p=0;
    id2=string_to_int(q+1);
    order11[max11]=id2;
    q=p;
   }
   /* remove the king */
   id2=order11[12];
   if_b_opt_bgfromfile(id2);
   wd_object[id2-1].options ^= WINDOW_HIDDEN;
   update_over(id2); 
   free_one_wd_object(id2);
   /* put back the suite */
   for(max11=12;max11>=0;max11--) {
    id2=order11[max11];
    gplanes=4;load_one_card(id2,xnew,ynew-max11*YDIF,0);
   }
   tracecount--;
   return 0;
  }
  return 1;
 }
 tracecount--;
 p=strchr(line,(int)' ');
 if(!p) return 1; /* trace corrupted */
 *p=0;
 id=string_to_int(line);
 q=strchr(p+1,(int)' ');
 if(!q) return 1; /* trace corrupted */
 *q=0;
 p1=strchr(q+1,(int)' '); /* is it flip command */
 if(p1) *p1=0;  
 homex=string_to_int(p+1);
 homey=string_to_int(q+1);
 if(!id) return 1; /* trace corrupted */
 xold=wd_object[id-1].xcord;
 yold=wd_object[id-1].ycord;

 if(p1 && !strncmp(p1+1,"flip",4)) {
  flip_card(id-1);   
  draw_buf2(xold,yold,0,0,(int)wd_object[id-1].xsize,
        (int)wd_object[id-1].ysize,xold%8,wd_object[id-1].clength,
        wd_object[id-1].isize,wd_object[id-1].foreground);
 }
 else {
  /* pick up id */

  id_move=move_pack((int)wd_object[id-1].xcord,(int)wd_object[id-1].ycord,
	     order11,&max11,0,MAX_WINDOWS);
  if(id_move==id) { /* the card id was on top, could be moved alone */
   /* move_pack lifts up the card, but does not take background */ 
   if(!(wd_object[id-1].options&WINDOW_HIDDEN)) {
    printf("take_move_back:this should not happen, card not hidden\n");
    wd_object[id-1].options^=WINDOW_HIDDEN;
    update_over(id);    
   }
   if_b_opt_bgfromfile(id);
   gplanes=4;get_foreground(id-1);gplanes=GPLANES;
   /* move it back */
   for(j=0;j<=8;j++) {
    xnew= ((8-j)*xold+j*homex)>>3;
    ynew= ((8-j)*yold+j*homey)>>3;
    movingPicture(xnew,ynew,1,id);
   }
   /* put id down */
   if_b_opt_bgtofile(id);
   wd_object[id-1].options^=WINDOW_HIDDEN;
   update_over(id);
   if(wd_object[id-1].options&WINDOW_HIDDEN)
    printf("take_move_back:error, card down and hidden\n");

  }
  else if(id_move==MAX_WINDOWS) { /* pack move */
   /* move_pack created a new pack card, which is hidden and not on stack */

   /* foreground is not correct in the foreground buffer */
   save_buf2(xold,yold,0,0,
     wd_object[id_move-1].xsize,wd_object[id_move-1].ysize,xold%8,
     wd_object[id_move-1].clength,
     wd_object[id_move-1].isize,
     wd_object[id_move-1].foreground);

   /* move it back */
   for(j=0;j<=8;j++) {
    xnew= ((8-j)*xold+j*homex)>>3;
    ynew= ((8-j)*yold+j*homey)>>3;
    movingPicture(xnew,ynew,1,id_move);
   }
   /* break the pack into cards */
   put_pack(max11,order11,MAX_WINDOWS);
  }
 }
 return 0;
}

/*******************************************
 * going move forward based on the trace is
 * almost the same as going backward
 * the main difference is treatment of bound
 *******************************************/
int go_move_forward(current,deck,deckmax,spider) 
int *current;unsigned char *deck;int deckmax,spider;
{
 int i,id,id2,k,lasti,empty,x1,y1;
 char *p,*q,*p1;char line[60];FILE *stream;
 int xold,yold,xnew,ynew,j,found;
 int max11,id_move,order11[14];
 
 stream=fopen("trace.tmp","rb");
 if(!stream) return 1;
 for(i=0;i<tracecount+1;i++) fgets(line,60,stream); 
 fclose(stream);
 /* line is the next move */
 if(debug311) 
  printf("go_move_forward: tracecount=%d line=%s\n",tracecount,line);

 if(!strncmp(line,"bound",5)) {
   /* bound id x y     or bound 0   or bound 0 id1 id2 ... */
  line[strlen(line)-1]=0; /* remove the carriage return */
  p=strchr(line,(int)' ');
  if(!p) return 1; /* trace corrupted */
  q=strchr(p+1,(int)' ');
  if(q) *q=0;
  id=string_to_int(p+1);
  if(!id) {  /* bound */ 
   tracecount++;
   if(q) { /* must be bound 0 id1 id2... , that is: deal cards */
    if(!spider) { 
     if(*current>deckmax) {
      /* all cards dealt, take what remains to the deck and deal again */
      while(1) {
       /* take the top card on x=130,y=40 */
       i=pop_up_wanted(130,40);
       if(!i) break; /* no cards, stop */
       /* lift up a card (save background,hide,release from stack) */
       if_b_opt_bgfromfile(i);
       wd_object[i-1].options ^= WINDOW_HIDDEN;
       update_over(i); 
       /* free the card, it will be put again later */
       free_one_wd_object(i);
       if(*current>0) {(*current)-=1;deck[*current]=i;}
      }
      /* draw the card back on upper left corner */ 
      draw_buf2(40,10,0,0,XSIZE,YSIZE,40&7,XSIZE/8+1,ISIZE,tplane1);
     }
     /* deal 3 (or how many remains) cards on the upper level */
     for(i= *current;i< *current+3;i++) {
      if(i>deckmax) break;
      gplanes=4;
      id2=(int)deck[i];
      load_one_card(id2,100+12*((i- *current)%3),10+10*((i- *current)%3),0);
     }
     *current += 3;
    }
    else { /* spider, deal 10 cards, one on top of each existing card */
     for(i=*current;i<=deckmax && i<*current+10;i++) {
      x1=XPOS*(i-*current)+XOFF;
      for(j=40;j>=0;j--) {
       y1=YPOS+YDIF*j+YSIZE-1;
       if(any_card(x1,y1)) break;
      }
      y1=YPOS+YDIF*(j+1);
      gplanes=4;
      id2=(int)deck[i];
      load_one_card(id2,x1,y1,0);
     }
     *current +=10;
    }      
   }
   /* if deck is over, draw empty rectangle */
   if(*current>deckmax) {
    fillbox2(40,10,XSIZE,YSIZE,xcolor[2].pixel); 
    rectangle(40,10,40+XSIZE,10+YSIZE,0);
   }
   return 0;
  }
  p1=strchr(q+1,(int)' '); 
  if(p1) *p1=0;  
  xnew=string_to_int(q+1);
  ynew=string_to_int(p1+1);
  /* it may happen that a full suite is removed at the time a card or  */
  /* a pack is moved to make the full suite, insert an explicit move   */
  if(wd_object[id-1].xcord!=xnew || wd_object[id-1].ycord!=ynew) {
   /* first move the card or the pack to this place               */
   xold=wd_object[id-1].xcord;
   yold=wd_object[id-1].ycord;
   id_move=move_pack((int)wd_object[id-1].xcord,(int)wd_object[id-1].ycord,
	     order11,&max11,0,MAX_WINDOWS);
   if(id_move==id) {
    if_b_opt_bgfromfile(id);
    gplanes=4;get_foreground(id-1);gplanes=GPLANES;
    for(j=0;j<=8;j++) {
     homex= ((8-j)*xold+j*xnew)>>3;
     homey= ((8-j)*yold+j*ynew)>>3;
     movingPicture(homex,homey,1,id);
    }
    if_b_opt_bgtofile(id);
    wd_object[id-1].options^=WINDOW_HIDDEN;
    update_over(id);
   }
   else if(id_move==MAX_WINDOWS) {
    save_buf2(xold,yold,0,0,
     wd_object[id_move-1].xsize,wd_object[id_move-1].ysize,xold%8,
     wd_object[id_move-1].clength,
     wd_object[id_move-1].isize,
     wd_object[id_move-1].foreground);
    for(j=0;j<=8;j++) {
     homex= ((8-j)*xold+j*xnew)>>3;
     homey= ((8-j)*yold+j*ynew)>>3;
     movingPicture(homex,homey,1,id_move);
    }
    put_pack(max11,order11,MAX_WINDOWS);
   }
  }
  /* we do not need to check if this is full suite, it is, this is a rerun */
  j=(id-2)%13;
  /* ace is j=0, the card 2,3,4,...13 is j+1 */
  /* as the suite is full, the ace must be at the coordinates */
  /* xnew,ynew+j*YDIF. as it is an ace, its id=k*13+2=0 */
  for(k=13;k>0;k--) {
   i=pop_up_wanted(xnew,ynew+(j+k-13)*YDIF);
   if(!i) break;
   if_b_opt_bgfromfile(i);
   wd_object[i-1].options ^= WINDOW_HIDDEN;
   update_over(i);
   free_one_wd_object(i);
  }
  gplanes=4;load_one_card(i,300+spider_xoff*20,10,0);
  spider_xoff++;
  tracecount++;
  return 0;
 }
 tracecount++;

 line[strlen(line)-1]=0; /* remove the carriage return */
 p=strchr(line,(int)' ');
 if(!p) return 1; /* trace corrupted */
 *p=0;
 id=string_to_int(line);
 if(!id) return 1; /* trace corrupted */
 q=strchr(p+1,(int)' ');
 if(!q) return 1; /* trace corrupted */
 *q=0;
 p1=strchr(q+1,(int)' '); 
 if(!p1) return 1; /* trace corrupted */
 *p1=0;  
 xold=string_to_int(p+1);
 yold=string_to_int(q+1);

 if(wd_object[id-1].xcord!=xold || wd_object[id-1].ycord!=yold) {
  /* this cannot happen   */
  printf("go_move_forward: error, could not find a card %d\n",id);
  printf("wd_object[id-1].xcord=%d xold=%d\n",wd_object[id-1].xcord,xold);
  printf("wd_object[id-1].ycord=%d yold=%d\n",wd_object[id-1].ycord,yold);
 }

 if(!strncmp(p1+1,"flip",4)) {
  flip_card(id-1);   
  draw_buf2(xold,yold,0,0,(int)wd_object[id-1].xsize,
        (int)wd_object[id-1].ysize,xold%8,wd_object[id-1].clength,
        wd_object[id-1].isize,wd_object[id-1].foreground);
  return 0;
 }
 p=strchr(p1+1,(int)' ');
 if(!p) return 1; /* trace corrupted */
 *p=0;
 homex=string_to_int(p1+1);
 homey=string_to_int(p+1);
 if(homex==xold && homey==yold) {
   if(debug311) printf("go_move: ignoring this move\n");
  return 0;
 }
 else {

 /* pick up id */
  id_move=move_pack((int)wd_object[id-1].xcord,(int)wd_object[id-1].ycord,
	     order11,&max11,0,MAX_WINDOWS);

  if(id_move==id) { /* the card id was on top, could be moved alone */
   /* move_pack lifts up the card, but does not take background */ 

   if(!(wd_object[id-1].options&WINDOW_HIDDEN)) {
    printf("go_move_forward:this should not happen, card not hidden\n");
    wd_object[id-1].options^=WINDOW_HIDDEN;
    update_over(id);    
   }
   if_b_opt_bgfromfile(id);
   gplanes=4;get_foreground(id-1);gplanes=GPLANES;
   /* move it forward, now homex, homey is the future place */

   for(j=0;j<=8;j++) {
    xnew= ((8-j)*xold+j*homex)>>3;
    ynew= ((8-j)*yold+j*homey)>>3;
    movingPicture(xnew,ynew,1,id);
   }
   /* put id down */
   if_b_opt_bgtofile(id);
   wd_object[id-1].options^=WINDOW_HIDDEN;
   update_over(id);
   if(wd_object[id-1].options&WINDOW_HIDDEN)
    printf("go_move_forward:error, card down and hidden\n");

  }
  else if(id_move==MAX_WINDOWS) { /* pack move */

   /* move_pack created a new pack card, which is hidden and not on stack */
   /* foreground is not correct in the foreground buffer */
   save_buf2(xold,yold,0,0,
     wd_object[id_move-1].xsize,wd_object[id_move-1].ysize,xold%8,
     wd_object[id_move-1].clength,
     wd_object[id_move-1].isize,
     wd_object[id_move-1].foreground);

   /* move it forward */
   for(j=0;j<=8;j++) {
    xnew= ((8-j)*xold+j*homex)>>3;
    ynew= ((8-j)*yold+j*homey)>>3;
    movingPicture(xnew,ynew,1,id_move);
   }
   /* break the pack into cards */
   put_pack(max11,order11,MAX_WINDOWS);
  }
 }
 return 0;
}

void inittrace(keep_old) int keep_old;
{
 char line[30];
 FILE *stream;

 if(keep_old) {
  stream=fopen("trace.tmp","rb+");
  if(!stream) stream=fopen("trace.tmp","wb+");
 }
 else stream=fopen("trace.tmp","wb+");
 if(!stream) return;

 fseek(stream,0,0);
 strcpy(line,"*** trace of all moves ***");
 strcat(line,"\n");
 fputs(line,stream);
 fclose(stream);
 tracecount=1;
}

int showbinary(line2,n,i1)
char *line2;int n;int i1;
{
 int i;
 unsigned long int k;
 
 *line2=0;

 i=i1;

 for(i--;i>=0;i--) {
  k= (1<<i);
  if(k&n) strcat(line2,"1");
  else strcat(line2,"0");
 }
}


int any_card(x,y) int x,y;
{
  int i;
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ &&
     !(wd_object[i].options & WINDOW_HIDDEN) && 
     !(wd_object[i].options & OBJECT_NOT_PUT))
  {      
   if(x >= wd_object[i].xcord && 
       x< wd_object[i].xcord + wd_object[i].xsize &&
       y >= wd_object[i].ycord && 
      y< wd_object[i].ycord + wd_object[i].ysize){
     return i+1;
   }
  }
 }
 return 0;
}
