/*****************************************************************************
* O4.C		CODE FOR WD_OBJECT TYPE animation
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
#include "animatio.h"
extern int gplanes;
extern XColor *xcolor;
extern int debug11;
/*****************************************************************************
RUN MODES (=class) ARE: (it is possible and easy to add more)
0= Walking man
1= Dying wolf
2= Running wolf
3= Running man
4= Swimming fish4
5= Swimming fish2
6= Walking man 2
7= Waving man
8= Swimming octopus
9= Moving plant
10= ...
 
When defining the different parts of object and their movement:
- xystep orders how much the whole animation object move in the screen. 
- Step orders the granularity of movement. 
- upperb[][] and lowerb[][] define the limits of movement of a part. 
  You can use in animation editor move part xx to angle yy -command. 
- iniang[][] initializes angle of each part of object called
  for the first time when animation object is created. 
All of these you determine by giving the parameter class.

*****************************************************************************
There are many parts in the animation. upperb, lowerb are given for each part.
So on one line is MAXPARTS=15 

 	max 16 moving parts in an animation image.		
        0  1  2  3  4  5  6  7  8  9  10  11 12 13 14 15			
*****************************************************************************/
int xystep[RUNMODES][2]=
	{{20,2},{0,1},{10,0},{10,0},{10,2},{5,0},{10,0},{1,0},{5,0},{0,0}};

/* it is 15*10, a row is 15=MAXPARTS, a column=10=RUNMODES */
short step[RUNMODES][MAXPARTS]={
	{0,-20, 20,3, 5, 5,-20, 20,-30,30,-30, 30,0,0,0},
    	{0,-10, 10,3,10,15, 20,-20,-20,20,-20, 20,0,0,0},
   	{0,-30, 30,3,10,15, 30,-30,-40,40, 40,-40,0,0,0},
        {0,-30, 40,3,10, 5,-40, 30,-40,40,-40, 40,0,0,0},
        {0,-15,  3,3, 5, 5, -6, 20,-30,30,-30, 30,0,0,0},
        {0,-15,  3,3, 5, 5, -6, 20,-30,30,-30, 30,0,0,0},
        {0,-20, 20,3, 5, 5,-20, 20,-30,30,-30, 30,0,0,0},
        {0,-15,  0,3, 0, 0,  0,  0, 30, 0,  0,  0,0,0,0},
        {0, -2, 10,0,10,10,  0,  0,  0, 0,  0,  0,0,0,0},
        {0, -2,  5,0, 5, 0,  0,  0,  0, 0,  0,  0,0,0,0}};
         
short upperb[RUNMODES][MAXPARTS]=  
	{{0, 40, 40, 6, 5,10,40,40, 30,60,60,30, 0,0,0},
   	 {0, 90, 90,20,10,60,90,90, 20,50,50,20, 0,0,0},
	 {0, 60, 60, 6,10,60,60,60, 80,80,80,80, 0,0,0},
	 {0, 60, 60, 6,10,10,60,60, 40,90,90,40, 0,0,0},
	 {0, 22, 10, 6, 5,10,10,40, 30,60,60,30, 0,0,0},
	 {0, 22, 10, 6, 5,10,10,40, 30,60,60,30, 0,0,0},
	 {0, 40, 40, 6, 5,10,40,40, 30,60,60,30, 0,0,0},
	 {0,250,  0, 6, 0, 0, 0, 0,250, 0, 0, 0, 0,0,0},
         {0, 20, 80, 0,80,80, 0, 0,  0, 0, 0, 0, 0,0,0},
	 {0, 40, 60, 0,60, 0, 0, 0,  0, 0, 0, 0, 0,0,0}};

short lowerb[RUNMODES][MAXPARTS]=
	{{0,-20,-20, -6,-10,  0,-20,-20,-60,-30,-30,-60,0,0,0},
	 {0,-10,-10,-20,-20,  0,-30,-30,-30,-10,-10,-30,0,0,0},
	 {0,-60,-60, -6,-20,  0,-60,-60,-80,-80,-80,-80,0,0,0},
	 {0,-20,-60, -6,-20,  0,-60,-30,-80,-30,-30,-80,0,0,0},
	 {0,-20, -5, -6, -5,  0, 30,-20,-60,-30,-30,-60,0,0,0},
	 {0,-20, -5, -6, -5,  0, 30,-20,-60,-30,-30,-60,0,0,0},
	 {0,-20,-20, -6,-10,  0,-20,-20,-60,-30,-30,-60,0,0,0},
         {0,205,  0, -6,  0,  0,  0,  0,160,  0,  0,  0,0,0,0},		
         {0,-20,-80,  0,-80,-80,  0,  0,  0,  0,  0,  0,0,0,0},
	 {0,-40,-60,  0,-60,  0,  0,  0,  0,  0,  0,  0,0,0,0}};
	
short iniang[RUNMODES][MAXPARTS]=
	{{0, 20,-20, 0,  0,0,-20,20,  0, 0,  0, 0,0,0,0},
	 {0,  0,  0, 0,  0,0,  0, 0,  0, 0,  0, 0,0,0,0},
	 {0,  0,  0, 0,  0,0,-30,30,  0, 0,-40,40,0,0,0},
	 {0, 30, 60, 0,  0,0,-60,30,  0,90,-30, 0,0,0,0},
	 {0, 15, -5, 0,  0,0, 10,20,  0, 0,  0, 0,0,0,0},
         {0, 15, -5, 0,  0,0, 10,20,  0, 0,  0, 0,0,0,0},
	 {0, 20,-20, 0,  0,0,-20,20,  0, 0,  0, 0,0,0,0},
	 {0,220,  0, 0,  0,0,  0, 0,200, 0,  0, 0,0,0,0}, 
         {0,  0,  0,80,-80,0,  0, 0,  0, 0,  0, 0,0,0,0},
	 {0,  0,  0, 0,  0,0,  0, 0,  0, 0,  0, 0,0,0,0}};
	
int set_turnpoints,set_flexdata,set_endpoints; 
PARTMOVES *partm_table[10];
extern int debug1;
/**********************************************************
* The animation wd_object-type has the 3 routines:
*	make_animation_obj
*	animate
*	free_animation
*
* The routine animate contains the main window routine.
* to do the work. It has subroutines 
* 	-
* There are useful subroutines 
*	-
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
*
* As an example there is a filling routine
*	fill_animation
***********************************************************/
/*************************************************************
* The wd_object type animation
* animation data is in picture, lines and part
* bgbuf will be a place to store the background of the window
* class is the mode how the whole window moves
* level means that higher level is on top when animations pass
* partmove_id is the mode how parts move
***************************************************************/
int make_animation_obj(id,x,y,xsize,ysize,picture,lines,bgbuf,part,clength,isize,class,level,partmove_id,name)
int id,x,y,xsize,ysize;
char *picture,*lines,*bgbuf;
TRANSFORMDATA *part;
int clength,isize,class,level,partmove_id;
char *name;
{
 int i;PARTMOVES *partm;

 i=id-1;
 strcpy(wd_object[i].name,name);
  wd_object[i].type=ANIMATION_OBJ;
 wd_object[i].options=OBJECT_NOT_PUT;   
 wd_object[i].xcord=x;
 wd_object[i].ycord=y;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize;
 wd_object[i].clength= clength;
 wd_object[i].isize= isize;   
 /* the difference between ylength and ysize is that ylength lines are saved */
 /* in background buffer, while ysize is shown. So ylength>=ysize, usually = */
 wd_object[i].ylength= ysize;
 wd_object[i].background=bgbuf;    
 wd_object[i].foreground=fgbuffer;          
 wd_object[i].col1=(unsigned char )2;  
 wd_object[i].i1=class;       
 wd_object[i].i2=level;        
 wd_object[i].p1=picture;
 wd_object[i].p2=(char **)lines;
 wd_object[i].p4=(char *)part;
 zero_over(i);
 part->partmove_id=partmove_id;
 partm=partm_table[part->partmove_id];
 inipartm(partm,class); 
 inipart(part,partm);
 return(0);
}

/***********************************************************
 * animate, the main animation routine
 * the way this routine works is that anumations are drawn
 * on a card. The foreground of the card is copied from the 
 * background, so the card is transparent. Animation picture
 * is drawn on the foreground before showing it with
 * moving Picture. The animation picture is drawn in 
 * add_all_animations
 ***********************************************************/
int animate(id,com_par)
int id,com_par;
{

 int i,j,len,class;
 int xcord,ycord,xsize,ysize,i1,i2,j1,j2,clength,isize,off;
 char *fgbuf;
 PARTMOVES *partm;
 TRANSFORMDATA *part;
 int order[MAX_WINDOWS];

 i=id-1;

 /* animation data is in the three pointers                */
 /*  picture=wd_object[i].p1;          not called directly */
 /* lines=(char *)wd_object[i].p2;     not called directly */
 /* and the one that we need nere, p4                      */
 part=(TRANSFORMDATA *)wd_object[i].p4;

 /* these are as always in wd_objects */
 clength=wd_object[i].clength;
 isize=wd_object[i].isize;
 xcord=wd_object[i].xcord;
 ycord=wd_object[i].ycord;   	  	
 xsize=wd_object[i].xsize;
 ysize=wd_object[i].ysize;   
 fgbuf=wd_object[i].foreground;

 /* animation object uses i1 to a parameter called class    */
 /* class determines the large scale movement of the window */
 class=wd_object[i].i1; 

 /* while partmove_id determines how parts move */
 partm=partm_table[part->partmove_id]; 
 
 if(com_par==DRAW_ONLY_DO_NOT_STAY){

  /* initiate animating parts of the image */
  inipart(part,partm);

  /* save background to wd_object[i].background */
  save_buf2(xcord,ycord,0,0,xsize,ysize,xcord%8,
      clength,isize,wd_object[i].background);

  /* this is normally done in put_wd_objects, but now needed         */
  /* as animations are rather special in the background buffer sense */
  if(wd_object[i].options&OBJECT_NOT_PUT) {
   wd_object[i].options-=OBJECT_NOT_PUT;
   update_over(id); /* WINDOW_HIDDEN flag is off */
  }

 } 

 /* an animation card moves, get new values to (xcord,ycord) */
 get_new_coordinates(i,class,&xcord,&ycord);
 off=xcord%8;   	  	

 /* copy background to foreground, thus making the card transparent        */
 /* the background size is ylength*isize but ysize*isize need to be copied */
 memcpy(fgbuf,wd_object[i].background,ysize*isize);

 /* is get new background to fgbuf */
 i1=xcord-wd_object[i].xcord;j1=ycord-wd_object[i].ycord;

 if(i1>=0 && j1>=0) { /* picture moved to lower right */
  if(xsize<i1) i1=xsize;if(ysize<j1) j1=ysize;
  i2=xsize-i1;j2=ysize-j1; 
  move_plane2a(i1,j1,xsize,ysize,clength,isize,fgbuf);
  save_buf2j(xcord,ycord,0,j2,i2,ysize,off,clength,isize,fgbuf);
  save_buf2j(xcord,ycord,i2,0,xsize,ysize,off,clength,isize,fgbuf);
 }   
 else if(i1>=0 && j1<0) { /* picture moved to upper right */ 	 
  j1 = -j1;if(xsize<i1) i1=xsize;if(ysize<j1) j1=ysize;
  i2=xsize-i1;j2=ysize-j1;
  move_plane2b(i1,j1,xsize,j2-1,clength,isize,fgbuf);
  save_buf2(xcord,ycord,0,0,i2,j1,off,clength,isize,fgbuf);   
  save_buf2j(xcord,ycord,i2,0,xsize,ysize,off,clength,isize,fgbuf);   
 }       
 else if(i1<0 && j1>=0) { /* picture moved to lower left */ 	 
  i1= -i1;if(xsize<i1) i1=xsize;if(ysize<j1) j1=ysize;
  i2=xsize-i1;j2=ysize-j1;
  move_plane2c(i1,j1,i2-1,ysize,clength,isize,fgbuf);
  save_buf2(xcord,ycord,0,0,i1,j2,off,clength,isize,fgbuf);
  save_buf2j(xcord,ycord,0,j2,xsize,ysize,off,clength,isize,fgbuf);
 }       
 else if(i1<0 && j1<0) { /* picture moved to upper left */ 	 
  i1 = -i1; j1= -j1;
  if(xsize<i1) i1=xsize;if(ysize<j1) j1=ysize;
  i2=xsize-i1;j2=ysize-j1;
  move_plane2d(i1,j1,i2-1,j2-1,clength,isize,fgbuf);
  save_buf2(xcord,ycord,0,0,i1,ysize,off,clength,isize,fgbuf);
  save_buf2j(xcord,ycord,i1,0,xsize,j1,off,clength,isize,fgbuf);   
 } 
 /* so far there is only the background in fgbuf */

 /* make the current transform to the animation */
 endp_transf(part); 

 /* draw all animations overlapping the window on the fgbuffer */
 add_all_animations(id,xcord,ycord);

 /* draw the foreground buffer with animation on the screen */
 if(com_par==DRAW_ONLY_DO_NOT_STAY) {
  movingPicture(xcord,ycord,0,id); 
 }
 else movingPicture(xcord,ycord,1,id);

   if(debug11) {
     printf("drawing background of id=%d on before leaving animate\n",i+1);

     clearwin(300,330,410,450,15);
     draw_buf2j(304,340,0,0,100,100,0,
      wd_object[i].clength,wd_object[i].isize,wd_object[i].background);
     getchar();
   }


 /* change the background so that the window is lowest in new cords */
 get_order(id,order,&len,300);
 /* order[0]=id, the other are windows below id */
 for(j=1;j<=len;j++) {
  /* every j the background of id goes lower in stacking order */  
  if(debug11 && i==1 && j==1) {;}
  else 
  update_backg_by_id(id,order[j]);
 } 
  
 if(buttons==1) return(-4); /* move */
 return(-2);
}

int free_animation(id)
int id;
{
 int i;
 char *buf;
  
 if(id<1) {illegal_pointer(24);return(1);}   
 i=id-1;
 buf=wd_object[i].p1;
 if(!buf) {illegal_pointer(25);return(1);} b_free(buf);
 buf=(char *)wd_object[i].p2; 
 if(!buf) {illegal_pointer(26);return(1);} b_free(buf); 
 buf=wd_object[i].p4; 
 if(!buf) {illegal_pointer(27);return(1);} b_free(buf); 
 buf=wd_object[i].background; 
 if(!buf) {illegal_pointer(28);return(1);} b_free(buf);  
 return(0);
}
/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/
/* main routine is animate */

/*********************************************************
* useful subroutines
**********************************************************/  
int allo_partm(id) int id;
{
 partm_table[id]=(PARTMOVES *)balloc(sizeof(PARTMOVES)); 
 if(!partm_table[id]) {no_memory();return 1;}
 return 0;
}
int free_partm(id) int id;
{
 if(partm_table[id]) b_free(partm_table[id]);
 return 0;
}
int inipartm(partm,class) PARTMOVES *partm;int class;
{
 int i;

 for(i=0;i<2;i++) partm->xystep[i]=xystep[class][i];
 for(i=0;i<MAXPARTS;i++) {
  partm->step[i]=step[class][i];
  partm->lowerb[i]=lowerb[class][i];      
  partm->upperb[i]=upperb[class][i];
  partm->iniang[i]=iniang[class][i];
 }
 return 0;	
}

int inipart(part,partm) TRANSFORMDATA *part;PARTMOVES *partm;
{
 int i;
 for(i=0;i<MAXPARTS;i++) {part[i].direct=1;part[i].angle=partm->iniang[i];}
 return 0;	
}
/*********************************************************
* Example of a fill routine
**********************************************************/
int fill_animation(id,name,x,y,class,level,partmove_id)
int id;char *name;
int x,y,class,level,partmove_id;
{
 int i;
 char line[4];
 FILE *stream;
 char *buf;
 long int size1,size2,size3;
 int clength1,clength2,isize1,isize2;
 TRANSFORMDATA* part;

 /* if there is no file, do not allocate buffers */
 stream=fopen(name,"rb+");
 if(!stream) {cannot_find_file(name);return(1);}

 /* earlier the sizes were JSIZE*ISIZE and JSIZE=100, ISIZE=100    */
 /* but now ISIZE=168, so to read old data, we read JSIZE*JSIZE    */
 /* the size JSIZE*JSIZE would be enough for old data, but for new */
 /* more: the card size is JSIZE*JSIZE. Thus the buffers need size */
 /* ylength*(color_planes*(xsize/8+1))=ylength*GPLANES*(JSIZE/8+1) */
 /* ylength=ysize=JSIZE, so the buffer size is 31200 bytes         */
 /* tplane is the background buffer and must have the larger size  */

 clength1=JSIZE/8+1;isize1=JSIZE;
 clength2=JSIZE/8+1;isize2=GPLANES*clength2;
 size1=JSIZE*JSIZE;   /* enough for old data of 4 color planes */
 size2=JSIZE*isize2;  /* needed for 24 color planes            */
 size3=3*JSIZE*JSIZE; /* 24 colors means 3 bytes/color */
 /* if there comes a memory error, fix it. We do not release other buffers */
 part=(TRANSFORMDATA *)balloc((long)sizeof(TRANSFORMDATA)*MAXPARTS);
 if(!part)                          {no_memory();return(1);}
 plane1=balloc(size3); if(!plane1)  {no_memory();return(1);}    
 plane2=balloc(size1); if(!plane2)  {no_memory();return(1);}
 tplane2=balloc(size2);if(!tplane2) {no_memory();return(1);}

 /* the old data will be set to .p1, .p2 and .p4 of the wd_object   */
 /* first read .p1 data to buf, then transfer to 24 color planes */
 rewind(stream);
 fread(line,1,4,stream); 
 /* the header tells us if the data is old or new */
 /* in old line[0],line[1]=xsize=100 and old line[2],line[3]=ysize=100 */
 /* in new, line[0] has the first bit set */
 if(line[0]==0){
  buf=balloc(size1);if(!buf){no_memory();return(1);}
  fread(buf,1,JSIZE*JSIZE,stream);
  change_to_24_colors(JSIZE,JSIZE,buf,plane1); 
  b_free(buf);
 }
 else {
  fread(plane1,1,3*JSIZE*JSIZE,stream);
 }
 fread(plane2,1,JSIZE*JSIZE,stream);
 fread((unsigned char *)part,MAXPARTS,sizeof(TRANSFORMDATA),stream);    
 fclose(stream);

 /* here we must use the current GPLANES value */
 make_animation_obj(id,x,y,(int)JSIZE,(int)JSIZE,
   plane1,plane2,tplane2,part,clength2,isize2,
   class,level,partmove_id,name);

 return 0;
}

/**************************************************
 * this routine converts a 4-color plane picture to
 * 24-color plane picture, assuming the palette is
 * in xcolor[0]...xcolor[255]
 *************************************************/
int change_to_24_colors(xsize,ysize,buf1,buf2) 
int xsize,ysize;char *buf1,*buf2;
{
 int i,j,color;
 char *buf_src,*buf_dst;
 unsigned long pixel;

 buf_src=buf1;buf_dst=buf2;
 for(j=0;j<ysize;j++) {
  for(i=0;i<xsize;i++) {
    /* this is not stored in color planes but as color byte */
   color= *buf_src;
   buf_src++;
   pixel=xcolor[color].pixel;
   /* will be stored as three bytes */
   *buf_dst=(pixel>>16)&0xff;
   buf_dst++;
   *buf_dst=(pixel>>8)&0xff;
   buf_dst++;
   *buf_dst=pixel&0xff;
   buf_dst++;
  }
 }
 return 0;
}
