/*****************************************************************************
* O5.C		CODE FOR WD_OBJECT TYPE threedim_obj
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
extern int gplanes;
extern void get_fg_if_transparent();
extern void update_tcard_background();
void clear_3dim_obj();
void draw3dimobj(),keep_on_rotating();
/**********************************************************
* The threedim_obj wd_object-type has the 3 routines:
*	make_threedim_obj
*	draw_threedim_obj
*	free_threedim_obj
*
***********************************************************/
/**********************************************************
* The wd_object type threedim_obj
***********************************************************/
int make_threedim_obj(id,xcord,ycord,file_name,xsize,ysize)
int id,xcord,ycord,xsize,ysize;
char *file_name;
{
 int i;
 COORDDATA *cd;

  
 i=id-1;if(i<0) return(1);

 wd_object[i].type=THREEDIM_OBJ;
 wd_object[i].options=WINDOW_HIDDEN; 
 zero_over(i);     
 update_over(i+1);
 wd_object[i].options|=OBJECT_NOT_PUT;
 wd_object[i].i1=PSIZE;
 wd_object[i].i2=QSIZE; 
 wd_object[i].xcord=xcord;
 wd_object[i].ycord=ycord;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize; 
 wd_object[i].ylength=wd_object[i].ysize;
 wd_object[i].clength=wd_object[i].xsize/8+1;
 wd_object[i].isize=gplanes*wd_object[i].clength;
 wd_object[i].p1=balloc(wd_object[i].i1*wd_object[i].i2);
 wd_object[i].p2=(char **)balloc(wd_object[i].ysize*wd_object[i].isize);
 cd=(COORDDATA *)balloc(sizeof(COORDDATA)); 
 wd_object[i].p4=(char *)cd;

 rotate_angle(0,&(cd->cos_a),&(cd->sin_a));  
 rotate_angle(25,&(cd->cos_c),&(cd->sin_c));
 strcpy(wd_object[i].name,file_name);
 wd_object[i].background=0;
 wd_object[i].foreground=0; 
 return(0);
}

int draw_threedim_obj(id,com_par)
int id,com_par;
{
 int j;

 j=id-1;
 if(id<2 || !wd_object[j].p1 || !wd_object[j].p2 ||
 	!wd_object[j].p4) {illegal_pointer(30);return(-2);}    	
 if(com_par==DRAW_ONLY_DO_NOT_STAY) {
   printf("should draw here\n");
  draw3dimobj(j);   
  return(-2); /* do nothing */
 }    	
 else if(com_par==REFRESH) {  
  save_buf2(wd_object[j].xcord,wd_object[j].ycord,0,0,
   	wd_object[j].xsize,wd_object[j].ysize,wd_object[j].xcord&7,
   	wd_object[j].clength,wd_object[j].isize,wd_object[j].p2);
  return(-2); /* do nothing */   
 }
 else {
  if(buttons) {
   keep_on_rotating(j);
   return(-2); /* do nothing */  	
  }
  else return(-2); /* do nothing */
 }
}	

int free_threedim_obj(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) return(1);

 wd_object[i].type=FREE_OBJ;   
 if(wd_object[i].background) {
  b_free(wd_object[i].background);
  wd_object[i].background=0;
 }
 if(wd_object[i].p1) {
  b_free(wd_object[i].p1);
  wd_object[i].p1=0;
 } 
 if(wd_object[i].p2) {
  b_free(wd_object[i].p2);
  wd_object[i].p2=0;
 } 
 if(wd_object[i].p4) {
  b_free(wd_object[i].p4);
  wd_object[i].p4=0;
 }   
 return(0);      
}

/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/
/* main routine is draw_threedim_obj */

void draw3dimobj(i) int i;
{
 COORDDATA *cd; 

 cd=(COORDDATA *)wd_object[i].p4;
 
 draw3dim(wd_object[i].p1,wd_object[i].p2,
  		cd->cos_c,cd->sin_c,cd->cos_a,cd->sin_a,
  		wd_object[i].i1,(int)wd_object[i].i2,
  		wd_object[i].xcord,wd_object[i].ycord,
  		wd_object[i].xsize,wd_object[i].ysize);
}  		

/***************************************************
* useful subroutines
****************************************************/
void clear_3dim_obj(i)
{
 int k;
 
 for(k=0;k<wd_object[i].i1;k++) 
  *(wd_object[i].p1+wd_object[i].i2*k)=0; 

 clearwin(wd_object[i].xcord,wd_object[i].ycord,
 	wd_object[i].xcord+wd_object[i].xsize,
 	wd_object[i].xcord+wd_object[i].ysize,bgcol);
}

void keep_on_rotating(i) int i;
{
 COORDDATA *cd; 

 cd=(COORDDATA *)wd_object[i].p4;

 do {      	    	  
  draw3dimobj(i);  
  step_angle(&(cd->cos_a),&(cd->sin_a),1);
 } while(!kbhit());
 getch();
}

void rotation(i,type,X) int i,type,X;
{
 COORDDATA *cd; 
 cd=(COORDDATA *)wd_object[i].p4;
 
 if(type==1) rotate_angle(X,&(cd->cos_a),&(cd->sin_a));
 else if(type==2) rotate_angle(X,&(cd->cos_c),&(cd->sin_c));   
 else if(type==3) step_angle(&(cd->cos_a),&(cd->sin_a),-1); 	
 else if (type==4) step_angle(&(cd->cos_a),&(cd->sin_a),1); 	 	
        	     
 draw3dimobj(i);   	  
}

/*****************************************************************
* Example of a fill routine
******************************************************************/
