/*****************************************************************************
* O6.C	CODE FOR WD_OBJECT TYPE pixel_draw
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
extern int gplanes;
int colorZ;
#ifndef DOS_SYSTEM
extern XColor   *xcolor;
#endif
void fn2_to_fnt(),fnt_to_fn2();
/*********************************************************
* The pixel_draw wd_object-type has the 3 routines:
*	make_pixel_draw
*	pixel_draw
*	free_pixel_draw
*
* The routine pixel_draw calls the main window routine 
*	pixel_editor_window
* to do the work. It has subroutines 
*	draw_magnification
*	inside_operations
* 
* There are useful subroutines 
*	fn2_to_fnt
*	fnt_to_fn2
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
*
* As an example there is a filling routine
*	...
**********************************************************/
/*********************************************************
* The wd_object type pixel_draw
**********************************************************/
int make_pixel_draw(id,x,y,xsize,ysize,col1,col2,name,lenseid)
int id;
int x,y,xsize,ysize,col1,col2;
char *name;
int lenseid;
{
 int i;
 i=id-1;if(i<0) return(1);
 
 wd_object[i].type=PIXEL_DRAW_OBJ;
 wd_object[i].options= NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING | NO_RESIZING | NO_ICONIZING; 
 wd_object[i].options|=OBJECT_NOT_PUT;   
 wd_object[i].xcord=x;
 wd_object[i].ycord=y;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize;
 wd_object[i].xstart=0;
 wd_object[i].ystart=0;  
 wd_object[i].clength= -1;
 wd_object[i].isize= -1;   
 wd_object[i].ylength= -1;    
 wd_object[i].background=0;     
 wd_object[i].foreground=fgbuffer;      
 wd_object[i].col1=col1;  
 wd_object[i].col2=col2;
 strcpy(wd_object[i].name,name);
 wd_object[i].i1=lenseid;
 zero_over(i);   
 return(0);
}

int pixel_draw(id,com_par)
int id,com_par;
{
  int ret;
 ret=pixel_editor_window(
  	&(wd_object[id-1].xcord),
 	&(wd_object[id-1].ycord),
 	&(wd_object[id-1].xsize),
 	&(wd_object[id-1].ysize),
       	&(wd_object[id-1].background),
       	&(wd_object[id-1].clength),
       	&(wd_object[id-1].isize),
       	&(wd_object[id-1].ylength),
       	(int)wd_object[id-1].col1,
       	(int)wd_object[id-1].col2,
       	(int)wd_object[id-1].i1,
       	wd_object[id-1].options,       	
	com_par);
 return ret;
} 		

int free_pixel_draw(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) {illegal_pointer(16);return(1);}
 
 remove_background(id);
 wd_object[i].type=FREE_OBJ;
 i=wd_object[i].i1;
 if(i) {
  bring_id_to_top(i,1);
  if_b_opt_bgfromfile(i);
  update_over(i);    
  free_transparent_card(i);
 }
 return(0);      
}

/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/

/******************************************************************************
*   	pixel_editor_window()
*
*   	Description:
*
*	Parameters: 
*		x,y 	= coordinates of the upper left corner of the window
*		xsize 	= horizonal size
*		ysize 	= vertical size
*
*		backg_buf = addr. to an address of background buffer
*		  The background buffer has the size isize*ylength characters.
*		  If *backg_buf==0, a memory area is allocated by balloc.
*		clength	= bytes in the horizontal direction for one color plane
*		isize	= normally isize=gplanes*clength, gplanes color planes
*		ylength	= pixels in vertical direction
*	
*		col1	= background color of the window
*		col2	= color of the scrolling bars and frame
*
*		lenseid = identifier of a lense window
*		mode	= controls the operation, following values
*				NORMAL
*				DRAW_ONLY_DO_NOT_STAY
*		 		REFRESH       
*	Operations: 
*		killing
*		iconizing
*		
******************************************************************************/ 
int pixel_editor_window(x,y,xsize,ysize,backg_buf,clength,isize,ylength,
			col1,col2,lenseid,options,mode)
int *x,*y,*xsize,*ysize;
char **backg_buf;
int *clength,*isize,*ylength;
int col1,col2;
int lenseid;
unsigned int options;
int mode;
{
 int ret,xstart,ystart;
 long percentx,percenty;
 
 if(make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,mode)) return(2);

 if(mode==DRAW_ONLY_DO_NOT_STAY || mode==REFRESH) {       
  
  clearwin(*x,*y,*x+ *xsize,*y+ *ysize,col1);  

  draw_magnification(11+ *x,11+ *y,lenseid);
  
  putWinFrame(*x,*y,*ysize,*xsize,0,0,0,0,&percentx,&percenty,col2,
                NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING,0); 
  

  return(-2); /* exit, do nothing */
 }

 while(1) {	
  do {
   if(!buttons){
    if(mouse_off) {showmouse();mouse_off=0;}
   }
   else {
    if(!mouse_off) {hidemouse();mouse_off=1;}
    
    ret=inside_operations(X,Y,*x+11,*y+11,*x+ *xsize-4,*y+ *ysize-4,lenseid);    
    if(ret)
     ret=check_scrolling(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,
    	&xstart,&ystart,&percentx,&percenty,0,0,col1,col2,
        NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING); 
    if(ret== -2) { /* pointer pressed outside the window */
     return(-2); /* exit, do nothing */
    }
    else if(ret==2) { /* move window marker pressed */	
     if(buttons==1) {
      draw_magnification(11+ *x,11+ *y,lenseid);	
      return(0); /* operations */           	
     }
     if(buttons==2) return(-4); /* move window */	
    }
    else if(ret==1) { /* kill window marker pressed */
     if(buttons==2) {
      if(options&NO_ICONIZING) return(-2);/* do nothing */     	
      return(-3); /* make icon */      
     }
     if(options&NO_KILLING) return(-2);/* do nothing */
     if(buttons==1) return(-1); /* kill window */	
    }
   }  	
   buttons=0;
   readmouse(&buttons,&X,&Y);
  } while(!kbhit());
 }    
}

int draw_magnification(xoff,yoff,lenseid) int xoff,yoff,lenseid;
{	
 int i,j,isize;
 VUNIT *plane;
 long pixel;

 plane=(VUNIT *)wd_object[lenseid-1].p2;
 isize=wd_object[lenseid-1].isize;
 if_b_opt_bgfromfile(lenseid);

 /* this is the same, only probably slower
 for(i=0;i<32;i++) {
  for(j=0;j<32;j++) {
    pixel=point_from_fn2b(i,j, wd_object[lenseid-1].clength,
			       wd_object[lenseid-1].isize,
                               wd_object[lenseid-1].background);
    fillbox2(xoff+i*5,yoff+j*5,5,5,pixel);
  }
 } 
 ***/

 fn2_to_fnt(wd_object[lenseid-1].background,plane,
  	wd_object[lenseid-1].xsize,wd_object[lenseid-1].ysize, 
 	wd_object[lenseid-1].clength,isize); 
 
 for(i=0;i<32;i++) {
  for(j=0;j<32;j++) {
   fillbox2(xoff+i*5,yoff+j*5,5,5,(int)plane[(j+1)*2*isize+i+1]);
  }
 } 
 return(0);
}
int inside_operations(x,y,x1,y1,x2,y2,lenseid)
int x,y,x1,y1,x2,y2,lenseid;
{
  int a,b;int pixel;

  pixel=(int)xcolor[colorZ].pixel;
 if(x<x1 || x>x2 || y<y1 || y>y2) return(1);
 /* this is the place to insert more operations */

 a=(x-x1)/5;b=(y-y1)/5;
 if(a>=0 && a<32 && b>=0 && b<32) { 
  fillbox2(x1+a*5,y1+b*5,5,5,pixel);
  point_to_fn2b(a+1,b+1,pixel,wd_object[lenseid-1].clength,
 	wd_object[lenseid-1].isize,wd_object[lenseid-1].background); 

  drawpixel2b(wd_object[lenseid-1].xcord+1+a,
    wd_object[lenseid-1].ycord+1+b,pixel);
 }
 return(0);
}


/*********************************************************
* useful subroutines
**********************************************************/
void fn2_to_fnt(buf1,buf2,xsize,ysize,clength,isize)
char *buf1;
VUNIT *buf2;
int xsize,ysize,clength,isize;
{
 register int i,j,k,index;

 for(j=0;j<ysize;j++) for(i=0;i<2*xsize;i++) buf2[2*isize*j+i]=0;
 
 for(j=0;j<ysize;j++)  {
  for(index=0;index<gplanes;index++) {
   for(i=0;i<clength;i++) {   
    for(k=0;k<8;k++) {
     if(*(buf1+j*isize+index*clength+i) & (0x80>>k))
      buf2[j*2*isize+8*i+k] |= (0x1<<(gplanes-1-index));             
    } 
   }
  }     
 }
}
void fnt_to_fn2(buf2,buf1,xsize,ysize,clength,isize)
VUNIT *buf2;
char *buf1;
int xsize,ysize,clength,isize;
{
 register int i,j,k,index;
 
 for(j=0;j<ysize;j++) for(i=0;i<xsize;i++) *(buf1+isize*j+i)=0;

 for(j=0;j<ysize;j++)  {
  for(index=0;index<gplanes;index++) {
   for(i=0;i<clength;i++) {   
    for(k=0;k<8;k++) {
     if( buf2[j*2*isize+8*i+k]&(0x1<<(gplanes-1-index)))   
      *(buf1+j*isize+index*clength+i) |= (0x80>>k);
    } 
   }
  }     
 }
}
/*********************************************************
* example of a fill routine
**********************************************************/
