/*****************************************************************************
* O7.C		CODE FOR WD_OBJECT TYPE transparent_card
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
extern int colorZ,nocolor;
extern XColor *xcolor;
extern int gplanes;
extern void get_fg_if_transparent();
extern void update_tcard_background();
void add_frame(),draw_frame(),copy_without_frames();
int set_mask;
/**********************************************************
* The transparent_card wd_object-type has the 3 routines:
*	make_transparent_card
*	draw_transparent_card
*	free_transparent_card
*
***********************************************************/
/**********************************************************
* The wd_object type transparent_card
***********************************************************/
int make_transparent_card(id,xcord,ycord,file_name,xsize,ysize,use_p2)
int id,xcord,ycord,xsize,ysize;
char *file_name;int use_p2;
{
 int i;
 i=id-1;if(i<0) return(1);
 	
 wd_object[i].type=TCARD_OBJ;
 wd_object[i].options=OBJECT_NOT_PUT;     
 if(xsize*ysize>XSIZE*YSIZE) wd_object[i].options |=MOVE_AS_RECTANGLE; 
 wd_object[i].xcord=xcord;
 wd_object[i].ycord=ycord;      
 wd_object[i].xsize=xsize; 
 wd_object[i].ysize=ysize;
 wd_object[i].clength=(xsize/8+1); 
 wd_object[i].isize=gplanes*wd_object[i].clength;  
 wd_object[i].ylength=ysize;     
 strcpy(wd_object[i].name,file_name);
 zero_over(i);   
 wd_object[i].background=balloc( (long)(wd_object[i].isize*wd_object[i].ylength));
 wd_object[i].foreground=fgbuffer;
 if(use_p2) {
  wd_object[i].p2=(char **)balloc( (long)(2*wd_object[i].isize*wd_object[i].ylength*sizeof(VUNIT)));
  wd_object[i].options |= NO_RESIZING;    
 }
 else wd_object[i].p2=0;
 wd_object[i].i1=4;
 wd_object[i].col3=0;/* color of resize marker */  
 return(0);
}
int draw_transparent_card(id,com_par)
int id,com_par;
{
 return(transparent_card(
  	&(wd_object[id-1].xcord),
 	&(wd_object[id-1].ycord),
 	&(wd_object[id-1].xsize),
 	&(wd_object[id-1].ysize),
       	&(wd_object[id-1].background),
       	&(wd_object[id-1].clength),
       	&(wd_object[id-1].isize),
       	&(wd_object[id-1].ylength),
       	(int)wd_object[id-1].col3,
 	id-1,       	
       	wd_object[id-1].options,
	com_par));
} 		

int free_transparent_card(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) return(1);
 movingPicture(0,0,2,id); 
 wd_object[i].type=FREE_OBJ;   
 if(wd_object[i].background) {
  b_free(wd_object[i].background);
  wd_object[i].background=0;
 }
 if(wd_object[i].p2) {
  b_free(wd_object[i].p2);
  wd_object[i].p2=0;
 } 
 return(0);      
}

/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/
int transparent_card(x,y,xsize,ysize,backg_buf,clength,isize,ylength,col3,j,options,mode)
int *x,*y,*xsize,*ysize;
char **backg_buf;
int *clength,*isize,*ylength;
int col3;
int j;
unsigned char options;
int mode;
{
 int ret;
 
 if(j<1)
  {illegal_pointer(29);return(-2);}    	
  
  if(!wd_object[j].background) 
  {illegal_pointer(30);return(-2);}    	
  
  if(!wd_object[j].foreground) 
  {illegal_pointer(43);return(-2);}    	

 if(mode==DRAW_ONLY_DO_NOT_STAY || mode==REFRESH) {       
  get_fg_if_transparent(j,*x,*y,1);
  add_frame(j);  
  if(mode!=REFRESH) {  
   movingPicture(*x,*y,0,j+1);
  }
  else {
   draw_buf2(*x,*y,0,0,*xsize,*ysize,(*x)&7,*clength,*isize,wd_object[j].foreground);     	
  }
  return(-2); /* exit, do nothing */
 }

 mov=0; 
 while(1) {	
  do {
   if(!buttons){
    if(curon) {marker(X,Y,CUROFF,col3,markershape);curon=0;}   	
    if(mouse_off) {
     wd_object[j].i1=4;    	    
     memset(wd_object[j].foreground,0xff,wd_object[j].isize*wd_object[j].ylength);           
     add_frame(j);
     draw_buf2(wd_object[j].xcord,wd_object[j].ycord,0,0,
   	wd_object[j].xsize,wd_object[j].ysize,wd_object[j].xcord&7,
   	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);    	
     showmouse();mouse_off=0;
    }
   }
   else {
    if(!mouse_off) {hidemouse();mouse_off=1;}
    if(!(options & NO_RESIZING)) {
     mov=check_resizing(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,&markershape);
    }
    else mov=0;
    if(!mov) {
     if(curon) {marker(X,Y,CUROFF,col3,markershape);curon=0;}    	
     ret=tcard_inside_operations(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,j);
     if(ret== -2) { /* pointer pressed outside the window */
      return(-2); /* exit, do nothing */
     }
     else return(-4); /* move window */	     
    }
    else {
     if(!curon) {marker(X,Y,CURON,col3,markershape);curon=1;}
     else marker(X,Y,CURMOVE,col3,markershape);    
    }
   }  	
  
   if(mov) {
    if(curon) marker(X,Y,CUROFF,col3,markershape);   	
    update_tcard_backgrnd(X,Y,x,y,xsize,ysize,clength,isize,ylength,backg_buf,&mov);
    if(mov & 1) {
     clearwin(*x+ *xsize-cs,*y,*x+ *xsize,*y+ *ysize,15);
     X= *x+ *xsize-2; 
    }
    if(mov & 2) X= *x+ *xsize-3;
    if(mov & 4) {
     clearwin(*x,*y+ *ysize-cr,*x+ *xsize,*y+ *ysize,15);    	
     Y= *y+ *ysize-2;
    }
    if(mov & 8) Y= *y+ *ysize-3; 
    if(mov) {
     draw_frame(j);
     setmouse(X,Y);
     setmouselim(0,0,X__max-4,Y__max-4);
     mov=0;
    }
    if(curon) marker(X,Y,CURON,col3,markershape);
   }   
   buttons=0;readmouse(&buttons,&X,&Y);
  } while(!kbhit());
 }
}

int tcard_inside_operations(X,Y,x1min,y1min,x1max,y1max,j)
int X,Y,x1min,y1min,x1max,y1max,j;
{
 
 if (X<x1min || X>x1max || Y<y1min || Y>y1max) {
  return(-2);/* button used outside, leave this menu */    	
 }    	 
 if(buttons&2) {
  if(!set_mask) {
   if(wd_object[j].p2 ||  wd_object[j].i1) { /* take background to fgbuf */
    memcpy(wd_object[j].foreground,wd_object[j].background,
     wd_object[j].isize*wd_object[j].ylength);   
    add_frame(j);
    draw_buf2(wd_object[j].xcord,wd_object[j].ycord,0,0,
   	wd_object[j].xsize,wd_object[j].ysize,wd_object[j].xcord&7,
   	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);    
    if(!wd_object[j].p2) wd_object[j].i1=0;
   }
   else { /* draw fgbuf to the screen*/
    copy_without_frames(wd_object[j].background,
    			wd_object[j].foreground,
    			wd_object[j].xsize,wd_object[j].ysize,
    			wd_object[j].clength,wd_object[j].isize);

    wd_object[j].i1=4;    	    
    memset(wd_object[j].foreground,0xff,wd_object[j].isize*wd_object[j].ylength);           
    add_frame(j);
    draw_buf2(wd_object[j].xcord,wd_object[j].ycord,0,0,
   	wd_object[j].xsize,wd_object[j].ysize,wd_object[j].xcord&7,
   	wd_object[j].clength,wd_object[j].isize,wd_object[j].foreground);        
  
   }
  }
  else {  /* set_mask is on and pressing right button allows drawing */
   if(colorZ!=nocolor) return -4;
   /* user puts a mask with nocolor */
   while(1){  /* capture mouse to this window */
    do {
     buttons=0;
     readmouse(&buttons,&X,&Y); 
     if (buttons) {
      if (X>=x1min && X<=x1max && Y>=y1min && Y<=y1max) {
       fillbox2(X,Y,5,5,xcolor[colorZ].pixel);
      }
      else return -4;
     }
    }
    while(!kbhit());
   }
  }
 }
 return(-4);	
}

/***************************************************
* useful subroutines
****************************************************/
void add_frame(n) int n;
{
 int i,clength,isize,col;

 col=wd_object[n].i1; 
 clength=wd_object[n].clength;isize=wd_object[n].isize;
 for(i=0;i<wd_object[n].xsize;i++) 
  point_to_fn2(i,0,col,clength,isize,wd_object[n].foreground);
 for(i=0;i<wd_object[n].xsize;i++) 
  point_to_fn2(i,wd_object[n].ysize-1,col,clength,isize,wd_object[n].foreground);  
 for(i=1;i<wd_object[n].ysize-1;i++) 
  point_to_fn2(0,i,col,clength,isize,wd_object[n].foreground);  
 for(i=1;i<wd_object[n].ysize-1;i++) 
  point_to_fn2(wd_object[n].xsize-1,i,col,clength,isize,wd_object[n].foreground);
}
void draw_frame(n) int n;
{
 int i,x1,y1,x2,y2,col;
 
 col=wd_object[n].i1;
 
 x1=wd_object[n].xcord;x2=wd_object[n].xcord+wd_object[n].xsize; 
 y1=wd_object[n].ycord;y2=wd_object[n].ycord+wd_object[n].ysize;
 for(i=x1;i<x2;i++) drawpixel(i,y1,col);
 for(i=x1;i<x2;i++) drawpixel(i,y2-1,col);
 for(i=1+y1;i<y2-1;i++) drawpixel(x1,i,col);
 for(i=1+y1;i<y2-1;i++) drawpixel(x2-1,i,col);
}
 
void copy_without_frames(to,from,xsize,ysize,clength,isize)
char *to,*from;int xsize,ysize,clength,isize;
{int i,j,l;char *buf1,*buf2;unsigned char mask1,mask2;

 l=xsize/8+1-2;
 if(xsize%8) {
  mask1=0xff>>((xsize%8)-1);mask2=0xff^mask1;
 }
 else {
  l--;mask1=0x1;mask2=0xfe;	
 }
 buf1=to+isize;buf2=from+isize; 	
 for(j=0;j<ysize-2;j++) {
  for(i=0;i<gplanes;i++) {
   *buf1 = (*buf1&0x80) | (*buf2 & 0x7f);
   memcpy(buf1+1,buf2+1,l);
   *(buf1+l+1) = (*(buf1+l+1)&mask1) | (*(buf2+l+1) & mask2);
   buf1 += clength;buf2 += clength; 	    
  }
 }
}

/*****************************************************************
* Example of a fill routine
******************************************************************/


