/*****************************************************************************
* O8.C	CODE FOR WD_OBJECT TYPE replace_buffer
* 
******************************************************************************/ 
#include "x.ext"
#include "text.ext"
#include "win.ext"
#ifndef DOS_SYSTEM
extern XColor   *xcolor;
#endif

extern int colorZ;
char *zballoc();
/*********************************************************
* The replace_buffer wd_object-type has the 3 routines:
*	make_replace_buffer
*	replace_buffer
*	free_replace_buffer
*
* The routine pixel_draw calls the main window routine 
*	replace_window
* to do the work. It has subroutines 
* 
* There are useful subroutines 
* 
* You should write a fill routine which creates a specific wd_object 
* of the wd_object type that you want. This fill routine then calls
* the make-routine of the wd_object type.
*
* As an example there is a filling routine
*	...
**********************************************************/
/*********************************************************
* The wd_object type replace_buffer
**********************************************************/
int make_replace_buffer(id,x,y,xsize,ysize,col1,col2,name,cutbufferid)
int id;
int x,y,xsize,ysize,col1,col2;
char *name;
int cutbufferid;
{
 int i;
 i=id-1;if(i<0) return(1);
 
 wd_object[i].type=REPLACE_BUFFER_OBJ;
 wd_object[i].options=OCTET_ALIGNED | NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING | NO_RESIZING | NO_ICONIZING | MOVE_AS_RECTANGLE; 
 wd_object[i].options|=OBJECT_NOT_PUT;   
 wd_object[i].xcord=x;
 wd_object[i].ycord=y;
 wd_object[i].xsize=xsize;
 wd_object[i].ysize=ysize;
 wd_object[i].xstart=0;
 wd_object[i].ystart=0;  
 wd_object[i].clength= -1;
 wd_object[i].isize= -1;   
 wd_object[i].ylength= -1;    
 wd_object[i].background=0;     
 wd_object[i].foreground=fgbuffer;      
 wd_object[i].col1=col1;  
 wd_object[i].col2=col2;
 strcpy(wd_object[i].name,name);
 wd_object[i].p1=zballoc(sizeof(VUNIT)*11*9,15);
 wd_object[i].p2=(char **)zballoc(sizeof(VUNIT)*11*9,15);
 wd_object[i].i1=cutbufferid;
 zero_over(i);
 return(0);
}

int replace_buffer(id,com_par)
int id,com_par;
{
 return(replace_window(
  	&(wd_object[id-1].xcord),
 	&(wd_object[id-1].ycord),
 	&(wd_object[id-1].xsize),
 	&(wd_object[id-1].ysize),
       	&(wd_object[id-1].background),
       	&(wd_object[id-1].clength),
       	&(wd_object[id-1].isize),
       	&(wd_object[id-1].ylength),
       	(int)wd_object[id-1].col1,
       	(int)wd_object[id-1].col2,
 	(char *)wd_object[id-1].p1,
 	(char *)wd_object[id-1].p2,
 	wd_object[id-1].options,
	com_par));
} 		

int free_replace_buffer(id) 
int id;
{
 int i;
 i=id-1;
 if(i<0) {illegal_pointer(16);return(1);}
 remove_background(id);
 b_free(wd_object[i].p1);b_free(wd_object[i].p2);
 wd_object[i].type=FREE_OBJ;
 return(0);      
}

/*********************************************************
* the main routine doing the work, and its subroutines
**********************************************************/

/******************************************************************************
*   	replace_window()
*
*   	Description:
*
*	Parameters: 
*		x,y 	= coordinates of the upper left corner of the window
*		xsize 	= horizonal size
*		ysize 	= vertical size
*
*		backg_buf = addr. to an address of background buffer
*		  The background buffer has the size isize*ylength characters.
*		  If *backg_buf==0, a memory area is allocated by balloc.
*		clength	= bytes in the horizontal direction for one color plane
*		isize	= normally isize=gplanes*clength, gplanes color planes
*		ylength	= pixels in vertical direction
*	
*		col1	= background color of the window
*		col2	= color of the scrolling bars and frame
*
*		mode	= controls the operation, following values
*				NORMAL
*				DRAW_ONLY_DO_NOT_STAY
*		 		REFRESH       
*	Operations: 
*		killing
*		iconizing
*		
******************************************************************************/ 
int replace_window(x,y,xsize,ysize,backg_buf,clength,isize,ylength,col1,col2,
 			match1buf,match2buf,options,mode)
int *x,*y,*xsize,*ysize;
char **backg_buf;
int *clength,*isize,*ylength;
int col1,col2;
VUNIT *match1buf,*match2buf;
unsigned int options;
int mode;
{
 int ret,xstart,ystart;
 long percentx,percenty;
 
 if(make_background(clength,isize,ylength,x,y,xsize,ysize,backg_buf,mode)) return(2);

 if(mode==DRAW_ONLY_DO_NOT_STAY || mode==REFRESH) {       
  clearwin(*x,*y,*x+ *xsize,*y+ *ysize-1,col1); 
 
  /* insert user written show window routine */
  draw_replace_buffer(*x,*y,match1buf,match2buf);
  putWinFrame(*x,*y,*ysize,*xsize,0,0,0,0,&percentx,&percenty,col2,
                NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING,0); 
  return(-2); /* exit, do nothing */
 }

 while(1) {	
  do {
   if(!buttons){
    if(mouse_off) {showmouse();mouse_off=0;}
   }
   else {
    if(!mouse_off) {hidemouse();mouse_off=1;}
    
    ret=repl_inside_operations(X,Y,*x+2*cs,*y+2*cs,
    	*x+ *xsize-cs,*y+ *ysize-cs,match1buf,match2buf);
    if(ret)
     ret=check_scrolling(X,Y,*x,*y,*x+ *xsize,*y+ *ysize,
    	&xstart,&ystart,&percentx,&percenty,0,0,col1,col2,
        NO_VERTICAL_SCROLLING | NO_HORIZONTAL_SCROLLING); 
    if(ret== -2) { /* pointer pressed outside the window */
     return(-2); /* exit, do nothing */
    }
    else if(ret==2) { /* move window marker pressed */	
     if(buttons==1) {
      return(0); /* operations */           	
     }
     if(buttons==2) return(-4); /* move window */	
    }
    else if(ret==1) { /* kill window marker pressed */
     if(buttons==2) {
      if(options&NO_RESIZING) return(-2);/* do nothing */     	
      return(-3); /* make icon */     
     } 
     if(options&NO_KILLING) return(-2);/* do nothing */
     if(buttons==1) return(-1); /* kill window */	
    }
   }  	
   buttons=0;
   readmouse(&buttons,&X,&Y);
  } while(!kbhit());
 }    
}
    	
int repl_inside_operations(x,y,x1,y1,x2,y2,match1,match2)
int x,y,x1,y1,x2,y2;VUNIT *match1,*match2;
{
 int a,b;
 int pixel; 	
 if(x<x1 || x>x2 || y<y1 || y>y2) return(1);

 pixel=(int)xcolor[colorZ].pixel;

 a=(x-x1)/5;b=(y-y1)/5;
 if(a>=3 && a<12 && b>=3 && b<14) {
  fillbox2(x1+a*5,y1+b*5,5,5,pixel);
  match1[(b-3)*9+ a-3]=pixel;
 }  
 else if(a>=17 && a<26 && b>=3 && b<14) {
  fillbox2(x1+a*5,y1+b*5,5,5,pixel);
  match2[(b-3)*9+ a-17]=pixel;
 }   
 return(0);
}
int draw_one_buffer(a,b,mb) 
int a,b;VUNIT *mb;
{ 
 int n,m;
 
 for(n=0;n<11;n++) for(m=0;m<9;m++) 
  fillbox2(a+m*5,b+n*5,5,5,(int)mb[n*9+m]);
 return(0); 
}
int draw_replace_buffer(x,y,match1b,match2b) 
int x,y;VUNIT *match1b,*match2b;
{ 
 draw_one_buffer(x+2*cs+3*5,y+2*cs+3*5,match1b); 
 return(draw_one_buffer(x+2*cs+17*5,y+2*cs+3*5,match2b));
}

/*********************************************************
* useful subroutines
**********************************************************/

int change_color(col1,col2,xcord,ycord,xsize,ysize,clength,isize,buf) 
int col1,col2,xcord,ycord,xsize,ysize,clength,isize;char *buf;
{
  int i,j;unsigned long pixel;int color1;
 
 for(i=0;i<xsize;i++) {
  for(j=0;j<ysize;j++) { 	
   pixel=(unsigned long)point_from_fn2b(i,j,clength,isize,buf);
   color_by_pixel(pixel,0,&color1);
   if(color1==col1)
   { 
    pixel=xcolor[col2].pixel;
    point_to_fn2b(i,j,(int)pixel,clength,isize,buf);
    drawpixel2b(xcord+i,ycord+j,pixel);
   }
  }
 }
} 	

int match_replacebuffer(testedbuf,matchbuf,i,j,clength1,isize1,isize2)
VUNIT *testedbuf,*matchbuf;
int i,j;
int clength1,isize1,isize2;
{
 int n,m;
 int pixel;
 
 for(n=0;n<11;n++) {
  for(m=0;m<9;m++) {
   pixel=point_from_fn2b(m+i,n+j,clength1,isize1,testedbuf);
   if(pixel != matchbuf[m+n*isize2]) return(0);	   
  }
 }
 return(1);	
}

int replace(testedbuf,replacebuf,i,j, clength1,isize1,isize2,cuti)
VUNIT *testedbuf,*replacebuf;
int i,j;
int clength1,isize1,isize2;
int cuti;
{
 int n,m,col,pixel;
 
 for(n=0;n<11;n++) {
  for(m=0;m<9;m++) {
   pixel=replacebuf[m+n*isize2];
   point_to_fn2b(m+i,n+j,pixel,clength1,isize1,testedbuf);
   drawpixel2b(wd_object[cuti].xcord+i+m,wd_object[cuti].ycord+j+n,pixel);   
  }
 }
 return(0);	
}

char *zballoc(size,col) int size;int col;
{
 char *buf;
 int i,j;VUNIT *p;
 
 i=size/sizeof(VUNIT);
 buf=balloc(size);if(!buf) {no_memory();return(0);} 
 p=(VUNIT *)buf;
 for(j=0;j<i;j++) p[j]=xcolor[col].pixel;
 return(buf);
}      

/*********************************************************
* example of a fill routine
**********************************************************/
int fill_chgcolormenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Change color    to    in Cutbuffer");
 
 u1[0].xcord=13*cs; 
 u1[0].ycord=0*cr; 
 u1[0].parmax=2;
 u1[0].bsize=u1[0].size=2; 
 strcpy(u1[0].name,"1");
 
 u1[1].xcord=19*cs; 
 u1[1].ycord=0*cr; 
 u1[1].parmax=1;
 u1[1].bsize=u1[1].size=2; 
 strcpy(u1[1].name,"1"); 
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}
int fill_cutbuffermenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return(1);
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textn("failed to allocate menu",15,0);	
  return(-1);
 }
 strcpy(u2[0],"Kill cut buffer ");
 strcpy(u2[1],"Save cut buffer ");
 strcpy(u2[2],"Read cut buffer "); 
 
 u1[0].xcord=strlen(u2[1])*cs; 
 u1[0].ycord=1*cr; 
 u1[0].parmax=1;
 strcpy(u1[0].name,"");
 
 u1[1].xcord=strlen(u2[2])*cs; 
 u1[1].ycord=2*cr; 
 u1[1].parmax=1;
 strcpy(u1[1].name,"");
 
 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return(0);
}
