/********************************************************************
* readgif.c reads and writes gif format images.
* this code is modified from the gif-code of Thomas Lipp 
* in the book Grafikformate. Lipps code no longer works in Win XP.
* The book gives buyers of the book (like me) all rights to use the 
* code or any parts of it in their code.
*********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "x.ext"
#define NO_LZW_CODE  4096  
#define PREFIXTABLE  12

extern Display  *display;
extern Colormap colormap;

extern XColor   *xcolor;
XColor   *xcolor2;
extern XImage   *screenbuf;

extern int dbug;
int ykoor=10;
int xkoor=496;

unsigned char *resbuf;
int   *lpPrefixTable;

unsigned char      *lpStack;
unsigned int       uDataSize;      // Datengre fr LZW-Kompression
unsigned int       uCodeSize;      // Codegre fr LZW-Kompression
unsigned int       uCodeMask;      // Codemaske fr LZW-Kompression
unsigned int       uClear;         // Clear-Code
unsigned int       uEOI;           // EOI-Code
unsigned int       uPrefix[4096];  // LZW-Prfix
unsigned char      cSuffix[4096];  // LZW-Suffix
unsigned char      cStack[4096];   // Stack
unsigned int       uAvail;    
unsigned int       uOldCode;  
unsigned char      *lpFill;   

int readGIF(filename,width,height,clarity) 
     char *filename;int *width,*height;int clarity;
{
 return readGIF1(filename,width,height,clarity,1.0);
}

/*************************************************/
/* set some colors to xcolor2 for writeGIF1      */
/*************************************************/
int set_xcolor2() 
{
 int u;

 u=21;
 while(1) {
  if (u+15>255) break;

  xcolor2[0+u].red=(0<<8);xcolor2[0+u].green=(0<<8);xcolor2[0+u].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor2[0+u])==0) 
    printf("problems with color %d\n",0);

  xcolor2[1+u].red=(0<<8);xcolor2[1+u].green=(0<<8);xcolor2[1+u].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor2[1+u])==0) 
    printf("problems with color %d\n",1);

  xcolor2[2+u].red=(0<<8);xcolor2[2+u].green=(255<<8);xcolor2[2+u].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor2[2+u])==0) 
    printf("problems with color %d\n",2);

  xcolor2[3+u].red=(0<<8);xcolor2[3+u].green=(255<<8);
  xcolor2[3+u].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor2[3+u])==0) 
    printf("problems with color %d\n",3);

  xcolor2[4+u].red=(255<<8);xcolor2[4+u].green=(0<<8);
  xcolor2[4+u].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor2[4+u])==0) 
    printf("problems with color %d\n",4);

  xcolor2[5+u].red=(188<<8);xcolor2[5+u].green=(143<<8);
  xcolor2[5+u].blue=(143<<8);
  if(XAllocColor(display,colormap,&xcolor2[5+u])==0) 
    printf("problems with color %d\n",5);

  xcolor2[6+u].red=(255<<8);xcolor2[6+u].green=(0<<8);
  xcolor2[6+u].blue=(255<<8);
  if(XAllocColor(display,colormap,&xcolor2[6+u])==0) 
    printf("problems with color %d\n",6);

  xcolor2[7+u].red=(192<<8);xcolor2[7+u].green=(192<<8);
  xcolor2[7+u].blue=(192<<8);
  if(XAllocColor(display,colormap,&xcolor2[7+u])==0) 
    printf("problems with color %d\n",7);

  xcolor2[8+u].red=(168<<8);xcolor2[8+u].green=(168<<8);
  xcolor2[8+u].blue=(168<<8);
  if(XAllocColor(display,colormap,&xcolor2[8+u])==0) 
    printf("problems with color %d\n",8);

  xcolor2[9+u].red=(191<<8);xcolor2[9+u].green=(216<<8);
  xcolor2[9+u].blue=(216<<8);
  if(XAllocColor(display,colormap,&xcolor2[9+u])==0) 
    printf("problems with color %d\n",9);

  xcolor2[10+u].red=(143<<8);xcolor2[10+u].green=(188<<8);
  xcolor2[10+u].blue=(143<<8);
  if(XAllocColor(display,colormap,&xcolor2[10+u])==0) 
    printf("problems with color %d\n",10);

  xcolor2[11+u].red=(204<<8);xcolor2[11+u].green=(50<<8);
  xcolor2[11+u].blue=(50<<8);
  if(XAllocColor(display,colormap,&xcolor2[11+u])==0) 
    printf("problems with color %d\n",11);

  xcolor2[12+u].red=(79<<8);xcolor2[12+u].green=(47<<8);
  xcolor2[12+u].blue=(79<<8);
  if(XAllocColor(display,colormap,&xcolor2[12+u])==0) 
    printf("problems with color %d\n",12);

  xcolor2[13+u].red=(216<<8);xcolor2[13+u].green=(216<<8);
  xcolor2[13+u].blue=(191<<8);
  if(XAllocColor(display,colormap,&xcolor2[13+u])==0) 
    printf("problems with color %d\n",13);

  xcolor2[14+u].red=(255<<8);xcolor2[14+u].green=(255<<8);
  xcolor2[14+u].blue=(0<<8);
  if(XAllocColor(display,colormap,&xcolor2[14+u])==0) 
    printf("problems with color %d\n",14);

  xcolor2[15+u].red=(252<<8);xcolor2[15+u].green=(252<<8);
  xcolor2[15+u].blue=(252<<8);
  if(XAllocColor(display,colormap,&xcolor2[15+u])==0) 
    printf("problems with color %d\n",15);
 
  if(u<32) u=32;
  else u+=16;
 }

 return 0;
}




int readGIF1(filename,width,height,clarity,magn) 
     char *filename;int *width,*height;int clarity;double magn;
{
 char cBuffer[7];    
 FILE *stream;
 unsigned int uColors;
 char  cSDStatus;     
 short wWidth;        
 short wHeight;       
 unsigned char  cByte; 
 unsigned char  cBackgrnd;     
 unsigned int   bQuit = 0; 
 int   bResult;    
 int uBitPerPixel,u;
 int i,j,k;
 unsigned char *interlacebuf;
 unsigned long pixel;
 short top1,width1,height1;char status; 
 FILE *fd;
 unsigned long shade;
 int xoff,yoff;

 if(clarity==3) shade=0;
 else if (clarity==2) shade=0x8888;
 else if (clarity==1) shade=0xcccc;

 stream = fopen(filename,"rb");
 if (!stream)
 {
   cannot_find_file(filename);
  return 0;  
 }
 fread(cBuffer,1,6,stream);  

 if (strncmp(cBuffer, "GIF", 3)) 
 {
  unknown_parameter("not gif-file");
  fclose(stream);
  return 0; 
 }
 if (strncmp(&cBuffer[3], "87a", 3) && 
     strncmp(&cBuffer[3], "89a", 3))
 {
  unknown_parameter("gif-version");
  printf("Unknown GIF-Version: %c%c%c\n ",
             cBuffer[3], cBuffer[4], cBuffer[5]);
  fclose(stream);
  return 0; 
 }

 fread((char *)&wWidth,1,2,stream);
 fread((char *)&wHeight,1,2,stream);
 fread((char *)&cSDStatus,1,1,stream);
 fread((char *)&cBackgrnd,1,1,stream);
 fread((char *)&cByte,1,1,stream);

 /***************/
 dbug=0;
 cBuffer[6]=0;
 print_dbug(xkoor,ykoor,cBuffer,0);ykoor+=15;
 print_dbug(xkoor,ykoor,"cSDStatus=",(int)cSDStatus);ykoor+=15;
 print_dbug(xkoor,ykoor,"wWidth=",wWidth);ykoor+=15;
 print_dbug(xkoor,ykoor,"wHeight=",wHeight);ykoor+=15;
 /***************/

 resbuf=malloc((int)wWidth*wHeight); 

 uBitPerPixel = (cSDStatus & 0x07) + 1;
 if (uBitPerPixel != 1)
  if (uBitPerPixel <= 4) uBitPerPixel = 4;
  else uBitPerPixel = 8;

 if (cSDStatus & 0x80) 
 {
  uColors = 1 << ((cSDStatus & 0x07) + 1);
  /* uColors;  is the number of colors */

  for (u = 0; u < uColors; u++)   
  {
   cBuffer[0]=fgetc(stream);
   cBuffer[1]=fgetc(stream);
   cBuffer[2]=fgetc(stream);
   
   xcolor2[u].red=  ((int)(0xff&cBuffer[0])<<8);
   xcolor2[u].green=((int)(0xff&cBuffer[1])<<8);
   xcolor2[u].blue= ((int)(0xff&cBuffer[2])<<8);

   xcolor2[u].red   |=shade;
   xcolor2[u].green |=shade;
   xcolor2[u].blue  |=shade;

   if(XAllocColor(display,colormap,&xcolor2[u])==0) 
   {printf("problems with color %d\n",u);return 0;}
   
  }
 }
 
 do
 {
  cByte = '\0';
  cByte=fgetc(stream);
  print_dbug(xkoor,ykoor,"cByte=",(int)cByte);ykoor+=15;
  switch (cByte)
  {
    
    /* case '\0': break; */ 
   case (char)0: bQuit=1; break;

   case ',' :
     bResult = ReadImage(stream,&top1,&width1,&height1,&status); 
    if (!bResult) bQuit = 1; /* errors */        
    break;
   case ';' : bQuit = 1; 
    break;
   case '!' : 
    ReadExtension(stream);  
    break;
   default  : 
    printf("Illegal GIF-Block!\n");
    bQuit = 1;
    break;
  }
 }
 while (!bQuit);

 if (status & 0x40) {
   /* image is interlaced */

   print_dbug(xkoor,ykoor,"interlaced ",0);ykoor+=15;
  interlacebuf=(char *)malloc((int)wWidth*wHeight); 
  if(!interlacebuf) {no_memory();return 0;} 
  k=0;
  for(j=top1;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+4;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+2;j<(top1+height1);j+=4) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }
  for(j=top1+1;j<(top1+height1);j+=2) {
   for(i=0;i<wWidth;i++) {
    interlacebuf[i+j*wWidth]=resbuf[k];k++;
   }
  }

  k=0;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    pixel=xcolor2[(int)interlacebuf[k]].pixel;
    xoff=(int)((double)i*magn*10.7/12.8);
    yoff=(int)(magn*(double)j);
    if(xoff<=*width && yoff<=*height)
     drawpixel2c(xoff,yoff,pixel);
    k++;
   }
  }
  free(interlacebuf);
 }
 else {
   print_dbug(xkoor,ykoor,"not interlaced ",0);ykoor+=15;
  k=0;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    xoff=(int)((double)i*magn*10.7/12.8);
    yoff=(int)(magn*(double)j);
    if(xoff<=*width && yoff<=*height)
     drawpixel2c(xoff,yoff,xcolor2[(int)resbuf[k]].pixel);
    k++;
   }
  }
 }

 if(magn*wWidth<=*width) *width=(int)(magn*wWidth);
 if(magn*wHeight<=*height) *height=(int)(magn*wHeight);
 free(resbuf);
 fclose(stream);    
 return 1;   
}

int ReadImage(stream,top,width,height,status) 
FILE *stream;short *top,*width,*height;char *status;    
{
 short               wLeft;     
 short               wTop;      
 short               wWidth;     
 short               wHeight;   
 char                cIDStatus; 
 int                 bResult;   
 char                cBuffer[3];
 unsigned int                 uColors;
 unsigned int                 u;

 // Image Descriptor
 fread((char *) &wLeft,1,2,stream); 
 fread((char *) &wTop,1,2,stream);  
 fread((char *) &wWidth,1,2,stream);  
 fread((char *) &wHeight,1,2,stream); 
 fread((char *) &cIDStatus,1,1,stream);
                                 
 *top=wTop;
 *width=wWidth;
 *height=wHeight;
 *status=cIDStatus;
 
 print_dbug(xkoor,ykoor,"wLeft=",wLeft);ykoor+=15;
 print_dbug(xkoor,ykoor,"wTop=",wTop);ykoor+=15;
 print_dbug(xkoor,ykoor,"wWidth=",wWidth);ykoor+=15;
 print_dbug(xkoor,ykoor,"wHeight=",wHeight);ykoor+=15;
 print_dbug(xkoor,ykoor,"cIDStatus=",(int)cIDStatus);ykoor+=15;

 // colormap
 if (cIDStatus & 0x80) 
 {
  uColors = 1 << ((cIDStatus & 0x07) + 1);

  for (u = 0; u < uColors; u++) 
  {
   fread(cBuffer,1,3,stream);
  }
 }
 bResult = ReadRaster(wWidth, wHeight,stream);
 if (!bResult)
 {
  return 0;
 }
 return 1;
}

int ReadExtension(stream) FILE *stream;
{
  char cCode;        
  char cCount;       
  char cBuffer[256]; 

  cCode=fgetc(stream);
  while (1) {
   cCount=fgetc(stream);
   if(cCount) {                     
    fread(cBuffer, 1, (int)cCount, stream);
   }
   else break;
  }
  return 1;
}

int ReadRaster(uWidth, uHeight,stream)
unsigned int  uWidth;
unsigned int uHeight;
FILE *stream;
{
 static   unsigned char   cBuffer[256]; 
 register int uBits   = 0; 
 register int dwDatum = 0l; 
 register int uCode   = 0;
 int      uCount  = 0;   
 int      bResult;      
 unsigned char     *lpByte;      
 unsigned char     buf[10];
 unsigned char ch1;
 int i;

 lpFill  =resbuf;
 lpStack =cStack;

 uDataSize = 0;
 uDataSize=(int)fgetc(stream);

 uClear    = 1 << uDataSize;            // Clear-Code
 uEOI      = uClear + 1;                // EOI-Code
 uAvail    = uClear + 2;               // Next free Code
 uOldCode  = NO_LZW_CODE;               // last Cod
 uCodeSize = uDataSize+1;            // Codesize
 uCodeMask = (1 << uCodeSize) - 1;      // Codemask

 for(uCode=0;uCode<uClear;uCode++) {
   uPrefix[uCode]=NO_LZW_CODE;
   cSuffix[uCode]=(char)uCode;
 }

 bResult = 1;

 uCount=(int)fgetc(stream);

 while (uCount > 0)
 {
  if (fread(cBuffer,1,uCount,stream) != uCount) {
    unknown_parameter("read fails");return 0;}

  if (bResult) {
   for (lpByte = cBuffer; uCount-- > 0; lpByte++)
   {
    ch1= *lpByte;

    dwDatum += ((int) ch1) << uBits;
    uBits   += 8;

    /* at this point uBits is the size of data in dwDatum */
    if (uBits >= uCodeSize)
    {
     uCode     = (int) dwDatum & uCodeMask; 
     dwDatum >>= uCodeSize;                 
     uBits    -= uCodeSize;
     if (uCode == uEOI)
      goto exitloop;  
     bResult = DecodeLZW(uCode);
     if (!bResult) uCount = 0;  /* error case */
    }
   }
   uCount=0;
   uCount=(int)fgetc(stream);
  }
 }
exitloop: // Marke zum vorzeitigen Verlassen der Schleife

 return bResult;
}

int DecodeLZW(uCode) int uCode; 
{
 static unsigned char cFirstChar;  
 unsigned int  uInCode;      
 char szString[40];

 if (uCode == uClear)
 {
  uCodeSize = uDataSize+1;
  uCodeMask = (1 << uCodeSize) - 1;
  uAvail    = uClear + 2;
  uOldCode  = NO_LZW_CODE;
  return 1;
 }

 if (uCode > uAvail)
 {
  printf("invalid LZW-Code %d uAvail=%d\n", uCode,uAvail);
  return 0; 

 }

 if (uOldCode == NO_LZW_CODE)
 {
  cFirstChar = cSuffix[uCode];
  *lpFill++  = cFirstChar;
  uOldCode   = uCode;
  return 1;
 }

 uInCode = uCode;  // LZW-Code marks

 if (uCode == uAvail)
 {
  *lpStack++ = cFirstChar;
  uCode      = uOldCode;
 }

 while (uCode > uClear)
 {
  *lpStack++ = cSuffix[uCode];
  uCode      = uPrefix[uCode];
 }

 cFirstChar      = cSuffix[uCode];
 *lpStack++      = cFirstChar;
 uPrefix[uAvail] = uOldCode;
 cSuffix[uAvail] = cFirstChar;
 if (uAvail < 4096) {
  uAvail++;
 }

 if (((uAvail & uCodeMask) == 0) && (uAvail < 4096))
 {
  uCodeSize++;
  uCodeMask += uAvail;
 }

 uOldCode = uInCode;
 do
 {
  *lpFill++ = *--lpStack;
 }
 while ((char *)lpStack > (char *) cStack);

 return 1;
}


/**********************************************
 * expands x-axis by 12.8/10.7
 *********************************************/
int writeGIF1(filename,x1,y1,x2,y2)
char* filename;int x1,y1,x2,y2;
{
 char cBuffer[6];
 FILE *stream;
 unsigned int uColors;
 char  cSDStatus;     
 int wWidth;        
 int wHeight;       
 unsigned char  cByte; 
 unsigned char  cBackgrnd;     
 int   bResult;    
 int uBitPerPixel,u;
 int i,j,k;
 unsigned char *interlacebuf;
 unsigned long pixel;
 int top1,width1,height1;
 unsigned char status; 
 int col1;
 unsigned char ch1,ch2;
 unsigned long shade;
 int width,x10;

 stream = fopen(filename,"wb+");
 if (!stream)
 {
   cannot_create_file(filename);
  return 0;  
 }
 width=x2-x1+1;
 wWidth=width1=(int)((double)width*12.8/10.7);
 wHeight=height1=y2-y1+1;
 cSDStatus=0xf7;
 /* status=0x40;*/
 status=0x07;

 top1=0;
 cBackgrnd=0; 
 cByte=0; 

 resbuf=(unsigned char *)malloc((int)wHeight*wWidth); 
 if(!resbuf) {no_memory();return 0;}

 if (status & 0x40) {
   /* image is interlaced */

  interlacebuf=(char *)malloc((int)wHeight*wWidth); 
  if(!interlacebuf) {no_memory();return 0;} 

  k=0;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    x10=(int)(10.7/12.8*(double)i)+x1;
    if(x10<0 || j+y1<0) col1=15;
    else {
     pixel=getpixel2c(x10,j+y1);

     color_by_pixel1(pixel,2,&col1,&shade);
     if(col1>-1) {
      interlacebuf[k]=(unsigned char)col1;
     }
    }
    k++;
   }
  }

  k=0;
  for(j=top1;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    resbuf[k]=interlacebuf[i+j*wWidth];k++;
   }
  }
  for(j=top1+4;j<(top1+height1);j+=8) {
   for(i=0;i<wWidth;i++) {
    resbuf[k]=interlacebuf[i+j*wWidth];k++;
   }
  }
  for(j=top1+2;j<(top1+height1);j+=4) {
   for(i=0;i<wWidth;i++) {
    resbuf[k]=interlacebuf[i+j*wWidth];k++;
   }
  }
  for(j=top1+1;j<(top1+height1);j+=2) {
   for(i=0;i<wWidth;i++) {
    resbuf[k]=interlacebuf[i+j*wWidth];k++;
   }
  }

  free(interlacebuf);
 }
 else {
  k=0;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    x10=(int)(10.7/12.8*(double)i)+x1;
    if(x10<0 || j+y1<0) col1=15;
    else {
     pixel=getpixel2c(x10,j+y1);
     color_by_pixel1(pixel,2,&col1,&shade);
     if(col1>-1) {
      resbuf[k]=(unsigned char)col1;
     }
    }
    k++;
   }
  }
 }
 strcpy(cBuffer,"GIF87a");
 fwrite(cBuffer,1,6,stream);  

 ch1=wWidth&0xff;ch2=(wWidth>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);
 ch1=wHeight&0xff;ch2=(wHeight>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);

 fputc(cSDStatus,stream);
 fputc(cBackgrnd,stream);
 fputc(cByte,stream);

 uBitPerPixel = (cSDStatus & 0x07) + 1;
 if (uBitPerPixel != 1)
  if (uBitPerPixel <= 4) uBitPerPixel = 4;
  else uBitPerPixel = 8;

 if (cSDStatus & 0x80) 
 {
  uColors = 1 << ((cSDStatus & 0x07) + 1);

  printf("in writeGIF1 uColors=%d\n",uColors);

  for(i=0;i<uColors;i++) {
   cBuffer[0]=(xcolor2[i].red>>8);
   cBuffer[1]=(xcolor2[i].green>>8);
   cBuffer[2]=(xcolor2[i].blue>>8);
   fwrite(cBuffer,1,3,stream);
  }
 }

 cByte=',';
 fputc(cByte,stream);
 bResult = WriteImage(stream,top1,width1,height1,status); 

 fputc(0x36,stream);
 free(resbuf);
 fclose(stream);
 return 1;   
}

int WriteImage(stream,top,width,height,status) 
FILE *stream;int top,width,height;char status;    
{
 int               wLeft;     
 int               wTop;      
 int               wWidth;     
 int               wHeight;

 char                cIDStatus; 
 int                 bResult;   
 char                cBuffer[3];
 unsigned int        uColors;
 unsigned int        u;
 unsigned char ch1,ch2;

 wTop=top;
 wWidth=width;
 wHeight=height;
 cIDStatus=status;

 wLeft=0;

 /* Image Descriptor */
 ch1=wLeft&0xff;ch2=(wLeft>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);
 ch1=wTop&0xff;ch2=(wTop>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);
 
 ch1=wWidth&0xff;ch2=(wWidth>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);
 ch1=wHeight&0xff;ch2=(wHeight>>8)&0xff;fputc(ch1,stream);fputc(ch2,stream);
 fputc(cIDStatus,stream);

 bResult = WriteRaster(wWidth, wHeight,stream);
 if (!bResult)
 {
  return 0;
 }
 return 1;
}


/**********************/
void WriteCode(uCode, uLength,stream)
int uCode;  
int uLength;
FILE *stream;
{
  static char   cBuffer[256]; 
  static int   uByte;         
  static int   uOffset;       
         int  dwShift;       
         unsigned char *lpByte; 
         int   uBits;         
         int   u;             

  if (uCode == NO_LZW_CODE && uLength == 0)
    {
     for (u = 1; u < 256; u++)
       cBuffer[u] = (unsigned char) 0;
     uOffset = 0;
     uByte   = 1;
     return;
    }

  uBits     = uOffset + uLength;
  dwShift   = (int) uCode;    
  dwShift <<= uOffset;        
  lpByte    = (unsigned char *) &dwShift; 
  cBuffer[uByte] |= lpByte[0];   
  if (uByte == 255 && uBits >= 8)
    {
     cBuffer[0] = (unsigned char) 255; 
     fwrite(cBuffer,1,256,stream);  
     for (u = 1; u < 256; u++)      
       cBuffer[u] = (unsigned char) 0;
     uByte = 0;
    }
  if (uBits >= 8) uByte++;  
  if (uBits > 8) cBuffer[uByte] = lpByte[1]; 
  if (uByte == 255 && uBits >= 16) 
    {
     cBuffer[0] = (unsigned char) 255;
     fwrite(cBuffer,1,256,stream); 
     for (u = 1; u < 256; u++) cBuffer[u] = (unsigned char) 0;
     uByte = 0;
    }
  if (uBits >= 16) uByte++; 
  if (uBits > 16)
    cBuffer[uByte] = lpByte[2]; 

  uOffset = uBits & 7; 

  if (uCode == uEOI)
    {
     if (uOffset == 0)
       uByte--;
     cBuffer[0] = (unsigned char)uByte;
     fwrite(cBuffer,1,uByte+1,stream); 

     cBuffer[0] = (unsigned char) 0;
     fputc(0x00,stream); 

    }
  return;
}

void EncodeLZW(uCode,stream)
register unsigned int uCode; 
FILE *stream;
{
  static   unsigned int uCurrentPrefix;
  static   unsigned char cCurrentSuffix;
           unsigned int uFound;         
           int bFound;         
           int bPrefixTableFull;
  register unsigned int u;      

  if (uCode == uClear)
    {
     uCurrentPrefix = NO_LZW_CODE;
     uCodeSize      = uDataSize + 1;
     WriteCode(NO_LZW_CODE, 0,stream); 
     WriteCode(uCode, uCodeSize,stream);
     return;
    }

  if (uCode == uEOI)
    {
     WriteCode(uCurrentPrefix, uCodeSize,stream);
     WriteCode(uCode, uCodeSize,stream);         
     return;
    }

  cCurrentSuffix = (unsigned char) uCode;

  bFound = 0;
  bPrefixTableFull = 1;

  if (uCurrentPrefix != NO_LZW_CODE)
    {
     for (u = 0; u < PREFIXTABLE && bPrefixTableFull; u++)
       {
        uFound = lpPrefixTable[uCurrentPrefix * PREFIXTABLE + u];
        if (uFound != NO_LZW_CODE)
          {  
           if (cSuffix[uFound] == cCurrentSuffix)
             { 
              bFound = 1;
              u = PREFIXTABLE;
             }
          }
         else
          bPrefixTableFull = 0;
       }
     if (!bPrefixTableFull)   
       uFound = NO_LZW_CODE;  
    }

  if (uCurrentPrefix == NO_LZW_CODE || (!bFound && bPrefixTableFull))
    { 
     uFound = NO_LZW_CODE;
     if (uCurrentPrefix == NO_LZW_CODE)
       u = 0;
      else
       u = uClear + 2;
     while (uFound == NO_LZW_CODE && u < uAvail)
       if (uPrefix[u] == uCurrentPrefix &&
           cSuffix[u] == cCurrentSuffix)
         uFound = u; 
        else
         u++;
    }

  if (uFound != NO_LZW_CODE)   
    uCurrentPrefix = uFound;   
   else                        
    if (uAvail == NO_LZW_CODE) 
      {
       WriteCode(uCurrentPrefix, uCodeSize,stream);

       uAvail = uClear + 2;
       for (u = 0; u < uAvail; u++)
         {
          uPrefix[u] = NO_LZW_CODE;
          cSuffix[u] = u;
         }
       for (u = 0; u < (int) 4096 * PREFIXTABLE; u++)
         lpPrefixTable[u] = NO_LZW_CODE;

       WriteCode(uClear, uCodeSize,stream); 
       uCodeSize      = uDataSize + 1; 
       uCurrentPrefix = uCode;         
      }
     else
      {
       uPrefix[uAvail] = uCurrentPrefix;
       cSuffix[uAvail] = cCurrentSuffix;

       for (u = 0; u < PREFIXTABLE; u++) 
         if (lpPrefixTable[uCurrentPrefix * PREFIXTABLE + u] ==
             NO_LZW_CODE)
           {
            lpPrefixTable[uCurrentPrefix * PREFIXTABLE + u] = uAvail;
            u = PREFIXTABLE;
           }

       WriteCode(uCurrentPrefix, uCodeSize,stream);
       uCodeSize = GetCodeLength(uAvail);    
       uAvail++;                             
       uCurrentPrefix = cCurrentSuffix;      
      }
  return;
}

/********************************************************************/

int WriteRaster(uWidth, uHeight,stream)
int uWidth; 
int uHeight;
FILE *stream;
{
  int   uCode;        
  int   uX;           
  int   uY;           
  int   val;
  int i,j;FILE *fd;

  uDataSize=8;
  fputc(0x08,stream);

  lpFill=resbuf;
  lpPrefixTable = (int *)malloc((int)4096*PREFIXTABLE*sizeof(int));
  if (!lpPrefixTable) {
      no_memory();
     return 1;
  }

  uClear = 1 << uDataSize;  // Clear-Code
  uEOI   = uClear + 1;      // EOI-Code
  uAvail = uClear + 2;      // Next free Code

  
  for (uCode = 0; uCode < uAvail; uCode++)
  {
     uPrefix[uCode] = NO_LZW_CODE;
     cSuffix[uCode] = uCode;
  }
  
  for (uCode = 0; uCode < (int) 4096 * PREFIXTABLE; uCode++)
    lpPrefixTable[uCode] = NO_LZW_CODE;

  EncodeLZW(uClear,stream);

  for (uY = 0; uY < uHeight; uY++)
    {
     for (uX = 0; uX < uWidth; uX++) {
       /* JJ
       val=(*lpFill)&0xff; 
       val |=((*(lpFill+1)&0xff)<<8);

       EncodeLZW(val,stream);
       lpFill++;
       */
       EncodeLZW(*lpFill++,stream);

     }
    }
  EncodeLZW(uEOI,stream);
  return 1; 
}
int GetCodeLength(uCode)
int uCode; 
{
  if (uCode & 2048)
    return 12;
  if (uCode & 1024)
    return 11;
  if (uCode &  512)
    return 10;
  if (uCode &  256)
    return  9;
  if (uCode &  128)
    return  8;
  if (uCode &   64)
    return  7;
  if (uCode &   32)
    return  6;
  if (uCode &   16)
    return  5;
  if (uCode &    8)
    return  4;
  return 3;
}
