/*****************************************
* REALMEM
* dummy for EXTMEM.C
* Jorma Jormakka
* 30. May 2005
******************************************/
#include "x.ext"
#include "win.ext"

int extended_mem_enough=1;
CHAINB **mempool;
char **mempool1;

int init_background_mem()
{ 
 int j;

 mempool1=(char **)malloc(16*sizeof(char *));
 if(!mempool1){printf("could not allocate mempool1\n");return 0;} 

 for(j=15;j>=0;j--) {
  mempool1[j]=(char *)malloc(8428L);
  if(!mempool1[j]) {  printf("could not allocate mempool1\n");return 0;}
  memset(mempool1[j],0,8428L);
 }

 if(fgbuffer) free(fgbuffer);
 fgbuffer=(char *)malloc(BGFGPART);
 if(!fgbuffer) {printf("could not allocate fgbuffer\n");return 0;} 	

 if(bgbuffer) free(bgbuffer);
 bgbuffer=(char *)malloc(BGFGPART);
 if(!bgbuffer) {printf("could not allocate bgbuffer\n");return 0;}
 
 return 1;
}


int init_em_pool(size) long size;
{
 int j;
 CHAINB *c;

 if(size>EXT_POOL_MAX) {printf("too large pool\n");return 0;}

 mempool=(CHAINB **)malloc(size*sizeof(CHAINB *));
 if(!mempool){printf("could not allocate mempool\n");return 0;}

 for(j=size;j>0;j--) {
  c=(CHAINB *)malloc(sizeof(CHAINB));
  if(!c) {  printf("could not allocate mempool\n");return 0;}
  memset(c,0,sizeof(CHAINB));
  c->chain_number=j;
  c->nextn=j+1;
  if(c->nextn>size) c->nextn=1;
  mempool[j-1]=c;
 }
 return 1;
}

int free_chain_mem()
{
 int j;

 if(mempool) {
  for(j=EXT_POOL_MAX-1;j>=0;j--) {
   if(mempool[j]) free(mempool[j]);
  }
  free(mempool);
 }
 
 return 0;
}

int free_background_mem()
{
 int j;

 if(fgbuffer) free(fgbuffer); 
 if(bgbuffer) free(bgbuffer);

 if(mempool1) {
  for(j=15;j>=0;j--) {
   if(mempool1[j]) free(mempool1[j]);
  }
  free(mempool1);
 }
 
 return 0;
}


CHAINB *get_cb(num,place) int place,num;
{
 CHAINB *c;

 if(!num) return(0); 	
 if(num<0) {printf("getc_cb: place=%d num=%d\n",place,num);getch();}
 c=(CHAINB *)mempool[num-1];

 if(c->chain_number!=num){
   printf("error in get_cb:  c->chain_number=%d\n",c->chain_number);
   printf("num=%d\n",num);   
   getch();	
 }
 return(c);
}

int refresh_cb(num,c,place) int num;CHAINB *c;int place;
{
 return 1;
}

int get_b(num,buf) int num;char *buf;
{
 if(num<1 || num>16) return 0; 	
 memcpy(buf,mempool1[num-1],8428L);
 return 0;
}
int save_b(num,buf) int num;char *buf;
{
 if(num<1 || num>16) return 0;
 memcpy(mempool1[num-1],buf,8428L);
 return 0;
} 
