/****************************************************************
* MODULE: SAVEPCX.C
* Author: Jorma Jormakka
* Date: 12.3.1992
* For viewing the plotted curves in Windows compress the image to 
* a PaintBrush *.pcx-file
* - the routine works for graphics mode 18 with VGA-display
*****************************************************************/
#include <stdio.h>
#include <string.h>
#include "x.ext"
#include "text.ext"
#include "win.ext"
#define seq_out(index,val) {outp(0x3c4,index);outp(0x3c5,val);}
#define graph_out(index,val) {outp(0x3ce,index);outp(0x3cf,val);}
#define LINELEN 80

extern unsigned char *resbuf; /* result will be here */

#ifndef DOS_SYSTEM
extern Display  *display;
extern Colormap colormap;
extern XColor   *xcolor2;
extern XColor   *xcolor;
extern XImage   *screenbuf;
#endif

extern unsigned int palette256[];

extern void setVGApalette();
int dbug=0;
 
int read_pixel(x,y) int x,y;
{
 int color; 
 color=change_pixel(x,y,15);
 drawpixel(x,y,color);	
 return color; 
}
 
print_dbug(x,y,str,val) 
int x,y;char *str;int val; {

 if(dbug) {
  print(x,y,str,val);if('q'==getch()) dbug=0;
 }
     
 /*
if(debug) {printf(str); printf("%d\n",val);}
 */
}
/********************************************************
* this routines saves files in *.pcx format, 256 color,
* run length coded
*********************************************************/
#ifdef NEW
int save_as_pcxfile(x1,y1,x2,y2,file_name,palette)
int x1,y1,x2,y2;char *file_name;unsigned char *palette;
{	
 int i,j,k,add1,add2,number,num_out,line_length,end,start_line,end_line;
 unsigned char ch,ch1,old_ch,red_col,green_col,blue_col;
 FILE *fd;unsigned char numcol;
 int color,color1,m;int bits;

 fd=fopen(file_name,"wb+");
 if(!fd) return(1);
 fputc(0x0a,fd); /*password */ 
 fputc(0x05,fd); /*version 3.0 */
 fputc(0x01,fd); /*run length encoding */
   
 numcol=4;
 if(numcol==4) {
  fputc(0x01,fd); /* bits per pixel */
  putw(x1,fd);    /* window dimensions */   
  putw(y1,fd);       
  putw(x2,fd);       
  putw(y2,fd);         
  putw(640,fd);   /* horizontal resolution */    
  putw(480,fd);   /* vertical resolution */

  for(i=0;i<16;i++) { /* color map */
   bits=palette256[i];
   red_col=  (((bits & 0x20)>>5)|((bits & 0x04)>>1))*85;
   green_col=(((bits & 0x10)>>4)|((bits & 0x02)))*85;
   blue_col= (((bits & 0x08)>>3)|((bits & 0x01)<<1))*85;   
   fputc(red_col,fd);
   fputc(green_col,fd);
   fputc(blue_col,fd);  
  }
    
  fputc(0x00,fd); /* reserved */
  fputc(0x04,fd); /* number of color planes */
  start_line=x1/8;end_line=x2/8+1;
  line_length=end_line-start_line;
  putw(line_length,fd); /* number of bytes per line */
  putw(1,fd);		  /* color/monochrome palette */
  for(i=70;i<128;i++) fputc(' ',fd); /* fill to the end of header */

  ch=0x00; 
  end=start_line+line_length*4+1;
  for(k=y1;k<y2;k++) {
   add1=LINELEN*k;
   number=1;
   j=0;
   add2= (start_line);
   old_ch=read_byte(add1+add2++,0);
   for(i=add2;i<end;i++) {
    if(i==end-1) ch=old_ch-1;
    else {
     if((add2)== end_line) { 
      j++;
      add2= start_line;
     }     
     ch=read_byte(add1+add2,j);
    }
    if((ch==old_ch) && number<63) number++;
    else {
     num_out=((unsigned char)number | 0xc0);
     if((number != 1) || ((old_ch & 0xc0)==0xc0)) fputc(num_out,fd);
     fputc(old_ch,fd);
     old_ch=ch;
     number=1;
    }
    add2++;
   }
  }
 }
 
 fclose(fd);
 return(0);
}  
#endif
int restore_screen(char file_name[])
{
 FILE *fd;unsigned char numcol;
 unsigned char ch,ch1,red_col,green_col,blue_col,line_length,end,color;
 int line_end,i,j,k,m,pass,x1,y1,x2,y2,xoff[20],yoff[20],times;
 double xscale, yscale, xyscale;
 int i1,j1,oldi1,oldj1,col1,ycut;
 int ch2,col2; 
 int pixel[640],pixupdates[640];
 
 dbug=0;
 for (i1=0;i1<256;i1++) {
  if(i1==0x0f) palette256[i1]=15;
  else if(i1==0x1f) palette256[i1]=15;  
  else if(i1==0x2f) palette256[i1]=15;      
  else if(i1==0x3f) palette256[i1]=15;    
  else if(i1==0x4f) palette256[i1]=15;
  else if(i1==0x5f) palette256[i1]=15;            
  else if(i1==0x6f) palette256[i1]=15;              
  else if(i1==0x7f) palette256[i1]=15; 
  else if(i1==0x8f) palette256[i1]=15;
  else if(i1==0x9f) palette256[i1]=15;                                 
  else if(i1==0xaf) palette256[i1]=15;          
  else if(i1==0xbf) palette256[i1]=15;
  else if(i1==0xcf) palette256[i1]=15;
  else if(i1==0xdf) palette256[i1]=15;                                    
  else if(i1==0xef) palette256[i1]=15;        
  else if(i1==0xff) palette256[i1]=15;        
  else if(i1&0x0f==0x07) palette256[i1]=15;  
  else palette256[i1]=0;
 }
 if((fd=fopen(file_name,"rb"))==NULL) {
  cannot_find_file(file_name);
  return(0);
 }
 else {
  ch=(char)fgetc(fd);
  if(ch != 0x0a) {
   print(10,10,"This file is not a .pcx file, id=",(int)ch);
   fclose(fd);
   return(0);
  }
 }
 if(dbug) clearwin(0,0,X__max,Y__max,0);
 ch=fgetc(fd);print_dbug(10,10,"pcx-version (should be 5)=",(int)ch);
 ch=fgetc(fd);print_dbug(10,30,"compression (should be 1)=",(int)ch); 	
 ch=fgetc(fd);print_dbug(10,50,"bits/pixel in colorplane (should be 1)=",(int)ch);

 x1=getw(fd);print_dbug(10,70,"x1=",(int)x1);
 y1=getw(fd);print_dbug(10,90,"y1=",(int)y1);
 x2=getw(fd);print_dbug(10,110,"x2=",(int)x2);
 y2=getw(fd);print_dbug(10,130,"y2=",(int)y2);
 if(x2>X__max) x2=X__max;if(y2>Y__max) y2=Y__max;
 i=getw(fd);print_dbug(10,150,"horizontal res=",(int)i);
 i=getw(fd);print_dbug(10,170,"vertical resol=",(int)i);
 
 for(i=0;i<16;i++) {
  red_col=fgetc(fd)/85;
  green_col=fgetc(fd)/85;
  blue_col=fgetc(fd)/85;

  /*
  color  = ((red_col & 1)<<5) | ((red_col & 2)<<1);   
  color |= ((green_col & 1)<<4) | (green_col & 2);  
  color |= ((blue_col & 1)<<3) | ((blue_col & 2)>>1);
  */
 }
 
 ch=fgetc(fd); /* reserved */
 numcol=fgetc(fd);print_dbug(10,190,"number of color planes=",(int)numcol);  
 x2=x1+getw(fd);print_dbug(10,210,"bytes/picture part/colorplane=",(int)(x2-x1));   
 i=getw(fd);print_dbug(10,230,"interpretation of colorplane=",(int)i);    

 if(dbug) getch(); 
/* clearwin(0,0,X__max,Y__max,0);*/

 /* free bytes for the header */
 for(i=70;i<128;i++) ch=fgetc(fd);

 if((int)numcol==4) {
  for(k=y1;k<y2;k++) {
   i= k*80+(x1/8);
   line_end=k*80+(x2/8)+1;
   j=0;
   while(j<4) {
    ch1=fgetc(fd);
    if((ch1 & 0xc0) != 0xc0) {
     show_byte(i,j,ch1);
     i++;
     if(i >= line_end) {
      j++;
      i=k*80+(x1/8);
     }
    }
    else {
     ch1 &= 0x3f;
     pass = ch1;
     ch = fgetc(fd);
     for(m=0;m<pass;m++) {
      show_byte(i,j,ch);
      i++;
      if(i>=line_end) {
       j++;
       i=k*80+(x1/8);
      }
     }
    }
   }
  }
 }
 else if((int)numcol==1) {
  xscale=1.0;
  yscale=0.25;
  xyscale=0.8*480.0/640.0;
  yscale *=xyscale;
  for(times=0;times<20;times++) {
   xoff[times]=x1;yoff[times]=y1;
  }      
  ycut=220+y1;       
  xoff[0]=x1;yoff[0]=y1;
  xoff[1]=x1;yoff[1]=y1+90;  
  xoff[2]=x1;yoff[2]=y1+2*90;  
  xoff[3]=x1+246+18;yoff[3]=y1-(ycut-y1-2*90);  
  xoff[4]=x1+246+18;yoff[4]=y1+50;  
  xoff[5]=x1+246+18;yoff[5]=y1+50+90;
  xoff[6]=x1+246+18;yoff[6]=y1+50+2*90;   
  xoff[7]=x1+246+18;yoff[7]=y1+50+3*90;   
  times=0;
  while(times<7) {
  j=y1;
  for(i1=0;i1<640;i1++) {pixel[i1]=0;pixupdates[i1]=0;}
  oldj1=-1;
  while(1) {
   i=x1;
   oldi1=-1;
   while(1) {
    ch1=fgetc(fd);
    if((ch1 & 0xc0) != 0xc0) {
     /* byte is to be directly displayed */ 
     ch2=col2=palette256[(int)ch1];

     i1=xscale*(i-x1)+xoff[times];
     j1=yscale*(j-y1)+yoff[times];
     if(j1==ycut && oldj1!=ycut && times==2) {
      times++;
      i1=xscale*(i-x1)+xoff[times];
      j1=yscale*(j-y1)+yoff[times];       
     }     
     if(i1<640 && j1<480) {
      if(oldj1==j1) {
       pixel[i1]+=col2/15;
       pixupdates[i1]++;
       if(pixel[i1]<=(int)((double)pixupdates[i1]/1.5)) col2=0;else col2=15;    	       
      }     
      else pixel[i1]=col2/15; 
      drawpixel(i1,j1,col2);
      oldi1=i1;
     }
     i++;
    }
    else { /* run length coded, last 6 bits give the number */
     ch1 &= 0x3f;
     pass = ch1;
     /* the next byte gives the color to display */
     ch = fgetc(fd);
     ch2=col2=palette256[(int)ch];
     for(m=0;m<pass;m++) {
      i1=xscale*(i-x1)+xoff[times];
      j1=yscale*(j-y1)+yoff[times];
      if(j1==ycut && oldj1!=ycut && times==2) {
       times++;
       i1=xscale*(i-x1)+xoff[times];
       j1=yscale*(j-y1)+yoff[times];       
      }
      if(i1<640 && j1<480) {
       if(oldj1==j1) {
        pixel[i1]+=col2/15;
        pixupdates[i1]++;
        if(pixel[i1]<=(int)((double)pixupdates[i1]/1.5)) col2=0;else col2=15;        
       }   
       else pixel[i1]=col2/15;
       drawpixel(i1,j1,(int)col2);
       oldi1=i1;
      }      
      i++;
      if(i>x2) break;
     }
    }
    if(i>=x2) break;
   }
   j++;
   oldj1=j1; 
   j1=yscale*(j-y1)+yoff[times];
   if(j1>oldj1) {for(k=0;k<640;k++) {pixel[k]=0;pixupdates[k]=0;}}
   
   if(j>=y2) break;   
  }
   times++;
  }  	
 }
 fclose(fd);
 return(x2);
}

int clean_pcx(char file_name[], char file_name2[])
{
 FILE *fd,*fd2;unsigned char numcol;
 unsigned char ch,ch1,ch3,red_col,green_col,blue_col,line_length,end,color;
 int line_end,i,j,k,m,pass,x1,y1,x2,y2,xoff[20],yoff[20],times;
 double xscale, yscale, xyscale;
 int i1,j1,oldi1,oldj1,col1,ycut;
 int ch2,col2; 
 char line[10];
 int pixel[640];
 
 dbug=0;
 for (i1=0;i1<256;i1++) {
  if(i1==0x0f) palette256[i1]=15;
  else if(i1==0x1f) palette256[i1]=15;  
  else if(i1==0x2f) palette256[i1]=15;      
  else if(i1==0x3f) palette256[i1]=15;    
  else if(i1==0x4f) palette256[i1]=15;
  else if(i1==0x5f) palette256[i1]=15;            
  else if(i1==0x6f) palette256[i1]=15;              
  else if(i1==0x7f) palette256[i1]=15; 
  else if(i1==0x8f) palette256[i1]=15;
  else if(i1==0x9f) palette256[i1]=15;                                 
  else if(i1==0xaf) palette256[i1]=15;          
  else if(i1==0xbf) palette256[i1]=15;
  else if(i1==0xcf) palette256[i1]=15;
  else if(i1==0xdf) palette256[i1]=15;                                    
  else if(i1==0xef) palette256[i1]=15;        
  else if(i1==0xff) palette256[i1]=15;        
  else if(i1&0x0f==0x07) palette256[i1]=15;  
  else palette256[i1]=0;
 }
 if((fd2=fopen(file_name2,"wb+"))==NULL) {
  cannot_create_file(file_name2);
  return(0);
 } 
 if((fd=fopen(file_name,"rb"))==NULL) {
  cannot_find_file(file_name);
  return(0);
 }



 ch=(char)fgetc(fd);
  fputc(ch,fd2);
 if(ch != 0x0a) {
  print(10,10,"This file is not a .pcx file, id=",(int)ch);
  fclose(fd);
  fclose(fd2);   
  return(0);
 }

 
 ch=fgetc(fd);
  fputc(ch,fd2); 
 ch=fgetc(fd);
  fputc(ch,fd2); 
 ch=fgetc(fd);
  fputc(ch,fd2);
  
 x1=getw(fd);
  putw(x1,fd2); 
 y1=getw(fd);
  putw(y1,fd2);  
 x2=getw(fd);
  putw(x2,fd2);  
 y2=getw(fd);
  putw(y2,fd2);  
 if(x2>X__max) x2=X__max;if(y2>Y__max) y2=Y__max;
 i=getw(fd);
  putw(i,fd2);  
 i=getw(fd);
  putw(i,fd2); 
   
 for(i=0;i<16;i++) {
  ch=fgetc(fd);fputc(ch,fd2); 
  ch=fgetc(fd);fputc(ch,fd2); 
  ch=fgetc(fd);fputc(ch,fd2); 
 }
 
 ch=fgetc(fd);
  fputc(ch,fd2);  
 ch=fgetc(fd);
  fputc(ch,fd2);  
 numcol=ch;
 x2=getw(fd);
  putw(x2,fd2);
 x2+=x1;
 i=getw(fd);
  putw(i,fd2); 


 for(i=70;i<128;i++) {ch=fgetc(fd);fputc(ch,fd2);}  


 if((int)numcol==4) {
  printf("not implemented\n");getch();return 0;
 }
 else if((int)numcol==1) {
  xscale=1.0;
  yscale=0.25;
  xyscale=0.8*480.0/640.0;
  yscale *=xyscale;
  for(times=0;times<20;times++) {
   xoff[times]=x1;yoff[times]=y1;
  }      
  ycut=220+y1;       
  xoff[0]=x1;yoff[0]=y1;
  xoff[1]=x1;yoff[1]=y1+90;  
  xoff[2]=x1;yoff[2]=y1+2*90;  
  xoff[3]=x1+246+18;yoff[3]=y1-(ycut-y1-2*90);  
  xoff[4]=x1+246+18;yoff[4]=y1+50;  
  xoff[5]=x1+246+18;yoff[5]=y1+50+90;
  xoff[6]=x1+246+18;yoff[6]=y1+50+2*90;   
  xoff[7]=x1+246+18;yoff[7]=y1+50+3*90;   
  times=0;


  while(times<7) {
  j=y1;
  for(i1=0;i1<640;i1++) pixel[i1]=15;
  oldj1=-1;
  while(1) {
   i=x1;oldi1=-1;
   while(1) {
    if(1!=fread(line,1,(long)1,fd)) break;
    ch1=ch3=line[0];

    if((ch1 & 0xc0) != 0xc0) {

     /* byte is to be directly displayed */ 
     ch2=palette256[(int)ch1];
     i1=xscale*(i-x1)+xoff[times];
     j1=yscale*(j-y1)+yoff[times];
     if(j1==ycut && oldj1!=ycut && times==2) {
      times++;
      i1=xscale*(i-x1)+xoff[times];
      j1=yscale*(j-y1)+yoff[times];       
     }     
     if(i1<640 && j1<480) {
      if(oldj1==j1) {
       col1=pixel[i1];
       if(col1==0) ch2=0;    
      }     
      pixel[i1]=ch2;
                       	             
      col1=read_pixel(i1,j1);   
      if(col1==15 && ch2==0) {
       ch3=255;
       if(dbug) {
       	print_dbug(10,20,"A i1=",i1);print_dbug(10,40,"A j1=",j1);
       	if('q'==getch()) dbug=0;
       }
      }
      ch2=col1;
      if(ch2==15) col2=15; else col2=4;

      drawpixel(i1,j1,col2);
      oldi1=i1;
     }
     i++;
      /* notice that we will not compress deleted parts */
     if(ch3==255) fputc(0xc1,fd2);
     fputc(ch3,fd2);
    }
    else { /* run length coded, last 6 bits give the number */
     fputc(ch1,fd2);
     ch1 &= 0x3f;
     pass = ch1;
     /* the next byte gives the color to display */
     if(1!=fread(line,1,(long)1,fd)) break;
     ch=ch3=line[0];           
     ch2=palette256[(int)ch];
     for(m=0;m<pass;m++) {
      i1=xscale*(i-x1)+xoff[times];
      j1=yscale*(j-y1)+yoff[times];
      if(j1==ycut && oldj1!=ycut && times==2) {
       times++;
       i1=xscale*(i-x1)+xoff[times];
       j1=yscale*(j-y1)+yoff[times];       
      }
        if(dbug && i1==75 && j1==0) {
       	 print_dbug(10,200,"c i1=",i1);
       	 print_dbug(10,220,"c j1=",j1);
       	 print_dbug(10,240,"c oldj1=",oldj1);
       	 print_dbug(10,260,"c pixel[75]=",pixel[i1]);       	 
   	 print_dbug(10,260,"c ch2=",ch2);       	        	 
   	 print_dbug(10,260,"c ch=",(int)ch);       	        	    	 
       	 if('q'==getch()) dbug=0;
        }

      if(i1<640 && j1<480) {
       if(oldj1==j1) {
        col1=pixel[i1];
        if(col1==0) ch2=0;    
       }     
       pixel[i1]=ch2;
             	
       col1=read_pixel(i1,j1);
       if(col1==15 && ch2==0) {
        ch3=255;
        if(dbug) {
       	 print_dbug(200,220,"B i1=",i1);
       	 print_dbug(200,240,"B j1=",j1);
       	 print_dbug(200,260,"B oldj1=",oldj1);
       	 print_dbug(200,280,"B pixel[75]=",pixel[i1]);       	        	 
       	 if('q'==getch()) dbug=0;
       	 for (k=0;k<100;k++) drawpixel(i1,j1+k,4);
       	 if('q'==getch()) dbug=0;       	 
        }
       }       

       ch2=col1;
       if(ch2==15) col2=15; else col2=4;                 	       
       drawpixel(i1,j1,(int)col2);
       oldi1=i1;
      }
      i++;
      if(i>x2) break;
     }
     fputc(ch3,fd2);
    }
    if(i>=x2) break;
   }
   j++;
   oldj1=j1;
   if(j>=y2) break;   
  }
   times++;
  } 

 }


 fclose(fd);
 fclose(fd2); 
 return(x2);
}


int readpcx(char file_name[],int *width,int *height)
{
 FILE *fd;unsigned char numcol;
 unsigned char ch,ch1,ch2;
 int red_col,green_col,blue_col;
 int i,j,k,x1,y1,x2,y2;
 int wWidth,wHeight,u,uCount;
 char *lpFill;
 unsigned char pixel1;
 int i1,j1;

 dbug=0;
 if((fd=fopen(file_name,"rb"))==NULL) {
  cannot_find_file(file_name);
  return(0);
 }
 else {
   ch=(char)fgetc(fd);
  if(ch != 0x0a) {
   print(10,10,"This file is not a .pcx file, id=",(int)ch);
   fclose(fd);
   return(0);
  }
 }

 ch=fgetc(fd);print_dbug(10,10,"pcx-version (should be 5)=",(int)ch);
 ch=fgetc(fd);print_dbug(10,30,"compression (should be 1)=",(int)ch); 	
 ch=fgetc(fd);print_dbug(10,50,"bits/pixel in colorplane=",(int)ch);

 if(ch!=8) {printf("only 256 color supported\n");return 1;}

 ch1=fgetc(fd); ch2=fgetc(fd);
 x1=ch2*256+ch1;
 print_dbug(10,110,"x1=",(int)x1);

 ch1=fgetc(fd); ch2=fgetc(fd);
 y1=ch2*256+ch1;
 print_dbug(10,110,"y1=",(int)y1);

 ch1=fgetc(fd); ch2=fgetc(fd);
 x2=ch2*256+ch1;
 print_dbug(10,110,"x2=",(int)x2);

 ch1=fgetc(fd); ch2=fgetc(fd);
 y2=ch2*256+ch1;
 print_dbug(10,110,"y2=",(int)y2);

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,150,"horizontal res=",(int)i);

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,170,"vertical resol=",(int)i);

 for(i=0;i<16;i++) { /* these are invalid for 256 colors */
  red_col=fgetc(fd);
  green_col=fgetc(fd);
  blue_col=fgetc(fd);
 }
 
 ch=fgetc(fd); /* reserved */
 
 numcol=fgetc(fd);
 print_dbug(10,190,"number of color planes=",(int)numcol);  

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,210,"bytes/picture part/colorplane=",(int)i);   
 wWidth=i;

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,230,"interpretation of colorplane=",(int)i);    

 /* free bytes for the header */
 for(i=70;i<128;i++) ch=fgetc(fd);


 wHeight=y2-y1+3;

 resbuf=malloc(wHeight*wWidth); 
 if(!resbuf) {no_memory();return 1;}
 lpFill=resbuf;

 if((int)numcol==1) { /* only 256 color supported */
  k=0;
  for(k=0;k<wWidth*wHeight;) {

   ch1=fgetc(fd);
   if((ch1 & 0xc0) == 0xc0) {
    uCount= ch1&0x3f;
    ch1=fgetc(fd);
    for(u=0;u<uCount;u++) {*lpFill++ = ch1;k++;} 
   }
   else {*lpFill++ = ch1;k++;}
  }
 }

 if(fgetc(fd)==0x0c) {
  for(i=0;i<256;i++) { /* 256 colors colormap at the end of the file */
   red_col=(int)fgetc(fd);
   green_col=(int)fgetc(fd);
   blue_col=(int)fgetc(fd);

   xcolor2[i].red= (red_col<<8);
   xcolor2[i].green=(green_col<<8);
   xcolor2[i].blue=(blue_col<<8);

   if(XAllocColor(display,colormap,&xcolor2[i])==0) 
   {printf("problems with color %d\n",i);return 0;}
  }
 }

 fclose(fd);

 if(wWidth<*width)   *width=wWidth;
 if(wHeight<*height) *height=wHeight;

 k=0;
 for(j=0;j<*height;j++) {
  for(i=0;i<*width;i++) {
   ch1=resbuf[k];
   drawpixel2c(i,j,xcolor2[(int)ch1].pixel);
   k++;
  }
 }


 free(resbuf);
 return(x2);
}


int writepcx(file_name,x1,y1,x2,y2)
char* file_name;int x1,y1,x2,y2;
{
 FILE *fd;
 unsigned char ch1,ch2;
 int red_col,green_col,blue_col;
 int i,j,k;
 int uCount;
 unsigned char *lpFill;
 unsigned long pixel;
 int palette_ind[256];int col1,col2;
 int wWidth,wHeight,numcol=1;
 int horres,vertres;

 fd=fopen(file_name,"wb+");
 if(!fd) return(1);
 fputc(0x0a,fd); /*password */ 
 fputc(0x05,fd); /*version 3.0 */
 fputc(0x01,fd); /*run length encoding */
 fputc(0x08,fd); /* 8 bits per pixel */

/* window dimensions */   
 ch1=x1&0xff;ch2=(x1>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);
 ch1=y1&0xff;ch2=(y1>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);
 ch1=x2&0xff;ch2=(x2>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);
 ch1=y2&0xff;ch2=(y2>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);

 /* horizontal resolution */
 horres=640;    
 ch1=horres&0xff;ch2=(horres>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);

 vertres=480;
/* vertical resolution */
 ch1=vertres&0xff;ch2=(vertres>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);

 for(i=0;i<16;i++) { /* color map for 16 colors. not valid */
  fputc(0x00,fd);
  fputc(0x00,fd);
  fputc(0x00,fd);
 }
     
 fputc(0x00,fd); /* reserved */
 fputc(0x01,fd); /* number of color planes */

 wWidth=x2-x1+2;
 wHeight=y2-y1+3;

 /* bytes/picture part/colorplane  */
 ch1=wWidth&0xff;ch2=(wWidth>>8)&0xff;fputc(ch1,fd);fputc(ch2,fd);

 /* color/monochrome palette */
 ch1=1;ch2=0;fputc(ch1,fd);fputc(ch2,fd);

 for(i=70;i<128;i++) fputc(' ',fd); /* fill to the end of header */

 for(i=0;i<256;i++) palette_ind[i]=2;

 resbuf=(unsigned char *)malloc(wHeight*wWidth); 
 if(!resbuf) {no_memory();return 1;}
 k=0;
 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {
   pixel=XGetPixel(screenbuf,i,j);
   color_by_pixel(pixel,2,&col1);
   if(col1>-1) {
    palette_ind[col1]=1;
    resbuf[k]=(char)col1;
   }
   else {
    color_by_pixel(pixel,1,&col1);
    palette_ind[col1]=1;
    resbuf[k]=(char)col1;
   }
   k++;
  }
 }

 lpFill=resbuf;

 /* run length coding */
 if((int)numcol==1) { /* only 256 color supported */
  for(i=0,k=0;k<wWidth*wHeight;) {
   ch1=*lpFill;
   while(ch1>=0xc0) {fputc(0xc1,fd);fputc(ch1,fd);lpFill++;k++;ch1=*lpFill;}
   uCount=1;
   while(1) {
    lpFill++;k++;
    i++;if(i>=wWidth) {i=0;break;} 
    if(ch1!=*lpFill || uCount==63) break;
    uCount++;
   } 
   if(uCount>1) {
    ch2=0xc0|(0x3f&uCount); fputc(ch2,fd);fputc(ch1,fd);
   }
   else fputc(ch1,fd);
  }
 }

 fputc(0x0c,fd);
 for(i=0;i<256;i++) { /* 256 colors colormap at the end of the file */
  if(palette_ind[i]==2) {
   red_col=(xcolor2[i].red>>8);
   green_col=(xcolor2[i].green>>8);
   blue_col=(xcolor2[i].blue>>8);
  }
  else {
   red_col=(xcolor[i].red>>8);
   green_col=(xcolor[i].green>>8);
   blue_col=(xcolor[i].blue>>8);
  }
  fputc((char)red_col,fd);
  fputc((char)green_col,fd);
  fputc((char)blue_col,fd);
 }

 free(resbuf);
 fclose(fd);

 return 0;
}


int altitude_from_pcx_map(char file_name[],int *width,int *height,
int mag,int startx,int starty)
{
 FILE *fd;unsigned char numcol;
 unsigned char ch,ch1,ch2;
 int red_col,green_col,blue_col;
 int i,j,k,x1,y1,x2,y2;
 int wWidth,wHeight,u,uCount;
 char *lpFill;
 unsigned char pixel1;
 int i1,j1;
 double rg,rb,gb;
 int m=0;
 unsigned long pixel,pixel_t0,pixel_t2;
 unsigned long pixel_u0,pixel_u1,pixel_u2;
 unsigned long pixel_l0,pixel_l1,pixel_l2;
 int unum,lnum,vnum,onum;

 dbug=0;
 if((fd=fopen(file_name,"rb"))==NULL) {
  cannot_find_file(file_name);
  return(0);
 }
 else {
   ch=(char)fgetc(fd);
  if(ch != 0x0a) {
   print(10,10,"This file is not a .pcx file, id=",(int)ch);
   fclose(fd);
   return(0);
  }
 }

 ch=fgetc(fd);print_dbug(10,10,"pcx-version (should be 5)=",(int)ch);
 ch=fgetc(fd);print_dbug(10,30,"compression (should be 1)=",(int)ch); 	
 ch=fgetc(fd);print_dbug(10,50,"bits/pixel in colorplane=",(int)ch);

 if(ch!=8) {printf("only 256 color supported\n");return 1;}

 ch1=fgetc(fd); ch2=fgetc(fd);
 x1=ch2*256+ch1;
 print_dbug(10,110,"x1=",(int)x1);

 ch1=fgetc(fd); ch2=fgetc(fd);
 y1=ch2*256+ch1;
 print_dbug(10,110,"y1=",(int)y1);

 ch1=fgetc(fd); ch2=fgetc(fd);
 x2=ch2*256+ch1;
 print_dbug(10,110,"x2=",(int)x2);

 ch1=fgetc(fd); ch2=fgetc(fd);
 y2=ch2*256+ch1;
 print_dbug(10,110,"y2=",(int)y2);

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,150,"horizontal res=",(int)i);

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,170,"vertical resol=",(int)i);

 for(i=0;i<16;i++) { /* these are invalid for 256 colors */
  red_col=fgetc(fd);
  green_col=fgetc(fd);
  blue_col=fgetc(fd);
 }
 
 ch=fgetc(fd); /* reserved */
 
 numcol=fgetc(fd);
 print_dbug(10,190,"number of color planes=",(int)numcol);  

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,210,"bytes/picture part/colorplane=",(int)i);   
 wWidth=i;

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;
 print_dbug(10,230,"interpretation of colorplane=",(int)i);    

 /* free bytes for the header */
 for(i=70;i<128;i++) ch=fgetc(fd);


 wHeight=y2-y1+3;

 resbuf=malloc(wHeight*wWidth); 
 if(!resbuf) {no_memory();return 1;}
 lpFill=resbuf;

 if((int)numcol==1) { /* only 256 color supported */
  k=0;
  for(k=0;k<wWidth*wHeight;) {

   ch1=fgetc(fd);
   if((ch1 & 0xc0) == 0xc0) {
    uCount= ch1&0x3f;
    ch1=fgetc(fd);
    for(u=0;u<uCount;u++) {*lpFill++ = ch1;k++;} 
   }
   else {*lpFill++ = ch1;k++;}
  }
 }

 if(fgetc(fd)==0x0c) {
  for(i=0;i<256;i++) { /* 256 colors colormap at the end of the file */
   red_col=(int)fgetc(fd);
   green_col=(int)fgetc(fd);
   blue_col=(int)fgetc(fd);

   xcolor2[i].red= (red_col<<8);
   xcolor2[i].green=(green_col<<8);
   xcolor2[i].blue=(blue_col<<8);

   if(XAllocColor(display,colormap,&xcolor2[i])==0) 
    {printf("problems with color %d\n",i);return 0;}
  }
 }

 fclose(fd);


 k=0;
 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {
   ch1=resbuf[k];
      
   if(i>=startx && mag*(i-startx)<wWidth 
    && j>=starty && mag*(j-starty)<wHeight ) 
   {
     
    if(is_brown((int)ch1))
     fillbox2(mag*(i-startx),mag*(j-starty),mag,mag,xcolor2[173].pixel);
    else 
     fillbox3(mag*(i-startx),mag*(j-starty),mag,mag,xcolor2[(int)ch1].pixel);        
   }    

   k++;
  }
 }
 *width=wWidth;*height=wHeight;
 free(resbuf);
 return(x2);
}

/******************/
int looks_brown(num,u) int num,u;
{
  if(u==0) {
    ;
  }
  else if(u==1) {
   if(num==200) return 1;  
   if(num==96) return 1;
   if(num==128) return 1;
   if(num==160) return 1;
   if(num==169) return 1;
  }
  else if (u==2) {
   if(num==96) return 1;
   if(num==105) return 1;
   if(num==109) return 1;
   if(num==128) return 1;

   if(num==145) return 1;
   if(num==149) return 1;
   if(num==160) return 1;
   if(num==168) return 1;
   if(num==169) return 1;
   if(num==173) return 1;
   if(num==177) return 1;
   if(num==178) return 1;
   if(num==181) return 1;
   if(num==182) return 1;
   if(num==186) return 1;

   if(num==105) return 1;  
   if(num==177) return 1; 
   if(num==181) return 1; 
  }
  else {
   if(num==200) return 1;
   if(num==205) return 1;
   if(num==209) return 1;

   if(num==213) return 1;
   if(num==214) return 1;
   if(num==218) return 1;
   if(num==222) return 1;
   if(num==242) return 1;
   if(num==246) return 1;
   if(num==250) return 1;
   if(num==254) return 1;
   if(num==215) return 1;
  }
  return 0;
}
/***************************/
int is_brown(num) int num;
{
  if(num==173) return 1;
  if(num==209) return 1;
  if(num==246) return 1; 

   if(num==205) return 1;
   if(num==214) return 1; 
   if(num==218) return 1;
   if(num==242) return 1;
   if(num==137) return 1; 

   if(num==210) return 1;
   if(num==114) return 1;
   if(num==46) return 1;
   if(num==213) return 1;
   if(num==250) return 1;
   if(num==141) return 1;
  return 0;
}

/****************************/
int algorithm2(wWidth,wHeight)  int wWidth,wHeight;
{
 int i,j;
 unsigned long pixel,pixel_t0,pixel_t2;
 unsigned long pixel_u0,pixel_u1,pixel_u2;
 unsigned long pixel_l0,pixel_l1,pixel_l2;
 int unum,lnum,vnum,onum;

 /*
 for(j=1;j<wHeight-1;j++) {
  for(i=1;i<wWidth-1;i++) {
   pixel=XGetPixel(screenbuf,i,j);
   if(pixel==0xffff) {
    pixel_t0=XGetPixel(screenbuf,i-1,j);
    pixel_t2=XGetPixel(screenbuf,i+1,j);

    pixel_u0=XGetPixel(screenbuf,i-1,j-1);
    pixel_u1=XGetPixel(screenbuf,i,j-1);
    pixel_u2=XGetPixel(screenbuf,i+1,j-1);
    unum=0;
    if(pixel_u0!=0xffff) unum++;
    if(pixel_u1!=0xffff) unum++;
    if(pixel_u2!=0xffff) unum++;

    pixel_l0=XGetPixel(screenbuf,i-1,j+1);
    pixel_l1=XGetPixel(screenbuf,i,j+1);
    pixel_l2=XGetPixel(screenbuf,i+1,j+1);
    lnum=0;
    if(pixel_l0!=0xffff) lnum++;
    if(pixel_l1!=0xffff) lnum++;
    if(pixel_l2!=0xffff) lnum++;
    if(pixel_t0==0xffff && pixel_t2==0xffff && 
       ( 
              (lnum==1  && (unum==1 || unum==2)) 
           || ((lnum==1 || lnum==2)  && unum==1)    
       )
      ) 
       pixel=0;
    else {

     vnum=0;
     if(pixel_u0!=0xffff) vnum++;
     if(pixel_t0!=0xffff) vnum++;
     if(pixel_l0!=0xffff) vnum++;
     onum=0;
     if(pixel_u2!=0xffff) onum++;
     if(pixel_t2!=0xffff) onum++;
     if(pixel_l2!=0xffff) onum++;
     if (pixel_u1==0xffff && pixel_l1==0xffff && 
	 (
          (onum==1  && (vnum==1 || vnum==2)) 
	  || ((onum==1 || onum==2)  && vnum==1))) 
     pixel=0;
    }
   }
   else pixel=0;
   drawpixel2b(i,j,pixel);
  }
 }
 */

 /* remove dots */
 for(j=1;j<wHeight-1;j++) {
  for(i=1;i<wWidth-1;i++) {
   pixel=XGetPixel(screenbuf,i,j);
   if(pixel!=0xffff) {
    pixel_t0=XGetPixel(screenbuf,i-1,j);
    if(pixel_t0==0xffff) { 
     pixel_t2=XGetPixel(screenbuf,i+1,j);
     if(pixel_t2==0xffff) { 
      pixel_u0=XGetPixel(screenbuf,i-1,j-1);
      if(pixel_u0==0xffff) { 
       pixel_u1=XGetPixel(screenbuf,i,j-1);
       if(pixel_u1==0xffff) { 
        pixel_u2=XGetPixel(screenbuf,i+1,j-1);
        if(pixel_u2==0xffff) { 
         pixel_l0=XGetPixel(screenbuf,i-1,j+1);
         if(pixel_u2==0xffff) { 
          pixel_l1=XGetPixel(screenbuf,i,j+1);
          if(pixel_l1==0xffff) { 
           pixel_l2=XGetPixel(screenbuf,i+1,j+1);
           if(pixel_l1==0xffff) pixel=0xffff;
	  }
	 }
	}
       }
      }
     }
    }
   }
   drawpixel2b(i,j,pixel);
  }
 }
 return 1;
}

int algorithm3(char file_name[])
{
 int i,j,counter;
 int col;
 unsigned long pixel,pixel_n0,pixel_n4;
 unsigned long pixel_t0,pixel_t4,pixel_t2;
 unsigned long pixel_m0,pixel_m4;
 unsigned long pixel_u0,pixel_u1,pixel_u2,pixel_u3,pixel_u4;
 unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_l3,pixel_l4;
 FILE *fd;unsigned char numcol;
 unsigned char ch,ch1,ch2;
 int red_col,green_col,blue_col;
 int k,x1,y1,x2,y2;
 int wWidth,wHeight,u,uCount;
 char *lpFill;
 unsigned long pixel1;
 int i1,j1,stop,color,col1,col2;


 /* first find water and fill them with col=1 */

 if((fd=fopen(file_name,"rb"))==NULL) {
  cannot_find_file(file_name);
  return(0);
 }
 else {
   ch=(char)fgetc(fd);
  if(ch != 0x0a) {
   print(10,10,"This file is not a .pcx file, id=",(int)ch);
   fclose(fd);
   return(0);
  }
 }

 ch=fgetc(fd);
 ch=fgetc(fd);
 ch=fgetc(fd);

 if(ch!=8) {printf("only 256 color supported\n");return 1;}

 ch1=fgetc(fd); ch2=fgetc(fd);
 x1=ch2*256+ch1;
 ch1=fgetc(fd); ch2=fgetc(fd);
 y1=ch2*256+ch1;
 ch1=fgetc(fd); ch2=fgetc(fd);
 x2=ch2*256+ch1;

 ch1=fgetc(fd); ch2=fgetc(fd);
 y2=ch2*256+ch1;

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;

 for(i=0;i<16;i++) { /* these are invalid for 256 colors */
  red_col=fgetc(fd);
  green_col=fgetc(fd);
  blue_col=fgetc(fd);
 }
 
 ch=fgetc(fd); /* reserved */
 
 numcol=fgetc(fd);

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;

 wWidth=i;

 ch1=fgetc(fd); ch2=fgetc(fd);
 i=ch2*256+ch1;

 /* free bytes for the header */
 for(i=70;i<128;i++) ch=fgetc(fd);

 wHeight=y2-y1+3;

 resbuf=malloc(wHeight*wWidth); 
 if(!resbuf) {no_memory();return 1;}
 lpFill=resbuf;

 if((int)numcol==1) { /* only 256 color supported */
  k=0;
  for(k=0;k<wWidth*wHeight;) {

   ch1=fgetc(fd);
   if((ch1 & 0xc0) == 0xc0) {
    uCount= ch1&0x3f;
    ch1=fgetc(fd);
    for(u=0;u<uCount;u++) {*lpFill++ = ch1;k++;} 
   }
   else {*lpFill++ = ch1;k++;}
  }
 }
 fclose(fd);
 /* now we have the map in resbuf */

 k=stop=0;
 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {
   ch1=resbuf[k];
   if((int)ch1==123) { /* this must be the color of water */
    pixel=XGetPixel(screenbuf,i,j);
    if(pixel==xcolor[15].pixel) {  
      flood_fill(i,j,1,0,0,wWidth-1,wHeight-3);stop=1; break;
    }
   }
   k++;
  }
   if(stop) break;
 }
 free(resbuf);

 /* now fill the rest of the map */
 counter=0;
 for(col=2;col<14;col++) {   
  pixel=xcolor[col-1].pixel;
  for(j=0;j<wHeight;j++) {
   for(i=0;i<wWidth;i++) {
    pixel1=XGetPixel(screenbuf,i,j);
    if(pixel1==xcolor[15].pixel) {

     if(j>1) {
      if(i>1)
       pixel_u0=XGetPixel(screenbuf,i-2,j-2);
      else pixel_u0=0;
      if(i>0)
       pixel_u1=XGetPixel(screenbuf,i-1,j-2);
      else pixel_u1=0;
       pixel_u2=XGetPixel(screenbuf,i,j-2);
      if(i<wHeight-1)
       pixel_u3=XGetPixel(screenbuf,i+1,j-2);
      else pixel_u3=0;
      if(i<wHeight-2)
       pixel_u4=XGetPixel(screenbuf,i+2,j-2);
      else pixel_u4=0;
     }
     else pixel_u0=pixel_u1=pixel_u2=pixel_u3=pixel_u4=0;
     if(j<wHeight-2) {
      if(i>1)
       pixel_l0=XGetPixel(screenbuf,i-2,j+2);
      else pixel_l0=0;
      if(i>0)
       pixel_l1=XGetPixel(screenbuf,i-1,j+2);
      else pixel_l1=0;
       pixel_l2=XGetPixel(screenbuf,i,j+2);
      if(i<wHeight-1)
       pixel_l3=XGetPixel(screenbuf,i+1,j+2);
      else pixel_l3=0;
      if(i<wHeight-2)
       pixel_l4=XGetPixel(screenbuf,i+2,j+2);
      else pixel_l4=0;
     }
     else pixel_l0=pixel_l1=pixel_l2=pixel_l3=pixel_l4=0;

     if(i>1) {
      if(j>0)
       pixel_n0=XGetPixel(screenbuf,i-2,j-1);
      else pixel_n0=0;
      pixel_t0=XGetPixel(screenbuf,i-2,j);
      if(j<wHeight-1)
       pixel_m0=XGetPixel(screenbuf,i-2,j+1);
      else pixel_m0=0;
     }
     else pixel_n0=pixel_t0=pixel_n0=0;

     if(i<wWidth-2) {
      if(j>0)
       pixel_n4=XGetPixel(screenbuf,i+2,j-1);
      else pixel_n4=0;
      pixel_t4=XGetPixel(screenbuf,i+2,j);
      if(j<wHeight-1)
       pixel_m4=XGetPixel(screenbuf,i+2,j+1);
      else pixel_m4=0;
     }
     else pixel_n4=pixel_t4=pixel_n4=0;
     if(  pixel_u0==pixel || pixel_u1==pixel || pixel_u2==pixel
       || pixel_u3==pixel || pixel_u4==pixel
       || pixel_l0==pixel || pixel_l1==pixel || pixel_l2==pixel
       || pixel_l3==pixel || pixel_l4==pixel
       || pixel_m0==pixel || pixel_m4==pixel || pixel_n0==pixel
       || pixel_n4==pixel || pixel_t0==pixel || pixel_t4==pixel) {
       
      flood_fill(i,j,col,0,0,wWidth-1,wHeight-3);
      drawpixel(i,j,col);
      counter=0;
     }
    }
    counter++;
    if(counter>wWidth*wHeight) break;
   }
   if(counter>wWidth*wHeight) break;
  }
 }
#ifdef JJ
 /* replace black with highest neighbor color */
 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {
   pixel=XGetPixel(screenbuf,i,j);
   if(!pixel) {  
    if(j>0) {
     if(i>0)
      pixel_u0=XGetPixel(screenbuf,i-1,j-1);
     else pixel_u0=0;
      pixel_u1=XGetPixel(screenbuf,i,j-1);
     if(i<wHeight-1)
      pixel_u2=XGetPixel(screenbuf,i+1,j-1);
     else pixel_u2=0;
    }
    else pixel_u0=pixel_u1=pixel_u2=0;
    if(j<wHeight-1) {
     if(i>0)
      pixel_l0=XGetPixel(screenbuf,i-1,j+1);
     else pixel_l0=0;
      pixel_l1=XGetPixel(screenbuf,i,j+1);
     if(i<wHeight-1)
      pixel_l2=XGetPixel(screenbuf,i+1,j+1);
     else pixel_l2=0;
    }
    else pixel_l0=pixel_l1=pixel_l2=0;
    if(i>0) 
     pixel_t0=XGetPixel(screenbuf,i-1,j);
    else pixel_t0=0;
    if(i<wWidth-1) 
     pixel_t2=XGetPixel(screenbuf,i+1,j);
    else pixel_t2=0;
    color=1;
    color_by_pixel(pixel_u0,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_u1,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_u2,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_l0,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_l1,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_l2,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_t0,1,&col1);if(color<col1) color=col1;
    color_by_pixel(pixel_t2,1,&col1);if(color<col1) color=col1;
    drawpixel(i,j,color);
   }
  }
 }
#endif
 /*printf("finished algorithm3\n");*/
  
 return 0;
}

int algorithm4(wWidth,wHeight)
{
 int i,j;
 unsigned long pixel,pixel1;
 unsigned long pixel_t0,pixel_t1,pixel_t3,pixel_t4;
 unsigned long pixel_n0,pixel_n1,pixel_n2,pixel_n3,pixel_n4;
 unsigned long pixel_m0,pixel_m1,pixel_m2,pixel_m3,pixel_m4;
 unsigned long pixel_u0,pixel_u1,pixel_u2,pixel_u3,pixel_u4;
 unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_l3,pixel_l4;
 int lnum,unum,tnum,mnum,nnum;


 pixel1=xcolor[0].pixel; if(pixel1) {printf("black is not black\n");exit(1);}
 pixel1=xcolor[15].pixel;

 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {

   pixel=XGetPixel(screenbuf,i,j);
   if(pixel==pixel1) {

    if(j>1) {
     if(i>1)
      pixel_u0=XGetPixel(screenbuf,i-2,j-2);
     else pixel_u0=0;
     if(i>0)
      pixel_u1=XGetPixel(screenbuf,i-1,j-2);
     else pixel_u1=0;
      pixel_u2=XGetPixel(screenbuf,i,j-2);
     if(i<wHeight-1)
      pixel_u3=XGetPixel(screenbuf,i+1,j-2);
     else pixel_u3=0;
     if(i<wHeight-2)
      pixel_u4=XGetPixel(screenbuf,i+2,j-2);
     else pixel_u4=0;
    }
    else pixel_u0=pixel_u1=pixel_u2=pixel_u3=pixel_u4=0;

    if(j>0) {
     if(i>1)
      pixel_n0=XGetPixel(screenbuf,i-2,j-1);
     else pixel_n0=0;
     if(i>0)
      pixel_n1=XGetPixel(screenbuf,i-1,j-1);
     else pixel_n1=0;
      pixel_n2=XGetPixel(screenbuf,i,j-1);
     if(i<wHeight-1)
      pixel_n3=XGetPixel(screenbuf,i+1,j-1);
     else pixel_n3=0;
     if(i<wHeight-2)
      pixel_n4=XGetPixel(screenbuf,i+2,j-1);
     else pixel_n4=0;
    }
    else pixel_n0=pixel_n1=pixel_n2=pixel_n3=pixel_n4=0;

    if(j<wHeight-2) {
     if(i>1)
      pixel_l0=XGetPixel(screenbuf,i-2,j+2);
     else pixel_l0=0;
     if(i>0)
      pixel_l1=XGetPixel(screenbuf,i-1,j+2);
     else pixel_l1=0;
      pixel_l2=XGetPixel(screenbuf,i,j+2);
     if(i<wHeight-1)
      pixel_l3=XGetPixel(screenbuf,i+1,j+2);
     else pixel_l3=0;
     if(i<wHeight-2)
      pixel_l4=XGetPixel(screenbuf,i+2,j+2);
     else pixel_l4=0;
    }
    else pixel_l0=pixel_l1=pixel_l2=pixel_l3=pixel_l4=0;

    if(j<wHeight-1) {
     if(i>1)
      pixel_m0=XGetPixel(screenbuf,i-2,j+1);
     else pixel_m0=0;
     if(i>0)
      pixel_m1=XGetPixel(screenbuf,i-1,j+1);
     else pixel_m1=0;
      pixel_m2=XGetPixel(screenbuf,i,j+1);
     if(i<wHeight-1)
      pixel_m3=XGetPixel(screenbuf,i+1,j+1);
     else pixel_m3=0;
     if(i<wHeight-2)
      pixel_m4=XGetPixel(screenbuf,i+2,j+1);
     else pixel_m4=0;
    }
    else pixel_m0=pixel_m1=pixel_m2=pixel_m3=pixel_m4=0;

    if(i>1) 
     pixel_t0=XGetPixel(screenbuf,i-2,j);
    else pixel_t0=0;
    if(i>0) 
     pixel_t1=XGetPixel(screenbuf,i-1,j);
    else pixel_t1=0;

    if(i<wWidth-1) 
     pixel_t3=XGetPixel(screenbuf,i+1,j);
     else pixel_t3=0;
    if(i<wWidth-2) 
     pixel_t4=XGetPixel(screenbuf,i+2,j);
     else pixel_t4=0;

    lnum=0;
    if(!pixel_l1) lnum++;
    if(!pixel_l2) lnum++;
    if(!pixel_l3) lnum++;
    unum=0;
    if(!pixel_u1) unum++;
    if(!pixel_u2) unum++;
    if(!pixel_u3) unum++;
    nnum=0;
    if(!pixel_n1) nnum++;
    if(!pixel_n2) nnum++;
    if(!pixel_n3) nnum++;
    mnum=0;
    if(!pixel_m1) mnum++;
    if(!pixel_m2) mnum++;
    if(!pixel_m3) mnum++;
     
    if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
       (nnum==1 || nnum==2) && (mnum==1 || mnum==2))
    {
     drawpixel2b(i,j,xcolor[0].pixel);
    }
    else if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
        pixel_m0 && pixel_m1 && pixel_m2 && pixel_m3 && pixel_m4 &&
       (nnum=1 || nnum==2) && (lnum==1 || lnum==2) ) {
       drawpixel2b(i,j,xcolor[0].pixel);
       drawpixel2b(i,j+1,xcolor[0].pixel);
    }
    else if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
        pixel_n0 && pixel_n1 && pixel_n2 && pixel_n3 && pixel_n4 &&
        pixel_m0 && pixel_m1 && pixel_m2 && pixel_m3 && pixel_m4 &&

          ( lnum==1 || lnum==2) && 
	  ( unum==1 || unum==2)) {
       drawpixel2b(i,j,xcolor[0].pixel);
       drawpixel2b(i,j-1,xcolor[0].pixel);
       drawpixel2b(i,j+1,xcolor[0].pixel);
    }
   }
  }
 }
 /* printf("finished algorithm4\n");*/
  
 return 0;
}
int algorithm5(wWidth,wHeight)
{
 int i,j;
 unsigned long pixel,pixel1;
 unsigned long pixel_t0,pixel_t1,pixel_t3,pixel_t4;
 unsigned long pixel_n0,pixel_n1,pixel_n2,pixel_n3,pixel_n4;
 unsigned long pixel_m0,pixel_m1,pixel_m2,pixel_m3,pixel_m4;
 unsigned long pixel_u0,pixel_u1,pixel_u2,pixel_u3,pixel_u4;
 unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_l3,pixel_l4;
 int lnum,unum,tnum,mnum,nnum;


 pixel1=xcolor[0].pixel; if(pixel1) {printf("black is not black\n");exit(1);}
 pixel1=xcolor[15].pixel;

 for(i=0;i<wWidth;i++) {
  for(j=0;j<wHeight;j++) {

   pixel=XGetPixel(screenbuf,i,j);
   if(pixel==pixel1) {

    if(j>1) {
     if(i>1)
      pixel_u0=XGetPixel(screenbuf,i-2,j-2);
     else pixel_u0=0;
     if(i>0)
      pixel_u1=XGetPixel(screenbuf,i-1,j-2);
     else pixel_u1=0;
      pixel_u2=XGetPixel(screenbuf,i,j-2);
     if(i<wHeight-1)
      pixel_u3=XGetPixel(screenbuf,i+1,j-2);
     else pixel_u3=0;
     if(i<wHeight-2)
      pixel_u4=XGetPixel(screenbuf,i+2,j-2);
     else pixel_u4=0;
    }
    else pixel_u0=pixel_u1=pixel_u2=pixel_u3=pixel_u4=0;

    if(j>0) {
     if(i>1)
      pixel_n0=XGetPixel(screenbuf,i-2,j-1);
     else pixel_n0=0;
     if(i>0)
      pixel_n1=XGetPixel(screenbuf,i-1,j-1);
     else pixel_n1=0;
      pixel_n2=XGetPixel(screenbuf,i,j-1);
     if(i<wHeight-1)
      pixel_n3=XGetPixel(screenbuf,i+1,j-1);
     else pixel_n3=0;
     if(i<wHeight-2)
      pixel_n4=XGetPixel(screenbuf,i+2,j-1);
     else pixel_n4=0;
    }
    else pixel_n0=pixel_n1=pixel_n2=pixel_n3=pixel_n4=0;

    if(j<wHeight-2) {
     if(i>1)
      pixel_l0=XGetPixel(screenbuf,i-2,j+2);
     else pixel_l0=0;
     if(i>0)
      pixel_l1=XGetPixel(screenbuf,i-1,j+2);
     else pixel_l1=0;
      pixel_l2=XGetPixel(screenbuf,i,j+2);
     if(i<wHeight-1)
      pixel_l3=XGetPixel(screenbuf,i+1,j+2);
     else pixel_l3=0;
     if(i<wHeight-2)
      pixel_l4=XGetPixel(screenbuf,i+2,j+2);
     else pixel_l4=0;
    }
    else pixel_l0=pixel_l1=pixel_l2=pixel_l3=pixel_l4=0;

    if(j<wHeight-1) {
     if(i>1)
      pixel_m0=XGetPixel(screenbuf,i-2,j+2);
     else pixel_m0=0;
     if(i>0)
      pixel_m1=XGetPixel(screenbuf,i-1,j+2);
     else pixel_m1=0;
      pixel_m2=XGetPixel(screenbuf,i,j+2);
     if(i<wHeight-1)
      pixel_m3=XGetPixel(screenbuf,i+1,j+2);
     else pixel_m3=0;
     if(i<wHeight-2)
      pixel_m4=XGetPixel(screenbuf,i+2,j+2);
     else pixel_m4=0;
    }
    else pixel_m0=pixel_m1=pixel_m2=pixel_m3=pixel_m4=0;

    if(i>1) 
     pixel_t0=XGetPixel(screenbuf,i-2,j);
    else pixel_t0=0;
    if(i>0) 
     pixel_t1=XGetPixel(screenbuf,i-1,j);
    else pixel_t1=0;

    if(i<wWidth-1) 
     pixel_t3=XGetPixel(screenbuf,i+1,j);
     else pixel_t3=0;
    if(i<wWidth-2) 
     pixel_t4=XGetPixel(screenbuf,i+2,j);
     else pixel_t4=0;

    lnum=0;
    if(!pixel_n4) lnum++;
    if(!pixel_t4) lnum++;
    if(!pixel_m4) lnum++;
    unum=0;
    if(!pixel_n0) unum++;
    if(!pixel_t0) unum++;
    if(!pixel_m0) unum++;

    nnum=0;
    if(!pixel_n1) nnum++;
    if(!pixel_t1) nnum++;
    if(!pixel_m1) nnum++;
    mnum=0;
    if(!pixel_n3) mnum++;
    if(!pixel_t3) mnum++;
    if(!pixel_m3) mnum++;
        
    if(pixel_u2 && pixel_n2 && pixel_m2 && pixel_l2 && 
       (nnum==1) && (mnum==1))
    {
     drawpixel2b(i,j,xcolor[0].pixel);
    }
    /*
    else
     
    if(pixel_u2 && pixel_n2 && pixel_m2 && pixel_l2 &&  
        pixel_u3 && pixel_n3 && pixel_t3 && pixel_m3 && pixel_l3 &&
       (nnum=1) && (lnum==1) ) {
       drawpixel2b(i,j,xcolor[0].pixel);
       drawpixel2b(i+1,j,xcolor[0].pixel);
    }
    else if(pixel_u2 && pixel_n2 && pixel_m2 && pixel_l2 && 
        pixel_u3 && pixel_n3 && pixel_t3 && pixel_m3 && pixel_l3 &&
        pixel_u1 && pixel_n1 && pixel_t1 && pixel_m1 && pixel_l1 &&

          ( lnum==1) && 
	  ( unum==1)) {
       drawpixel2b(i,j,xcolor[0].pixel);
       drawpixel2b(i-1,j,xcolor[0].pixel);
       drawpixel2b(i+1,j,xcolor[0].pixel);
    }
    */
   }
  }
 }
 /* printf("finished algorithm5\n");*/
  
 return 0;
}








int algorithm4b(wWidth,wHeight)
{
 int i,j;
 unsigned long pixel,pixel1;
 unsigned long pixel_t0,pixel_t1,pixel_t3,pixel_t4;
 unsigned long pixel_n0,pixel_n1,pixel_n2,pixel_n3,pixel_n4;
 unsigned long pixel_m0,pixel_m1,pixel_m2,pixel_m3,pixel_m4;
 unsigned long pixel_u0,pixel_u1,pixel_u2,pixel_u3,pixel_u4;
 unsigned long pixel_l0,pixel_l1,pixel_l2,pixel_l3,pixel_l4;
 int lnum,unum,tnum,mnum,nnum;
 int startx=300,starty=300;

 pixel1=xcolor[3].pixel; 
 pixel1=xcolor[15].pixel;

 for(j=0;j<wHeight;j++) {
  for(i=0;i<wWidth;i++) {
   if(i>=startx && i<startx+100 && j>=starty && j<starty+100 ) {
    pixel=getpixel2c(3*(i-startx)+1,3*(j-starty)+1);
    if(pixel==pixel1) {

     if(j>1) {
      if(i>1)
       pixel_u0=getpixel2c(3*(i-2-startx)+1,3*(j-2-starty)+1);
      else pixel_u0=0;
      if(i>0)
       pixel_u1=getpixel2c(3*(i-1-startx)+1,3*(j-2-starty)+1);
      else pixel_u1=0;
      pixel_u2=getpixel2c(3*(i-startx)+1,3*(j-2-starty)+1);
      if(i<wHeight-1)
       pixel_u3=getpixel2c(3*(i+1-startx)+1,3*(j-2-starty)+1);
      else pixel_u3=0;
      if(i<wHeight-2)
       pixel_u4=getpixel2c(3*(i+2-startx)+1,3*(j-2-starty)+1);
      else pixel_u4=0;
     }
     else pixel_u0=pixel_u1=pixel_u2=pixel_u3=pixel_u4=0;

     if(j>0) {
      if(i>1)
       pixel_n0=getpixel2c(3*(i-2-startx)+1,3*(j-1-starty)+1);
      else pixel_n0=0;
      if(i>0)
       pixel_n1=getpixel2c(3*(i-1-startx)+1,3*(j-1-starty)+1);
      else pixel_n1=0;
      pixel_n2=getpixel2c(3*(i-startx)+1,3*(j-1-starty)+1);
      if(i<wHeight-1)
       pixel_n3=getpixel2c(3*(i+1-startx)+1,3*(j-1-starty)+1);
      else pixel_n3=0;
      if(i<wHeight-2)
       pixel_n4=getpixel2c(3*(i+2-startx)+1,3*(j-1-starty)+1);
      else pixel_n4=0;
     }
     else pixel_n0=pixel_n1=pixel_n2=pixel_n3=pixel_n4=0;

     if(j<wHeight-2) {
      if(i>1)
       pixel_l0=getpixel2c(3*(i-2-startx)+1,3*(j+2-starty)+1);
      else pixel_l0=0;
      if(i>0)
       pixel_l1=getpixel2c(3*(i-1-startx)+1,3*(j+2-starty)+1);
      else pixel_l1=0;
      pixel_l2=getpixel2c(3*(i-startx)+1,3*(j+2-starty)+1);
      if(i<wHeight-1)
       pixel_l3=getpixel2c(3*(i+1-startx)+1,3*(j+2-starty)+1);
      else pixel_l3=0;
      if(i<wHeight-2)
       pixel_l4=getpixel2c(3*(i+2-startx)+1,3*(j+2-starty)+1);
      else pixel_l4=0;
     }
     else pixel_l0=pixel_l1=pixel_l2=pixel_l3=pixel_l4=0;

     if(j<wHeight-1) {
      if(i>1)
       pixel_m0=getpixel2c(3*(i-2-startx)+1,3*(j+1-starty)+1);
      else pixel_m0=0;
      if(i>0)
       pixel_m1=getpixel2c(3*(i-1-startx)+1,3*(j+1-starty)+1);
      else pixel_m1=0;
      pixel_m2=getpixel2c(3*(i-startx)+1,3*(j+1-starty)+1);
      if(i<wHeight-1)
       pixel_m3=getpixel2c(3*(i+1-startx)+1,3*(j+1-starty)+1);
      else pixel_m3=0;
      if(i<wHeight-2)
       pixel_m4=getpixel2c(3*(i+2-startx)+1,3*(j+1-starty)+1);
      else pixel_m4=0;
     }
     else pixel_m0=pixel_m1=pixel_m2=pixel_m3=pixel_m4=0;

     if(i>1) 
      pixel_t0=getpixel2c(3*(i-2-startx)+1,3*(j-starty)+1);
     else pixel_t0=0;
     if(i>0) 
      pixel_t1=getpixel2c(3*(i-1-startx)+1,3*(j-starty)+1);
     else pixel_t1=0;

     if(i<wWidth-1) 
      pixel_t3=getpixel2c(3*(i+1-startx)+1,3*(j-starty)+1);
     else pixel_t3=0;
     if(i<wWidth-2) 
      pixel_t4=getpixel2c(3*(i+2-startx)+1,3*(j-starty)+1);
     else pixel_t4=0;

     lnum=0;
     if(!pixel_l1) lnum++;
     if(!pixel_l2) lnum++;
     if(!pixel_l3) lnum++;
     unum=0;
     if(!pixel_u1) unum++;
     if(!pixel_u2) unum++;
     if(!pixel_u3) unum++;
     nnum=0;
     if(!pixel_n1) nnum++;
     if(!pixel_n2) nnum++;
     if(!pixel_n3) nnum++;
     mnum=0;
     if(!pixel_m1) mnum++;
     if(!pixel_m2) mnum++;
     if(!pixel_m3) mnum++;
     
     if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
       (nnum==1 || nnum==2) && (mnum==1 || mnum==2))
     {
      drawpixel2b(3*i+1,3*j+1,xcolor[0].pixel);
     }
     else if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
        pixel_m0 && pixel_m1 && pixel_m2 && pixel_m3 && pixel_m4 &&
       (nnum=1 || nnum==2) && (lnum==1 || lnum==2) ) {
       draw_line2b(3*i+1,3*j+1,3*i+1,3*(j+1)+1,xcolor[0].pixel);
     }
     else if(pixel_t0 && pixel_t1 && pixel_t3 && pixel_t4 && 
        pixel_n0 && pixel_n1 && pixel_n2 && pixel_n3 && pixel_n4 &&
        pixel_m0 && pixel_m1 && pixel_m2 && pixel_m3 && pixel_m4 &&

          ( lnum==1 || lnum==2) && 
	  ( unum==1 || unum==2)) {
       draw_line2b(3*i+1,3*(j-1)+1,3*i+1,3*(j+1)+1,xcolor[0].pixel);
     }
    }
   }
  }
 }
 /* printf("finished algorithm4b\n");*/
  
 return 0;
}
