/*************************************
* pmodel.h
* Date: 1.3.2000
**************************************/

#include <stdio.h>
#include <math.h>
#define LIMDBAR 680
#define LIMDBAR1 780
#define LIMDBAR2 712  /* must be divisible by 8 */
#define SMALL 1
#define OK 0
#define GPLANES   24 /* 16 for old X11 */ /* 4 for PC */
/* menu colors */
#define Co1	16 /* 7 */
#define Co2	1
#define Co3	3
#define Co4	9
#define Co5	0

#define SIZE_STAT 600 /* size of statistics buffer */
#define TIME_SLICE 500	/* time slice in time-units for Unix server */
#define TIME_SCALE 10000000L /* scale 10-7 sec */

/* sim_operation options */
#define DYNAMIC_TEST 		1
#define EFFICIENCY 		2
#define THROUGHPUT		3
#define SYSTEM_TIME_DISTR	4
#define INTERARRIVAL_DISTR	5
#define QUEUE_LENGTH		6
#define ISMA_RES		7

typedef struct pathData {
 int x,y,z,time;double speed;
} PathData;

typedef struct ttime{
 int hour;
 int min;
 int sec;
 unsigned long sec10_8;	
}TTIME;

typedef struct stime{
 unsigned long sec;
 unsigned long sec10_7;	
}STIME;

typedef struct hs_par {
 double p1a,p1b,p2,p3a,p3b,p4a,p4b,p5a,p5b,p6a,p6b,p7;
} HS_PAR;

typedef struct session {
 struct session *prev,*next;	
 STIME start_time;
 STIME next_time; 
 int type;
 int num,num2;
 int max_transfers;
 long size;
} SESSION;

#define VUNIT int
#define CVOBJ_NAME_SIZE 20
typedef struct vector_object {
	struct vector_object *next,*last;
	VUNIT *buf;
	char name[20];
	int x1,y1,x2,y2,color,opt;int mode;	
	struct vector_object *n,*p,*c;
	int e;
	int i1,i4; /* free parameters for usage */ 
	long i2,i3; /* free parameters for usage */ 	
	double i5,i6,i7,i8; /* free parameters for usage */ 	
	int i9,ix; /* free parameters for usage */ 	
	int menuid;
	struct vector_object *labelid;
} VECTOR_OBJECT;
	
typedef struct cnvtbl{
	char *s;
	int i;	
} CNVTBL;



/* 0 is reserved */
#define ARROW 		1
#define NODE		2
#define QUEUE		3
#define VLINE		4
#define VBOX		5
#define TELEPHONE	6
#define LABEL		7
#define VCIRCLE		8
#define NODEB		9
#define NODEC		10
/* add here new vobj-types, add back-types, put-types and update 
   difference1 and compile all */
#define DIFFERENCE1	NODEC /* number of last vobject */
#define DIFFERENCE2	2*DIFFERENCE1

#define BACKARROW 	-ARROW
#define BACKNODE	-NODE
#define BACKQUEUE	-QUEUE
#define BACKVLINE	-VLINE
#define BACKVBOX	-VBOX
#define BACKTELEPHONE	-TELEPHONE
#define BACKLABEL	-LABEL
#define BACKVCIRCLE	-VCIRCLE
#define BACKNODEB	-NODEB
#define BACKNODEC	-NODEC

#define PUT_ARROW 	ARROW+DIFFERENCE1
#define PUT_NODE 	NODE+DIFFERENCE1
#define PUT_QUEUE 	QUEUE+DIFFERENCE1
#define PUT_VLINE 	VLINE+DIFFERENCE1
#define PUT_VBOX 	VBOX+DIFFERENCE1
#define PUT_TELEPHONE 	TELEPHONE+DIFFERENCE1
#define PUT_LABEL 	LABEL+DIFFERENCE1
#define PUT_VCIRCLE 	VCIRCLE+DIFFERENCE1
#define PUT_NODEB 	NODEB+DIFFERENCE1
#define PUT_NODEC 	NODEC+DIFFERENCE1

#define MOVE 		1+DIFFERENCE2
#define DIFFERENCE3	MOVE		/* <= all moving vobjmodes */
#define POINTER 	2+DIFFERENCE2
#define SIMULATING	3+DIFFERENCE2
#define PLOTTER		4+DIFFERENCE2
#define SIMDATA_IN	5+DIFFERENCE2
#define SIMDATA_OUT	6+DIFFERENCE2
#define IN_MENU		7+DIFFERENCE2
#define MAKE_PCX_FILE	8+DIFFERENCE2

typedef struct {
	int x1,x2,y1,y2;
	int (*jmpfunc)();
} JMPTABLE;

typedef struct {
	int (*jmpfunc)();
} JMPTABLE_B;

#define DIALLING_TIME	30000L	/* time in msec to retry after rejection */
/* #define MAX_RETRY	3       fall 1999 DK changed to a variable */

/* buffer limits */
#define CHAIN_MAX	40	/* max intervals in CCLASS */
#define CHAIN_MAX1	12	/* max intervals in CHAIN, do not change! */
#define MAX_CLASSES	7	/* max number of call types */
#define MAX_SERVERS	31 /*7*/ /*65*/ /*50*/	/* maximum number of servers +1 in an element */

/* parameters */
#define REJECTED	0x1000
#define MASK1		0xff

/* maximum number of elements */
#define NUM_ELEMENTS	30

/* scheduler types */
#define FIFO		1
#define PS_FB		2
#define PS_RR		3
#define CSMA_CD		4
#define UNIX		5
#define LOSS_SYSTEM	6
#define Channel		7

/* server selection rules */
#define FIRST_FREE	1
#define LEAST_OCCUPIED	2
#define CLASS_DEPENDENT	3
#define DEDICATED	4
#define PRIORITY	5

typedef struct chainb {
	short class1;		/* class (=call type) of the chain */
	short last;		/* index of last valid message */
	short nextn;		/* index in free chain list */
	short onextn;		/* forward index in queue list */
	short olastn;		/* backward index in queue list */
	short timeoutn;		/* forward index in time-out list */
	short timeoutp;		/* backward index in time-out list */
	short oindex;		/* current message number in call type */		
	short chain_number;	/* identifier of the chain */
	short retry_counter;	/* counter for retrials */
	long recsrv;		/* amount of received processing */
	long left;		/* amount of processing left */
	short type;		/* type is element number of the ith interval*/
	short server;		/* server of type type[i] for the ith interval*/	
	short repeat_counter;	/* counter of repeats */
	short parent_counter;	/* counter of fragmented messages */	
	short parent_chain_num;	/* parent chain_number of fragmented messages */		
	short d_server;		/* dedicated server if dedicated or priority rule*/
	short csma_retries;	/* counter for CSMA/CD protocol retries */
	short prevtype;		/* previous type or -1 */
	long last_received;	/* last recsrv if oindex>0 */	
	STIME start_time;	/* starting time of the chain */
	STIME end_time;		/* end time of the chain */	
	STIME user_time_out;	/* user aborts the call after this time*/	
	STIME parent_start;	/* start_time of parent */
	long delay;		/* amount of delay left */
	short parent_class;	/* chain class which starts the chain */
	
/* application specific fields */	
	short session_num;	/* session number in home shopping model */
	long size;		/* file size in home shopping model */
	char header;		/* ABR header */
	char cellid;		/* ABR identifier if RM cell or data cell */	
	char rmbits;		/* bits for ABR rm cells (BN,DI,CI,NI) */
	short er;		/* ABR rm cell ER-field */
	short ccr;		/* ABR rm cell CCR-field */	
	short mcr;		/* ABR rm cell MCR-field */	
	unsigned long msid; 	/* ISMA test */
        unsigned long neigh1;   /* ADHOC tests */
        unsigned long neigh2;	
	} CHAINB;

/* sizes of extended memory pool of CHAINB buffers */
#define WSIZE (unsigned)(sizeof(CHAINB)+1)/2 /* buffer size in words */
#define LSIZE (long)WSIZE*2	/* buffer size in double bytes */
#define EXT_TO_ONE_MEM  100 	/* how many ext.mem. buffers to one conv.mem. buffer */
#define MEM_POOL_MAX /* 280*/ 140	/* size of conventional memory buffer */
#define EXT_POOL_MAX (long)(EXT_TO_ONE_MEM*MEM_POOL_MAX) /* number of buffers in pool */
#define EXT_POOL_UB (long)(EXT_POOL_MAX+1) /* pool upper bound */
#define CHAIN_POOL_SIZE	EXT_POOL_MAX-1 /* maximum index for buffer, index starts at 0 */
#define EXT_POOL_SIZE_IN_KILOS (unsigned)((LSIZE*EXT_POOL_MAX)/1024+1) 
#define BGFGPART /*16916L */8458L /* part of fg or bg buffer in ext mem */
#define BGFGNUM 8 /*16*/	/* number of allocated fg or bg parts n*8 */
#define BGFGSIZE_IN_KILOS (unsigned)((BGFGNUM*BGFGPART)/1024+1)

#define NOCLSFUNC 1

typedef struct animatdata {
  int x1,y1,x2,y2;
  int ox1,oy1,ox2,oy2;
  char buf[1000]; 
} ANIMATDATA;

typedef struct chainlist {
        int oendn[NUM_ELEMENTS*MAX_SERVERS];        
        int ostartn[NUM_ELEMENTS*MAX_SERVERS];	        
	} CHAINLIST;

typedef struct cclass{	      /* structure defining a class of a call */
	long 	*time;	      /* time[i] is end time of ith interval*/
	short  	*type;	      /* element number */
	short  	*max_msg;     /* max message size or 0 if infinite */	
	short  	*child;       /* chain class of a child chain */		
	short 	*distribution;/* workload distribution type */
	long 	*distr_param;/* workload distribution parameter */		
	short  	max;		/* number of intervals in this chain class */
	double 	lambda;		/* mean arrival rate of the class (chains/sec)*/
	STIME	system_time_out;/* system timeout for a chain (sec) */
	STIME	user_time_out_m;/* normally distributed user time out (sec) */
	STIME	user_time_out_v;/* deviation of user time out (sec) */
	double 	retry_number_m;/* normally distributed number of retrials */	
	double 	retry_number_v;	
	short 	arrival_distr;	/* arrival distribution type */	
	} CCLASS;

typedef struct tracestr_d{
	int num;
	double sum;
	double val[100];
} TRACESTR_D;

typedef struct tracestr_l{
	int num;
	double mean_time;
	long val[100];
} TRACESTR_L;

typedef struct tracestr_i{
	int num;
	double sum;
	int val[100];
} TRACESTR_I;

typedef struct chainpool {
	int firstn;	
	}CHAINPOOL;


typedef struct element{		/* data for element */
	/* fields which are needed in compiling simulation data */
	int x,y1,y2;		/* coordinates of element in the editor */	
	char name[20];		/* name of the element */
	VECTOR_OBJECT *queue;	/* first queue of a chain starting from elem */ 	
	
	/* character of the element as a queue */
	short scheduler_type;	/* FIFO etc. type of the element */
	short servers;		/* number of servers in element */
	short select;		/* selection rule for a server */
	short cur_prior;	/* if select=priority, cur_prior is server to be served now */
	char busy[MAX_SERVERS];	/* indication that a server is busy */

	/* fields connected with UNIX time sharing */
	unsigned char rr_next[MAX_SERVERS];/* next server in Unix round-robin */
	unsigned char turn;		/* server which has the time slice */
	long time_slices;/* counter of received time slices */
	long chain_id[MAX_SERVERS];/* chain_number of chain occupying the server */	

	/* fields relating to the operation of the queues */
	int queue_len;			/* number of chains in the queue */
	int queue_len_max;		/* maximum length of the queue */
	double occupied[MAX_SERVERS];	/* busy time percentage of a server */
		
	/* fields related to tracing element usage */
	int trace_usage;	/* what trace is required */
	char *buf;		/* pointer to trace buffer */

	/* automatic call control related fields */
	double acg_gaplen;
	STIME acg_gapstart;
	double acg_nextgaplen;
	int acg_gap_update,acg_curgap_update;	
	int acg_count,acg_countmax;
	int acg_gapnum,acg_type;
	
 	/* last time this element was updated in evd simulator */
	STIME serv_time;
	} ELEMENT; 

